"Main interface for ec2 type defs"
from __future__ import annotations

from datetime import datetime
from typing import List
from typing_extensions import TypedDict


__all__ = (
    "BundleTaskCompleteWaitFiltersTypeDef",
    "BundleTaskCompleteWaitWaiterConfigTypeDef",
    "ClassicAddressAssociateResponseTypeDef",
    "ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef",
    "ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseTypeDef",
    "ClientAdvertiseByoipCidrResponseByoipCidrTypeDef",
    "ClientAdvertiseByoipCidrResponseTypeDef",
    "ClientAllocateAddressResponseTypeDef",
    "ClientAllocateHostsResponseTypeDef",
    "ClientAllocateHostsTagSpecificationsTagsTypeDef",
    "ClientAllocateHostsTagSpecificationsTypeDef",
    "ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef",
    "ClientAssignIpv6AddressesResponseTypeDef",
    "ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    "ClientAssignPrivateIpAddressesResponseTypeDef",
    "ClientAssociateAddressResponseTypeDef",
    "ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef",
    "ClientAssociateClientVpnTargetNetworkResponseTypeDef",
    "ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef",
    "ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    "ClientAssociateIamInstanceProfileResponseTypeDef",
    "ClientAssociateRouteTableResponseTypeDef",
    "ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientAssociateSubnetCidrBlockResponseTypeDef",
    "ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef",
    "ClientAssociateTransitGatewayRouteTableResponseTypeDef",
    "ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    "ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    "ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientAssociateVpcCidrBlockResponseTypeDef",
    "ClientAttachClassicLinkVpcResponseTypeDef",
    "ClientAttachNetworkInterfaceResponseTypeDef",
    "ClientAttachVolumeResponseTypeDef",
    "ClientAttachVpnGatewayResponseVpcAttachmentTypeDef",
    "ClientAttachVpnGatewayResponseTypeDef",
    "ClientAuthorizeClientVpnIngressResponseStatusTypeDef",
    "ClientAuthorizeClientVpnIngressResponseTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef",
    "ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef",
    "ClientBundleInstanceResponseBundleTaskStorageS3TypeDef",
    "ClientBundleInstanceResponseBundleTaskStorageTypeDef",
    "ClientBundleInstanceResponseBundleTaskTypeDef",
    "ClientBundleInstanceResponseTypeDef",
    "ClientBundleInstanceStorageS3TypeDef",
    "ClientBundleInstanceStorageTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef",
    "ClientCancelBundleTaskResponseBundleTaskStorageTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskTypeDef",
    "ClientCancelBundleTaskResponseTypeDef",
    "ClientCancelCapacityReservationResponseTypeDef",
    "ClientCancelImportTaskResponseTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    "ClientCancelReservedInstancesListingResponseTypeDef",
    "ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef",
    "ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef",
    "ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef",
    "ClientCancelSpotFleetRequestsResponseTypeDef",
    "ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef",
    "ClientCancelSpotInstanceRequestsResponseTypeDef",
    "ClientConfirmProductInstanceResponseTypeDef",
    "ClientCopyFpgaImageResponseTypeDef",
    "ClientCopyImageResponseTypeDef",
    "ClientCopySnapshotResponseTagsTypeDef",
    "ClientCopySnapshotResponseTypeDef",
    "ClientCopySnapshotTagSpecificationsTagsTypeDef",
    "ClientCopySnapshotTagSpecificationsTypeDef",
    "ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef",
    "ClientCreateCapacityReservationResponseCapacityReservationTypeDef",
    "ClientCreateCapacityReservationResponseTypeDef",
    "ClientCreateCapacityReservationTagSpecificationsTagsTypeDef",
    "ClientCreateCapacityReservationTagSpecificationsTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef",
    "ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef",
    "ClientCreateClientVpnEndpointResponseStatusTypeDef",
    "ClientCreateClientVpnEndpointResponseTypeDef",
    "ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef",
    "ClientCreateClientVpnEndpointTagSpecificationsTypeDef",
    "ClientCreateClientVpnRouteResponseStatusTypeDef",
    "ClientCreateClientVpnRouteResponseTypeDef",
    "ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef",
    "ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef",
    "ClientCreateCustomerGatewayResponseTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetTagsTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetTypeDef",
    "ClientCreateDefaultSubnetResponseTypeDef",
    "ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultVpcResponseVpcTagsTypeDef",
    "ClientCreateDefaultVpcResponseVpcTypeDef",
    "ClientCreateDefaultVpcResponseTypeDef",
    "ClientCreateDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef",
    "ClientCreateDhcpOptionsResponseTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsTypeDef",
    "ClientCreateFleetOnDemandOptionsTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef",
    "ClientCreateFleetResponseErrorsTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef",
    "ClientCreateFleetResponseInstancesTypeDef",
    "ClientCreateFleetResponseTypeDef",
    "ClientCreateFleetSpotOptionsTypeDef",
    "ClientCreateFleetTagSpecificationsTagsTypeDef",
    "ClientCreateFleetTagSpecificationsTypeDef",
    "ClientCreateFleetTargetCapacitySpecificationTypeDef",
    "ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef",
    "ClientCreateFlowLogsResponseUnsuccessfulTypeDef",
    "ClientCreateFlowLogsResponseTypeDef",
    "ClientCreateFpgaImageInputStorageLocationTypeDef",
    "ClientCreateFpgaImageLogsStorageLocationTypeDef",
    "ClientCreateFpgaImageResponseTypeDef",
    "ClientCreateFpgaImageTagSpecificationsTagsTypeDef",
    "ClientCreateFpgaImageTagSpecificationsTypeDef",
    "ClientCreateImageBlockDeviceMappingsEbsTypeDef",
    "ClientCreateImageBlockDeviceMappingsTypeDef",
    "ClientCreateImageResponseTypeDef",
    "ClientCreateInstanceExportTaskExportToS3TaskTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskTypeDef",
    "ClientCreateInstanceExportTaskResponseTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayTypeDef",
    "ClientCreateInternetGatewayResponseTypeDef",
    "ClientCreateKeyPairResponseTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientCreateLaunchTemplateResponseTypeDef",
    "ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef",
    "ClientCreateLaunchTemplateVersionResponseTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayTagsTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayTypeDef",
    "ClientCreateNatGatewayResponseTypeDef",
    "ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef",
    "ClientCreateNetworkAclEntryPortRangeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclTagsTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclTypeDef",
    "ClientCreateNetworkAclResponseTypeDef",
    "ClientCreateNetworkInterfaceIpv6AddressesTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseTypeDef",
    "ClientCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef",
    "ClientCreateNetworkInterfaceResponseTypeDef",
    "ClientCreateReservedInstancesListingPriceSchedulesTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    "ClientCreateReservedInstancesListingResponseTypeDef",
    "ClientCreateRouteResponseTypeDef",
    "ClientCreateRouteTableResponseRouteTableAssociationsTypeDef",
    "ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef",
    "ClientCreateRouteTableResponseRouteTableRoutesTypeDef",
    "ClientCreateRouteTableResponseRouteTableTagsTypeDef",
    "ClientCreateRouteTableResponseRouteTableTypeDef",
    "ClientCreateRouteTableResponseTypeDef",
    "ClientCreateSecurityGroupResponseTypeDef",
    "ClientCreateSnapshotResponseTagsTypeDef",
    "ClientCreateSnapshotResponseTypeDef",
    "ClientCreateSnapshotTagSpecificationsTagsTypeDef",
    "ClientCreateSnapshotTagSpecificationsTypeDef",
    "ClientCreateSnapshotsInstanceSpecificationTypeDef",
    "ClientCreateSnapshotsResponseSnapshotsTagsTypeDef",
    "ClientCreateSnapshotsResponseSnapshotsTypeDef",
    "ClientCreateSnapshotsResponseTypeDef",
    "ClientCreateSnapshotsTagSpecificationsTagsTypeDef",
    "ClientCreateSnapshotsTagSpecificationsTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseTypeDef",
    "ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateSubnetResponseSubnetTagsTypeDef",
    "ClientCreateSubnetResponseSubnetTypeDef",
    "ClientCreateSubnetResponseTypeDef",
    "ClientCreateTagsTagsTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTypeDef",
    "ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTypeDef",
    "ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTypeDef",
    "ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTypeDef",
    "ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayOptionsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayTypeDef",
    "ClientCreateTransitGatewayResponseTypeDef",
    "ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientCreateTransitGatewayRouteResponseRouteTypeDef",
    "ClientCreateTransitGatewayRouteResponseTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTypeDef",
    "ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef",
    "ClientCreateVolumeResponseAttachmentsTypeDef",
    "ClientCreateVolumeResponseTagsTypeDef",
    "ClientCreateVolumeResponseTypeDef",
    "ClientCreateVolumeTagSpecificationsTagsTypeDef",
    "ClientCreateVolumeTagSpecificationsTypeDef",
    "ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef",
    "ClientCreateVpcEndpointConnectionNotificationResponseTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointTypeDef",
    "ClientCreateVpcEndpointResponseTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    "ClientCreateVpcPeeringConnectionResponseTypeDef",
    "ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef",
    "ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateVpcResponseVpcTagsTypeDef",
    "ClientCreateVpcResponseVpcTypeDef",
    "ClientCreateVpcResponseTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientCreateVpnConnectionOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionTypeDef",
    "ClientCreateVpnConnectionResponseTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayTypeDef",
    "ClientCreateVpnGatewayResponseTypeDef",
    "ClientDeleteClientVpnEndpointResponseStatusTypeDef",
    "ClientDeleteClientVpnEndpointResponseTypeDef",
    "ClientDeleteClientVpnRouteResponseStatusTypeDef",
    "ClientDeleteClientVpnRouteResponseTypeDef",
    "ClientDeleteEgressOnlyInternetGatewayResponseTypeDef",
    "ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef",
    "ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef",
    "ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef",
    "ClientDeleteFleetsResponseTypeDef",
    "ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteFlowLogsResponseUnsuccessfulTypeDef",
    "ClientDeleteFlowLogsResponseTypeDef",
    "ClientDeleteFpgaImageResponseTypeDef",
    "ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientDeleteLaunchTemplateResponseTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseTypeDef",
    "ClientDeleteNatGatewayResponseTypeDef",
    "ClientDeleteNetworkInterfacePermissionResponseTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseTypeDef",
    "ClientDeleteTagsTagsTypeDef",
    "ClientDeleteTrafficMirrorFilterResponseTypeDef",
    "ClientDeleteTrafficMirrorFilterRuleResponseTypeDef",
    "ClientDeleteTrafficMirrorSessionResponseTypeDef",
    "ClientDeleteTrafficMirrorTargetResponseTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayTypeDef",
    "ClientDeleteTransitGatewayResponseTypeDef",
    "ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientDeleteTransitGatewayRouteResponseRouteTypeDef",
    "ClientDeleteTransitGatewayRouteResponseTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef",
    "ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointsResponseTypeDef",
    "ClientDeleteVpcPeeringConnectionResponseTypeDef",
    "ClientDeprovisionByoipCidrResponseByoipCidrTypeDef",
    "ClientDeprovisionByoipCidrResponseTypeDef",
    "ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef",
    "ClientDescribeAccountAttributesResponseAccountAttributesTypeDef",
    "ClientDescribeAccountAttributesResponseTypeDef",
    "ClientDescribeAddressesFiltersTypeDef",
    "ClientDescribeAddressesResponseAddressesTagsTypeDef",
    "ClientDescribeAddressesResponseAddressesTypeDef",
    "ClientDescribeAddressesResponseTypeDef",
    "ClientDescribeAggregateIdFormatResponseStatusesTypeDef",
    "ClientDescribeAggregateIdFormatResponseTypeDef",
    "ClientDescribeAvailabilityZonesFiltersTypeDef",
    "ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef",
    "ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef",
    "ClientDescribeAvailabilityZonesResponseTypeDef",
    "ClientDescribeBundleTasksFiltersTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksTypeDef",
    "ClientDescribeBundleTasksResponseTypeDef",
    "ClientDescribeByoipCidrsResponseByoipCidrsTypeDef",
    "ClientDescribeByoipCidrsResponseTypeDef",
    "ClientDescribeCapacityReservationsFiltersTypeDef",
    "ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef",
    "ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef",
    "ClientDescribeCapacityReservationsResponseTypeDef",
    "ClientDescribeClassicLinkInstancesFiltersTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesTypeDef",
    "ClientDescribeClassicLinkInstancesResponseTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseTypeDef",
    "ClientDescribeClientVpnConnectionsFiltersTypeDef",
    "ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef",
    "ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef",
    "ClientDescribeClientVpnConnectionsResponseTypeDef",
    "ClientDescribeClientVpnEndpointsFiltersTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseTypeDef",
    "ClientDescribeClientVpnRoutesFiltersTypeDef",
    "ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef",
    "ClientDescribeClientVpnRoutesResponseRoutesTypeDef",
    "ClientDescribeClientVpnRoutesResponseTypeDef",
    "ClientDescribeClientVpnTargetNetworksFiltersTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksTypeDef",
    "ClientDescribeConversionTasksResponseTypeDef",
    "ClientDescribeCustomerGatewaysFiltersTypeDef",
    "ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef",
    "ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef",
    "ClientDescribeCustomerGatewaysResponseTypeDef",
    "ClientDescribeDhcpOptionsFiltersTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef",
    "ClientDescribeDhcpOptionsResponseTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef",
    "ClientDescribeElasticGpusFiltersTypeDef",
    "ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef",
    "ClientDescribeElasticGpusResponseElasticGpuSetTypeDef",
    "ClientDescribeElasticGpusResponseTypeDef",
    "ClientDescribeExportImageTasksFiltersTypeDef",
    "ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef",
    "ClientDescribeExportImageTasksResponseExportImageTasksTypeDef",
    "ClientDescribeExportImageTasksResponseTypeDef",
    "ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef",
    "ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef",
    "ClientDescribeExportTasksResponseExportTasksTypeDef",
    "ClientDescribeExportTasksResponseTypeDef",
    "ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef",
    "ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef",
    "ClientDescribeFleetHistoryResponseTypeDef",
    "ClientDescribeFleetInstancesFiltersTypeDef",
    "ClientDescribeFleetInstancesResponseActiveInstancesTypeDef",
    "ClientDescribeFleetInstancesResponseTypeDef",
    "ClientDescribeFleetsFiltersTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef",
    "ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef",
    "ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef",
    "ClientDescribeFleetsResponseFleetsTagsTypeDef",
    "ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsTypeDef",
    "ClientDescribeFleetsResponseTypeDef",
    "ClientDescribeFlowLogsFiltersTypeDef",
    "ClientDescribeFlowLogsResponseFlowLogsTypeDef",
    "ClientDescribeFlowLogsResponseTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    "ClientDescribeFpgaImageAttributeResponseTypeDef",
    "ClientDescribeFpgaImagesFiltersTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesTypeDef",
    "ClientDescribeFpgaImagesResponseTypeDef",
    "ClientDescribeHostReservationOfferingsFiltersTypeDef",
    "ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef",
    "ClientDescribeHostReservationOfferingsResponseTypeDef",
    "ClientDescribeHostReservationsFiltersTypeDef",
    "ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef",
    "ClientDescribeHostReservationsResponseHostReservationSetTypeDef",
    "ClientDescribeHostReservationsResponseTypeDef",
    "ClientDescribeHostsFiltersTypeDef",
    "ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    "ClientDescribeHostsResponseHostsAvailableCapacityTypeDef",
    "ClientDescribeHostsResponseHostsHostPropertiesTypeDef",
    "ClientDescribeHostsResponseHostsInstancesTypeDef",
    "ClientDescribeHostsResponseHostsTagsTypeDef",
    "ClientDescribeHostsResponseHostsTypeDef",
    "ClientDescribeHostsResponseTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseTypeDef",
    "ClientDescribeIdFormatResponseStatusesTypeDef",
    "ClientDescribeIdFormatResponseTypeDef",
    "ClientDescribeIdentityIdFormatResponseStatusesTypeDef",
    "ClientDescribeIdentityIdFormatResponseTypeDef",
    "ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef",
    "ClientDescribeImageAttributeResponseDescriptionTypeDef",
    "ClientDescribeImageAttributeResponseKernelIdTypeDef",
    "ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef",
    "ClientDescribeImageAttributeResponseProductCodesTypeDef",
    "ClientDescribeImageAttributeResponseRamdiskIdTypeDef",
    "ClientDescribeImageAttributeResponseSriovNetSupportTypeDef",
    "ClientDescribeImageAttributeResponseTypeDef",
    "ClientDescribeImagesFiltersTypeDef",
    "ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef",
    "ClientDescribeImagesResponseImagesProductCodesTypeDef",
    "ClientDescribeImagesResponseImagesStateReasonTypeDef",
    "ClientDescribeImagesResponseImagesTagsTypeDef",
    "ClientDescribeImagesResponseImagesTypeDef",
    "ClientDescribeImagesResponseTypeDef",
    "ClientDescribeImportImageTasksFiltersTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksTypeDef",
    "ClientDescribeImportImageTasksResponseTypeDef",
    "ClientDescribeImportSnapshotTasksFiltersTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef",
    "ClientDescribeImportSnapshotTasksResponseTypeDef",
    "ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef",
    "ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef",
    "ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef",
    "ClientDescribeInstanceAttributeResponseEnaSupportTypeDef",
    "ClientDescribeInstanceAttributeResponseGroupsTypeDef",
    "ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    "ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef",
    "ClientDescribeInstanceAttributeResponseKernelIdTypeDef",
    "ClientDescribeInstanceAttributeResponseProductCodesTypeDef",
    "ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef",
    "ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef",
    "ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef",
    "ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef",
    "ClientDescribeInstanceAttributeResponseUserDataTypeDef",
    "ClientDescribeInstanceAttributeResponseTypeDef",
    "ClientDescribeInstanceCreditSpecificationsFiltersTypeDef",
    "ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef",
    "ClientDescribeInstanceCreditSpecificationsResponseTypeDef",
    "ClientDescribeInstanceStatusFiltersTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef",
    "ClientDescribeInstanceStatusResponseTypeDef",
    "ClientDescribeInstancesFiltersTypeDef",
    "ClientDescribeInstancesResponseReservationsGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesStateTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesTypeDef",
    "ClientDescribeInstancesResponseReservationsTypeDef",
    "ClientDescribeInstancesResponseTypeDef",
    "ClientDescribeInternetGatewaysFiltersTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef",
    "ClientDescribeInternetGatewaysResponseTypeDef",
    "ClientDescribeKeyPairsFiltersTypeDef",
    "ClientDescribeKeyPairsResponseKeyPairsTypeDef",
    "ClientDescribeKeyPairsResponseTypeDef",
    "ClientDescribeLaunchTemplateVersionsFiltersTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseTypeDef",
    "ClientDescribeLaunchTemplatesFiltersTypeDef",
    "ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef",
    "ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef",
    "ClientDescribeLaunchTemplatesResponseTypeDef",
    "ClientDescribeMovingAddressesFiltersTypeDef",
    "ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef",
    "ClientDescribeMovingAddressesResponseTypeDef",
    "ClientDescribeNatGatewaysFiltersTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysTypeDef",
    "ClientDescribeNatGatewaysResponseTypeDef",
    "ClientDescribeNetworkAclsFiltersTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsTypeDef",
    "ClientDescribeNetworkAclsResponseTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseTypeDef",
    "ClientDescribeNetworkInterfacePermissionsFiltersTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseTypeDef",
    "ClientDescribeNetworkInterfacesFiltersTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef",
    "ClientDescribeNetworkInterfacesResponseTypeDef",
    "ClientDescribePlacementGroupsFiltersTypeDef",
    "ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef",
    "ClientDescribePlacementGroupsResponseTypeDef",
    "ClientDescribePrefixListsFiltersTypeDef",
    "ClientDescribePrefixListsResponsePrefixListsTypeDef",
    "ClientDescribePrefixListsResponseTypeDef",
    "ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef",
    "ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef",
    "ClientDescribePrincipalIdFormatResponseTypeDef",
    "ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    "ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef",
    "ClientDescribePublicIpv4PoolsResponseTypeDef",
    "ClientDescribeRegionsFiltersTypeDef",
    "ClientDescribeRegionsResponseRegionsTypeDef",
    "ClientDescribeRegionsResponseTypeDef",
    "ClientDescribeReservedInstancesFiltersTypeDef",
    "ClientDescribeReservedInstancesListingsFiltersTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseTypeDef",
    "ClientDescribeReservedInstancesModificationsFiltersTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseTypeDef",
    "ClientDescribeReservedInstancesOfferingsFiltersTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesTypeDef",
    "ClientDescribeReservedInstancesResponseTypeDef",
    "ClientDescribeRouteTablesFiltersTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesTypeDef",
    "ClientDescribeRouteTablesResponseTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseTypeDef",
    "ClientDescribeScheduledInstancesFiltersTypeDef",
    "ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    "ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef",
    "ClientDescribeScheduledInstancesResponseTypeDef",
    "ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef",
    "ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef",
    "ClientDescribeSecurityGroupReferencesResponseTypeDef",
    "ClientDescribeSecurityGroupsFiltersTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef",
    "ClientDescribeSecurityGroupsResponseTypeDef",
    "ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef",
    "ClientDescribeSnapshotAttributeResponseProductCodesTypeDef",
    "ClientDescribeSnapshotAttributeResponseTypeDef",
    "ClientDescribeSnapshotsFiltersTypeDef",
    "ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef",
    "ClientDescribeSnapshotsResponseSnapshotsTypeDef",
    "ClientDescribeSnapshotsResponseTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseTypeDef",
    "ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef",
    "ClientDescribeSpotFleetInstancesResponseTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseTypeDef",
    "ClientDescribeSpotInstanceRequestsFiltersTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseTypeDef",
    "ClientDescribeSpotPriceHistoryFiltersTypeDef",
    "ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef",
    "ClientDescribeSpotPriceHistoryResponseTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseTypeDef",
    "ClientDescribeSubnetsFiltersTypeDef",
    "ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    "ClientDescribeSubnetsResponseSubnetsTagsTypeDef",
    "ClientDescribeSubnetsResponseSubnetsTypeDef",
    "ClientDescribeSubnetsResponseTypeDef",
    "ClientDescribeTagsFiltersTypeDef",
    "ClientDescribeTagsResponseTagsTypeDef",
    "ClientDescribeTagsResponseTypeDef",
    "ClientDescribeTrafficMirrorFiltersFiltersTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTypeDef",
    "ClientDescribeTrafficMirrorSessionsFiltersTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTypeDef",
    "ClientDescribeTrafficMirrorTargetsFiltersTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTypeDef",
    "ClientDescribeTransitGatewayAttachmentsFiltersTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTypeDef",
    "ClientDescribeTransitGatewayRouteTablesFiltersTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef",
    "ClientDescribeTransitGatewaysFiltersTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef",
    "ClientDescribeTransitGatewaysResponseTypeDef",
    "ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef",
    "ClientDescribeVolumeAttributeResponseProductCodesTypeDef",
    "ClientDescribeVolumeAttributeResponseTypeDef",
    "ClientDescribeVolumeStatusFiltersTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef",
    "ClientDescribeVolumeStatusResponseTypeDef",
    "ClientDescribeVolumesFiltersTypeDef",
    "ClientDescribeVolumesModificationsFiltersTypeDef",
    "ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef",
    "ClientDescribeVolumesModificationsResponseTypeDef",
    "ClientDescribeVolumesResponseVolumesAttachmentsTypeDef",
    "ClientDescribeVolumesResponseVolumesTagsTypeDef",
    "ClientDescribeVolumesResponseVolumesTypeDef",
    "ClientDescribeVolumesResponseTypeDef",
    "ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef",
    "ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef",
    "ClientDescribeVpcAttributeResponseTypeDef",
    "ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef",
    "ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientDescribeVpcClassicLinkFiltersTypeDef",
    "ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef",
    "ClientDescribeVpcClassicLinkResponseVpcsTypeDef",
    "ClientDescribeVpcClassicLinkResponseTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef",
    "ClientDescribeVpcEndpointConnectionsFiltersTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsResponseTypeDef",
    "ClientDescribeVpcEndpointServicesFiltersTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef",
    "ClientDescribeVpcEndpointServicesResponseTypeDef",
    "ClientDescribeVpcEndpointsFiltersTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef",
    "ClientDescribeVpcEndpointsResponseTypeDef",
    "ClientDescribeVpcPeeringConnectionsFiltersTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseTypeDef",
    "ClientDescribeVpcsFiltersTypeDef",
    "ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef",
    "ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    "ClientDescribeVpcsResponseVpcsTagsTypeDef",
    "ClientDescribeVpcsResponseVpcsTypeDef",
    "ClientDescribeVpcsResponseTypeDef",
    "ClientDescribeVpnConnectionsFiltersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef",
    "ClientDescribeVpnConnectionsResponseTypeDef",
    "ClientDescribeVpnGatewaysFiltersTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef",
    "ClientDescribeVpnGatewaysResponseTypeDef",
    "ClientDetachClassicLinkVpcResponseTypeDef",
    "ClientDetachVolumeResponseTypeDef",
    "ClientDisableEbsEncryptionByDefaultResponseTypeDef",
    "ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    "ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef",
    "ClientDisableVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientDisableVpcClassicLinkResponseTypeDef",
    "ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef",
    "ClientDisassociateClientVpnTargetNetworkResponseTypeDef",
    "ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    "ClientDisassociateIamInstanceProfileResponseTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseTypeDef",
    "ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef",
    "ClientDisassociateTransitGatewayRouteTableResponseTypeDef",
    "ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    "ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    "ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientDisassociateVpcCidrBlockResponseTypeDef",
    "ClientEnableEbsEncryptionByDefaultResponseTypeDef",
    "ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    "ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef",
    "ClientEnableVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientEnableVpcClassicLinkResponseTypeDef",
    "ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef",
    "ClientExportClientVpnClientCertificateRevocationListResponseTypeDef",
    "ClientExportClientVpnClientConfigurationResponseTypeDef",
    "ClientExportImageResponseS3ExportLocationTypeDef",
    "ClientExportImageResponseTypeDef",
    "ClientExportImageS3ExportLocationTypeDef",
    "ClientExportTransitGatewayRoutesFiltersTypeDef",
    "ClientExportTransitGatewayRoutesResponseTypeDef",
    "ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef",
    "ClientGetCapacityReservationUsageResponseTypeDef",
    "ClientGetConsoleOutputResponseTypeDef",
    "ClientGetConsoleScreenshotResponseTypeDef",
    "ClientGetEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientGetEbsEncryptionByDefaultResponseTypeDef",
    "ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef",
    "ClientGetHostReservationPurchasePreviewResponseTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef",
    "ClientGetLaunchTemplateDataResponseTypeDef",
    "ClientGetPasswordDataResponseTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTypeDef",
    "ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef",
    "ClientImportClientVpnClientCertificateRevocationListResponseTypeDef",
    "ClientImportImageClientDataTypeDef",
    "ClientImportImageDiskContainersUserBucketTypeDef",
    "ClientImportImageDiskContainersTypeDef",
    "ClientImportImageResponseSnapshotDetailsUserBucketTypeDef",
    "ClientImportImageResponseSnapshotDetailsTypeDef",
    "ClientImportImageResponseTypeDef",
    "ClientImportInstanceDiskImagesImageTypeDef",
    "ClientImportInstanceDiskImagesVolumeTypeDef",
    "ClientImportInstanceDiskImagesTypeDef",
    "ClientImportInstanceLaunchSpecificationPlacementTypeDef",
    "ClientImportInstanceLaunchSpecificationUserDataTypeDef",
    "ClientImportInstanceLaunchSpecificationTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskTagsTypeDef",
    "ClientImportInstanceResponseConversionTaskTypeDef",
    "ClientImportInstanceResponseTypeDef",
    "ClientImportKeyPairResponseTypeDef",
    "ClientImportSnapshotClientDataTypeDef",
    "ClientImportSnapshotDiskContainerUserBucketTypeDef",
    "ClientImportSnapshotDiskContainerTypeDef",
    "ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef",
    "ClientImportSnapshotResponseSnapshotTaskDetailTypeDef",
    "ClientImportSnapshotResponseTypeDef",
    "ClientImportVolumeImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskTagsTypeDef",
    "ClientImportVolumeResponseConversionTaskTypeDef",
    "ClientImportVolumeResponseTypeDef",
    "ClientImportVolumeVolumeTypeDef",
    "ClientModifyCapacityReservationResponseTypeDef",
    "ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef",
    "ClientModifyClientVpnEndpointDnsServersTypeDef",
    "ClientModifyClientVpnEndpointResponseTypeDef",
    "ClientModifyEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientModifyFleetResponseTypeDef",
    "ClientModifyFleetTargetCapacitySpecificationTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    "ClientModifyFpgaImageAttributeResponseTypeDef",
    "ClientModifyHostsResponseUnsuccessfulErrorTypeDef",
    "ClientModifyHostsResponseUnsuccessfulTypeDef",
    "ClientModifyHostsResponseTypeDef",
    "ClientModifyImageAttributeDescriptionTypeDef",
    "ClientModifyImageAttributeLaunchPermissionAddTypeDef",
    "ClientModifyImageAttributeLaunchPermissionRemoveTypeDef",
    "ClientModifyImageAttributeLaunchPermissionTypeDef",
    "ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef",
    "ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef",
    "ClientModifyInstanceAttributeDisableApiTerminationTypeDef",
    "ClientModifyInstanceAttributeEbsOptimizedTypeDef",
    "ClientModifyInstanceAttributeEnaSupportTypeDef",
    "ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    "ClientModifyInstanceAttributeInstanceTypeTypeDef",
    "ClientModifyInstanceAttributeKernelTypeDef",
    "ClientModifyInstanceAttributeRamdiskTypeDef",
    "ClientModifyInstanceAttributeSourceDestCheckTypeDef",
    "ClientModifyInstanceAttributeSriovNetSupportTypeDef",
    "ClientModifyInstanceAttributeUserDataTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesResponseTypeDef",
    "ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseTypeDef",
    "ClientModifyInstanceEventStartTimeResponseEventTypeDef",
    "ClientModifyInstanceEventStartTimeResponseTypeDef",
    "ClientModifyInstancePlacementResponseTypeDef",
    "ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientModifyLaunchTemplateResponseTypeDef",
    "ClientModifyNetworkInterfaceAttributeAttachmentTypeDef",
    "ClientModifyNetworkInterfaceAttributeDescriptionTypeDef",
    "ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef",
    "ClientModifyReservedInstancesResponseTypeDef",
    "ClientModifyReservedInstancesTargetConfigurationsTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionTypeDef",
    "ClientModifySpotFleetRequestResponseTypeDef",
    "ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef",
    "ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef",
    "ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTypeDef",
    "ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientModifyVolumeAttributeAutoEnableIOTypeDef",
    "ClientModifyVolumeResponseVolumeModificationTypeDef",
    "ClientModifyVolumeResponseTypeDef",
    "ClientModifyVpcAttributeEnableDnsHostnamesTypeDef",
    "ClientModifyVpcAttributeEnableDnsSupportTypeDef",
    "ClientModifyVpcEndpointConnectionNotificationResponseTypeDef",
    "ClientModifyVpcEndpointResponseTypeDef",
    "ClientModifyVpcEndpointServiceConfigurationResponseTypeDef",
    "ClientModifyVpcEndpointServicePermissionsResponseTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseTypeDef",
    "ClientModifyVpcTenancyResponseTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionTypeDef",
    "ClientModifyVpnConnectionResponseTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef",
    "ClientModifyVpnTunnelCertificateResponseTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef",
    "ClientModifyVpnTunnelOptionsResponseTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef",
    "ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    "ClientMonitorInstancesResponseInstanceMonitoringsTypeDef",
    "ClientMonitorInstancesResponseTypeDef",
    "ClientMoveAddressToVpcResponseTypeDef",
    "ClientProvisionByoipCidrCidrAuthorizationContextTypeDef",
    "ClientProvisionByoipCidrResponseByoipCidrTypeDef",
    "ClientProvisionByoipCidrResponseTypeDef",
    "ClientPurchaseHostReservationResponsePurchaseTypeDef",
    "ClientPurchaseHostReservationResponseTypeDef",
    "ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef",
    "ClientPurchaseReservedInstancesOfferingResponseTypeDef",
    "ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef",
    "ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    "ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef",
    "ClientPurchaseScheduledInstancesResponseTypeDef",
    "ClientRegisterImageBlockDeviceMappingsEbsTypeDef",
    "ClientRegisterImageBlockDeviceMappingsTypeDef",
    "ClientRegisterImageResponseTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseTypeDef",
    "ClientRejectVpcPeeringConnectionResponseTypeDef",
    "ClientReleaseHostsResponseUnsuccessfulErrorTypeDef",
    "ClientReleaseHostsResponseUnsuccessfulTypeDef",
    "ClientReleaseHostsResponseTypeDef",
    "ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseTypeDef",
    "ClientReplaceNetworkAclAssociationResponseTypeDef",
    "ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef",
    "ClientReplaceNetworkAclEntryPortRangeTypeDef",
    "ClientReplaceRouteTableAssociationResponseTypeDef",
    "ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientReplaceTransitGatewayRouteResponseRouteTypeDef",
    "ClientReplaceTransitGatewayRouteResponseTypeDef",
    "ClientRequestSpotFleetResponseTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef",
    "ClientRequestSpotInstancesResponseTypeDef",
    "ClientResetEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientResetFpgaImageAttributeResponseTypeDef",
    "ClientRestoreAddressToClassicResponseTypeDef",
    "ClientRevokeClientVpnIngressResponseStatusTypeDef",
    "ClientRevokeClientVpnIngressResponseTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsTypeDef",
    "ClientRunInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientRunInstancesBlockDeviceMappingsTypeDef",
    "ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientRunInstancesCapacityReservationSpecificationTypeDef",
    "ClientRunInstancesCpuOptionsTypeDef",
    "ClientRunInstancesCreditSpecificationTypeDef",
    "ClientRunInstancesElasticGpuSpecificationTypeDef",
    "ClientRunInstancesElasticInferenceAcceleratorsTypeDef",
    "ClientRunInstancesHibernationOptionsTypeDef",
    "ClientRunInstancesIamInstanceProfileTypeDef",
    "ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientRunInstancesInstanceMarketOptionsTypeDef",
    "ClientRunInstancesIpv6AddressesTypeDef",
    "ClientRunInstancesLaunchTemplateTypeDef",
    "ClientRunInstancesLicenseSpecificationsTypeDef",
    "ClientRunInstancesMonitoringTypeDef",
    "ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRunInstancesNetworkInterfacesTypeDef",
    "ClientRunInstancesPlacementTypeDef",
    "ClientRunInstancesResponseGroupsTypeDef",
    "ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef",
    "ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef",
    "ClientRunInstancesResponseInstancesCpuOptionsTypeDef",
    "ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef",
    "ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "ClientRunInstancesResponseInstancesHibernationOptionsTypeDef",
    "ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef",
    "ClientRunInstancesResponseInstancesLicensesTypeDef",
    "ClientRunInstancesResponseInstancesMonitoringTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef",
    "ClientRunInstancesResponseInstancesPlacementTypeDef",
    "ClientRunInstancesResponseInstancesProductCodesTypeDef",
    "ClientRunInstancesResponseInstancesSecurityGroupsTypeDef",
    "ClientRunInstancesResponseInstancesStateReasonTypeDef",
    "ClientRunInstancesResponseInstancesStateTypeDef",
    "ClientRunInstancesResponseInstancesTagsTypeDef",
    "ClientRunInstancesResponseInstancesTypeDef",
    "ClientRunInstancesResponseTypeDef",
    "ClientRunInstancesTagSpecificationsTagsTypeDef",
    "ClientRunInstancesTagSpecificationsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationTypeDef",
    "ClientRunScheduledInstancesResponseTypeDef",
    "ClientSearchTransitGatewayRoutesFiltersTypeDef",
    "ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef",
    "ClientSearchTransitGatewayRoutesResponseRoutesTypeDef",
    "ClientSearchTransitGatewayRoutesResponseTypeDef",
    "ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef",
    "ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef",
    "ClientStartInstancesResponseStartingInstancesTypeDef",
    "ClientStartInstancesResponseTypeDef",
    "ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef",
    "ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef",
    "ClientStopInstancesResponseStoppingInstancesTypeDef",
    "ClientStopInstancesResponseTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef",
    "ClientTerminateClientVpnConnectionsResponseTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesTypeDef",
    "ClientTerminateInstancesResponseTypeDef",
    "ClientUnassignIpv6AddressesResponseTypeDef",
    "ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    "ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef",
    "ClientUnmonitorInstancesResponseTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef",
    "ClientWithdrawByoipCidrResponseByoipCidrTypeDef",
    "ClientWithdrawByoipCidrResponseTypeDef",
    "ConversionTaskCancelledWaitWaiterConfigTypeDef",
    "ConversionTaskCompletedWaitWaiterConfigTypeDef",
    "ConversionTaskDeletedWaitWaiterConfigTypeDef",
    "CustomerGatewayAvailableWaitFiltersTypeDef",
    "CustomerGatewayAvailableWaitWaiterConfigTypeDef",
    "DescribeByoipCidrsPaginatePaginationConfigTypeDef",
    "DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef",
    "DescribeByoipCidrsPaginateResponseTypeDef",
    "DescribeCapacityReservationsPaginateFiltersTypeDef",
    "DescribeCapacityReservationsPaginatePaginationConfigTypeDef",
    "DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef",
    "DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef",
    "DescribeCapacityReservationsPaginateResponseTypeDef",
    "DescribeClassicLinkInstancesPaginateFiltersTypeDef",
    "DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef",
    "DescribeClientVpnConnectionsPaginateFiltersTypeDef",
    "DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseTypeDef",
    "DescribeClientVpnEndpointsPaginateFiltersTypeDef",
    "DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseTypeDef",
    "DescribeClientVpnRoutesPaginateFiltersTypeDef",
    "DescribeClientVpnRoutesPaginatePaginationConfigTypeDef",
    "DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef",
    "DescribeClientVpnRoutesPaginateResponseRoutesTypeDef",
    "DescribeClientVpnRoutesPaginateResponseTypeDef",
    "DescribeClientVpnTargetNetworksPaginateFiltersTypeDef",
    "DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseTypeDef",
    "DescribeDhcpOptionsPaginateFiltersTypeDef",
    "DescribeDhcpOptionsPaginatePaginationConfigTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef",
    "DescribeDhcpOptionsPaginateResponseTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef",
    "DescribeFleetsPaginateFiltersTypeDef",
    "DescribeFleetsPaginatePaginationConfigTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef",
    "DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef",
    "DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef",
    "DescribeFleetsPaginateResponseFleetsTagsTypeDef",
    "DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsTypeDef",
    "DescribeFleetsPaginateResponseTypeDef",
    "DescribeFlowLogsPaginateFiltersTypeDef",
    "DescribeFlowLogsPaginatePaginationConfigTypeDef",
    "DescribeFlowLogsPaginateResponseFlowLogsTypeDef",
    "DescribeFlowLogsPaginateResponseTypeDef",
    "DescribeFpgaImagesPaginateFiltersTypeDef",
    "DescribeFpgaImagesPaginatePaginationConfigTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef",
    "DescribeFpgaImagesPaginateResponseTypeDef",
    "DescribeHostReservationOfferingsPaginateFiltersTypeDef",
    "DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef",
    "DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef",
    "DescribeHostReservationOfferingsPaginateResponseTypeDef",
    "DescribeHostReservationsPaginateFiltersTypeDef",
    "DescribeHostReservationsPaginatePaginationConfigTypeDef",
    "DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef",
    "DescribeHostReservationsPaginateResponseHostReservationSetTypeDef",
    "DescribeHostReservationsPaginateResponseTypeDef",
    "DescribeHostsPaginateFiltersTypeDef",
    "DescribeHostsPaginatePaginationConfigTypeDef",
    "DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    "DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef",
    "DescribeHostsPaginateResponseHostsHostPropertiesTypeDef",
    "DescribeHostsPaginateResponseHostsInstancesTypeDef",
    "DescribeHostsPaginateResponseHostsTagsTypeDef",
    "DescribeHostsPaginateResponseHostsTypeDef",
    "DescribeHostsPaginateResponseTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef",
    "DescribeImportImageTasksPaginateFiltersTypeDef",
    "DescribeImportImageTasksPaginatePaginationConfigTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef",
    "DescribeImportImageTasksPaginateResponseTypeDef",
    "DescribeImportSnapshotTasksPaginateFiltersTypeDef",
    "DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef",
    "DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateResponseTypeDef",
    "DescribeInstanceStatusPaginateFiltersTypeDef",
    "DescribeInstanceStatusPaginatePaginationConfigTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef",
    "DescribeInstanceStatusPaginateResponseTypeDef",
    "DescribeInstancesPaginateFiltersTypeDef",
    "DescribeInstancesPaginatePaginationConfigTypeDef",
    "DescribeInstancesPaginateResponseReservationsGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesTypeDef",
    "DescribeInstancesPaginateResponseReservationsTypeDef",
    "DescribeInstancesPaginateResponseTypeDef",
    "DescribeInternetGatewaysPaginateFiltersTypeDef",
    "DescribeInternetGatewaysPaginatePaginationConfigTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef",
    "DescribeInternetGatewaysPaginateResponseTypeDef",
    "DescribeLaunchTemplateVersionsPaginateFiltersTypeDef",
    "DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseTypeDef",
    "DescribeLaunchTemplatesPaginateFiltersTypeDef",
    "DescribeLaunchTemplatesPaginatePaginationConfigTypeDef",
    "DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef",
    "DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef",
    "DescribeLaunchTemplatesPaginateResponseTypeDef",
    "DescribeMovingAddressesPaginateFiltersTypeDef",
    "DescribeMovingAddressesPaginatePaginationConfigTypeDef",
    "DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef",
    "DescribeMovingAddressesPaginateResponseTypeDef",
    "DescribeNatGatewaysPaginateFiltersTypeDef",
    "DescribeNatGatewaysPaginatePaginationConfigTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef",
    "DescribeNatGatewaysPaginateResponseTypeDef",
    "DescribeNetworkAclsPaginateFiltersTypeDef",
    "DescribeNetworkAclsPaginatePaginationConfigTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef",
    "DescribeNetworkAclsPaginateResponseTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef",
    "DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseTypeDef",
    "DescribeNetworkInterfacesPaginateFiltersTypeDef",
    "DescribeNetworkInterfacesPaginatePaginationConfigTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseTypeDef",
    "DescribePrefixListsPaginateFiltersTypeDef",
    "DescribePrefixListsPaginatePaginationConfigTypeDef",
    "DescribePrefixListsPaginateResponsePrefixListsTypeDef",
    "DescribePrefixListsPaginateResponseTypeDef",
    "DescribePrincipalIdFormatPaginatePaginationConfigTypeDef",
    "DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef",
    "DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef",
    "DescribePrincipalIdFormatPaginateResponseTypeDef",
    "DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef",
    "DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    "DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef",
    "DescribePublicIpv4PoolsPaginateResponseTypeDef",
    "DescribeReservedInstancesModificationsPaginateFiltersTypeDef",
    "DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseTypeDef",
    "DescribeReservedInstancesOfferingsPaginateFiltersTypeDef",
    "DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseTypeDef",
    "DescribeRouteTablesPaginateFiltersTypeDef",
    "DescribeRouteTablesPaginatePaginationConfigTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesTypeDef",
    "DescribeRouteTablesPaginateResponseTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef",
    "DescribeScheduledInstancesPaginateFiltersTypeDef",
    "DescribeScheduledInstancesPaginatePaginationConfigTypeDef",
    "DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef",
    "DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef",
    "DescribeScheduledInstancesPaginateResponseTypeDef",
    "DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef",
    "DescribeSecurityGroupsPaginateFiltersTypeDef",
    "DescribeSecurityGroupsPaginatePaginationConfigTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef",
    "DescribeSecurityGroupsPaginateResponseTypeDef",
    "DescribeSnapshotsPaginateFiltersTypeDef",
    "DescribeSnapshotsPaginatePaginationConfigTypeDef",
    "DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef",
    "DescribeSnapshotsPaginateResponseSnapshotsTypeDef",
    "DescribeSnapshotsPaginateResponseTypeDef",
    "DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef",
    "DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef",
    "DescribeSpotFleetInstancesPaginateResponseTypeDef",
    "DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseTypeDef",
    "DescribeSpotInstanceRequestsPaginateFiltersTypeDef",
    "DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseTypeDef",
    "DescribeSpotPriceHistoryPaginateFiltersTypeDef",
    "DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef",
    "DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef",
    "DescribeSpotPriceHistoryPaginateResponseTypeDef",
    "DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseTypeDef",
    "DescribeSubnetsPaginateFiltersTypeDef",
    "DescribeSubnetsPaginatePaginationConfigTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsTagsTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsTypeDef",
    "DescribeSubnetsPaginateResponseTypeDef",
    "DescribeTagsPaginateFiltersTypeDef",
    "DescribeTagsPaginatePaginationConfigTypeDef",
    "DescribeTagsPaginateResponseTagsTypeDef",
    "DescribeTagsPaginateResponseTypeDef",
    "DescribeTrafficMirrorFiltersPaginateFiltersTypeDef",
    "DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTypeDef",
    "DescribeTrafficMirrorSessionsPaginateFiltersTypeDef",
    "DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTypeDef",
    "DescribeTrafficMirrorTargetsPaginateFiltersTypeDef",
    "DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef",
    "DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef",
    "DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef",
    "DescribeTransitGatewaysPaginateFiltersTypeDef",
    "DescribeTransitGatewaysPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef",
    "DescribeTransitGatewaysPaginateResponseTypeDef",
    "DescribeVolumeStatusPaginateFiltersTypeDef",
    "DescribeVolumeStatusPaginatePaginationConfigTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef",
    "DescribeVolumeStatusPaginateResponseTypeDef",
    "DescribeVolumesModificationsPaginateFiltersTypeDef",
    "DescribeVolumesModificationsPaginatePaginationConfigTypeDef",
    "DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef",
    "DescribeVolumesModificationsPaginateResponseTypeDef",
    "DescribeVolumesPaginateFiltersTypeDef",
    "DescribeVolumesPaginatePaginationConfigTypeDef",
    "DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef",
    "DescribeVolumesPaginateResponseVolumesTagsTypeDef",
    "DescribeVolumesPaginateResponseVolumesTypeDef",
    "DescribeVolumesPaginateResponseTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef",
    "DescribeVpcEndpointConnectionsPaginateFiltersTypeDef",
    "DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef",
    "DescribeVpcEndpointServicesPaginateFiltersTypeDef",
    "DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseTypeDef",
    "DescribeVpcEndpointsPaginateFiltersTypeDef",
    "DescribeVpcEndpointsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef",
    "DescribeVpcEndpointsPaginateResponseTypeDef",
    "DescribeVpcPeeringConnectionsPaginateFiltersTypeDef",
    "DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseTypeDef",
    "DescribeVpcsPaginateFiltersTypeDef",
    "DescribeVpcsPaginatePaginationConfigTypeDef",
    "DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    "DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef",
    "DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    "DescribeVpcsPaginateResponseVpcsTagsTypeDef",
    "DescribeVpcsPaginateResponseVpcsTypeDef",
    "DescribeVpcsPaginateResponseTypeDef",
    "DhcpOptionsCreateTagsTagsTypeDef",
    "DhcpOptionsSetsFilterFiltersTypeDef",
    "ExportTaskCancelledWaitWaiterConfigTypeDef",
    "ExportTaskCompletedWaitWaiterConfigTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef",
    "ImageAvailableWaitFiltersTypeDef",
    "ImageAvailableWaitWaiterConfigTypeDef",
    "ImageCreateTagsTagsTypeDef",
    "ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    "ImageDescribeAttributeResponseDescriptionTypeDef",
    "ImageDescribeAttributeResponseKernelIdTypeDef",
    "ImageDescribeAttributeResponseLaunchPermissionsTypeDef",
    "ImageDescribeAttributeResponseProductCodesTypeDef",
    "ImageDescribeAttributeResponseRamdiskIdTypeDef",
    "ImageDescribeAttributeResponseSriovNetSupportTypeDef",
    "ImageDescribeAttributeResponseTypeDef",
    "ImageExistsWaitFiltersTypeDef",
    "ImageExistsWaitWaiterConfigTypeDef",
    "ImageModifyAttributeDescriptionTypeDef",
    "ImageModifyAttributeLaunchPermissionAddTypeDef",
    "ImageModifyAttributeLaunchPermissionRemoveTypeDef",
    "ImageModifyAttributeLaunchPermissionTypeDef",
    "ImageWaitUntilExistsFiltersTypeDef",
    "ImagesFilterFiltersTypeDef",
    "InstanceAttachClassicLinkVpcResponseTypeDef",
    "InstanceAttachVolumeResponseTypeDef",
    "InstanceConsoleOutputResponseTypeDef",
    "InstanceCreateImageBlockDeviceMappingsEbsTypeDef",
    "InstanceCreateImageBlockDeviceMappingsTypeDef",
    "InstanceCreateTagsTagsTypeDef",
    "InstanceDeleteTagsTagsTypeDef",
    "InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    "InstanceDescribeAttributeResponseDisableApiTerminationTypeDef",
    "InstanceDescribeAttributeResponseEbsOptimizedTypeDef",
    "InstanceDescribeAttributeResponseEnaSupportTypeDef",
    "InstanceDescribeAttributeResponseGroupsTypeDef",
    "InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    "InstanceDescribeAttributeResponseInstanceTypeTypeDef",
    "InstanceDescribeAttributeResponseKernelIdTypeDef",
    "InstanceDescribeAttributeResponseProductCodesTypeDef",
    "InstanceDescribeAttributeResponseRamdiskIdTypeDef",
    "InstanceDescribeAttributeResponseRootDeviceNameTypeDef",
    "InstanceDescribeAttributeResponseSourceDestCheckTypeDef",
    "InstanceDescribeAttributeResponseSriovNetSupportTypeDef",
    "InstanceDescribeAttributeResponseUserDataTypeDef",
    "InstanceDescribeAttributeResponseTypeDef",
    "InstanceDetachClassicLinkVpcResponseTypeDef",
    "InstanceDetachVolumeResponseTypeDef",
    "InstanceExistsWaitFiltersTypeDef",
    "InstanceExistsWaitWaiterConfigTypeDef",
    "InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef",
    "InstanceModifyAttributeBlockDeviceMappingsTypeDef",
    "InstanceModifyAttributeDisableApiTerminationTypeDef",
    "InstanceModifyAttributeEbsOptimizedTypeDef",
    "InstanceModifyAttributeEnaSupportTypeDef",
    "InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    "InstanceModifyAttributeInstanceTypeTypeDef",
    "InstanceModifyAttributeKernelTypeDef",
    "InstanceModifyAttributeRamdiskTypeDef",
    "InstanceModifyAttributeSourceDestCheckTypeDef",
    "InstanceModifyAttributeSriovNetSupportTypeDef",
    "InstanceModifyAttributeUserDataTypeDef",
    "InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstanceMonitorResponseInstanceMonitoringsTypeDef",
    "InstanceMonitorResponseTypeDef",
    "InstancePasswordDataResponseTypeDef",
    "InstanceRunningWaitFiltersTypeDef",
    "InstanceRunningWaitWaiterConfigTypeDef",
    "InstanceStartResponseStartingInstancesCurrentStateTypeDef",
    "InstanceStartResponseStartingInstancesPreviousStateTypeDef",
    "InstanceStartResponseStartingInstancesTypeDef",
    "InstanceStartResponseTypeDef",
    "InstanceStatusOkWaitFiltersTypeDef",
    "InstanceStatusOkWaitWaiterConfigTypeDef",
    "InstanceStopResponseStoppingInstancesCurrentStateTypeDef",
    "InstanceStopResponseStoppingInstancesPreviousStateTypeDef",
    "InstanceStopResponseStoppingInstancesTypeDef",
    "InstanceStopResponseTypeDef",
    "InstanceStoppedWaitFiltersTypeDef",
    "InstanceStoppedWaitWaiterConfigTypeDef",
    "InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    "InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    "InstanceTerminateResponseTerminatingInstancesTypeDef",
    "InstanceTerminateResponseTypeDef",
    "InstanceTerminatedWaitFiltersTypeDef",
    "InstanceTerminatedWaitWaiterConfigTypeDef",
    "InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstanceUnmonitorResponseInstanceMonitoringsTypeDef",
    "InstanceUnmonitorResponseTypeDef",
    "InstanceWaitUntilExistsFiltersTypeDef",
    "InstanceWaitUntilRunningFiltersTypeDef",
    "InstanceWaitUntilStoppedFiltersTypeDef",
    "InstanceWaitUntilTerminatedFiltersTypeDef",
    "InstancesCreateTagsTagsTypeDef",
    "InstancesFilterFiltersTypeDef",
    "InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstancesMonitorResponseInstanceMonitoringsTypeDef",
    "InstancesMonitorResponseTypeDef",
    "InstancesStartResponseStartingInstancesCurrentStateTypeDef",
    "InstancesStartResponseStartingInstancesPreviousStateTypeDef",
    "InstancesStartResponseStartingInstancesTypeDef",
    "InstancesStartResponseTypeDef",
    "InstancesStopResponseStoppingInstancesCurrentStateTypeDef",
    "InstancesStopResponseStoppingInstancesPreviousStateTypeDef",
    "InstancesStopResponseStoppingInstancesTypeDef",
    "InstancesStopResponseTypeDef",
    "InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    "InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    "InstancesTerminateResponseTerminatingInstancesTypeDef",
    "InstancesTerminateResponseTypeDef",
    "InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstancesUnmonitorResponseInstanceMonitoringsTypeDef",
    "InstancesUnmonitorResponseTypeDef",
    "InternetGatewayCreateTagsTagsTypeDef",
    "InternetGatewaysFilterFiltersTypeDef",
    "KeyPairExistsWaitFiltersTypeDef",
    "KeyPairExistsWaitWaiterConfigTypeDef",
    "KeyPairsFilterFiltersTypeDef",
    "NatGatewayAvailableWaitFiltersTypeDef",
    "NatGatewayAvailableWaitWaiterConfigTypeDef",
    "NetworkAclCreateEntryIcmpTypeCodeTypeDef",
    "NetworkAclCreateEntryPortRangeTypeDef",
    "NetworkAclCreateTagsTagsTypeDef",
    "NetworkAclReplaceAssociationResponseTypeDef",
    "NetworkAclReplaceEntryIcmpTypeCodeTypeDef",
    "NetworkAclReplaceEntryPortRangeTypeDef",
    "NetworkAclsFilterFiltersTypeDef",
    "NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    "NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef",
    "NetworkInterfaceAttachResponseTypeDef",
    "NetworkInterfaceAvailableWaitFiltersTypeDef",
    "NetworkInterfaceAvailableWaitWaiterConfigTypeDef",
    "NetworkInterfaceCreateTagsTagsTypeDef",
    "NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef",
    "NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef",
    "NetworkInterfaceDescribeAttributeResponseGroupsTypeDef",
    "NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef",
    "NetworkInterfaceDescribeAttributeResponseTypeDef",
    "NetworkInterfaceModifyAttributeAttachmentTypeDef",
    "NetworkInterfaceModifyAttributeDescriptionTypeDef",
    "NetworkInterfaceModifyAttributeSourceDestCheckTypeDef",
    "NetworkInterfacesFilterFiltersTypeDef",
    "PasswordDataAvailableWaitWaiterConfigTypeDef",
    "PlacementGroupsFilterFiltersTypeDef",
    "RouteTableCreateTagsTagsTypeDef",
    "RouteTablesFilterFiltersTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsTypeDef",
    "SecurityGroupCreateTagsTagsTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsTypeDef",
    "SecurityGroupsFilterFiltersTypeDef",
    "ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef",
    "ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef",
    "ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef",
    "ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef",
    "ServiceResourceCreateInstancesCpuOptionsTypeDef",
    "ServiceResourceCreateInstancesCreditSpecificationTypeDef",
    "ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef",
    "ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef",
    "ServiceResourceCreateInstancesHibernationOptionsTypeDef",
    "ServiceResourceCreateInstancesIamInstanceProfileTypeDef",
    "ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef",
    "ServiceResourceCreateInstancesIpv6AddressesTypeDef",
    "ServiceResourceCreateInstancesLaunchTemplateTypeDef",
    "ServiceResourceCreateInstancesLicenseSpecificationsTypeDef",
    "ServiceResourceCreateInstancesMonitoringTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesTypeDef",
    "ServiceResourceCreateInstancesPlacementTypeDef",
    "ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateInstancesTagSpecificationsTypeDef",
    "ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef",
    "ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateSnapshotTagSpecificationsTypeDef",
    "ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateVolumeTagSpecificationsTypeDef",
    "ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef",
    "ServiceResourceRegisterImageBlockDeviceMappingsTypeDef",
    "SnapshotCompletedWaitFiltersTypeDef",
    "SnapshotCompletedWaitWaiterConfigTypeDef",
    "SnapshotCopyResponseTagsTypeDef",
    "SnapshotCopyResponseTypeDef",
    "SnapshotCopyTagSpecificationsTagsTypeDef",
    "SnapshotCopyTagSpecificationsTypeDef",
    "SnapshotCreateTagsTagsTypeDef",
    "SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef",
    "SnapshotDescribeAttributeResponseProductCodesTypeDef",
    "SnapshotDescribeAttributeResponseTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionAddTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionTypeDef",
    "SnapshotWaitUntilCompletedFiltersTypeDef",
    "SnapshotsFilterFiltersTypeDef",
    "SpotInstanceRequestFulfilledWaitFiltersTypeDef",
    "SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef",
    "SubnetAvailableWaitFiltersTypeDef",
    "SubnetAvailableWaitWaiterConfigTypeDef",
    "SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef",
    "SubnetCreateInstancesBlockDeviceMappingsTypeDef",
    "SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "SubnetCreateInstancesCapacityReservationSpecificationTypeDef",
    "SubnetCreateInstancesCpuOptionsTypeDef",
    "SubnetCreateInstancesCreditSpecificationTypeDef",
    "SubnetCreateInstancesElasticGpuSpecificationTypeDef",
    "SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef",
    "SubnetCreateInstancesHibernationOptionsTypeDef",
    "SubnetCreateInstancesIamInstanceProfileTypeDef",
    "SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "SubnetCreateInstancesInstanceMarketOptionsTypeDef",
    "SubnetCreateInstancesIpv6AddressesTypeDef",
    "SubnetCreateInstancesLaunchTemplateTypeDef",
    "SubnetCreateInstancesLicenseSpecificationsTypeDef",
    "SubnetCreateInstancesMonitoringTypeDef",
    "SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "SubnetCreateInstancesNetworkInterfacesTypeDef",
    "SubnetCreateInstancesPlacementTypeDef",
    "SubnetCreateInstancesTagSpecificationsTagsTypeDef",
    "SubnetCreateInstancesTagSpecificationsTypeDef",
    "SubnetCreateNetworkInterfaceIpv6AddressesTypeDef",
    "SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "SubnetCreateTagsTagsTypeDef",
    "SubnetsFilterFiltersTypeDef",
    "SystemStatusOkWaitFiltersTypeDef",
    "SystemStatusOkWaitWaiterConfigTypeDef",
    "VolumeAttachToInstanceResponseTypeDef",
    "VolumeAvailableWaitFiltersTypeDef",
    "VolumeAvailableWaitWaiterConfigTypeDef",
    "VolumeCreateSnapshotTagSpecificationsTagsTypeDef",
    "VolumeCreateSnapshotTagSpecificationsTypeDef",
    "VolumeCreateTagsTagsTypeDef",
    "VolumeDeletedWaitFiltersTypeDef",
    "VolumeDeletedWaitWaiterConfigTypeDef",
    "VolumeDescribeAttributeResponseAutoEnableIOTypeDef",
    "VolumeDescribeAttributeResponseProductCodesTypeDef",
    "VolumeDescribeAttributeResponseTypeDef",
    "VolumeDescribeStatusFiltersTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesTypeDef",
    "VolumeDescribeStatusResponseTypeDef",
    "VolumeDetachFromInstanceResponseTypeDef",
    "VolumeInUseWaitFiltersTypeDef",
    "VolumeInUseWaitWaiterConfigTypeDef",
    "VolumeModifyAttributeAutoEnableIOTypeDef",
    "VolumesFilterFiltersTypeDef",
    "VpcAddressAssociateResponseTypeDef",
    "VpcAttachClassicLinkInstanceResponseTypeDef",
    "VpcAvailableWaitFiltersTypeDef",
    "VpcAvailableWaitWaiterConfigTypeDef",
    "VpcCreateTagsTagsTypeDef",
    "VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef",
    "VpcDescribeAttributeResponseEnableDnsSupportTypeDef",
    "VpcDescribeAttributeResponseTypeDef",
    "VpcDetachClassicLinkInstanceResponseTypeDef",
    "VpcDisableClassicLinkResponseTypeDef",
    "VpcEnableClassicLinkResponseTypeDef",
    "VpcExistsWaitFiltersTypeDef",
    "VpcExistsWaitWaiterConfigTypeDef",
    "VpcModifyAttributeEnableDnsHostnamesTypeDef",
    "VpcModifyAttributeEnableDnsSupportTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef",
    "VpcPeeringConnectionAcceptResponseTypeDef",
    "VpcPeeringConnectionDeleteResponseTypeDef",
    "VpcPeeringConnectionDeletedWaitFiltersTypeDef",
    "VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef",
    "VpcPeeringConnectionExistsWaitFiltersTypeDef",
    "VpcPeeringConnectionExistsWaitWaiterConfigTypeDef",
    "VpcPeeringConnectionRejectResponseTypeDef",
    "VpcPeeringConnectionWaitUntilExistsFiltersTypeDef",
    "VpcPeeringConnectionsFilterFiltersTypeDef",
    "VpcWaitUntilAvailableFiltersTypeDef",
    "VpcWaitUntilExistsFiltersTypeDef",
    "VpcsFilterFiltersTypeDef",
    "VpnConnectionAvailableWaitFiltersTypeDef",
    "VpnConnectionAvailableWaitWaiterConfigTypeDef",
    "VpnConnectionDeletedWaitFiltersTypeDef",
    "VpnConnectionDeletedWaitWaiterConfigTypeDef",
)


_BundleTaskCompleteWaitFiltersTypeDef = TypedDict(
    "_BundleTaskCompleteWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class BundleTaskCompleteWaitFiltersTypeDef(_BundleTaskCompleteWaitFiltersTypeDef):
    """
    Type definition for `BundleTaskCompleteWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_BundleTaskCompleteWaitWaiterConfigTypeDef = TypedDict(
    "_BundleTaskCompleteWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class BundleTaskCompleteWaitWaiterConfigTypeDef(
    _BundleTaskCompleteWaitWaiterConfigTypeDef
):
    """
    Type definition for `BundleTaskCompleteWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ClassicAddressAssociateResponseTypeDef = TypedDict(
    "_ClassicAddressAssociateResponseTypeDef", {"AssociationId": str}, total=False
)


class ClassicAddressAssociateResponseTypeDef(_ClassicAddressAssociateResponseTypeDef):
    """
    Type definition for `ClassicAddressAssociate` `Response`

    - **AssociationId** *(string) --*

      [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef = TypedDict(
    "_ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef",
    {"ExchangeId": str},
    total=False,
)


class ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef(
    _ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef
):
    """
    Type definition for `ClientAcceptReservedInstancesExchangeQuote` `Response`

    The result of the exchange and whether it was ``successful`` .

    - **ExchangeId** *(string) --*

      The ID of the successful exchange.
    """


_RequiredClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_RequiredClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"OfferingId": str},
)
_OptionalClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_OptionalClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"InstanceCount": int},
    total=False,
)


class ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef(
    _RequiredClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef,
    _OptionalClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef,
):
    """
    Type definition for `ClientAcceptReservedInstancesExchangeQuote` `TargetConfigurations`

    Details about the target configuration.

    - **InstanceCount** *(integer) --*

      The number of instances the Covertible Reserved Instance offering can be applied to. This
      parameter is reserved and cannot be specified in a request

    - **OfferingId** *(string) --* **[REQUIRED]**

      The Convertible Reserved Instance offering ID.
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    """
    Type definition for `ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    Type definition for `ClientAcceptTransitGatewayVpcAttachmentResponse` `TransitGatewayVpcAttachment`

    The VPC attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    Type definition for `ClientAcceptTransitGatewayVpcAttachment` `Response`

    - **TransitGatewayVpcAttachment** *(dict) --*

      The VPC attachment.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **VpcOwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **State** *(string) --*

        The state of the VPC attachment.

      - **SubnetIds** *(list) --*

        The IDs of the subnets.

        - *(string) --*

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The VPC attachment options.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

        - **Ipv6Support** *(string) --*

          Indicates whether IPv6 support is enabled.

      - **Tags** *(list) --*

        The tags for the VPC attachment.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientAcceptVpcEndpointConnectionsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientAcceptVpcEndpointConnectionsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientAcceptVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseTypeDef",
    {
        "Unsuccessful": List[
            ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef
        ]
    },
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseTypeDef
):
    """
    Type definition for `ClientAcceptVpcEndpointConnections` `Response`

    - **Unsuccessful** *(list) --*

      Information about the interface endpoints that were not accepted, if applicable.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnection` `AccepterVpcInfo`

    Information about the accepter VPC. CIDR block information is only returned when describing
    an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnection` `RequesterVpcInfo`

    Information about the requester VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnection` `Status`

    The status of the VPC peering connection.

    - **Code** *(string) --*

      The status of the VPC peering connection.

    - **Message** *(string) --*

      A message that provides more information about the status, if applicable.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
        ],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnectionResponse` `VpcPeeringConnection`

    Information about the VPC peering connection.

    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing
      an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **ExpirationTime** *(datetime) --*

      The time that an unaccepted VPC peering connection will expire.

    - **RequesterVpcInfo** *(dict) --*

      Information about the requester VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **Status** *(dict) --*

      The status of the VPC peering connection.

      - **Code** *(string) --*

        The status of the VPC peering connection.

      - **Message** *(string) --*

        A message that provides more information about the status, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_ClientAcceptVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseTypeDef",
    {
        "VpcPeeringConnection": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseTypeDef
):
    """
    Type definition for `ClientAcceptVpcPeeringConnection` `Response`

    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.

      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **ExpirationTime** *(datetime) --*

        The time that an unaccepted VPC peering connection will expire.

      - **RequesterVpcInfo** *(dict) --*

        Information about the requester VPC. CIDR block information is only returned when
        describing an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **Status** *(dict) --*

        The status of the VPC peering connection.

        - **Code** *(string) --*

          The status of the VPC peering connection.

        - **Message** *(string) --*

          A message that provides more information about the status, if applicable.

      - **Tags** *(list) --*

        Any tags assigned to the resource.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcPeeringConnectionId** *(string) --*

        The ID of the VPC peering connection.
    """


_ClientAdvertiseByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientAdvertiseByoipCidrResponseByoipCidrTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class ClientAdvertiseByoipCidrResponseByoipCidrTypeDef(
    _ClientAdvertiseByoipCidrResponseByoipCidrTypeDef
):
    """
    Type definition for `ClientAdvertiseByoipCidrResponse` `ByoipCidr`

    Information about the address range.

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_ClientAdvertiseByoipCidrResponseTypeDef = TypedDict(
    "_ClientAdvertiseByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientAdvertiseByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientAdvertiseByoipCidrResponseTypeDef(_ClientAdvertiseByoipCidrResponseTypeDef):
    """
    Type definition for `ClientAdvertiseByoipCidr` `Response`

    - **ByoipCidr** *(dict) --*

      Information about the address range.

      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.

      - **Description** *(string) --*

        The description of the address range.

      - **StatusMessage** *(string) --*

        Upon success, contains the ID of the address pool. Otherwise, contains an error message.

      - **State** *(string) --*

        The state of the address pool.
    """


_ClientAllocateAddressResponseTypeDef = TypedDict(
    "_ClientAllocateAddressResponseTypeDef",
    {"PublicIp": str, "AllocationId": str, "PublicIpv4Pool": str, "Domain": str},
    total=False,
)


class ClientAllocateAddressResponseTypeDef(_ClientAllocateAddressResponseTypeDef):
    """
    Type definition for `ClientAllocateAddress` `Response`

    - **PublicIp** *(string) --*

      The Elastic IP address.

    - **AllocationId** *(string) --*

      [EC2-VPC] The ID that AWS assigns to represent the allocation of the Elastic IP address for
      use with instances in a VPC.

    - **PublicIpv4Pool** *(string) --*

      The ID of an address pool.

    - **Domain** *(string) --*

      Indicates whether this Elastic IP address is for use with instances in EC2-Classic
      (``standard`` ) or instances in a VPC (``vpc`` ).
    """


_ClientAllocateHostsResponseTypeDef = TypedDict(
    "_ClientAllocateHostsResponseTypeDef", {"HostIds": List[str]}, total=False
)


class ClientAllocateHostsResponseTypeDef(_ClientAllocateHostsResponseTypeDef):
    """
    Type definition for `ClientAllocateHosts` `Response`

    Contains the output of AllocateHosts.

    - **HostIds** *(list) --*

      The ID of the allocated Dedicated Host. This is used to launch an instance onto a specific
      host.

      - *(string) --*
    """


_ClientAllocateHostsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientAllocateHostsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientAllocateHostsTagSpecificationsTagsTypeDef(
    _ClientAllocateHostsTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientAllocateHostsTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientAllocateHostsTagSpecificationsTypeDef = TypedDict(
    "_ClientAllocateHostsTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientAllocateHostsTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientAllocateHostsTagSpecificationsTypeDef(
    _ClientAllocateHostsTagSpecificationsTypeDef
):
    """
    Type definition for `ClientAllocateHosts` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef",
    {"SecurityGroupIds": List[str]},
    total=False,
)


class ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef(
    _ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef
):
    """
    Type definition for `ClientApplySecurityGroupsToClientVpnTargetNetwork` `Response`

    - **SecurityGroupIds** *(list) --*

      The IDs of the applied security groups.

      - *(string) --*
    """


_ClientAssignIpv6AddressesResponseTypeDef = TypedDict(
    "_ClientAssignIpv6AddressesResponseTypeDef",
    {"AssignedIpv6Addresses": List[str], "NetworkInterfaceId": str},
    total=False,
)


class ClientAssignIpv6AddressesResponseTypeDef(
    _ClientAssignIpv6AddressesResponseTypeDef
):
    """
    Type definition for `ClientAssignIpv6Addresses` `Response`

    - **AssignedIpv6Addresses** *(list) --*

      The IPv6 addresses assigned to the network interface.

      - *(string) --*

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.
    """


_ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef = TypedDict(
    "_ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    {"PrivateIpAddress": str},
    total=False,
)


class ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef(
    _ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientAssignPrivateIpAddressesResponse` `AssignedPrivateIpAddresses`

    Describes the private IP addresses assigned to a network interface.

    - **PrivateIpAddress** *(string) --*

      The private IP address assigned to the network interface.
    """


_ClientAssignPrivateIpAddressesResponseTypeDef = TypedDict(
    "_ClientAssignPrivateIpAddressesResponseTypeDef",
    {
        "NetworkInterfaceId": str,
        "AssignedPrivateIpAddresses": List[
            ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
        ],
    },
    total=False,
)


class ClientAssignPrivateIpAddressesResponseTypeDef(
    _ClientAssignPrivateIpAddressesResponseTypeDef
):
    """
    Type definition for `ClientAssignPrivateIpAddresses` `Response`

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **AssignedPrivateIpAddresses** *(list) --*

      The private IP addresses assigned to the network interface.

      - *(dict) --*

        Describes the private IP addresses assigned to a network interface.

        - **PrivateIpAddress** *(string) --*

          The private IP address assigned to the network interface.
    """


_ClientAssociateAddressResponseTypeDef = TypedDict(
    "_ClientAssociateAddressResponseTypeDef", {"AssociationId": str}, total=False
)


class ClientAssociateAddressResponseTypeDef(_ClientAssociateAddressResponseTypeDef):
    """
    Type definition for `ClientAssociateAddress` `Response`

    - **AssociationId** *(string) --*

      [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef = TypedDict(
    "_ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef(
    _ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef
):
    """
    Type definition for `ClientAssociateClientVpnTargetNetworkResponse` `Status`

    The current state of the target network association.

    - **Code** *(string) --*

      The state of the target network association.

    - **Message** *(string) --*

      A message about the status of the target network association, if applicable.
    """


_ClientAssociateClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientAssociateClientVpnTargetNetworkResponseTypeDef",
    {
        "AssociationId": str,
        "Status": ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef,
    },
    total=False,
)


class ClientAssociateClientVpnTargetNetworkResponseTypeDef(
    _ClientAssociateClientVpnTargetNetworkResponseTypeDef
):
    """
    Type definition for `ClientAssociateClientVpnTargetNetwork` `Response`

    - **AssociationId** *(string) --*

      The unique ID of the target network association.

    - **Status** *(dict) --*

      The current state of the target network association.

      - **Code** *(string) --*

        The state of the target network association.

      - **Message** *(string) --*

        A message about the status of the target network association, if applicable.
    """


_ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef(
    _ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientAssociateIamInstanceProfile` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociation` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef(
    _ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
):
    """
    Type definition for `ClientAssociateIamInstanceProfileResponse` `IamInstanceProfileAssociation`

    Information about the IAM instance profile association.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **State** *(string) --*

      The state of the association.

    - **Timestamp** *(datetime) --*

      The time the IAM instance profile was associated with the instance.
    """


_ClientAssociateIamInstanceProfileResponseTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientAssociateIamInstanceProfileResponseTypeDef(
    _ClientAssociateIamInstanceProfileResponseTypeDef
):
    """
    Type definition for `ClientAssociateIamInstanceProfile` `Response`

    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.

      - **AssociationId** *(string) --*

        The ID of the association.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Id** *(string) --*

          The ID of the instance profile.

      - **State** *(string) --*

        The state of the association.

      - **Timestamp** *(datetime) --*

        The time the IAM instance profile was associated with the instance.
    """


_ClientAssociateRouteTableResponseTypeDef = TypedDict(
    "_ClientAssociateRouteTableResponseTypeDef", {"AssociationId": str}, total=False
)


class ClientAssociateRouteTableResponseTypeDef(
    _ClientAssociateRouteTableResponseTypeDef
):
    """
    Type definition for `ClientAssociateRouteTable` `Response`

    - **AssociationId** *(string) --*

      The route table association ID. This ID is required for disassociating the route table.
    """


_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociation` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientAssociateSubnetCidrBlockResponse` `Ipv6CidrBlockAssociation`

    Information about the IPv6 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateSubnetCidrBlockResponseTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "SubnetId": str,
    },
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseTypeDef(
    _ClientAssociateSubnetCidrBlockResponseTypeDef
):
    """
    Type definition for `ClientAssociateSubnetCidrBlock` `Response`

    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the CIDR block.

      - **Ipv6CidrBlock** *(string) --*

        The IPv6 CIDR block.

      - **Ipv6CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of a CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef = TypedDict(
    "_ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef(
    _ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef
):
    """
    Type definition for `ClientAssociateTransitGatewayRouteTableResponse` `Association`

    The ID of the association.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **State** *(string) --*

      The state of the association.
    """


_ClientAssociateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientAssociateTransitGatewayRouteTableResponseTypeDef",
    {"Association": ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef},
    total=False,
)


class ClientAssociateTransitGatewayRouteTableResponseTypeDef(
    _ClientAssociateTransitGatewayRouteTableResponseTypeDef
):
    """
    Type definition for `ClientAssociateTransitGatewayRouteTable` `Response`

    - **Association** *(dict) --*

      The ID of the association.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **ResourceId** *(string) --*

        The ID of the resource.

      - **ResourceType** *(string) --*

        The resource type.

      - **State** *(string) --*

        The state of the association.
    """


_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef(
    _ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef
):
    """
    Type definition for `ClientAssociateVpcCidrBlockResponseCidrBlockAssociation` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef(
    _ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientAssociateVpcCidrBlockResponse` `CidrBlockAssociation`

    Information about the IPv4 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociation` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientAssociateVpcCidrBlockResponse` `Ipv6CidrBlockAssociation`

    Information about the IPv6 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientAssociateVpcCidrBlockResponseTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "CidrBlockAssociation": ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef,
        "VpcId": str,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseTypeDef(
    _ClientAssociateVpcCidrBlockResponseTypeDef
):
    """
    Type definition for `ClientAssociateVpcCidrBlock` `Response`

    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the IPv6 CIDR block.

      - **Ipv6CidrBlock** *(string) --*

        The IPv6 CIDR block.

      - **Ipv6CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of the CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociation** *(dict) --*

      Information about the IPv4 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the IPv4 CIDR block.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block.

      - **CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of the CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientAttachClassicLinkVpcResponseTypeDef = TypedDict(
    "_ClientAttachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class ClientAttachClassicLinkVpcResponseTypeDef(
    _ClientAttachClassicLinkVpcResponseTypeDef
):
    """
    Type definition for `ClientAttachClassicLinkVpc` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientAttachNetworkInterfaceResponseTypeDef = TypedDict(
    "_ClientAttachNetworkInterfaceResponseTypeDef", {"AttachmentId": str}, total=False
)


class ClientAttachNetworkInterfaceResponseTypeDef(
    _ClientAttachNetworkInterfaceResponseTypeDef
):
    """
    Type definition for `ClientAttachNetworkInterface` `Response`

    Contains the output of AttachNetworkInterface.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.
    """


_ClientAttachVolumeResponseTypeDef = TypedDict(
    "_ClientAttachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientAttachVolumeResponseTypeDef(_ClientAttachVolumeResponseTypeDef):
    """
    Type definition for `ClientAttachVolume` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_ClientAttachVpnGatewayResponseVpcAttachmentTypeDef = TypedDict(
    "_ClientAttachVpnGatewayResponseVpcAttachmentTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientAttachVpnGatewayResponseVpcAttachmentTypeDef(
    _ClientAttachVpnGatewayResponseVpcAttachmentTypeDef
):
    """
    Type definition for `ClientAttachVpnGatewayResponse` `VpcAttachment`

    Information about the attachment.

    - **State** *(string) --*

      The current state of the attachment.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientAttachVpnGatewayResponseTypeDef = TypedDict(
    "_ClientAttachVpnGatewayResponseTypeDef",
    {"VpcAttachment": ClientAttachVpnGatewayResponseVpcAttachmentTypeDef},
    total=False,
)


class ClientAttachVpnGatewayResponseTypeDef(_ClientAttachVpnGatewayResponseTypeDef):
    """
    Type definition for `ClientAttachVpnGateway` `Response`

    Contains the output of AttachVpnGateway.

    - **VpcAttachment** *(dict) --*

      Information about the attachment.

      - **State** *(string) --*

        The current state of the attachment.

      - **VpcId** *(string) --*

        The ID of the VPC.
    """


_ClientAuthorizeClientVpnIngressResponseStatusTypeDef = TypedDict(
    "_ClientAuthorizeClientVpnIngressResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientAuthorizeClientVpnIngressResponseStatusTypeDef(
    _ClientAuthorizeClientVpnIngressResponseStatusTypeDef
):
    """
    Type definition for `ClientAuthorizeClientVpnIngressResponse` `Status`

    The current state of the authorization rule.

    - **Code** *(string) --*

      The state of the authorization rule.

    - **Message** *(string) --*

      A message about the status of the authorization rule, if applicable.
    """


_ClientAuthorizeClientVpnIngressResponseTypeDef = TypedDict(
    "_ClientAuthorizeClientVpnIngressResponseTypeDef",
    {"Status": ClientAuthorizeClientVpnIngressResponseStatusTypeDef},
    total=False,
)


class ClientAuthorizeClientVpnIngressResponseTypeDef(
    _ClientAuthorizeClientVpnIngressResponseTypeDef
):
    """
    Type definition for `ClientAuthorizeClientVpnIngress` `Response`

    - **Status** *(dict) --*

      The current state of the authorization rule.

      - **Code** *(string) --*

        The state of the authorization rule.

      - **Message** *(string) --*

        A message about the status of the authorization rule, if applicable.
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupEgressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupEgressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupEgressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupEgressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupEgress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupIngressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupIngressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupIngressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupIngressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef
):
    """
    Type definition for `ClientAuthorizeSecurityGroupIngress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef(
    _ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef
):
    """
    Type definition for `ClientBundleInstanceResponseBundleTask` `BundleTaskError`

    If the task fails, a description of the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message.
    """


_ClientBundleInstanceResponseBundleTaskStorageS3TypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientBundleInstanceResponseBundleTaskStorageS3TypeDef(
    _ClientBundleInstanceResponseBundleTaskStorageS3TypeDef
):
    """
    Type definition for `ClientBundleInstanceResponseBundleTaskStorage` `S3`

    An Amazon S3 storage location.

    - **AWSAccessKeyId** *(string) --*

      The access key ID of the owner of the bucket. Before you specify a value for your
      access key ID, review and follow the guidance in `Best Practices for Managing AWS
      Access Keys
      <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

    - **Bucket** *(string) --*

      The bucket in which to store the AMI. You can specify a bucket that you already own or
      a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
      belongs to someone else, Amazon EC2 returns an error.

    - **Prefix** *(string) --*

      The beginning of the file name of the AMI.

    - **UploadPolicy** *(bytes) --*

      An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
      S3 on your behalf.

    - **UploadPolicySignature** *(string) --*

      The signature of the JSON document.
    """


_ClientBundleInstanceResponseBundleTaskStorageTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskStorageTypeDef",
    {"S3": ClientBundleInstanceResponseBundleTaskStorageS3TypeDef},
    total=False,
)


class ClientBundleInstanceResponseBundleTaskStorageTypeDef(
    _ClientBundleInstanceResponseBundleTaskStorageTypeDef
):
    """
    Type definition for `ClientBundleInstanceResponseBundleTask` `Storage`

    The Amazon S3 storage locations.

    - **S3** *(dict) --*

      An Amazon S3 storage location.

      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your
        access key ID, review and follow the guidance in `Best Practices for Managing AWS
        Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

      - **Bucket** *(string) --*

        The bucket in which to store the AMI. You can specify a bucket that you already own or
        a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
        belongs to someone else, Amazon EC2 returns an error.

      - **Prefix** *(string) --*

        The beginning of the file name of the AMI.

      - **UploadPolicy** *(bytes) --*

        An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
        S3 on your behalf.

      - **UploadPolicySignature** *(string) --*

        The signature of the JSON document.
    """


_ClientBundleInstanceResponseBundleTaskTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": str,
        "Storage": ClientBundleInstanceResponseBundleTaskStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientBundleInstanceResponseBundleTaskTypeDef(
    _ClientBundleInstanceResponseBundleTaskTypeDef
):
    """
    Type definition for `ClientBundleInstanceResponse` `BundleTask`

    Information about the bundle task.

    - **BundleId** *(string) --*

      The ID of the bundle task.

    - **BundleTaskError** *(dict) --*

      If the task fails, a description of the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message.

    - **InstanceId** *(string) --*

      The ID of the instance associated with this bundle task.

    - **Progress** *(string) --*

      The level of task completion, as a percent (for example, 20%).

    - **StartTime** *(datetime) --*

      The time this task started.

    - **State** *(string) --*

      The state of the task.

    - **Storage** *(dict) --*

      The Amazon S3 storage locations.

      - **S3** *(dict) --*

        An Amazon S3 storage location.

        - **AWSAccessKeyId** *(string) --*

          The access key ID of the owner of the bucket. Before you specify a value for your
          access key ID, review and follow the guidance in `Best Practices for Managing AWS
          Access Keys
          <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

        - **Bucket** *(string) --*

          The bucket in which to store the AMI. You can specify a bucket that you already own or
          a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
          belongs to someone else, Amazon EC2 returns an error.

        - **Prefix** *(string) --*

          The beginning of the file name of the AMI.

        - **UploadPolicy** *(bytes) --*

          An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
          S3 on your behalf.

        - **UploadPolicySignature** *(string) --*

          The signature of the JSON document.

    - **UpdateTime** *(datetime) --*

      The time of the most recent update for the task.
    """


_ClientBundleInstanceResponseTypeDef = TypedDict(
    "_ClientBundleInstanceResponseTypeDef",
    {"BundleTask": ClientBundleInstanceResponseBundleTaskTypeDef},
    total=False,
)


class ClientBundleInstanceResponseTypeDef(_ClientBundleInstanceResponseTypeDef):
    """
    Type definition for `ClientBundleInstance` `Response`

    Contains the output of BundleInstance.

    - **BundleTask** *(dict) --*

      Information about the bundle task.

      - **BundleId** *(string) --*

        The ID of the bundle task.

      - **BundleTaskError** *(dict) --*

        If the task fails, a description of the error.

        - **Code** *(string) --*

          The error code.

        - **Message** *(string) --*

          The error message.

      - **InstanceId** *(string) --*

        The ID of the instance associated with this bundle task.

      - **Progress** *(string) --*

        The level of task completion, as a percent (for example, 20%).

      - **StartTime** *(datetime) --*

        The time this task started.

      - **State** *(string) --*

        The state of the task.

      - **Storage** *(dict) --*

        The Amazon S3 storage locations.

        - **S3** *(dict) --*

          An Amazon S3 storage location.

          - **AWSAccessKeyId** *(string) --*

            The access key ID of the owner of the bucket. Before you specify a value for your
            access key ID, review and follow the guidance in `Best Practices for Managing AWS
            Access Keys
            <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

          - **Bucket** *(string) --*

            The bucket in which to store the AMI. You can specify a bucket that you already own or
            a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
            belongs to someone else, Amazon EC2 returns an error.

          - **Prefix** *(string) --*

            The beginning of the file name of the AMI.

          - **UploadPolicy** *(bytes) --*

            An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
            S3 on your behalf.

          - **UploadPolicySignature** *(string) --*

            The signature of the JSON document.

      - **UpdateTime** *(datetime) --*

        The time of the most recent update for the task.
    """


_ClientBundleInstanceStorageS3TypeDef = TypedDict(
    "_ClientBundleInstanceStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientBundleInstanceStorageS3TypeDef(_ClientBundleInstanceStorageS3TypeDef):
    """
    Type definition for `ClientBundleInstanceStorage` `S3`

    An Amazon S3 storage location.

    - **AWSAccessKeyId** *(string) --*

      The access key ID of the owner of the bucket. Before you specify a value for your access key
      ID, review and follow the guidance in `Best Practices for Managing AWS Access Keys
      <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

    - **Bucket** *(string) --*

      The bucket in which to store the AMI. You can specify a bucket that you already own or a new
      bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to
      someone else, Amazon EC2 returns an error.

    - **Prefix** *(string) --*

      The beginning of the file name of the AMI.

    - **UploadPolicy** *(bytes) --*

      An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon S3 on
      your behalf.

    - **UploadPolicySignature** *(string) --*

      The signature of the JSON document.
    """


_ClientBundleInstanceStorageTypeDef = TypedDict(
    "_ClientBundleInstanceStorageTypeDef",
    {"S3": ClientBundleInstanceStorageS3TypeDef},
    total=False,
)


class ClientBundleInstanceStorageTypeDef(_ClientBundleInstanceStorageTypeDef):
    """
    Type definition for `ClientBundleInstance` `Storage`

    The bucket in which to store the AMI. You can specify a bucket that you already own or a new
    bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone
    else, Amazon EC2 returns an error.

    - **S3** *(dict) --*

      An Amazon S3 storage location.

      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your access key
        ID, review and follow the guidance in `Best Practices for Managing AWS Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

      - **Bucket** *(string) --*

        The bucket in which to store the AMI. You can specify a bucket that you already own or a new
        bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to
        someone else, Amazon EC2 returns an error.

      - **Prefix** *(string) --*

        The beginning of the file name of the AMI.

      - **UploadPolicy** *(bytes) --*

        An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon S3 on
        your behalf.

      - **UploadPolicySignature** *(string) --*

        The signature of the JSON document.
    """


_ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef
):
    """
    Type definition for `ClientCancelBundleTaskResponseBundleTask` `BundleTaskError`

    If the task fails, a description of the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message.
    """


_ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef(
    _ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef
):
    """
    Type definition for `ClientCancelBundleTaskResponseBundleTaskStorage` `S3`

    An Amazon S3 storage location.

    - **AWSAccessKeyId** *(string) --*

      The access key ID of the owner of the bucket. Before you specify a value for your
      access key ID, review and follow the guidance in `Best Practices for Managing AWS
      Access Keys
      <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

    - **Bucket** *(string) --*

      The bucket in which to store the AMI. You can specify a bucket that you already own or
      a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
      belongs to someone else, Amazon EC2 returns an error.

    - **Prefix** *(string) --*

      The beginning of the file name of the AMI.

    - **UploadPolicy** *(bytes) --*

      An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
      S3 on your behalf.

    - **UploadPolicySignature** *(string) --*

      The signature of the JSON document.
    """


_ClientCancelBundleTaskResponseBundleTaskStorageTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskStorageTypeDef",
    {"S3": ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef},
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskStorageTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskStorageTypeDef
):
    """
    Type definition for `ClientCancelBundleTaskResponseBundleTask` `Storage`

    The Amazon S3 storage locations.

    - **S3** *(dict) --*

      An Amazon S3 storage location.

      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your
        access key ID, review and follow the guidance in `Best Practices for Managing AWS
        Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

      - **Bucket** *(string) --*

        The bucket in which to store the AMI. You can specify a bucket that you already own or
        a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
        belongs to someone else, Amazon EC2 returns an error.

      - **Prefix** *(string) --*

        The beginning of the file name of the AMI.

      - **UploadPolicy** *(bytes) --*

        An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
        S3 on your behalf.

      - **UploadPolicySignature** *(string) --*

        The signature of the JSON document.
    """


_ClientCancelBundleTaskResponseBundleTaskTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": str,
        "Storage": ClientCancelBundleTaskResponseBundleTaskStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskTypeDef
):
    """
    Type definition for `ClientCancelBundleTaskResponse` `BundleTask`

    Information about the bundle task.

    - **BundleId** *(string) --*

      The ID of the bundle task.

    - **BundleTaskError** *(dict) --*

      If the task fails, a description of the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message.

    - **InstanceId** *(string) --*

      The ID of the instance associated with this bundle task.

    - **Progress** *(string) --*

      The level of task completion, as a percent (for example, 20%).

    - **StartTime** *(datetime) --*

      The time this task started.

    - **State** *(string) --*

      The state of the task.

    - **Storage** *(dict) --*

      The Amazon S3 storage locations.

      - **S3** *(dict) --*

        An Amazon S3 storage location.

        - **AWSAccessKeyId** *(string) --*

          The access key ID of the owner of the bucket. Before you specify a value for your
          access key ID, review and follow the guidance in `Best Practices for Managing AWS
          Access Keys
          <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

        - **Bucket** *(string) --*

          The bucket in which to store the AMI. You can specify a bucket that you already own or
          a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
          belongs to someone else, Amazon EC2 returns an error.

        - **Prefix** *(string) --*

          The beginning of the file name of the AMI.

        - **UploadPolicy** *(bytes) --*

          An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
          S3 on your behalf.

        - **UploadPolicySignature** *(string) --*

          The signature of the JSON document.

    - **UpdateTime** *(datetime) --*

      The time of the most recent update for the task.
    """


_ClientCancelBundleTaskResponseTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseTypeDef",
    {"BundleTask": ClientCancelBundleTaskResponseBundleTaskTypeDef},
    total=False,
)


class ClientCancelBundleTaskResponseTypeDef(_ClientCancelBundleTaskResponseTypeDef):
    """
    Type definition for `ClientCancelBundleTask` `Response`

    Contains the output of CancelBundleTask.

    - **BundleTask** *(dict) --*

      Information about the bundle task.

      - **BundleId** *(string) --*

        The ID of the bundle task.

      - **BundleTaskError** *(dict) --*

        If the task fails, a description of the error.

        - **Code** *(string) --*

          The error code.

        - **Message** *(string) --*

          The error message.

      - **InstanceId** *(string) --*

        The ID of the instance associated with this bundle task.

      - **Progress** *(string) --*

        The level of task completion, as a percent (for example, 20%).

      - **StartTime** *(datetime) --*

        The time this task started.

      - **State** *(string) --*

        The state of the task.

      - **Storage** *(dict) --*

        The Amazon S3 storage locations.

        - **S3** *(dict) --*

          An Amazon S3 storage location.

          - **AWSAccessKeyId** *(string) --*

            The access key ID of the owner of the bucket. Before you specify a value for your
            access key ID, review and follow the guidance in `Best Practices for Managing AWS
            Access Keys
            <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .

          - **Bucket** *(string) --*

            The bucket in which to store the AMI. You can specify a bucket that you already own or
            a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
            belongs to someone else, Amazon EC2 returns an error.

          - **Prefix** *(string) --*

            The beginning of the file name of the AMI.

          - **UploadPolicy** *(bytes) --*

            An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon
            S3 on your behalf.

          - **UploadPolicySignature** *(string) --*

            The signature of the JSON document.

      - **UpdateTime** *(datetime) --*

        The time of the most recent update for the task.
    """


_ClientCancelCapacityReservationResponseTypeDef = TypedDict(
    "_ClientCancelCapacityReservationResponseTypeDef", {"Return": bool}, total=False
)


class ClientCancelCapacityReservationResponseTypeDef(
    _ClientCancelCapacityReservationResponseTypeDef
):
    """
    Type definition for `ClientCancelCapacityReservation` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientCancelImportTaskResponseTypeDef = TypedDict(
    "_ClientCancelImportTaskResponseTypeDef",
    {"ImportTaskId": str, "PreviousState": str, "State": str},
    total=False,
)


class ClientCancelImportTaskResponseTypeDef(_ClientCancelImportTaskResponseTypeDef):
    """
    Type definition for `ClientCancelImportTask` `Response`

    - **ImportTaskId** *(string) --*

      The ID of the task being canceled.

    - **PreviousState** *(string) --*

      The current state of the task being canceled.

    - **State** *(string) --*

      The current state of the task being canceled.
    """


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": str},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
):
    """
    Type definition for `ClientCancelReservedInstancesListingResponseReservedInstancesListings` `InstanceCounts`

    Describes a Reserved Instance listing state.

    - **InstanceCount** *(integer) --*

      The number of listed Reserved Instances in the state specified by the ``state`` .

    - **State** *(string) --*

      The states of the listed Reserved Instances.
    """


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    """
    Type definition for `ClientCancelReservedInstancesListingResponseReservedInstancesListings` `PriceSchedules`

    Describes the price for a Reserved Instance.

    - **Active** *(boolean) --*

      The current price schedule, as determined by the term remaining for the Reserved
      Instance in the listing.

      A specific price schedule is always in effect, but only one price schedule can be
      active at any time. Take, for example, a Reserved Instance listing that has five
      months remaining in its term. When you specify price schedules for five months and
      two months, this means that schedule 1, covering the first three months of the
      remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
      the last two months of the term, will be active for months 2 and 1.

    - **CurrencyCode** *(string) --*

      The currency for transacting the Reserved Instance resale. At this time, the only
      supported currency is ``USD`` .

    - **Price** *(float) --*

      The fixed price for the term.

    - **Term** *(integer) --*

      The number of months remaining in the reservation. For example, 2 is the second to
      the last month before the capacity reservation expires.
    """


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
):
    """
    Type definition for `ClientCancelReservedInstancesListingResponseReservedInstancesListings` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": str,
        "StatusMessage": str,
        "Tags": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef
):
    """
    Type definition for `ClientCancelReservedInstancesListingResponse` `ReservedInstancesListings`

    Describes a Reserved Instance listing.

    - **ClientToken** *(string) --*

      A unique, case-sensitive key supplied by the client to ensure that the request is
      idempotent. For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **CreateDate** *(datetime) --*

      The time the listing was created.

    - **InstanceCounts** *(list) --*

      The number of instances in this state.

      - *(dict) --*

        Describes a Reserved Instance listing state.

        - **InstanceCount** *(integer) --*

          The number of listed Reserved Instances in the state specified by the ``state`` .

        - **State** *(string) --*

          The states of the listed Reserved Instances.

    - **PriceSchedules** *(list) --*

      The price of the Reserved Instance listing.

      - *(dict) --*

        Describes the price for a Reserved Instance.

        - **Active** *(boolean) --*

          The current price schedule, as determined by the term remaining for the Reserved
          Instance in the listing.

          A specific price schedule is always in effect, but only one price schedule can be
          active at any time. Take, for example, a Reserved Instance listing that has five
          months remaining in its term. When you specify price schedules for five months and
          two months, this means that schedule 1, covering the first three months of the
          remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
          the last two months of the term, will be active for months 2 and 1.

        - **CurrencyCode** *(string) --*

          The currency for transacting the Reserved Instance resale. At this time, the only
          supported currency is ``USD`` .

        - **Price** *(float) --*

          The fixed price for the term.

        - **Term** *(integer) --*

          The number of months remaining in the reservation. For example, 2 is the second to
          the last month before the capacity reservation expires.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.

    - **ReservedInstancesListingId** *(string) --*

      The ID of the Reserved Instance listing.

    - **Status** *(string) --*

      The status of the Reserved Instance listing.

    - **StatusMessage** *(string) --*

      The reason for the current status of the Reserved Instance listing. The response can be
      blank.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **UpdateDate** *(datetime) --*

      The last modified timestamp of the listing.
    """


_ClientCancelReservedInstancesListingResponseTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientCancelReservedInstancesListingResponseTypeDef(
    _ClientCancelReservedInstancesListingResponseTypeDef
):
    """
    Type definition for `ClientCancelReservedInstancesListing` `Response`

    Contains the output of CancelReservedInstancesListing.

    - **ReservedInstancesListings** *(list) --*

      The Reserved Instance listing.

      - *(dict) --*

        Describes a Reserved Instance listing.

        - **ClientToken** *(string) --*

          A unique, case-sensitive key supplied by the client to ensure that the request is
          idempotent. For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **CreateDate** *(datetime) --*

          The time the listing was created.

        - **InstanceCounts** *(list) --*

          The number of instances in this state.

          - *(dict) --*

            Describes a Reserved Instance listing state.

            - **InstanceCount** *(integer) --*

              The number of listed Reserved Instances in the state specified by the ``state`` .

            - **State** *(string) --*

              The states of the listed Reserved Instances.

        - **PriceSchedules** *(list) --*

          The price of the Reserved Instance listing.

          - *(dict) --*

            Describes the price for a Reserved Instance.

            - **Active** *(boolean) --*

              The current price schedule, as determined by the term remaining for the Reserved
              Instance in the listing.

              A specific price schedule is always in effect, but only one price schedule can be
              active at any time. Take, for example, a Reserved Instance listing that has five
              months remaining in its term. When you specify price schedules for five months and
              two months, this means that schedule 1, covering the first three months of the
              remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
              the last two months of the term, will be active for months 2 and 1.

            - **CurrencyCode** *(string) --*

              The currency for transacting the Reserved Instance resale. At this time, the only
              supported currency is ``USD`` .

            - **Price** *(float) --*

              The fixed price for the term.

            - **Term** *(integer) --*

              The number of months remaining in the reservation. For example, 2 is the second to
              the last month before the capacity reservation expires.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

        - **ReservedInstancesListingId** *(string) --*

          The ID of the Reserved Instance listing.

        - **Status** *(string) --*

          The status of the Reserved Instance listing.

        - **StatusMessage** *(string) --*

          The reason for the current status of the Reserved Instance listing. The response can be
          blank.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **UpdateDate** *(datetime) --*

          The last modified timestamp of the listing.
    """


_ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef",
    {
        "CurrentSpotFleetRequestState": str,
        "PreviousSpotFleetRequestState": str,
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef(
    _ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef
):
    """
    Type definition for `ClientCancelSpotFleetRequestsResponse` `SuccessfulFleetRequests`

    Describes a Spot Fleet request that was successfully canceled.

    - **CurrentSpotFleetRequestState** *(string) --*

      The current state of the Spot Fleet request.

    - **PreviousSpotFleetRequestState** *(string) --*

      The previous state of the Spot Fleet request.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.
    """


_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef(
    _ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef
):
    """
    Type definition for `ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequests` `Error`

    The error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The description for the error code.
    """


_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef",
    {
        "Error": ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef,
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef(
    _ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef
):
    """
    Type definition for `ClientCancelSpotFleetRequestsResponse` `UnsuccessfulFleetRequests`

    Describes a Spot Fleet request that was not successfully canceled.

    - **Error** *(dict) --*

      The error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The description for the error code.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.
    """


_ClientCancelSpotFleetRequestsResponseTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseTypeDef",
    {
        "SuccessfulFleetRequests": List[
            ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef
        ],
        "UnsuccessfulFleetRequests": List[
            ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef
        ],
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseTypeDef(
    _ClientCancelSpotFleetRequestsResponseTypeDef
):
    """
    Type definition for `ClientCancelSpotFleetRequests` `Response`

    Contains the output of CancelSpotFleetRequests.

    - **SuccessfulFleetRequests** *(list) --*

      Information about the Spot Fleet requests that are successfully canceled.

      - *(dict) --*

        Describes a Spot Fleet request that was successfully canceled.

        - **CurrentSpotFleetRequestState** *(string) --*

          The current state of the Spot Fleet request.

        - **PreviousSpotFleetRequestState** *(string) --*

          The previous state of the Spot Fleet request.

        - **SpotFleetRequestId** *(string) --*

          The ID of the Spot Fleet request.

    - **UnsuccessfulFleetRequests** *(list) --*

      Information about the Spot Fleet requests that are not successfully canceled.

      - *(dict) --*

        Describes a Spot Fleet request that was not successfully canceled.

        - **Error** *(dict) --*

          The error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The description for the error code.

        - **SpotFleetRequestId** *(string) --*

          The ID of the Spot Fleet request.
    """


_ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef",
    {"SpotInstanceRequestId": str, "State": str},
    total=False,
)


class ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef(
    _ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef
):
    """
    Type definition for `ClientCancelSpotInstanceRequestsResponse` `CancelledSpotInstanceRequests`

    Describes a request to cancel a Spot Instance.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **State** *(string) --*

      The state of the Spot Instance request.
    """


_ClientCancelSpotInstanceRequestsResponseTypeDef = TypedDict(
    "_ClientCancelSpotInstanceRequestsResponseTypeDef",
    {
        "CancelledSpotInstanceRequests": List[
            ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef
        ]
    },
    total=False,
)


class ClientCancelSpotInstanceRequestsResponseTypeDef(
    _ClientCancelSpotInstanceRequestsResponseTypeDef
):
    """
    Type definition for `ClientCancelSpotInstanceRequests` `Response`

    Contains the output of CancelSpotInstanceRequests.

    - **CancelledSpotInstanceRequests** *(list) --*

      One or more Spot Instance requests.

      - *(dict) --*

        Describes a request to cancel a Spot Instance.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **State** *(string) --*

          The state of the Spot Instance request.
    """


_ClientConfirmProductInstanceResponseTypeDef = TypedDict(
    "_ClientConfirmProductInstanceResponseTypeDef",
    {"OwnerId": str, "Return": bool},
    total=False,
)


class ClientConfirmProductInstanceResponseTypeDef(
    _ClientConfirmProductInstanceResponseTypeDef
):
    """
    Type definition for `ClientConfirmProductInstance` `Response`

    - **OwnerId** *(string) --*

      The AWS account ID of the instance owner. This is only present if the product code is
      attached to the instance.

    - **Return** *(boolean) --*

      The return value of the request. Returns ``true`` if the specified product code is owned by
      the requester and associated with the specified instance.
    """


_ClientCopyFpgaImageResponseTypeDef = TypedDict(
    "_ClientCopyFpgaImageResponseTypeDef", {"FpgaImageId": str}, total=False
)


class ClientCopyFpgaImageResponseTypeDef(_ClientCopyFpgaImageResponseTypeDef):
    """
    Type definition for `ClientCopyFpgaImage` `Response`

    - **FpgaImageId** *(string) --*

      The ID of the new AFI.
    """


_ClientCopyImageResponseTypeDef = TypedDict(
    "_ClientCopyImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientCopyImageResponseTypeDef(_ClientCopyImageResponseTypeDef):
    """
    Type definition for `ClientCopyImage` `Response`

    Contains the output of CopyImage.

    - **ImageId** *(string) --*

      The ID of the new AMI.
    """


_ClientCopySnapshotResponseTagsTypeDef = TypedDict(
    "_ClientCopySnapshotResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCopySnapshotResponseTagsTypeDef(_ClientCopySnapshotResponseTagsTypeDef):
    """
    Type definition for `ClientCopySnapshotResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCopySnapshotResponseTypeDef = TypedDict(
    "_ClientCopySnapshotResponseTypeDef",
    {"SnapshotId": str, "Tags": List[ClientCopySnapshotResponseTagsTypeDef]},
    total=False,
)


class ClientCopySnapshotResponseTypeDef(_ClientCopySnapshotResponseTypeDef):
    """
    Type definition for `ClientCopySnapshot` `Response`

    Contains the output of CopySnapshot.

    - **SnapshotId** *(string) --*

      The ID of the new snapshot.

    - **Tags** *(list) --*

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCopySnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCopySnapshotTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCopySnapshotTagSpecificationsTagsTypeDef(
    _ClientCopySnapshotTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCopySnapshotTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCopySnapshotTagSpecificationsTypeDef = TypedDict(
    "_ClientCopySnapshotTagSpecificationsTypeDef",
    {"ResourceType": str, "Tags": List[ClientCopySnapshotTagSpecificationsTagsTypeDef]},
    total=False,
)


class ClientCopySnapshotTagSpecificationsTypeDef(
    _ClientCopySnapshotTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCopySnapshot` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef(
    _ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef
):
    """
    Type definition for `ClientCreateCapacityReservationResponseCapacityReservation` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateCapacityReservationResponseCapacityReservationTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseCapacityReservationTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": str,
        "AvailabilityZone": str,
        "Tenancy": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": str,
        "EndDate": datetime,
        "EndDateType": str,
        "InstanceMatchCriteria": str,
        "CreateDate": datetime,
        "Tags": List[
            ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateCapacityReservationResponseCapacityReservationTypeDef(
    _ClientCreateCapacityReservationResponseCapacityReservationTypeDef
):
    """
    Type definition for `ClientCreateCapacityReservationResponse` `CapacityReservation`

    Information about the Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the Capacity Reservation.

    - **CapacityReservationArn** *(string) --*

      The Amazon Resource Name (ARN) of the Capacity Reservation.

    - **AvailabilityZoneId** *(string) --*

      The Availability Zone ID of the Capacity Reservation.

    - **InstanceType** *(string) --*

      The type of instance for which the Capacity Reservation reserves capacity.

    - **InstancePlatform** *(string) --*

      The type of operating system for which the Capacity Reservation reserves capacity.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the capacity is reserved.

    - **Tenancy** *(string) --*

      Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
      the following tenancy settings:

      * ``default`` - The Capacity Reservation is created on hardware that is shared with other
      AWS accounts.

      * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
      dedicated to a single AWS account.

    - **TotalInstanceCount** *(integer) --*

      The total number of instances for which the Capacity Reservation reserves capacity.

    - **AvailableInstanceCount** *(integer) --*

      The remaining capacity. Indicates the number of instances that can be launched in the
      Capacity Reservation.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the Capacity Reservation supports EBS-optimized instances. This
      optimization provides dedicated throughput to Amazon EBS and an optimized configuration
      stack to provide optimal I/O performance. This optimization isn't available with all
      instance types. Additional usage charges apply when using an EBS- optimized instance.

    - **EphemeralStorage** *(boolean) --*

      Indicates whether the Capacity Reservation supports instances with temporary, block-level
      storage.

    - **State** *(string) --*

      The current state of the Capacity Reservation. A Capacity Reservation can be in one of the
      following states:

      * ``active`` - The Capacity Reservation is active and the capacity is available for your
      use.

      * ``expired`` - The Capacity Reservation expired automatically at the date and time
      specified in your request. The reserved capacity is no longer available for your use.

      * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity is
      no longer available for your use.

      * ``pending`` - The Capacity Reservation request was successful but the capacity
      provisioning is still pending.

      * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
      invalid request parameters, capacity constraints, or instance limit constraints. Failed
      requests are retained for 60 minutes.

    - **EndDate** *(datetime) --*

      The date and time at which the Capacity Reservation expires. When a Capacity Reservation
      expires, the reserved capacity is released and you can no longer launch instances into it.
      The Capacity Reservation's state changes to ``expired`` when it reaches its end date and
      time.

    - **EndDateType** *(string) --*

      Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
      one of the following end types:

      * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

      * ``limited`` - The Capacity Reservation expires automatically at a specified date and time.

    - **InstanceMatchCriteria** *(string) --*

      Indicates the type of instance launches that the Capacity Reservation accepts. The options
      include:

      * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
      (instance type, platform, and Availability Zone). Instances that have matching attributes
      launch into the Capacity Reservation automatically without specifying any additional
      parameters.

      * ``targeted`` - The Capacity Reservation only accepts instances that have matching
      attributes (instance type, platform, and Availability Zone), and explicitly target the
      Capacity Reservation. This ensures that only permitted instances can use the reserved
      capacity.

    - **CreateDate** *(datetime) --*

      The date and time at which the Capacity Reservation was created.

    - **Tags** *(list) --*

      Any tags assigned to the Capacity Reservation.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateCapacityReservationResponseTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseTypeDef",
    {
        "CapacityReservation": ClientCreateCapacityReservationResponseCapacityReservationTypeDef
    },
    total=False,
)


class ClientCreateCapacityReservationResponseTypeDef(
    _ClientCreateCapacityReservationResponseTypeDef
):
    """
    Type definition for `ClientCreateCapacityReservation` `Response`

    - **CapacityReservation** *(dict) --*

      Information about the Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the Capacity Reservation.

      - **CapacityReservationArn** *(string) --*

        The Amazon Resource Name (ARN) of the Capacity Reservation.

      - **AvailabilityZoneId** *(string) --*

        The Availability Zone ID of the Capacity Reservation.

      - **InstanceType** *(string) --*

        The type of instance for which the Capacity Reservation reserves capacity.

      - **InstancePlatform** *(string) --*

        The type of operating system for which the Capacity Reservation reserves capacity.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which the capacity is reserved.

      - **Tenancy** *(string) --*

        Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
        the following tenancy settings:

        * ``default`` - The Capacity Reservation is created on hardware that is shared with other
        AWS accounts.

        * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
        dedicated to a single AWS account.

      - **TotalInstanceCount** *(integer) --*

        The total number of instances for which the Capacity Reservation reserves capacity.

      - **AvailableInstanceCount** *(integer) --*

        The remaining capacity. Indicates the number of instances that can be launched in the
        Capacity Reservation.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the Capacity Reservation supports EBS-optimized instances. This
        optimization provides dedicated throughput to Amazon EBS and an optimized configuration
        stack to provide optimal I/O performance. This optimization isn't available with all
        instance types. Additional usage charges apply when using an EBS- optimized instance.

      - **EphemeralStorage** *(boolean) --*

        Indicates whether the Capacity Reservation supports instances with temporary, block-level
        storage.

      - **State** *(string) --*

        The current state of the Capacity Reservation. A Capacity Reservation can be in one of the
        following states:

        * ``active`` - The Capacity Reservation is active and the capacity is available for your
        use.

        * ``expired`` - The Capacity Reservation expired automatically at the date and time
        specified in your request. The reserved capacity is no longer available for your use.

        * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity is
        no longer available for your use.

        * ``pending`` - The Capacity Reservation request was successful but the capacity
        provisioning is still pending.

        * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
        invalid request parameters, capacity constraints, or instance limit constraints. Failed
        requests are retained for 60 minutes.

      - **EndDate** *(datetime) --*

        The date and time at which the Capacity Reservation expires. When a Capacity Reservation
        expires, the reserved capacity is released and you can no longer launch instances into it.
        The Capacity Reservation's state changes to ``expired`` when it reaches its end date and
        time.

      - **EndDateType** *(string) --*

        Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
        one of the following end types:

        * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

        * ``limited`` - The Capacity Reservation expires automatically at a specified date and time.

      - **InstanceMatchCriteria** *(string) --*

        Indicates the type of instance launches that the Capacity Reservation accepts. The options
        include:

        * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
        (instance type, platform, and Availability Zone). Instances that have matching attributes
        launch into the Capacity Reservation automatically without specifying any additional
        parameters.

        * ``targeted`` - The Capacity Reservation only accepts instances that have matching
        attributes (instance type, platform, and Availability Zone), and explicitly target the
        Capacity Reservation. This ensures that only permitted instances can use the reserved
        capacity.

      - **CreateDate** *(datetime) --*

        The date and time at which the Capacity Reservation was created.

      - **Tags** *(list) --*

        Any tags assigned to the Capacity Reservation.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateCapacityReservationTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCapacityReservationTagSpecificationsTagsTypeDef(
    _ClientCreateCapacityReservationTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateCapacityReservationTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateCapacityReservationTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateCapacityReservationTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateCapacityReservationTagSpecificationsTypeDef(
    _ClientCreateCapacityReservationTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateCapacityReservation` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpointAuthenticationOptions` `ActiveDirectory`

    Information about the Active Directory to be used, if applicable. You must provide this
    information if **Type** is ``directory-service-authentication`` .

    - **DirectoryId** *(string) --*

      The ID of the Active Directory to be used for authentication.
    """


_ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChainArn": str},
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpointAuthenticationOptions` `MutualAuthentication`

    Information about the authentication certificates to be used, if applicable. You must provide
    this information if **Type** is ``certificate-authentication`` .

    - **ClientRootCertificateChainArn** *(string) --*

      The ARN of the client certificate. The certificate must be signed by a certificate
      authority (CA) and it must be provisioned in AWS Certificate Manager (ACM).
    """


_ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef",
    {
        "Type": str,
        "ActiveDirectory": ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpoint` `AuthenticationOptions`

    Describes the authentication method to be used by a Client VPN endpoint. Client VPN supports
    Active Directory and mutual authentication. For more information, see `Authentication
    <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
    in the *AWS Client VPN Administrator Guide* .

    - **Type** *(string) --*

      The type of client authentication to be used. Specify ``certificate-authentication`` to use
      certificate-based authentication, or ``directory-service-authentication`` to use Active
      Directory authentication.

    - **ActiveDirectory** *(dict) --*

      Information about the Active Directory to be used, if applicable. You must provide this
      information if **Type** is ``directory-service-authentication`` .

      - **DirectoryId** *(string) --*

        The ID of the Active Directory to be used for authentication.

    - **MutualAuthentication** *(dict) --*

      Information about the authentication certificates to be used, if applicable. You must provide
      this information if **Type** is ``certificate-authentication`` .

      - **ClientRootCertificateChainArn** *(string) --*

        The ARN of the client certificate. The certificate must be signed by a certificate
        authority (CA) and it must be provisioned in AWS Certificate Manager (ACM).
    """


_ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef(
    _ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpoint` `ConnectionLogOptions`

    Information about the client connection logging options.

    If you enable client connection logging, data about client connections is sent to a Cloudwatch
    Logs log stream. The following information is logged:

    * Client connection requests

    * Client connection results (successful and unsuccessful)

    * Reasons for unsuccessful client connection requests

    * Client connection termination time

    - **Enabled** *(boolean) --*

      Indicates whether connection logging is enabled.

    - **CloudwatchLogGroup** *(string) --*

      The name of the CloudWatch Logs log group.

    - **CloudwatchLogStream** *(string) --*

      The name of the CloudWatch Logs log stream to which the connection data is published.
    """


_ClientCreateClientVpnEndpointResponseStatusTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateClientVpnEndpointResponseStatusTypeDef(
    _ClientCreateClientVpnEndpointResponseStatusTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpointResponse` `Status`

    The current state of the Client VPN endpoint.

    - **Code** *(string) --*

      The state of the Client VPN endpoint. Possible states include:

      * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
      have been associated. The Client VPN endpoint cannot accept connections.

      * ``available`` - The Client VPN endpoint has been created and a target network has been
      associated. The Client VPN endpoint can accept connections.

      * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
      accept connections.

      * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
      accept connections.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint.
    """


_ClientCreateClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointResponseTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Status": ClientCreateClientVpnEndpointResponseStatusTypeDef,
        "DnsName": str,
    },
    total=False,
)


class ClientCreateClientVpnEndpointResponseTypeDef(
    _ClientCreateClientVpnEndpointResponseTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpoint` `Response`

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint.

    - **Status** *(dict) --*

      The current state of the Client VPN endpoint.

      - **Code** *(string) --*

        The state of the Client VPN endpoint. Possible states include:

        * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
        have been associated. The Client VPN endpoint cannot accept connections.

        * ``available`` - The Client VPN endpoint has been created and a target network has been
        associated. The Client VPN endpoint can accept connections.

        * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
        accept connections.

        * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
        accept connections.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint.

    - **DnsName** *(string) --*

      The DNS name to be used by clients when establishing their VPN session.
    """


_ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef(
    _ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpointTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateClientVpnEndpointTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateClientVpnEndpointTagSpecificationsTypeDef(
    _ClientCreateClientVpnEndpointTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateClientVpnEndpoint` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateClientVpnRouteResponseStatusTypeDef = TypedDict(
    "_ClientCreateClientVpnRouteResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateClientVpnRouteResponseStatusTypeDef(
    _ClientCreateClientVpnRouteResponseStatusTypeDef
):
    """
    Type definition for `ClientCreateClientVpnRouteResponse` `Status`

    The current state of the route.

    - **Code** *(string) --*

      The state of the Client VPN endpoint route.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint route, if applicable.
    """


_ClientCreateClientVpnRouteResponseTypeDef = TypedDict(
    "_ClientCreateClientVpnRouteResponseTypeDef",
    {"Status": ClientCreateClientVpnRouteResponseStatusTypeDef},
    total=False,
)


class ClientCreateClientVpnRouteResponseTypeDef(
    _ClientCreateClientVpnRouteResponseTypeDef
):
    """
    Type definition for `ClientCreateClientVpnRoute` `Response`

    - **Status** *(dict) --*

      The current state of the route.

      - **Code** *(string) --*

        The state of the Client VPN endpoint route.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint route, if applicable.
    """


_ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef(
    _ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef
):
    """
    Type definition for `ClientCreateCustomerGatewayResponseCustomerGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef",
    {
        "BgpAsn": str,
        "CustomerGatewayId": str,
        "IpAddress": str,
        "CertificateArn": str,
        "State": str,
        "Type": str,
        "Tags": List[ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef(
    _ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef
):
    """
    Type definition for `ClientCreateCustomerGatewayResponse` `CustomerGateway`

    Information about the customer gateway.

    - **BgpAsn** *(string) --*

      The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway.

    - **IpAddress** *(string) --*

      The Internet-routable IP address of the customer gateway's outside interface.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) for the customer gateway certificate.

    - **State** *(string) --*

      The current state of the customer gateway (``pending | available | deleting | deleted`` ).

    - **Type** *(string) --*

      The type of VPN connection the customer gateway supports (``ipsec.1`` ).

    - **Tags** *(list) --*

      Any tags assigned to the customer gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateCustomerGatewayResponseTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseTypeDef",
    {"CustomerGateway": ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef},
    total=False,
)


class ClientCreateCustomerGatewayResponseTypeDef(
    _ClientCreateCustomerGatewayResponseTypeDef
):
    """
    Type definition for `ClientCreateCustomerGateway` `Response`

    Contains the output of CreateCustomerGateway.

    - **CustomerGateway** *(dict) --*

      Information about the customer gateway.

      - **BgpAsn** *(string) --*

        The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).

      - **CustomerGatewayId** *(string) --*

        The ID of the customer gateway.

      - **IpAddress** *(string) --*

        The Internet-routable IP address of the customer gateway's outside interface.

      - **CertificateArn** *(string) --*

        The Amazon Resource Name (ARN) for the customer gateway certificate.

      - **State** *(string) --*

        The current state of the customer gateway (``pending | available | deleting | deleted`` ).

      - **Type** *(string) --*

        The type of VPN connection the customer gateway supports (``ipsec.1`` ).

      - **Tags** *(list) --*

        Any tags assigned to the customer gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateDefaultSubnetResponseSubnet` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a subnet.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultSubnetResponseSubnetTagsTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetTagsTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetTagsTypeDef
):
    """
    Type definition for `ClientCreateDefaultSubnetResponseSubnet` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateDefaultSubnetResponseSubnetTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientCreateDefaultSubnetResponseSubnetTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetTypeDef
):
    """
    Type definition for `ClientCreateDefaultSubnetResponse` `Subnet`

    Information about the subnet.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the subnet.

    - **AvailabilityZoneId** *(string) --*

      The AZ ID of the subnet.

    - **AvailableIpAddressCount** *(integer) --*

      The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
      stopped instances are considered unavailable.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block assigned to the subnet.

    - **DefaultForAz** *(boolean) --*

      Indicates whether this is the default subnet for the Availability Zone.

    - **MapPublicIpOnLaunch** *(boolean) --*

      Indicates whether instances launched in this subnet receive a public IPv4 address.

    - **State** *(string) --*

      The current state of the subnet.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC the subnet is in.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the subnet.

    - **AssignIpv6AddressOnCreation** *(boolean) --*

      Indicates whether a network interface created in this subnet (including a network interface
      created by  RunInstances ) receives an IPv6 address.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the subnet.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a subnet.

        - **AssociationId** *(string) --*

          The association ID for the CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of a CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the subnet.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **SubnetArn** *(string) --*

      The Amazon Resource Name (ARN) of the subnet.
    """


_ClientCreateDefaultSubnetResponseTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseTypeDef",
    {"Subnet": ClientCreateDefaultSubnetResponseSubnetTypeDef},
    total=False,
)


class ClientCreateDefaultSubnetResponseTypeDef(
    _ClientCreateDefaultSubnetResponseTypeDef
):
    """
    Type definition for `ClientCreateDefaultSubnet` `Response`

    - **Subnet** *(dict) --*

      Information about the subnet.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.

      - **AvailabilityZoneId** *(string) --*

        The AZ ID of the subnet.

      - **AvailableIpAddressCount** *(integer) --*

        The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
        stopped instances are considered unavailable.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block assigned to the subnet.

      - **DefaultForAz** *(boolean) --*

        Indicates whether this is the default subnet for the Availability Zone.

      - **MapPublicIpOnLaunch** *(boolean) --*

        Indicates whether instances launched in this subnet receive a public IPv4 address.

      - **State** *(string) --*

        The current state of the subnet.

      - **SubnetId** *(string) --*

        The ID of the subnet.

      - **VpcId** *(string) --*

        The ID of the VPC the subnet is in.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the subnet.

      - **AssignIpv6AddressOnCreation** *(boolean) --*

        Indicates whether a network interface created in this subnet (including a network interface
        created by  RunInstances ) receives an IPv6 address.

      - **Ipv6CidrBlockAssociationSet** *(list) --*

        Information about the IPv6 CIDR blocks associated with the subnet.

        - *(dict) --*

          Describes an IPv6 CIDR block associated with a subnet.

          - **AssociationId** *(string) --*

            The association ID for the CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

          - **Ipv6CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of a CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **Tags** *(list) --*

        Any tags assigned to the subnet.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **SubnetArn** *(string) --*

        The Amazon Resource Name (ARN) of the subnet.
    """


_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSet` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponseVpc` `CidrBlockAssociationSet`

    Describes an IPv4 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponseVpc` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateDefaultVpcResponseVpcTagsTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateDefaultVpcResponseVpcTagsTypeDef(
    _ClientCreateDefaultVpcResponseVpcTagsTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponseVpc` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateDefaultVpcResponseVpcTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": str,
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": str,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[ClientCreateDefaultVpcResponseVpcTagsTypeDef],
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcTypeDef(
    _ClientCreateDefaultVpcResponseVpcTypeDef
):
    """
    Type definition for `ClientCreateDefaultVpcResponse` `Vpc`

    Information about the VPC.

    - **CidrBlock** *(string) --*

      The primary IPv4 CIDR block for the VPC.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
      default options are associated with the VPC).

    - **State** *(string) --*

      The current state of the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **InstanceTenancy** *(string) --*

      The allowed tenancy of instances launched into the VPC.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociationSet** *(list) --*

      Information about the IPv4 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

        - **CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **IsDefault** *(boolean) --*

      Indicates whether the VPC is the default VPC.

    - **Tags** *(list) --*

      Any tags assigned to the VPC.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateDefaultVpcResponseTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseTypeDef",
    {"Vpc": ClientCreateDefaultVpcResponseVpcTypeDef},
    total=False,
)


class ClientCreateDefaultVpcResponseTypeDef(_ClientCreateDefaultVpcResponseTypeDef):
    """
    Type definition for `ClientCreateDefaultVpc` `Response`

    - **Vpc** *(dict) --*

      Information about the VPC.

      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.

      - **DhcpOptionsId** *(string) --*

        The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
        default options are associated with the VPC).

      - **State** *(string) --*

        The current state of the VPC.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **InstanceTenancy** *(string) --*

        The allowed tenancy of instances launched into the VPC.

      - **Ipv6CidrBlockAssociationSet** *(list) --*

        Information about the IPv6 CIDR blocks associated with the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block associated with a VPC.

          - **AssociationId** *(string) --*

            The association ID for the IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

          - **Ipv6CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of the CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **CidrBlockAssociationSet** *(list) --*

        Information about the IPv4 CIDR blocks associated with the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block associated with a VPC.

          - **AssociationId** *(string) --*

            The association ID for the IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

          - **CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of the CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **IsDefault** *(boolean) --*

        Indicates whether the VPC is the default VPC.

      - **Tags** *(list) --*

        Any tags assigned to the VPC.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsDhcpConfigurationsTypeDef",
    {"Key": str, "Values": List[str]},
    total=False,
)


class ClientCreateDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientCreateDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    Type definition for `ClientCreateDhcpOptions` `DhcpConfigurations`

    - **Key** *(string) --*

    - **Values** *(list) --*

      - *(string) --*
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    """
    Type definition for `ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurations` `Values`

    Describes a value for a resource attribute that is a String.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[
            ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
        ],
    },
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    Type definition for `ClientCreateDhcpOptionsResponseDhcpOptions` `DhcpConfigurations`

    Describes a DHCP configuration option.

    - **Key** *(string) --*

      The name of a DHCP option.

    - **Values** *(list) --*

      One or more values for the DHCP option.

      - *(dict) --*

        Describes a value for a resource attribute that is a String.

        - **Value** *(string) --*

          The attribute value. The value is case-sensitive.
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef
):
    """
    Type definition for `ClientCreateDhcpOptionsResponseDhcpOptions` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef
):
    """
    Type definition for `ClientCreateDhcpOptionsResponse` `DhcpOptions`

    A set of DHCP options.

    - **DhcpConfigurations** *(list) --*

      One or more DHCP options in the set.

      - *(dict) --*

        Describes a DHCP configuration option.

        - **Key** *(string) --*

          The name of a DHCP option.

        - **Values** *(list) --*

          One or more values for the DHCP option.

          - *(dict) --*

            Describes a value for a resource attribute that is a String.

            - **Value** *(string) --*

              The attribute value. The value is case-sensitive.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the DHCP options set.

    - **Tags** *(list) --*

      Any tags assigned to the DHCP options set.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateDhcpOptionsResponseTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseTypeDef",
    {"DhcpOptions": ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef},
    total=False,
)


class ClientCreateDhcpOptionsResponseTypeDef(_ClientCreateDhcpOptionsResponseTypeDef):
    """
    Type definition for `ClientCreateDhcpOptions` `Response`

    - **DhcpOptions** *(dict) --*

      A set of DHCP options.

      - **DhcpConfigurations** *(list) --*

        One or more DHCP options in the set.

        - *(dict) --*

          Describes a DHCP configuration option.

          - **Key** *(string) --*

            The name of a DHCP option.

          - **Values** *(list) --*

            One or more values for the DHCP option.

            - *(dict) --*

              Describes a value for a resource attribute that is a String.

              - **Value** *(string) --*

                The attribute value. The value is case-sensitive.

      - **DhcpOptionsId** *(string) --*

        The ID of the set of DHCP options.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the DHCP options set.

      - **Tags** *(list) --*

        Any tags assigned to the DHCP options set.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGateway` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef",
    {
        "Attachments": List[
            ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef
):
    """
    Type definition for `ClientCreateEgressOnlyInternetGatewayResponse` `EgressOnlyInternetGateway`

    Information about the egress-only internet gateway.

    - **Attachments** *(list) --*

      Information about the attachment of the egress-only internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.
    """


_ClientCreateEgressOnlyInternetGatewayResponseTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseTypeDef",
    {
        "ClientToken": str,
        "EgressOnlyInternetGateway": ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef,
    },
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseTypeDef
):
    """
    Type definition for `ClientCreateEgressOnlyInternetGateway` `Response`

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.

    - **EgressOnlyInternetGateway** *(dict) --*

      Information about the egress-only internet gateway.

      - **Attachments** *(list) --*

        Information about the attachment of the egress-only internet gateway.

        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.

          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is
            ``available`` when attached to a VPC; otherwise, this value is not returned.

          - **VpcId** *(string) --*

            The ID of the VPC.

      - **EgressOnlyInternetGatewayId** *(string) --*

        The ID of the egress-only internet gateway.
    """


_ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientCreateFleetLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template to use. You must specify either the launch template ID or launch template
    name in the request.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **Version** *(string) --*

      The version number of the launch template. Note: This is a required parameter and will be
      updated soon.
    """


_ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef
):
    """
    Type definition for `ClientCreateFleetLaunchTemplateConfigsOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on
      the load balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not
      supported for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group
      strategy is set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not
      supported for the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for the  ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `ClientCreateFleetLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set to
      ``prioritized`` , EC2 Fleet uses priority to determine which launch template override to
      use first in fulfilling On-Demand capacity. The highest priority is launched first. Valid
      values are whole numbers starting at ``0`` . The lower the number, the higher the
      priority. If no number is set, the launch template override has the lowest priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

        If not specified, an Availability Zone will be automatically chosen for you based on
        the load balancing criteria for the Region.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host. This parameter is not
        supported for the  ImportInstance command.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.

      - **PartitionNumber** *(integer) --*

        The number of the partition the instance is in. Valid only if the placement group
        strategy is set to ``partition`` .

      - **HostId** *(string) --*

        The ID of the Dedicated Host on which the instance resides. This parameter is not
        supported for the  ImportInstance command.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for the  ImportInstance command.

      - **SpreadDomain** *(string) --*

        Reserved for future use.
    """


_ClientCreateFleetLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef],
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `ClientCreateFleet` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template to use. You must specify either the launch template ID or launch template
      name in the request.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template.

      - **Version** *(string) --*

        The version number of the launch template. Note: This is a required parameter and will be
        updated soon.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set to
          ``prioritized`` , EC2 Fleet uses priority to determine which launch template override to
          use first in fulfilling On-Demand capacity. The highest priority is launched first. Valid
          values are whole numbers starting at ``0`` . The lower the number, the higher the
          priority. If no number is set, the launch template override has the lowest priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.

            If not specified, an Availability Zone will be automatically chosen for you based on
            the load balancing criteria for the Region.

          - **Affinity** *(string) --*

            The affinity setting for the instance on the Dedicated Host. This parameter is not
            supported for the  ImportInstance command.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

          - **PartitionNumber** *(integer) --*

            The number of the partition the instance is in. Valid only if the placement group
            strategy is set to ``partition`` .

          - **HostId** *(string) --*

            The ID of the Dedicated Host on which the instance resides. This parameter is not
            supported for the  ImportInstance command.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with a
            tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
            supported for the  ImportInstance command.

          - **SpreadDomain** *(string) --*

            Reserved for future use.
    """


_ClientCreateFleetOnDemandOptionsTypeDef = TypedDict(
    "_ClientCreateFleetOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientCreateFleetOnDemandOptionsTypeDef(_ClientCreateFleetOnDemandOptionsTypeDef):
    """
    Type definition for `ClientCreateFleet` `OnDemandOptions`

    Describes the configuration of On-Demand Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If you
      specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching the lowest
      price first. If you specify ``prioritized`` , EC2 Fleet uses the priority that you assigned to
      each launch template override, launching the highest priority first. If you do not specify a
      value, EC2 Fleet defaults to ``lowest-price`` .

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all On-Demand Instances in the
      fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all On-Demand Instances into a single Availability Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
      capacity is not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay.
    """


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseErrorsLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a template
      name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseErrorsLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set to
      ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
      to use first in fulfilling On-Demand capacity. The highest priority is launched
      first. Valid values are whole numbers starting at ``0`` . The lower the number, the
      higher the priority. If no number is set, the override has the lowest priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseErrors` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the launch
    template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a template
        name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set to
        ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
        to use first in fulfilling On-Demand capacity. The highest priority is launched
        first. Valid values are whole numbers starting at ``0`` . The lower the number, the
        higher the priority. If no number is set, the override has the lowest priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseErrorsTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsTypeDef(_ClientCreateFleetResponseErrorsTypeDef):
    """
    Type definition for `ClientCreateFleetResponse` `Errors`

    Describes the instances that could not be launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the launch
      template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a template
          name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set to
          ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
          to use first in fulfilling On-Demand capacity. The highest priority is launched
          first. Valid values are whole numbers starting at ``0`` . The lower the number, the
          higher the priority. If no number is set, the override has the lowest priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that could not be launched was a Spot Instance or On-Demand
      Instance.

    - **ErrorCode** *(string) --*

      The error code that indicates why the instance could not be launched. For more
      information about error codes, see `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__ .

    - **ErrorMessage** *(string) --*

      The error message that describes why the instance could not be launched. For more
      information about error messages, see ee `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__ .
    """


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseInstancesLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a template
      name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseInstancesLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set to
      ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
      to use first in fulfilling On-Demand capacity. The highest priority is launched
      first. Valid values are whole numbers starting at ``0`` . The lower the number, the
      higher the priority. If no number is set, the override has the lowest priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `ClientCreateFleetResponseInstances` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the launch
    template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a template
        name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set to
        ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
        to use first in fulfilling On-Demand capacity. The highest priority is launched
        first. Valid values are whole numbers starting at ``0`` . The lower the number, the
        higher the priority. If no number is set, the override has the lowest priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_ClientCreateFleetResponseInstancesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "InstanceIds": List[str],
        "InstanceType": str,
        "Platform": str,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesTypeDef(
    _ClientCreateFleetResponseInstancesTypeDef
):
    """
    Type definition for `ClientCreateFleetResponse` `Instances`

    Describes the instances that were launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the launch
      template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a template
          name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set to
          ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
          to use first in fulfilling On-Demand capacity. The highest priority is launched
          first. Valid values are whole numbers starting at ``0`` . The lower the number, the
          higher the priority. If no number is set, the override has the lowest priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

    - **InstanceIds** *(list) --*

      The IDs of the instances.

      - *(string) --*

    - **InstanceType** *(string) --*

      The instance type.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.
    """


_ClientCreateFleetResponseTypeDef = TypedDict(
    "_ClientCreateFleetResponseTypeDef",
    {
        "FleetId": str,
        "Errors": List[ClientCreateFleetResponseErrorsTypeDef],
        "Instances": List[ClientCreateFleetResponseInstancesTypeDef],
    },
    total=False,
)


class ClientCreateFleetResponseTypeDef(_ClientCreateFleetResponseTypeDef):
    """
    Type definition for `ClientCreateFleet` `Response`

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.

    - **Errors** *(list) --*

      Information about the instances that could not be launched by the fleet. Valid only when
      **Type** is set to ``instant`` .

      - *(dict) --*

        Describes the instances that could not be launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the launch
          template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a template
              name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set to
              ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
              to use first in fulfilling On-Demand capacity. The highest priority is launched
              first. Valid values are whole numbers starting at ``0`` . The lower the number, the
              higher the priority. If no number is set, the override has the lowest priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that could not be launched was a Spot Instance or On-Demand
          Instance.

        - **ErrorCode** *(string) --*

          The error code that indicates why the instance could not be launched. For more
          information about error codes, see `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__ .

        - **ErrorMessage** *(string) --*

          The error message that describes why the instance could not be launched. For more
          information about error messages, see ee `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__ .

    - **Instances** *(list) --*

      Information about the instances that were launched by the fleet. Valid only when **Type** is
      set to ``instant`` .

      - *(dict) --*

        Describes the instances that were launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the launch
          template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a template
              name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set to
              ``prioritized`` , EC2 Fleet uses priority to determine which launch template override
              to use first in fulfilling On-Demand capacity. The highest priority is launched
              first. Valid values are whole numbers starting at ``0`` . The lower the number, the
              higher the priority. If no number is set, the override has the lowest priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

        - **InstanceIds** *(list) --*

          The IDs of the instances.

          - *(string) --*

        - **InstanceType** *(string) --*

          The instance type.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.
    """


_ClientCreateFleetSpotOptionsTypeDef = TypedDict(
    "_ClientCreateFleetSpotOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "InstanceInterruptionBehavior": str,
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientCreateFleetSpotOptionsTypeDef(_ClientCreateFleetSpotOptionsTypeDef):
    """
    Type definition for `ClientCreateFleet` `SpotOptions`

    Describes the configuration of Spot Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance pools
      specified by the EC2 Fleet.

      If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the Spot
      Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all the Spot
      Instance pools that you specify.

      If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances from Spot
      Instance pools with optimal capacity for the number of instances that are launching.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only when
      Spot **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest Spot
      pools and evenly allocates your target Spot capacity across the number of Spot pools that you
      specify.

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all Spot Instances in the fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all Spot Instances into a single Availability Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for Spot Instances in the fleet. If the minimum target capacity is
      not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay.
    """


_ClientCreateFleetTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateFleetTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateFleetTagSpecificationsTagsTypeDef(
    _ClientCreateFleetTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateFleetTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateFleetTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateFleetTagSpecificationsTypeDef",
    {"ResourceType": str, "Tags": List[ClientCreateFleetTagSpecificationsTagsTypeDef]},
    total=False,
)


class ClientCreateFleetTagSpecificationsTypeDef(
    _ClientCreateFleetTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateFleet` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_RequiredClientCreateFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_RequiredClientCreateFleetTargetCapacitySpecificationTypeDef",
    {"TotalTargetCapacity": int},
)
_OptionalClientCreateFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_OptionalClientCreateFleetTargetCapacitySpecificationTypeDef",
    {
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": str,
    },
    total=False,
)


class ClientCreateFleetTargetCapacitySpecificationTypeDef(
    _RequiredClientCreateFleetTargetCapacitySpecificationTypeDef,
    _OptionalClientCreateFleetTargetCapacitySpecificationTypeDef,
):
    """
    Type definition for `ClientCreateFleet` `TargetCapacitySpecification`

    The number of units to request.

    - **TotalTargetCapacity** *(integer) --* **[REQUIRED]**

      The number of units to request, filled using ``DefaultTargetCapacityType`` .

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request.

    - **SpotTargetCapacity** *(integer) --*

      The number of Spot units to request.

    - **DefaultTargetCapacityType** *(string) --*

      The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .
    """


_ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef(
    _ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientCreateFlowLogsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientCreateFlowLogsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseUnsuccessfulTypeDef",
    {"Error": ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientCreateFlowLogsResponseUnsuccessfulTypeDef(
    _ClientCreateFlowLogsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientCreateFlowLogsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientCreateFlowLogsResponseTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseTypeDef",
    {
        "ClientToken": str,
        "FlowLogIds": List[str],
        "Unsuccessful": List[ClientCreateFlowLogsResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientCreateFlowLogsResponseTypeDef(_ClientCreateFlowLogsResponseTypeDef):
    """
    Type definition for `ClientCreateFlowLogs` `Response`

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.

    - **FlowLogIds** *(list) --*

      The IDs of the flow logs.

      - *(string) --*

    - **Unsuccessful** *(list) --*

      Information about the flow logs that could not be created successfully.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientCreateFpgaImageInputStorageLocationTypeDef = TypedDict(
    "_ClientCreateFpgaImageInputStorageLocationTypeDef",
    {"Bucket": str, "Key": str},
    total=False,
)


class ClientCreateFpgaImageInputStorageLocationTypeDef(
    _ClientCreateFpgaImageInputStorageLocationTypeDef
):
    """
    Type definition for `ClientCreateFpgaImage` `InputStorageLocation`

    The location of the encrypted design checkpoint in Amazon S3. The input must be a tarball.

    - **Bucket** *(string) --*

      The name of the S3 bucket.

    - **Key** *(string) --*

      The key.
    """


_ClientCreateFpgaImageLogsStorageLocationTypeDef = TypedDict(
    "_ClientCreateFpgaImageLogsStorageLocationTypeDef",
    {"Bucket": str, "Key": str},
    total=False,
)


class ClientCreateFpgaImageLogsStorageLocationTypeDef(
    _ClientCreateFpgaImageLogsStorageLocationTypeDef
):
    """
    Type definition for `ClientCreateFpgaImage` `LogsStorageLocation`

    The location in Amazon S3 for the output logs.

    - **Bucket** *(string) --*

      The name of the S3 bucket.

    - **Key** *(string) --*

      The key.
    """


_ClientCreateFpgaImageResponseTypeDef = TypedDict(
    "_ClientCreateFpgaImageResponseTypeDef",
    {"FpgaImageId": str, "FpgaImageGlobalId": str},
    total=False,
)


class ClientCreateFpgaImageResponseTypeDef(_ClientCreateFpgaImageResponseTypeDef):
    """
    Type definition for `ClientCreateFpgaImage` `Response`

    - **FpgaImageId** *(string) --*

      The FPGA image identifier (AFI ID).

    - **FpgaImageGlobalId** *(string) --*

      The global FPGA image identifier (AGFI ID).
    """


_ClientCreateFpgaImageTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateFpgaImageTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateFpgaImageTagSpecificationsTagsTypeDef(
    _ClientCreateFpgaImageTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateFpgaImageTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateFpgaImageTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateFpgaImageTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateFpgaImageTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateFpgaImageTagSpecificationsTypeDef(
    _ClientCreateFpgaImageTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateFpgaImage` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientCreateImageBlockDeviceMappingsEbsTypeDef(
    _ClientCreateImageBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientCreateImageBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_ClientCreateImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateImageBlockDeviceMappingsTypeDef(
    _ClientCreateImageBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientCreateImage` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientCreateImageResponseTypeDef = TypedDict(
    "_ClientCreateImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientCreateImageResponseTypeDef(_ClientCreateImageResponseTypeDef):
    """
    Type definition for `ClientCreateImage` `Response`

    - **ImageId** *(string) --*

      The ID of the new AMI.
    """


_ClientCreateInstanceExportTaskExportToS3TaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskExportToS3TaskTypeDef",
    {"ContainerFormat": str, "DiskImageFormat": str, "S3Bucket": str, "S3Prefix": str},
    total=False,
)


class ClientCreateInstanceExportTaskExportToS3TaskTypeDef(
    _ClientCreateInstanceExportTaskExportToS3TaskTypeDef
):
    """
    Type definition for `ClientCreateInstanceExportTask` `ExportToS3Task`

    The format and location for an instance export task.

    - **ContainerFormat** *(string) --*

      The container format used to combine disk images with metadata (such as OVF). If absent, only
      the disk image is exported.

    - **DiskImageFormat** *(string) --*

      The format for the exported image.

    - **S3Bucket** *(string) --*

      The S3 bucket for the destination image. The destination bucket must exist and grant WRITE and
      READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

    - **S3Prefix** *(string) --*

      The image is written to a single object in the S3 bucket at the S3 key s3prefix + exportTaskId
      + '.' + diskImageFormat.
    """


_ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef",
    {"ContainerFormat": str, "DiskImageFormat": str, "S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef
):
    """
    Type definition for `ClientCreateInstanceExportTaskResponseExportTask` `ExportToS3Task`

    Information about the export task.

    - **ContainerFormat** *(string) --*

      The container format used to combine disk images with metadata (such as OVF). If absent,
      only the disk image is exported.

    - **DiskImageFormat** *(string) --*

      The format for the exported image.

    - **S3Bucket** *(string) --*

      The S3 bucket for the destination image. The destination bucket must exist and grant
      WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

    - **S3Key** *(string) --*

      The encryption key for your S3 bucket.
    """


_ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef",
    {"InstanceId": str, "TargetEnvironment": str},
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef
):
    """
    Type definition for `ClientCreateInstanceExportTaskResponseExportTask` `InstanceExportDetails`

    Information about the instance to export.

    - **InstanceId** *(string) --*

      The ID of the resource being exported.

    - **TargetEnvironment** *(string) --*

      The target virtualization environment.
    """


_ClientCreateInstanceExportTaskResponseExportTaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskTypeDef",
    {
        "Description": str,
        "ExportTaskId": str,
        "ExportToS3Task": ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef,
        "InstanceExportDetails": ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef,
        "State": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskTypeDef
):
    """
    Type definition for `ClientCreateInstanceExportTaskResponse` `ExportTask`

    Information about the instance export task.

    - **Description** *(string) --*

      A description of the resource being exported.

    - **ExportTaskId** *(string) --*

      The ID of the export task.

    - **ExportToS3Task** *(dict) --*

      Information about the export task.

      - **ContainerFormat** *(string) --*

        The container format used to combine disk images with metadata (such as OVF). If absent,
        only the disk image is exported.

      - **DiskImageFormat** *(string) --*

        The format for the exported image.

      - **S3Bucket** *(string) --*

        The S3 bucket for the destination image. The destination bucket must exist and grant
        WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

      - **S3Key** *(string) --*

        The encryption key for your S3 bucket.

    - **InstanceExportDetails** *(dict) --*

      Information about the instance to export.

      - **InstanceId** *(string) --*

        The ID of the resource being exported.

      - **TargetEnvironment** *(string) --*

        The target virtualization environment.

    - **State** *(string) --*

      The state of the export task.

    - **StatusMessage** *(string) --*

      The status message related to the export task.
    """


_ClientCreateInstanceExportTaskResponseTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseTypeDef",
    {"ExportTask": ClientCreateInstanceExportTaskResponseExportTaskTypeDef},
    total=False,
)


class ClientCreateInstanceExportTaskResponseTypeDef(
    _ClientCreateInstanceExportTaskResponseTypeDef
):
    """
    Type definition for `ClientCreateInstanceExportTask` `Response`

    - **ExportTask** *(dict) --*

      Information about the instance export task.

      - **Description** *(string) --*

        A description of the resource being exported.

      - **ExportTaskId** *(string) --*

        The ID of the export task.

      - **ExportToS3Task** *(dict) --*

        Information about the export task.

        - **ContainerFormat** *(string) --*

          The container format used to combine disk images with metadata (such as OVF). If absent,
          only the disk image is exported.

        - **DiskImageFormat** *(string) --*

          The format for the exported image.

        - **S3Bucket** *(string) --*

          The S3 bucket for the destination image. The destination bucket must exist and grant
          WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

        - **S3Key** *(string) --*

          The encryption key for your S3 bucket.

      - **InstanceExportDetails** *(dict) --*

        Information about the instance to export.

        - **InstanceId** *(string) --*

          The ID of the resource being exported.

        - **TargetEnvironment** *(string) --*

          The target virtualization environment.

      - **State** *(string) --*

        The state of the export task.

      - **StatusMessage** *(string) --*

        The status message related to the export task.
    """


_ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientCreateInternetGatewayResponseInternetGateway` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef
):
    """
    Type definition for `ClientCreateInternetGatewayResponseInternetGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateInternetGatewayResponseInternetGatewayTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayTypeDef",
    {
        "Attachments": List[
            ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef
        ],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayTypeDef
):
    """
    Type definition for `ClientCreateInternetGatewayResponse` `InternetGateway`

    Information about the internet gateway.

    - **Attachments** *(list) --*

      Any VPCs attached to the internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **InternetGatewayId** *(string) --*

      The ID of the internet gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the internet gateway.

    - **Tags** *(list) --*

      Any tags assigned to the internet gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateInternetGatewayResponseTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseTypeDef",
    {"InternetGateway": ClientCreateInternetGatewayResponseInternetGatewayTypeDef},
    total=False,
)


class ClientCreateInternetGatewayResponseTypeDef(
    _ClientCreateInternetGatewayResponseTypeDef
):
    """
    Type definition for `ClientCreateInternetGateway` `Response`

    - **InternetGateway** *(dict) --*

      Information about the internet gateway.

      - **Attachments** *(list) --*

        Any VPCs attached to the internet gateway.

        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.

          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is
            ``available`` when attached to a VPC; otherwise, this value is not returned.

          - **VpcId** *(string) --*

            The ID of the VPC.

      - **InternetGatewayId** *(string) --*

        The ID of the internet gateway.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the internet gateway.

      - **Tags** *(list) --*

        Any tags assigned to the internet gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateKeyPairResponseTypeDef = TypedDict(
    "_ClientCreateKeyPairResponseTypeDef",
    {"KeyFingerprint": str, "KeyMaterial": str, "KeyName": str},
    total=False,
)


class ClientCreateKeyPairResponseTypeDef(_ClientCreateKeyPairResponseTypeDef):
    """
    Type definition for `ClientCreateKeyPair` `Response`

    Describes a key pair.

    - **KeyFingerprint** *(string) --*

      The SHA-1 digest of the DER encoded private key.

    - **KeyMaterial** *(string) --*

      An unencrypted PEM encoded RSA private key.

    - **KeyName** *(string) --*

      The name of the key pair.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
      instances that support Amazon EBS encryption. If you are creating a volume from a
      snapshot, you can't specify an encryption value.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For io1, this
      represents the number of IOPS that are provisioned for the volume. For gp2, this
      represents the baseline performance of the volume and the rate at which the volume
      accumulates I/O credits for bursting. For more information about General Purpose SSD
      baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create io1 volumes; it is not used
      in requests to create gp2, st1, sc1, or standard volumes.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

    - **VolumeType** *(string) --*

      The volume type.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, /dev/sdh or xvdh).

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN). Instance store volumes are numbered starting from 0.
      An instance type with 2 available instance store volumes can specify mappings for
      ephemeral0 and ephemeral1. The number of available instance store volumes depends on the
      instance type. After you connect to the instance, you must mount the volume.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
        instances that support Amazon EBS encryption. If you are creating a volume from a
        snapshot, you can't specify an encryption value.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For io1, this
        represents the number of IOPS that are provisioned for the volume. For gp2, this
        represents the baseline performance of the volume and the rate at which the volume
        accumulates I/O credits for bursting. For more information about General Purpose SSD
        baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create io1 volumes; it is not used
        in requests to create gp2, st1, sc1, or standard volumes.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `CapacityReservationSpecification`

    The Capacity Reservation targeting option. If you do not specify this parameter, the instance's
    Capacity Reservation preference defaults to ``open`` , which enables it to run in any open
    Capacity Reservation that has matching attributes (instance type, platform, Availability Zone).

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core. To disable multithreading for the instance, specify a
      value of 1. Otherwise, specify the default value of 2.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
)


class ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance. Valid for T2 or T3 instances only.

    - **CpuCredits** *(string) --* **[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
)


class ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `ElasticGpuSpecifications`

    A specification for an Elastic Graphics accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of Elastic Graphics accelerator.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
)


class ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of elastic inference accelerator. The possible values are eia1.medium, eia1.large,
      and eia1.xlarge.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is enabled for hibernation. This parameter is valid only if the
    instance meets the `hibernation prerequisites
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites>`__
    . For more information, see `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon Elastic
    Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , the instance is enabled for hibernation.

      Default: ``false``
    """


_ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
      value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until all
      instances launch, the request is canceled, or this date is reached. If the request is
      persistent, it remains active until it is canceled or this date and time is reached. The
      default end date is 7 days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
        value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until all
        instances launch, the request is canceled, or this date is reached. If the request is
        persistent, it remains active until it is canceled or this date and time is reached. The
        default end date is 7 days from the current date.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Specify ``true`` to enable detailed monitoring. Otherwise, basic monitoring is enabled.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only
      one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `NetworkInterfaces`

    The parameters for a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Associates a public IPv4 address with eth0 for a new network interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses to assign to a network interface. Amazon EC2 automatically
      selects the IPv6 addresses from the subnet range. You can't use this option if specifying
      specific IPv6 addresses.

    - **Ipv6Addresses** *(list) --*

      One or more specific IPv6 addresses from the IPv6 CIDR block range of your subnet. You
      can't use this option if you're specifying a number of IPv6 addresses.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only
          one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses to assign to a network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `Placement`

    The placement for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the instance.

    - **Affinity** *(string) --*

      The affinity setting for an instance on a Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of dedicated runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateLaunchTemplateData` `TagSpecifications`

    The tags specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are ``instance`` and ``volume`` . To tag a resource after it has been created, see
      `CreateTags <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__
      .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplate` `LaunchTemplateData`

    The information for the launch template.

    - **KernelId** *(string) --*

      The ID of the kernel.

      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information, see
        `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal
      Amazon EBS I/O performance. This optimization isn't available with all instance types.
      Additional usage charges apply when using an EBS-optimized instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping.

      .. warning::

        Supplying both a snapshot ID and an encryption value as arguments for block-device mapping
        results in an error. This is because only blank volumes can be encrypted on start, and these
        are not created from a snapshot. If a snapshot is the basis for the volume, it contains data
        by definition and its encryption status cannot be changed using this action.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, /dev/sdh or xvdh).

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN). Instance store volumes are numbered starting from 0.
          An instance type with 2 available instance store volumes can specify mappings for
          ephemeral0 and ephemeral1. The number of available instance store volumes depends on the
          instance type. After you connect to the instance, you must mount the volume.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
            instances that support Amazon EBS encryption. If you are creating a volume from a
            snapshot, you can't specify an encryption value.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For io1, this
            represents the number of IOPS that are provisioned for the volume. For gp2, this
            represents the baseline performance of the volume and the rate at which the volume
            accumulates I/O credits for bursting. For more information about General Purpose SSD
            baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create io1 volumes; it is not used
            in requests to create gp2, st1, sc1, or standard volumes.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify any
      security groups and subnets as part of the network interface.

      - *(dict) --*

        The parameters for a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Associates a public IPv4 address with eth0 for a new network interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
          For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
          Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses to assign to a network interface. Amazon EC2 automatically
          selects the IPv6 addresses from the subnet range. You can't use this option if specifying
          specific IPv6 addresses.

        - **Ipv6Addresses** *(list) --*

          One or more specific IPv6 addresses from the IPv6 CIDR block range of your subnet. You
          can't use this option if you're specifying a number of IPv6 addresses.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address. Only
              one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses to assign to a network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type. For more information, see `Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

    - **KeyName** *(string) --*

      The name of the key pair. You can create a key pair using `CreateKeyPair
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html>`__ or
      `ImportKeyPair
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html>`__ .

      .. warning::

        If you do not specify a key pair, you can't connect to the instance unless you choose an AMI
        that is configured to allow users another way to log in.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Specify ``true`` to enable detailed monitoring. Otherwise, basic monitoring is enabled.

    - **Placement** *(dict) --*

      The placement for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone for the instance.

      - **Affinity** *(string) --*

        The affinity setting for an instance on a Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
        of dedicated runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk.

      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information, see
        `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

    - **DisableApiTermination** *(boolean) --*

      If you set this parameter to ``true`` , you can't terminate the instance using the Amazon EC2
      console, CLI, or API; otherwise, you can. To change this attribute after launch, use
      `ModifyInstanceAttribute
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html>`__ .
      Alternatively, if you set ``InstanceInitiatedShutdownBehavior`` to ``terminate`` , you can
      terminate the instance by running the shutdown command from the instance.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the instance
      (using the operating system command for system shutdown).

      Default: ``stop``

    - **UserData** *(string) --*

      The Base64-encoded user data to make available to the instance. For more information, see
      `Running Commands on Your Linux Instance at Launch
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html>`__ (Linux) and `Adding
      User Data
      <https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data>`__
      (Windows).

    - **TagSpecifications** *(list) --*

      The tags to apply to the resources during launch. You can only tag instances and volumes on
      launch. The specified tags are applied to all instances or volumes that are created during
      launch. To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

      - *(dict) --*

        The tags specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource to tag. Currently, the resource types that support tagging on creation
          are ``instance`` and ``volume`` . To tag a resource after it has been created, see
          `CreateTags <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__
          .

        - **Tags** *(list) --*

          The tags to apply to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      An elastic GPU to associate with the instance.

      - *(dict) --*

        A specification for an Elastic Graphics accelerator.

        - **Type** *(string) --* **[REQUIRED]**

          The type of Elastic Graphics accelerator.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --* **[REQUIRED]**

          The type of elastic inference accelerator. The possible values are eia1.medium, eia1.large,
          and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      One or more security group IDs. You can create a security group using `CreateSecurityGroup
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateSecurityGroup.html>`__ . You
      cannot specify both a security group ID and security name in the same request.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      [EC2-Classic, default VPC] One or more security group names. For a nondefault VPC, you must use
      security group IDs instead. You cannot specify both a security group ID and security name in
      the same request.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
          value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active until all
          instances launch, the request is canceled, or this date is reached. If the request is
          persistent, it remains active until it is canceled or this date and time is reached. The
          default end date is 7 days from the current date.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance. Valid for T2 or T3 instances only.

      - **CpuCredits** *(string) --* **[REQUIRED]**

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
        ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core. To disable multithreading for the instance, specify a
        value of 1. Otherwise, specify the default value of 2.

    - **CapacityReservationSpecification** *(dict) --*

      The Capacity Reservation targeting option. If you do not specify this parameter, the instance's
      Capacity Reservation preference defaults to ``open`` , which enables it to run in any open
      Capacity Reservation that has matching attributes (instance type, platform, Availability Zone).

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
        attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
        The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is enabled for hibernation. This parameter is valid only if the
      instance meets the `hibernation prerequisites
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites>`__
      . For more information, see `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If you set this parameter to ``true`` , the instance is enabled for hibernation.

        Default: ``false``
    """


_ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateResponseLaunchTemplate` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateResponse` `LaunchTemplate`

    Information about the launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **CreateTime** *(datetime) --*

      The time launch template was created.

    - **CreatedBy** *(string) --*

      The principal that created the launch template.

    - **DefaultVersionNumber** *(integer) --*

      The version number of the default version of the launch template.

    - **LatestVersionNumber** *(integer) --*

      The version number of the latest version of the launch template.

    - **Tags** *(list) --*

      The tags for the launch template.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientCreateLaunchTemplateResponseTypeDef(
    _ClientCreateLaunchTemplateResponseTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplate` `Response`

    - **LaunchTemplate** *(dict) --*

      Information about the launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template.

      - **CreateTime** *(datetime) --*

        The time launch template was created.

      - **CreatedBy** *(string) --*

        The principal that created the launch template.

      - **DefaultVersionNumber** *(integer) --*

        The version number of the default version of the launch template.

      - **LatestVersionNumber** *(integer) --*

        The version number of the latest version of the launch template.

      - **Tags** *(list) --*

        The tags for the launch template.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateLaunchTemplateTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateLaunchTemplateTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplate` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
      instances that support Amazon EBS encryption. If you are creating a volume from a
      snapshot, you can't specify an encryption value.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For io1, this
      represents the number of IOPS that are provisioned for the volume. For gp2, this
      represents the baseline performance of the volume and the rate at which the volume
      accumulates I/O credits for bursting. For more information about General Purpose SSD
      baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create io1 volumes; it is not used
      in requests to create gp2, st1, sc1, or standard volumes.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

    - **VolumeType** *(string) --*

      The volume type.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, /dev/sdh or xvdh).

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN). Instance store volumes are numbered starting from 0.
      An instance type with 2 available instance store volumes can specify mappings for
      ephemeral0 and ephemeral1. The number of available instance store volumes depends on the
      instance type. After you connect to the instance, you must mount the volume.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
        instances that support Amazon EBS encryption. If you are creating a volume from a
        snapshot, you can't specify an encryption value.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For io1, this
        represents the number of IOPS that are provisioned for the volume. For gp2, this
        represents the baseline performance of the volume and the rate at which the volume
        accumulates I/O credits for bursting. For more information about General Purpose SSD
        baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create io1 volumes; it is not used
        in requests to create gp2, st1, sc1, or standard volumes.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `CapacityReservationSpecification`

    The Capacity Reservation targeting option. If you do not specify this parameter, the instance's
    Capacity Reservation preference defaults to ``open`` , which enables it to run in any open
    Capacity Reservation that has matching attributes (instance type, platform, Availability Zone).

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core. To disable multithreading for the instance, specify a
      value of 1. Otherwise, specify the default value of 2.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance. Valid for T2 or T3 instances only.

    - **CpuCredits** *(string) --* **[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `ElasticGpuSpecifications`

    A specification for an Elastic Graphics accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of Elastic Graphics accelerator.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of elastic inference accelerator. The possible values are eia1.medium, eia1.large,
      and eia1.xlarge.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is enabled for hibernation. This parameter is valid only if the
    instance meets the `hibernation prerequisites
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites>`__
    . For more information, see `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon Elastic
    Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , the instance is enabled for hibernation.

      Default: ``false``
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
      value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until all
      instances launch, the request is canceled, or this date is reached. If the request is
      persistent, it remains active until it is canceled or this date and time is reached. The
      default end date is 7 days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
        value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until all
        instances launch, the request is canceled, or this date is reached. If the request is
        persistent, it remains active until it is canceled or this date and time is reached. The
        default end date is 7 days from the current date.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Specify ``true`` to enable detailed monitoring. Otherwise, basic monitoring is enabled.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only
      one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `NetworkInterfaces`

    The parameters for a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Associates a public IPv4 address with eth0 for a new network interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses to assign to a network interface. Amazon EC2 automatically
      selects the IPv6 addresses from the subnet range. You can't use this option if specifying
      specific IPv6 addresses.

    - **Ipv6Addresses** *(list) --*

      One or more specific IPv6 addresses from the IPv6 CIDR block range of your subnet. You
      can't use this option if you're specifying a number of IPv6 addresses.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only
          one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses to assign to a network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `Placement`

    The placement for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the instance.

    - **Affinity** *(string) --*

      The affinity setting for an instance on a Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of dedicated runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionLaunchTemplateData` `TagSpecifications`

    The tags specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are ``instance`` and ``volume`` . To tag a resource after it has been created, see
      `CreateTags <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__
      .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersion` `LaunchTemplateData`

    The information for the launch template.

    - **KernelId** *(string) --*

      The ID of the kernel.

      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information, see
        `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal
      Amazon EBS I/O performance. This optimization isn't available with all instance types.
      Additional usage charges apply when using an EBS-optimized instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping.

      .. warning::

        Supplying both a snapshot ID and an encryption value as arguments for block-device mapping
        results in an error. This is because only blank volumes can be encrypted on start, and these
        are not created from a snapshot. If a snapshot is the basis for the volume, it contains data
        by definition and its encryption status cannot be changed using this action.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, /dev/sdh or xvdh).

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN). Instance store volumes are numbered starting from 0.
          An instance type with 2 available instance store volumes can specify mappings for
          ephemeral0 and ephemeral1. The number of available instance store volumes depends on the
          instance type. After you connect to the instance, you must mount the volume.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted. Encrypted volumes can only be attached to
            instances that support Amazon EBS encryption. If you are creating a volume from a
            snapshot, you can't specify an encryption value.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For io1, this
            represents the number of IOPS that are provisioned for the volume. For gp2, this
            represents the baseline performance of the volume and the rate at which the volume
            accumulates I/O credits for bursting. For more information about General Purpose SSD
            baseline performance, I/O credits, and bursting, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create io1 volumes; it is not used
            in requests to create gp2, st1, sc1, or standard volumes.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify any
      security groups and subnets as part of the network interface.

      - *(dict) --*

        The parameters for a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Associates a public IPv4 address with eth0 for a new network interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
          For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
          Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses to assign to a network interface. Amazon EC2 automatically
          selects the IPv6 addresses from the subnet range. You can't use this option if specifying
          specific IPv6 addresses.

        - **Ipv6Addresses** *(list) --*

          One or more specific IPv6 addresses from the IPv6 CIDR block range of your subnet. You
          can't use this option if you're specifying a number of IPv6 addresses.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address. Only
              one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses to assign to a network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type. For more information, see `Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

    - **KeyName** *(string) --*

      The name of the key pair. You can create a key pair using `CreateKeyPair
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html>`__ or
      `ImportKeyPair
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html>`__ .

      .. warning::

        If you do not specify a key pair, you can't connect to the instance unless you choose an AMI
        that is configured to allow users another way to log in.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Specify ``true`` to enable detailed monitoring. Otherwise, basic monitoring is enabled.

    - **Placement** *(dict) --*

      The placement for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone for the instance.

      - **Affinity** *(string) --*

        The affinity setting for an instance on a Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
        of dedicated runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk.

      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information, see
        `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

    - **DisableApiTermination** *(boolean) --*

      If you set this parameter to ``true`` , you can't terminate the instance using the Amazon EC2
      console, CLI, or API; otherwise, you can. To change this attribute after launch, use
      `ModifyInstanceAttribute
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html>`__ .
      Alternatively, if you set ``InstanceInitiatedShutdownBehavior`` to ``terminate`` , you can
      terminate the instance by running the shutdown command from the instance.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the instance
      (using the operating system command for system shutdown).

      Default: ``stop``

    - **UserData** *(string) --*

      The Base64-encoded user data to make available to the instance. For more information, see
      `Running Commands on Your Linux Instance at Launch
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html>`__ (Linux) and `Adding
      User Data
      <https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data>`__
      (Windows).

    - **TagSpecifications** *(list) --*

      The tags to apply to the resources during launch. You can only tag instances and volumes on
      launch. The specified tags are applied to all instances or volumes that are created during
      launch. To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

      - *(dict) --*

        The tags specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource to tag. Currently, the resource types that support tagging on creation
          are ``instance`` and ``volume`` . To tag a resource after it has been created, see
          `CreateTags <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__
          .

        - **Tags** *(list) --*

          The tags to apply to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      An elastic GPU to associate with the instance.

      - *(dict) --*

        A specification for an Elastic Graphics accelerator.

        - **Type** *(string) --* **[REQUIRED]**

          The type of Elastic Graphics accelerator.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --* **[REQUIRED]**

          The type of elastic inference accelerator. The possible values are eia1.medium, eia1.large,
          and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      One or more security group IDs. You can create a security group using `CreateSecurityGroup
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateSecurityGroup.html>`__ . You
      cannot specify both a security group ID and security name in the same request.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      [EC2-Classic, default VPC] One or more security group names. For a nondefault VPC, you must use
      security group IDs instead. You cannot specify both a security group ID and security name in
      the same request.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
          value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active until all
          instances launch, the request is canceled, or this date is reached. If the request is
          persistent, it remains active until it is canceled or this date and time is reached. The
          default end date is 7 days from the current date.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance. Valid for T2 or T3 instances only.

      - **CpuCredits** *(string) --* **[REQUIRED]**

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
        ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core. To disable multithreading for the instance, specify a
        value of 1. Otherwise, specify the default value of 2.

    - **CapacityReservationSpecification** *(dict) --*

      The Capacity Reservation targeting option. If you do not specify this parameter, the instance's
      Capacity Reservation preference defaults to ``open`` , which enables it to run in any open
      Capacity Reservation that has matching attributes (instance type, platform, Availability Zone).

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
        attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
        The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is enabled for hibernation. This parameter is valid only if the
      instance meets the `hibernation prerequisites
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites>`__
      . For more information, see `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If you set this parameter to ``true`` , the instance is enabled for hibernation.

        Default: ``false``
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Information about the block device for an EBS volume.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **VolumeType** *(string) --*

      The volume type.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name.

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN).

    - **Ebs** *(dict) --*

      Information about the block device for an EBS volume.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
      and ``unlimited`` .
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `ElasticGpuSpecifications`

    Describes an elastic GPU.

    - **Type** *(string) --*

      The elastic GPU type.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --*

      The type of elastic inference accelerator. The possible values are eia1.medium,
      eia1.large, and eia1.xlarge.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is configured for hibernation. For more information, see
    `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
    Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , the instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes.
      This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until
      all instances launch, the request is canceled, or this date is reached. If the
      request is persistent, it remains active until it is canceled or this date and time
      is reached.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes.
        This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until
        all instances launch, the request is canceled, or this date is reached. If the
        request is persistent, it remains active until it is canceled or this date and time
        is reached.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to associate a public IPv4 address with eth0 for a new network
      interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses for the network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses for the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses for the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `Placement`

    The placement of the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateData` `TagSpecifications`

    The tag specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource.

    - **Tags** *(list) --*

      The tags for the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersion` `LaunchTemplateData`

    Information about the launch template.

    - **KernelId** *(string) --*

      The ID of the kernel, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mappings.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name.

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN).

        - **Ebs** *(dict) --*

          Information about the block device for an EBS volume.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      The network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to associate a public IPv4 address with eth0 for a new network
          interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses for the network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses for the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses for the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI that was used to launch the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The placement of the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk, if applicable.

    - **DisableApiTermination** *(boolean) --*

      If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
      EC2 console, command line tool, or API.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

    - **UserData** *(string) --*

      The user data for the instance.

    - **TagSpecifications** *(list) --*

      The tags.

      - *(dict) --*

        The tag specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource.

        - **Tags** *(list) --*

          The tags for the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      The elastic GPU specification.

      - *(dict) --*

        Describes an elastic GPU.

        - **Type** *(string) --*

          The elastic GPU type.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --*

          The type of elastic inference accelerator. The possible values are eia1.medium,
          eia1.large, and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      The security group IDs.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      The security group names.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in minutes.
          This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active until
          all instances launch, the request is canceled, or this date is reached. If the
          request is persistent, it remains active until it is canceled or this date and time
          is reached.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance.

      - **CpuCredits** *(string) --*

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
        and ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is configured for hibernation. For more information, see
      `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , the instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersionResponse` `LaunchTemplateVersion`

    Information about the launch template version.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **VersionNumber** *(integer) --*

      The version number.

    - **VersionDescription** *(string) --*

      The description for the version.

    - **CreateTime** *(datetime) --*

      The time the version was created.

    - **CreatedBy** *(string) --*

      The principal that created the version.

    - **DefaultVersion** *(boolean) --*

      Indicates whether the version is the default version.

    - **LaunchTemplateData** *(dict) --*

      Information about the launch template.

      - **KernelId** *(string) --*

        The ID of the kernel, if applicable.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for Amazon EBS I/O.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **BlockDeviceMappings** *(list) --*

        The block device mappings.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name.

          - **VirtualName** *(string) --*

            The virtual device name (ephemeralN).

          - **Ebs** *(dict) --*

            Information about the block device for an EBS volume.

            - **Encrypted** *(boolean) --*

              Indicates whether the EBS volume is encrypted.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports.

            - **KmsKeyId** *(string) --*

              The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

            - **VolumeType** *(string) --*

              The volume type.

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **NetworkInterfaces** *(list) --*

        The network interfaces.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to associate a public IPv4 address with eth0 for a new network
            interface.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **Description** *(string) --*

            A description for the network interface.

          - **DeviceIndex** *(integer) --*

            The device index for the network interface attachment.

          - **Groups** *(list) --*

            The IDs of one or more security groups.

            - *(string) --*

          - **InterfaceType** *(string) --*

            The type of network interface.

          - **Ipv6AddressCount** *(integer) --*

            The number of IPv6 addresses for the network interface.

          - **Ipv6Addresses** *(list) --*

            The IPv6 addresses for the network interface.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The primary private IPv4 address of the network interface.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses for the network interface.

          - **SubnetId** *(string) --*

            The ID of the subnet for the network interface.

      - **ImageId** *(string) --*

        The ID of the AMI that was used to launch the instance.

      - **InstanceType** *(string) --*

        The instance type.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **Monitoring** *(dict) --*

        The monitoring for the instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

      - **Placement** *(dict) --*

        The placement of the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Affinity** *(string) --*

          The affinity setting for the instance on the Dedicated Host.

        - **GroupName** *(string) --*

          The name of the placement group for the instance.

        - **HostId** *(string) --*

          The ID of the Dedicated Host for the instance.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware.

        - **SpreadDomain** *(string) --*

          Reserved for future use.

      - **RamDiskId** *(string) --*

        The ID of the RAM disk, if applicable.

      - **DisableApiTermination** *(boolean) --*

        If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
        EC2 console, command line tool, or API.

      - **InstanceInitiatedShutdownBehavior** *(string) --*

        Indicates whether an instance stops or terminates when you initiate shutdown from the
        instance (using the operating system command for system shutdown).

      - **UserData** *(string) --*

        The user data for the instance.

      - **TagSpecifications** *(list) --*

        The tags.

        - *(dict) --*

          The tag specification for the launch template.

          - **ResourceType** *(string) --*

            The type of resource.

          - **Tags** *(list) --*

            The tags for the resource.

            - *(dict) --*

              Describes a tag.

              - **Key** *(string) --*

                The key of the tag.

                Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                characters. May not begin with ``aws:`` .

              - **Value** *(string) --*

                The value of the tag.

                Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                characters.

      - **ElasticGpuSpecifications** *(list) --*

        The elastic GPU specification.

        - *(dict) --*

          Describes an elastic GPU.

          - **Type** *(string) --*

            The elastic GPU type.

      - **ElasticInferenceAccelerators** *(list) --*

        The elastic inference accelerator for the instance.

        - *(dict) --*

          Describes an elastic inference accelerator.

          - **Type** *(string) --*

            The type of elastic inference accelerator. The possible values are eia1.medium,
            eia1.large, and eia1.xlarge.

      - **SecurityGroupIds** *(list) --*

        The security group IDs.

        - *(string) --*

      - **SecurityGroups** *(list) --*

        The security group names.

        - *(string) --*

      - **InstanceMarketOptions** *(dict) --*

        The market (purchasing) option for the instances.

        - **MarketType** *(string) --*

          The market type.

        - **SpotOptions** *(dict) --*

          The options for Spot Instances.

          - **MaxPrice** *(string) --*

            The maximum hourly price you're willing to pay for the Spot Instances.

          - **SpotInstanceType** *(string) --*

            The Spot Instance request type.

          - **BlockDurationMinutes** *(integer) --*

            The required duration for the Spot Instances (also known as Spot blocks), in minutes.
            This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

          - **ValidUntil** *(datetime) --*

            The end date of the request. For a one-time request, the request remains active until
            all instances launch, the request is canceled, or this date is reached. If the
            request is persistent, it remains active until it is canceled or this date and time
            is reached.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted.

      - **CreditSpecification** *(dict) --*

        The credit option for CPU usage of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
          and ``unlimited`` .

      - **CpuOptions** *(dict) --*

        The CPU options for the instance. For more information, see `Optimizing CPU Options
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        - **CoreCount** *(integer) --*

          The number of CPU cores for the instance.

        - **ThreadsPerCore** *(integer) --*

          The number of threads per CPU core.

      - **CapacityReservationSpecification** *(dict) --*

        Information about the Capacity Reservation targeting option.

        - **CapacityReservationPreference** *(string) --*

          Indicates the instance's Capacity Reservation preferences. Possible preferences include:

          * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
          matching attributes (instance type, platform, Availability Zone).

          * ``none`` - The instance avoids running in a Capacity Reservation even if one is
          available. The instance runs in On-Demand capacity.

        - **CapacityReservationTarget** *(dict) --*

          Information about the target Capacity Reservation.

          - **CapacityReservationId** *(string) --*

            The ID of the Capacity Reservation.

      - **LicenseSpecifications** *(list) --*

        The license configurations.

        - *(dict) --*

          Describes a license configuration.

          - **LicenseConfigurationArn** *(string) --*

            The Amazon Resource Name (ARN) of the license configuration.

      - **HibernationOptions** *(dict) --*

        Indicates whether an instance is configured for hibernation. For more information, see
        `Hibernate Your Instance
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        - **Configured** *(boolean) --*

          If this parameter is set to ``true`` , the instance is enabled for hibernation;
          otherwise, it is not enabled for hibernation.
    """


_ClientCreateLaunchTemplateVersionResponseTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseTypeDef",
    {
        "LaunchTemplateVersion": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseTypeDef(
    _ClientCreateLaunchTemplateVersionResponseTypeDef
):
    """
    Type definition for `ClientCreateLaunchTemplateVersion` `Response`

    - **LaunchTemplateVersion** *(dict) --*

      Information about the launch template version.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template.

      - **VersionNumber** *(integer) --*

        The version number.

      - **VersionDescription** *(string) --*

        The description for the version.

      - **CreateTime** *(datetime) --*

        The time the version was created.

      - **CreatedBy** *(string) --*

        The principal that created the version.

      - **DefaultVersion** *(boolean) --*

        Indicates whether the version is the default version.

      - **LaunchTemplateData** *(dict) --*

        Information about the launch template.

        - **KernelId** *(string) --*

          The ID of the kernel, if applicable.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instance is optimized for Amazon EBS I/O.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Name** *(string) --*

            The name of the instance profile.

        - **BlockDeviceMappings** *(list) --*

          The block device mappings.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name.

            - **VirtualName** *(string) --*

              The virtual device name (ephemeralN).

            - **Ebs** *(dict) --*

              Information about the block device for an EBS volume.

              - **Encrypted** *(boolean) --*

                Indicates whether the EBS volume is encrypted.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the EBS volume is deleted on instance termination.

              - **Iops** *(integer) --*

                The number of I/O operations per second (IOPS) that the volume supports.

              - **KmsKeyId** *(string) --*

                The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

              - **SnapshotId** *(string) --*

                The ID of the snapshot.

              - **VolumeSize** *(integer) --*

                The size of the volume, in GiB.

              - **VolumeType** *(string) --*

                The volume type.

            - **NoDevice** *(string) --*

              Suppresses the specified device included in the block device mapping of the AMI.

        - **NetworkInterfaces** *(list) --*

          The network interfaces.

          - *(dict) --*

            Describes a network interface.

            - **AssociatePublicIpAddress** *(boolean) --*

              Indicates whether to associate a public IPv4 address with eth0 for a new network
              interface.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the network interface is deleted when the instance is terminated.

            - **Description** *(string) --*

              A description for the network interface.

            - **DeviceIndex** *(integer) --*

              The device index for the network interface attachment.

            - **Groups** *(list) --*

              The IDs of one or more security groups.

              - *(string) --*

            - **InterfaceType** *(string) --*

              The type of network interface.

            - **Ipv6AddressCount** *(integer) --*

              The number of IPv6 addresses for the network interface.

            - **Ipv6Addresses** *(list) --*

              The IPv6 addresses for the network interface.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **PrivateIpAddress** *(string) --*

              The primary private IPv4 address of the network interface.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses.

              - *(dict) --*

                Describes a secondary private IPv4 address for a network interface.

                - **Primary** *(boolean) --*

                  Indicates whether the private IPv4 address is the primary private IPv4 address.
                  Only one IPv4 address can be designated as primary.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 addresses.

            - **SecondaryPrivateIpAddressCount** *(integer) --*

              The number of secondary private IPv4 addresses for the network interface.

            - **SubnetId** *(string) --*

              The ID of the subnet for the network interface.

        - **ImageId** *(string) --*

          The ID of the AMI that was used to launch the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **KeyName** *(string) --*

          The name of the key pair.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **Enabled** *(boolean) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.

        - **Placement** *(dict) --*

          The placement of the instance.

          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.

          - **Affinity** *(string) --*

            The affinity setting for the instance on the Dedicated Host.

          - **GroupName** *(string) --*

            The name of the placement group for the instance.

          - **HostId** *(string) --*

            The ID of the Dedicated Host for the instance.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with a
            tenancy of ``dedicated`` runs on single-tenant hardware.

          - **SpreadDomain** *(string) --*

            Reserved for future use.

        - **RamDiskId** *(string) --*

          The ID of the RAM disk, if applicable.

        - **DisableApiTermination** *(boolean) --*

          If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
          EC2 console, command line tool, or API.

        - **InstanceInitiatedShutdownBehavior** *(string) --*

          Indicates whether an instance stops or terminates when you initiate shutdown from the
          instance (using the operating system command for system shutdown).

        - **UserData** *(string) --*

          The user data for the instance.

        - **TagSpecifications** *(list) --*

          The tags.

          - *(dict) --*

            The tag specification for the launch template.

            - **ResourceType** *(string) --*

              The type of resource.

            - **Tags** *(list) --*

              The tags for the resource.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                  characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                  characters.

        - **ElasticGpuSpecifications** *(list) --*

          The elastic GPU specification.

          - *(dict) --*

            Describes an elastic GPU.

            - **Type** *(string) --*

              The elastic GPU type.

        - **ElasticInferenceAccelerators** *(list) --*

          The elastic inference accelerator for the instance.

          - *(dict) --*

            Describes an elastic inference accelerator.

            - **Type** *(string) --*

              The type of elastic inference accelerator. The possible values are eia1.medium,
              eia1.large, and eia1.xlarge.

        - **SecurityGroupIds** *(list) --*

          The security group IDs.

          - *(string) --*

        - **SecurityGroups** *(list) --*

          The security group names.

          - *(string) --*

        - **InstanceMarketOptions** *(dict) --*

          The market (purchasing) option for the instances.

          - **MarketType** *(string) --*

            The market type.

          - **SpotOptions** *(dict) --*

            The options for Spot Instances.

            - **MaxPrice** *(string) --*

              The maximum hourly price you're willing to pay for the Spot Instances.

            - **SpotInstanceType** *(string) --*

              The Spot Instance request type.

            - **BlockDurationMinutes** *(integer) --*

              The required duration for the Spot Instances (also known as Spot blocks), in minutes.
              This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

            - **ValidUntil** *(datetime) --*

              The end date of the request. For a one-time request, the request remains active until
              all instances launch, the request is canceled, or this date is reached. If the
              request is persistent, it remains active until it is canceled or this date and time
              is reached.

            - **InstanceInterruptionBehavior** *(string) --*

              The behavior when a Spot Instance is interrupted.

        - **CreditSpecification** *(dict) --*

          The credit option for CPU usage of the instance.

          - **CpuCredits** *(string) --*

            The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
            and ``unlimited`` .

        - **CpuOptions** *(dict) --*

          The CPU options for the instance. For more information, see `Optimizing CPU Options
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
          the *Amazon Elastic Compute Cloud User Guide* .

          - **CoreCount** *(integer) --*

            The number of CPU cores for the instance.

          - **ThreadsPerCore** *(integer) --*

            The number of threads per CPU core.

        - **CapacityReservationSpecification** *(dict) --*

          Information about the Capacity Reservation targeting option.

          - **CapacityReservationPreference** *(string) --*

            Indicates the instance's Capacity Reservation preferences. Possible preferences include:

            * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
            matching attributes (instance type, platform, Availability Zone).

            * ``none`` - The instance avoids running in a Capacity Reservation even if one is
            available. The instance runs in On-Demand capacity.

          - **CapacityReservationTarget** *(dict) --*

            Information about the target Capacity Reservation.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

        - **LicenseSpecifications** *(list) --*

          The license configurations.

          - *(dict) --*

            Describes a license configuration.

            - **LicenseConfigurationArn** *(string) --*

              The Amazon Resource Name (ARN) of the license configuration.

        - **HibernationOptions** *(dict) --*

          Indicates whether an instance is configured for hibernation. For more information, see
          `Hibernate Your Instance
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
          Elastic Compute Cloud User Guide* .

          - **Configured** *(boolean) --*

            If this parameter is set to ``true`` , the instance is enabled for hibernation;
            otherwise, it is not enabled for hibernation.
    """


_ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef
):
    """
    Type definition for `ClientCreateNatGatewayResponseNatGateway` `NatGatewayAddresses`

    Describes the IP addresses and network interface associated with a NAT gateway.

    - **AllocationId** *(string) --*

      The allocation ID of the Elastic IP address that's associated with the NAT gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface associated with the NAT gateway.

    - **PrivateIp** *(string) --*

      The private IP address associated with the Elastic IP address.

    - **PublicIp** *(string) --*

      The Elastic IP address associated with the NAT gateway.
    """


_ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef
):
    """
    Type definition for `ClientCreateNatGatewayResponseNatGateway` `ProvisionedBandwidth`

    Reserved. If you need to sustain traffic greater than the `documented limits
    <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
    through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **ProvisionTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Provisioned** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **RequestTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Requested** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Status** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .
    """


_ClientCreateNatGatewayResponseNatGatewayTagsTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayTagsTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayTagsTypeDef
):
    """
    Type definition for `ClientCreateNatGatewayResponseNatGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateNatGatewayResponseNatGatewayTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[ClientCreateNatGatewayResponseNatGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayTypeDef
):
    """
    Type definition for `ClientCreateNatGatewayResponse` `NatGateway`

    Information about the NAT gateway.

    - **CreateTime** *(datetime) --*

      The date and time the NAT gateway was created.

    - **DeleteTime** *(datetime) --*

      The date and time the NAT gateway was deleted, if applicable.

    - **FailureCode** *(string) --*

      If the NAT gateway could not be created, specifies the error code for the failure.
      (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
      ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
      ``InvalidSubnetID.NotFound`` )

    - **FailureMessage** *(string) --*

      If the NAT gateway could not be created, specifies the error message for the failure, that
      corresponds to the error code.

      * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to create
      this NAT gateway"

      * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

      * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
      associated with this NAT gateway"

      * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
      associated"

      * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
      NAT gateway is in an invalid state. Please try again."

      * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
      could not be found."

    - **NatGatewayAddresses** *(list) --*

      Information about the IP addresses and network interface associated with the NAT gateway.

      - *(dict) --*

        Describes the IP addresses and network interface associated with a NAT gateway.

        - **AllocationId** *(string) --*

          The allocation ID of the Elastic IP address that's associated with the NAT gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface associated with the NAT gateway.

        - **PrivateIp** *(string) --*

          The private IP address associated with the Elastic IP address.

        - **PublicIp** *(string) --*

          The Elastic IP address associated with the NAT gateway.

    - **NatGatewayId** *(string) --*

      The ID of the NAT gateway.

    - **ProvisionedBandwidth** *(dict) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **ProvisionTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Provisioned** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **RequestTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Requested** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Status** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **State** *(string) --*

      The state of the NAT gateway.

      * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

      * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
      ``failureMessage`` fields for the reason.

      * ``available`` : The NAT gateway is able to process traffic. This status remains until you
      delete the NAT gateway, and does not indicate the health of the NAT gateway.

      * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
      processing traffic.

      * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

    - **SubnetId** *(string) --*

      The ID of the subnet in which the NAT gateway is located.

    - **VpcId** *(string) --*

      The ID of the VPC in which the NAT gateway is located.

    - **Tags** *(list) --*

      The tags for the NAT gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateNatGatewayResponseTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseTypeDef",
    {"ClientToken": str, "NatGateway": ClientCreateNatGatewayResponseNatGatewayTypeDef},
    total=False,
)


class ClientCreateNatGatewayResponseTypeDef(_ClientCreateNatGatewayResponseTypeDef):
    """
    Type definition for `ClientCreateNatGateway` `Response`

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier to ensure the idempotency of the request. Only returned if
      a client token was provided in the request.

    - **NatGateway** *(dict) --*

      Information about the NAT gateway.

      - **CreateTime** *(datetime) --*

        The date and time the NAT gateway was created.

      - **DeleteTime** *(datetime) --*

        The date and time the NAT gateway was deleted, if applicable.

      - **FailureCode** *(string) --*

        If the NAT gateway could not be created, specifies the error code for the failure.
        (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
        ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
        ``InvalidSubnetID.NotFound`` )

      - **FailureMessage** *(string) --*

        If the NAT gateway could not be created, specifies the error message for the failure, that
        corresponds to the error code.

        * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to create
        this NAT gateway"

        * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

        * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
        associated with this NAT gateway"

        * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
        associated"

        * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
        NAT gateway is in an invalid state. Please try again."

        * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
        could not be found."

      - **NatGatewayAddresses** *(list) --*

        Information about the IP addresses and network interface associated with the NAT gateway.

        - *(dict) --*

          Describes the IP addresses and network interface associated with a NAT gateway.

          - **AllocationId** *(string) --*

            The allocation ID of the Elastic IP address that's associated with the NAT gateway.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface associated with the NAT gateway.

          - **PrivateIp** *(string) --*

            The private IP address associated with the Elastic IP address.

          - **PublicIp** *(string) --*

            The Elastic IP address associated with the NAT gateway.

      - **NatGatewayId** *(string) --*

        The ID of the NAT gateway.

      - **ProvisionedBandwidth** *(dict) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **ProvisionTime** *(datetime) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **Provisioned** *(string) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **RequestTime** *(datetime) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **Requested** *(string) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **Status** *(string) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **State** *(string) --*

        The state of the NAT gateway.

        * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

        * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
        ``failureMessage`` fields for the reason.

        * ``available`` : The NAT gateway is able to process traffic. This status remains until you
        delete the NAT gateway, and does not indicate the health of the NAT gateway.

        * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
        processing traffic.

        * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

      - **SubnetId** *(string) --*

        The ID of the subnet in which the NAT gateway is located.

      - **VpcId** *(string) --*

        The ID of the VPC in which the NAT gateway is located.

      - **Tags** *(list) --*

        The tags for the NAT gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef = TypedDict(
    "_ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef(
    _ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclEntry` `IcmpTypeCode`

    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_ClientCreateNetworkAclEntryPortRangeTypeDef = TypedDict(
    "_ClientCreateNetworkAclEntryPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientCreateNetworkAclEntryPortRangeTypeDef(
    _ClientCreateNetworkAclEntryPortRangeTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclEntry` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponseNetworkAcl` `Associations`

    Describes an association between a network ACL and a subnet.

    - **NetworkAclAssociationId** *(string) --*

      The ID of the association between a network ACL and a subnet.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponseNetworkAclEntries` `IcmpTypeCode`

    ICMP protocol: The ICMP type and code.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponseNetworkAclEntries` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to.

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": str,
        "RuleNumber": int,
    },
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponseNetworkAcl` `Entries`

    Describes an entry in a network ACL.

    - **CidrBlock** *(string) --*

      The IPv4 network range to allow or deny, in CIDR notation.

    - **Egress** *(boolean) --*

      Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

    - **IcmpTypeCode** *(dict) --*

      ICMP protocol: The ICMP type and code.

      - **Code** *(integer) --*

        The ICMP code. A value of -1 means all codes for the specified ICMP type.

      - **Type** *(integer) --*

        The ICMP type. A value of -1 means all types.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 network range to allow or deny, in CIDR notation.

    - **PortRange** *(dict) --*

      TCP or UDP protocols: The range of ports the rule applies to.

      - **From** *(integer) --*

        The first port in the range.

      - **To** *(integer) --*

        The last port in the range.

    - **Protocol** *(string) --*

      The protocol number. A value of "-1" means all protocols.

    - **RuleAction** *(string) --*

      Indicates whether to allow or deny the traffic that matches the rule.

    - **RuleNumber** *(integer) --*

      The rule number for the entry. ACL entries are processed in ascending order by rule
      number.
    """


_ClientCreateNetworkAclResponseNetworkAclTagsTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclTagsTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclTagsTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponseNetworkAcl` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateNetworkAclResponseNetworkAclTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclTypeDef",
    {
        "Associations": List[
            ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef
        ],
        "Entries": List[ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[ClientCreateNetworkAclResponseNetworkAclTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclTypeDef
):
    """
    Type definition for `ClientCreateNetworkAclResponse` `NetworkAcl`

    Information about the network ACL.

    - **Associations** *(list) --*

      Any associations between the network ACL and one or more subnets

      - *(dict) --*

        Describes an association between a network ACL and a subnet.

        - **NetworkAclAssociationId** *(string) --*

          The ID of the association between a network ACL and a subnet.

        - **NetworkAclId** *(string) --*

          The ID of the network ACL.

        - **SubnetId** *(string) --*

          The ID of the subnet.

    - **Entries** *(list) --*

      One or more entries (rules) in the network ACL.

      - *(dict) --*

        Describes an entry in a network ACL.

        - **CidrBlock** *(string) --*

          The IPv4 network range to allow or deny, in CIDR notation.

        - **Egress** *(boolean) --*

          Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

        - **IcmpTypeCode** *(dict) --*

          ICMP protocol: The ICMP type and code.

          - **Code** *(integer) --*

            The ICMP code. A value of -1 means all codes for the specified ICMP type.

          - **Type** *(integer) --*

            The ICMP type. A value of -1 means all types.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 network range to allow or deny, in CIDR notation.

        - **PortRange** *(dict) --*

          TCP or UDP protocols: The range of ports the rule applies to.

          - **From** *(integer) --*

            The first port in the range.

          - **To** *(integer) --*

            The last port in the range.

        - **Protocol** *(string) --*

          The protocol number. A value of "-1" means all protocols.

        - **RuleAction** *(string) --*

          Indicates whether to allow or deny the traffic that matches the rule.

        - **RuleNumber** *(integer) --*

          The rule number for the entry. ACL entries are processed in ascending order by rule
          number.

    - **IsDefault** *(boolean) --*

      Indicates whether this is the default network ACL for the VPC.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **Tags** *(list) --*

      Any tags assigned to the network ACL.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC for the network ACL.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the network ACL.
    """


_ClientCreateNetworkAclResponseTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseTypeDef",
    {"NetworkAcl": ClientCreateNetworkAclResponseNetworkAclTypeDef},
    total=False,
)


class ClientCreateNetworkAclResponseTypeDef(_ClientCreateNetworkAclResponseTypeDef):
    """
    Type definition for `ClientCreateNetworkAcl` `Response`

    - **NetworkAcl** *(dict) --*

      Information about the network ACL.

      - **Associations** *(list) --*

        Any associations between the network ACL and one or more subnets

        - *(dict) --*

          Describes an association between a network ACL and a subnet.

          - **NetworkAclAssociationId** *(string) --*

            The ID of the association between a network ACL and a subnet.

          - **NetworkAclId** *(string) --*

            The ID of the network ACL.

          - **SubnetId** *(string) --*

            The ID of the subnet.

      - **Entries** *(list) --*

        One or more entries (rules) in the network ACL.

        - *(dict) --*

          Describes an entry in a network ACL.

          - **CidrBlock** *(string) --*

            The IPv4 network range to allow or deny, in CIDR notation.

          - **Egress** *(boolean) --*

            Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

          - **IcmpTypeCode** *(dict) --*

            ICMP protocol: The ICMP type and code.

            - **Code** *(integer) --*

              The ICMP code. A value of -1 means all codes for the specified ICMP type.

            - **Type** *(integer) --*

              The ICMP type. A value of -1 means all types.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 network range to allow or deny, in CIDR notation.

          - **PortRange** *(dict) --*

            TCP or UDP protocols: The range of ports the rule applies to.

            - **From** *(integer) --*

              The first port in the range.

            - **To** *(integer) --*

              The last port in the range.

          - **Protocol** *(string) --*

            The protocol number. A value of "-1" means all protocols.

          - **RuleAction** *(string) --*

            Indicates whether to allow or deny the traffic that matches the rule.

          - **RuleNumber** *(integer) --*

            The rule number for the entry. ACL entries are processed in ascending order by rule
            number.

      - **IsDefault** *(boolean) --*

        Indicates whether this is the default network ACL for the VPC.

      - **NetworkAclId** *(string) --*

        The ID of the network ACL.

      - **Tags** *(list) --*

        Any tags assigned to the network ACL.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcId** *(string) --*

        The ID of the VPC for the network ACL.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the network ACL.
    """


_ClientCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateNetworkInterfaceIpv6AddressesTypeDef(
    _ClientCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterface` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfacePermissionResponseInterfacePermission` `PermissionState`

    Information about the state of the permission.

    - **State** *(string) --*

      The state of the permission.

    - **StatusMessage** *(string) --*

      A status message, if applicable.
    """


_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": str,
        "PermissionState": ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef,
    },
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfacePermissionResponse` `InterfacePermission`

    Information about the permission for the network interface.

    - **NetworkInterfacePermissionId** *(string) --*

      The ID of the network interface permission.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **AwsAccountId** *(string) --*

      The AWS account ID.

    - **AwsService** *(string) --*

      The AWS service.

    - **Permission** *(string) --*

      The type of permission.

    - **PermissionState** *(dict) --*

      Information about the state of the permission.

      - **State** *(string) --*

        The state of the permission.

      - **StatusMessage** *(string) --*

        A status message, if applicable.
    """


_ClientCreateNetworkInterfacePermissionResponseTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseTypeDef",
    {
        "InterfacePermission": ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef
    },
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfacePermission` `Response`

    Contains the output of CreateNetworkInterfacePermission.

    - **InterfacePermission** *(dict) --*

      Information about the permission for the network interface.

      - **NetworkInterfacePermissionId** *(string) --*

        The ID of the network interface permission.

      - **NetworkInterfaceId** *(string) --*

        The ID of the network interface.

      - **AwsAccountId** *(string) --*

        The AWS account ID.

      - **AwsService** *(string) --*

        The AWS service.

      - **Permission** *(string) --*

        The type of permission.

      - **PermissionState** *(dict) --*

        Information about the state of the permission.

        - **State** *(string) --*

          The state of the permission.

        - **StatusMessage** *(string) --*

          A status message, if applicable.
    """


_ClientCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _ClientCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterface` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one IPv4
      address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `Association`

    The association information for an Elastic IP address (IPv4) associated with the network
    interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The timestamp indicating when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The device index of the network interface attachment on the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **Status** *(string) --*

      The attachment state.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `Ipv6Addresses`

    Describes an IPv6 address associated with a network interface.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddresses` `Association`

    The association information for an Elastic IP address (IPv4) associated with the
    network interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef",
    {
        "Association": ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `PrivateIpAddresses`

    Describes the private IPv4 address of a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the
      network interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IPv4 address of the network
      interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponseNetworkInterface` `TagSet`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef",
    {
        "Association": ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef,
        "Attachment": ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef
        ],
        "InterfaceType": str,
        "Ipv6Addresses": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "TagSet": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterfaceResponse` `NetworkInterface`

    Information about the network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The device index of the network interface attachment on the instance.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **InstanceOwnerId** *(string) --*

        The AWS account ID of the owner of the instance.

      - **Status** *(string) --*

        The attachment state.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **Description** *(string) --*

      A description.

    - **Groups** *(list) --*

      Any security groups for the network interface.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address associated with a network interface.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The AWS account ID of the owner of the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      The private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes the private IPv4 address of a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the
          network interface.

          - **AllocationId** *(string) --*

            The allocation ID.

          - **AssociationId** *(string) --*

            The association ID.

          - **IpOwnerId** *(string) --*

            The ID of the Elastic IP address owner.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The address of the Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IPv4 address of the network
          interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address.

    - **RequesterId** *(string) --*

      The ID of the entity that launched the instance on your behalf (for example, AWS Management
      Console or Auto Scaling).

    - **RequesterManaged** *(boolean) --*

      Indicates whether the network interface is being managed by AWS.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether traffic to or from the instance is validated.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **TagSet** *(list) --*

      Any tags assigned to the network interface.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientCreateNetworkInterfaceResponseTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseTypeDef",
    {"NetworkInterface": ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef},
    total=False,
)


class ClientCreateNetworkInterfaceResponseTypeDef(
    _ClientCreateNetworkInterfaceResponseTypeDef
):
    """
    Type definition for `ClientCreateNetworkInterface` `Response`

    Contains the output of CreateNetworkInterface.

    - **NetworkInterface** *(dict) --*

      Information about the network interface.

      - **Association** *(dict) --*

        The association information for an Elastic IP address (IPv4) associated with the network
        interface.

        - **AllocationId** *(string) --*

          The allocation ID.

        - **AssociationId** *(string) --*

          The association ID.

        - **IpOwnerId** *(string) --*

          The ID of the Elastic IP address owner.

        - **PublicDnsName** *(string) --*

          The public DNS name.

        - **PublicIp** *(string) --*

          The address of the Elastic IP address bound to the network interface.

      - **Attachment** *(dict) --*

        The network interface attachment.

        - **AttachTime** *(datetime) --*

          The timestamp indicating when the attachment initiated.

        - **AttachmentId** *(string) --*

          The ID of the network interface attachment.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **DeviceIndex** *(integer) --*

          The device index of the network interface attachment on the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceOwnerId** *(string) --*

          The AWS account ID of the owner of the instance.

        - **Status** *(string) --*

          The attachment state.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

      - **Description** *(string) --*

        A description.

      - **Groups** *(list) --*

        Any security groups for the network interface.

        - *(dict) --*

          Describes a security group.

          - **GroupName** *(string) --*

            The name of the security group.

          - **GroupId** *(string) --*

            The ID of the security group.

      - **InterfaceType** *(string) --*

        The type of network interface.

      - **Ipv6Addresses** *(list) --*

        The IPv6 addresses associated with the network interface.

        - *(dict) --*

          Describes an IPv6 address associated with a network interface.

          - **Ipv6Address** *(string) --*

            The IPv6 address.

      - **MacAddress** *(string) --*

        The MAC address.

      - **NetworkInterfaceId** *(string) --*

        The ID of the network interface.

      - **OwnerId** *(string) --*

        The AWS account ID of the owner of the network interface.

      - **PrivateDnsName** *(string) --*

        The private DNS name.

      - **PrivateIpAddress** *(string) --*

        The IPv4 address of the network interface within the subnet.

      - **PrivateIpAddresses** *(list) --*

        The private IPv4 addresses associated with the network interface.

        - *(dict) --*

          Describes the private IPv4 address of a network interface.

          - **Association** *(dict) --*

            The association information for an Elastic IP address (IPv4) associated with the
            network interface.

            - **AllocationId** *(string) --*

              The allocation ID.

            - **AssociationId** *(string) --*

              The association ID.

            - **IpOwnerId** *(string) --*

              The ID of the Elastic IP address owner.

            - **PublicDnsName** *(string) --*

              The public DNS name.

            - **PublicIp** *(string) --*

              The address of the Elastic IP address bound to the network interface.

          - **Primary** *(boolean) --*

            Indicates whether this IPv4 address is the primary private IPv4 address of the network
            interface.

          - **PrivateDnsName** *(string) --*

            The private DNS name.

          - **PrivateIpAddress** *(string) --*

            The private IPv4 address.

      - **RequesterId** *(string) --*

        The ID of the entity that launched the instance on your behalf (for example, AWS Management
        Console or Auto Scaling).

      - **RequesterManaged** *(boolean) --*

        Indicates whether the network interface is being managed by AWS.

      - **SourceDestCheck** *(boolean) --*

        Indicates whether traffic to or from the instance is validated.

      - **Status** *(string) --*

        The status of the network interface.

      - **SubnetId** *(string) --*

        The ID of the subnet.

      - **TagSet** *(list) --*

        Any tags assigned to the network interface.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcId** *(string) --*

        The ID of the VPC.
    """


_ClientCreateReservedInstancesListingPriceSchedulesTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingPriceSchedulesTypeDef",
    {"CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCreateReservedInstancesListingPriceSchedulesTypeDef(
    _ClientCreateReservedInstancesListingPriceSchedulesTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListing` `PriceSchedules`

    Describes the price for a Reserved Instance.

    - **CurrencyCode** *(string) --*

      The currency for transacting the Reserved Instance resale. At this time, the only supported
      currency is ``USD`` .

    - **Price** *(float) --*

      The fixed price for the term.

    - **Term** *(integer) --*

      The number of months remaining in the reservation. For example, 2 is the second to the last
      month before the capacity reservation expires.
    """


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": str},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListingResponseReservedInstancesListings` `InstanceCounts`

    Describes a Reserved Instance listing state.

    - **InstanceCount** *(integer) --*

      The number of listed Reserved Instances in the state specified by the ``state`` .

    - **State** *(string) --*

      The states of the listed Reserved Instances.
    """


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListingResponseReservedInstancesListings` `PriceSchedules`

    Describes the price for a Reserved Instance.

    - **Active** *(boolean) --*

      The current price schedule, as determined by the term remaining for the Reserved
      Instance in the listing.

      A specific price schedule is always in effect, but only one price schedule can be
      active at any time. Take, for example, a Reserved Instance listing that has five
      months remaining in its term. When you specify price schedules for five months and
      two months, this means that schedule 1, covering the first three months of the
      remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
      the last two months of the term, will be active for months 2 and 1.

    - **CurrencyCode** *(string) --*

      The currency for transacting the Reserved Instance resale. At this time, the only
      supported currency is ``USD`` .

    - **Price** *(float) --*

      The fixed price for the term.

    - **Term** *(integer) --*

      The number of months remaining in the reservation. For example, 2 is the second to
      the last month before the capacity reservation expires.
    """


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListingResponseReservedInstancesListings` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": str,
        "StatusMessage": str,
        "Tags": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListingResponse` `ReservedInstancesListings`

    Describes a Reserved Instance listing.

    - **ClientToken** *(string) --*

      A unique, case-sensitive key supplied by the client to ensure that the request is
      idempotent. For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **CreateDate** *(datetime) --*

      The time the listing was created.

    - **InstanceCounts** *(list) --*

      The number of instances in this state.

      - *(dict) --*

        Describes a Reserved Instance listing state.

        - **InstanceCount** *(integer) --*

          The number of listed Reserved Instances in the state specified by the ``state`` .

        - **State** *(string) --*

          The states of the listed Reserved Instances.

    - **PriceSchedules** *(list) --*

      The price of the Reserved Instance listing.

      - *(dict) --*

        Describes the price for a Reserved Instance.

        - **Active** *(boolean) --*

          The current price schedule, as determined by the term remaining for the Reserved
          Instance in the listing.

          A specific price schedule is always in effect, but only one price schedule can be
          active at any time. Take, for example, a Reserved Instance listing that has five
          months remaining in its term. When you specify price schedules for five months and
          two months, this means that schedule 1, covering the first three months of the
          remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
          the last two months of the term, will be active for months 2 and 1.

        - **CurrencyCode** *(string) --*

          The currency for transacting the Reserved Instance resale. At this time, the only
          supported currency is ``USD`` .

        - **Price** *(float) --*

          The fixed price for the term.

        - **Term** *(integer) --*

          The number of months remaining in the reservation. For example, 2 is the second to
          the last month before the capacity reservation expires.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.

    - **ReservedInstancesListingId** *(string) --*

      The ID of the Reserved Instance listing.

    - **Status** *(string) --*

      The status of the Reserved Instance listing.

    - **StatusMessage** *(string) --*

      The reason for the current status of the Reserved Instance listing. The response can be
      blank.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **UpdateDate** *(datetime) --*

      The last modified timestamp of the listing.
    """


_ClientCreateReservedInstancesListingResponseTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientCreateReservedInstancesListingResponseTypeDef(
    _ClientCreateReservedInstancesListingResponseTypeDef
):
    """
    Type definition for `ClientCreateReservedInstancesListing` `Response`

    Contains the output of CreateReservedInstancesListing.

    - **ReservedInstancesListings** *(list) --*

      Information about the Standard Reserved Instance listing.

      - *(dict) --*

        Describes a Reserved Instance listing.

        - **ClientToken** *(string) --*

          A unique, case-sensitive key supplied by the client to ensure that the request is
          idempotent. For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **CreateDate** *(datetime) --*

          The time the listing was created.

        - **InstanceCounts** *(list) --*

          The number of instances in this state.

          - *(dict) --*

            Describes a Reserved Instance listing state.

            - **InstanceCount** *(integer) --*

              The number of listed Reserved Instances in the state specified by the ``state`` .

            - **State** *(string) --*

              The states of the listed Reserved Instances.

        - **PriceSchedules** *(list) --*

          The price of the Reserved Instance listing.

          - *(dict) --*

            Describes the price for a Reserved Instance.

            - **Active** *(boolean) --*

              The current price schedule, as determined by the term remaining for the Reserved
              Instance in the listing.

              A specific price schedule is always in effect, but only one price schedule can be
              active at any time. Take, for example, a Reserved Instance listing that has five
              months remaining in its term. When you specify price schedules for five months and
              two months, this means that schedule 1, covering the first three months of the
              remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
              the last two months of the term, will be active for months 2 and 1.

            - **CurrencyCode** *(string) --*

              The currency for transacting the Reserved Instance resale. At this time, the only
              supported currency is ``USD`` .

            - **Price** *(float) --*

              The fixed price for the term.

            - **Term** *(integer) --*

              The number of months remaining in the reservation. For example, 2 is the second to
              the last month before the capacity reservation expires.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

        - **ReservedInstancesListingId** *(string) --*

          The ID of the Reserved Instance listing.

        - **Status** *(string) --*

          The status of the Reserved Instance listing.

        - **StatusMessage** *(string) --*

          The reason for the current status of the Reserved Instance listing. The response can be
          blank.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **UpdateDate** *(datetime) --*

          The last modified timestamp of the listing.
    """


_ClientCreateRouteResponseTypeDef = TypedDict(
    "_ClientCreateRouteResponseTypeDef", {"Return": bool}, total=False
)


class ClientCreateRouteResponseTypeDef(_ClientCreateRouteResponseTypeDef):
    """
    Type definition for `ClientCreateRoute` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientCreateRouteTableResponseRouteTableAssociationsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableAssociationsTypeDef",
    {
        "Main": bool,
        "RouteTableAssociationId": str,
        "RouteTableId": str,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateRouteTableResponseRouteTableAssociationsTypeDef(
    _ClientCreateRouteTableResponseRouteTableAssociationsTypeDef
):
    """
    Type definition for `ClientCreateRouteTableResponseRouteTable` `Associations`

    Describes an association between a route table and a subnet.

    - **Main** *(boolean) --*

      Indicates whether this is the main route table.

    - **RouteTableAssociationId** *(string) --*

      The ID of the association between a route table and a subnet.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **SubnetId** *(string) --*

      The ID of the subnet. A subnet ID is not returned for an implicit association.
    """


_ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef(
    _ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef
):
    """
    Type definition for `ClientCreateRouteTableResponseRouteTable` `PropagatingVgws`

    Describes a virtual private gateway propagating route.

    - **GatewayId** *(string) --*

      The ID of the virtual private gateway.
    """


_ClientCreateRouteTableResponseRouteTableRoutesTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": str,
        "State": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientCreateRouteTableResponseRouteTableRoutesTypeDef(
    _ClientCreateRouteTableResponseRouteTableRoutesTypeDef
):
    """
    Type definition for `ClientCreateRouteTableResponseRouteTable` `Routes`

    Describes a route in a route table.

    - **DestinationCidrBlock** *(string) --*

      The IPv4 CIDR block used for the destination match.

    - **DestinationIpv6CidrBlock** *(string) --*

      The IPv6 CIDR block used for the destination match.

    - **DestinationPrefixListId** *(string) --*

      The prefix of the AWS service.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.

    - **GatewayId** *(string) --*

      The ID of a gateway attached to your VPC.

    - **InstanceId** *(string) --*

      The ID of a NAT instance in your VPC.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **NatGatewayId** *(string) --*

      The ID of a NAT gateway.

    - **TransitGatewayId** *(string) --*

      The ID of a transit gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **Origin** *(string) --*

      Describes how the route was created.

      * ``CreateRouteTable`` - The route was automatically created when the route table was
      created.

      * ``CreateRoute`` - The route was manually added to the route table.

      * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

    - **State** *(string) --*

      The state of the route. The ``blackhole`` state indicates that the route's target isn't
      available (for example, the specified gateway isn't attached to the VPC, or the
      specified NAT instance has been terminated).

    - **VpcPeeringConnectionId** *(string) --*

      The ID of a VPC peering connection.
    """


_ClientCreateRouteTableResponseRouteTableTagsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateRouteTableResponseRouteTableTagsTypeDef(
    _ClientCreateRouteTableResponseRouteTableTagsTypeDef
):
    """
    Type definition for `ClientCreateRouteTableResponseRouteTable` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateRouteTableResponseRouteTableTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableTypeDef",
    {
        "Associations": List[
            ClientCreateRouteTableResponseRouteTableAssociationsTypeDef
        ],
        "PropagatingVgws": List[
            ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef
        ],
        "RouteTableId": str,
        "Routes": List[ClientCreateRouteTableResponseRouteTableRoutesTypeDef],
        "Tags": List[ClientCreateRouteTableResponseRouteTableTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateRouteTableResponseRouteTableTypeDef(
    _ClientCreateRouteTableResponseRouteTableTypeDef
):
    """
    Type definition for `ClientCreateRouteTableResponse` `RouteTable`

    Information about the route table.

    - **Associations** *(list) --*

      The associations between the route table and one or more subnets.

      - *(dict) --*

        Describes an association between a route table and a subnet.

        - **Main** *(boolean) --*

          Indicates whether this is the main route table.

        - **RouteTableAssociationId** *(string) --*

          The ID of the association between a route table and a subnet.

        - **RouteTableId** *(string) --*

          The ID of the route table.

        - **SubnetId** *(string) --*

          The ID of the subnet. A subnet ID is not returned for an implicit association.

    - **PropagatingVgws** *(list) --*

      Any virtual private gateway (VGW) propagating routes.

      - *(dict) --*

        Describes a virtual private gateway propagating route.

        - **GatewayId** *(string) --*

          The ID of the virtual private gateway.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **Routes** *(list) --*

      The routes in the route table.

      - *(dict) --*

        Describes a route in a route table.

        - **DestinationCidrBlock** *(string) --*

          The IPv4 CIDR block used for the destination match.

        - **DestinationIpv6CidrBlock** *(string) --*

          The IPv6 CIDR block used for the destination match.

        - **DestinationPrefixListId** *(string) --*

          The prefix of the AWS service.

        - **EgressOnlyInternetGatewayId** *(string) --*

          The ID of the egress-only internet gateway.

        - **GatewayId** *(string) --*

          The ID of a gateway attached to your VPC.

        - **InstanceId** *(string) --*

          The ID of a NAT instance in your VPC.

        - **InstanceOwnerId** *(string) --*

          The AWS account ID of the owner of the instance.

        - **NatGatewayId** *(string) --*

          The ID of a NAT gateway.

        - **TransitGatewayId** *(string) --*

          The ID of a transit gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **Origin** *(string) --*

          Describes how the route was created.

          * ``CreateRouteTable`` - The route was automatically created when the route table was
          created.

          * ``CreateRoute`` - The route was manually added to the route table.

          * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

        - **State** *(string) --*

          The state of the route. The ``blackhole`` state indicates that the route's target isn't
          available (for example, the specified gateway isn't attached to the VPC, or the
          specified NAT instance has been terminated).

        - **VpcPeeringConnectionId** *(string) --*

          The ID of a VPC peering connection.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the route table.
    """


_ClientCreateRouteTableResponseTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseTypeDef",
    {"RouteTable": ClientCreateRouteTableResponseRouteTableTypeDef},
    total=False,
)


class ClientCreateRouteTableResponseTypeDef(_ClientCreateRouteTableResponseTypeDef):
    """
    Type definition for `ClientCreateRouteTable` `Response`

    - **RouteTable** *(dict) --*

      Information about the route table.

      - **Associations** *(list) --*

        The associations between the route table and one or more subnets.

        - *(dict) --*

          Describes an association between a route table and a subnet.

          - **Main** *(boolean) --*

            Indicates whether this is the main route table.

          - **RouteTableAssociationId** *(string) --*

            The ID of the association between a route table and a subnet.

          - **RouteTableId** *(string) --*

            The ID of the route table.

          - **SubnetId** *(string) --*

            The ID of the subnet. A subnet ID is not returned for an implicit association.

      - **PropagatingVgws** *(list) --*

        Any virtual private gateway (VGW) propagating routes.

        - *(dict) --*

          Describes a virtual private gateway propagating route.

          - **GatewayId** *(string) --*

            The ID of the virtual private gateway.

      - **RouteTableId** *(string) --*

        The ID of the route table.

      - **Routes** *(list) --*

        The routes in the route table.

        - *(dict) --*

          Describes a route in a route table.

          - **DestinationCidrBlock** *(string) --*

            The IPv4 CIDR block used for the destination match.

          - **DestinationIpv6CidrBlock** *(string) --*

            The IPv6 CIDR block used for the destination match.

          - **DestinationPrefixListId** *(string) --*

            The prefix of the AWS service.

          - **EgressOnlyInternetGatewayId** *(string) --*

            The ID of the egress-only internet gateway.

          - **GatewayId** *(string) --*

            The ID of a gateway attached to your VPC.

          - **InstanceId** *(string) --*

            The ID of a NAT instance in your VPC.

          - **InstanceOwnerId** *(string) --*

            The AWS account ID of the owner of the instance.

          - **NatGatewayId** *(string) --*

            The ID of a NAT gateway.

          - **TransitGatewayId** *(string) --*

            The ID of a transit gateway.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **Origin** *(string) --*

            Describes how the route was created.

            * ``CreateRouteTable`` - The route was automatically created when the route table was
            created.

            * ``CreateRoute`` - The route was manually added to the route table.

            * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

          - **State** *(string) --*

            The state of the route. The ``blackhole`` state indicates that the route's target isn't
            available (for example, the specified gateway isn't attached to the VPC, or the
            specified NAT instance has been terminated).

          - **VpcPeeringConnectionId** *(string) --*

            The ID of a VPC peering connection.

      - **Tags** *(list) --*

        Any tags assigned to the route table.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the route table.
    """


_ClientCreateSecurityGroupResponseTypeDef = TypedDict(
    "_ClientCreateSecurityGroupResponseTypeDef", {"GroupId": str}, total=False
)


class ClientCreateSecurityGroupResponseTypeDef(
    _ClientCreateSecurityGroupResponseTypeDef
):
    """
    Type definition for `ClientCreateSecurityGroup` `Response`

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientCreateSnapshotResponseTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSnapshotResponseTagsTypeDef(_ClientCreateSnapshotResponseTagsTypeDef):
    """
    Type definition for `ClientCreateSnapshotResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSnapshotResponseTypeDef = TypedDict(
    "_ClientCreateSnapshotResponseTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": str,
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[ClientCreateSnapshotResponseTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotResponseTypeDef(_ClientCreateSnapshotResponseTypeDef):
    """
    Type definition for `ClientCreateSnapshot` `Response`

    Describes a snapshot.

    - **DataEncryptionKeyId** *(string) --*

      The data encryption key identifier for the snapshot. This value is a unique identifier that
      corresponds to the data encryption key that was used to encrypt the original volume or
      snapshot copy. Because data encryption keys are inherited by volumes created from snapshots,
      and vice versa, if snapshots share the same data encryption key identifier, then they belong
      to the same volume/snapshot lineage. This parameter is only returned by  DescribeSnapshots .

    - **Description** *(string) --*

      The description for the snapshot.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer master
      key (CMK) that was used to protect the volume encryption key for the parent volume.

    - **OwnerId** *(string) --*

      The AWS account ID of the EBS snapshot owner.

    - **Progress** *(string) --*

      The progress of the snapshot, as a percentage.

    - **SnapshotId** *(string) --*

      The ID of the snapshot. Each snapshot receives a unique identifier when it is created.

    - **StartTime** *(datetime) --*

      The time stamp when the snapshot was initiated.

    - **State** *(string) --*

      The snapshot state.

    - **StateMessage** *(string) --*

      Encrypted Amazon EBS snapshots are copied asynchronously. If a snapshot copy operation fails
      (for example, if the proper AWS Key Management Service (AWS KMS) permissions are not
      obtained) this field displays error state details to help you diagnose why the error
      occurred. This parameter is only returned by  DescribeSnapshots .

    - **VolumeId** *(string) --*

      The ID of the volume that was used to create the snapshot. Snapshots created by the
      CopySnapshot action have an arbitrary volume ID that should not be used for any purpose.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **OwnerAlias** *(string) --*

      Value from an Amazon-maintained list (``amazon`` | ``self`` | ``all`` | ``aws-marketplace`` |
      ``microsoft`` ) of snapshot owners. Not to be confused with the user-configured AWS account
      alias, which is set from the IAM console.

    - **Tags** *(list) --*

      Any tags assigned to the snapshot.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateSnapshotTagSpecificationsTagsTypeDef(
    _ClientCreateSnapshotTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateSnapshotTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotTagSpecificationsTypeDef(
    _ClientCreateSnapshotTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateSnapshot` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSnapshotsInstanceSpecificationTypeDef = TypedDict(
    "_ClientCreateSnapshotsInstanceSpecificationTypeDef",
    {"InstanceId": str, "ExcludeBootVolume": bool},
    total=False,
)


class ClientCreateSnapshotsInstanceSpecificationTypeDef(
    _ClientCreateSnapshotsInstanceSpecificationTypeDef
):
    """
    Type definition for `ClientCreateSnapshots` `InstanceSpecification`

    The instance to specify which volumes should be included in the snapshots.

    - **InstanceId** *(string) --*

      The instance to specify which volumes should be snapshotted.

    - **ExcludeBootVolume** *(boolean) --*

      Excludes the root volume from being snapshotted.
    """


_ClientCreateSnapshotsResponseSnapshotsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseSnapshotsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateSnapshotsResponseSnapshotsTagsTypeDef(
    _ClientCreateSnapshotsResponseSnapshotsTagsTypeDef
):
    """
    Type definition for `ClientCreateSnapshotsResponseSnapshots` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateSnapshotsResponseSnapshotsTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseSnapshotsTypeDef",
    {
        "Description": str,
        "Tags": List[ClientCreateSnapshotsResponseSnapshotsTagsTypeDef],
        "Encrypted": bool,
        "VolumeId": str,
        "State": str,
        "VolumeSize": int,
        "StartTime": datetime,
        "Progress": str,
        "OwnerId": str,
        "SnapshotId": str,
    },
    total=False,
)


class ClientCreateSnapshotsResponseSnapshotsTypeDef(
    _ClientCreateSnapshotsResponseSnapshotsTypeDef
):
    """
    Type definition for `ClientCreateSnapshotsResponse` `Snapshots`

    Information about a snapshot.

    - **Description** *(string) --*

      Description specified by the CreateSnapshotRequest that has been applied to all snapshots.

    - **Tags** *(list) --*

      Tags associated with this snapshot.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **VolumeId** *(string) --*

      Source volume from which this snapshot was created.

    - **State** *(string) --*

      Current state of the snapshot.

    - **VolumeSize** *(integer) --*

      Size of the volume from which this snapshot was created.

    - **StartTime** *(datetime) --*

      Time this snapshot was started. This is the same for all snapshots initiated by the same
      request.

    - **Progress** *(string) --*

      Progress this snapshot has made towards completing.

    - **OwnerId** *(string) --*

      Account id used when creating this snapshot.

    - **SnapshotId** *(string) --*

      Snapshot id that can be used to describe this snapshot.
    """


_ClientCreateSnapshotsResponseTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseTypeDef",
    {"Snapshots": List[ClientCreateSnapshotsResponseSnapshotsTypeDef]},
    total=False,
)


class ClientCreateSnapshotsResponseTypeDef(_ClientCreateSnapshotsResponseTypeDef):
    """
    Type definition for `ClientCreateSnapshots` `Response`

    - **Snapshots** *(list) --*

      List of snapshots.

      - *(dict) --*

        Information about a snapshot.

        - **Description** *(string) --*

          Description specified by the CreateSnapshotRequest that has been applied to all snapshots.

        - **Tags** *(list) --*

          Tags associated with this snapshot.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Encrypted** *(boolean) --*

          Indicates whether the snapshot is encrypted.

        - **VolumeId** *(string) --*

          Source volume from which this snapshot was created.

        - **State** *(string) --*

          Current state of the snapshot.

        - **VolumeSize** *(integer) --*

          Size of the volume from which this snapshot was created.

        - **StartTime** *(datetime) --*

          Time this snapshot was started. This is the same for all snapshots initiated by the same
          request.

        - **Progress** *(string) --*

          Progress this snapshot has made towards completing.

        - **OwnerId** *(string) --*

          Account id used when creating this snapshot.

        - **SnapshotId** *(string) --*

          Snapshot id that can be used to describe this snapshot.
    """


_ClientCreateSnapshotsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateSnapshotsTagSpecificationsTagsTypeDef(
    _ClientCreateSnapshotsTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateSnapshotsTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSnapshotsTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateSnapshotsTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateSnapshotsTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotsTagSpecificationsTypeDef(
    _ClientCreateSnapshotsTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateSnapshots` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef
):
    """
    Type definition for `ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscription` `Fault`

    The fault codes for the Spot Instance request, if any.

    - **Code** *(string) --*

      The reason code for the Spot Instance state change.

    - **Message** *(string) --*

      The message for the Spot Instance state change.
    """


_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    {
        "Bucket": str,
        "Fault": ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef,
        "OwnerId": str,
        "Prefix": str,
        "State": str,
    },
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
):
    """
    Type definition for `ClientCreateSpotDatafeedSubscriptionResponse` `SpotDatafeedSubscription`

    The Spot Instance data feed subscription.

    - **Bucket** *(string) --*

      The Amazon S3 bucket where the Spot Instance data feed is located.

    - **Fault** *(dict) --*

      The fault codes for the Spot Instance request, if any.

      - **Code** *(string) --*

        The reason code for the Spot Instance state change.

      - **Message** *(string) --*

        The message for the Spot Instance state change.

    - **OwnerId** *(string) --*

      The AWS account ID of the account.

    - **Prefix** *(string) --*

      The prefix that is prepended to data feed files.

    - **State** *(string) --*

      The state of the Spot Instance data feed subscription.
    """


_ClientCreateSpotDatafeedSubscriptionResponseTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseTypeDef",
    {
        "SpotDatafeedSubscription": ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
    },
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseTypeDef
):
    """
    Type definition for `ClientCreateSpotDatafeedSubscription` `Response`

    Contains the output of CreateSpotDatafeedSubscription.

    - **SpotDatafeedSubscription** *(dict) --*

      The Spot Instance data feed subscription.

      - **Bucket** *(string) --*

        The Amazon S3 bucket where the Spot Instance data feed is located.

      - **Fault** *(dict) --*

        The fault codes for the Spot Instance request, if any.

        - **Code** *(string) --*

          The reason code for the Spot Instance state change.

        - **Message** *(string) --*

          The message for the Spot Instance state change.

      - **OwnerId** *(string) --*

        The AWS account ID of the account.

      - **Prefix** *(string) --*

        The prefix that is prepended to data feed files.

      - **State** *(string) --*

        The state of the Spot Instance data feed subscription.
    """


_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateSubnetResponseSubnet` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a subnet.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateSubnetResponseSubnetTagsTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateSubnetResponseSubnetTagsTypeDef(
    _ClientCreateSubnetResponseSubnetTagsTypeDef
):
    """
    Type definition for `ClientCreateSubnetResponseSubnet` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateSubnetResponseSubnetTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientCreateSubnetResponseSubnetTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientCreateSubnetResponseSubnetTypeDef(_ClientCreateSubnetResponseSubnetTypeDef):
    """
    Type definition for `ClientCreateSubnetResponse` `Subnet`

    Information about the subnet.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the subnet.

    - **AvailabilityZoneId** *(string) --*

      The AZ ID of the subnet.

    - **AvailableIpAddressCount** *(integer) --*

      The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
      stopped instances are considered unavailable.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block assigned to the subnet.

    - **DefaultForAz** *(boolean) --*

      Indicates whether this is the default subnet for the Availability Zone.

    - **MapPublicIpOnLaunch** *(boolean) --*

      Indicates whether instances launched in this subnet receive a public IPv4 address.

    - **State** *(string) --*

      The current state of the subnet.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC the subnet is in.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the subnet.

    - **AssignIpv6AddressOnCreation** *(boolean) --*

      Indicates whether a network interface created in this subnet (including a network interface
      created by  RunInstances ) receives an IPv6 address.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the subnet.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a subnet.

        - **AssociationId** *(string) --*

          The association ID for the CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of a CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the subnet.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **SubnetArn** *(string) --*

      The Amazon Resource Name (ARN) of the subnet.
    """


_ClientCreateSubnetResponseTypeDef = TypedDict(
    "_ClientCreateSubnetResponseTypeDef",
    {"Subnet": ClientCreateSubnetResponseSubnetTypeDef},
    total=False,
)


class ClientCreateSubnetResponseTypeDef(_ClientCreateSubnetResponseTypeDef):
    """
    Type definition for `ClientCreateSubnet` `Response`

    - **Subnet** *(dict) --*

      Information about the subnet.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.

      - **AvailabilityZoneId** *(string) --*

        The AZ ID of the subnet.

      - **AvailableIpAddressCount** *(integer) --*

        The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
        stopped instances are considered unavailable.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block assigned to the subnet.

      - **DefaultForAz** *(boolean) --*

        Indicates whether this is the default subnet for the Availability Zone.

      - **MapPublicIpOnLaunch** *(boolean) --*

        Indicates whether instances launched in this subnet receive a public IPv4 address.

      - **State** *(string) --*

        The current state of the subnet.

      - **SubnetId** *(string) --*

        The ID of the subnet.

      - **VpcId** *(string) --*

        The ID of the VPC the subnet is in.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the subnet.

      - **AssignIpv6AddressOnCreation** *(boolean) --*

        Indicates whether a network interface created in this subnet (including a network interface
        created by  RunInstances ) receives an IPv6 address.

      - **Ipv6CidrBlockAssociationSet** *(list) --*

        Information about the IPv6 CIDR blocks associated with the subnet.

        - *(dict) --*

          Describes an IPv6 CIDR block associated with a subnet.

          - **AssociationId** *(string) --*

            The association ID for the CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

          - **Ipv6CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of a CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **Tags** *(list) --*

        Any tags assigned to the subnet.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **SubnetArn** *(string) --*

        The Amazon Resource Name (ARN) of the subnet.
    """


_ClientCreateTagsTagsTypeDef = TypedDict(
    "_ClientCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateTagsTagsTypeDef(_ClientCreateTagsTagsTypeDef):
    """
    Type definition for `ClientCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilter` `EgressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilter` `IngressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilter` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[
            ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterResponse` `TrafficMirrorFilter`

    Information about the Traffic Mirror filter.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **IngressFilterRules** *(list) --*

      Information about the ingress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **EgressFilterRules** *(list) --*

      Information about the egress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **NetworkServices** *(list) --*

      The network service traffic that is associated with the Traffic Mirror filter.

      - *(string) --*

    - **Description** *(string) --*

      The description of the Traffic Mirror filter.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror filter.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTrafficMirrorFilterResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTypeDef",
    {
        "TrafficMirrorFilter": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilter` `Response`

    - **TrafficMirrorFilter** *(dict) --*

      Information about the Traffic Mirror filter.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.

      - **IngressFilterRules** *(list) --*

        Information about the ingress rules that are associated with the Traffic Mirror filter.

        - *(dict) --*

          Describes the Traffic Mirror rule.

          - **TrafficMirrorFilterRuleId** *(string) --*

            The ID of the Traffic Mirror rule.

          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter that the rule is associated with.

          - **TrafficDirection** *(string) --*

            The traffic direction assigned to the Traffic Mirror rule.

          - **RuleNumber** *(integer) --*

            The rule number of the Traffic Mirror rule.

          - **RuleAction** *(string) --*

            The action assigned to the Traffic Mirror rule.

          - **Protocol** *(integer) --*

            The protocol assigned to the Traffic Mirror rule.

          - **DestinationPortRange** *(dict) --*

            The destination port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **SourcePortRange** *(dict) --*

            The source port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **DestinationCidrBlock** *(string) --*

            The destination CIDR block assigned to the Traffic Mirror rule.

          - **SourceCidrBlock** *(string) --*

            The source CIDR block assigned to the Traffic Mirror rule.

          - **Description** *(string) --*

            The description of the Traffic Mirror rule.

      - **EgressFilterRules** *(list) --*

        Information about the egress rules that are associated with the Traffic Mirror filter.

        - *(dict) --*

          Describes the Traffic Mirror rule.

          - **TrafficMirrorFilterRuleId** *(string) --*

            The ID of the Traffic Mirror rule.

          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter that the rule is associated with.

          - **TrafficDirection** *(string) --*

            The traffic direction assigned to the Traffic Mirror rule.

          - **RuleNumber** *(integer) --*

            The rule number of the Traffic Mirror rule.

          - **RuleAction** *(string) --*

            The action assigned to the Traffic Mirror rule.

          - **Protocol** *(integer) --*

            The protocol assigned to the Traffic Mirror rule.

          - **DestinationPortRange** *(dict) --*

            The destination port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **SourcePortRange** *(dict) --*

            The source port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **DestinationCidrBlock** *(string) --*

            The destination CIDR block assigned to the Traffic Mirror rule.

          - **SourceCidrBlock** *(string) --*

            The source CIDR block assigned to the Traffic Mirror rule.

          - **Description** *(string) --*

            The description of the Traffic Mirror rule.

      - **NetworkServices** *(list) --*

        The network service traffic that is associated with the Traffic Mirror filter.

        - *(string) --*

      - **Description** *(string) --*

        The description of the Traffic Mirror filter.

      - **Tags** *(list) --*

        The tags assigned to the Traffic Mirror filter.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
      For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRule` `DestinationPortRange`

    The destination port range.

    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The last port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRule` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRule` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRuleResponse` `TrafficMirrorFilterRule`

    The Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTypeDef",
    {
        "TrafficMirrorFilterRule": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRule` `Response`

    - **TrafficMirrorFilterRule** *(dict) --*

      The Traffic Mirror rule.

      - **TrafficMirrorFilterRuleId** *(string) --*

        The ID of the Traffic Mirror rule.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter that the rule is associated with.

      - **TrafficDirection** *(string) --*

        The traffic direction assigned to the Traffic Mirror rule.

      - **RuleNumber** *(integer) --*

        The rule number of the Traffic Mirror rule.

      - **RuleAction** *(string) --*

        The action assigned to the Traffic Mirror rule.

      - **Protocol** *(integer) --*

        The protocol assigned to the Traffic Mirror rule.

      - **DestinationPortRange** *(dict) --*

        The destination port range assigned to the Traffic Mirror rule.

        - **FromPort** *(integer) --*

          The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **ToPort** *(integer) --*

          The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **SourcePortRange** *(dict) --*

        The source port range assigned to the Traffic Mirror rule.

        - **FromPort** *(integer) --*

          The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **ToPort** *(integer) --*

          The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **DestinationCidrBlock** *(string) --*

        The destination CIDR block assigned to the Traffic Mirror rule.

      - **SourceCidrBlock** *(string) --*

        The source CIDR block assigned to the Traffic Mirror rule.

      - **Description** *(string) --*

        The description of the Traffic Mirror rule.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
      For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterRule` `SourcePortRange`

    The source port range.

    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The last port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilterTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorFilter` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorSessionResponseTrafficMirrorSession` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[
            ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorSessionResponse` `TrafficMirrorSession`

    Information about the Traffic Mirror session.

    - **TrafficMirrorSessionId** *(string) --*

      The ID for the Traffic Mirror session.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **NetworkInterfaceId** *(string) --*

      The ID of the Traffic Mirror session's network interface.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror session.

    - **PacketLength** *(integer) --*

      The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
      To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
      this value to 100, then the first 100 bytes that meet the filter criteria are copied to the
      target. Do not specify this parameter when you want to mirror the entire packet

    - **SessionNumber** *(integer) --*

      The session number determines the order in which sessions are evaluated when an interface
      is used by multiple sessions. The first session with a matching filter is the one that
      mirrors the packets.

      Valid values are 1-32766.

    - **VirtualNetworkId** *(integer) --*

      The virtual network ID associated with the Traffic Mirror session.

    - **Description** *(string) --*

      The description of the Traffic Mirror session.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror session.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTypeDef",
    {
        "TrafficMirrorSession": ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorSession` `Response`

    - **TrafficMirrorSession** *(dict) --*

      Information about the Traffic Mirror session.

      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.

      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.

      - **NetworkInterfaceId** *(string) --*

        The ID of the Traffic Mirror session's network interface.

      - **OwnerId** *(string) --*

        The ID of the account that owns the Traffic Mirror session.

      - **PacketLength** *(integer) --*

        The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
        To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
        this value to 100, then the first 100 bytes that meet the filter criteria are copied to the
        target. Do not specify this parameter when you want to mirror the entire packet

      - **SessionNumber** *(integer) --*

        The session number determines the order in which sessions are evaluated when an interface
        is used by multiple sessions. The first session with a matching filter is the one that
        mirrors the packets.

        Valid values are 1-32766.

      - **VirtualNetworkId** *(integer) --*

        The virtual network ID associated with the Traffic Mirror session.

      - **Description** *(string) --*

        The description of the Traffic Mirror session.

      - **Tags** *(list) --*

        The tags assigned to the Traffic Mirror session.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
      For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorSessionTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorSession` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorTargetResponseTrafficMirrorTarget` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": str,
        "Description": str,
        "OwnerId": str,
        "Tags": List[
            ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorTargetResponse` `TrafficMirrorTarget`

    Information about the Traffic Mirror target.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **NetworkInterfaceId** *(string) --*

      The network interface ID that is attached to the target.

    - **NetworkLoadBalancerArn** *(string) --*

      The Amazon Resource Name (ARN) of the Network Load Balancer.

    - **Type** *(string) --*

      The type of Traffic Mirror target.

    - **Description** *(string) --*

      Information about the Traffic Mirror target.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror target.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror target.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTrafficMirrorTargetResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTypeDef",
    {
        "TrafficMirrorTarget": ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorTarget` `Response`

    - **TrafficMirrorTarget** *(dict) --*

      Information about the Traffic Mirror target.

      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.

      - **NetworkInterfaceId** *(string) --*

        The network interface ID that is attached to the target.

      - **NetworkLoadBalancerArn** *(string) --*

        The Amazon Resource Name (ARN) of the Network Load Balancer.

      - **Type** *(string) --*

        The type of Traffic Mirror target.

      - **Description** *(string) --*

        Information about the Traffic Mirror target.

      - **OwnerId** *(string) --*

        The ID of the account that owns the Traffic Mirror target.

      - **Tags** *(list) --*

        The tags assigned to the Traffic Mirror target.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
      For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorTargetTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTrafficMirrorTarget` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": str,
        "DefaultRouteTableAssociation": str,
        "DefaultRouteTablePropagation": str,
        "VpnEcmpSupport": str,
        "DnsSupport": str,
    },
    total=False,
)


class ClientCreateTransitGatewayOptionsTypeDef(
    _ClientCreateTransitGatewayOptionsTypeDef
):
    """
    Type definition for `ClientCreateTransitGateway` `Options`

    The transit gateway options.

    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is
      64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

    - **AutoAcceptSharedAttachments** *(string) --*

      Enable or disable automatic acceptance of attachment requests. The default is ``disable`` .

    - **DefaultRouteTableAssociation** *(string) --*

      Enable or disable automatic association with the default association route table. The default
      is ``enable`` .

    - **DefaultRouteTablePropagation** *(string) --*

      Enable or disable automatic propagation of routes to the default propagation route table. The
      default is ``enable`` .

    - **VpnEcmpSupport** *(string) --*

      Enable or disable Equal Cost Multipath Protocol support.

    - **DnsSupport** *(string) --*

      Enable or disable DNS support.
    """


_ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": str,
        "DefaultRouteTableAssociation": str,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": str,
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": str,
        "DnsSupport": str,
    },
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayResponseTransitGateway` `Options`

    The transit gateway options.

    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
      is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

    - **AutoAcceptSharedAttachments** *(string) --*

      Indicates whether attachment requests are automatically accepted.

    - **DefaultRouteTableAssociation** *(string) --*

      Indicates whether resource attachments are automatically associated with the default
      association route table.

    - **AssociationDefaultRouteTableId** *(string) --*

      The ID of the default association route table.

    - **DefaultRouteTablePropagation** *(string) --*

      Indicates whether resource attachments automatically propagate routes to the default
      propagation route table.

    - **PropagationDefaultRouteTableId** *(string) --*

      The ID of the default propagation route table.

    - **VpnEcmpSupport** *(string) --*

      Indicates whether Equal Cost Multipath Protocol support is enabled.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.
    """


_ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayResponseTransitGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTransitGatewayResponseTransitGatewayTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": str,
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef,
        "Tags": List[ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayResponse` `TransitGateway`

    Information about the transit gateway.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayArn** *(string) --*

      The Amazon Resource Name (ARN) of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account ID that owns the transit gateway.

    - **Description** *(string) --*

      The description of the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The transit gateway options.

      - **AmazonSideAsn** *(integer) --*

        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
        is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

      - **AutoAcceptSharedAttachments** *(string) --*

        Indicates whether attachment requests are automatically accepted.

      - **DefaultRouteTableAssociation** *(string) --*

        Indicates whether resource attachments are automatically associated with the default
        association route table.

      - **AssociationDefaultRouteTableId** *(string) --*

        The ID of the default association route table.

      - **DefaultRouteTablePropagation** *(string) --*

        Indicates whether resource attachments automatically propagate routes to the default
        propagation route table.

      - **PropagationDefaultRouteTableId** *(string) --*

        The ID of the default propagation route table.

      - **VpnEcmpSupport** *(string) --*

        Indicates whether Equal Cost Multipath Protocol support is enabled.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

    - **Tags** *(list) --*

      The tags for the transit gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTransitGatewayResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTypeDef",
    {"TransitGateway": ClientCreateTransitGatewayResponseTransitGatewayTypeDef},
    total=False,
)


class ClientCreateTransitGatewayResponseTypeDef(
    _ClientCreateTransitGatewayResponseTypeDef
):
    """
    Type definition for `ClientCreateTransitGateway` `Response`

    - **TransitGateway** *(dict) --*

      Information about the transit gateway.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **TransitGatewayArn** *(string) --*

        The Amazon Resource Name (ARN) of the transit gateway.

      - **State** *(string) --*

        The state of the transit gateway.

      - **OwnerId** *(string) --*

        The ID of the AWS account ID that owns the transit gateway.

      - **Description** *(string) --*

        The description of the transit gateway.

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The transit gateway options.

        - **AmazonSideAsn** *(integer) --*

          A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
          is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

        - **AutoAcceptSharedAttachments** *(string) --*

          Indicates whether attachment requests are automatically accepted.

        - **DefaultRouteTableAssociation** *(string) --*

          Indicates whether resource attachments are automatically associated with the default
          association route table.

        - **AssociationDefaultRouteTableId** *(string) --*

          The ID of the default association route table.

        - **DefaultRouteTablePropagation** *(string) --*

          Indicates whether resource attachments automatically propagate routes to the default
          propagation route table.

        - **PropagationDefaultRouteTableId** *(string) --*

          The ID of the default propagation route table.

        - **VpnEcmpSupport** *(string) --*

          Indicates whether Equal Cost Multipath Protocol support is enabled.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

      - **Tags** *(list) --*

        The tags for the transit gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {"ResourceId": str, "TransitGatewayAttachmentId": str, "ResourceType": str},
    total=False,
)


class ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteResponseRoute` `TransitGatewayAttachments`

    Describes a route attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceType** *(string) --*

      The resource type.
    """


_ClientCreateTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": str,
        "State": str,
    },
    total=False,
)


class ClientCreateTransitGatewayRouteResponseRouteTypeDef(
    _ClientCreateTransitGatewayRouteResponseRouteTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteResponse` `Route`

    Information about the route.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block used for destination matches.

    - **TransitGatewayAttachments** *(list) --*

      The attachments.

      - *(dict) --*

        Describes a route attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceType** *(string) --*

          The resource type.

    - **Type** *(string) --*

      The route type.

    - **State** *(string) --*

      The state of the route.
    """


_ClientCreateTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseTypeDef",
    {"Route": ClientCreateTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientCreateTransitGatewayRouteResponseTypeDef(
    _ClientCreateTransitGatewayRouteResponseTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRoute` `Response`

    - **Route** *(dict) --*

      Information about the route.

      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.

      - **TransitGatewayAttachments** *(list) --*

        The attachments.

        - *(dict) --*

          Describes a route attachment.

          - **ResourceId** *(string) --*

            The ID of the resource.

          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.

          - **ResourceType** *(string) --*

            The resource type.

      - **Type** *(string) --*

        The route type.

      - **State** *(string) --*

        The state of the route.
    """


_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTable` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": str,
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteTableResponse` `TransitGatewayRouteTable`

    Information about the transit gateway route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway route table.

    - **DefaultAssociationRouteTable** *(boolean) --*

      Indicates whether this is the default association route table for the transit gateway.

    - **DefaultPropagationRouteTable** *(boolean) --*

      Indicates whether this is the default propagation route table for the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTypeDef",
    {
        "TransitGatewayRouteTable": ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteTable` `Response`

    - **TransitGatewayRouteTable** *(dict) --*

      Information about the transit gateway route table.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **State** *(string) --*

        The state of the transit gateway route table.

      - **DefaultAssociationRouteTable** *(boolean) --*

        Indicates whether this is the default association route table for the transit gateway.

      - **DefaultPropagationRouteTable** *(boolean) --*

        Indicates whether this is the default propagation route table for the transit gateway.

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Tags** *(list) --*

        Any tags assigned to the route table.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteTableTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayRouteTable` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ClientCreateTransitGatewayTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTransitGateway` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Enable or disable DNS support. The default is ``enable`` .

    - **Ipv6Support** *(string) --*

      Enable or disable IPv6 support. The default is ``enable`` .
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachmentResponse` `TransitGatewayVpcAttachment`

    Information about the VPC attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachment` `Response`

    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the VPC attachment.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **VpcOwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **State** *(string) --*

        The state of the VPC attachment.

      - **SubnetIds** *(list) --*

        The IDs of the subnets.

        - *(string) --*

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The VPC attachment options.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

        - **Ipv6Support** *(string) --*

          Indicates whether IPv6 support is enabled.

      - **Tags** *(list) --*

        The tags for the VPC attachment.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachmentTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateTransitGatewayVpcAttachment` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateVolumeResponseAttachmentsTypeDef = TypedDict(
    "_ClientCreateVolumeResponseAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientCreateVolumeResponseAttachmentsTypeDef(
    _ClientCreateVolumeResponseAttachmentsTypeDef
):
    """
    Type definition for `ClientCreateVolumeResponse` `Attachments`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_ClientCreateVolumeResponseTagsTypeDef = TypedDict(
    "_ClientCreateVolumeResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVolumeResponseTagsTypeDef(_ClientCreateVolumeResponseTagsTypeDef):
    """
    Type definition for `ClientCreateVolumeResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateVolumeResponseTypeDef = TypedDict(
    "_ClientCreateVolumeResponseTypeDef",
    {
        "Attachments": List[ClientCreateVolumeResponseAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": str,
        "VolumeId": str,
        "Iops": int,
        "Tags": List[ClientCreateVolumeResponseTagsTypeDef],
        "VolumeType": str,
    },
    total=False,
)


class ClientCreateVolumeResponseTypeDef(_ClientCreateVolumeResponseTypeDef):
    """
    Type definition for `ClientCreateVolume` `Response`

    Describes a volume.

    - **Attachments** *(list) --*

      Information about the volume attachments.

      - *(dict) --*

        Describes volume attachment details.

        - **AttachTime** *(datetime) --*

          The time stamp when the attachment initiated.

        - **Device** *(string) --*

          The device name.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **State** *(string) --*

          The attachment state of the volume.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the EBS volume is deleted on instance termination.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the volume.

    - **CreateTime** *(datetime) --*

      The time stamp when volume creation was initiated.

    - **Encrypted** *(boolean) --*

      Indicates whether the volume is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer master
      key (CMK) that was used to protect the volume encryption key for the volume.

    - **Size** *(integer) --*

      The size of the volume, in GiBs.

    - **SnapshotId** *(string) --*

      The snapshot from which the volume was created, if applicable.

    - **State** *(string) --*

      The volume state.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For Provisioned IOPS
      SSD volumes, this represents the number of IOPS that are provisioned for the volume. For
      General Purpose SSD volumes, this represents the baseline performance of the volume and the
      rate at which the volume accumulates I/O credits for bursting. For more information, see
      `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes, in most Regions. The maximum IOPS for ``io1`` of 64,000 is guaranteed only on
      `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS.

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not used
      in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **Tags** *(list) --*

      Any tags assigned to the volume.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.

    - **VolumeType** *(string) --*

      The volume type. This can be ``gp2`` for General Purpose SSD, ``io1`` for Provisioned IOPS
      SSD, ``st1`` for Throughput Optimized HDD, ``sc1`` for Cold HDD, or ``standard`` for Magnetic
      volumes.
    """


_ClientCreateVolumeTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateVolumeTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVolumeTagSpecificationsTagsTypeDef(
    _ClientCreateVolumeTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientCreateVolumeTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateVolumeTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateVolumeTagSpecificationsTypeDef",
    {"ResourceType": str, "Tags": List[ClientCreateVolumeTagSpecificationsTagsTypeDef]},
    total=False,
)


class ClientCreateVolumeTagSpecificationsTypeDef(
    _ClientCreateVolumeTagSpecificationsTypeDef
):
    """
    Type definition for `ClientCreateVolume` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef = TypedDict(
    "_ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": str,
    },
    total=False,
)


class ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef(
    _ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointConnectionNotificationResponse` `ConnectionNotification`

    Information about the notification.

    - **ConnectionNotificationId** *(string) --*

      The ID of the notification.

    - **ServiceId** *(string) --*

      The ID of the endpoint service.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **ConnectionNotificationType** *(string) --*

      The type of notification.

    - **ConnectionNotificationArn** *(string) --*

      The ARN of the SNS topic for the notification.

    - **ConnectionEvents** *(list) --*

      The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
      and ``Reject`` .

      - *(string) --*

    - **ConnectionNotificationState** *(string) --*

      The state of the notification.
    """


_ClientCreateVpcEndpointConnectionNotificationResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointConnectionNotificationResponseTypeDef",
    {
        "ConnectionNotification": ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateVpcEndpointConnectionNotificationResponseTypeDef(
    _ClientCreateVpcEndpointConnectionNotificationResponseTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointConnectionNotification` `Response`

    - **ConnectionNotification** *(dict) --*

      Information about the notification.

      - **ConnectionNotificationId** *(string) --*

        The ID of the notification.

      - **ServiceId** *(string) --*

        The ID of the endpoint service.

      - **VpcEndpointId** *(string) --*

        The ID of the VPC endpoint.

      - **ConnectionNotificationType** *(string) --*

        The type of notification.

      - **ConnectionNotificationArn** *(string) --*

        The ARN of the SNS topic for the notification.

      - **ConnectionEvents** *(list) --*

        The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
        and ``Reject`` .

        - *(string) --*

      - **ConnectionNotificationState** *(string) --*

        The state of the notification.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
    """


_ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointResponseVpcEndpoint` `DnsEntries`

    Describes a DNS entry.

    - **DnsName** *(string) --*

      The DNS name.

    - **HostedZoneId** *(string) --*

      The ID of the private hosted zone.
    """


_ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointResponseVpcEndpoint` `Groups`

    Describes a security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group.
    """


_ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointResponseVpcEndpoint` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpcEndpointResponseVpcEndpointTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": str,
        "VpcId": str,
        "ServiceName": str,
        "State": str,
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef],
        "CreationTimestamp": datetime,
        "Tags": List[ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointResponse` `VpcEndpoint`

    Information about the endpoint.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **VpcEndpointType** *(string) --*

      The type of endpoint.

    - **VpcId** *(string) --*

      The ID of the VPC to which the endpoint is associated.

    - **ServiceName** *(string) --*

      The name of the service to which the endpoint is associated.

    - **State** *(string) --*

      The state of the VPC endpoint.

    - **PolicyDocument** *(string) --*

      The policy document associated with the endpoint, if applicable.

    - **RouteTableIds** *(list) --*

      (Gateway endpoint) One or more route tables associated with the endpoint.

      - *(string) --*

    - **SubnetIds** *(list) --*

      (Interface endpoint) One or more subnets in which the endpoint is located.

      - *(string) --*

    - **Groups** *(list) --*

      (Interface endpoint) Information about the security groups associated with the network
      interface.

      - *(dict) --*

        Describes a security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

    - **PrivateDnsEnabled** *(boolean) --*

      (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

    - **RequesterManaged** *(boolean) --*

      Indicates whether the VPC endpoint is being managed by its service.

    - **NetworkInterfaceIds** *(list) --*

      (Interface endpoint) One or more network interfaces for the endpoint.

      - *(string) --*

    - **DnsEntries** *(list) --*

      (Interface endpoint) The DNS entries for the endpoint.

      - *(dict) --*

        Describes a DNS entry.

        - **DnsName** *(string) --*

          The DNS name.

        - **HostedZoneId** *(string) --*

          The ID of the private hosted zone.

    - **CreationTimestamp** *(datetime) --*

      The date and time the VPC endpoint was created.

    - **Tags** *(list) --*

      Any tags assigned to the VPC endpoint.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC endpoint.
    """


_ClientCreateVpcEndpointResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseTypeDef",
    {
        "VpcEndpoint": ClientCreateVpcEndpointResponseVpcEndpointTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateVpcEndpointResponseTypeDef(_ClientCreateVpcEndpointResponseTypeDef):
    """
    Type definition for `ClientCreateVpcEndpoint` `Response`

    Contains the output of CreateVpcEndpoint.

    - **VpcEndpoint** *(dict) --*

      Information about the endpoint.

      - **VpcEndpointId** *(string) --*

        The ID of the VPC endpoint.

      - **VpcEndpointType** *(string) --*

        The type of endpoint.

      - **VpcId** *(string) --*

        The ID of the VPC to which the endpoint is associated.

      - **ServiceName** *(string) --*

        The name of the service to which the endpoint is associated.

      - **State** *(string) --*

        The state of the VPC endpoint.

      - **PolicyDocument** *(string) --*

        The policy document associated with the endpoint, if applicable.

      - **RouteTableIds** *(list) --*

        (Gateway endpoint) One or more route tables associated with the endpoint.

        - *(string) --*

      - **SubnetIds** *(list) --*

        (Interface endpoint) One or more subnets in which the endpoint is located.

        - *(string) --*

      - **Groups** *(list) --*

        (Interface endpoint) Information about the security groups associated with the network
        interface.

        - *(dict) --*

          Describes a security group.

          - **GroupId** *(string) --*

            The ID of the security group.

          - **GroupName** *(string) --*

            The name of the security group.

      - **PrivateDnsEnabled** *(boolean) --*

        (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

      - **RequesterManaged** *(boolean) --*

        Indicates whether the VPC endpoint is being managed by its service.

      - **NetworkInterfaceIds** *(list) --*

        (Interface endpoint) One or more network interfaces for the endpoint.

        - *(string) --*

      - **DnsEntries** *(list) --*

        (Interface endpoint) The DNS entries for the endpoint.

        - *(dict) --*

          Describes a DNS entry.

          - **DnsName** *(string) --*

            The DNS name.

          - **HostedZoneId** *(string) --*

            The ID of the private hosted zone.

      - **CreationTimestamp** *(datetime) --*

        The date and time the VPC endpoint was created.

      - **Tags** *(list) --*

        Any tags assigned to the VPC endpoint.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the VPC endpoint.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef",
    {"ServiceType": str},
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointServiceConfigurationResponseServiceConfiguration` `ServiceType`

    Describes the type of service for a VPC endpoint.

    - **ServiceType** *(string) --*

      The type of service.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointServiceConfigurationResponseServiceConfiguration` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef",
    {
        "ServiceType": List[
            ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": str,
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointServiceConfigurationResponse` `ServiceConfiguration`

    Information about the service configuration.

    - **ServiceType** *(list) --*

      The type of service.

      - *(dict) --*

        Describes the type of service for a VPC endpoint.

        - **ServiceType** *(string) --*

          The type of service.

    - **ServiceId** *(string) --*

      The ID of the service.

    - **ServiceName** *(string) --*

      The name of the service.

    - **ServiceState** *(string) --*

      The service state.

    - **AvailabilityZones** *(list) --*

      In the Availability Zones in which the service is available.

      - *(string) --*

    - **AcceptanceRequired** *(boolean) --*

      Indicates whether requests from other AWS accounts to create an endpoint to the service
      must first be accepted.

    - **ManagesVpcEndpoints** *(boolean) --*

      Indicates whether the service manages it's VPC endpoints. Management of the service VPC
      endpoints using the VPC endpoint API is restricted.

    - **NetworkLoadBalancerArns** *(list) --*

      The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

      - *(string) --*

    - **BaseEndpointDnsNames** *(list) --*

      The DNS names for the service.

      - *(string) --*

    - **PrivateDnsName** *(string) --*

      The private DNS name for the service.

    - **Tags** *(list) --*

      Any tags assigned to the service.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseTypeDef",
    {
        "ServiceConfiguration": ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseTypeDef
):
    """
    Type definition for `ClientCreateVpcEndpointServiceConfiguration` `Response`

    - **ServiceConfiguration** *(dict) --*

      Information about the service configuration.

      - **ServiceType** *(list) --*

        The type of service.

        - *(dict) --*

          Describes the type of service for a VPC endpoint.

          - **ServiceType** *(string) --*

            The type of service.

      - **ServiceId** *(string) --*

        The ID of the service.

      - **ServiceName** *(string) --*

        The name of the service.

      - **ServiceState** *(string) --*

        The service state.

      - **AvailabilityZones** *(list) --*

        In the Availability Zones in which the service is available.

        - *(string) --*

      - **AcceptanceRequired** *(boolean) --*

        Indicates whether requests from other AWS accounts to create an endpoint to the service
        must first be accepted.

      - **ManagesVpcEndpoints** *(boolean) --*

        Indicates whether the service manages it's VPC endpoints. Management of the service VPC
        endpoints using the VPC endpoint API is restricted.

      - **NetworkLoadBalancerArns** *(list) --*

        The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

        - *(string) --*

      - **BaseEndpointDnsNames** *(list) --*

        The DNS names for the service.

        - *(string) --*

      - **PrivateDnsName** *(string) --*

        The private DNS name for the service.

      - **Tags** *(list) --*

        Any tags assigned to the service.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnection` `AccepterVpcInfo`

    Information about the accepter VPC. CIDR block information is only returned when describing
    an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnection` `RequesterVpcInfo`

    Information about the requester VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnection` `Status`

    The status of the VPC peering connection.

    - **Code** *(string) --*

      The status of the VPC peering connection.

    - **Message** *(string) --*

      A message that provides more information about the status, if applicable.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponseVpcPeeringConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
        ],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnectionResponse` `VpcPeeringConnection`

    Information about the VPC peering connection.

    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing
      an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **ExpirationTime** *(datetime) --*

      The time that an unaccepted VPC peering connection will expire.

    - **RequesterVpcInfo** *(dict) --*

      Information about the requester VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **Status** *(dict) --*

      The status of the VPC peering connection.

      - **Code** *(string) --*

        The status of the VPC peering connection.

      - **Message** *(string) --*

        A message that provides more information about the status, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_ClientCreateVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseTypeDef",
    {
        "VpcPeeringConnection": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseTypeDef(
    _ClientCreateVpcPeeringConnectionResponseTypeDef
):
    """
    Type definition for `ClientCreateVpcPeeringConnection` `Response`

    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.

      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **ExpirationTime** *(datetime) --*

        The time that an unaccepted VPC peering connection will expire.

      - **RequesterVpcInfo** *(dict) --*

        Information about the requester VPC. CIDR block information is only returned when
        describing an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **Status** *(dict) --*

        The status of the VPC peering connection.

        - **Code** *(string) --*

          The status of the VPC peering connection.

        - **Message** *(string) --*

          A message that provides more information about the status, if applicable.

      - **Tags** *(list) --*

        Any tags assigned to the resource.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcPeeringConnectionId** *(string) --*

        The ID of the VPC peering connection.
    """


_ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateVpcResponseVpcCidrBlockAssociationSet` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef(
    _ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateVpcResponseVpc` `CidrBlockAssociationSet`

    Describes an IPv4 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientCreateVpcResponseVpc` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientCreateVpcResponseVpcTagsTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVpcResponseVpcTagsTypeDef(_ClientCreateVpcResponseVpcTagsTypeDef):
    """
    Type definition for `ClientCreateVpcResponseVpc` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpcResponseVpcTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": str,
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": str,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[ClientCreateVpcResponseVpcTagsTypeDef],
    },
    total=False,
)


class ClientCreateVpcResponseVpcTypeDef(_ClientCreateVpcResponseVpcTypeDef):
    """
    Type definition for `ClientCreateVpcResponse` `Vpc`

    Information about the VPC.

    - **CidrBlock** *(string) --*

      The primary IPv4 CIDR block for the VPC.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
      default options are associated with the VPC).

    - **State** *(string) --*

      The current state of the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **InstanceTenancy** *(string) --*

      The allowed tenancy of instances launched into the VPC.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociationSet** *(list) --*

      Information about the IPv4 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

        - **CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **IsDefault** *(boolean) --*

      Indicates whether the VPC is the default VPC.

    - **Tags** *(list) --*

      Any tags assigned to the VPC.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateVpcResponseTypeDef = TypedDict(
    "_ClientCreateVpcResponseTypeDef",
    {"Vpc": ClientCreateVpcResponseVpcTypeDef},
    total=False,
)


class ClientCreateVpcResponseTypeDef(_ClientCreateVpcResponseTypeDef):
    """
    Type definition for `ClientCreateVpc` `Response`

    - **Vpc** *(dict) --*

      Information about the VPC.

      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.

      - **DhcpOptionsId** *(string) --*

        The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
        default options are associated with the VPC).

      - **State** *(string) --*

        The current state of the VPC.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **OwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **InstanceTenancy** *(string) --*

        The allowed tenancy of instances launched into the VPC.

      - **Ipv6CidrBlockAssociationSet** *(list) --*

        Information about the IPv6 CIDR blocks associated with the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block associated with a VPC.

          - **AssociationId** *(string) --*

            The association ID for the IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

          - **Ipv6CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of the CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **CidrBlockAssociationSet** *(list) --*

        Information about the IPv4 CIDR blocks associated with the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block associated with a VPC.

          - **AssociationId** *(string) --*

            The association ID for the IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

          - **CidrBlockState** *(dict) --*

            Information about the state of the CIDR block.

            - **State** *(string) --*

              The state of the CIDR block.

            - **StatusMessage** *(string) --*

              A message about the status of the CIDR block, if applicable.

      - **IsDefault** *(boolean) --*

        Indicates whether the VPC is the default VPC.

      - **Tags** *(list) --*

        Any tags assigned to the VPC.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `IKEVersions`

    The IKE version that is permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase1DHGroupNumbers`

    Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase2DHGroupNumbers`

    Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IKEVersions": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionOptions` `TunnelOptions`

    The tunnel options for a VPN connection.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel. Any specified CIDR blocks must be unique
      across all VPN connections that use the same virtual private gateway.

      Constraints: A size /30 CIDR block from the ``169.254.0.0/16`` range. The following CIDR
      blocks are reserved and cannot be used:

      * ``169.254.0.0/30``

      * ``169.254.1.0/30``

      * ``169.254.2.0/30``

      * ``169.254.3.0/30``

      * ``169.254.4.0/30``

      * ``169.254.5.0/30``

      * ``169.254.169.252/30``

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual private
      gateway and customer gateway.

      Constraints: Allowed characters are alphanumeric characters, periods (.), and underscores
      (_). Must be between 8 and 64 characters in length and cannot start with zero (0).

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

      Constraints: A value between 900 and 28,800.

      Default: ``28800``

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

      Constraints: A value between 900 and 3,600. The value must be less than the value for
      ``Phase1LifetimeSeconds`` .

      Default: ``3600``

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the AWS side
      of the VPN connection performs an IKE rekey. The exact time of the rekey is randomly
      selected based on the value for ``RekeyFuzzPercentage`` .

      Constraints: A value between 60 and half of ``Phase2LifetimeSeconds`` .

      Default: ``540``

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window (determined by ``RekeyMarginTimeSeconds`` ) during which
      the rekey time is randomly selected.

      Constraints: A value between 0 and 100.

      Default: ``100``

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

      Constraints: A value between 64 and 2048.

      Default: ``1024``

    - **DPDTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

      Constraints: A value between 0 and 30.

      Default: ``30``

    - **Phase1EncryptionAlgorithms** *(list) --*

      One or more encryption algorithms that are permitted for the VPN tunnel for phase 1 IKE
      negotiations.

      Valid values: ``AES128`` | ``AES256``

      - *(dict) --*

        Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      One or more encryption algorithms that are permitted for the VPN tunnel for phase 2 IKE
      negotiations.

      Valid values: ``AES128`` | ``AES256``

      - *(dict) --*

        Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      One or more integrity algorithms that are permitted for the VPN tunnel for phase 1 IKE
      negotiations.

      Valid values: ``SHA1`` | ``SHA2-256``

      - *(dict) --*

        Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      One or more integrity algorithms that are permitted for the VPN tunnel for phase 2 IKE
      negotiations.

      Valid values: ``SHA1`` | ``SHA2-256``

      - *(dict) --*

        Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 1
      IKE negotiations.

      Valid values: ``2`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23`` | ``24``

      - *(dict) --*

        Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 2
      IKE negotiations.

      Valid values: ``2`` | ``5`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23``
      | ``24``

      - *(dict) --*

        Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IKEVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      Valid values: ``ikev1`` | ``ikev2``

      - *(dict) --*

        The IKE version that is permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientCreateVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef],
    },
    total=False,
)


class ClientCreateVpnConnectionOptionsTypeDef(_ClientCreateVpnConnectionOptionsTypeDef):
    """
    Type definition for `ClientCreateVpnConnection` `Options`

    The options for the VPN connection.

    - **StaticRoutesOnly** *(boolean) --*

      Indicate whether the VPN connection uses static routes only. If you are creating a VPN
      connection for a device that does not support BGP, you must specify ``true`` . Use
      CreateVpnConnectionRoute to create a static route.

      Default: ``false``

    - **TunnelOptions** *(list) --*

      The tunnel options for the VPN connection.

      - *(dict) --*

        The tunnel options for a VPN connection.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel. Any specified CIDR blocks must be unique
          across all VPN connections that use the same virtual private gateway.

          Constraints: A size /30 CIDR block from the ``169.254.0.0/16`` range. The following CIDR
          blocks are reserved and cannot be used:

          * ``169.254.0.0/30``

          * ``169.254.1.0/30``

          * ``169.254.2.0/30``

          * ``169.254.3.0/30``

          * ``169.254.4.0/30``

          * ``169.254.5.0/30``

          * ``169.254.169.252/30``

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual private
          gateway and customer gateway.

          Constraints: Allowed characters are alphanumeric characters, periods (.), and underscores
          (_). Must be between 8 and 64 characters in length and cannot start with zero (0).

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

          Constraints: A value between 900 and 28,800.

          Default: ``28800``

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

          Constraints: A value between 900 and 3,600. The value must be less than the value for
          ``Phase1LifetimeSeconds`` .

          Default: ``3600``

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the AWS side
          of the VPN connection performs an IKE rekey. The exact time of the rekey is randomly
          selected based on the value for ``RekeyFuzzPercentage`` .

          Constraints: A value between 60 and half of ``Phase2LifetimeSeconds`` .

          Default: ``540``

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window (determined by ``RekeyMarginTimeSeconds`` ) during which
          the rekey time is randomly selected.

          Constraints: A value between 0 and 100.

          Default: ``100``

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

          Constraints: A value between 64 and 2048.

          Default: ``1024``

        - **DPDTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

          Constraints: A value between 0 and 30.

          Default: ``30``

        - **Phase1EncryptionAlgorithms** *(list) --*

          One or more encryption algorithms that are permitted for the VPN tunnel for phase 1 IKE
          negotiations.

          Valid values: ``AES128`` | ``AES256``

          - *(dict) --*

            Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          One or more encryption algorithms that are permitted for the VPN tunnel for phase 2 IKE
          negotiations.

          Valid values: ``AES128`` | ``AES256``

          - *(dict) --*

            Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          One or more integrity algorithms that are permitted for the VPN tunnel for phase 1 IKE
          negotiations.

          Valid values: ``SHA1`` | ``SHA2-256``

          - *(dict) --*

            Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          One or more integrity algorithms that are permitted for the VPN tunnel for phase 2 IKE
          negotiations.

          Valid values: ``SHA1`` | ``SHA2-256``

          - *(dict) --*

            Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 1
          IKE negotiations.

          Valid values: ``2`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23`` | ``24``

          - *(dict) --*

            Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 2
          IKE negotiations.

          Valid values: ``2`` | ``5`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23``
          | ``24``

          - *(dict) --*

            Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IKEVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          Valid values: ``ikev1`` | ``ikev2``

          - *(dict) --*

            The IKE version that is permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `IkeVersions`

    The internet key exchange (IKE) version permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1DHGroupNumbers`

    The Diffie-Hellmann group number for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    The encryption algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    The integrity algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2DHGroupNumbers`

    The Diffie-Hellmann group number for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    The encryption algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    The integrity algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnectionOptions` `TunnelOptions`

    The VPN tunnel options.

    - **OutsideIpAddress** *(string) --*

      The external IP address of the VPN tunnel.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel.

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual
      private gateway and the customer gateway.

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the
      AWS side of the VPN connection performs an IKE rekey.

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
      which the rekey time is randomly selected.

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

    - **DpdTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

    - **Phase1EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IkeVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      - *(dict) --*

        The internet key exchange (IKE) version permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnection` `Options`

    The VPN connection options.

    - **StaticRoutesOnly** *(boolean) --*

      Indicates whether the VPN connection uses static routes only. Static routes must be used
      for devices that don't support BGP.

    - **TunnelOptions** *(list) --*

      Indicates the VPN tunnel options.

      - *(dict) --*

        The VPN tunnel options.

        - **OutsideIpAddress** *(string) --*

          The external IP address of the VPN tunnel.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel.

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual
          private gateway and the customer gateway.

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the
          AWS side of the VPN connection performs an IKE rekey.

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
          which the rekey time is randomly selected.

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

        - **DpdTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

        - **Phase1EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IkeVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          - *(dict) --*

            The internet key exchange (IKE) version permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef",
    {"DestinationCidrBlock": str, "Source": str, "State": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnection` `Routes`

    Describes a static route for a VPN connection.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block associated with the local subnet of the customer data center.

    - **Source** *(string) --*

      Indicates how the routes were provided.

    - **State** *(string) --*

      The current state of the static route.
    """


_ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": str,
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponseVpnConnection` `VgwTelemetry`

    Describes telemetry for a VPN tunnel.

    - **AcceptedRouteCount** *(integer) --*

      The number of accepted routes.

    - **LastStatusChange** *(datetime) --*

      The date and time of the last change in status.

    - **OutsideIpAddress** *(string) --*

      The Internet-routable IP address of the virtual private gateway's outside interface.

    - **Status** *(string) --*

      The status of the VPN tunnel.

    - **StatusMessage** *(string) --*

      If an error occurs, a description of the error.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientCreateVpnConnectionResponseVpnConnectionTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": str,
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[
            ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionTypeDef
):
    """
    Type definition for `ClientCreateVpnConnectionResponse` `VpnConnection`

    Information about the VPN connection.

    - **CustomerGatewayConfiguration** *(string) --*

      The configuration information for the VPN connection's customer gateway (in the native XML
      format). This element is always present in the  CreateVpnConnection response; however, it's
      present in the  DescribeVpnConnections response only if the VPN connection is in the
      ``pending`` or ``available`` state.

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway at your end of the VPN connection.

    - **Category** *(string) --*

      The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
      value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

    - **State** *(string) --*

      The current state of the VPN connection.

    - **Type** *(string) --*

      The type of VPN connection.

    - **VpnConnectionId** *(string) --*

      The ID of the VPN connection.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway at the AWS side of the VPN connection.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway associated with the VPN connection.

    - **Options** *(dict) --*

      The VPN connection options.

      - **StaticRoutesOnly** *(boolean) --*

        Indicates whether the VPN connection uses static routes only. Static routes must be used
        for devices that don't support BGP.

      - **TunnelOptions** *(list) --*

        Indicates the VPN tunnel options.

        - *(dict) --*

          The VPN tunnel options.

          - **OutsideIpAddress** *(string) --*

            The external IP address of the VPN tunnel.

          - **TunnelInsideCidr** *(string) --*

            The range of inside IP addresses for the tunnel.

          - **PreSharedKey** *(string) --*

            The pre-shared key (PSK) to establish initial authentication between the virtual
            private gateway and the customer gateway.

          - **Phase1LifetimeSeconds** *(integer) --*

            The lifetime for phase 1 of the IKE negotiation, in seconds.

          - **Phase2LifetimeSeconds** *(integer) --*

            The lifetime for phase 2 of the IKE negotiation, in seconds.

          - **RekeyMarginTimeSeconds** *(integer) --*

            The margin time, in seconds, before the phase 2 lifetime expires, during which the
            AWS side of the VPN connection performs an IKE rekey.

          - **RekeyFuzzPercentage** *(integer) --*

            The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
            which the rekey time is randomly selected.

          - **ReplayWindowSize** *(integer) --*

            The number of packets in an IKE replay window.

          - **DpdTimeoutSeconds** *(integer) --*

            The number of seconds after which a DPD timeout occurs.

          - **Phase1EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the encryption algorithm.

          - **Phase2EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The encryption algorithm.

          - **Phase1IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the integrity algorithm.

          - **Phase2IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The integrity algorithm.

          - **Phase1DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 1 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **Phase2DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 2 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **IkeVersions** *(list) --*

            The IKE versions that are permitted for the VPN tunnel.

            - *(dict) --*

              The internet key exchange (IKE) version permitted for the VPN tunnel.

              - **Value** *(string) --*

                The IKE version.

    - **Routes** *(list) --*

      The static routes associated with the VPN connection.

      - *(dict) --*

        Describes a static route for a VPN connection.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block associated with the local subnet of the customer data center.

        - **Source** *(string) --*

          Indicates how the routes were provided.

        - **State** *(string) --*

          The current state of the static route.

    - **Tags** *(list) --*

      Any tags assigned to the VPN connection.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VgwTelemetry** *(list) --*

      Information about the VPN tunnel.

      - *(dict) --*

        Describes telemetry for a VPN tunnel.

        - **AcceptedRouteCount** *(integer) --*

          The number of accepted routes.

        - **LastStatusChange** *(datetime) --*

          The date and time of the last change in status.

        - **OutsideIpAddress** *(string) --*

          The Internet-routable IP address of the virtual private gateway's outside interface.

        - **Status** *(string) --*

          The status of the VPN tunnel.

        - **StatusMessage** *(string) --*

          If an error occurs, a description of the error.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientCreateVpnConnectionResponseTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseTypeDef",
    {"VpnConnection": ClientCreateVpnConnectionResponseVpnConnectionTypeDef},
    total=False,
)


class ClientCreateVpnConnectionResponseTypeDef(
    _ClientCreateVpnConnectionResponseTypeDef
):
    """
    Type definition for `ClientCreateVpnConnection` `Response`

    Contains the output of CreateVpnConnection.

    - **VpnConnection** *(dict) --*

      Information about the VPN connection.

      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.

      - **CustomerGatewayId** *(string) --*

        The ID of the customer gateway at your end of the VPN connection.

      - **Category** *(string) --*

        The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
        value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

      - **State** *(string) --*

        The current state of the VPN connection.

      - **Type** *(string) --*

        The type of VPN connection.

      - **VpnConnectionId** *(string) --*

        The ID of the VPN connection.

      - **VpnGatewayId** *(string) --*

        The ID of the virtual private gateway at the AWS side of the VPN connection.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway associated with the VPN connection.

      - **Options** *(dict) --*

        The VPN connection options.

        - **StaticRoutesOnly** *(boolean) --*

          Indicates whether the VPN connection uses static routes only. Static routes must be used
          for devices that don't support BGP.

        - **TunnelOptions** *(list) --*

          Indicates the VPN tunnel options.

          - *(dict) --*

            The VPN tunnel options.

            - **OutsideIpAddress** *(string) --*

              The external IP address of the VPN tunnel.

            - **TunnelInsideCidr** *(string) --*

              The range of inside IP addresses for the tunnel.

            - **PreSharedKey** *(string) --*

              The pre-shared key (PSK) to establish initial authentication between the virtual
              private gateway and the customer gateway.

            - **Phase1LifetimeSeconds** *(integer) --*

              The lifetime for phase 1 of the IKE negotiation, in seconds.

            - **Phase2LifetimeSeconds** *(integer) --*

              The lifetime for phase 2 of the IKE negotiation, in seconds.

            - **RekeyMarginTimeSeconds** *(integer) --*

              The margin time, in seconds, before the phase 2 lifetime expires, during which the
              AWS side of the VPN connection performs an IKE rekey.

            - **RekeyFuzzPercentage** *(integer) --*

              The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
              which the rekey time is randomly selected.

            - **ReplayWindowSize** *(integer) --*

              The number of packets in an IKE replay window.

            - **DpdTimeoutSeconds** *(integer) --*

              The number of seconds after which a DPD timeout occurs.

            - **Phase1EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the encryption algorithm.

            - **Phase2EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The encryption algorithm.

            - **Phase1IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the integrity algorithm.

            - **Phase2IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The integrity algorithm.

            - **Phase1DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 1 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **Phase2DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 2 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **IkeVersions** *(list) --*

              The IKE versions that are permitted for the VPN tunnel.

              - *(dict) --*

                The internet key exchange (IKE) version permitted for the VPN tunnel.

                - **Value** *(string) --*

                  The IKE version.

      - **Routes** *(list) --*

        The static routes associated with the VPN connection.

        - *(dict) --*

          Describes a static route for a VPN connection.

          - **DestinationCidrBlock** *(string) --*

            The CIDR block associated with the local subnet of the customer data center.

          - **Source** *(string) --*

            Indicates how the routes were provided.

          - **State** *(string) --*

            The current state of the static route.

      - **Tags** *(list) --*

        Any tags assigned to the VPN connection.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VgwTelemetry** *(list) --*

        Information about the VPN tunnel.

        - *(dict) --*

          Describes telemetry for a VPN tunnel.

          - **AcceptedRouteCount** *(integer) --*

            The number of accepted routes.

          - **LastStatusChange** *(datetime) --*

            The date and time of the last change in status.

          - **OutsideIpAddress** *(string) --*

            The Internet-routable IP address of the virtual private gateway's outside interface.

          - **Status** *(string) --*

            The status of the VPN tunnel.

          - **StatusMessage** *(string) --*

            If an error occurs, a description of the error.

          - **CertificateArn** *(string) --*

            The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef
):
    """
    Type definition for `ClientCreateVpnGatewayResponseVpnGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef
):
    """
    Type definition for `ClientCreateVpnGatewayResponseVpnGateway` `VpcAttachments`

    Describes an attachment between a virtual private gateway and a VPC.

    - **State** *(string) --*

      The current state of the attachment.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientCreateVpnGatewayResponseVpnGatewayTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayTypeDef",
    {
        "AvailabilityZone": str,
        "State": str,
        "Type": str,
        "VpcAttachments": List[
            ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef
        ],
        "VpnGatewayId": str,
        "AmazonSideAsn": int,
        "Tags": List[ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateVpnGatewayResponseVpnGatewayTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayTypeDef
):
    """
    Type definition for `ClientCreateVpnGatewayResponse` `VpnGateway`

    Information about the virtual private gateway.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the virtual private gateway was created, if applicable. This
      field may be empty or not returned.

    - **State** *(string) --*

      The current state of the virtual private gateway.

    - **Type** *(string) --*

      The type of VPN connection the virtual private gateway supports.

    - **VpcAttachments** *(list) --*

      Any VPCs attached to the virtual private gateway.

      - *(dict) --*

        Describes an attachment between a virtual private gateway and a VPC.

        - **State** *(string) --*

          The current state of the attachment.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway.

    - **AmazonSideAsn** *(integer) --*

      The private Autonomous System Number (ASN) for the Amazon side of a BGP session.

    - **Tags** *(list) --*

      Any tags assigned to the virtual private gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientCreateVpnGatewayResponseTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseTypeDef",
    {"VpnGateway": ClientCreateVpnGatewayResponseVpnGatewayTypeDef},
    total=False,
)


class ClientCreateVpnGatewayResponseTypeDef(_ClientCreateVpnGatewayResponseTypeDef):
    """
    Type definition for `ClientCreateVpnGateway` `Response`

    Contains the output of CreateVpnGateway.

    - **VpnGateway** *(dict) --*

      Information about the virtual private gateway.

      - **AvailabilityZone** *(string) --*

        The Availability Zone where the virtual private gateway was created, if applicable. This
        field may be empty or not returned.

      - **State** *(string) --*

        The current state of the virtual private gateway.

      - **Type** *(string) --*

        The type of VPN connection the virtual private gateway supports.

      - **VpcAttachments** *(list) --*

        Any VPCs attached to the virtual private gateway.

        - *(dict) --*

          Describes an attachment between a virtual private gateway and a VPC.

          - **State** *(string) --*

            The current state of the attachment.

          - **VpcId** *(string) --*

            The ID of the VPC.

      - **VpnGatewayId** *(string) --*

        The ID of the virtual private gateway.

      - **AmazonSideAsn** *(integer) --*

        The private Autonomous System Number (ASN) for the Amazon side of a BGP session.

      - **Tags** *(list) --*

        Any tags assigned to the virtual private gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientDeleteClientVpnEndpointResponseStatusTypeDef = TypedDict(
    "_ClientDeleteClientVpnEndpointResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteClientVpnEndpointResponseStatusTypeDef(
    _ClientDeleteClientVpnEndpointResponseStatusTypeDef
):
    """
    Type definition for `ClientDeleteClientVpnEndpointResponse` `Status`

    The current state of the Client VPN endpoint.

    - **Code** *(string) --*

      The state of the Client VPN endpoint. Possible states include:

      * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
      have been associated. The Client VPN endpoint cannot accept connections.

      * ``available`` - The Client VPN endpoint has been created and a target network has been
      associated. The Client VPN endpoint can accept connections.

      * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
      accept connections.

      * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
      accept connections.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint.
    """


_ClientDeleteClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteClientVpnEndpointResponseTypeDef",
    {"Status": ClientDeleteClientVpnEndpointResponseStatusTypeDef},
    total=False,
)


class ClientDeleteClientVpnEndpointResponseTypeDef(
    _ClientDeleteClientVpnEndpointResponseTypeDef
):
    """
    Type definition for `ClientDeleteClientVpnEndpoint` `Response`

    - **Status** *(dict) --*

      The current state of the Client VPN endpoint.

      - **Code** *(string) --*

        The state of the Client VPN endpoint. Possible states include:

        * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
        have been associated. The Client VPN endpoint cannot accept connections.

        * ``available`` - The Client VPN endpoint has been created and a target network has been
        associated. The Client VPN endpoint can accept connections.

        * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
        accept connections.

        * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
        accept connections.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint.
    """


_ClientDeleteClientVpnRouteResponseStatusTypeDef = TypedDict(
    "_ClientDeleteClientVpnRouteResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteClientVpnRouteResponseStatusTypeDef(
    _ClientDeleteClientVpnRouteResponseStatusTypeDef
):
    """
    Type definition for `ClientDeleteClientVpnRouteResponse` `Status`

    The current state of the route.

    - **Code** *(string) --*

      The state of the Client VPN endpoint route.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint route, if applicable.
    """


_ClientDeleteClientVpnRouteResponseTypeDef = TypedDict(
    "_ClientDeleteClientVpnRouteResponseTypeDef",
    {"Status": ClientDeleteClientVpnRouteResponseStatusTypeDef},
    total=False,
)


class ClientDeleteClientVpnRouteResponseTypeDef(
    _ClientDeleteClientVpnRouteResponseTypeDef
):
    """
    Type definition for `ClientDeleteClientVpnRoute` `Response`

    - **Status** *(dict) --*

      The current state of the route.

      - **Code** *(string) --*

        The state of the Client VPN endpoint route.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint route, if applicable.
    """


_ClientDeleteEgressOnlyInternetGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteEgressOnlyInternetGatewayResponseTypeDef",
    {"ReturnCode": bool},
    total=False,
)


class ClientDeleteEgressOnlyInternetGatewayResponseTypeDef(
    _ClientDeleteEgressOnlyInternetGatewayResponseTypeDef
):
    """
    Type definition for `ClientDeleteEgressOnlyInternetGateway` `Response`

    - **ReturnCode** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef",
    {"CurrentFleetState": str, "PreviousFleetState": str, "FleetId": str},
    total=False,
)


class ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef(
    _ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef
):
    """
    Type definition for `ClientDeleteFleetsResponse` `SuccessfulFleetDeletions`

    Describes an EC2 Fleet that was successfully deleted.

    - **CurrentFleetState** *(string) --*

      The current state of the EC2 Fleet.

    - **PreviousFleetState** *(string) --*

      The previous state of the EC2 Fleet.

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.
    """


_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef(
    _ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef
):
    """
    Type definition for `ClientDeleteFleetsResponseUnsuccessfulFleetDeletions` `Error`

    The error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The description for the error code.
    """


_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef",
    {
        "Error": ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef,
        "FleetId": str,
    },
    total=False,
)


class ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef(
    _ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef
):
    """
    Type definition for `ClientDeleteFleetsResponse` `UnsuccessfulFleetDeletions`

    Describes an EC2 Fleet that was not successfully deleted.

    - **Error** *(dict) --*

      The error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The description for the error code.

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.
    """


_ClientDeleteFleetsResponseTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseTypeDef",
    {
        "SuccessfulFleetDeletions": List[
            ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef
        ],
        "UnsuccessfulFleetDeletions": List[
            ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteFleetsResponseTypeDef(_ClientDeleteFleetsResponseTypeDef):
    """
    Type definition for `ClientDeleteFleets` `Response`

    - **SuccessfulFleetDeletions** *(list) --*

      Information about the EC2 Fleets that are successfully deleted.

      - *(dict) --*

        Describes an EC2 Fleet that was successfully deleted.

        - **CurrentFleetState** *(string) --*

          The current state of the EC2 Fleet.

        - **PreviousFleetState** *(string) --*

          The previous state of the EC2 Fleet.

        - **FleetId** *(string) --*

          The ID of the EC2 Fleet.

    - **UnsuccessfulFleetDeletions** *(list) --*

      Information about the EC2 Fleets that are not successfully deleted.

      - *(dict) --*

        Describes an EC2 Fleet that was not successfully deleted.

        - **Error** *(dict) --*

          The error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The description for the error code.

        - **FleetId** *(string) --*

          The ID of the EC2 Fleet.
    """


_ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientDeleteFlowLogsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientDeleteFlowLogsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseUnsuccessfulTypeDef",
    {"Error": ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientDeleteFlowLogsResponseUnsuccessfulTypeDef(
    _ClientDeleteFlowLogsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientDeleteFlowLogsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientDeleteFlowLogsResponseTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseTypeDef",
    {"Unsuccessful": List[ClientDeleteFlowLogsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientDeleteFlowLogsResponseTypeDef(_ClientDeleteFlowLogsResponseTypeDef):
    """
    Type definition for `ClientDeleteFlowLogs` `Response`

    - **Unsuccessful** *(list) --*

      Information about the flow logs that could not be deleted successfully.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientDeleteFpgaImageResponseTypeDef = TypedDict(
    "_ClientDeleteFpgaImageResponseTypeDef", {"Return": bool}, total=False
)


class ClientDeleteFpgaImageResponseTypeDef(_ClientDeleteFpgaImageResponseTypeDef):
    """
    Type definition for `ClientDeleteFpgaImage` `Response`

    - **Return** *(boolean) --*

      Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateResponseLaunchTemplate` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateResponse` `LaunchTemplate`

    Information about the launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **CreateTime** *(datetime) --*

      The time launch template was created.

    - **CreatedBy** *(string) --*

      The principal that created the launch template.

    - **DefaultVersionNumber** *(integer) --*

      The version number of the default version of the launch template.

    - **LatestVersionNumber** *(integer) --*

      The version number of the latest version of the launch template.

    - **Tags** *(list) --*

      The tags for the launch template.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDeleteLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientDeleteLaunchTemplateResponseTypeDef(
    _ClientDeleteLaunchTemplateResponseTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplate` `Response`

    - **LaunchTemplate** *(dict) --*

      Information about the launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template.

      - **CreateTime** *(datetime) --*

        The time launch template was created.

      - **CreatedBy** *(string) --*

        The principal that created the launch template.

      - **DefaultVersionNumber** *(integer) --*

        The version number of the default version of the launch template.

      - **LatestVersionNumber** *(integer) --*

        The version number of the latest version of the launch template.

      - **Tags** *(list) --*

        The tags for the launch template.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "VersionNumber": int},
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateVersionsResponse` `SuccessfullyDeletedLaunchTemplateVersions`

    Describes a launch template version that was successfully deleted.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **VersionNumber** *(integer) --*

      The version number of the launch template.
    """


_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersions` `ResponseError`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message, if applicable.
    """


_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "ResponseError": ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef,
    },
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateVersionsResponse` `UnsuccessfullyDeletedLaunchTemplateVersions`

    Describes a launch template version that could not be deleted.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **VersionNumber** *(integer) --*

      The version number of the launch template.

    - **ResponseError** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message, if applicable.
    """


_ClientDeleteLaunchTemplateVersionsResponseTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseTypeDef",
    {
        "SuccessfullyDeletedLaunchTemplateVersions": List[
            ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef
        ],
        "UnsuccessfullyDeletedLaunchTemplateVersions": List[
            ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseTypeDef
):
    """
    Type definition for `ClientDeleteLaunchTemplateVersions` `Response`

    - **SuccessfullyDeletedLaunchTemplateVersions** *(list) --*

      Information about the launch template versions that were successfully deleted.

      - *(dict) --*

        Describes a launch template version that was successfully deleted.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **VersionNumber** *(integer) --*

          The version number of the launch template.

    - **UnsuccessfullyDeletedLaunchTemplateVersions** *(list) --*

      Information about the launch template versions that could not be deleted.

      - *(dict) --*

        Describes a launch template version that could not be deleted.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **VersionNumber** *(integer) --*

          The version number of the launch template.

        - **ResponseError** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message, if applicable.
    """


_ClientDeleteNatGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteNatGatewayResponseTypeDef", {"NatGatewayId": str}, total=False
)


class ClientDeleteNatGatewayResponseTypeDef(_ClientDeleteNatGatewayResponseTypeDef):
    """
    Type definition for `ClientDeleteNatGateway` `Response`

    - **NatGatewayId** *(string) --*

      The ID of the NAT gateway.
    """


_ClientDeleteNetworkInterfacePermissionResponseTypeDef = TypedDict(
    "_ClientDeleteNetworkInterfacePermissionResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientDeleteNetworkInterfacePermissionResponseTypeDef(
    _ClientDeleteNetworkInterfacePermissionResponseTypeDef
):
    """
    Type definition for `ClientDeleteNetworkInterfacePermission` `Response`

    Contains the output for DeleteNetworkInterfacePermission.

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds, otherwise returns an error.
    """


_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef
):
    """
    Type definition for `ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletions` `Error`

    The error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message.
    """


_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef",
    {
        "Error": ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef,
        "ReservedInstancesId": str,
    },
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef
):
    """
    Type definition for `ClientDeleteQueuedReservedInstancesResponse` `FailedQueuedPurchaseDeletions`

    Describes a Reserved Instance whose queued purchase was not deleted.

    - **Error** *(dict) --*

      The error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.
    """


_ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef
):
    """
    Type definition for `ClientDeleteQueuedReservedInstancesResponse` `SuccessfulQueuedPurchaseDeletions`

    Describes a Reserved Instance whose queued purchase was successfully deleted.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.
    """


_ClientDeleteQueuedReservedInstancesResponseTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseTypeDef",
    {
        "SuccessfulQueuedPurchaseDeletions": List[
            ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef
        ],
        "FailedQueuedPurchaseDeletions": List[
            ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseTypeDef
):
    """
    Type definition for `ClientDeleteQueuedReservedInstances` `Response`

    - **SuccessfulQueuedPurchaseDeletions** *(list) --*

      Information about the queued purchases that were successfully deleted.

      - *(dict) --*

        Describes a Reserved Instance whose queued purchase was successfully deleted.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

    - **FailedQueuedPurchaseDeletions** *(list) --*

      Information about the queued purchases that could not be deleted.

      - *(dict) --*

        Describes a Reserved Instance whose queued purchase was not deleted.

        - **Error** *(dict) --*

          The error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.
    """


_ClientDeleteTagsTagsTypeDef = TypedDict(
    "_ClientDeleteTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDeleteTagsTagsTypeDef(_ClientDeleteTagsTagsTypeDef):
    """
    Type definition for `ClientDeleteTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientDeleteTrafficMirrorFilterResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorFilterResponseTypeDef",
    {"TrafficMirrorFilterId": str},
    total=False,
)


class ClientDeleteTrafficMirrorFilterResponseTypeDef(
    _ClientDeleteTrafficMirrorFilterResponseTypeDef
):
    """
    Type definition for `ClientDeleteTrafficMirrorFilter` `Response`

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.
    """


_ClientDeleteTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorFilterRuleResponseTypeDef",
    {"TrafficMirrorFilterRuleId": str},
    total=False,
)


class ClientDeleteTrafficMirrorFilterRuleResponseTypeDef(
    _ClientDeleteTrafficMirrorFilterRuleResponseTypeDef
):
    """
    Type definition for `ClientDeleteTrafficMirrorFilterRule` `Response`

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the deleted Traffic Mirror rule.
    """


_ClientDeleteTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorSessionResponseTypeDef",
    {"TrafficMirrorSessionId": str},
    total=False,
)


class ClientDeleteTrafficMirrorSessionResponseTypeDef(
    _ClientDeleteTrafficMirrorSessionResponseTypeDef
):
    """
    Type definition for `ClientDeleteTrafficMirrorSession` `Response`

    - **TrafficMirrorSessionId** *(string) --*

      The ID of the deleted Traffic Mirror session.
    """


_ClientDeleteTrafficMirrorTargetResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorTargetResponseTypeDef",
    {"TrafficMirrorTargetId": str},
    total=False,
)


class ClientDeleteTrafficMirrorTargetResponseTypeDef(
    _ClientDeleteTrafficMirrorTargetResponseTypeDef
):
    """
    Type definition for `ClientDeleteTrafficMirrorTarget` `Response`

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the deleted Traffic Mirror target.
    """


_ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": str,
        "DefaultRouteTableAssociation": str,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": str,
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": str,
        "DnsSupport": str,
    },
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayResponseTransitGateway` `Options`

    The transit gateway options.

    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
      is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

    - **AutoAcceptSharedAttachments** *(string) --*

      Indicates whether attachment requests are automatically accepted.

    - **DefaultRouteTableAssociation** *(string) --*

      Indicates whether resource attachments are automatically associated with the default
      association route table.

    - **AssociationDefaultRouteTableId** *(string) --*

      The ID of the default association route table.

    - **DefaultRouteTablePropagation** *(string) --*

      Indicates whether resource attachments automatically propagate routes to the default
      propagation route table.

    - **PropagationDefaultRouteTableId** *(string) --*

      The ID of the default propagation route table.

    - **VpnEcmpSupport** *(string) --*

      Indicates whether Equal Cost Multipath Protocol support is enabled.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.
    """


_ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayResponseTransitGateway` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDeleteTransitGatewayResponseTransitGatewayTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": str,
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef,
        "Tags": List[ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef],
    },
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayResponse` `TransitGateway`

    Information about the deleted transit gateway.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayArn** *(string) --*

      The Amazon Resource Name (ARN) of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account ID that owns the transit gateway.

    - **Description** *(string) --*

      The description of the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The transit gateway options.

      - **AmazonSideAsn** *(integer) --*

        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
        is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

      - **AutoAcceptSharedAttachments** *(string) --*

        Indicates whether attachment requests are automatically accepted.

      - **DefaultRouteTableAssociation** *(string) --*

        Indicates whether resource attachments are automatically associated with the default
        association route table.

      - **AssociationDefaultRouteTableId** *(string) --*

        The ID of the default association route table.

      - **DefaultRouteTablePropagation** *(string) --*

        Indicates whether resource attachments automatically propagate routes to the default
        propagation route table.

      - **PropagationDefaultRouteTableId** *(string) --*

        The ID of the default propagation route table.

      - **VpnEcmpSupport** *(string) --*

        Indicates whether Equal Cost Multipath Protocol support is enabled.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

    - **Tags** *(list) --*

      The tags for the transit gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDeleteTransitGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTypeDef",
    {"TransitGateway": ClientDeleteTransitGatewayResponseTransitGatewayTypeDef},
    total=False,
)


class ClientDeleteTransitGatewayResponseTypeDef(
    _ClientDeleteTransitGatewayResponseTypeDef
):
    """
    Type definition for `ClientDeleteTransitGateway` `Response`

    - **TransitGateway** *(dict) --*

      Information about the deleted transit gateway.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **TransitGatewayArn** *(string) --*

        The Amazon Resource Name (ARN) of the transit gateway.

      - **State** *(string) --*

        The state of the transit gateway.

      - **OwnerId** *(string) --*

        The ID of the AWS account ID that owns the transit gateway.

      - **Description** *(string) --*

        The description of the transit gateway.

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The transit gateway options.

        - **AmazonSideAsn** *(integer) --*

          A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range
          is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

        - **AutoAcceptSharedAttachments** *(string) --*

          Indicates whether attachment requests are automatically accepted.

        - **DefaultRouteTableAssociation** *(string) --*

          Indicates whether resource attachments are automatically associated with the default
          association route table.

        - **AssociationDefaultRouteTableId** *(string) --*

          The ID of the default association route table.

        - **DefaultRouteTablePropagation** *(string) --*

          Indicates whether resource attachments automatically propagate routes to the default
          propagation route table.

        - **PropagationDefaultRouteTableId** *(string) --*

          The ID of the default propagation route table.

        - **VpnEcmpSupport** *(string) --*

          Indicates whether Equal Cost Multipath Protocol support is enabled.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

      - **Tags** *(list) --*

        The tags for the transit gateway.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {"ResourceId": str, "TransitGatewayAttachmentId": str, "ResourceType": str},
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRouteResponseRoute` `TransitGatewayAttachments`

    Describes a route attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceType** *(string) --*

      The resource type.
    """


_ClientDeleteTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": str,
        "State": str,
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseRouteTypeDef(
    _ClientDeleteTransitGatewayRouteResponseRouteTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRouteResponse` `Route`

    Information about the route.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block used for destination matches.

    - **TransitGatewayAttachments** *(list) --*

      The attachments.

      - *(dict) --*

        Describes a route attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceType** *(string) --*

          The resource type.

    - **Type** *(string) --*

      The route type.

    - **State** *(string) --*

      The state of the route.
    """


_ClientDeleteTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseTypeDef",
    {"Route": ClientDeleteTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseTypeDef(
    _ClientDeleteTransitGatewayRouteResponseTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRoute` `Response`

    - **Route** *(dict) --*

      Information about the route.

      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.

      - **TransitGatewayAttachments** *(list) --*

        The attachments.

        - *(dict) --*

          Describes a route attachment.

          - **ResourceId** *(string) --*

            The ID of the resource.

          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.

          - **ResourceType** *(string) --*

            The resource type.

      - **Type** *(string) --*

        The route type.

      - **State** *(string) --*

        The state of the route.
    """


_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTable` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": str,
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRouteTableResponse` `TransitGatewayRouteTable`

    Information about the deleted transit gateway route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway route table.

    - **DefaultAssociationRouteTable** *(boolean) --*

      Indicates whether this is the default association route table for the transit gateway.

    - **DefaultPropagationRouteTable** *(boolean) --*

      Indicates whether this is the default propagation route table for the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDeleteTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTypeDef",
    {
        "TransitGatewayRouteTable": ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayRouteTable` `Response`

    - **TransitGatewayRouteTable** *(dict) --*

      Information about the deleted transit gateway route table.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **State** *(string) --*

        The state of the transit gateway route table.

      - **DefaultAssociationRouteTable** *(boolean) --*

        Indicates whether this is the default association route table for the transit gateway.

      - **DefaultPropagationRouteTable** *(boolean) --*

        Indicates whether this is the default propagation route table for the transit gateway.

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Tags** *(list) --*

        Any tags assigned to the route table.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayVpcAttachmentResponse` `TransitGatewayVpcAttachment`

    Information about the deleted VPC attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    Type definition for `ClientDeleteTransitGatewayVpcAttachment` `Response`

    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the deleted VPC attachment.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **VpcOwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **State** *(string) --*

        The state of the VPC attachment.

      - **SubnetIds** *(list) --*

        The IDs of the subnets.

        - *(string) --*

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The VPC attachment options.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

        - **Ipv6Support** *(string) --*

          Indicates whether IPv6 support is enabled.

      - **Tags** *(list) --*

        The tags for the VPC attachment.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointConnectionNotificationsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef",
    {
        "Unsuccessful": List[
            ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef
        ]
    },
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointConnectionNotifications` `Response`

    - **Unsuccessful** *(list) --*

      Information about the notifications that could not be deleted successfully.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointServiceConfigurationsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef",
    {
        "Unsuccessful": List[
            ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef
        ]
    },
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointServiceConfigurations` `Response`

    - **Unsuccessful** *(list) --*

      Information about the service configurations that were not deleted, if applicable.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientDeleteVpcEndpointsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientDeleteVpcEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseTypeDef",
    {"Unsuccessful": List[ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientDeleteVpcEndpointsResponseTypeDef(_ClientDeleteVpcEndpointsResponseTypeDef):
    """
    Type definition for `ClientDeleteVpcEndpoints` `Response`

    Contains the output of DeleteVpcEndpoints.

    - **Unsuccessful** *(list) --*

      Information about the VPC endpoints that were not successfully deleted.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientDeleteVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientDeleteVpcPeeringConnectionResponseTypeDef", {"Return": bool}, total=False
)


class ClientDeleteVpcPeeringConnectionResponseTypeDef(
    _ClientDeleteVpcPeeringConnectionResponseTypeDef
):
    """
    Type definition for `ClientDeleteVpcPeeringConnection` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDeprovisionByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientDeprovisionByoipCidrResponseByoipCidrTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class ClientDeprovisionByoipCidrResponseByoipCidrTypeDef(
    _ClientDeprovisionByoipCidrResponseByoipCidrTypeDef
):
    """
    Type definition for `ClientDeprovisionByoipCidrResponse` `ByoipCidr`

    Information about the address range.

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_ClientDeprovisionByoipCidrResponseTypeDef = TypedDict(
    "_ClientDeprovisionByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientDeprovisionByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientDeprovisionByoipCidrResponseTypeDef(
    _ClientDeprovisionByoipCidrResponseTypeDef
):
    """
    Type definition for `ClientDeprovisionByoipCidr` `Response`

    - **ByoipCidr** *(dict) --*

      Information about the address range.

      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.

      - **Description** *(string) --*

        The description of the address range.

      - **StatusMessage** *(string) --*

        Upon success, contains the ID of the address pool. Otherwise, contains an error message.

      - **State** *(string) --*

        The state of the address pool.
    """


_ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef",
    {"AttributeValue": str},
    total=False,
)


class ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef(
    _ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef
):
    """
    Type definition for `ClientDescribeAccountAttributesResponseAccountAttributes` `AttributeValues`

    Describes a value of an account attribute.

    - **AttributeValue** *(string) --*

      The value of the attribute.
    """


_ClientDescribeAccountAttributesResponseAccountAttributesTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseAccountAttributesTypeDef",
    {
        "AttributeName": str,
        "AttributeValues": List[
            ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeAccountAttributesResponseAccountAttributesTypeDef(
    _ClientDescribeAccountAttributesResponseAccountAttributesTypeDef
):
    """
    Type definition for `ClientDescribeAccountAttributesResponse` `AccountAttributes`

    Describes an account attribute.

    - **AttributeName** *(string) --*

      The name of the account attribute.

    - **AttributeValues** *(list) --*

      The values for the account attribute.

      - *(dict) --*

        Describes a value of an account attribute.

        - **AttributeValue** *(string) --*

          The value of the attribute.
    """


_ClientDescribeAccountAttributesResponseTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseTypeDef",
    {
        "AccountAttributes": List[
            ClientDescribeAccountAttributesResponseAccountAttributesTypeDef
        ]
    },
    total=False,
)


class ClientDescribeAccountAttributesResponseTypeDef(
    _ClientDescribeAccountAttributesResponseTypeDef
):
    """
    Type definition for `ClientDescribeAccountAttributes` `Response`

    - **AccountAttributes** *(list) --*

      Information about the account attributes.

      - *(dict) --*

        Describes an account attribute.

        - **AttributeName** *(string) --*

          The name of the account attribute.

        - **AttributeValues** *(list) --*

          The values for the account attribute.

          - *(dict) --*

            Describes a value of an account attribute.

            - **AttributeValue** *(string) --*

              The value of the attribute.
    """


_ClientDescribeAddressesFiltersTypeDef = TypedDict(
    "_ClientDescribeAddressesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeAddressesFiltersTypeDef(_ClientDescribeAddressesFiltersTypeDef):
    """
    Type definition for `ClientDescribeAddresses` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeAddressesResponseAddressesTagsTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseAddressesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeAddressesResponseAddressesTagsTypeDef(
    _ClientDescribeAddressesResponseAddressesTagsTypeDef
):
    """
    Type definition for `ClientDescribeAddressesResponseAddresses` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeAddressesResponseAddressesTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseAddressesTypeDef",
    {
        "InstanceId": str,
        "PublicIp": str,
        "AllocationId": str,
        "AssociationId": str,
        "Domain": str,
        "NetworkInterfaceId": str,
        "NetworkInterfaceOwnerId": str,
        "PrivateIpAddress": str,
        "Tags": List[ClientDescribeAddressesResponseAddressesTagsTypeDef],
        "PublicIpv4Pool": str,
    },
    total=False,
)


class ClientDescribeAddressesResponseAddressesTypeDef(
    _ClientDescribeAddressesResponseAddressesTypeDef
):
    """
    Type definition for `ClientDescribeAddressesResponse` `Addresses`

    Describes an Elastic IP address.

    - **InstanceId** *(string) --*

      The ID of the instance that the address is associated with (if any).

    - **PublicIp** *(string) --*

      The Elastic IP address.

    - **AllocationId** *(string) --*

      The ID representing the allocation of the address for use with EC2-VPC.

    - **AssociationId** *(string) --*

      The ID representing the association of the address with an instance in a VPC.

    - **Domain** *(string) --*

      Indicates whether this Elastic IP address is for use with instances in EC2-Classic
      (``standard`` ) or instances in a VPC (``vpc`` ).

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **NetworkInterfaceOwnerId** *(string) --*

      The ID of the AWS account that owns the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IP address associated with the Elastic IP address.

    - **Tags** *(list) --*

      Any tags assigned to the Elastic IP address.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **PublicIpv4Pool** *(string) --*

      The ID of an address pool.
    """


_ClientDescribeAddressesResponseTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseTypeDef",
    {"Addresses": List[ClientDescribeAddressesResponseAddressesTypeDef]},
    total=False,
)


class ClientDescribeAddressesResponseTypeDef(_ClientDescribeAddressesResponseTypeDef):
    """
    Type definition for `ClientDescribeAddresses` `Response`

    - **Addresses** *(list) --*

      Information about the Elastic IP addresses.

      - *(dict) --*

        Describes an Elastic IP address.

        - **InstanceId** *(string) --*

          The ID of the instance that the address is associated with (if any).

        - **PublicIp** *(string) --*

          The Elastic IP address.

        - **AllocationId** *(string) --*

          The ID representing the allocation of the address for use with EC2-VPC.

        - **AssociationId** *(string) --*

          The ID representing the association of the address with an instance in a VPC.

        - **Domain** *(string) --*

          Indicates whether this Elastic IP address is for use with instances in EC2-Classic
          (``standard`` ) or instances in a VPC (``vpc`` ).

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **NetworkInterfaceOwnerId** *(string) --*

          The ID of the AWS account that owns the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IP address associated with the Elastic IP address.

        - **Tags** *(list) --*

          Any tags assigned to the Elastic IP address.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **PublicIpv4Pool** *(string) --*

          The ID of an address pool.
    """


_ClientDescribeAggregateIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeAggregateIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeAggregateIdFormatResponseStatusesTypeDef(
    _ClientDescribeAggregateIdFormatResponseStatusesTypeDef
):
    """
    Type definition for `ClientDescribeAggregateIdFormatResponse` `Statuses`

    Describes the ID format for a resource.

    - **Deadline** *(datetime) --*

      The date in UTC at which you are permanently switched over to using longer IDs. If a
      deadline is not yet available for this resource type, this field is not returned.

    - **Resource** *(string) --*

      The type of resource.

    - **UseLongIds** *(boolean) --*

      Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeAggregateIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeAggregateIdFormatResponseTypeDef",
    {
        "UseLongIdsAggregated": bool,
        "Statuses": List[ClientDescribeAggregateIdFormatResponseStatusesTypeDef],
    },
    total=False,
)


class ClientDescribeAggregateIdFormatResponseTypeDef(
    _ClientDescribeAggregateIdFormatResponseTypeDef
):
    """
    Type definition for `ClientDescribeAggregateIdFormat` `Response`

    - **UseLongIdsAggregated** *(boolean) --*

      Indicates whether all resource types in the Region are configured to use longer IDs. This
      value is only ``true`` if all users are configured to use longer IDs for all resources types
      in the Region.

    - **Statuses** *(list) --*

      Information about each resource's ID format.

      - *(dict) --*

        Describes the ID format for a resource.

        - **Deadline** *(datetime) --*

          The date in UTC at which you are permanently switched over to using longer IDs. If a
          deadline is not yet available for this resource type, this field is not returned.

        - **Resource** *(string) --*

          The type of resource.

        - **UseLongIds** *(boolean) --*

          Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeAvailabilityZonesFiltersTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeAvailabilityZonesFiltersTypeDef(
    _ClientDescribeAvailabilityZonesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeAvailabilityZones` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef",
    {"Message": str},
    total=False,
)


class ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef(
    _ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef
):
    """
    Type definition for `ClientDescribeAvailabilityZonesResponseAvailabilityZones` `Messages`

    Describes a message about an Availability Zone.

    - **Message** *(string) --*

      The message about the Availability Zone.
    """


_ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef",
    {
        "State": str,
        "Messages": List[
            ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef
        ],
        "RegionName": str,
        "ZoneName": str,
        "ZoneId": str,
    },
    total=False,
)


class ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef(
    _ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef
):
    """
    Type definition for `ClientDescribeAvailabilityZonesResponse` `AvailabilityZones`

    Describes an Availability Zone.

    - **State** *(string) --*

      The state of the Availability Zone.

    - **Messages** *(list) --*

      Any messages about the Availability Zone.

      - *(dict) --*

        Describes a message about an Availability Zone.

        - **Message** *(string) --*

          The message about the Availability Zone.

    - **RegionName** *(string) --*

      The name of the Region.

    - **ZoneName** *(string) --*

      The name of the Availability Zone.

    - **ZoneId** *(string) --*

      The ID of the Availability Zone.
    """


_ClientDescribeAvailabilityZonesResponseTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseTypeDef",
    {
        "AvailabilityZones": List[
            ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef
        ]
    },
    total=False,
)


class ClientDescribeAvailabilityZonesResponseTypeDef(
    _ClientDescribeAvailabilityZonesResponseTypeDef
):
    """
    Type definition for `ClientDescribeAvailabilityZones` `Response`

    - **AvailabilityZones** *(list) --*

      Information about the Availability Zones.

      - *(dict) --*

        Describes an Availability Zone.

        - **State** *(string) --*

          The state of the Availability Zone.

        - **Messages** *(list) --*

          Any messages about the Availability Zone.

          - *(dict) --*

            Describes a message about an Availability Zone.

            - **Message** *(string) --*

              The message about the Availability Zone.

        - **RegionName** *(string) --*

          The name of the Region.

        - **ZoneName** *(string) --*

          The name of the Availability Zone.

        - **ZoneId** *(string) --*

          The ID of the Availability Zone.
    """


_ClientDescribeBundleTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeBundleTasksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeBundleTasksFiltersTypeDef(_ClientDescribeBundleTasksFiltersTypeDef):
    """
    Type definition for `ClientDescribeBundleTasks` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef
):
    """
    Type definition for `ClientDescribeBundleTasksResponseBundleTasks` `BundleTaskError`

    If the task fails, a description of the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message.
    """


_ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef
):
    """
    Type definition for `ClientDescribeBundleTasksResponseBundleTasksStorage` `S3`

    An Amazon S3 storage location.

    - **AWSAccessKeyId** *(string) --*

      The access key ID of the owner of the bucket. Before you specify a value for your
      access key ID, review and follow the guidance in `Best Practices for Managing AWS
      Access Keys
      <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__
      .

    - **Bucket** *(string) --*

      The bucket in which to store the AMI. You can specify a bucket that you already own
      or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
      belongs to someone else, Amazon EC2 returns an error.

    - **Prefix** *(string) --*

      The beginning of the file name of the AMI.

    - **UploadPolicy** *(bytes) --*

      An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into
      Amazon S3 on your behalf.

    - **UploadPolicySignature** *(string) --*

      The signature of the JSON document.
    """


_ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef",
    {"S3": ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef},
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef
):
    """
    Type definition for `ClientDescribeBundleTasksResponseBundleTasks` `Storage`

    The Amazon S3 storage locations.

    - **S3** *(dict) --*

      An Amazon S3 storage location.

      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your
        access key ID, review and follow the guidance in `Best Practices for Managing AWS
        Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__
        .

      - **Bucket** *(string) --*

        The bucket in which to store the AMI. You can specify a bucket that you already own
        or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
        belongs to someone else, Amazon EC2 returns an error.

      - **Prefix** *(string) --*

        The beginning of the file name of the AMI.

      - **UploadPolicy** *(bytes) --*

        An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into
        Amazon S3 on your behalf.

      - **UploadPolicySignature** *(string) --*

        The signature of the JSON document.
    """


_ClientDescribeBundleTasksResponseBundleTasksTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": str,
        "Storage": ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksTypeDef
):
    """
    Type definition for `ClientDescribeBundleTasksResponse` `BundleTasks`

    Describes a bundle task.

    - **BundleId** *(string) --*

      The ID of the bundle task.

    - **BundleTaskError** *(dict) --*

      If the task fails, a description of the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message.

    - **InstanceId** *(string) --*

      The ID of the instance associated with this bundle task.

    - **Progress** *(string) --*

      The level of task completion, as a percent (for example, 20%).

    - **StartTime** *(datetime) --*

      The time this task started.

    - **State** *(string) --*

      The state of the task.

    - **Storage** *(dict) --*

      The Amazon S3 storage locations.

      - **S3** *(dict) --*

        An Amazon S3 storage location.

        - **AWSAccessKeyId** *(string) --*

          The access key ID of the owner of the bucket. Before you specify a value for your
          access key ID, review and follow the guidance in `Best Practices for Managing AWS
          Access Keys
          <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__
          .

        - **Bucket** *(string) --*

          The bucket in which to store the AMI. You can specify a bucket that you already own
          or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
          belongs to someone else, Amazon EC2 returns an error.

        - **Prefix** *(string) --*

          The beginning of the file name of the AMI.

        - **UploadPolicy** *(bytes) --*

          An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into
          Amazon S3 on your behalf.

        - **UploadPolicySignature** *(string) --*

          The signature of the JSON document.

    - **UpdateTime** *(datetime) --*

      The time of the most recent update for the task.
    """


_ClientDescribeBundleTasksResponseTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseTypeDef",
    {"BundleTasks": List[ClientDescribeBundleTasksResponseBundleTasksTypeDef]},
    total=False,
)


class ClientDescribeBundleTasksResponseTypeDef(
    _ClientDescribeBundleTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeBundleTasks` `Response`

    - **BundleTasks** *(list) --*

      Information about the bundle tasks.

      - *(dict) --*

        Describes a bundle task.

        - **BundleId** *(string) --*

          The ID of the bundle task.

        - **BundleTaskError** *(dict) --*

          If the task fails, a description of the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message.

        - **InstanceId** *(string) --*

          The ID of the instance associated with this bundle task.

        - **Progress** *(string) --*

          The level of task completion, as a percent (for example, 20%).

        - **StartTime** *(datetime) --*

          The time this task started.

        - **State** *(string) --*

          The state of the task.

        - **Storage** *(dict) --*

          The Amazon S3 storage locations.

          - **S3** *(dict) --*

            An Amazon S3 storage location.

            - **AWSAccessKeyId** *(string) --*

              The access key ID of the owner of the bucket. Before you specify a value for your
              access key ID, review and follow the guidance in `Best Practices for Managing AWS
              Access Keys
              <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__
              .

            - **Bucket** *(string) --*

              The bucket in which to store the AMI. You can specify a bucket that you already own
              or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that
              belongs to someone else, Amazon EC2 returns an error.

            - **Prefix** *(string) --*

              The beginning of the file name of the AMI.

            - **UploadPolicy** *(bytes) --*

              An Amazon S3 upload policy that gives Amazon EC2 permission to upload items into
              Amazon S3 on your behalf.

            - **UploadPolicySignature** *(string) --*

              The signature of the JSON document.

        - **UpdateTime** *(datetime) --*

          The time of the most recent update for the task.
    """


_ClientDescribeByoipCidrsResponseByoipCidrsTypeDef = TypedDict(
    "_ClientDescribeByoipCidrsResponseByoipCidrsTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class ClientDescribeByoipCidrsResponseByoipCidrsTypeDef(
    _ClientDescribeByoipCidrsResponseByoipCidrsTypeDef
):
    """
    Type definition for `ClientDescribeByoipCidrsResponse` `ByoipCidrs`

    Information about an address range that is provisioned for use with your AWS resources
    through bring your own IP addresses (BYOIP).

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_ClientDescribeByoipCidrsResponseTypeDef = TypedDict(
    "_ClientDescribeByoipCidrsResponseTypeDef",
    {
        "ByoipCidrs": List[ClientDescribeByoipCidrsResponseByoipCidrsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeByoipCidrsResponseTypeDef(_ClientDescribeByoipCidrsResponseTypeDef):
    """
    Type definition for `ClientDescribeByoipCidrs` `Response`

    - **ByoipCidrs** *(list) --*

      Information about your address ranges.

      - *(dict) --*

        Information about an address range that is provisioned for use with your AWS resources
        through bring your own IP addresses (BYOIP).

        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.

        - **Description** *(string) --*

          The description of the address range.

        - **StatusMessage** *(string) --*

          Upon success, contains the ID of the address pool. Otherwise, contains an error message.

        - **State** *(string) --*

          The state of the address pool.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeCapacityReservationsFiltersTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeCapacityReservationsFiltersTypeDef(
    _ClientDescribeCapacityReservationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeCapacityReservations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef(
    _ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef
):
    """
    Type definition for `ClientDescribeCapacityReservationsResponseCapacityReservations` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": str,
        "AvailabilityZone": str,
        "Tenancy": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": str,
        "EndDate": datetime,
        "EndDateType": str,
        "InstanceMatchCriteria": str,
        "CreateDate": datetime,
        "Tags": List[
            ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef(
    _ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef
):
    """
    Type definition for `ClientDescribeCapacityReservationsResponse` `CapacityReservations`

    Describes a Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the Capacity Reservation.

    - **CapacityReservationArn** *(string) --*

      The Amazon Resource Name (ARN) of the Capacity Reservation.

    - **AvailabilityZoneId** *(string) --*

      The Availability Zone ID of the Capacity Reservation.

    - **InstanceType** *(string) --*

      The type of instance for which the Capacity Reservation reserves capacity.

    - **InstancePlatform** *(string) --*

      The type of operating system for which the Capacity Reservation reserves capacity.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the capacity is reserved.

    - **Tenancy** *(string) --*

      Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
      the following tenancy settings:

      * ``default`` - The Capacity Reservation is created on hardware that is shared with other
      AWS accounts.

      * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
      dedicated to a single AWS account.

    - **TotalInstanceCount** *(integer) --*

      The total number of instances for which the Capacity Reservation reserves capacity.

    - **AvailableInstanceCount** *(integer) --*

      The remaining capacity. Indicates the number of instances that can be launched in the
      Capacity Reservation.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the Capacity Reservation supports EBS-optimized instances. This
      optimization provides dedicated throughput to Amazon EBS and an optimized configuration
      stack to provide optimal I/O performance. This optimization isn't available with all
      instance types. Additional usage charges apply when using an EBS- optimized instance.

    - **EphemeralStorage** *(boolean) --*

      Indicates whether the Capacity Reservation supports instances with temporary, block-level
      storage.

    - **State** *(string) --*

      The current state of the Capacity Reservation. A Capacity Reservation can be in one of
      the following states:

      * ``active`` - The Capacity Reservation is active and the capacity is available for your
      use.

      * ``expired`` - The Capacity Reservation expired automatically at the date and time
      specified in your request. The reserved capacity is no longer available for your use.

      * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity
      is no longer available for your use.

      * ``pending`` - The Capacity Reservation request was successful but the capacity
      provisioning is still pending.

      * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
      invalid request parameters, capacity constraints, or instance limit constraints. Failed
      requests are retained for 60 minutes.

    - **EndDate** *(datetime) --*

      The date and time at which the Capacity Reservation expires. When a Capacity Reservation
      expires, the reserved capacity is released and you can no longer launch instances into
      it. The Capacity Reservation's state changes to ``expired`` when it reaches its end date
      and time.

    - **EndDateType** *(string) --*

      Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
      one of the following end types:

      * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

      * ``limited`` - The Capacity Reservation expires automatically at a specified date and
      time.

    - **InstanceMatchCriteria** *(string) --*

      Indicates the type of instance launches that the Capacity Reservation accepts. The
      options include:

      * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
      (instance type, platform, and Availability Zone). Instances that have matching attributes
      launch into the Capacity Reservation automatically without specifying any additional
      parameters.

      * ``targeted`` - The Capacity Reservation only accepts instances that have matching
      attributes (instance type, platform, and Availability Zone), and explicitly target the
      Capacity Reservation. This ensures that only permitted instances can use the reserved
      capacity.

    - **CreateDate** *(datetime) --*

      The date and time at which the Capacity Reservation was created.

    - **Tags** *(list) --*

      Any tags assigned to the Capacity Reservation.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeCapacityReservationsResponseTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseTypeDef",
    {
        "NextToken": str,
        "CapacityReservations": List[
            ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeCapacityReservationsResponseTypeDef(
    _ClientDescribeCapacityReservationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeCapacityReservations` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **CapacityReservations** *(list) --*

      Information about the Capacity Reservations.

      - *(dict) --*

        Describes a Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the Capacity Reservation.

        - **CapacityReservationArn** *(string) --*

          The Amazon Resource Name (ARN) of the Capacity Reservation.

        - **AvailabilityZoneId** *(string) --*

          The Availability Zone ID of the Capacity Reservation.

        - **InstanceType** *(string) --*

          The type of instance for which the Capacity Reservation reserves capacity.

        - **InstancePlatform** *(string) --*

          The type of operating system for which the Capacity Reservation reserves capacity.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which the capacity is reserved.

        - **Tenancy** *(string) --*

          Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
          the following tenancy settings:

          * ``default`` - The Capacity Reservation is created on hardware that is shared with other
          AWS accounts.

          * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
          dedicated to a single AWS account.

        - **TotalInstanceCount** *(integer) --*

          The total number of instances for which the Capacity Reservation reserves capacity.

        - **AvailableInstanceCount** *(integer) --*

          The remaining capacity. Indicates the number of instances that can be launched in the
          Capacity Reservation.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the Capacity Reservation supports EBS-optimized instances. This
          optimization provides dedicated throughput to Amazon EBS and an optimized configuration
          stack to provide optimal I/O performance. This optimization isn't available with all
          instance types. Additional usage charges apply when using an EBS- optimized instance.

        - **EphemeralStorage** *(boolean) --*

          Indicates whether the Capacity Reservation supports instances with temporary, block-level
          storage.

        - **State** *(string) --*

          The current state of the Capacity Reservation. A Capacity Reservation can be in one of
          the following states:

          * ``active`` - The Capacity Reservation is active and the capacity is available for your
          use.

          * ``expired`` - The Capacity Reservation expired automatically at the date and time
          specified in your request. The reserved capacity is no longer available for your use.

          * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity
          is no longer available for your use.

          * ``pending`` - The Capacity Reservation request was successful but the capacity
          provisioning is still pending.

          * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
          invalid request parameters, capacity constraints, or instance limit constraints. Failed
          requests are retained for 60 minutes.

        - **EndDate** *(datetime) --*

          The date and time at which the Capacity Reservation expires. When a Capacity Reservation
          expires, the reserved capacity is released and you can no longer launch instances into
          it. The Capacity Reservation's state changes to ``expired`` when it reaches its end date
          and time.

        - **EndDateType** *(string) --*

          Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
          one of the following end types:

          * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

          * ``limited`` - The Capacity Reservation expires automatically at a specified date and
          time.

        - **InstanceMatchCriteria** *(string) --*

          Indicates the type of instance launches that the Capacity Reservation accepts. The
          options include:

          * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
          (instance type, platform, and Availability Zone). Instances that have matching attributes
          launch into the Capacity Reservation automatically without specifying any additional
          parameters.

          * ``targeted`` - The Capacity Reservation only accepts instances that have matching
          attributes (instance type, platform, and Availability Zone), and explicitly target the
          Capacity Reservation. This ensures that only permitted instances can use the reserved
          capacity.

        - **CreateDate** *(datetime) --*

          The date and time at which the Capacity Reservation was created.

        - **Tags** *(list) --*

          Any tags assigned to the Capacity Reservation.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientDescribeClassicLinkInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClassicLinkInstancesFiltersTypeDef(
    _ClientDescribeClassicLinkInstancesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClassicLinkInstances` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef
):
    """
    Type definition for `ClientDescribeClassicLinkInstancesResponseInstances` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef
):
    """
    Type definition for `ClientDescribeClassicLinkInstancesResponseInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeClassicLinkInstancesResponseInstancesTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesTypeDef",
    {
        "Groups": List[
            ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef
        ],
        "InstanceId": str,
        "Tags": List[ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesTypeDef
):
    """
    Type definition for `ClientDescribeClassicLinkInstancesResponse` `Instances`

    Describes a linked EC2-Classic instance.

    - **Groups** *(list) --*

      A list of security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Tags** *(list) --*

      Any tags assigned to the instance.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeClassicLinkInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseTypeDef",
    {
        "Instances": List[ClientDescribeClassicLinkInstancesResponseInstancesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseTypeDef(
    _ClientDescribeClassicLinkInstancesResponseTypeDef
):
    """
    Type definition for `ClientDescribeClassicLinkInstances` `Response`

    - **Instances** *(list) --*

      Information about one or more linked EC2-Classic instances.

      - *(dict) --*

        Describes a linked EC2-Classic instance.

        - **Groups** *(list) --*

          A list of security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Tags** *(list) --*

          Any tags assigned to the instance.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnAuthorizationRules` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRules` `Status`

    The current state of the authorization rule.

    - **Code** *(string) --*

      The state of the authorization rule.

    - **Message** *(string) --*

      A message about the status of the authorization rule, if applicable.
    """


_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "GroupId": str,
        "AccessAll": bool,
        "DestinationCidr": str,
        "Status": ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef,
    },
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnAuthorizationRulesResponse` `AuthorizationRules`

    Information about an authorization rule.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the authorization rule is associated.

    - **Description** *(string) --*

      A brief description of the authorization rule.

    - **GroupId** *(string) --*

      The ID of the Active Directory group to which the authorization rule grants access.

    - **AccessAll** *(boolean) --*

      Indicates whether the authorization rule grants access to all clients.

    - **DestinationCidr** *(string) --*

      The IPv4 address range, in CIDR notation, of the network to which the authorization rule
      applies.

    - **Status** *(dict) --*

      The current state of the authorization rule.

      - **Code** *(string) --*

        The state of the authorization rule.

      - **Message** *(string) --*

        A message about the status of the authorization rule, if applicable.
    """


_ClientDescribeClientVpnAuthorizationRulesResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseTypeDef",
    {
        "AuthorizationRules": List[
            ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnAuthorizationRules` `Response`

    - **AuthorizationRules** *(list) --*

      Information about the authorization rules.

      - *(dict) --*

        Information about an authorization rule.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the authorization rule is associated.

        - **Description** *(string) --*

          A brief description of the authorization rule.

        - **GroupId** *(string) --*

          The ID of the Active Directory group to which the authorization rule grants access.

        - **AccessAll** *(boolean) --*

          Indicates whether the authorization rule grants access to all clients.

        - **DestinationCidr** *(string) --*

          The IPv4 address range, in CIDR notation, of the network to which the authorization rule
          applies.

        - **Status** *(dict) --*

          The current state of the authorization rule.

          - **Code** *(string) --*

            The state of the authorization rule.

          - **Message** *(string) --*

            A message about the status of the authorization rule, if applicable.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeClientVpnConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnConnectionsFiltersTypeDef(
    _ClientDescribeClientVpnConnectionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnConnections` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef(
    _ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnConnectionsResponseConnections` `Status`

    The current state of the client connection.

    - **Code** *(string) --*

      The state of the client connection.

    - **Message** *(string) --*

      A message about the status of the client connection, if applicable.
    """


_ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Timestamp": str,
        "ConnectionId": str,
        "Username": str,
        "ConnectionEstablishedTime": str,
        "IngressBytes": str,
        "EgressBytes": str,
        "IngressPackets": str,
        "EgressPackets": str,
        "ClientIp": str,
        "CommonName": str,
        "Status": ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef,
        "ConnectionEndTime": str,
    },
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef(
    _ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnConnectionsResponse` `Connections`

    Describes a client connection.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint to which the client is connected.

    - **Timestamp** *(string) --*

      The current date and time.

    - **ConnectionId** *(string) --*

      The ID of the client connection.

    - **Username** *(string) --*

      The username of the client who established the client connection. This information is
      only provided if Active Directory client authentication is used.

    - **ConnectionEstablishedTime** *(string) --*

      The date and time the client connection was established.

    - **IngressBytes** *(string) --*

      The number of bytes sent by the client.

    - **EgressBytes** *(string) --*

      The number of bytes received by the client.

    - **IngressPackets** *(string) --*

      The number of packets sent by the client.

    - **EgressPackets** *(string) --*

      The number of packets received by the client.

    - **ClientIp** *(string) --*

      The IP address of the client.

    - **CommonName** *(string) --*

      The common name associated with the client. This is either the name of the client
      certificate, or the Active Directory user name.

    - **Status** *(dict) --*

      The current state of the client connection.

      - **Code** *(string) --*

        The state of the client connection.

      - **Message** *(string) --*

        A message about the status of the client connection, if applicable.

    - **ConnectionEndTime** *(string) --*

      The date and time the client connection was terminated.
    """


_ClientDescribeClientVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseTypeDef",
    {
        "Connections": List[
            ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseTypeDef(
    _ClientDescribeClientVpnConnectionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnConnections` `Response`

    - **Connections** *(list) --*

      Information about the active and terminated client connections.

      - *(dict) --*

        Describes a client connection.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint to which the client is connected.

        - **Timestamp** *(string) --*

          The current date and time.

        - **ConnectionId** *(string) --*

          The ID of the client connection.

        - **Username** *(string) --*

          The username of the client who established the client connection. This information is
          only provided if Active Directory client authentication is used.

        - **ConnectionEstablishedTime** *(string) --*

          The date and time the client connection was established.

        - **IngressBytes** *(string) --*

          The number of bytes sent by the client.

        - **EgressBytes** *(string) --*

          The number of bytes received by the client.

        - **IngressPackets** *(string) --*

          The number of packets sent by the client.

        - **EgressPackets** *(string) --*

          The number of packets received by the client.

        - **ClientIp** *(string) --*

          The IP address of the client.

        - **CommonName** *(string) --*

          The common name associated with the client. This is either the name of the client
          certificate, or the Active Directory user name.

        - **Status** *(dict) --*

          The current state of the client connection.

          - **Code** *(string) --*

            The state of the client connection.

          - **Message** *(string) --*

            A message about the status of the client connection, if applicable.

        - **ConnectionEndTime** *(string) --*

          The date and time the client connection was terminated.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeClientVpnEndpointsFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnEndpointsFiltersTypeDef(
    _ClientDescribeClientVpnEndpointsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpoints` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    {"NetworkId": str, "NetworkType": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpoints` `AssociatedTargetNetworks`

    Describes a target network that is associated with a Client VPN endpoint. A target
    network is a subnet in a VPC.

    - **NetworkId** *(string) --*

      The ID of the subnet.

    - **NetworkType** *(string) --*

      The target network type.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptions` `ActiveDirectory`

    Information about the Active Directory, if applicable.

    - **DirectoryId** *(string) --*

      The ID of the Active Directory used for authentication.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChain": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptions` `MutualAuthentication`

    Information about the authentication certificates, if applicable.

    - **ClientRootCertificateChain** *(string) --*

      The ARN of the client certificate.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    {
        "Type": str,
        "ActiveDirectory": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpoints` `AuthenticationOptions`

    Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
    Active Directory and mutual authentication. For more information, see `Authentication
    <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
    in the *AWS Client VPN Administrator Guide* .

    - **Type** *(string) --*

      The authentication type used.

    - **ActiveDirectory** *(dict) --*

      Information about the Active Directory, if applicable.

      - **DirectoryId** *(string) --*

        The ID of the Active Directory used for authentication.

    - **MutualAuthentication** *(dict) --*

      Information about the authentication certificates, if applicable.

      - **ClientRootCertificateChain** *(string) --*

        The ARN of the client certificate.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpoints` `ConnectionLogOptions`

    Information about the client connection logging options for the Client VPN endpoint.

    - **Enabled** *(boolean) --*

      Indicates whether client connection logging is enabled for the Client VPN endpoint.

    - **CloudwatchLogGroup** *(string) --*

      The name of the Amazon CloudWatch Logs log group to which connection logging data is
      published.

    - **CloudwatchLogStream** *(string) --*

      The name of the Amazon CloudWatch Logs log stream to which connection logging data is
      published.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpoints` `Status`

    The current state of the Client VPN endpoint.

    - **Code** *(string) --*

      The state of the Client VPN endpoint. Possible states include:

      * ``pending-associate`` - The Client VPN endpoint has been created but no target
      networks have been associated. The Client VPN endpoint cannot accept connections.

      * ``available`` - The Client VPN endpoint has been created and a target network has
      been associated. The Client VPN endpoint can accept connections.

      * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
      cannot accept connections.

      * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
      cannot accept connections.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponseClientVpnEndpoints` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "Status": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef,
        "CreationTime": str,
        "DeletionTime": str,
        "DnsName": str,
        "ClientCidrBlock": str,
        "DnsServers": List[str],
        "SplitTunnel": bool,
        "VpnProtocol": str,
        "TransportProtocol": str,
        "AssociatedTargetNetworks": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
        ],
        "ServerCertificateArn": str,
        "AuthenticationOptions": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef
        ],
        "ConnectionLogOptions": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef,
        "Tags": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpointsResponse` `ClientVpnEndpoints`

    Describes a Client VPN endpoint.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint.

    - **Description** *(string) --*

      A brief description of the endpoint.

    - **Status** *(dict) --*

      The current state of the Client VPN endpoint.

      - **Code** *(string) --*

        The state of the Client VPN endpoint. Possible states include:

        * ``pending-associate`` - The Client VPN endpoint has been created but no target
        networks have been associated. The Client VPN endpoint cannot accept connections.

        * ``available`` - The Client VPN endpoint has been created and a target network has
        been associated. The Client VPN endpoint can accept connections.

        * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
        cannot accept connections.

        * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
        cannot accept connections.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint.

    - **CreationTime** *(string) --*

      The date and time the Client VPN endpoint was created.

    - **DeletionTime** *(string) --*

      The date and time the Client VPN endpoint was deleted, if applicable.

    - **DnsName** *(string) --*

      The DNS name to be used by clients when connecting to the Client VPN endpoint.

    - **ClientCidrBlock** *(string) --*

      The IPv4 address range, in CIDR notation, from which client IP addresses are assigned.

    - **DnsServers** *(list) --*

      Information about the DNS servers to be used for DNS resolution.

      - *(string) --*

    - **SplitTunnel** *(boolean) --*

      Indicates whether split-tunnel is enabled in the AWS Client VPN endpoint.

      For information about split-tunnel VPN endpoints, see `Split-Tunnel AWS Client VPN
      Endpoint
      <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html>`__ in the
      *AWS Client VPN Administrator Guide* .

    - **VpnProtocol** *(string) --*

      The protocol used by the VPN session.

    - **TransportProtocol** *(string) --*

      The transport protocol used by the Client VPN endpoint.

    - **AssociatedTargetNetworks** *(list) --*

      Information about the associated target networks. A target network is a subnet in a VPC.

      - *(dict) --*

        Describes a target network that is associated with a Client VPN endpoint. A target
        network is a subnet in a VPC.

        - **NetworkId** *(string) --*

          The ID of the subnet.

        - **NetworkType** *(string) --*

          The target network type.

    - **ServerCertificateArn** *(string) --*

      The ARN of the server certificate.

    - **AuthenticationOptions** *(list) --*

      Information about the authentication method used by the Client VPN endpoint.

      - *(dict) --*

        Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
        Active Directory and mutual authentication. For more information, see `Authentication
        <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
        in the *AWS Client VPN Administrator Guide* .

        - **Type** *(string) --*

          The authentication type used.

        - **ActiveDirectory** *(dict) --*

          Information about the Active Directory, if applicable.

          - **DirectoryId** *(string) --*

            The ID of the Active Directory used for authentication.

        - **MutualAuthentication** *(dict) --*

          Information about the authentication certificates, if applicable.

          - **ClientRootCertificateChain** *(string) --*

            The ARN of the client certificate.

    - **ConnectionLogOptions** *(dict) --*

      Information about the client connection logging options for the Client VPN endpoint.

      - **Enabled** *(boolean) --*

        Indicates whether client connection logging is enabled for the Client VPN endpoint.

      - **CloudwatchLogGroup** *(string) --*

        The name of the Amazon CloudWatch Logs log group to which connection logging data is
        published.

      - **CloudwatchLogStream** *(string) --*

        The name of the Amazon CloudWatch Logs log stream to which connection logging data is
        published.

    - **Tags** *(list) --*

      Any tags assigned to the Client VPN endpoint.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeClientVpnEndpointsResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseTypeDef",
    {
        "ClientVpnEndpoints": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseTypeDef(
    _ClientDescribeClientVpnEndpointsResponseTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnEndpoints` `Response`

    - **ClientVpnEndpoints** *(list) --*

      Information about the Client VPN endpoints.

      - *(dict) --*

        Describes a Client VPN endpoint.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint.

        - **Description** *(string) --*

          A brief description of the endpoint.

        - **Status** *(dict) --*

          The current state of the Client VPN endpoint.

          - **Code** *(string) --*

            The state of the Client VPN endpoint. Possible states include:

            * ``pending-associate`` - The Client VPN endpoint has been created but no target
            networks have been associated. The Client VPN endpoint cannot accept connections.

            * ``available`` - The Client VPN endpoint has been created and a target network has
            been associated. The Client VPN endpoint can accept connections.

            * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
            cannot accept connections.

            * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
            cannot accept connections.

          - **Message** *(string) --*

            A message about the status of the Client VPN endpoint.

        - **CreationTime** *(string) --*

          The date and time the Client VPN endpoint was created.

        - **DeletionTime** *(string) --*

          The date and time the Client VPN endpoint was deleted, if applicable.

        - **DnsName** *(string) --*

          The DNS name to be used by clients when connecting to the Client VPN endpoint.

        - **ClientCidrBlock** *(string) --*

          The IPv4 address range, in CIDR notation, from which client IP addresses are assigned.

        - **DnsServers** *(list) --*

          Information about the DNS servers to be used for DNS resolution.

          - *(string) --*

        - **SplitTunnel** *(boolean) --*

          Indicates whether split-tunnel is enabled in the AWS Client VPN endpoint.

          For information about split-tunnel VPN endpoints, see `Split-Tunnel AWS Client VPN
          Endpoint
          <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html>`__ in the
          *AWS Client VPN Administrator Guide* .

        - **VpnProtocol** *(string) --*

          The protocol used by the VPN session.

        - **TransportProtocol** *(string) --*

          The transport protocol used by the Client VPN endpoint.

        - **AssociatedTargetNetworks** *(list) --*

          Information about the associated target networks. A target network is a subnet in a VPC.

          - *(dict) --*

            Describes a target network that is associated with a Client VPN endpoint. A target
            network is a subnet in a VPC.

            - **NetworkId** *(string) --*

              The ID of the subnet.

            - **NetworkType** *(string) --*

              The target network type.

        - **ServerCertificateArn** *(string) --*

          The ARN of the server certificate.

        - **AuthenticationOptions** *(list) --*

          Information about the authentication method used by the Client VPN endpoint.

          - *(dict) --*

            Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
            Active Directory and mutual authentication. For more information, see `Authentication
            <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
            in the *AWS Client VPN Administrator Guide* .

            - **Type** *(string) --*

              The authentication type used.

            - **ActiveDirectory** *(dict) --*

              Information about the Active Directory, if applicable.

              - **DirectoryId** *(string) --*

                The ID of the Active Directory used for authentication.

            - **MutualAuthentication** *(dict) --*

              Information about the authentication certificates, if applicable.

              - **ClientRootCertificateChain** *(string) --*

                The ARN of the client certificate.

        - **ConnectionLogOptions** *(dict) --*

          Information about the client connection logging options for the Client VPN endpoint.

          - **Enabled** *(boolean) --*

            Indicates whether client connection logging is enabled for the Client VPN endpoint.

          - **CloudwatchLogGroup** *(string) --*

            The name of the Amazon CloudWatch Logs log group to which connection logging data is
            published.

          - **CloudwatchLogStream** *(string) --*

            The name of the Amazon CloudWatch Logs log stream to which connection logging data is
            published.

        - **Tags** *(list) --*

          Any tags assigned to the Client VPN endpoint.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeClientVpnRoutesFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnRoutesFiltersTypeDef(
    _ClientDescribeClientVpnRoutesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnRoutes` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef(
    _ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnRoutesResponseRoutes` `Status`

    The current state of the route.

    - **Code** *(string) --*

      The state of the Client VPN endpoint route.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint route, if applicable.
    """


_ClientDescribeClientVpnRoutesResponseRoutesTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseRoutesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidr": str,
        "TargetSubnet": str,
        "Type": str,
        "Origin": str,
        "Status": ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef,
        "Description": str,
    },
    total=False,
)


class ClientDescribeClientVpnRoutesResponseRoutesTypeDef(
    _ClientDescribeClientVpnRoutesResponseRoutesTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnRoutesResponse` `Routes`

    Information about a Client VPN endpoint route.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the route is associated.

    - **DestinationCidr** *(string) --*

      The IPv4 address range, in CIDR notation, of the route destination.

    - **TargetSubnet** *(string) --*

      The ID of the subnet through which traffic is routed.

    - **Type** *(string) --*

      The route type.

    - **Origin** *(string) --*

      Indicates how the route was associated with the Client VPN endpoint. ``associate``
      indicates that the route was automatically added when the target network was associated
      with the Client VPN endpoint. ``add-route`` indicates that the route was manually added
      using the **CreateClientVpnRoute** action.

    - **Status** *(dict) --*

      The current state of the route.

      - **Code** *(string) --*

        The state of the Client VPN endpoint route.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint route, if applicable.

    - **Description** *(string) --*

      A brief description of the route.
    """


_ClientDescribeClientVpnRoutesResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseTypeDef",
    {
        "Routes": List[ClientDescribeClientVpnRoutesResponseRoutesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnRoutesResponseTypeDef(
    _ClientDescribeClientVpnRoutesResponseTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnRoutes` `Response`

    - **Routes** *(list) --*

      Information about the Client VPN endpoint routes.

      - *(dict) --*

        Information about a Client VPN endpoint route.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the route is associated.

        - **DestinationCidr** *(string) --*

          The IPv4 address range, in CIDR notation, of the route destination.

        - **TargetSubnet** *(string) --*

          The ID of the subnet through which traffic is routed.

        - **Type** *(string) --*

          The route type.

        - **Origin** *(string) --*

          Indicates how the route was associated with the Client VPN endpoint. ``associate``
          indicates that the route was automatically added when the target network was associated
          with the Client VPN endpoint. ``add-route`` indicates that the route was manually added
          using the **CreateClientVpnRoute** action.

        - **Status** *(dict) --*

          The current state of the route.

          - **Code** *(string) --*

            The state of the Client VPN endpoint route.

          - **Message** *(string) --*

            A message about the status of the Client VPN endpoint route, if applicable.

        - **Description** *(string) --*

          A brief description of the route.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeClientVpnTargetNetworksFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnTargetNetworksFiltersTypeDef(
    _ClientDescribeClientVpnTargetNetworksFiltersTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnTargetNetworks` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworks` `Status`

    The current state of the target network association.

    - **Code** *(string) --*

      The state of the target network association.

    - **Message** *(string) --*

      A message about the status of the target network association, if applicable.
    """


_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef",
    {
        "AssociationId": str,
        "VpcId": str,
        "TargetNetworkId": str,
        "ClientVpnEndpointId": str,
        "Status": ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef,
        "SecurityGroups": List[str],
    },
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnTargetNetworksResponse` `ClientVpnTargetNetworks`

    Describes a target network associated with a Client VPN endpoint.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **VpcId** *(string) --*

      The ID of the VPC in which the target network (subnet) is located.

    - **TargetNetworkId** *(string) --*

      The ID of the subnet specified as the target network.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the target network is associated.

    - **Status** *(dict) --*

      The current state of the target network association.

      - **Code** *(string) --*

        The state of the target network association.

      - **Message** *(string) --*

        A message about the status of the target network association, if applicable.

    - **SecurityGroups** *(list) --*

      The IDs of the security groups applied to the target network association.

      - *(string) --*
    """


_ClientDescribeClientVpnTargetNetworksResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseTypeDef",
    {
        "ClientVpnTargetNetworks": List[
            ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseTypeDef
):
    """
    Type definition for `ClientDescribeClientVpnTargetNetworks` `Response`

    - **ClientVpnTargetNetworks** *(list) --*

      Information about the associated target networks.

      - *(dict) --*

        Describes a target network associated with a Client VPN endpoint.

        - **AssociationId** *(string) --*

          The ID of the association.

        - **VpcId** *(string) --*

          The ID of the VPC in which the target network (subnet) is located.

        - **TargetNetworkId** *(string) --*

          The ID of the subnet specified as the target network.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the target network is associated.

        - **Status** *(dict) --*

          The current state of the target network association.

          - **Code** *(string) --*

            The state of the target network association.

          - **Message** *(string) --*

            A message about the status of the target network association, if applicable.

        - **SecurityGroups** *(list) --*

          The IDs of the security groups applied to the target network association.

          - *(string) --*

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumes` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information
      about creating a presigned URL for an Amazon S3 object, read the "Query String
      Request Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
      topic in the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM
      Import Manifest
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumes` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasksImportInstance` `Volumes`

    Describes an import volume task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting instance will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      A description of the task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information
        about creating a presigned URL for an Amazon S3 object, read the "Query String
        Request Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
        topic in the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM
        Import Manifest
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Status** *(string) --*

      The status of the import of this particular disk image.

    - **StatusMessage** *(string) --*

      The status information or errors related to the disk image.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[
            ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasks` `ImportInstance`

    If the task is for importing an instance, this contains information about the import
    instance task.

    - **Description** *(string) --*

      A description of the task.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Platform** *(string) --*

      The instance operating system.

    - **Volumes** *(list) --*

      The volumes.

      - *(dict) --*

        Describes an import volume task.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the resulting instance will reside.

        - **BytesConverted** *(integer) --*

          The number of bytes converted so far.

        - **Description** *(string) --*

          A description of the task.

        - **Image** *(dict) --*

          The image.

          - **Checksum** *(string) --*

            The checksum computed for the disk image.

          - **Format** *(string) --*

            The disk image format.

          - **ImportManifestUrl** *(string) --*

            A presigned URL for the import manifest stored in Amazon S3. For information
            about creating a presigned URL for an Amazon S3 object, read the "Query String
            Request Authentication Alternative" section of the `Authenticating REST Requests
            <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
            topic in the *Amazon Simple Storage Service Developer Guide* .

            For information about the import manifest referenced by this API action, see `VM
            Import Manifest
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

          - **Size** *(integer) --*

            The size of the disk image, in GiB.

        - **Status** *(string) --*

          The status of the import of this particular disk image.

        - **StatusMessage** *(string) --*

          The status information or errors related to the disk image.

        - **Volume** *(dict) --*

          The volume.

          - **Id** *(string) --*

            The volume identifier.

          - **Size** *(integer) --*

            The size of the volume, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasksImportVolume` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information about
      creating a presigned URL for an Amazon S3 object, read the "Query String Request
      Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
      the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM
      Import Manifest
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasksImportVolume` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef,
        "Volume": ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasks` `ImportVolume`

    If the task is for importing a volume, this contains information about the import volume
    task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting volume will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      The description you provided when starting the import volume task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information about
        creating a presigned URL for an Amazon S3 object, read the "Query String Request
        Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
        the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM
        Import Manifest
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponseConversionTasks` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeConversionTasksResponseConversionTasksTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef,
        "ImportVolume": ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef,
        "State": str,
        "StatusMessage": str,
        "Tags": List[ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef],
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasksResponse` `ConversionTasks`

    Describes a conversion task.

    - **ConversionTaskId** *(string) --*

      The ID of the conversion task.

    - **ExpirationTime** *(string) --*

      The time when the task expires. If the upload isn't complete before the expiration time,
      we automatically cancel the task.

    - **ImportInstance** *(dict) --*

      If the task is for importing an instance, this contains information about the import
      instance task.

      - **Description** *(string) --*

        A description of the task.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **Platform** *(string) --*

        The instance operating system.

      - **Volumes** *(list) --*

        The volumes.

        - *(dict) --*

          Describes an import volume task.

          - **AvailabilityZone** *(string) --*

            The Availability Zone where the resulting instance will reside.

          - **BytesConverted** *(integer) --*

            The number of bytes converted so far.

          - **Description** *(string) --*

            A description of the task.

          - **Image** *(dict) --*

            The image.

            - **Checksum** *(string) --*

              The checksum computed for the disk image.

            - **Format** *(string) --*

              The disk image format.

            - **ImportManifestUrl** *(string) --*

              A presigned URL for the import manifest stored in Amazon S3. For information
              about creating a presigned URL for an Amazon S3 object, read the "Query String
              Request Authentication Alternative" section of the `Authenticating REST Requests
              <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
              topic in the *Amazon Simple Storage Service Developer Guide* .

              For information about the import manifest referenced by this API action, see `VM
              Import Manifest
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

            - **Size** *(integer) --*

              The size of the disk image, in GiB.

          - **Status** *(string) --*

            The status of the import of this particular disk image.

          - **StatusMessage** *(string) --*

            The status information or errors related to the disk image.

          - **Volume** *(dict) --*

            The volume.

            - **Id** *(string) --*

              The volume identifier.

            - **Size** *(integer) --*

              The size of the volume, in GiB.

    - **ImportVolume** *(dict) --*

      If the task is for importing a volume, this contains information about the import volume
      task.

      - **AvailabilityZone** *(string) --*

        The Availability Zone where the resulting volume will reside.

      - **BytesConverted** *(integer) --*

        The number of bytes converted so far.

      - **Description** *(string) --*

        The description you provided when starting the import volume task.

      - **Image** *(dict) --*

        The image.

        - **Checksum** *(string) --*

          The checksum computed for the disk image.

        - **Format** *(string) --*

          The disk image format.

        - **ImportManifestUrl** *(string) --*

          A presigned URL for the import manifest stored in Amazon S3. For information about
          creating a presigned URL for an Amazon S3 object, read the "Query String Request
          Authentication Alternative" section of the `Authenticating REST Requests
          <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
          the *Amazon Simple Storage Service Developer Guide* .

          For information about the import manifest referenced by this API action, see `VM
          Import Manifest
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

        - **Size** *(integer) --*

          The size of the disk image, in GiB.

      - **Volume** *(dict) --*

        The volume.

        - **Id** *(string) --*

          The volume identifier.

        - **Size** *(integer) --*

          The size of the volume, in GiB.

    - **State** *(string) --*

      The state of the conversion task.

    - **StatusMessage** *(string) --*

      The status message related to the conversion task.

    - **Tags** *(list) --*

      Any tags assigned to the task.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeConversionTasksResponseTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseTypeDef",
    {
        "ConversionTasks": List[
            ClientDescribeConversionTasksResponseConversionTasksTypeDef
        ]
    },
    total=False,
)


class ClientDescribeConversionTasksResponseTypeDef(
    _ClientDescribeConversionTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeConversionTasks` `Response`

    - **ConversionTasks** *(list) --*

      Information about the conversion tasks.

      - *(dict) --*

        Describes a conversion task.

        - **ConversionTaskId** *(string) --*

          The ID of the conversion task.

        - **ExpirationTime** *(string) --*

          The time when the task expires. If the upload isn't complete before the expiration time,
          we automatically cancel the task.

        - **ImportInstance** *(dict) --*

          If the task is for importing an instance, this contains information about the import
          instance task.

          - **Description** *(string) --*

            A description of the task.

          - **InstanceId** *(string) --*

            The ID of the instance.

          - **Platform** *(string) --*

            The instance operating system.

          - **Volumes** *(list) --*

            The volumes.

            - *(dict) --*

              Describes an import volume task.

              - **AvailabilityZone** *(string) --*

                The Availability Zone where the resulting instance will reside.

              - **BytesConverted** *(integer) --*

                The number of bytes converted so far.

              - **Description** *(string) --*

                A description of the task.

              - **Image** *(dict) --*

                The image.

                - **Checksum** *(string) --*

                  The checksum computed for the disk image.

                - **Format** *(string) --*

                  The disk image format.

                - **ImportManifestUrl** *(string) --*

                  A presigned URL for the import manifest stored in Amazon S3. For information
                  about creating a presigned URL for an Amazon S3 object, read the "Query String
                  Request Authentication Alternative" section of the `Authenticating REST Requests
                  <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
                  topic in the *Amazon Simple Storage Service Developer Guide* .

                  For information about the import manifest referenced by this API action, see `VM
                  Import Manifest
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

                - **Size** *(integer) --*

                  The size of the disk image, in GiB.

              - **Status** *(string) --*

                The status of the import of this particular disk image.

              - **StatusMessage** *(string) --*

                The status information or errors related to the disk image.

              - **Volume** *(dict) --*

                The volume.

                - **Id** *(string) --*

                  The volume identifier.

                - **Size** *(integer) --*

                  The size of the volume, in GiB.

        - **ImportVolume** *(dict) --*

          If the task is for importing a volume, this contains information about the import volume
          task.

          - **AvailabilityZone** *(string) --*

            The Availability Zone where the resulting volume will reside.

          - **BytesConverted** *(integer) --*

            The number of bytes converted so far.

          - **Description** *(string) --*

            The description you provided when starting the import volume task.

          - **Image** *(dict) --*

            The image.

            - **Checksum** *(string) --*

              The checksum computed for the disk image.

            - **Format** *(string) --*

              The disk image format.

            - **ImportManifestUrl** *(string) --*

              A presigned URL for the import manifest stored in Amazon S3. For information about
              creating a presigned URL for an Amazon S3 object, read the "Query String Request
              Authentication Alternative" section of the `Authenticating REST Requests
              <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
              the *Amazon Simple Storage Service Developer Guide* .

              For information about the import manifest referenced by this API action, see `VM
              Import Manifest
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

            - **Size** *(integer) --*

              The size of the disk image, in GiB.

          - **Volume** *(dict) --*

            The volume.

            - **Id** *(string) --*

              The volume identifier.

            - **Size** *(integer) --*

              The size of the volume, in GiB.

        - **State** *(string) --*

          The state of the conversion task.

        - **StatusMessage** *(string) --*

          The status message related to the conversion task.

        - **Tags** *(list) --*

          Any tags assigned to the task.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientDescribeCustomerGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeCustomerGatewaysFiltersTypeDef(
    _ClientDescribeCustomerGatewaysFiltersTypeDef
):
    """
    Type definition for `ClientDescribeCustomerGateways` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef(
    _ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef
):
    """
    Type definition for `ClientDescribeCustomerGatewaysResponseCustomerGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef",
    {
        "BgpAsn": str,
        "CustomerGatewayId": str,
        "IpAddress": str,
        "CertificateArn": str,
        "State": str,
        "Type": str,
        "Tags": List[ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef(
    _ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeCustomerGatewaysResponse` `CustomerGateways`

    Describes a customer gateway.

    - **BgpAsn** *(string) --*

      The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway.

    - **IpAddress** *(string) --*

      The Internet-routable IP address of the customer gateway's outside interface.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) for the customer gateway certificate.

    - **State** *(string) --*

      The current state of the customer gateway (``pending | available | deleting | deleted`` ).

    - **Type** *(string) --*

      The type of VPN connection the customer gateway supports (``ipsec.1`` ).

    - **Tags** *(list) --*

      Any tags assigned to the customer gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeCustomerGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseTypeDef",
    {
        "CustomerGateways": List[
            ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef
        ]
    },
    total=False,
)


class ClientDescribeCustomerGatewaysResponseTypeDef(
    _ClientDescribeCustomerGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeCustomerGateways` `Response`

    Contains the output of DescribeCustomerGateways.

    - **CustomerGateways** *(list) --*

      Information about one or more customer gateways.

      - *(dict) --*

        Describes a customer gateway.

        - **BgpAsn** *(string) --*

          The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).

        - **CustomerGatewayId** *(string) --*

          The ID of the customer gateway.

        - **IpAddress** *(string) --*

          The Internet-routable IP address of the customer gateway's outside interface.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) for the customer gateway certificate.

        - **State** *(string) --*

          The current state of the customer gateway (``pending | available | deleting | deleted`` ).

        - **Type** *(string) --*

          The type of VPN connection the customer gateway supports (``ipsec.1`` ).

        - **Tags** *(list) --*

          Any tags assigned to the customer gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientDescribeDhcpOptionsFiltersTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeDhcpOptionsFiltersTypeDef(_ClientDescribeDhcpOptionsFiltersTypeDef):
    """
    Type definition for `ClientDescribeDhcpOptions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    """
    Type definition for `ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurations` `Values`

    Describes a value for a resource attribute that is a String.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[
            ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    Type definition for `ClientDescribeDhcpOptionsResponseDhcpOptions` `DhcpConfigurations`

    Describes a DHCP configuration option.

    - **Key** *(string) --*

      The name of a DHCP option.

    - **Values** *(list) --*

      One or more values for the DHCP option.

      - *(dict) --*

        Describes a value for a resource attribute that is a String.

        - **Value** *(string) --*

          The attribute value. The value is case-sensitive.
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef
):
    """
    Type definition for `ClientDescribeDhcpOptionsResponseDhcpOptions` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef
):
    """
    Type definition for `ClientDescribeDhcpOptionsResponse` `DhcpOptions`

    Describes a set of DHCP options.

    - **DhcpConfigurations** *(list) --*

      One or more DHCP options in the set.

      - *(dict) --*

        Describes a DHCP configuration option.

        - **Key** *(string) --*

          The name of a DHCP option.

        - **Values** *(list) --*

          One or more values for the DHCP option.

          - *(dict) --*

            Describes a value for a resource attribute that is a String.

            - **Value** *(string) --*

              The attribute value. The value is case-sensitive.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the DHCP options set.

    - **Tags** *(list) --*

      Any tags assigned to the DHCP options set.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeDhcpOptionsResponseTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseTypeDef",
    {
        "DhcpOptions": List[ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeDhcpOptionsResponseTypeDef(
    _ClientDescribeDhcpOptionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeDhcpOptions` `Response`

    - **DhcpOptions** *(list) --*

      Information about one or more DHCP options sets.

      - *(dict) --*

        Describes a set of DHCP options.

        - **DhcpConfigurations** *(list) --*

          One or more DHCP options in the set.

          - *(dict) --*

            Describes a DHCP configuration option.

            - **Key** *(string) --*

              The name of a DHCP option.

            - **Values** *(list) --*

              One or more values for the DHCP option.

              - *(dict) --*

                Describes a value for a resource attribute that is a String.

                - **Value** *(string) --*

                  The attribute value. The value is case-sensitive.

        - **DhcpOptionsId** *(string) --*

          The ID of the set of DHCP options.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the DHCP options set.

        - **Tags** *(list) --*

          Any tags assigned to the DHCP options set.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGateways` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef",
    {
        "Attachments": List[
            ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeEgressOnlyInternetGatewaysResponse` `EgressOnlyInternetGateways`

    Describes an egress-only internet gateway.

    - **Attachments** *(list) --*

      Information about the attachment of the egress-only internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef",
    {
        "EgressOnlyInternetGateways": List[
            ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeEgressOnlyInternetGateways` `Response`

    - **EgressOnlyInternetGateways** *(list) --*

      Information about the egress-only internet gateways.

      - *(dict) --*

        Describes an egress-only internet gateway.

        - **Attachments** *(list) --*

          Information about the attachment of the egress-only internet gateway.

          - *(dict) --*

            Describes the attachment of a VPC to an internet gateway or an egress-only internet
            gateway.

            - **State** *(string) --*

              The current state of the attachment. For an internet gateway, the state is
              ``available`` when attached to a VPC; otherwise, this value is not returned.

            - **VpcId** *(string) --*

              The ID of the VPC.

        - **EgressOnlyInternetGatewayId** *(string) --*

          The ID of the egress-only internet gateway.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeElasticGpusFiltersTypeDef = TypedDict(
    "_ClientDescribeElasticGpusFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeElasticGpusFiltersTypeDef(_ClientDescribeElasticGpusFiltersTypeDef):
    """
    Type definition for `ClientDescribeElasticGpus` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef",
    {"Status": str},
    total=False,
)


class ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef(
    _ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef
):
    """
    Type definition for `ClientDescribeElasticGpusResponseElasticGpuSet` `ElasticGpuHealth`

    The status of the Elastic Graphics accelerator.

    - **Status** *(string) --*

      The health status.
    """


_ClientDescribeElasticGpusResponseElasticGpuSetTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseElasticGpuSetTypeDef",
    {
        "ElasticGpuId": str,
        "AvailabilityZone": str,
        "ElasticGpuType": str,
        "ElasticGpuHealth": ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef,
        "ElasticGpuState": str,
        "InstanceId": str,
    },
    total=False,
)


class ClientDescribeElasticGpusResponseElasticGpuSetTypeDef(
    _ClientDescribeElasticGpusResponseElasticGpuSetTypeDef
):
    """
    Type definition for `ClientDescribeElasticGpusResponse` `ElasticGpuSet`

    Describes an Elastic Graphics accelerator.

    - **ElasticGpuId** *(string) --*

      The ID of the Elastic Graphics accelerator.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in the which the Elastic Graphics accelerator resides.

    - **ElasticGpuType** *(string) --*

      The type of Elastic Graphics accelerator.

    - **ElasticGpuHealth** *(dict) --*

      The status of the Elastic Graphics accelerator.

      - **Status** *(string) --*

        The health status.

    - **ElasticGpuState** *(string) --*

      The state of the Elastic Graphics accelerator.

    - **InstanceId** *(string) --*

      The ID of the instance to which the Elastic Graphics accelerator is attached.
    """


_ClientDescribeElasticGpusResponseTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseTypeDef",
    {
        "ElasticGpuSet": List[ClientDescribeElasticGpusResponseElasticGpuSetTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeElasticGpusResponseTypeDef(
    _ClientDescribeElasticGpusResponseTypeDef
):
    """
    Type definition for `ClientDescribeElasticGpus` `Response`

    - **ElasticGpuSet** *(list) --*

      Information about the Elastic Graphics accelerators.

      - *(dict) --*

        Describes an Elastic Graphics accelerator.

        - **ElasticGpuId** *(string) --*

          The ID of the Elastic Graphics accelerator.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in the which the Elastic Graphics accelerator resides.

        - **ElasticGpuType** *(string) --*

          The type of Elastic Graphics accelerator.

        - **ElasticGpuHealth** *(dict) --*

          The status of the Elastic Graphics accelerator.

          - **Status** *(string) --*

            The health status.

        - **ElasticGpuState** *(string) --*

          The state of the Elastic Graphics accelerator.

        - **InstanceId** *(string) --*

          The ID of the instance to which the Elastic Graphics accelerator is attached.

    - **MaxResults** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a Next-Token will be provided in the output that you can
      use to resume pagination.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeExportImageTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeExportImageTasksFiltersTypeDef(
    _ClientDescribeExportImageTasksFiltersTypeDef
):
    """
    Type definition for `ClientDescribeExportImageTasks` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef",
    {"S3Bucket": str, "S3Prefix": str},
    total=False,
)


class ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef(
    _ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef
):
    """
    Type definition for `ClientDescribeExportImageTasksResponseExportImageTasks` `S3ExportLocation`

    Information about the destination S3 bucket.

    - **S3Bucket** *(string) --*

      The destination S3 bucket.

    - **S3Prefix** *(string) --*

      The prefix (logical hierarchy) in the bucket.
    """


_ClientDescribeExportImageTasksResponseExportImageTasksTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseExportImageTasksTypeDef",
    {
        "Description": str,
        "ExportImageTaskId": str,
        "ImageId": str,
        "Progress": str,
        "S3ExportLocation": ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef,
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeExportImageTasksResponseExportImageTasksTypeDef(
    _ClientDescribeExportImageTasksResponseExportImageTasksTypeDef
):
    """
    Type definition for `ClientDescribeExportImageTasksResponse` `ExportImageTasks`

    Describes an export image task.

    - **Description** *(string) --*

      A description of the image being exported.

    - **ExportImageTaskId** *(string) --*

      The ID of the export image task.

    - **ImageId** *(string) --*

      The ID of the image.

    - **Progress** *(string) --*

      The percent complete of the export image task.

    - **S3ExportLocation** *(dict) --*

      Information about the destination S3 bucket.

      - **S3Bucket** *(string) --*

        The destination S3 bucket.

      - **S3Prefix** *(string) --*

        The prefix (logical hierarchy) in the bucket.

    - **Status** *(string) --*

      The status of the export image task. The possible values are ``active`` , ``completed`` ,
      ``deleting`` , and ``deleted`` .

    - **StatusMessage** *(string) --*

      The status message for the export image task.
    """


_ClientDescribeExportImageTasksResponseTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseTypeDef",
    {
        "ExportImageTasks": List[
            ClientDescribeExportImageTasksResponseExportImageTasksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeExportImageTasksResponseTypeDef(
    _ClientDescribeExportImageTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeExportImageTasks` `Response`

    - **ExportImageTasks** *(list) --*

      Information about the export image tasks.

      - *(dict) --*

        Describes an export image task.

        - **Description** *(string) --*

          A description of the image being exported.

        - **ExportImageTaskId** *(string) --*

          The ID of the export image task.

        - **ImageId** *(string) --*

          The ID of the image.

        - **Progress** *(string) --*

          The percent complete of the export image task.

        - **S3ExportLocation** *(dict) --*

          Information about the destination S3 bucket.

          - **S3Bucket** *(string) --*

            The destination S3 bucket.

          - **S3Prefix** *(string) --*

            The prefix (logical hierarchy) in the bucket.

        - **Status** *(string) --*

          The status of the export image task. The possible values are ``active`` , ``completed`` ,
          ``deleting`` , and ``deleted`` .

        - **StatusMessage** *(string) --*

          The status message for the export image task.

    - **NextToken** *(string) --*

      The token to use to get the next page of results. This value is ``null`` when there are no
      more results to return.
    """


_ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef",
    {"ContainerFormat": str, "DiskImageFormat": str, "S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef(
    _ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef
):
    """
    Type definition for `ClientDescribeExportTasksResponseExportTasks` `ExportToS3Task`

    Information about the export task.

    - **ContainerFormat** *(string) --*

      The container format used to combine disk images with metadata (such as OVF). If
      absent, only the disk image is exported.

    - **DiskImageFormat** *(string) --*

      The format for the exported image.

    - **S3Bucket** *(string) --*

      The S3 bucket for the destination image. The destination bucket must exist and grant
      WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

    - **S3Key** *(string) --*

      The encryption key for your S3 bucket.
    """


_ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef",
    {"InstanceId": str, "TargetEnvironment": str},
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef(
    _ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef
):
    """
    Type definition for `ClientDescribeExportTasksResponseExportTasks` `InstanceExportDetails`

    Information about the instance to export.

    - **InstanceId** *(string) --*

      The ID of the resource being exported.

    - **TargetEnvironment** *(string) --*

      The target virtualization environment.
    """


_ClientDescribeExportTasksResponseExportTasksTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksTypeDef",
    {
        "Description": str,
        "ExportTaskId": str,
        "ExportToS3Task": ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef,
        "InstanceExportDetails": ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef,
        "State": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksTypeDef(
    _ClientDescribeExportTasksResponseExportTasksTypeDef
):
    """
    Type definition for `ClientDescribeExportTasksResponse` `ExportTasks`

    Describes an instance export task.

    - **Description** *(string) --*

      A description of the resource being exported.

    - **ExportTaskId** *(string) --*

      The ID of the export task.

    - **ExportToS3Task** *(dict) --*

      Information about the export task.

      - **ContainerFormat** *(string) --*

        The container format used to combine disk images with metadata (such as OVF). If
        absent, only the disk image is exported.

      - **DiskImageFormat** *(string) --*

        The format for the exported image.

      - **S3Bucket** *(string) --*

        The S3 bucket for the destination image. The destination bucket must exist and grant
        WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

      - **S3Key** *(string) --*

        The encryption key for your S3 bucket.

    - **InstanceExportDetails** *(dict) --*

      Information about the instance to export.

      - **InstanceId** *(string) --*

        The ID of the resource being exported.

      - **TargetEnvironment** *(string) --*

        The target virtualization environment.

    - **State** *(string) --*

      The state of the export task.

    - **StatusMessage** *(string) --*

      The status message related to the export task.
    """


_ClientDescribeExportTasksResponseTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseTypeDef",
    {"ExportTasks": List[ClientDescribeExportTasksResponseExportTasksTypeDef]},
    total=False,
)


class ClientDescribeExportTasksResponseTypeDef(
    _ClientDescribeExportTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeExportTasks` `Response`

    - **ExportTasks** *(list) --*

      Information about the export tasks.

      - *(dict) --*

        Describes an instance export task.

        - **Description** *(string) --*

          A description of the resource being exported.

        - **ExportTaskId** *(string) --*

          The ID of the export task.

        - **ExportToS3Task** *(dict) --*

          Information about the export task.

          - **ContainerFormat** *(string) --*

            The container format used to combine disk images with metadata (such as OVF). If
            absent, only the disk image is exported.

          - **DiskImageFormat** *(string) --*

            The format for the exported image.

          - **S3Bucket** *(string) --*

            The S3 bucket for the destination image. The destination bucket must exist and grant
            WRITE and READ_ACP permissions to the AWS account ``vm-import-export@amazon.com`` .

          - **S3Key** *(string) --*

            The encryption key for your S3 bucket.

        - **InstanceExportDetails** *(dict) --*

          Information about the instance to export.

          - **InstanceId** *(string) --*

            The ID of the resource being exported.

          - **TargetEnvironment** *(string) --*

            The target virtualization environment.

        - **State** *(string) --*

          The state of the export task.

        - **StatusMessage** *(string) --*

          The status message related to the export task.
    """


_ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef",
    {"EventDescription": str, "EventSubType": str, "InstanceId": str},
    total=False,
)


class ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef(
    _ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef
):
    """
    Type definition for `ClientDescribeFleetHistoryResponseHistoryRecords` `EventInformation`

    Information about the event.

    - **EventDescription** *(string) --*

      The description of the event.

    - **EventSubType** *(string) --*

      The event.

      The following are the ``error`` events:

      * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
      permissions either to launch or terminate an instance.

      * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
      information, see the description of the event.

      * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
      Instances that you can launch.

      The following are the ``fleetRequestChange`` events:

      * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
      attempting to maintain the target number of running Spot Instances.

      * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
      Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
      instances were terminated.

      * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
      launch additional Spot Instances. Existing Spot Instances continue to run until they
      are interrupted or terminated.

      * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
      Spot Instances are terminating.

      * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
      indicates that the instances were terminated, if the request was created with
      ``TerminateInstancesWithExpiration`` set.

      * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
      accepted and is in progress.

      * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

      * ``price_update`` - The price for a launch configuration was adjusted because it was
      too high. This change is permanent.

      * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
      is preparing to launch the target number of Spot Instances.

      The following are the ``instanceChange`` events:

      * ``launched`` - A request was fulfilled and a new instance was launched.

      * ``terminated`` - An instance was terminated by the user.

      The following are the ``Information`` events:

      * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
      attempts to launch instances have failed. For more information, see the description of
      the event.

      * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
      is below the Spot price or the Spot price is above the On-Demand price.

      * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
      launch specification might become valid if the Spot price changes.

    - **InstanceId** *(string) --*

      The ID of the instance. This information is available only for ``instanceChange``
      events.
    """


_ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef",
    {
        "EventInformation": ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef,
        "EventType": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef(
    _ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef
):
    """
    Type definition for `ClientDescribeFleetHistoryResponse` `HistoryRecords`

    Describes an event in the history of an EC2 Fleet.

    - **EventInformation** *(dict) --*

      Information about the event.

      - **EventDescription** *(string) --*

        The description of the event.

      - **EventSubType** *(string) --*

        The event.

        The following are the ``error`` events:

        * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
        permissions either to launch or terminate an instance.

        * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
        information, see the description of the event.

        * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
        Instances that you can launch.

        The following are the ``fleetRequestChange`` events:

        * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
        attempting to maintain the target number of running Spot Instances.

        * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
        Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
        instances were terminated.

        * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
        launch additional Spot Instances. Existing Spot Instances continue to run until they
        are interrupted or terminated.

        * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
        Spot Instances are terminating.

        * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
        indicates that the instances were terminated, if the request was created with
        ``TerminateInstancesWithExpiration`` set.

        * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
        accepted and is in progress.

        * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

        * ``price_update`` - The price for a launch configuration was adjusted because it was
        too high. This change is permanent.

        * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
        is preparing to launch the target number of Spot Instances.

        The following are the ``instanceChange`` events:

        * ``launched`` - A request was fulfilled and a new instance was launched.

        * ``terminated`` - An instance was terminated by the user.

        The following are the ``Information`` events:

        * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
        attempts to launch instances have failed. For more information, see the description of
        the event.

        * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
        is below the Spot price or the Spot price is above the On-Demand price.

        * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
        launch specification might become valid if the Spot price changes.

      - **InstanceId** *(string) --*

        The ID of the instance. This information is available only for ``instanceChange``
        events.

    - **EventType** *(string) --*

      The event type.

    - **Timestamp** *(datetime) --*

      The date and time of the event, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
      :*MM* :*SS* Z).
    """


_ClientDescribeFleetHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseTypeDef",
    {
        "HistoryRecords": List[ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "FleetId": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientDescribeFleetHistoryResponseTypeDef(
    _ClientDescribeFleetHistoryResponseTypeDef
):
    """
    Type definition for `ClientDescribeFleetHistory` `Response`

    - **HistoryRecords** *(list) --*

      Information about the events in the history of the EC2 Fleet.

      - *(dict) --*

        Describes an event in the history of an EC2 Fleet.

        - **EventInformation** *(dict) --*

          Information about the event.

          - **EventDescription** *(string) --*

            The description of the event.

          - **EventSubType** *(string) --*

            The event.

            The following are the ``error`` events:

            * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
            permissions either to launch or terminate an instance.

            * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
            information, see the description of the event.

            * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
            Instances that you can launch.

            The following are the ``fleetRequestChange`` events:

            * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
            attempting to maintain the target number of running Spot Instances.

            * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
            Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
            instances were terminated.

            * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
            launch additional Spot Instances. Existing Spot Instances continue to run until they
            are interrupted or terminated.

            * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
            Spot Instances are terminating.

            * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
            indicates that the instances were terminated, if the request was created with
            ``TerminateInstancesWithExpiration`` set.

            * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
            accepted and is in progress.

            * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

            * ``price_update`` - The price for a launch configuration was adjusted because it was
            too high. This change is permanent.

            * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
            is preparing to launch the target number of Spot Instances.

            The following are the ``instanceChange`` events:

            * ``launched`` - A request was fulfilled and a new instance was launched.

            * ``terminated`` - An instance was terminated by the user.

            The following are the ``Information`` events:

            * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
            attempts to launch instances have failed. For more information, see the description of
            the event.

            * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
            is below the Spot price or the Spot price is above the On-Demand price.

            * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
            launch specification might become valid if the Spot price changes.

          - **InstanceId** *(string) --*

            The ID of the instance. This information is available only for ``instanceChange``
            events.

        - **EventType** *(string) --*

          The event type.

        - **Timestamp** *(datetime) --*

          The date and time of the event, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
          :*MM* :*SS* Z).

    - **LastEvaluatedTime** *(datetime) --*

      The last date and time for the events, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
      :*MM* :*SS* Z). All records up to this time were retrieved.

      If ``nextToken`` indicates that there are more results, this value is not present.

    - **NextToken** *(string) --*

      The token for the next set of results.

    - **FleetId** *(string) --*

      The ID of the EC Fleet.

    - **StartTime** *(datetime) --*

      The start date and time for the events, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
      :*MM* :*SS* Z).
    """


_ClientDescribeFleetInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeFleetInstancesFiltersTypeDef(
    _ClientDescribeFleetInstancesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeFleetInstances` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeFleetInstancesResponseActiveInstancesTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": str,
    },
    total=False,
)


class ClientDescribeFleetInstancesResponseActiveInstancesTypeDef(
    _ClientDescribeFleetInstancesResponseActiveInstancesTypeDef
):
    """
    Type definition for `ClientDescribeFleetInstancesResponse` `ActiveInstances`

    Describes a running instance in a Spot Fleet.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **InstanceHealth** *(string) --*

      The health status of the instance. If the status of either the instance status check or
      the system status check is ``impaired`` , the health status of the instance is
      ``unhealthy`` . Otherwise, the health status is ``healthy`` .
    """


_ClientDescribeFleetInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesResponseTypeDef",
    {
        "ActiveInstances": List[
            ClientDescribeFleetInstancesResponseActiveInstancesTypeDef
        ],
        "NextToken": str,
        "FleetId": str,
    },
    total=False,
)


class ClientDescribeFleetInstancesResponseTypeDef(
    _ClientDescribeFleetInstancesResponseTypeDef
):
    """
    Type definition for `ClientDescribeFleetInstances` `Response`

    - **ActiveInstances** *(list) --*

      The running instances. This list is refreshed periodically and might be out of date.

      - *(dict) --*

        Describes a running instance in a Spot Fleet.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **InstanceHealth** *(string) --*

          The health status of the instance. If the status of either the instance status check or
          the system status check is ``impaired`` , the health status of the instance is
          ``unhealthy`` . Otherwise, the health status is ``healthy`` .

    - **NextToken** *(string) --*

      The token for the next set of results.

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.
    """


_ClientDescribeFleetsFiltersTypeDef = TypedDict(
    "_ClientDescribeFleetsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeFleetsFiltersTypeDef(_ClientDescribeFleetsFiltersTypeDef):
    """
    Type definition for `ClientDescribeFleets` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsErrors` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the
    launch template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set
        to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
        override to use first in fulfilling On-Demand capacity. The highest priority is
        launched first. Valid values are whole numbers starting at ``0`` . The lower the
        number, the higher the priority. If no number is set, the override has the lowest
        priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsErrorsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `Errors`

    Describes the instances that could not be launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the
      launch template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a
          template name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that could not be launched was a Spot Instance or On-Demand
      Instance.

    - **ErrorCode** *(string) --*

      The error code that indicates why the instance could not be launched. For more
      information about error codes, see `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
      .

    - **ErrorMessage** *(string) --*

      The error message that describes why the instance could not be launched. For more
      information about error messages, see ee `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
      .
    """


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsInstances` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the
    launch template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set
        to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
        override to use first in fulfilling On-Demand capacity. The highest priority is
        launched first. Valid values are whole numbers starting at ``0`` . The lower the
        number, the higher the priority. If no number is set, the override has the lowest
        priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsInstancesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "InstanceIds": List[str],
        "InstanceType": str,
        "Platform": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `Instances`

    Describes the instances that were launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the
      launch template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a
          template name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

    - **InstanceIds** *(list) --*

      The IDs of the instances.

      - *(string) --*

    - **InstanceType** *(string) --*

      The instance type.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.
    """


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a template
      name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleetsLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a template
        name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.
    """


_ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef(
    _ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `OnDemandOptions`

    The allocation strategy of On-Demand Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If
      you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
      the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
      that you assigned to each launch template override, launching the highest priority
      first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all On-Demand Instances
      in the fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all On-Demand Instances into a single Availability
      Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
      capacity is not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay.
    """


_ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "InstanceInterruptionBehavior": str,
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef(
    _ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `SpotOptions`

    The configuration of Spot Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance
      pools specified by the EC2 Fleet.

      If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
      Spot Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
      the Spot Instance pools that you specify.

      If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
      from Spot Instance pools with optimal capacity for the number of instances that are
      launching.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only
      when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
      Spot pools and evenly allocates your target Spot capacity across the number of Spot
      pools that you specify.

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all Spot Instances in
      the fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all Spot Instances into a single Availability Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for Spot Instances in the fleet. If the minimum target
      capacity is not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay.
    """


_ClientDescribeFleetsResponseFleetsTagsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsTagsTypeDef(
    _ClientDescribeFleetsResponseFleetsTagsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef",
    {
        "TotalTargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponseFleets` `TargetCapacitySpecification`

    The number of units to request. You can choose to set the target capacity in terms of
    instances or a performance characteristic that is important to your application workload,
    such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
    target capacity of 0 and add capacity later.

    - **TotalTargetCapacity** *(integer) --*

      The number of units to request, filled using ``DefaultTargetCapacityType`` .

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request. If you specify a target capacity for Spot
      units, you cannot specify a target capacity for On-Demand units.

    - **SpotTargetCapacity** *(integer) --*

      The maximum number of Spot units to launch. If you specify a target capacity for
      On-Demand units, you cannot specify a target capacity for Spot units.

    - **DefaultTargetCapacityType** *(string) --*

      The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .
    """


_ClientDescribeFleetsResponseFleetsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTypeDef",
    {
        "ActivityStatus": str,
        "CreateTime": datetime,
        "FleetId": str,
        "FleetState": str,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": str,
        "FulfilledCapacity": float,
        "FulfilledOnDemandCapacity": float,
        "LaunchTemplateConfigs": List[
            ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef
        ],
        "TargetCapacitySpecification": ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef,
        "TerminateInstancesWithExpiration": bool,
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "SpotOptions": ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef,
        "OnDemandOptions": ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef,
        "Tags": List[ClientDescribeFleetsResponseFleetsTagsTypeDef],
        "Errors": List[ClientDescribeFleetsResponseFleetsErrorsTypeDef],
        "Instances": List[ClientDescribeFleetsResponseFleetsInstancesTypeDef],
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsTypeDef(
    _ClientDescribeFleetsResponseFleetsTypeDef
):
    """
    Type definition for `ClientDescribeFleetsResponse` `Fleets`

    Describes an EC2 Fleet.

    - **ActivityStatus** *(string) --*

      The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
      requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2 Fleet
      is equal to or greater than its target capacity, the status is ``fulfilled`` . If the
      size of the EC2 Fleet is decreased, the status is ``pending_termination`` while instances
      are terminating.

    - **CreateTime** *(datetime) --*

      The creation date and time of the EC2 Fleet.

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.

    - **FleetState** *(string) --*

      The state of the EC2 Fleet.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
      For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

      Constraints: Maximum 64 ASCII characters

    - **ExcessCapacityTerminationPolicy** *(string) --*

      Indicates whether running instances should be terminated if the target capacity of the
      EC2 Fleet is decreased below the current size of the EC2 Fleet.

    - **FulfilledCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target capacity.

    - **FulfilledOnDemandCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target On-Demand
      capacity.

    - **LaunchTemplateConfigs** *(list) --*

      The launch template and overrides.

      - *(dict) --*

        Describes a launch template and overrides.

        - **LaunchTemplateSpecification** *(dict) --*

          The launch template.

          - **LaunchTemplateId** *(string) --*

            The ID of the launch template. You must specify either a template ID or a template
            name.

          - **LaunchTemplateName** *(string) --*

            The name of the launch template. You must specify either a template name or a
            template ID.

          - **Version** *(string) --*

            The version number of the launch template. You must specify a version number.

        - **Overrides** *(list) --*

          Any parameters that you specify override the same parameters in the launch template.

          - *(dict) --*

            Describes overrides for a launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

    - **TargetCapacitySpecification** *(dict) --*

      The number of units to request. You can choose to set the target capacity in terms of
      instances or a performance characteristic that is important to your application workload,
      such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
      target capacity of 0 and add capacity later.

      - **TotalTargetCapacity** *(integer) --*

        The number of units to request, filled using ``DefaultTargetCapacityType`` .

      - **OnDemandTargetCapacity** *(integer) --*

        The number of On-Demand units to request. If you specify a target capacity for Spot
        units, you cannot specify a target capacity for On-Demand units.

      - **SpotTargetCapacity** *(integer) --*

        The maximum number of Spot units to launch. If you specify a target capacity for
        On-Demand units, you cannot specify a target capacity for Spot units.

      - **DefaultTargetCapacityType** *(string) --*

        The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .

    - **TerminateInstancesWithExpiration** *(boolean) --*

      Indicates whether running instances should be terminated when the EC2 Fleet expires.

    - **Type** *(string) --*

      The type of request. Indicates whether the EC2 Fleet only ``requests`` the target
      capacity, or also attempts to ``maintain`` it. If you request a certain target capacity,
      EC2 Fleet only places the required requests; it does not attempt to replenish instances
      if capacity is diminished, and does not submit requests in alternative capacity pools if
      capacity is unavailable. To maintain a certain target capacity, EC2 Fleet places the
      required requests to meet this target capacity. It also automatically replenishes any
      interrupted Spot Instances. Default: ``maintain`` .

    - **ValidFrom** *(datetime) --*

      The start date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z). The default is to start fulfilling the request immediately.

    - **ValidUntil** *(datetime) --*

      The end date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z). At this point, no new instance requests are placed or able to
      fulfill the request. The default end date is 7 days from the current date.

    - **ReplaceUnhealthyInstances** *(boolean) --*

      Indicates whether EC2 Fleet should replace unhealthy instances.

    - **SpotOptions** *(dict) --*

      The configuration of Spot Instances in an EC2 Fleet.

      - **AllocationStrategy** *(string) --*

        Indicates how to allocate the target Spot Instance capacity across the Spot Instance
        pools specified by the EC2 Fleet.

        If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
        Spot Instance pools with the lowest price. This is the default allocation strategy.

        If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
        the Spot Instance pools that you specify.

        If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
        from Spot Instance pools with optimal capacity for the number of instances that are
        launching.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

      - **InstancePoolsToUseCount** *(integer) --*

        The number of Spot pools across which to allocate your target Spot capacity. Valid only
        when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
        Spot pools and evenly allocates your target Spot capacity across the number of Spot
        pools that you specify.

      - **SingleInstanceType** *(boolean) --*

        Indicates that the fleet uses a single instance type to launch all Spot Instances in
        the fleet.

      - **SingleAvailabilityZone** *(boolean) --*

        Indicates that the fleet launches all Spot Instances into a single Availability Zone.

      - **MinTargetCapacity** *(integer) --*

        The minimum target capacity for Spot Instances in the fleet. If the minimum target
        capacity is not reached, the fleet launches no instances.

      - **MaxTotalPrice** *(string) --*

        The maximum amount per hour for Spot Instances that you're willing to pay.

    - **OnDemandOptions** *(dict) --*

      The allocation strategy of On-Demand Instances in an EC2 Fleet.

      - **AllocationStrategy** *(string) --*

        The order of the launch template overrides to use in fulfilling On-Demand capacity. If
        you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
        the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
        that you assigned to each launch template override, launching the highest priority
        first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

      - **SingleInstanceType** *(boolean) --*

        Indicates that the fleet uses a single instance type to launch all On-Demand Instances
        in the fleet.

      - **SingleAvailabilityZone** *(boolean) --*

        Indicates that the fleet launches all On-Demand Instances into a single Availability
        Zone.

      - **MinTargetCapacity** *(integer) --*

        The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
        capacity is not reached, the fleet launches no instances.

      - **MaxTotalPrice** *(string) --*

        The maximum amount per hour for On-Demand Instances that you're willing to pay.

    - **Tags** *(list) --*

      The tags for an EC2 Fleet resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Errors** *(list) --*

      Information about the instances that could not be launched by the fleet. Valid only when
      **Type** is set to ``instant`` .

      - *(dict) --*

        Describes the instances that could not be launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the
          launch template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that could not be launched was a Spot Instance or On-Demand
          Instance.

        - **ErrorCode** *(string) --*

          The error code that indicates why the instance could not be launched. For more
          information about error codes, see `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
          .

        - **ErrorMessage** *(string) --*

          The error message that describes why the instance could not be launched. For more
          information about error messages, see ee `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
          .

    - **Instances** *(list) --*

      Information about the instances that were launched by the fleet. Valid only when **Type**
      is set to ``instant`` .

      - *(dict) --*

        Describes the instances that were launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the
          launch template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

        - **InstanceIds** *(list) --*

          The IDs of the instances.

          - *(string) --*

        - **InstanceType** *(string) --*

          The instance type.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.
    """


_ClientDescribeFleetsResponseTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseTypeDef",
    {"NextToken": str, "Fleets": List[ClientDescribeFleetsResponseFleetsTypeDef]},
    total=False,
)


class ClientDescribeFleetsResponseTypeDef(_ClientDescribeFleetsResponseTypeDef):
    """
    Type definition for `ClientDescribeFleets` `Response`

    - **NextToken** *(string) --*

      The token for the next set of results.

    - **Fleets** *(list) --*

      Information about the EC2 Fleets.

      - *(dict) --*

        Describes an EC2 Fleet.

        - **ActivityStatus** *(string) --*

          The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
          requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2 Fleet
          is equal to or greater than its target capacity, the status is ``fulfilled`` . If the
          size of the EC2 Fleet is decreased, the status is ``pending_termination`` while instances
          are terminating.

        - **CreateTime** *(datetime) --*

          The creation date and time of the EC2 Fleet.

        - **FleetId** *(string) --*

          The ID of the EC2 Fleet.

        - **FleetState** *(string) --*

          The state of the EC2 Fleet.

        - **ClientToken** *(string) --*

          Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
          For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

          Constraints: Maximum 64 ASCII characters

        - **ExcessCapacityTerminationPolicy** *(string) --*

          Indicates whether running instances should be terminated if the target capacity of the
          EC2 Fleet is decreased below the current size of the EC2 Fleet.

        - **FulfilledCapacity** *(float) --*

          The number of units fulfilled by this request compared to the set target capacity.

        - **FulfilledOnDemandCapacity** *(float) --*

          The number of units fulfilled by this request compared to the set target On-Demand
          capacity.

        - **LaunchTemplateConfigs** *(list) --*

          The launch template and overrides.

          - *(dict) --*

            Describes a launch template and overrides.

            - **LaunchTemplateSpecification** *(dict) --*

              The launch template.

              - **LaunchTemplateId** *(string) --*

                The ID of the launch template. You must specify either a template ID or a template
                name.

              - **LaunchTemplateName** *(string) --*

                The name of the launch template. You must specify either a template name or a
                template ID.

              - **Version** *(string) --*

                The version number of the launch template. You must specify a version number.

            - **Overrides** *(list) --*

              Any parameters that you specify override the same parameters in the launch template.

              - *(dict) --*

                Describes overrides for a launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

        - **TargetCapacitySpecification** *(dict) --*

          The number of units to request. You can choose to set the target capacity in terms of
          instances or a performance characteristic that is important to your application workload,
          such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
          target capacity of 0 and add capacity later.

          - **TotalTargetCapacity** *(integer) --*

            The number of units to request, filled using ``DefaultTargetCapacityType`` .

          - **OnDemandTargetCapacity** *(integer) --*

            The number of On-Demand units to request. If you specify a target capacity for Spot
            units, you cannot specify a target capacity for On-Demand units.

          - **SpotTargetCapacity** *(integer) --*

            The maximum number of Spot units to launch. If you specify a target capacity for
            On-Demand units, you cannot specify a target capacity for Spot units.

          - **DefaultTargetCapacityType** *(string) --*

            The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .

        - **TerminateInstancesWithExpiration** *(boolean) --*

          Indicates whether running instances should be terminated when the EC2 Fleet expires.

        - **Type** *(string) --*

          The type of request. Indicates whether the EC2 Fleet only ``requests`` the target
          capacity, or also attempts to ``maintain`` it. If you request a certain target capacity,
          EC2 Fleet only places the required requests; it does not attempt to replenish instances
          if capacity is diminished, and does not submit requests in alternative capacity pools if
          capacity is unavailable. To maintain a certain target capacity, EC2 Fleet places the
          required requests to meet this target capacity. It also automatically replenishes any
          interrupted Spot Instances. Default: ``maintain`` .

        - **ValidFrom** *(datetime) --*

          The start date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z). The default is to start fulfilling the request immediately.

        - **ValidUntil** *(datetime) --*

          The end date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z). At this point, no new instance requests are placed or able to
          fulfill the request. The default end date is 7 days from the current date.

        - **ReplaceUnhealthyInstances** *(boolean) --*

          Indicates whether EC2 Fleet should replace unhealthy instances.

        - **SpotOptions** *(dict) --*

          The configuration of Spot Instances in an EC2 Fleet.

          - **AllocationStrategy** *(string) --*

            Indicates how to allocate the target Spot Instance capacity across the Spot Instance
            pools specified by the EC2 Fleet.

            If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
            Spot Instance pools with the lowest price. This is the default allocation strategy.

            If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
            the Spot Instance pools that you specify.

            If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
            from Spot Instance pools with optimal capacity for the number of instances that are
            launching.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

          - **InstancePoolsToUseCount** *(integer) --*

            The number of Spot pools across which to allocate your target Spot capacity. Valid only
            when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
            Spot pools and evenly allocates your target Spot capacity across the number of Spot
            pools that you specify.

          - **SingleInstanceType** *(boolean) --*

            Indicates that the fleet uses a single instance type to launch all Spot Instances in
            the fleet.

          - **SingleAvailabilityZone** *(boolean) --*

            Indicates that the fleet launches all Spot Instances into a single Availability Zone.

          - **MinTargetCapacity** *(integer) --*

            The minimum target capacity for Spot Instances in the fleet. If the minimum target
            capacity is not reached, the fleet launches no instances.

          - **MaxTotalPrice** *(string) --*

            The maximum amount per hour for Spot Instances that you're willing to pay.

        - **OnDemandOptions** *(dict) --*

          The allocation strategy of On-Demand Instances in an EC2 Fleet.

          - **AllocationStrategy** *(string) --*

            The order of the launch template overrides to use in fulfilling On-Demand capacity. If
            you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
            the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
            that you assigned to each launch template override, launching the highest priority
            first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

          - **SingleInstanceType** *(boolean) --*

            Indicates that the fleet uses a single instance type to launch all On-Demand Instances
            in the fleet.

          - **SingleAvailabilityZone** *(boolean) --*

            Indicates that the fleet launches all On-Demand Instances into a single Availability
            Zone.

          - **MinTargetCapacity** *(integer) --*

            The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
            capacity is not reached, the fleet launches no instances.

          - **MaxTotalPrice** *(string) --*

            The maximum amount per hour for On-Demand Instances that you're willing to pay.

        - **Tags** *(list) --*

          The tags for an EC2 Fleet resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Errors** *(list) --*

          Information about the instances that could not be launched by the fleet. Valid only when
          **Type** is set to ``instant`` .

          - *(dict) --*

            Describes the instances that could not be launched by the fleet.

            - **LaunchTemplateAndOverrides** *(dict) --*

              The launch templates and overrides that were used for launching the instances. Any
              parameters that you specify in the Overrides override the same parameters in the
              launch template.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(dict) --*

                Any parameters that you specify override the same parameters in the launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

            - **Lifecycle** *(string) --*

              Indicates if the instance that could not be launched was a Spot Instance or On-Demand
              Instance.

            - **ErrorCode** *(string) --*

              The error code that indicates why the instance could not be launched. For more
              information about error codes, see `Error Codes
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
              .

            - **ErrorMessage** *(string) --*

              The error message that describes why the instance could not be launched. For more
              information about error messages, see ee `Error Codes
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
              .

        - **Instances** *(list) --*

          Information about the instances that were launched by the fleet. Valid only when **Type**
          is set to ``instant`` .

          - *(dict) --*

            Describes the instances that were launched by the fleet.

            - **LaunchTemplateAndOverrides** *(dict) --*

              The launch templates and overrides that were used for launching the instances. Any
              parameters that you specify in the Overrides override the same parameters in the
              launch template.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(dict) --*

                Any parameters that you specify override the same parameters in the launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

            - **Lifecycle** *(string) --*

              Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

            - **InstanceIds** *(list) --*

              The IDs of the instances.

              - *(string) --*

            - **InstanceType** *(string) --*

              The instance type.

            - **Platform** *(string) --*

              The value is ``Windows`` for Windows instances; otherwise blank.
    """


_ClientDescribeFlowLogsFiltersTypeDef = TypedDict(
    "_ClientDescribeFlowLogsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeFlowLogsFiltersTypeDef(_ClientDescribeFlowLogsFiltersTypeDef):
    """
    Type definition for `ClientDescribeFlowLogs` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeFlowLogsResponseFlowLogsTypeDef = TypedDict(
    "_ClientDescribeFlowLogsResponseFlowLogsTypeDef",
    {
        "CreationTime": datetime,
        "DeliverLogsErrorMessage": str,
        "DeliverLogsPermissionArn": str,
        "DeliverLogsStatus": str,
        "FlowLogId": str,
        "FlowLogStatus": str,
        "LogGroupName": str,
        "ResourceId": str,
        "TrafficType": str,
        "LogDestinationType": str,
        "LogDestination": str,
        "LogFormat": str,
    },
    total=False,
)


class ClientDescribeFlowLogsResponseFlowLogsTypeDef(
    _ClientDescribeFlowLogsResponseFlowLogsTypeDef
):
    """
    Type definition for `ClientDescribeFlowLogsResponse` `FlowLogs`

    Describes a flow log.

    - **CreationTime** *(datetime) --*

      The date and time the flow log was created.

    - **DeliverLogsErrorMessage** *(string) --*

      Information about the error that occurred. ``Rate limited`` indicates that CloudWatch
      Logs throttling has been applied for one or more network interfaces, or that you've
      reached the limit on the number of log groups that you can create. ``Access error``
      indicates that the IAM role associated with the flow log does not have sufficient
      permissions to publish to CloudWatch Logs. ``Unknown error`` indicates an internal error.

    - **DeliverLogsPermissionArn** *(string) --*

      The ARN of the IAM role that posts logs to CloudWatch Logs.

    - **DeliverLogsStatus** *(string) --*

      The status of the logs delivery (``SUCCESS`` | ``FAILED`` ).

    - **FlowLogId** *(string) --*

      The flow log ID.

    - **FlowLogStatus** *(string) --*

      The status of the flow log (``ACTIVE`` ).

    - **LogGroupName** *(string) --*

      The name of the flow log group.

    - **ResourceId** *(string) --*

      The ID of the resource on which the flow log was created.

    - **TrafficType** *(string) --*

      The type of traffic captured for the flow log.

    - **LogDestinationType** *(string) --*

      Specifies the type of destination to which the flow log data is published. Flow log data
      can be published to CloudWatch Logs or Amazon S3.

    - **LogDestination** *(string) --*

      Specifies the destination to which the flow log data is published. Flow log data can be
      published to an CloudWatch Logs log group or an Amazon S3 bucket. If the flow log
      publishes to CloudWatch Logs, this element indicates the Amazon Resource Name (ARN) of
      the CloudWatch Logs log group to which the data is published. If the flow log publishes
      to Amazon S3, this element indicates the ARN of the Amazon S3 bucket to which the data is
      published.

    - **LogFormat** *(string) --*

      The format of the flow log record.
    """


_ClientDescribeFlowLogsResponseTypeDef = TypedDict(
    "_ClientDescribeFlowLogsResponseTypeDef",
    {"FlowLogs": List[ClientDescribeFlowLogsResponseFlowLogsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeFlowLogsResponseTypeDef(_ClientDescribeFlowLogsResponseTypeDef):
    """
    Type definition for `ClientDescribeFlowLogs` `Response`

    - **FlowLogs** *(list) --*

      Information about the flow logs.

      - *(dict) --*

        Describes a flow log.

        - **CreationTime** *(datetime) --*

          The date and time the flow log was created.

        - **DeliverLogsErrorMessage** *(string) --*

          Information about the error that occurred. ``Rate limited`` indicates that CloudWatch
          Logs throttling has been applied for one or more network interfaces, or that you've
          reached the limit on the number of log groups that you can create. ``Access error``
          indicates that the IAM role associated with the flow log does not have sufficient
          permissions to publish to CloudWatch Logs. ``Unknown error`` indicates an internal error.

        - **DeliverLogsPermissionArn** *(string) --*

          The ARN of the IAM role that posts logs to CloudWatch Logs.

        - **DeliverLogsStatus** *(string) --*

          The status of the logs delivery (``SUCCESS`` | ``FAILED`` ).

        - **FlowLogId** *(string) --*

          The flow log ID.

        - **FlowLogStatus** *(string) --*

          The status of the flow log (``ACTIVE`` ).

        - **LogGroupName** *(string) --*

          The name of the flow log group.

        - **ResourceId** *(string) --*

          The ID of the resource on which the flow log was created.

        - **TrafficType** *(string) --*

          The type of traffic captured for the flow log.

        - **LogDestinationType** *(string) --*

          Specifies the type of destination to which the flow log data is published. Flow log data
          can be published to CloudWatch Logs or Amazon S3.

        - **LogDestination** *(string) --*

          Specifies the destination to which the flow log data is published. Flow log data can be
          published to an CloudWatch Logs log group or an Amazon S3 bucket. If the flow log
          publishes to CloudWatch Logs, this element indicates the Amazon Resource Name (ARN) of
          the CloudWatch Logs log group to which the data is published. If the flow log publishes
          to Amazon S3, this element indicates the ARN of the Amazon S3 bucket to which the data is
          published.

        - **LogFormat** *(string) --*

          The format of the flow log record.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    {"UserId": str, "Group": str},
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImageAttributeResponseFpgaImageAttribute` `LoadPermissions`

    Describes a load permission.

    - **UserId** *(string) --*

      The AWS account ID.

    - **Group** *(string) --*

      The name of the group.
    """


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImageAttributeResponseFpgaImageAttribute` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    {
        "FpgaImageId": str,
        "Name": str,
        "Description": str,
        "LoadPermissions": List[
            ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
        ],
        "ProductCodes": List[
            ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImageAttributeResponse` `FpgaImageAttribute`

    Information about the attribute.

    - **FpgaImageId** *(string) --*

      The ID of the AFI.

    - **Name** *(string) --*

      The name of the AFI.

    - **Description** *(string) --*

      The description of the AFI.

    - **LoadPermissions** *(list) --*

      The load permissions.

      - *(dict) --*

        Describes a load permission.

        - **UserId** *(string) --*

          The AWS account ID.

        - **Group** *(string) --*

          The name of the group.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.
    """


_ClientDescribeFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseTypeDef",
    {
        "FpgaImageAttribute": ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef
    },
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseTypeDef(
    _ClientDescribeFpgaImageAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImageAttribute` `Response`

    - **FpgaImageAttribute** *(dict) --*

      Information about the attribute.

      - **FpgaImageId** *(string) --*

        The ID of the AFI.

      - **Name** *(string) --*

        The name of the AFI.

      - **Description** *(string) --*

        The description of the AFI.

      - **LoadPermissions** *(list) --*

        The load permissions.

        - *(dict) --*

          Describes a load permission.

          - **UserId** *(string) --*

            The AWS account ID.

          - **Group** *(string) --*

            The name of the group.

      - **ProductCodes** *(list) --*

        The product codes.

        - *(dict) --*

          Describes a product code.

          - **ProductCodeId** *(string) --*

            The product code.

          - **ProductCodeType** *(string) --*

            The type of product code.
    """


_ClientDescribeFpgaImagesFiltersTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeFpgaImagesFiltersTypeDef(_ClientDescribeFpgaImagesFiltersTypeDef):
    """
    Type definition for `ClientDescribeFpgaImages` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef",
    {"DeviceId": str, "VendorId": str, "SubsystemId": str, "SubsystemVendorId": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImagesResponseFpgaImages` `PciId`

    Information about the PCI bus.

    - **DeviceId** *(string) --*

      The ID of the device.

    - **VendorId** *(string) --*

      The ID of the vendor.

    - **SubsystemId** *(string) --*

      The ID of the subsystem.

    - **SubsystemVendorId** *(string) --*

      The ID of the vendor for the subsystem.
    """


_ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImagesResponseFpgaImages` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImagesResponseFpgaImages` `State`

    Information about the state of the AFI.

    - **Code** *(string) --*

      The state. The following are the possible values:

      * ``pending`` - AFI bitstream generation is in progress.

      * ``available`` - The AFI is available for use.

      * ``failed`` - AFI bitstream generation failed.

      * ``unavailable`` - The AFI is no longer available for use.

    - **Message** *(string) --*

      If the state is ``failed`` , this is the error message.
    """


_ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImagesResponseFpgaImages` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeFpgaImagesResponseFpgaImagesTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "Name": str,
        "Description": str,
        "ShellVersion": str,
        "PciId": ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef,
        "State": ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef,
        "CreateTime": datetime,
        "UpdateTime": datetime,
        "OwnerId": str,
        "OwnerAlias": str,
        "ProductCodes": List[
            ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef
        ],
        "Tags": List[ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef],
        "Public": bool,
        "DataRetentionSupport": bool,
    },
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesTypeDef
):
    """
    Type definition for `ClientDescribeFpgaImagesResponse` `FpgaImages`

    Describes an Amazon FPGA image (AFI).

    - **FpgaImageId** *(string) --*

      The FPGA image identifier (AFI ID).

    - **FpgaImageGlobalId** *(string) --*

      The global FPGA image identifier (AGFI ID).

    - **Name** *(string) --*

      The name of the AFI.

    - **Description** *(string) --*

      The description of the AFI.

    - **ShellVersion** *(string) --*

      The version of the AWS Shell that was used to create the bitstream.

    - **PciId** *(dict) --*

      Information about the PCI bus.

      - **DeviceId** *(string) --*

        The ID of the device.

      - **VendorId** *(string) --*

        The ID of the vendor.

      - **SubsystemId** *(string) --*

        The ID of the subsystem.

      - **SubsystemVendorId** *(string) --*

        The ID of the vendor for the subsystem.

    - **State** *(dict) --*

      Information about the state of the AFI.

      - **Code** *(string) --*

        The state. The following are the possible values:

        * ``pending`` - AFI bitstream generation is in progress.

        * ``available`` - The AFI is available for use.

        * ``failed`` - AFI bitstream generation failed.

        * ``unavailable`` - The AFI is no longer available for use.

      - **Message** *(string) --*

        If the state is ``failed`` , this is the error message.

    - **CreateTime** *(datetime) --*

      The date and time the AFI was created.

    - **UpdateTime** *(datetime) --*

      The time of the most recent update to the AFI.

    - **OwnerId** *(string) --*

      The AWS account ID of the AFI owner.

    - **OwnerAlias** *(string) --*

      The alias of the AFI owner. Possible values include ``self`` , ``amazon`` , and
      ``aws-marketplace`` .

    - **ProductCodes** *(list) --*

      The product codes for the AFI.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **Tags** *(list) --*

      Any tags assigned to the AFI.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Public** *(boolean) --*

      Indicates whether the AFI is public.

    - **DataRetentionSupport** *(boolean) --*

      Indicates whether data retention support is enabled for the AFI.
    """


_ClientDescribeFpgaImagesResponseTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseTypeDef",
    {
        "FpgaImages": List[ClientDescribeFpgaImagesResponseFpgaImagesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeFpgaImagesResponseTypeDef(_ClientDescribeFpgaImagesResponseTypeDef):
    """
    Type definition for `ClientDescribeFpgaImages` `Response`

    - **FpgaImages** *(list) --*

      Information about the FPGA images.

      - *(dict) --*

        Describes an Amazon FPGA image (AFI).

        - **FpgaImageId** *(string) --*

          The FPGA image identifier (AFI ID).

        - **FpgaImageGlobalId** *(string) --*

          The global FPGA image identifier (AGFI ID).

        - **Name** *(string) --*

          The name of the AFI.

        - **Description** *(string) --*

          The description of the AFI.

        - **ShellVersion** *(string) --*

          The version of the AWS Shell that was used to create the bitstream.

        - **PciId** *(dict) --*

          Information about the PCI bus.

          - **DeviceId** *(string) --*

            The ID of the device.

          - **VendorId** *(string) --*

            The ID of the vendor.

          - **SubsystemId** *(string) --*

            The ID of the subsystem.

          - **SubsystemVendorId** *(string) --*

            The ID of the vendor for the subsystem.

        - **State** *(dict) --*

          Information about the state of the AFI.

          - **Code** *(string) --*

            The state. The following are the possible values:

            * ``pending`` - AFI bitstream generation is in progress.

            * ``available`` - The AFI is available for use.

            * ``failed`` - AFI bitstream generation failed.

            * ``unavailable`` - The AFI is no longer available for use.

          - **Message** *(string) --*

            If the state is ``failed`` , this is the error message.

        - **CreateTime** *(datetime) --*

          The date and time the AFI was created.

        - **UpdateTime** *(datetime) --*

          The time of the most recent update to the AFI.

        - **OwnerId** *(string) --*

          The AWS account ID of the AFI owner.

        - **OwnerAlias** *(string) --*

          The alias of the AFI owner. Possible values include ``self`` , ``amazon`` , and
          ``aws-marketplace`` .

        - **ProductCodes** *(list) --*

          The product codes for the AFI.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **Tags** *(list) --*

          Any tags assigned to the AFI.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Public** *(boolean) --*

          Indicates whether the AFI is public.

        - **DataRetentionSupport** *(boolean) --*

          Indicates whether data retention support is enabled for the AFI.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeHostReservationOfferingsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeHostReservationOfferingsFiltersTypeDef(
    _ClientDescribeHostReservationOfferingsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeHostReservationOfferings` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": str,
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef(
    _ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef
):
    """
    Type definition for `ClientDescribeHostReservationOfferingsResponse` `OfferingSet`

    Details about the Dedicated Host Reservation offering.

    - **CurrencyCode** *(string) --*

      The currency of the offering.

    - **Duration** *(integer) --*

      The duration of the offering (in seconds).

    - **HourlyPrice** *(string) --*

      The hourly price of the offering.

    - **InstanceFamily** *(string) --*

      The instance family of the offering.

    - **OfferingId** *(string) --*

      The ID of the offering.

    - **PaymentOption** *(string) --*

      The available payment option.

    - **UpfrontPrice** *(string) --*

      The upfront price of the offering. Does not apply to No Upfront offerings.
    """


_ClientDescribeHostReservationOfferingsResponseTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsResponseTypeDef",
    {
        "NextToken": str,
        "OfferingSet": List[
            ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeHostReservationOfferingsResponseTypeDef(
    _ClientDescribeHostReservationOfferingsResponseTypeDef
):
    """
    Type definition for `ClientDescribeHostReservationOfferings` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **OfferingSet** *(list) --*

      Information about the offerings.

      - *(dict) --*

        Details about the Dedicated Host Reservation offering.

        - **CurrencyCode** *(string) --*

          The currency of the offering.

        - **Duration** *(integer) --*

          The duration of the offering (in seconds).

        - **HourlyPrice** *(string) --*

          The hourly price of the offering.

        - **InstanceFamily** *(string) --*

          The instance family of the offering.

        - **OfferingId** *(string) --*

          The ID of the offering.

        - **PaymentOption** *(string) --*

          The available payment option.

        - **UpfrontPrice** *(string) --*

          The upfront price of the offering. Does not apply to No Upfront offerings.
    """


_ClientDescribeHostReservationsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostReservationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeHostReservationsFiltersTypeDef(
    _ClientDescribeHostReservationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeHostReservations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef(
    _ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef
):
    """
    Type definition for `ClientDescribeHostReservationsResponseHostReservationSet` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeHostReservationsResponseHostReservationSetTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseHostReservationSetTypeDef",
    {
        "Count": int,
        "CurrencyCode": str,
        "Duration": int,
        "End": datetime,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": str,
        "Start": datetime,
        "State": str,
        "UpfrontPrice": str,
        "Tags": List[
            ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeHostReservationsResponseHostReservationSetTypeDef(
    _ClientDescribeHostReservationsResponseHostReservationSetTypeDef
):
    """
    Type definition for `ClientDescribeHostReservationsResponse` `HostReservationSet`

    Details about the Dedicated Host Reservation and associated Dedicated Hosts.

    - **Count** *(integer) --*

      The number of Dedicated Hosts the reservation is associated with.

    - **CurrencyCode** *(string) --*

      The currency in which the ``upfrontPrice`` and ``hourlyPrice`` amounts are specified. At
      this time, the only supported currency is ``USD`` .

    - **Duration** *(integer) --*

      The length of the reservation's term, specified in seconds. Can be ``31536000 (1 year)``
      | ``94608000 (3 years)`` .

    - **End** *(datetime) --*

      The date and time that the reservation ends.

    - **HostIdSet** *(list) --*

      The IDs of the Dedicated Hosts associated with the reservation.

      - *(string) --*

    - **HostReservationId** *(string) --*

      The ID of the reservation that specifies the associated Dedicated Hosts.

    - **HourlyPrice** *(string) --*

      The hourly price of the reservation.

    - **InstanceFamily** *(string) --*

      The instance family of the Dedicated Host Reservation. The instance family on the
      Dedicated Host must be the same in order for it to benefit from the reservation.

    - **OfferingId** *(string) --*

      The ID of the reservation. This remains the same regardless of which Dedicated Hosts are
      associated with it.

    - **PaymentOption** *(string) --*

      The payment option selected for this reservation.

    - **Start** *(datetime) --*

      The date and time that the reservation started.

    - **State** *(string) --*

      The state of the reservation.

    - **UpfrontPrice** *(string) --*

      The upfront price of the reservation.

    - **Tags** *(list) --*

      Any tags assigned to the Dedicated Host Reservation.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeHostReservationsResponseTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseTypeDef",
    {
        "HostReservationSet": List[
            ClientDescribeHostReservationsResponseHostReservationSetTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeHostReservationsResponseTypeDef(
    _ClientDescribeHostReservationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeHostReservations` `Response`

    - **HostReservationSet** *(list) --*

      Details about the reservation's configuration.

      - *(dict) --*

        Details about the Dedicated Host Reservation and associated Dedicated Hosts.

        - **Count** *(integer) --*

          The number of Dedicated Hosts the reservation is associated with.

        - **CurrencyCode** *(string) --*

          The currency in which the ``upfrontPrice`` and ``hourlyPrice`` amounts are specified. At
          this time, the only supported currency is ``USD`` .

        - **Duration** *(integer) --*

          The length of the reservation's term, specified in seconds. Can be ``31536000 (1 year)``
          | ``94608000 (3 years)`` .

        - **End** *(datetime) --*

          The date and time that the reservation ends.

        - **HostIdSet** *(list) --*

          The IDs of the Dedicated Hosts associated with the reservation.

          - *(string) --*

        - **HostReservationId** *(string) --*

          The ID of the reservation that specifies the associated Dedicated Hosts.

        - **HourlyPrice** *(string) --*

          The hourly price of the reservation.

        - **InstanceFamily** *(string) --*

          The instance family of the Dedicated Host Reservation. The instance family on the
          Dedicated Host must be the same in order for it to benefit from the reservation.

        - **OfferingId** *(string) --*

          The ID of the reservation. This remains the same regardless of which Dedicated Hosts are
          associated with it.

        - **PaymentOption** *(string) --*

          The payment option selected for this reservation.

        - **Start** *(datetime) --*

          The date and time that the reservation started.

        - **State** *(string) --*

          The state of the reservation.

        - **UpfrontPrice** *(string) --*

          The upfront price of the reservation.

        - **Tags** *(list) --*

          Any tags assigned to the Dedicated Host Reservation.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeHostsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeHostsFiltersTypeDef(_ClientDescribeHostsFiltersTypeDef):
    """
    Type definition for `ClientDescribeHosts` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    {"AvailableCapacity": int, "InstanceType": str, "TotalCapacity": int},
    total=False,
)


class ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef(
    _ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
):
    """
    Type definition for `ClientDescribeHostsResponseHostsAvailableCapacity` `AvailableInstanceCapacity`

    Information about the instance type that the Dedicated Host supports.

    - **AvailableCapacity** *(integer) --*

      The number of instances that can still be launched onto the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size supported by the Dedicated Host.

    - **TotalCapacity** *(integer) --*

      The total number of instances that can be launched onto the Dedicated Host.
    """


_ClientDescribeHostsResponseHostsAvailableCapacityTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsAvailableCapacityTypeDef",
    {
        "AvailableInstanceCapacity": List[
            ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
        ],
        "AvailableVCpus": int,
    },
    total=False,
)


class ClientDescribeHostsResponseHostsAvailableCapacityTypeDef(
    _ClientDescribeHostsResponseHostsAvailableCapacityTypeDef
):
    """
    Type definition for `ClientDescribeHostsResponseHosts` `AvailableCapacity`

    The number of new instances that can be launched onto the Dedicated Host.

    - **AvailableInstanceCapacity** *(list) --*

      The total number of instances supported by the Dedicated Host.

      - *(dict) --*

        Information about the instance type that the Dedicated Host supports.

        - **AvailableCapacity** *(integer) --*

          The number of instances that can still be launched onto the Dedicated Host.

        - **InstanceType** *(string) --*

          The instance type size supported by the Dedicated Host.

        - **TotalCapacity** *(integer) --*

          The total number of instances that can be launched onto the Dedicated Host.

    - **AvailableVCpus** *(integer) --*

      The number of vCPUs available on the Dedicated Host.
    """


_ClientDescribeHostsResponseHostsHostPropertiesTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsHostPropertiesTypeDef",
    {"Cores": int, "InstanceType": str, "Sockets": int, "TotalVCpus": int},
    total=False,
)


class ClientDescribeHostsResponseHostsHostPropertiesTypeDef(
    _ClientDescribeHostsResponseHostsHostPropertiesTypeDef
):
    """
    Type definition for `ClientDescribeHostsResponseHosts` `HostProperties`

    The hardware specifications of the Dedicated Host.

    - **Cores** *(integer) --*

      The number of cores on the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

    - **Sockets** *(integer) --*

      The number of sockets on the Dedicated Host.

    - **TotalVCpus** *(integer) --*

      The number of vCPUs on the Dedicated Host.
    """


_ClientDescribeHostsResponseHostsInstancesTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsInstancesTypeDef",
    {"InstanceId": str, "InstanceType": str},
    total=False,
)


class ClientDescribeHostsResponseHostsInstancesTypeDef(
    _ClientDescribeHostsResponseHostsInstancesTypeDef
):
    """
    Type definition for `ClientDescribeHostsResponseHosts` `Instances`

    Describes an instance running on a Dedicated Host.

    - **InstanceId** *(string) --*

      the IDs of instances that are running on the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size (for example, ``m3.medium`` ) of the running instance.
    """


_ClientDescribeHostsResponseHostsTagsTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeHostsResponseHostsTagsTypeDef(
    _ClientDescribeHostsResponseHostsTagsTypeDef
):
    """
    Type definition for `ClientDescribeHostsResponseHosts` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeHostsResponseHostsTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsTypeDef",
    {
        "AutoPlacement": str,
        "AvailabilityZone": str,
        "AvailableCapacity": ClientDescribeHostsResponseHostsAvailableCapacityTypeDef,
        "ClientToken": str,
        "HostId": str,
        "HostProperties": ClientDescribeHostsResponseHostsHostPropertiesTypeDef,
        "HostReservationId": str,
        "Instances": List[ClientDescribeHostsResponseHostsInstancesTypeDef],
        "State": str,
        "AllocationTime": datetime,
        "ReleaseTime": datetime,
        "Tags": List[ClientDescribeHostsResponseHostsTagsTypeDef],
        "HostRecovery": str,
    },
    total=False,
)


class ClientDescribeHostsResponseHostsTypeDef(_ClientDescribeHostsResponseHostsTypeDef):
    """
    Type definition for `ClientDescribeHostsResponse` `Hosts`

    Describes the properties of the Dedicated Host.

    - **AutoPlacement** *(string) --*

      Whether auto-placement is on or off.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the Dedicated Host.

    - **AvailableCapacity** *(dict) --*

      The number of new instances that can be launched onto the Dedicated Host.

      - **AvailableInstanceCapacity** *(list) --*

        The total number of instances supported by the Dedicated Host.

        - *(dict) --*

          Information about the instance type that the Dedicated Host supports.

          - **AvailableCapacity** *(integer) --*

            The number of instances that can still be launched onto the Dedicated Host.

          - **InstanceType** *(string) --*

            The instance type size supported by the Dedicated Host.

          - **TotalCapacity** *(integer) --*

            The total number of instances that can be launched onto the Dedicated Host.

      - **AvailableVCpus** *(integer) --*

        The number of vCPUs available on the Dedicated Host.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the
      request. For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **HostId** *(string) --*

      The ID of the Dedicated Host.

    - **HostProperties** *(dict) --*

      The hardware specifications of the Dedicated Host.

      - **Cores** *(integer) --*

        The number of cores on the Dedicated Host.

      - **InstanceType** *(string) --*

        The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

      - **Sockets** *(integer) --*

        The number of sockets on the Dedicated Host.

      - **TotalVCpus** *(integer) --*

        The number of vCPUs on the Dedicated Host.

    - **HostReservationId** *(string) --*

      The reservation ID of the Dedicated Host. This returns a ``null`` response if the
      Dedicated Host doesn't have an associated reservation.

    - **Instances** *(list) --*

      The IDs and instance type that are currently running on the Dedicated Host.

      - *(dict) --*

        Describes an instance running on a Dedicated Host.

        - **InstanceId** *(string) --*

          the IDs of instances that are running on the Dedicated Host.

        - **InstanceType** *(string) --*

          The instance type size (for example, ``m3.medium`` ) of the running instance.

    - **State** *(string) --*

      The Dedicated Host's state.

    - **AllocationTime** *(datetime) --*

      The time that the Dedicated Host was allocated.

    - **ReleaseTime** *(datetime) --*

      The time that the Dedicated Host was released.

    - **Tags** *(list) --*

      Any tags assigned to the Dedicated Host.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **HostRecovery** *(string) --*

      Indicates whether host recovery is enabled or disabled for the Dedicated Host.
    """


_ClientDescribeHostsResponseTypeDef = TypedDict(
    "_ClientDescribeHostsResponseTypeDef",
    {"Hosts": List[ClientDescribeHostsResponseHostsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeHostsResponseTypeDef(_ClientDescribeHostsResponseTypeDef):
    """
    Type definition for `ClientDescribeHosts` `Response`

    - **Hosts** *(list) --*

      Information about the Dedicated Hosts.

      - *(dict) --*

        Describes the properties of the Dedicated Host.

        - **AutoPlacement** *(string) --*

          Whether auto-placement is on or off.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the Dedicated Host.

        - **AvailableCapacity** *(dict) --*

          The number of new instances that can be launched onto the Dedicated Host.

          - **AvailableInstanceCapacity** *(list) --*

            The total number of instances supported by the Dedicated Host.

            - *(dict) --*

              Information about the instance type that the Dedicated Host supports.

              - **AvailableCapacity** *(integer) --*

                The number of instances that can still be launched onto the Dedicated Host.

              - **InstanceType** *(string) --*

                The instance type size supported by the Dedicated Host.

              - **TotalCapacity** *(integer) --*

                The total number of instances that can be launched onto the Dedicated Host.

          - **AvailableVCpus** *(integer) --*

            The number of vCPUs available on the Dedicated Host.

        - **ClientToken** *(string) --*

          Unique, case-sensitive identifier that you provide to ensure the idempotency of the
          request. For more information, see `How to Ensure Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **HostId** *(string) --*

          The ID of the Dedicated Host.

        - **HostProperties** *(dict) --*

          The hardware specifications of the Dedicated Host.

          - **Cores** *(integer) --*

            The number of cores on the Dedicated Host.

          - **InstanceType** *(string) --*

            The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

          - **Sockets** *(integer) --*

            The number of sockets on the Dedicated Host.

          - **TotalVCpus** *(integer) --*

            The number of vCPUs on the Dedicated Host.

        - **HostReservationId** *(string) --*

          The reservation ID of the Dedicated Host. This returns a ``null`` response if the
          Dedicated Host doesn't have an associated reservation.

        - **Instances** *(list) --*

          The IDs and instance type that are currently running on the Dedicated Host.

          - *(dict) --*

            Describes an instance running on a Dedicated Host.

            - **InstanceId** *(string) --*

              the IDs of instances that are running on the Dedicated Host.

            - **InstanceType** *(string) --*

              The instance type size (for example, ``m3.medium`` ) of the running instance.

        - **State** *(string) --*

          The Dedicated Host's state.

        - **AllocationTime** *(datetime) --*

          The time that the Dedicated Host was allocated.

        - **ReleaseTime** *(datetime) --*

          The time that the Dedicated Host was released.

        - **Tags** *(list) --*

          Any tags assigned to the Dedicated Host.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **HostRecovery** *(string) --*

          Indicates whether host recovery is enabled or disabled for the Dedicated Host.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeIamInstanceProfileAssociations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociations` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef,
        "State": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef
):
    """
    Type definition for `ClientDescribeIamInstanceProfileAssociationsResponse` `IamInstanceProfileAssociations`

    Describes an association between an IAM instance profile and an instance.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **State** *(string) --*

      The state of the association.

    - **Timestamp** *(datetime) --*

      The time the IAM instance profile was associated with the instance.
    """


_ClientDescribeIamInstanceProfileAssociationsResponseTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseTypeDef",
    {
        "IamInstanceProfileAssociations": List[
            ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeIamInstanceProfileAssociations` `Response`

    - **IamInstanceProfileAssociations** *(list) --*

      Information about the IAM instance profile associations.

      - *(dict) --*

        Describes an association between an IAM instance profile and an instance.

        - **AssociationId** *(string) --*

          The ID of the association.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Id** *(string) --*

            The ID of the instance profile.

        - **State** *(string) --*

          The state of the association.

        - **Timestamp** *(datetime) --*

          The time the IAM instance profile was associated with the instance.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeIdFormatResponseStatusesTypeDef(
    _ClientDescribeIdFormatResponseStatusesTypeDef
):
    """
    Type definition for `ClientDescribeIdFormatResponse` `Statuses`

    Describes the ID format for a resource.

    - **Deadline** *(datetime) --*

      The date in UTC at which you are permanently switched over to using longer IDs. If a
      deadline is not yet available for this resource type, this field is not returned.

    - **Resource** *(string) --*

      The type of resource.

    - **UseLongIds** *(boolean) --*

      Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeIdFormatResponseTypeDef",
    {"Statuses": List[ClientDescribeIdFormatResponseStatusesTypeDef]},
    total=False,
)


class ClientDescribeIdFormatResponseTypeDef(_ClientDescribeIdFormatResponseTypeDef):
    """
    Type definition for `ClientDescribeIdFormat` `Response`

    - **Statuses** *(list) --*

      Information about the ID format for the resource.

      - *(dict) --*

        Describes the ID format for a resource.

        - **Deadline** *(datetime) --*

          The date in UTC at which you are permanently switched over to using longer IDs. If a
          deadline is not yet available for this resource type, this field is not returned.

        - **Resource** *(string) --*

          The type of resource.

        - **UseLongIds** *(boolean) --*

          Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeIdentityIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeIdentityIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeIdentityIdFormatResponseStatusesTypeDef(
    _ClientDescribeIdentityIdFormatResponseStatusesTypeDef
):
    """
    Type definition for `ClientDescribeIdentityIdFormatResponse` `Statuses`

    Describes the ID format for a resource.

    - **Deadline** *(datetime) --*

      The date in UTC at which you are permanently switched over to using longer IDs. If a
      deadline is not yet available for this resource type, this field is not returned.

    - **Resource** *(string) --*

      The type of resource.

    - **UseLongIds** *(boolean) --*

      Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeIdentityIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeIdentityIdFormatResponseTypeDef",
    {"Statuses": List[ClientDescribeIdentityIdFormatResponseStatusesTypeDef]},
    total=False,
)


class ClientDescribeIdentityIdFormatResponseTypeDef(
    _ClientDescribeIdentityIdFormatResponseTypeDef
):
    """
    Type definition for `ClientDescribeIdentityIdFormat` `Response`

    - **Statuses** *(list) --*

      Information about the ID format for the resources.

      - *(dict) --*

        Describes the ID format for a resource.

        - **Deadline** *(datetime) --*

          The date in UTC at which you are permanently switched over to using longer IDs. If a
          deadline is not yet available for this resource type, this field is not returned.

        - **Resource** *(string) --*

          The type of resource.

        - **UseLongIds** *(boolean) --*

          Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponseBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see
      `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
      `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
      SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
      HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
      snapshot, the volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
      the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends
      on the volume origin (new or from a snapshot), starting encryption state, ownership,
      and whether encryption by default is enabled. For more information, see `Amazon EBS
      Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
      For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
      which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
      and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef(
    _ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
      from 0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
      depends on the instance type. After you connect to the instance, you must mount the
      volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any instance
      store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see
        `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
        ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
        `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
        SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
        HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
        snapshot, the volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
        the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends
        on the volume origin (new or from a snapshot), starting encryption state, ownership,
        and whether encryption by default is enabled. For more information, see `Amazon EBS
        Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
        For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
        which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
        and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientDescribeImageAttributeResponseDescriptionTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseDescriptionTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeImageAttributeResponseDescriptionTypeDef(
    _ClientDescribeImageAttributeResponseDescriptionTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `Description`

    A description for the AMI.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeImageAttributeResponseKernelIdTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseKernelIdTypeDef(
    _ClientDescribeImageAttributeResponseKernelIdTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `KernelId`

    The kernel ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef(
    _ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `LaunchPermissions`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ClientDescribeImageAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeImageAttributeResponseProductCodesTypeDef(
    _ClientDescribeImageAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeImageAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseRamdiskIdTypeDef(
    _ClientDescribeImageAttributeResponseRamdiskIdTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `RamdiskId`

    The RAM disk ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeImageAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseSriovNetSupportTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeImageAttributeResponseSriovNetSupportTypeDef(
    _ClientDescribeImageAttributeResponseSriovNetSupportTypeDef
):
    """
    Type definition for `ClientDescribeImageAttributeResponse` `SriovNetSupport`

    Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
    enabled.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeImageAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseTypeDef",
    {
        "BlockDeviceMappings": List[
            ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef
        ],
        "ImageId": str,
        "LaunchPermissions": List[
            ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef
        ],
        "ProductCodes": List[ClientDescribeImageAttributeResponseProductCodesTypeDef],
        "Description": ClientDescribeImageAttributeResponseDescriptionTypeDef,
        "KernelId": ClientDescribeImageAttributeResponseKernelIdTypeDef,
        "RamdiskId": ClientDescribeImageAttributeResponseRamdiskIdTypeDef,
        "SriovNetSupport": ClientDescribeImageAttributeResponseSriovNetSupportTypeDef,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseTypeDef(
    _ClientDescribeImageAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeImageAttribute` `Response`

    Describes an image attribute.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
          from 0. An instance type with 2 available instance store volumes can specify mappings for
          ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
          depends on the instance type. After you connect to the instance, you must mount the
          volume.

          NVMe instance store volumes are automatically enumerated and assigned a device name.
          Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any instance
          store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
            volumes, this represents the number of IOPS that are provisioned for the volume. For
            ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
            which the volume accumulates I/O credits for bursting. For more information, see
            `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
            ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
            `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it is not
            used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
            SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
            HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
            snapshot, the volume size must be equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
            the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being restored
            from a backing snapshot. The effect of setting the encryption state to ``true`` depends
            on the volume origin (new or from a snapshot), starting encryption state, ownership,
            and whether encryption by default is enabled. For more information, see `Amazon EBS
            Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
            For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
            which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
            `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
            and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **LaunchPermissions** *(list) --*

      The launch permissions.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **Description** *(dict) --*

      A description for the AMI.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **KernelId** *(dict) --*

      The kernel ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **RamdiskId** *(dict) --*

      The RAM disk ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **SriovNetSupport** *(dict) --*

      Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.
    """


_ClientDescribeImagesFiltersTypeDef = TypedDict(
    "_ClientDescribeImagesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeImagesFiltersTypeDef(_ClientDescribeImagesFiltersTypeDef):
    """
    Type definition for `ClientDescribeImages` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponseImagesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for the
      volume. For ``gp2`` volumes, this represents the baseline performance of the volume
      and the rate at which the volume accumulates I/O credits for bursting. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only
      on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is
      not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
      volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume
      size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
      IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
      for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
      specify a snapshot, the volume size must be equal to or larger than the snapshot
      size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS
      that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being
      restored from a backing snapshot. The effect of setting the encryption state to
      ``true`` depends on the volume origin (new or from a snapshot), starting encryption
      state, ownership, and whether encryption by default is enabled. For more
      information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
      under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef(
    _ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponseImages` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can specify
      mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available instance
      store volumes depends on the instance type. After you connect to the instance, you
      must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any
      instance store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for the
        volume. For ``gp2`` volumes, this represents the baseline performance of the volume
        and the rate at which the volume accumulates I/O credits for bursting. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
        ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only
        on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is
        not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
        volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume
        size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
        IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
        for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
        specify a snapshot, the volume size must be equal to or larger than the snapshot
        size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS
        that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being
        restored from a backing snapshot. The effect of setting the encryption state to
        ``true`` depends on the volume origin (new or from a snapshot), starting encryption
        state, ownership, and whether encryption by default is enabled. For more
        information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
        under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientDescribeImagesResponseImagesProductCodesTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeImagesResponseImagesProductCodesTypeDef(
    _ClientDescribeImagesResponseImagesProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponseImages` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeImagesResponseImagesStateReasonTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeImagesResponseImagesStateReasonTypeDef(
    _ClientDescribeImagesResponseImagesStateReasonTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponseImages` `StateReason`

    The reason for the state change.

    - **Code** *(string) --*

      The reason code for the state change.

    - **Message** *(string) --*

      The message for the state change.

      * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
      to satisfy the launch request.

      * ``Server.InternalError`` : An internal error caused the instance to terminate during
      launch.

      * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

      * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
      requests with a maximum price equal to or higher than the Spot price exceeded available
      capacity or because of an increase in the Spot price.

      * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
      of Spot requests with a maximum price equal to or higher than the Spot price exceeded
      available capacity or because of an increase in the Spot price.

      * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
      ``shutdown -h`` command from the instance.

      * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
      creation.

      * ``Client.InternalError`` : A client error caused the instance to terminate during
      launch.

      * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

      * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

      * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
      API.

      * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
      storage was exceeded. Decrease usage or request an increase in your account limits.
    """


_ClientDescribeImagesResponseImagesTagsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeImagesResponseImagesTagsTypeDef(
    _ClientDescribeImagesResponseImagesTagsTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponseImages` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeImagesResponseImagesTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesTypeDef",
    {
        "Architecture": str,
        "CreationDate": str,
        "ImageId": str,
        "ImageLocation": str,
        "ImageType": str,
        "Public": bool,
        "KernelId": str,
        "OwnerId": str,
        "Platform": str,
        "ProductCodes": List[ClientDescribeImagesResponseImagesProductCodesTypeDef],
        "RamdiskId": str,
        "State": str,
        "BlockDeviceMappings": List[
            ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef
        ],
        "Description": str,
        "EnaSupport": bool,
        "Hypervisor": str,
        "ImageOwnerAlias": str,
        "Name": str,
        "RootDeviceName": str,
        "RootDeviceType": str,
        "SriovNetSupport": str,
        "StateReason": ClientDescribeImagesResponseImagesStateReasonTypeDef,
        "Tags": List[ClientDescribeImagesResponseImagesTagsTypeDef],
        "VirtualizationType": str,
    },
    total=False,
)


class ClientDescribeImagesResponseImagesTypeDef(
    _ClientDescribeImagesResponseImagesTypeDef
):
    """
    Type definition for `ClientDescribeImagesResponse` `Images`

    Describes an image.

    - **Architecture** *(string) --*

      The architecture of the image.

    - **CreationDate** *(string) --*

      The date and time the image was created.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **ImageLocation** *(string) --*

      The location of the AMI.

    - **ImageType** *(string) --*

      The type of image.

    - **Public** *(boolean) --*

      Indicates whether the image has public launch permissions. The value is ``true`` if this
      image has public launch permissions or ``false`` if it has only implicit and explicit
      launch permissions.

    - **KernelId** *(string) --*

      The kernel associated with the image, if any. Only applicable for machine images.

    - **OwnerId** *(string) --*

      The AWS account ID of the image owner.

    - **Platform** *(string) --*

      This value is set to ``windows`` for Windows AMIs; otherwise, it is blank.

    - **ProductCodes** *(list) --*

      Any product codes associated with the AMI.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **RamdiskId** *(string) --*

      The RAM disk associated with the image, if any. Only applicable for machine images.

    - **State** *(string) --*

      The current state of the AMI. If the state is ``available`` , the image is successfully
      registered and can be used to launch an instance.

    - **BlockDeviceMappings** *(list) --*

      Any block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can specify
          mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available instance
          store volumes depends on the instance type. After you connect to the instance, you
          must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device name.
          Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any
          instance store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for the
            volume. For ``gp2`` volumes, this represents the baseline performance of the volume
            and the rate at which the volume accumulates I/O credits for bursting. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
            ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only
            on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it is
            not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
            volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume
            size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
            IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
            for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
            specify a snapshot, the volume size must be equal to or larger than the snapshot
            size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS
            that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being
            restored from a backing snapshot. The effect of setting the encryption state to
            ``true`` depends on the volume origin (new or from a snapshot), starting encryption
            state, ownership, and whether encryption by default is enabled. For more
            information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
            under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
            `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **Description** *(string) --*

      The description of the AMI that was provided during image creation.

    - **EnaSupport** *(boolean) --*

      Specifies whether enhanced networking with ENA is enabled.

    - **Hypervisor** *(string) --*

      The hypervisor type of the image.

    - **ImageOwnerAlias** *(string) --*

      The AWS account alias (for example, ``amazon`` , ``self`` ) or the AWS account ID of the
      AMI owner.

    - **Name** *(string) --*

      The name of the AMI that was provided during image creation.

    - **RootDeviceName** *(string) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **RootDeviceType** *(string) --*

      The type of root device used by the AMI. The AMI can use an EBS volume or an instance
      store volume.

    - **SriovNetSupport** *(string) --*

      Specifies whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

    - **StateReason** *(dict) --*

      The reason for the state change.

      - **Code** *(string) --*

        The reason code for the state change.

      - **Message** *(string) --*

        The message for the state change.

        * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
        to satisfy the launch request.

        * ``Server.InternalError`` : An internal error caused the instance to terminate during
        launch.

        * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

        * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
        requests with a maximum price equal to or higher than the Spot price exceeded available
        capacity or because of an increase in the Spot price.

        * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
        of Spot requests with a maximum price equal to or higher than the Spot price exceeded
        available capacity or because of an increase in the Spot price.

        * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
        ``shutdown -h`` command from the instance.

        * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
        creation.

        * ``Client.InternalError`` : A client error caused the instance to terminate during
        launch.

        * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

        * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

        * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
        API.

        * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
        storage was exceeded. Decrease usage or request an increase in your account limits.

    - **Tags** *(list) --*

      Any tags assigned to the image.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VirtualizationType** *(string) --*

      The type of virtualization of the AMI.
    """


_ClientDescribeImagesResponseTypeDef = TypedDict(
    "_ClientDescribeImagesResponseTypeDef",
    {"Images": List[ClientDescribeImagesResponseImagesTypeDef]},
    total=False,
)


class ClientDescribeImagesResponseTypeDef(_ClientDescribeImagesResponseTypeDef):
    """
    Type definition for `ClientDescribeImages` `Response`

    - **Images** *(list) --*

      Information about the images.

      - *(dict) --*

        Describes an image.

        - **Architecture** *(string) --*

          The architecture of the image.

        - **CreationDate** *(string) --*

          The date and time the image was created.

        - **ImageId** *(string) --*

          The ID of the AMI.

        - **ImageLocation** *(string) --*

          The location of the AMI.

        - **ImageType** *(string) --*

          The type of image.

        - **Public** *(boolean) --*

          Indicates whether the image has public launch permissions. The value is ``true`` if this
          image has public launch permissions or ``false`` if it has only implicit and explicit
          launch permissions.

        - **KernelId** *(string) --*

          The kernel associated with the image, if any. Only applicable for machine images.

        - **OwnerId** *(string) --*

          The AWS account ID of the image owner.

        - **Platform** *(string) --*

          This value is set to ``windows`` for Windows AMIs; otherwise, it is blank.

        - **ProductCodes** *(list) --*

          Any product codes associated with the AMI.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **RamdiskId** *(string) --*

          The RAM disk associated with the image, if any. Only applicable for machine images.

        - **State** *(string) --*

          The current state of the AMI. If the state is ``available`` , the image is successfully
          registered and can be used to launch an instance.

        - **BlockDeviceMappings** *(list) --*

          Any block device mapping entries.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **VirtualName** *(string) --*

              The virtual device name (``ephemeral`` N). Instance store volumes are numbered
              starting from 0. An instance type with 2 available instance store volumes can specify
              mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available instance
              store volumes depends on the instance type. After you connect to the instance, you
              must mount the volume.

              NVMe instance store volumes are automatically enumerated and assigned a device name.
              Including them in your block device mapping has no effect.

              Constraints: For M3 instances, you must specify instance store volumes in the block
              device mapping for the instance. When you launch an M3 instance, we ignore any
              instance store volumes specified in the block device mapping for the AMI.

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is launched.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the EBS volume is deleted on instance termination. For more
                information, see `Preserving Amazon EBS Volumes on Instance Termination
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                in the Amazon Elastic Compute Cloud User Guide.

              - **Iops** *(integer) --*

                The number of I/O operations per second (IOPS) that the volume supports. For
                ``io1`` volumes, this represents the number of IOPS that are provisioned for the
                volume. For ``gp2`` volumes, this represents the baseline performance of the volume
                and the rate at which the volume accumulates I/O credits for bursting. For more
                information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
                ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only
                on `Nitro-based instances
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                . Other instance families guarantee performance up to 32,000 IOPS. For more
                information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                Condition: This parameter is required for requests to create ``io1`` volumes; it is
                not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
                volumes.

              - **SnapshotId** *(string) --*

                The ID of the snapshot.

              - **VolumeSize** *(integer) --*

                The size of the volume, in GiB.

                Default: If you're creating the volume from a snapshot and don't specify a volume
                size, the default is the snapshot size.

                Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
                IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
                for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
                specify a snapshot, the volume size must be equal to or larger than the snapshot
                size.

              - **VolumeType** *(string) --*

                The volume type. If you set the type to ``io1`` , you must also specify the IOPS
                that the volume supports.

                Default: ``gp2``

              - **Encrypted** *(boolean) --*

                Indicates whether the encryption state of an EBS volume is changed while being
                restored from a backing snapshot. The effect of setting the encryption state to
                ``true`` depends on the volume origin (new or from a snapshot), starting encryption
                state, ownership, and whether encryption by default is enabled. For more
                information, see `Amazon EBS Encryption
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                In no case can you remove encryption from an encrypted volume.

                Encrypted volumes can only be attached to instances that support Amazon EBS
                encryption. For more information, see `Supported Instance Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                .

              - **KmsKeyId** *(string) --*

                Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
                under which the EBS volume is encrypted.

                This parameter is only supported on ``BlockDeviceMapping`` objects called by
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
                `RequestSpotFleet
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                , and `RequestSpotInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                .

            - **NoDevice** *(string) --*

              Suppresses the specified device included in the block device mapping of the AMI.

        - **Description** *(string) --*

          The description of the AMI that was provided during image creation.

        - **EnaSupport** *(boolean) --*

          Specifies whether enhanced networking with ENA is enabled.

        - **Hypervisor** *(string) --*

          The hypervisor type of the image.

        - **ImageOwnerAlias** *(string) --*

          The AWS account alias (for example, ``amazon`` , ``self`` ) or the AWS account ID of the
          AMI owner.

        - **Name** *(string) --*

          The name of the AMI that was provided during image creation.

        - **RootDeviceName** *(string) --*

          The device name of the root device volume (for example, ``/dev/sda1`` ).

        - **RootDeviceType** *(string) --*

          The type of root device used by the AMI. The AMI can use an EBS volume or an instance
          store volume.

        - **SriovNetSupport** *(string) --*

          Specifies whether enhanced networking with the Intel 82599 Virtual Function interface is
          enabled.

        - **StateReason** *(dict) --*

          The reason for the state change.

          - **Code** *(string) --*

            The reason code for the state change.

          - **Message** *(string) --*

            The message for the state change.

            * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
            to satisfy the launch request.

            * ``Server.InternalError`` : An internal error caused the instance to terminate during
            launch.

            * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

            * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
            requests with a maximum price equal to or higher than the Spot price exceeded available
            capacity or because of an increase in the Spot price.

            * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
            of Spot requests with a maximum price equal to or higher than the Spot price exceeded
            available capacity or because of an increase in the Spot price.

            * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
            ``shutdown -h`` command from the instance.

            * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
            creation.

            * ``Client.InternalError`` : A client error caused the instance to terminate during
            launch.

            * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

            * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

            * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
            API.

            * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
            storage was exceeded. Decrease usage or request an increase in your account limits.

        - **Tags** *(list) --*

          Any tags assigned to the image.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VirtualizationType** *(string) --*

          The type of virtualization of the AMI.
    """


_ClientDescribeImportImageTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeImportImageTasksFiltersTypeDef(
    _ClientDescribeImportImageTasksFiltersTypeDef
):
    """
    Type definition for `ClientDescribeImportImageTasks` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef
):
    """
    Type definition for `ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetails` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef
):
    """
    Type definition for `ClientDescribeImportImageTasksResponseImportImageTasks` `SnapshotDetails`

    Describes the snapshot created from the imported disk.

    - **Description** *(string) --*

      A description for the snapshot.

    - **DeviceName** *(string) --*

      The block device mapping for the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **Progress** *(string) --*

      The percentage of progress for the task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status of the snapshot creation.

    - **StatusMessage** *(string) --*

      A detailed status message for the snapshot creation.

    - **Url** *(string) --*

      The URL used to access the disk image.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientDescribeImportImageTasksResponseImportImageTasksTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[
            ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef
        ],
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksTypeDef
):
    """
    Type definition for `ClientDescribeImportImageTasksResponse` `ImportImageTasks`

    Describes an import image task.

    - **Architecture** *(string) --*

      The architecture of the virtual machine.

      Valid values: ``i386`` | ``x86_64`` | ``arm64``

    - **Description** *(string) --*

      A description of the import task.

    - **Encrypted** *(boolean) --*

      Indicates whether the image is encrypted.

    - **Hypervisor** *(string) --*

      The target hypervisor for the import task.

      Valid values: ``xen``

    - **ImageId** *(string) --*

      The ID of the Amazon Machine Image (AMI) of the imported virtual machine.

    - **ImportTaskId** *(string) --*

      The ID of the import image task.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
      that was used to create the encrypted image.

    - **LicenseType** *(string) --*

      The license type of the virtual machine.

    - **Platform** *(string) --*

      The description string for the import image task.

    - **Progress** *(string) --*

      The percentage of progress of the import image task.

    - **SnapshotDetails** *(list) --*

      Information about the snapshots.

      - *(dict) --*

        Describes the snapshot created from the imported disk.

        - **Description** *(string) --*

          A description for the snapshot.

        - **DeviceName** *(string) --*

          The block device mapping for the snapshot.

        - **DiskImageSize** *(float) --*

          The size of the disk in the snapshot, in GiB.

        - **Format** *(string) --*

          The format of the disk image from which the snapshot is created.

        - **Progress** *(string) --*

          The percentage of progress for the task.

        - **SnapshotId** *(string) --*

          The snapshot ID of the disk being imported.

        - **Status** *(string) --*

          A brief status of the snapshot creation.

        - **StatusMessage** *(string) --*

          A detailed status message for the snapshot creation.

        - **Url** *(string) --*

          The URL used to access the disk image.

        - **UserBucket** *(dict) --*

          The S3 bucket for the disk image.

          - **S3Bucket** *(string) --*

            The S3 bucket from which the disk image was created.

          - **S3Key** *(string) --*

            The file name of the disk image.

    - **Status** *(string) --*

      A brief status for the import image task.

    - **StatusMessage** *(string) --*

      A descriptive status message for the import image task.
    """


_ClientDescribeImportImageTasksResponseTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseTypeDef",
    {
        "ImportImageTasks": List[
            ClientDescribeImportImageTasksResponseImportImageTasksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseTypeDef(
    _ClientDescribeImportImageTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeImportImageTasks` `Response`

    - **ImportImageTasks** *(list) --*

      A list of zero or more import image tasks that are currently active or were completed or
      canceled in the previous 7 days.

      - *(dict) --*

        Describes an import image task.

        - **Architecture** *(string) --*

          The architecture of the virtual machine.

          Valid values: ``i386`` | ``x86_64`` | ``arm64``

        - **Description** *(string) --*

          A description of the import task.

        - **Encrypted** *(boolean) --*

          Indicates whether the image is encrypted.

        - **Hypervisor** *(string) --*

          The target hypervisor for the import task.

          Valid values: ``xen``

        - **ImageId** *(string) --*

          The ID of the Amazon Machine Image (AMI) of the imported virtual machine.

        - **ImportTaskId** *(string) --*

          The ID of the import image task.

        - **KmsKeyId** *(string) --*

          The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
          that was used to create the encrypted image.

        - **LicenseType** *(string) --*

          The license type of the virtual machine.

        - **Platform** *(string) --*

          The description string for the import image task.

        - **Progress** *(string) --*

          The percentage of progress of the import image task.

        - **SnapshotDetails** *(list) --*

          Information about the snapshots.

          - *(dict) --*

            Describes the snapshot created from the imported disk.

            - **Description** *(string) --*

              A description for the snapshot.

            - **DeviceName** *(string) --*

              The block device mapping for the snapshot.

            - **DiskImageSize** *(float) --*

              The size of the disk in the snapshot, in GiB.

            - **Format** *(string) --*

              The format of the disk image from which the snapshot is created.

            - **Progress** *(string) --*

              The percentage of progress for the task.

            - **SnapshotId** *(string) --*

              The snapshot ID of the disk being imported.

            - **Status** *(string) --*

              A brief status of the snapshot creation.

            - **StatusMessage** *(string) --*

              A detailed status message for the snapshot creation.

            - **Url** *(string) --*

              The URL used to access the disk image.

            - **UserBucket** *(dict) --*

              The S3 bucket for the disk image.

              - **S3Bucket** *(string) --*

                The S3 bucket from which the disk image was created.

              - **S3Key** *(string) --*

                The file name of the disk image.

        - **Status** *(string) --*

          A brief status for the import image task.

        - **StatusMessage** *(string) --*

          A descriptive status message for the import image task.

    - **NextToken** *(string) --*

      The token to use to get the next page of results. This value is ``null`` when there are no
      more results to return.
    """


_ClientDescribeImportSnapshotTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeImportSnapshotTasksFiltersTypeDef(
    _ClientDescribeImportSnapshotTasksFiltersTypeDef
):
    """
    Type definition for `ClientDescribeImportSnapshotTasks` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef
):
    """
    Type definition for `ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetail` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef
):
    """
    Type definition for `ClientDescribeImportSnapshotTasksResponseImportSnapshotTasks` `SnapshotTaskDetail`

    Describes an import snapshot task.

    - **Description** *(string) --*

      The description of the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
      that was used to create the encrypted snapshot.

    - **Progress** *(string) --*

      The percentage of completion for the import snapshot task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status for the import snapshot task.

    - **StatusMessage** *(string) --*

      A detailed status message for the import snapshot task.

    - **Url** *(string) --*

      The URL of the disk image from which the snapshot is created.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef
):
    """
    Type definition for `ClientDescribeImportSnapshotTasksResponse` `ImportSnapshotTasks`

    Describes an import snapshot task.

    - **Description** *(string) --*

      A description of the import snapshot task.

    - **ImportTaskId** *(string) --*

      The ID of the import snapshot task.

    - **SnapshotTaskDetail** *(dict) --*

      Describes an import snapshot task.

      - **Description** *(string) --*

        The description of the snapshot.

      - **DiskImageSize** *(float) --*

        The size of the disk in the snapshot, in GiB.

      - **Encrypted** *(boolean) --*

        Indicates whether the snapshot is encrypted.

      - **Format** *(string) --*

        The format of the disk image from which the snapshot is created.

      - **KmsKeyId** *(string) --*

        The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
        that was used to create the encrypted snapshot.

      - **Progress** *(string) --*

        The percentage of completion for the import snapshot task.

      - **SnapshotId** *(string) --*

        The snapshot ID of the disk being imported.

      - **Status** *(string) --*

        A brief status for the import snapshot task.

      - **StatusMessage** *(string) --*

        A detailed status message for the import snapshot task.

      - **Url** *(string) --*

        The URL of the disk image from which the snapshot is created.

      - **UserBucket** *(dict) --*

        The S3 bucket for the disk image.

        - **S3Bucket** *(string) --*

          The S3 bucket from which the disk image was created.

        - **S3Key** *(string) --*

          The file name of the disk image.
    """


_ClientDescribeImportSnapshotTasksResponseTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseTypeDef",
    {
        "ImportSnapshotTasks": List[
            ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseTypeDef(
    _ClientDescribeImportSnapshotTasksResponseTypeDef
):
    """
    Type definition for `ClientDescribeImportSnapshotTasks` `Response`

    - **ImportSnapshotTasks** *(list) --*

      A list of zero or more import snapshot tasks that are currently active or were completed or
      canceled in the previous 7 days.

      - *(dict) --*

        Describes an import snapshot task.

        - **Description** *(string) --*

          A description of the import snapshot task.

        - **ImportTaskId** *(string) --*

          The ID of the import snapshot task.

        - **SnapshotTaskDetail** *(dict) --*

          Describes an import snapshot task.

          - **Description** *(string) --*

            The description of the snapshot.

          - **DiskImageSize** *(float) --*

            The size of the disk in the snapshot, in GiB.

          - **Encrypted** *(boolean) --*

            Indicates whether the snapshot is encrypted.

          - **Format** *(string) --*

            The format of the disk image from which the snapshot is created.

          - **KmsKeyId** *(string) --*

            The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
            that was used to create the encrypted snapshot.

          - **Progress** *(string) --*

            The percentage of completion for the import snapshot task.

          - **SnapshotId** *(string) --*

            The snapshot ID of the disk being imported.

          - **Status** *(string) --*

            A brief status for the import snapshot task.

          - **StatusMessage** *(string) --*

            A detailed status message for the import snapshot task.

          - **Url** *(string) --*

            The URL of the disk image from which the snapshot is created.

          - **UserBucket** *(dict) --*

            The S3 bucket for the disk image.

            - **S3Bucket** *(string) --*

              The S3 bucket from which the disk image was created.

            - **S3Key** *(string) --*

              The file name of the disk image.

    - **NextToken** *(string) --*

      The token to use to get the next page of results. This value is ``null`` when there are no
      more results to return.
    """


_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": str,
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponseBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Status** *(string) --*

      The attachment state.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef(
    _ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Status** *(string) --*

        The attachment state.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.
    """


_ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef(
    _ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `DisableApiTermination`

    If the value is ``true`` , you can't terminate the instance through the Amazon EC2 console,
    CLI, or API; otherwise, you can.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef(
    _ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `EbsOptimized`

    Indicates whether the instance is optimized for Amazon EBS I/O.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeInstanceAttributeResponseEnaSupportTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseEnaSupportTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeInstanceAttributeResponseEnaSupportTypeDef(
    _ClientDescribeInstanceAttributeResponseEnaSupportTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `EnaSupport`

    Indicates whether enhanced networking with ENA is enabled.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeInstanceAttributeResponseGroupsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseGroupsTypeDef(
    _ClientDescribeInstanceAttributeResponseGroupsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef(
    _ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `InstanceInitiatedShutdownBehavior`

    Indicates whether an instance stops or terminates when you initiate shutdown from the
    instance (using the operating system command for system shutdown).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef(
    _ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `InstanceType`

    The instance type.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseKernelIdTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseKernelIdTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseKernelIdTypeDef(
    _ClientDescribeInstanceAttributeResponseKernelIdTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `KernelId`

    The kernel ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseProductCodesTypeDef(
    _ClientDescribeInstanceAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef(
    _ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `RamdiskId`

    The RAM disk ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef(
    _ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `RootDeviceName`

    The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef(
    _ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `SourceDestCheck`

    Indicates whether source/destination checking is enabled. A value of ``true`` means that
    checking is enabled, and ``false`` means that checking is disabled. This value must be
    ``false`` for a NAT instance to perform NAT.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef(
    _ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `SriovNetSupport`

    Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
    enabled.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseUserDataTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseUserDataTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseUserDataTypeDef(
    _ClientDescribeInstanceAttributeResponseUserDataTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttributeResponse` `UserData`

    The user data.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseTypeDef",
    {
        "Groups": List[ClientDescribeInstanceAttributeResponseGroupsTypeDef],
        "BlockDeviceMappings": List[
            ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef
        ],
        "DisableApiTermination": ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef,
        "EnaSupport": ClientDescribeInstanceAttributeResponseEnaSupportTypeDef,
        "EbsOptimized": ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef,
        "InstanceId": str,
        "InstanceInitiatedShutdownBehavior": ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef,
        "InstanceType": ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef,
        "KernelId": ClientDescribeInstanceAttributeResponseKernelIdTypeDef,
        "ProductCodes": List[
            ClientDescribeInstanceAttributeResponseProductCodesTypeDef
        ],
        "RamdiskId": ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef,
        "RootDeviceName": ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef,
        "SourceDestCheck": ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef,
        "SriovNetSupport": ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef,
        "UserData": ClientDescribeInstanceAttributeResponseUserDataTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseTypeDef(
    _ClientDescribeInstanceAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeInstanceAttribute` `Response`

    Describes an instance attribute.

    - **Groups** *(list) --*

      The security groups associated with the instance.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping of the instance.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Status** *(string) --*

            The attachment state.

          - **VolumeId** *(string) --*

            The ID of the EBS volume.

    - **DisableApiTermination** *(dict) --*

      If the value is ``true`` , you can't terminate the instance through the Amazon EC2 console,
      CLI, or API; otherwise, you can.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EnaSupport** *(dict) --*

      Indicates whether enhanced networking with ENA is enabled.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EbsOptimized** *(dict) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceInitiatedShutdownBehavior** *(dict) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **InstanceType** *(dict) --*

      The instance type.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **KernelId** *(dict) --*

      The kernel ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **ProductCodes** *(list) --*

      A list of product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **RamdiskId** *(dict) --*

      The RAM disk ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **RootDeviceName** *(dict) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **SourceDestCheck** *(dict) --*

      Indicates whether source/destination checking is enabled. A value of ``true`` means that
      checking is enabled, and ``false`` means that checking is disabled. This value must be
      ``false`` for a NAT instance to perform NAT.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **SriovNetSupport** *(dict) --*

      Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **UserData** *(dict) --*

      The user data.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.
    """


_ClientDescribeInstanceCreditSpecificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsFiltersTypeDef(
    _ClientDescribeInstanceCreditSpecificationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeInstanceCreditSpecifications` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef(
    _ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceCreditSpecificationsResponse` `InstanceCreditSpecifications`

    Describes the credit option for CPU usage of a T2 or T3 instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of the instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientDescribeInstanceCreditSpecificationsResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsResponseTypeDef",
    {
        "InstanceCreditSpecifications": List[
            ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsResponseTypeDef(
    _ClientDescribeInstanceCreditSpecificationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeInstanceCreditSpecifications` `Response`

    - **InstanceCreditSpecifications** *(list) --*

      Information about the credit option for CPU usage of an instance.

      - *(dict) --*

        Describes the credit option for CPU usage of a T2 or T3 instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of the instance. Valid values are ``standard`` and
          ``unlimited`` .

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeInstanceStatusFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInstanceStatusFiltersTypeDef(
    _ClientDescribeInstanceStatusFiltersTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatus` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef",
    {
        "InstanceEventId": str,
        "Code": str,
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatuses` `Events`

    Describes a scheduled event for an instance.

    - **InstanceEventId** *(string) --*

      The ID of the event.

    - **Code** *(string) --*

      The event code.

    - **Description** *(string) --*

      A description of the event.

      After a scheduled event is completed, it can still be described for up to a week. If
      the event has been completed, this description starts with the following text:
      [Completed].

    - **NotAfter** *(datetime) --*

      The latest scheduled end time for the event.

    - **NotBefore** *(datetime) --*

      The earliest scheduled start time for the event.

    - **NotBeforeDeadline** *(datetime) --*

      The deadline for starting the event.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatuses` `InstanceState`

    The intended state of the instance.  DescribeInstanceStatus requires that an instance be
    in the ``running`` state.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    {"ImpairedSince": datetime, "Name": str, "Status": str},
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatus` `Details`

    Describes the instance status.

    - **ImpairedSince** *(datetime) --*

      The time when a status check failed. For an instance that was launched and
      impaired, this is the time when the instance was launched.

    - **Name** *(string) --*

      The type of instance status.

    - **Status** *(string) --*

      The status.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef",
    {
        "Details": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatuses` `InstanceStatus`

    Reports impaired functionality that stems from issues internal to the instance, such as
    impaired reachability.

    - **Details** *(list) --*

      The system instance health or application instance health.

      - *(dict) --*

        Describes the instance status.

        - **ImpairedSince** *(datetime) --*

          The time when a status check failed. For an instance that was launched and
          impaired, this is the time when the instance was launched.

        - **Name** *(string) --*

          The type of instance status.

        - **Status** *(string) --*

          The status.

    - **Status** *(string) --*

      The status.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef",
    {"ImpairedSince": datetime, "Name": str, "Status": str},
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatus` `Details`

    Describes the instance status.

    - **ImpairedSince** *(datetime) --*

      The time when a status check failed. For an instance that was launched and
      impaired, this is the time when the instance was launched.

    - **Name** *(string) --*

      The type of instance status.

    - **Status** *(string) --*

      The status.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef",
    {
        "Details": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponseInstanceStatuses` `SystemStatus`

    Reports impaired functionality that stems from issues related to the systems that support
    an instance, such as hardware failures and network connectivity problems.

    - **Details** *(list) --*

      The system instance health or application instance health.

      - *(dict) --*

        Describes the instance status.

        - **ImpairedSince** *(datetime) --*

          The time when a status check failed. For an instance that was launched and
          impaired, this is the time when the instance was launched.

        - **Name** *(string) --*

          The type of instance status.

        - **Status** *(string) --*

          The status.

    - **Status** *(string) --*

      The status.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef",
    {
        "AvailabilityZone": str,
        "Events": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef
        ],
        "InstanceId": str,
        "InstanceState": ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef,
        "InstanceStatus": ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef,
        "SystemStatus": ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatusResponse` `InstanceStatuses`

    Describes the status of an instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Events** *(list) --*

      Any scheduled events associated with the instance.

      - *(dict) --*

        Describes a scheduled event for an instance.

        - **InstanceEventId** *(string) --*

          The ID of the event.

        - **Code** *(string) --*

          The event code.

        - **Description** *(string) --*

          A description of the event.

          After a scheduled event is completed, it can still be described for up to a week. If
          the event has been completed, this description starts with the following text:
          [Completed].

        - **NotAfter** *(datetime) --*

          The latest scheduled end time for the event.

        - **NotBefore** *(datetime) --*

          The earliest scheduled start time for the event.

        - **NotBeforeDeadline** *(datetime) --*

          The deadline for starting the event.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceState** *(dict) --*

      The intended state of the instance.  DescribeInstanceStatus requires that an instance be
      in the ``running`` state.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceStatus** *(dict) --*

      Reports impaired functionality that stems from issues internal to the instance, such as
      impaired reachability.

      - **Details** *(list) --*

        The system instance health or application instance health.

        - *(dict) --*

          Describes the instance status.

          - **ImpairedSince** *(datetime) --*

            The time when a status check failed. For an instance that was launched and
            impaired, this is the time when the instance was launched.

          - **Name** *(string) --*

            The type of instance status.

          - **Status** *(string) --*

            The status.

      - **Status** *(string) --*

        The status.

    - **SystemStatus** *(dict) --*

      Reports impaired functionality that stems from issues related to the systems that support
      an instance, such as hardware failures and network connectivity problems.

      - **Details** *(list) --*

        The system instance health or application instance health.

        - *(dict) --*

          Describes the instance status.

          - **ImpairedSince** *(datetime) --*

            The time when a status check failed. For an instance that was launched and
            impaired, this is the time when the instance was launched.

          - **Name** *(string) --*

            The type of instance status.

          - **Status** *(string) --*

            The status.

      - **Status** *(string) --*

        The status.
    """


_ClientDescribeInstanceStatusResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseTypeDef",
    {
        "InstanceStatuses": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseTypeDef(
    _ClientDescribeInstanceStatusResponseTypeDef
):
    """
    Type definition for `ClientDescribeInstanceStatus` `Response`

    - **InstanceStatuses** *(list) --*

      Information about the status of the instances.

      - *(dict) --*

        Describes the status of an instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Events** *(list) --*

          Any scheduled events associated with the instance.

          - *(dict) --*

            Describes a scheduled event for an instance.

            - **InstanceEventId** *(string) --*

              The ID of the event.

            - **Code** *(string) --*

              The event code.

            - **Description** *(string) --*

              A description of the event.

              After a scheduled event is completed, it can still be described for up to a week. If
              the event has been completed, this description starts with the following text:
              [Completed].

            - **NotAfter** *(datetime) --*

              The latest scheduled end time for the event.

            - **NotBefore** *(datetime) --*

              The earliest scheduled start time for the event.

            - **NotBeforeDeadline** *(datetime) --*

              The deadline for starting the event.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceState** *(dict) --*

          The intended state of the instance.  DescribeInstanceStatus requires that an instance be
          in the ``running`` state.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceStatus** *(dict) --*

          Reports impaired functionality that stems from issues internal to the instance, such as
          impaired reachability.

          - **Details** *(list) --*

            The system instance health or application instance health.

            - *(dict) --*

              Describes the instance status.

              - **ImpairedSince** *(datetime) --*

                The time when a status check failed. For an instance that was launched and
                impaired, this is the time when the instance was launched.

              - **Name** *(string) --*

                The type of instance status.

              - **Status** *(string) --*

                The status.

          - **Status** *(string) --*

            The status.

        - **SystemStatus** *(dict) --*

          Reports impaired functionality that stems from issues related to the systems that support
          an instance, such as hardware failures and network connectivity problems.

          - **Details** *(list) --*

            The system instance health or application instance health.

            - *(dict) --*

              Describes the instance status.

              - **ImpairedSince** *(datetime) --*

                The time when a status check failed. For an instance that was launched and
                impaired, this is the time when the instance was launched.

              - **Name** *(string) --*

                The type of instance status.

              - **Status** *(string) --*

                The status.

          - **Status** *(string) --*

            The status.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInstancesFiltersTypeDef(_ClientDescribeInstancesFiltersTypeDef):
    """
    Type definition for `ClientDescribeInstances` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeInstancesResponseReservationsGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsGroupsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservations` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": str,
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Status** *(string) --*

      The attachment state.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Status** *(string) --*

        The attachment state.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.
    """


_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the targeted Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Describes the instance's Capacity Reservation preferences. Possible preferences
      include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the targeted Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `CpuOptions`

    The CPU options for the instance.

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `ElasticGpuAssociations`

    Describes the association between an instance and an Elastic Graphics accelerator.

    - **ElasticGpuId** *(string) --*

      The ID of the Elastic Graphics accelerator.

    - **ElasticGpuAssociationId** *(string) --*

      The ID of the association.

    - **ElasticGpuAssociationState** *(string) --*

      The state of the association between the instance and the Elastic Graphics
      accelerator.

    - **ElasticGpuAssociationTime** *(string) --*

      The time the Elastic Graphics accelerator was associated with the instance.
    """


_ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `ElasticInferenceAcceleratorAssociations`

    Describes the association between an instance and an elastic inference accelerator.

    - **ElasticInferenceAcceleratorArn** *(string) --*

      The Amazon Resource Name (ARN) of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationId** *(string) --*

      The ID of the association.

    - **ElasticInferenceAcceleratorAssociationState** *(string) --*

      The state of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

      The time at which the elastic inference accelerator is associated with an
      instance.
    """


_ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `HibernationOptions`

    Indicates whether the instance is enabled for hibernation.

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , your instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `IamInstanceProfile`

    The IAM instance profile associated with the instance, if applicable.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `Licenses`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef",
    {"State": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfaces` `Association`

    The association information for an Elastic IPv4 associated with the network
    interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfaces` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is
      terminated.

    - **DeviceIndex** *(integer) --*

      The index of the device on the instance for the network interface attachment.

    - **Status** *(string) --*

      The attachment state.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfaces` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddresses` `Association`

    The association information for an Elastic IP address for the network
    interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a private IPv4 address.

    - **Association** *(dict) --*

      The association information for an Elastic IP address for the network
      interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IP address of the
      network interface.

    - **PrivateDnsName** *(string) --*

      The private IPv4 DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface.
    """


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef",
    {
        "Association": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
        ],
        "Ipv6Addresses": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `NetworkInterfaces`

    Describes a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IPv4 associated with the network
      interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is
        terminated.

      - **DeviceIndex** *(integer) --*

        The index of the device on the instance for the network interface attachment.

      - **Status** *(string) --*

        The attachment state.

    - **Description** *(string) --*

      The description.

    - **Groups** *(list) --*

      One or more security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The ID of the AWS account that created the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes a private IPv4 address.

        - **Association** *(dict) --*

          The association information for an Elastic IP address for the network
          interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IP address of the
          network interface.

        - **PrivateDnsName** *(string) --*

          The private IPv4 DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether to validate network traffic to or from this network interface.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **InterfaceType** *(string) --*

      Describes the type of network interface.

      Valid values: ``interface`` | ``efa``
    """


_ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `Placement`

    The location where the instance launched, if applicable.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based
      on the load balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not
      supported for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group
      strategy is set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not
      supported for the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with
      a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
      not supported for the  ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `StateReason`

    The reason for the most recent state transition.

    - **Code** *(string) --*

      The reason code for the state change.

    - **Message** *(string) --*

      The message for the state change.

      * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
      available to satisfy the launch request.

      * ``Server.InternalError`` : An internal error caused the instance to terminate
      during launch.

      * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

      * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
      Spot requests with a maximum price equal to or higher than the Spot price exceeded
      available capacity or because of an increase in the Spot price.

      * ``Server.SpotInstanceTermination`` : The instance was terminated because the
      number of Spot requests with a maximum price equal to or higher than the Spot price
      exceeded available capacity or because of an increase in the Spot price.

      * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
      ``shutdown -h`` command from the instance.

      * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
      AMI creation.

      * ``Client.InternalError`` : A client error caused the instance to terminate during
      launch.

      * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

      * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

      * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
      EC2 API.

      * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
      storage was exceeded. Decrease usage or request an increase in your account limits.
    """


_ClientDescribeInstancesResponseReservationsInstancesStateTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesStateTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesStateTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `State`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
      values between 256 and 65,535. These numerical values are used for internal
      purposes and should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
      values between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte
      and they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
      in decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservationsInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeInstancesResponseReservationsInstancesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef,
        "Placement": ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[
            ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef
        ],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": ClientDescribeInstancesResponseReservationsInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": str,
        "BlockDeviceMappings": List[
            ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef
        ],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": str,
        "IamInstanceProfile": ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": str,
        "ElasticGpuAssociations": List[
            ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef
        ],
        "RootDeviceName": str,
        "RootDeviceType": str,
        "SecurityGroups": List[
            ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef
        ],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef,
        "Tags": List[ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef],
        "VirtualizationType": str,
        "CpuOptions": ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef,
        "Licenses": List[
            ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponseReservations` `Instances`

    Describes an instance.

    - **AmiLaunchIndex** *(integer) --*

      The AMI launch index, which can be used to find this instance in the launch group.

    - **ImageId** *(string) --*

      The ID of the AMI used to launch the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The kernel associated with this instance, if applicable.

    - **KeyName** *(string) --*

      The name of the key pair, if this instance was launched with an associated key pair.

    - **LaunchTime** *(datetime) --*

      The time the instance was launched.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

        If not specified, an Availability Zone will be automatically chosen for you based
        on the load balancing criteria for the Region.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host. This parameter is not
        supported for the  ImportInstance command.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.

      - **PartitionNumber** *(integer) --*

        The number of the partition the instance is in. Valid only if the placement group
        strategy is set to ``partition`` .

      - **HostId** *(string) --*

        The ID of the Dedicated Host on which the instance resides. This parameter is not
        supported for the  ImportInstance command.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with
        a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
        not supported for the  ImportInstance command.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.

    - **PrivateDnsName** *(string) --*

      (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
      can only be used inside the Amazon EC2 network. This name is not available until the
      instance enters the ``running`` state.

      [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
      hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
      not using the Amazon-provided DNS server in your VPC, your custom domain name servers
      must resolve the hostname as appropriate.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address assigned to the instance.

    - **ProductCodes** *(list) --*

      The product codes attached to this instance, if applicable.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **PublicDnsName** *(string) --*

      (IPv4 only) The public DNS name assigned to the instance. This name is not available
      until the instance enters the ``running`` state. For EC2-VPC, this name is only
      available if you've enabled DNS hostnames for your VPC.

    - **PublicIpAddress** *(string) --*

      The public IPv4 address assigned to the instance, if applicable.

    - **RamdiskId** *(string) --*

      The RAM disk associated with this instance, if applicable.

    - **State** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
        values between 256 and 65,535. These numerical values are used for internal
        purposes and should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
        values between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte
        and they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
        in decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **StateTransitionReason** *(string) --*

      The reason for the most recent state transition. This might be an empty string.

    - **SubnetId** *(string) --*

      [EC2-VPC] The ID of the subnet in which the instance is running.

    - **VpcId** *(string) --*

      [EC2-VPC] The ID of the VPC in which the instance is running.

    - **Architecture** *(string) --*

      The architecture of the image.

    - **BlockDeviceMappings** *(list) --*

      Any block device mapping entries for the instance.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Status** *(string) --*

            The attachment state.

          - **VolumeId** *(string) --*

            The ID of the EBS volume.

    - **ClientToken** *(string) --*

      The idempotency token you provided when you launched the instance, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
      provides dedicated throughput to Amazon EBS and an optimized configuration stack to
      provide optimal I/O performance. This optimization isn't available with all instance
      types. Additional usage charges apply when using an EBS Optimized instance.

    - **EnaSupport** *(boolean) --*

      Specifies whether enhanced networking with ENA is enabled.

    - **Hypervisor** *(string) --*

      The hypervisor type of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile associated with the instance, if applicable.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **InstanceLifecycle** *(string) --*

      Indicates whether this is a Spot Instance or a Scheduled Instance.

    - **ElasticGpuAssociations** *(list) --*

      The Elastic GPU associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an Elastic Graphics accelerator.

        - **ElasticGpuId** *(string) --*

          The ID of the Elastic Graphics accelerator.

        - **ElasticGpuAssociationId** *(string) --*

          The ID of the association.

        - **ElasticGpuAssociationState** *(string) --*

          The state of the association between the instance and the Elastic Graphics
          accelerator.

        - **ElasticGpuAssociationTime** *(string) --*

          The time the Elastic Graphics accelerator was associated with the instance.

    - **ElasticInferenceAcceleratorAssociations** *(list) --*

      The elastic inference accelerator associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an elastic inference accelerator.

        - **ElasticInferenceAcceleratorArn** *(string) --*

          The Amazon Resource Name (ARN) of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationId** *(string) --*

          The ID of the association.

        - **ElasticInferenceAcceleratorAssociationState** *(string) --*

          The state of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

          The time at which the elastic inference accelerator is associated with an
          instance.

    - **NetworkInterfaces** *(list) --*

      [EC2-VPC] The network interfaces for the instance.

      - *(dict) --*

        Describes a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IPv4 associated with the network
          interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Attachment** *(dict) --*

          The network interface attachment.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **AttachmentId** *(string) --*

            The ID of the network interface attachment.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is
            terminated.

          - **DeviceIndex** *(integer) --*

            The index of the device on the instance for the network interface attachment.

          - **Status** *(string) --*

            The attachment state.

        - **Description** *(string) --*

          The description.

        - **Groups** *(list) --*

          One or more security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses associated with the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **MacAddress** *(string) --*

          The MAC address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **OwnerId** *(string) --*

          The ID of the AWS account that created the network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses associated with the network interface.

          - *(dict) --*

            Describes a private IPv4 address.

            - **Association** *(dict) --*

              The association information for an Elastic IP address for the network
              interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Primary** *(boolean) --*

              Indicates whether this IPv4 address is the primary private IP address of the
              network interface.

            - **PrivateDnsName** *(string) --*

              The private IPv4 DNS name.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface.

        - **SourceDestCheck** *(boolean) --*

          Indicates whether to validate network traffic to or from this network interface.

        - **Status** *(string) --*

          The status of the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **InterfaceType** *(string) --*

          Describes the type of network interface.

          Valid values: ``interface`` | ``efa``

    - **RootDeviceName** *(string) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **RootDeviceType** *(string) --*

      The root device type used by the AMI. The AMI can use an EBS volume or an instance
      store volume.

    - **SecurityGroups** *(list) --*

      The security groups for the instance.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **SourceDestCheck** *(boolean) --*

      Specifies whether to enable an instance launched in a VPC to perform NAT. This
      controls whether source/destination checking is enabled on the instance. A value of
      ``true`` means that checking is enabled, and ``false`` means that checking is
      disabled. The value must be ``false`` for the instance to perform NAT. For more
      information, see `NAT Instances
      <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
      the *Amazon Virtual Private Cloud User Guide* .

    - **SpotInstanceRequestId** *(string) --*

      If the request is a Spot Instance request, the ID of the request.

    - **SriovNetSupport** *(string) --*

      Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
      is enabled.

    - **StateReason** *(dict) --*

      The reason for the most recent state transition.

      - **Code** *(string) --*

        The reason code for the state change.

      - **Message** *(string) --*

        The message for the state change.

        * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
        available to satisfy the launch request.

        * ``Server.InternalError`` : An internal error caused the instance to terminate
        during launch.

        * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

        * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
        Spot requests with a maximum price equal to or higher than the Spot price exceeded
        available capacity or because of an increase in the Spot price.

        * ``Server.SpotInstanceTermination`` : The instance was terminated because the
        number of Spot requests with a maximum price equal to or higher than the Spot price
        exceeded available capacity or because of an increase in the Spot price.

        * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
        ``shutdown -h`` command from the instance.

        * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
        AMI creation.

        * ``Client.InternalError`` : A client error caused the instance to terminate during
        launch.

        * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

        * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

        * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
        EC2 API.

        * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
        storage was exceeded. Decrease usage or request an increase in your account limits.

    - **Tags** *(list) --*

      Any tags assigned to the instance.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VirtualizationType** *(string) --*

      The virtualization type of the instance.

    - **CpuOptions** *(dict) --*

      The CPU options for the instance.

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Describes the instance's Capacity Reservation preferences. Possible preferences
        include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the targeted Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **HibernationOptions** *(dict) --*

      Indicates whether the instance is enabled for hibernation.

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , your instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.

    - **Licenses** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientDescribeInstancesResponseReservationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsTypeDef",
    {
        "Groups": List[ClientDescribeInstancesResponseReservationsGroupsTypeDef],
        "Instances": List[ClientDescribeInstancesResponseReservationsInstancesTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsTypeDef(
    _ClientDescribeInstancesResponseReservationsTypeDef
):
    """
    Type definition for `ClientDescribeInstancesResponse` `Reservations`

    Describes a reservation.

    - **Groups** *(list) --*

      [EC2-Classic only] The security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Instances** *(list) --*

      The instances.

      - *(dict) --*

        Describes an instance.

        - **AmiLaunchIndex** *(integer) --*

          The AMI launch index, which can be used to find this instance in the launch group.

        - **ImageId** *(string) --*

          The ID of the AMI used to launch the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The kernel associated with this instance, if applicable.

        - **KeyName** *(string) --*

          The name of the key pair, if this instance was launched with an associated key pair.

        - **LaunchTime** *(datetime) --*

          The time the instance was launched.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.

            If not specified, an Availability Zone will be automatically chosen for you based
            on the load balancing criteria for the Region.

          - **Affinity** *(string) --*

            The affinity setting for the instance on the Dedicated Host. This parameter is not
            supported for the  ImportInstance command.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

          - **PartitionNumber** *(integer) --*

            The number of the partition the instance is in. Valid only if the placement group
            strategy is set to ``partition`` .

          - **HostId** *(string) --*

            The ID of the Dedicated Host on which the instance resides. This parameter is not
            supported for the  ImportInstance command.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with
            a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
            not supported for the  ImportInstance command.

          - **SpreadDomain** *(string) --*

            Reserved for future use.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.

        - **PrivateDnsName** *(string) --*

          (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
          can only be used inside the Amazon EC2 network. This name is not available until the
          instance enters the ``running`` state.

          [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
          hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
          not using the Amazon-provided DNS server in your VPC, your custom domain name servers
          must resolve the hostname as appropriate.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address assigned to the instance.

        - **ProductCodes** *(list) --*

          The product codes attached to this instance, if applicable.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **PublicDnsName** *(string) --*

          (IPv4 only) The public DNS name assigned to the instance. This name is not available
          until the instance enters the ``running`` state. For EC2-VPC, this name is only
          available if you've enabled DNS hostnames for your VPC.

        - **PublicIpAddress** *(string) --*

          The public IPv4 address assigned to the instance, if applicable.

        - **RamdiskId** *(string) --*

          The RAM disk associated with this instance, if applicable.

        - **State** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
            values between 256 and 65,535. These numerical values are used for internal
            purposes and should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
            values between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte
            and they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
            in decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **StateTransitionReason** *(string) --*

          The reason for the most recent state transition. This might be an empty string.

        - **SubnetId** *(string) --*

          [EC2-VPC] The ID of the subnet in which the instance is running.

        - **VpcId** *(string) --*

          [EC2-VPC] The ID of the VPC in which the instance is running.

        - **Architecture** *(string) --*

          The architecture of the image.

        - **BlockDeviceMappings** *(list) --*

          Any block device mapping entries for the instance.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is launched.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the volume is deleted on instance termination.

              - **Status** *(string) --*

                The attachment state.

              - **VolumeId** *(string) --*

                The ID of the EBS volume.

        - **ClientToken** *(string) --*

          The idempotency token you provided when you launched the instance, if applicable.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
          provides dedicated throughput to Amazon EBS and an optimized configuration stack to
          provide optimal I/O performance. This optimization isn't available with all instance
          types. Additional usage charges apply when using an EBS Optimized instance.

        - **EnaSupport** *(boolean) --*

          Specifies whether enhanced networking with ENA is enabled.

        - **Hypervisor** *(string) --*

          The hypervisor type of the instance.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile associated with the instance, if applicable.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Id** *(string) --*

            The ID of the instance profile.

        - **InstanceLifecycle** *(string) --*

          Indicates whether this is a Spot Instance or a Scheduled Instance.

        - **ElasticGpuAssociations** *(list) --*

          The Elastic GPU associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an Elastic Graphics accelerator.

            - **ElasticGpuId** *(string) --*

              The ID of the Elastic Graphics accelerator.

            - **ElasticGpuAssociationId** *(string) --*

              The ID of the association.

            - **ElasticGpuAssociationState** *(string) --*

              The state of the association between the instance and the Elastic Graphics
              accelerator.

            - **ElasticGpuAssociationTime** *(string) --*

              The time the Elastic Graphics accelerator was associated with the instance.

        - **ElasticInferenceAcceleratorAssociations** *(list) --*

          The elastic inference accelerator associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an elastic inference accelerator.

            - **ElasticInferenceAcceleratorArn** *(string) --*

              The Amazon Resource Name (ARN) of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationId** *(string) --*

              The ID of the association.

            - **ElasticInferenceAcceleratorAssociationState** *(string) --*

              The state of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

              The time at which the elastic inference accelerator is associated with an
              instance.

        - **NetworkInterfaces** *(list) --*

          [EC2-VPC] The network interfaces for the instance.

          - *(dict) --*

            Describes a network interface.

            - **Association** *(dict) --*

              The association information for an Elastic IPv4 associated with the network
              interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Attachment** *(dict) --*

              The network interface attachment.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **AttachmentId** *(string) --*

                The ID of the network interface attachment.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the network interface is deleted when the instance is
                terminated.

              - **DeviceIndex** *(integer) --*

                The index of the device on the instance for the network interface attachment.

              - **Status** *(string) --*

                The attachment state.

            - **Description** *(string) --*

              The description.

            - **Groups** *(list) --*

              One or more security groups.

              - *(dict) --*

                Describes a security group.

                - **GroupName** *(string) --*

                  The name of the security group.

                - **GroupId** *(string) --*

                  The ID of the security group.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses associated with the network interface.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **MacAddress** *(string) --*

              The MAC address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **OwnerId** *(string) --*

              The ID of the AWS account that created the network interface.

            - **PrivateDnsName** *(string) --*

              The private DNS name.

            - **PrivateIpAddress** *(string) --*

              The IPv4 address of the network interface within the subnet.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses associated with the network interface.

              - *(dict) --*

                Describes a private IPv4 address.

                - **Association** *(dict) --*

                  The association information for an Elastic IP address for the network
                  interface.

                  - **IpOwnerId** *(string) --*

                    The ID of the owner of the Elastic IP address.

                  - **PublicDnsName** *(string) --*

                    The public DNS name.

                  - **PublicIp** *(string) --*

                    The public IP address or Elastic IP address bound to the network interface.

                - **Primary** *(boolean) --*

                  Indicates whether this IPv4 address is the primary private IP address of the
                  network interface.

                - **PrivateDnsName** *(string) --*

                  The private IPv4 DNS name.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 address of the network interface.

            - **SourceDestCheck** *(boolean) --*

              Indicates whether to validate network traffic to or from this network interface.

            - **Status** *(string) --*

              The status of the network interface.

            - **SubnetId** *(string) --*

              The ID of the subnet.

            - **VpcId** *(string) --*

              The ID of the VPC.

            - **InterfaceType** *(string) --*

              Describes the type of network interface.

              Valid values: ``interface`` | ``efa``

        - **RootDeviceName** *(string) --*

          The device name of the root device volume (for example, ``/dev/sda1`` ).

        - **RootDeviceType** *(string) --*

          The root device type used by the AMI. The AMI can use an EBS volume or an instance
          store volume.

        - **SecurityGroups** *(list) --*

          The security groups for the instance.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **SourceDestCheck** *(boolean) --*

          Specifies whether to enable an instance launched in a VPC to perform NAT. This
          controls whether source/destination checking is enabled on the instance. A value of
          ``true`` means that checking is enabled, and ``false`` means that checking is
          disabled. The value must be ``false`` for the instance to perform NAT. For more
          information, see `NAT Instances
          <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
          the *Amazon Virtual Private Cloud User Guide* .

        - **SpotInstanceRequestId** *(string) --*

          If the request is a Spot Instance request, the ID of the request.

        - **SriovNetSupport** *(string) --*

          Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
          is enabled.

        - **StateReason** *(dict) --*

          The reason for the most recent state transition.

          - **Code** *(string) --*

            The reason code for the state change.

          - **Message** *(string) --*

            The message for the state change.

            * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
            available to satisfy the launch request.

            * ``Server.InternalError`` : An internal error caused the instance to terminate
            during launch.

            * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

            * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
            Spot requests with a maximum price equal to or higher than the Spot price exceeded
            available capacity or because of an increase in the Spot price.

            * ``Server.SpotInstanceTermination`` : The instance was terminated because the
            number of Spot requests with a maximum price equal to or higher than the Spot price
            exceeded available capacity or because of an increase in the Spot price.

            * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
            ``shutdown -h`` command from the instance.

            * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
            AMI creation.

            * ``Client.InternalError`` : A client error caused the instance to terminate during
            launch.

            * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

            * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

            * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
            EC2 API.

            * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
            storage was exceeded. Decrease usage or request an increase in your account limits.

        - **Tags** *(list) --*

          Any tags assigned to the instance.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VirtualizationType** *(string) --*

          The virtualization type of the instance.

        - **CpuOptions** *(dict) --*

          The CPU options for the instance.

          - **CoreCount** *(integer) --*

            The number of CPU cores for the instance.

          - **ThreadsPerCore** *(integer) --*

            The number of threads per CPU core.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

        - **CapacityReservationSpecification** *(dict) --*

          Information about the Capacity Reservation targeting option.

          - **CapacityReservationPreference** *(string) --*

            Describes the instance's Capacity Reservation preferences. Possible preferences
            include:

            * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
            matching attributes (instance type, platform, Availability Zone).

            * ``none`` - The instance avoids running in a Capacity Reservation even if one is
            available. The instance runs in On-Demand capacity.

          - **CapacityReservationTarget** *(dict) --*

            Information about the targeted Capacity Reservation.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

        - **HibernationOptions** *(dict) --*

          Indicates whether the instance is enabled for hibernation.

          - **Configured** *(boolean) --*

            If this parameter is set to ``true`` , your instance is enabled for hibernation;
            otherwise, it is not enabled for hibernation.

        - **Licenses** *(list) --*

          The license configurations.

          - *(dict) --*

            Describes a license configuration.

            - **LicenseConfigurationArn** *(string) --*

              The Amazon Resource Name (ARN) of the license configuration.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the reservation.

    - **RequesterId** *(string) --*

      The ID of the requester that launched the instances on your behalf (for example, AWS
      Management Console or Auto Scaling).

    - **ReservationId** *(string) --*

      The ID of the reservation.
    """


_ClientDescribeInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseTypeDef",
    {
        "Reservations": List[ClientDescribeInstancesResponseReservationsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseTypeDef(_ClientDescribeInstancesResponseTypeDef):
    """
    Type definition for `ClientDescribeInstances` `Response`

    - **Reservations** *(list) --*

      Information about the reservations.

      - *(dict) --*

        Describes a reservation.

        - **Groups** *(list) --*

          [EC2-Classic only] The security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **Instances** *(list) --*

          The instances.

          - *(dict) --*

            Describes an instance.

            - **AmiLaunchIndex** *(integer) --*

              The AMI launch index, which can be used to find this instance in the launch group.

            - **ImageId** *(string) --*

              The ID of the AMI used to launch the instance.

            - **InstanceId** *(string) --*

              The ID of the instance.

            - **InstanceType** *(string) --*

              The instance type.

            - **KernelId** *(string) --*

              The kernel associated with this instance, if applicable.

            - **KeyName** *(string) --*

              The name of the key pair, if this instance was launched with an associated key pair.

            - **LaunchTime** *(datetime) --*

              The time the instance was launched.

            - **Monitoring** *(dict) --*

              The monitoring for the instance.

              - **State** *(string) --*

                Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
                enabled.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **AvailabilityZone** *(string) --*

                The Availability Zone of the instance.

                If not specified, an Availability Zone will be automatically chosen for you based
                on the load balancing criteria for the Region.

              - **Affinity** *(string) --*

                The affinity setting for the instance on the Dedicated Host. This parameter is not
                supported for the  ImportInstance command.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

              - **PartitionNumber** *(integer) --*

                The number of the partition the instance is in. Valid only if the placement group
                strategy is set to ``partition`` .

              - **HostId** *(string) --*

                The ID of the Dedicated Host on which the instance resides. This parameter is not
                supported for the  ImportInstance command.

              - **Tenancy** *(string) --*

                The tenancy of the instance (if the instance is running in a VPC). An instance with
                a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
                not supported for the  ImportInstance command.

              - **SpreadDomain** *(string) --*

                Reserved for future use.

            - **Platform** *(string) --*

              The value is ``Windows`` for Windows instances; otherwise blank.

            - **PrivateDnsName** *(string) --*

              (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
              can only be used inside the Amazon EC2 network. This name is not available until the
              instance enters the ``running`` state.

              [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
              hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
              not using the Amazon-provided DNS server in your VPC, your custom domain name servers
              must resolve the hostname as appropriate.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address assigned to the instance.

            - **ProductCodes** *(list) --*

              The product codes attached to this instance, if applicable.

              - *(dict) --*

                Describes a product code.

                - **ProductCodeId** *(string) --*

                  The product code.

                - **ProductCodeType** *(string) --*

                  The type of product code.

            - **PublicDnsName** *(string) --*

              (IPv4 only) The public DNS name assigned to the instance. This name is not available
              until the instance enters the ``running`` state. For EC2-VPC, this name is only
              available if you've enabled DNS hostnames for your VPC.

            - **PublicIpAddress** *(string) --*

              The public IPv4 address assigned to the instance, if applicable.

            - **RamdiskId** *(string) --*

              The RAM disk associated with this instance, if applicable.

            - **State** *(dict) --*

              The current state of the instance.

              - **Code** *(integer) --*

                The state of the instance as a 16-bit unsigned integer.

                The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
                values between 256 and 65,535. These numerical values are used for internal
                purposes and should be ignored.

                The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
                values between 0 and 255.

                The valid values for instance-state-code will all be in the range of the low byte
                and they are:

                * ``0`` : ``pending``

                * ``16`` : ``running``

                * ``32`` : ``shutting-down``

                * ``48`` : ``terminated``

                * ``64`` : ``stopping``

                * ``80`` : ``stopped``

                You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
                in decimal.

              - **Name** *(string) --*

                The current state of the instance.

            - **StateTransitionReason** *(string) --*

              The reason for the most recent state transition. This might be an empty string.

            - **SubnetId** *(string) --*

              [EC2-VPC] The ID of the subnet in which the instance is running.

            - **VpcId** *(string) --*

              [EC2-VPC] The ID of the VPC in which the instance is running.

            - **Architecture** *(string) --*

              The architecture of the image.

            - **BlockDeviceMappings** *(list) --*

              Any block device mapping entries for the instance.

              - *(dict) --*

                Describes a block device mapping.

                - **DeviceName** *(string) --*

                  The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

                - **Ebs** *(dict) --*

                  Parameters used to automatically set up EBS volumes when the instance is launched.

                  - **AttachTime** *(datetime) --*

                    The time stamp when the attachment initiated.

                  - **DeleteOnTermination** *(boolean) --*

                    Indicates whether the volume is deleted on instance termination.

                  - **Status** *(string) --*

                    The attachment state.

                  - **VolumeId** *(string) --*

                    The ID of the EBS volume.

            - **ClientToken** *(string) --*

              The idempotency token you provided when you launched the instance, if applicable.

            - **EbsOptimized** *(boolean) --*

              Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
              provides dedicated throughput to Amazon EBS and an optimized configuration stack to
              provide optimal I/O performance. This optimization isn't available with all instance
              types. Additional usage charges apply when using an EBS Optimized instance.

            - **EnaSupport** *(boolean) --*

              Specifies whether enhanced networking with ENA is enabled.

            - **Hypervisor** *(string) --*

              The hypervisor type of the instance.

            - **IamInstanceProfile** *(dict) --*

              The IAM instance profile associated with the instance, if applicable.

              - **Arn** *(string) --*

                The Amazon Resource Name (ARN) of the instance profile.

              - **Id** *(string) --*

                The ID of the instance profile.

            - **InstanceLifecycle** *(string) --*

              Indicates whether this is a Spot Instance or a Scheduled Instance.

            - **ElasticGpuAssociations** *(list) --*

              The Elastic GPU associated with the instance.

              - *(dict) --*

                Describes the association between an instance and an Elastic Graphics accelerator.

                - **ElasticGpuId** *(string) --*

                  The ID of the Elastic Graphics accelerator.

                - **ElasticGpuAssociationId** *(string) --*

                  The ID of the association.

                - **ElasticGpuAssociationState** *(string) --*

                  The state of the association between the instance and the Elastic Graphics
                  accelerator.

                - **ElasticGpuAssociationTime** *(string) --*

                  The time the Elastic Graphics accelerator was associated with the instance.

            - **ElasticInferenceAcceleratorAssociations** *(list) --*

              The elastic inference accelerator associated with the instance.

              - *(dict) --*

                Describes the association between an instance and an elastic inference accelerator.

                - **ElasticInferenceAcceleratorArn** *(string) --*

                  The Amazon Resource Name (ARN) of the elastic inference accelerator.

                - **ElasticInferenceAcceleratorAssociationId** *(string) --*

                  The ID of the association.

                - **ElasticInferenceAcceleratorAssociationState** *(string) --*

                  The state of the elastic inference accelerator.

                - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

                  The time at which the elastic inference accelerator is associated with an
                  instance.

            - **NetworkInterfaces** *(list) --*

              [EC2-VPC] The network interfaces for the instance.

              - *(dict) --*

                Describes a network interface.

                - **Association** *(dict) --*

                  The association information for an Elastic IPv4 associated with the network
                  interface.

                  - **IpOwnerId** *(string) --*

                    The ID of the owner of the Elastic IP address.

                  - **PublicDnsName** *(string) --*

                    The public DNS name.

                  - **PublicIp** *(string) --*

                    The public IP address or Elastic IP address bound to the network interface.

                - **Attachment** *(dict) --*

                  The network interface attachment.

                  - **AttachTime** *(datetime) --*

                    The time stamp when the attachment initiated.

                  - **AttachmentId** *(string) --*

                    The ID of the network interface attachment.

                  - **DeleteOnTermination** *(boolean) --*

                    Indicates whether the network interface is deleted when the instance is
                    terminated.

                  - **DeviceIndex** *(integer) --*

                    The index of the device on the instance for the network interface attachment.

                  - **Status** *(string) --*

                    The attachment state.

                - **Description** *(string) --*

                  The description.

                - **Groups** *(list) --*

                  One or more security groups.

                  - *(dict) --*

                    Describes a security group.

                    - **GroupName** *(string) --*

                      The name of the security group.

                    - **GroupId** *(string) --*

                      The ID of the security group.

                - **Ipv6Addresses** *(list) --*

                  One or more IPv6 addresses associated with the network interface.

                  - *(dict) --*

                    Describes an IPv6 address.

                    - **Ipv6Address** *(string) --*

                      The IPv6 address.

                - **MacAddress** *(string) --*

                  The MAC address.

                - **NetworkInterfaceId** *(string) --*

                  The ID of the network interface.

                - **OwnerId** *(string) --*

                  The ID of the AWS account that created the network interface.

                - **PrivateDnsName** *(string) --*

                  The private DNS name.

                - **PrivateIpAddress** *(string) --*

                  The IPv4 address of the network interface within the subnet.

                - **PrivateIpAddresses** *(list) --*

                  One or more private IPv4 addresses associated with the network interface.

                  - *(dict) --*

                    Describes a private IPv4 address.

                    - **Association** *(dict) --*

                      The association information for an Elastic IP address for the network
                      interface.

                      - **IpOwnerId** *(string) --*

                        The ID of the owner of the Elastic IP address.

                      - **PublicDnsName** *(string) --*

                        The public DNS name.

                      - **PublicIp** *(string) --*

                        The public IP address or Elastic IP address bound to the network interface.

                    - **Primary** *(boolean) --*

                      Indicates whether this IPv4 address is the primary private IP address of the
                      network interface.

                    - **PrivateDnsName** *(string) --*

                      The private IPv4 DNS name.

                    - **PrivateIpAddress** *(string) --*

                      The private IPv4 address of the network interface.

                - **SourceDestCheck** *(boolean) --*

                  Indicates whether to validate network traffic to or from this network interface.

                - **Status** *(string) --*

                  The status of the network interface.

                - **SubnetId** *(string) --*

                  The ID of the subnet.

                - **VpcId** *(string) --*

                  The ID of the VPC.

                - **InterfaceType** *(string) --*

                  Describes the type of network interface.

                  Valid values: ``interface`` | ``efa``

            - **RootDeviceName** *(string) --*

              The device name of the root device volume (for example, ``/dev/sda1`` ).

            - **RootDeviceType** *(string) --*

              The root device type used by the AMI. The AMI can use an EBS volume or an instance
              store volume.

            - **SecurityGroups** *(list) --*

              The security groups for the instance.

              - *(dict) --*

                Describes a security group.

                - **GroupName** *(string) --*

                  The name of the security group.

                - **GroupId** *(string) --*

                  The ID of the security group.

            - **SourceDestCheck** *(boolean) --*

              Specifies whether to enable an instance launched in a VPC to perform NAT. This
              controls whether source/destination checking is enabled on the instance. A value of
              ``true`` means that checking is enabled, and ``false`` means that checking is
              disabled. The value must be ``false`` for the instance to perform NAT. For more
              information, see `NAT Instances
              <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
              the *Amazon Virtual Private Cloud User Guide* .

            - **SpotInstanceRequestId** *(string) --*

              If the request is a Spot Instance request, the ID of the request.

            - **SriovNetSupport** *(string) --*

              Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
              is enabled.

            - **StateReason** *(dict) --*

              The reason for the most recent state transition.

              - **Code** *(string) --*

                The reason code for the state change.

              - **Message** *(string) --*

                The message for the state change.

                * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
                available to satisfy the launch request.

                * ``Server.InternalError`` : An internal error caused the instance to terminate
                during launch.

                * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

                * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
                Spot requests with a maximum price equal to or higher than the Spot price exceeded
                available capacity or because of an increase in the Spot price.

                * ``Server.SpotInstanceTermination`` : The instance was terminated because the
                number of Spot requests with a maximum price equal to or higher than the Spot price
                exceeded available capacity or because of an increase in the Spot price.

                * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
                ``shutdown -h`` command from the instance.

                * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
                AMI creation.

                * ``Client.InternalError`` : A client error caused the instance to terminate during
                launch.

                * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

                * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

                * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
                EC2 API.

                * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
                storage was exceeded. Decrease usage or request an increase in your account limits.

            - **Tags** *(list) --*

              Any tags assigned to the instance.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                  characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                  characters.

            - **VirtualizationType** *(string) --*

              The virtualization type of the instance.

            - **CpuOptions** *(dict) --*

              The CPU options for the instance.

              - **CoreCount** *(integer) --*

                The number of CPU cores for the instance.

              - **ThreadsPerCore** *(integer) --*

                The number of threads per CPU core.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

            - **CapacityReservationSpecification** *(dict) --*

              Information about the Capacity Reservation targeting option.

              - **CapacityReservationPreference** *(string) --*

                Describes the instance's Capacity Reservation preferences. Possible preferences
                include:

                * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
                matching attributes (instance type, platform, Availability Zone).

                * ``none`` - The instance avoids running in a Capacity Reservation even if one is
                available. The instance runs in On-Demand capacity.

              - **CapacityReservationTarget** *(dict) --*

                Information about the targeted Capacity Reservation.

                - **CapacityReservationId** *(string) --*

                  The ID of the Capacity Reservation.

            - **HibernationOptions** *(dict) --*

              Indicates whether the instance is enabled for hibernation.

              - **Configured** *(boolean) --*

                If this parameter is set to ``true`` , your instance is enabled for hibernation;
                otherwise, it is not enabled for hibernation.

            - **Licenses** *(list) --*

              The license configurations.

              - *(dict) --*

                Describes a license configuration.

                - **LicenseConfigurationArn** *(string) --*

                  The Amazon Resource Name (ARN) of the license configuration.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the reservation.

        - **RequesterId** *(string) --*

          The ID of the requester that launched the instances on your behalf (for example, AWS
          Management Console or Auto Scaling).

        - **ReservationId** *(string) --*

          The ID of the reservation.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeInternetGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInternetGatewaysFiltersTypeDef(
    _ClientDescribeInternetGatewaysFiltersTypeDef
):
    """
    Type definition for `ClientDescribeInternetGateways` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeInternetGatewaysResponseInternetGateways` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef
):
    """
    Type definition for `ClientDescribeInternetGatewaysResponseInternetGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef",
    {
        "Attachments": List[
            ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef
        ],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeInternetGatewaysResponse` `InternetGateways`

    Describes an internet gateway.

    - **Attachments** *(list) --*

      Any VPCs attached to the internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **InternetGatewayId** *(string) --*

      The ID of the internet gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the internet gateway.

    - **Tags** *(list) --*

      Any tags assigned to the internet gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeInternetGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseTypeDef",
    {
        "InternetGateways": List[
            ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInternetGatewaysResponseTypeDef(
    _ClientDescribeInternetGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeInternetGateways` `Response`

    - **InternetGateways** *(list) --*

      Information about one or more internet gateways.

      - *(dict) --*

        Describes an internet gateway.

        - **Attachments** *(list) --*

          Any VPCs attached to the internet gateway.

          - *(dict) --*

            Describes the attachment of a VPC to an internet gateway or an egress-only internet
            gateway.

            - **State** *(string) --*

              The current state of the attachment. For an internet gateway, the state is
              ``available`` when attached to a VPC; otherwise, this value is not returned.

            - **VpcId** *(string) --*

              The ID of the VPC.

        - **InternetGatewayId** *(string) --*

          The ID of the internet gateway.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the internet gateway.

        - **Tags** *(list) --*

          Any tags assigned to the internet gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeKeyPairsFiltersTypeDef = TypedDict(
    "_ClientDescribeKeyPairsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeKeyPairsFiltersTypeDef(_ClientDescribeKeyPairsFiltersTypeDef):
    """
    Type definition for `ClientDescribeKeyPairs` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeKeyPairsResponseKeyPairsTypeDef = TypedDict(
    "_ClientDescribeKeyPairsResponseKeyPairsTypeDef",
    {"KeyFingerprint": str, "KeyName": str},
    total=False,
)


class ClientDescribeKeyPairsResponseKeyPairsTypeDef(
    _ClientDescribeKeyPairsResponseKeyPairsTypeDef
):
    """
    Type definition for `ClientDescribeKeyPairsResponse` `KeyPairs`

    Describes a key pair.

    - **KeyFingerprint** *(string) --*

      If you used  CreateKeyPair to create the key pair, this is the SHA-1 digest of the DER
      encoded private key. If you used  ImportKeyPair to provide AWS the public key, this is
      the MD5 public key fingerprint as specified in section 4 of RFC4716.

    - **KeyName** *(string) --*

      The name of the key pair.
    """


_ClientDescribeKeyPairsResponseTypeDef = TypedDict(
    "_ClientDescribeKeyPairsResponseTypeDef",
    {"KeyPairs": List[ClientDescribeKeyPairsResponseKeyPairsTypeDef]},
    total=False,
)


class ClientDescribeKeyPairsResponseTypeDef(_ClientDescribeKeyPairsResponseTypeDef):
    """
    Type definition for `ClientDescribeKeyPairs` `Response`

    - **KeyPairs** *(list) --*

      Information about the key pairs.

      - *(dict) --*

        Describes a key pair.

        - **KeyFingerprint** *(string) --*

          If you used  CreateKeyPair to create the key pair, this is the SHA-1 digest of the DER
          encoded private key. If you used  ImportKeyPair to provide AWS the public key, this is
          the MD5 public key fingerprint as specified in section 4 of RFC4716.

        - **KeyName** *(string) --*

          The name of the key pair.
    """


_ClientDescribeLaunchTemplateVersionsFiltersTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsFiltersTypeDef(
    _ClientDescribeLaunchTemplateVersionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Information about the block device for an EBS volume.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **VolumeType** *(string) --*

      The volume type.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name.

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN).

    - **Ebs** *(dict) --*

      Information about the block device for an EBS volume.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences
      include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
      and ``unlimited`` .
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `ElasticGpuSpecifications`

    Describes an elastic GPU.

    - **Type** *(string) --*

      The elastic GPU type.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --*

      The type of elastic inference accelerator. The possible values are eia1.medium,
      eia1.large, and eia1.xlarge.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is configured for hibernation. For more information, see
    `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
    Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , the instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in
      minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active
      until all instances launch, the request is canceled, or this date is reached. If
      the request is persistent, it remains active until it is canceled or this date and
      time is reached.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in
        minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active
        until all instances launch, the request is canceled, or this date is reached. If
        the request is persistent, it remains active until it is canceled or this date and
        time is reached.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to associate a public IPv4 address with eth0 for a new network
      interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses for the network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses for the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses for the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `Placement`

    The placement of the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateData` `TagSpecifications`

    The tag specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource.

    - **Tags** *(list) --*

      The tags for the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersions` `LaunchTemplateData`

    Information about the launch template.

    - **KernelId** *(string) --*

      The ID of the kernel, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mappings.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name.

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN).

        - **Ebs** *(dict) --*

          Information about the block device for an EBS volume.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      The network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to associate a public IPv4 address with eth0 for a new network
          interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses for the network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses for the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses for the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI that was used to launch the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The placement of the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk, if applicable.

    - **DisableApiTermination** *(boolean) --*

      If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
      EC2 console, command line tool, or API.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

    - **UserData** *(string) --*

      The user data for the instance.

    - **TagSpecifications** *(list) --*

      The tags.

      - *(dict) --*

        The tag specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource.

        - **Tags** *(list) --*

          The tags for the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      The elastic GPU specification.

      - *(dict) --*

        Describes an elastic GPU.

        - **Type** *(string) --*

          The elastic GPU type.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --*

          The type of elastic inference accelerator. The possible values are eia1.medium,
          eia1.large, and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      The security group IDs.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      The security group names.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in
          minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active
          until all instances launch, the request is canceled, or this date is reached. If
          the request is persistent, it remains active until it is canceled or this date and
          time is reached.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance.

      - **CpuCredits** *(string) --*

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
        and ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences
        include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is configured for hibernation. For more information, see
      `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , the instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersionsResponse` `LaunchTemplateVersions`

    Describes a launch template version.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **VersionNumber** *(integer) --*

      The version number.

    - **VersionDescription** *(string) --*

      The description for the version.

    - **CreateTime** *(datetime) --*

      The time the version was created.

    - **CreatedBy** *(string) --*

      The principal that created the version.

    - **DefaultVersion** *(boolean) --*

      Indicates whether the version is the default version.

    - **LaunchTemplateData** *(dict) --*

      Information about the launch template.

      - **KernelId** *(string) --*

        The ID of the kernel, if applicable.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for Amazon EBS I/O.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **BlockDeviceMappings** *(list) --*

        The block device mappings.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name.

          - **VirtualName** *(string) --*

            The virtual device name (ephemeralN).

          - **Ebs** *(dict) --*

            Information about the block device for an EBS volume.

            - **Encrypted** *(boolean) --*

              Indicates whether the EBS volume is encrypted.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports.

            - **KmsKeyId** *(string) --*

              The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

            - **VolumeType** *(string) --*

              The volume type.

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **NetworkInterfaces** *(list) --*

        The network interfaces.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to associate a public IPv4 address with eth0 for a new network
            interface.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **Description** *(string) --*

            A description for the network interface.

          - **DeviceIndex** *(integer) --*

            The device index for the network interface attachment.

          - **Groups** *(list) --*

            The IDs of one or more security groups.

            - *(string) --*

          - **InterfaceType** *(string) --*

            The type of network interface.

          - **Ipv6AddressCount** *(integer) --*

            The number of IPv6 addresses for the network interface.

          - **Ipv6Addresses** *(list) --*

            The IPv6 addresses for the network interface.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The primary private IPv4 address of the network interface.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses for the network interface.

          - **SubnetId** *(string) --*

            The ID of the subnet for the network interface.

      - **ImageId** *(string) --*

        The ID of the AMI that was used to launch the instance.

      - **InstanceType** *(string) --*

        The instance type.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **Monitoring** *(dict) --*

        The monitoring for the instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

      - **Placement** *(dict) --*

        The placement of the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Affinity** *(string) --*

          The affinity setting for the instance on the Dedicated Host.

        - **GroupName** *(string) --*

          The name of the placement group for the instance.

        - **HostId** *(string) --*

          The ID of the Dedicated Host for the instance.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware.

        - **SpreadDomain** *(string) --*

          Reserved for future use.

      - **RamDiskId** *(string) --*

        The ID of the RAM disk, if applicable.

      - **DisableApiTermination** *(boolean) --*

        If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
        EC2 console, command line tool, or API.

      - **InstanceInitiatedShutdownBehavior** *(string) --*

        Indicates whether an instance stops or terminates when you initiate shutdown from the
        instance (using the operating system command for system shutdown).

      - **UserData** *(string) --*

        The user data for the instance.

      - **TagSpecifications** *(list) --*

        The tags.

        - *(dict) --*

          The tag specification for the launch template.

          - **ResourceType** *(string) --*

            The type of resource.

          - **Tags** *(list) --*

            The tags for the resource.

            - *(dict) --*

              Describes a tag.

              - **Key** *(string) --*

                The key of the tag.

                Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                characters. May not begin with ``aws:`` .

              - **Value** *(string) --*

                The value of the tag.

                Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                characters.

      - **ElasticGpuSpecifications** *(list) --*

        The elastic GPU specification.

        - *(dict) --*

          Describes an elastic GPU.

          - **Type** *(string) --*

            The elastic GPU type.

      - **ElasticInferenceAccelerators** *(list) --*

        The elastic inference accelerator for the instance.

        - *(dict) --*

          Describes an elastic inference accelerator.

          - **Type** *(string) --*

            The type of elastic inference accelerator. The possible values are eia1.medium,
            eia1.large, and eia1.xlarge.

      - **SecurityGroupIds** *(list) --*

        The security group IDs.

        - *(string) --*

      - **SecurityGroups** *(list) --*

        The security group names.

        - *(string) --*

      - **InstanceMarketOptions** *(dict) --*

        The market (purchasing) option for the instances.

        - **MarketType** *(string) --*

          The market type.

        - **SpotOptions** *(dict) --*

          The options for Spot Instances.

          - **MaxPrice** *(string) --*

            The maximum hourly price you're willing to pay for the Spot Instances.

          - **SpotInstanceType** *(string) --*

            The Spot Instance request type.

          - **BlockDurationMinutes** *(integer) --*

            The required duration for the Spot Instances (also known as Spot blocks), in
            minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

          - **ValidUntil** *(datetime) --*

            The end date of the request. For a one-time request, the request remains active
            until all instances launch, the request is canceled, or this date is reached. If
            the request is persistent, it remains active until it is canceled or this date and
            time is reached.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted.

      - **CreditSpecification** *(dict) --*

        The credit option for CPU usage of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
          and ``unlimited`` .

      - **CpuOptions** *(dict) --*

        The CPU options for the instance. For more information, see `Optimizing CPU Options
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        - **CoreCount** *(integer) --*

          The number of CPU cores for the instance.

        - **ThreadsPerCore** *(integer) --*

          The number of threads per CPU core.

      - **CapacityReservationSpecification** *(dict) --*

        Information about the Capacity Reservation targeting option.

        - **CapacityReservationPreference** *(string) --*

          Indicates the instance's Capacity Reservation preferences. Possible preferences
          include:

          * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
          matching attributes (instance type, platform, Availability Zone).

          * ``none`` - The instance avoids running in a Capacity Reservation even if one is
          available. The instance runs in On-Demand capacity.

        - **CapacityReservationTarget** *(dict) --*

          Information about the target Capacity Reservation.

          - **CapacityReservationId** *(string) --*

            The ID of the Capacity Reservation.

      - **LicenseSpecifications** *(list) --*

        The license configurations.

        - *(dict) --*

          Describes a license configuration.

          - **LicenseConfigurationArn** *(string) --*

            The Amazon Resource Name (ARN) of the license configuration.

      - **HibernationOptions** *(dict) --*

        Indicates whether an instance is configured for hibernation. For more information, see
        `Hibernate Your Instance
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        - **Configured** *(boolean) --*

          If this parameter is set to ``true`` , the instance is enabled for hibernation;
          otherwise, it is not enabled for hibernation.
    """


_ClientDescribeLaunchTemplateVersionsResponseTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseTypeDef",
    {
        "LaunchTemplateVersions": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplateVersions` `Response`

    - **LaunchTemplateVersions** *(list) --*

      Information about the launch template versions.

      - *(dict) --*

        Describes a launch template version.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **VersionNumber** *(integer) --*

          The version number.

        - **VersionDescription** *(string) --*

          The description for the version.

        - **CreateTime** *(datetime) --*

          The time the version was created.

        - **CreatedBy** *(string) --*

          The principal that created the version.

        - **DefaultVersion** *(boolean) --*

          Indicates whether the version is the default version.

        - **LaunchTemplateData** *(dict) --*

          Information about the launch template.

          - **KernelId** *(string) --*

            The ID of the kernel, if applicable.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instance is optimized for Amazon EBS I/O.

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **BlockDeviceMappings** *(list) --*

            The block device mappings.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name.

              - **VirtualName** *(string) --*

                The virtual device name (ephemeralN).

              - **Ebs** *(dict) --*

                Information about the block device for an EBS volume.

                - **Encrypted** *(boolean) --*

                  Indicates whether the EBS volume is encrypted.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports.

                - **KmsKeyId** *(string) --*

                  The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                - **VolumeType** *(string) --*

                  The volume type.

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **NetworkInterfaces** *(list) --*

            The network interfaces.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to associate a public IPv4 address with eth0 for a new network
                interface.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the network interface is deleted when the instance is terminated.

              - **Description** *(string) --*

                A description for the network interface.

              - **DeviceIndex** *(integer) --*

                The device index for the network interface attachment.

              - **Groups** *(list) --*

                The IDs of one or more security groups.

                - *(string) --*

              - **InterfaceType** *(string) --*

                The type of network interface.

              - **Ipv6AddressCount** *(integer) --*

                The number of IPv6 addresses for the network interface.

              - **Ipv6Addresses** *(list) --*

                The IPv6 addresses for the network interface.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The primary private IPv4 address of the network interface.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4 address.
                    Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses for the network interface.

              - **SubnetId** *(string) --*

                The ID of the subnet for the network interface.

          - **ImageId** *(string) --*

            The ID of the AMI that was used to launch the instance.

          - **InstanceType** *(string) --*

            The instance type.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **Monitoring** *(dict) --*

            The monitoring for the instance.

            - **Enabled** *(boolean) --*

              Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
              enabled.

          - **Placement** *(dict) --*

            The placement of the instance.

            - **AvailabilityZone** *(string) --*

              The Availability Zone of the instance.

            - **Affinity** *(string) --*

              The affinity setting for the instance on the Dedicated Host.

            - **GroupName** *(string) --*

              The name of the placement group for the instance.

            - **HostId** *(string) --*

              The ID of the Dedicated Host for the instance.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance with a
              tenancy of ``dedicated`` runs on single-tenant hardware.

            - **SpreadDomain** *(string) --*

              Reserved for future use.

          - **RamDiskId** *(string) --*

            The ID of the RAM disk, if applicable.

          - **DisableApiTermination** *(boolean) --*

            If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
            EC2 console, command line tool, or API.

          - **InstanceInitiatedShutdownBehavior** *(string) --*

            Indicates whether an instance stops or terminates when you initiate shutdown from the
            instance (using the operating system command for system shutdown).

          - **UserData** *(string) --*

            The user data for the instance.

          - **TagSpecifications** *(list) --*

            The tags.

            - *(dict) --*

              The tag specification for the launch template.

              - **ResourceType** *(string) --*

                The type of resource.

              - **Tags** *(list) --*

                The tags for the resource.

                - *(dict) --*

                  Describes a tag.

                  - **Key** *(string) --*

                    The key of the tag.

                    Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                    characters. May not begin with ``aws:`` .

                  - **Value** *(string) --*

                    The value of the tag.

                    Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                    characters.

          - **ElasticGpuSpecifications** *(list) --*

            The elastic GPU specification.

            - *(dict) --*

              Describes an elastic GPU.

              - **Type** *(string) --*

                The elastic GPU type.

          - **ElasticInferenceAccelerators** *(list) --*

            The elastic inference accelerator for the instance.

            - *(dict) --*

              Describes an elastic inference accelerator.

              - **Type** *(string) --*

                The type of elastic inference accelerator. The possible values are eia1.medium,
                eia1.large, and eia1.xlarge.

          - **SecurityGroupIds** *(list) --*

            The security group IDs.

            - *(string) --*

          - **SecurityGroups** *(list) --*

            The security group names.

            - *(string) --*

          - **InstanceMarketOptions** *(dict) --*

            The market (purchasing) option for the instances.

            - **MarketType** *(string) --*

              The market type.

            - **SpotOptions** *(dict) --*

              The options for Spot Instances.

              - **MaxPrice** *(string) --*

                The maximum hourly price you're willing to pay for the Spot Instances.

              - **SpotInstanceType** *(string) --*

                The Spot Instance request type.

              - **BlockDurationMinutes** *(integer) --*

                The required duration for the Spot Instances (also known as Spot blocks), in
                minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

              - **ValidUntil** *(datetime) --*

                The end date of the request. For a one-time request, the request remains active
                until all instances launch, the request is canceled, or this date is reached. If
                the request is persistent, it remains active until it is canceled or this date and
                time is reached.

              - **InstanceInterruptionBehavior** *(string) --*

                The behavior when a Spot Instance is interrupted.

          - **CreditSpecification** *(dict) --*

            The credit option for CPU usage of the instance.

            - **CpuCredits** *(string) --*

              The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
              and ``unlimited`` .

          - **CpuOptions** *(dict) --*

            The CPU options for the instance. For more information, see `Optimizing CPU Options
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            - **CoreCount** *(integer) --*

              The number of CPU cores for the instance.

            - **ThreadsPerCore** *(integer) --*

              The number of threads per CPU core.

          - **CapacityReservationSpecification** *(dict) --*

            Information about the Capacity Reservation targeting option.

            - **CapacityReservationPreference** *(string) --*

              Indicates the instance's Capacity Reservation preferences. Possible preferences
              include:

              * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
              matching attributes (instance type, platform, Availability Zone).

              * ``none`` - The instance avoids running in a Capacity Reservation even if one is
              available. The instance runs in On-Demand capacity.

            - **CapacityReservationTarget** *(dict) --*

              Information about the target Capacity Reservation.

              - **CapacityReservationId** *(string) --*

                The ID of the Capacity Reservation.

          - **LicenseSpecifications** *(list) --*

            The license configurations.

            - *(dict) --*

              Describes a license configuration.

              - **LicenseConfigurationArn** *(string) --*

                The Amazon Resource Name (ARN) of the license configuration.

          - **HibernationOptions** *(dict) --*

            Indicates whether an instance is configured for hibernation. For more information, see
            `Hibernate Your Instance
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
            Elastic Compute Cloud User Guide* .

            - **Configured** *(boolean) --*

              If this parameter is set to ``true`` , the instance is enabled for hibernation;
              otherwise, it is not enabled for hibernation.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeLaunchTemplatesFiltersTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeLaunchTemplatesFiltersTypeDef(
    _ClientDescribeLaunchTemplatesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplates` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef(
    _ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplatesResponseLaunchTemplates` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef],
    },
    total=False,
)


class ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef(
    _ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplatesResponse` `LaunchTemplates`

    Describes a launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **CreateTime** *(datetime) --*

      The time launch template was created.

    - **CreatedBy** *(string) --*

      The principal that created the launch template.

    - **DefaultVersionNumber** *(integer) --*

      The version number of the default version of the launch template.

    - **LatestVersionNumber** *(integer) --*

      The version number of the latest version of the launch template.

    - **Tags** *(list) --*

      The tags for the launch template.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeLaunchTemplatesResponseTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseTypeDef",
    {
        "LaunchTemplates": List[
            ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplatesResponseTypeDef(
    _ClientDescribeLaunchTemplatesResponseTypeDef
):
    """
    Type definition for `ClientDescribeLaunchTemplates` `Response`

    - **LaunchTemplates** *(list) --*

      Information about the launch templates.

      - *(dict) --*

        Describes a launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **CreateTime** *(datetime) --*

          The time launch template was created.

        - **CreatedBy** *(string) --*

          The principal that created the launch template.

        - **DefaultVersionNumber** *(integer) --*

          The version number of the default version of the launch template.

        - **LatestVersionNumber** *(integer) --*

          The version number of the latest version of the launch template.

        - **Tags** *(list) --*

          The tags for the launch template.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeMovingAddressesFiltersTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeMovingAddressesFiltersTypeDef(
    _ClientDescribeMovingAddressesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeMovingAddresses` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef",
    {"MoveStatus": str, "PublicIp": str},
    total=False,
)


class ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef(
    _ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef
):
    """
    Type definition for `ClientDescribeMovingAddressesResponse` `MovingAddressStatuses`

    Describes the status of a moving Elastic IP address.

    - **MoveStatus** *(string) --*

      The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
      restored to the EC2-Classic platform.

    - **PublicIp** *(string) --*

      The Elastic IP address.
    """


_ClientDescribeMovingAddressesResponseTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesResponseTypeDef",
    {
        "MovingAddressStatuses": List[
            ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeMovingAddressesResponseTypeDef(
    _ClientDescribeMovingAddressesResponseTypeDef
):
    """
    Type definition for `ClientDescribeMovingAddresses` `Response`

    - **MovingAddressStatuses** *(list) --*

      The status for each Elastic IP address.

      - *(dict) --*

        Describes the status of a moving Elastic IP address.

        - **MoveStatus** *(string) --*

          The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
          restored to the EC2-Classic platform.

        - **PublicIp** *(string) --*

          The Elastic IP address.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeNatGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNatGatewaysFiltersTypeDef(_ClientDescribeNatGatewaysFiltersTypeDef):
    """
    Type definition for `ClientDescribeNatGateways` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef
):
    """
    Type definition for `ClientDescribeNatGatewaysResponseNatGateways` `NatGatewayAddresses`

    Describes the IP addresses and network interface associated with a NAT gateway.

    - **AllocationId** *(string) --*

      The allocation ID of the Elastic IP address that's associated with the NAT gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface associated with the NAT gateway.

    - **PrivateIp** *(string) --*

      The private IP address associated with the Elastic IP address.

    - **PublicIp** *(string) --*

      The Elastic IP address associated with the NAT gateway.
    """


_ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef
):
    """
    Type definition for `ClientDescribeNatGatewaysResponseNatGateways` `ProvisionedBandwidth`

    Reserved. If you need to sustain traffic greater than the `documented limits
    <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
    through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **ProvisionTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Provisioned** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **RequestTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Requested** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Status** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .
    """


_ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef
):
    """
    Type definition for `ClientDescribeNatGatewaysResponseNatGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeNatGatewaysResponseNatGatewaysTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeNatGatewaysResponse` `NatGateways`

    Describes a NAT gateway.

    - **CreateTime** *(datetime) --*

      The date and time the NAT gateway was created.

    - **DeleteTime** *(datetime) --*

      The date and time the NAT gateway was deleted, if applicable.

    - **FailureCode** *(string) --*

      If the NAT gateway could not be created, specifies the error code for the failure.
      (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
      ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
      ``InvalidSubnetID.NotFound`` )

    - **FailureMessage** *(string) --*

      If the NAT gateway could not be created, specifies the error message for the failure,
      that corresponds to the error code.

      * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to
      create this NAT gateway"

      * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

      * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
      associated with this NAT gateway"

      * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
      associated"

      * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
      NAT gateway is in an invalid state. Please try again."

      * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
      could not be found."

    - **NatGatewayAddresses** *(list) --*

      Information about the IP addresses and network interface associated with the NAT gateway.

      - *(dict) --*

        Describes the IP addresses and network interface associated with a NAT gateway.

        - **AllocationId** *(string) --*

          The allocation ID of the Elastic IP address that's associated with the NAT gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface associated with the NAT gateway.

        - **PrivateIp** *(string) --*

          The private IP address associated with the Elastic IP address.

        - **PublicIp** *(string) --*

          The Elastic IP address associated with the NAT gateway.

    - **NatGatewayId** *(string) --*

      The ID of the NAT gateway.

    - **ProvisionedBandwidth** *(dict) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **ProvisionTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Provisioned** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **RequestTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Requested** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Status** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **State** *(string) --*

      The state of the NAT gateway.

      * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

      * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
      ``failureMessage`` fields for the reason.

      * ``available`` : The NAT gateway is able to process traffic. This status remains until
      you delete the NAT gateway, and does not indicate the health of the NAT gateway.

      * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
      processing traffic.

      * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

    - **SubnetId** *(string) --*

      The ID of the subnet in which the NAT gateway is located.

    - **VpcId** *(string) --*

      The ID of the VPC in which the NAT gateway is located.

    - **Tags** *(list) --*

      The tags for the NAT gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeNatGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseTypeDef",
    {
        "NatGateways": List[ClientDescribeNatGatewaysResponseNatGatewaysTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNatGatewaysResponseTypeDef(
    _ClientDescribeNatGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeNatGateways` `Response`

    - **NatGateways** *(list) --*

      Information about the NAT gateways.

      - *(dict) --*

        Describes a NAT gateway.

        - **CreateTime** *(datetime) --*

          The date and time the NAT gateway was created.

        - **DeleteTime** *(datetime) --*

          The date and time the NAT gateway was deleted, if applicable.

        - **FailureCode** *(string) --*

          If the NAT gateway could not be created, specifies the error code for the failure.
          (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
          ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
          ``InvalidSubnetID.NotFound`` )

        - **FailureMessage** *(string) --*

          If the NAT gateway could not be created, specifies the error message for the failure,
          that corresponds to the error code.

          * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to
          create this NAT gateway"

          * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

          * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
          associated with this NAT gateway"

          * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
          associated"

          * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
          NAT gateway is in an invalid state. Please try again."

          * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
          could not be found."

        - **NatGatewayAddresses** *(list) --*

          Information about the IP addresses and network interface associated with the NAT gateway.

          - *(dict) --*

            Describes the IP addresses and network interface associated with a NAT gateway.

            - **AllocationId** *(string) --*

              The allocation ID of the Elastic IP address that's associated with the NAT gateway.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface associated with the NAT gateway.

            - **PrivateIp** *(string) --*

              The private IP address associated with the Elastic IP address.

            - **PublicIp** *(string) --*

              The Elastic IP address associated with the NAT gateway.

        - **NatGatewayId** *(string) --*

          The ID of the NAT gateway.

        - **ProvisionedBandwidth** *(dict) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **ProvisionTime** *(datetime) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Provisioned** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **RequestTime** *(datetime) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Requested** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Status** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **State** *(string) --*

          The state of the NAT gateway.

          * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

          * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
          ``failureMessage`` fields for the reason.

          * ``available`` : The NAT gateway is able to process traffic. This status remains until
          you delete the NAT gateway, and does not indicate the health of the NAT gateway.

          * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
          processing traffic.

          * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

        - **SubnetId** *(string) --*

          The ID of the subnet in which the NAT gateway is located.

        - **VpcId** *(string) --*

          The ID of the VPC in which the NAT gateway is located.

        - **Tags** *(list) --*

          The tags for the NAT gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeNetworkAclsFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNetworkAclsFiltersTypeDef(_ClientDescribeNetworkAclsFiltersTypeDef):
    """
    Type definition for `ClientDescribeNetworkAcls` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponseNetworkAcls` `Associations`

    Describes an association between a network ACL and a subnet.

    - **NetworkAclAssociationId** *(string) --*

      The ID of the association between a network ACL and a subnet.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponseNetworkAclsEntries` `IcmpTypeCode`

    ICMP protocol: The ICMP type and code.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponseNetworkAclsEntries` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to.

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": str,
        "RuleNumber": int,
    },
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponseNetworkAcls` `Entries`

    Describes an entry in a network ACL.

    - **CidrBlock** *(string) --*

      The IPv4 network range to allow or deny, in CIDR notation.

    - **Egress** *(boolean) --*

      Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

    - **IcmpTypeCode** *(dict) --*

      ICMP protocol: The ICMP type and code.

      - **Code** *(integer) --*

        The ICMP code. A value of -1 means all codes for the specified ICMP type.

      - **Type** *(integer) --*

        The ICMP type. A value of -1 means all types.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 network range to allow or deny, in CIDR notation.

    - **PortRange** *(dict) --*

      TCP or UDP protocols: The range of ports the rule applies to.

      - **From** *(integer) --*

        The first port in the range.

      - **To** *(integer) --*

        The last port in the range.

    - **Protocol** *(string) --*

      The protocol number. A value of "-1" means all protocols.

    - **RuleAction** *(string) --*

      Indicates whether to allow or deny the traffic that matches the rule.

    - **RuleNumber** *(integer) --*

      The rule number for the entry. ACL entries are processed in ascending order by rule
      number.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponseNetworkAcls` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsTypeDef",
    {
        "Associations": List[
            ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef
        ],
        "Entries": List[ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAclsResponse` `NetworkAcls`

    Describes a network ACL.

    - **Associations** *(list) --*

      Any associations between the network ACL and one or more subnets

      - *(dict) --*

        Describes an association between a network ACL and a subnet.

        - **NetworkAclAssociationId** *(string) --*

          The ID of the association between a network ACL and a subnet.

        - **NetworkAclId** *(string) --*

          The ID of the network ACL.

        - **SubnetId** *(string) --*

          The ID of the subnet.

    - **Entries** *(list) --*

      One or more entries (rules) in the network ACL.

      - *(dict) --*

        Describes an entry in a network ACL.

        - **CidrBlock** *(string) --*

          The IPv4 network range to allow or deny, in CIDR notation.

        - **Egress** *(boolean) --*

          Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

        - **IcmpTypeCode** *(dict) --*

          ICMP protocol: The ICMP type and code.

          - **Code** *(integer) --*

            The ICMP code. A value of -1 means all codes for the specified ICMP type.

          - **Type** *(integer) --*

            The ICMP type. A value of -1 means all types.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 network range to allow or deny, in CIDR notation.

        - **PortRange** *(dict) --*

          TCP or UDP protocols: The range of ports the rule applies to.

          - **From** *(integer) --*

            The first port in the range.

          - **To** *(integer) --*

            The last port in the range.

        - **Protocol** *(string) --*

          The protocol number. A value of "-1" means all protocols.

        - **RuleAction** *(string) --*

          Indicates whether to allow or deny the traffic that matches the rule.

        - **RuleNumber** *(integer) --*

          The rule number for the entry. ACL entries are processed in ascending order by rule
          number.

    - **IsDefault** *(boolean) --*

      Indicates whether this is the default network ACL for the VPC.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **Tags** *(list) --*

      Any tags assigned to the network ACL.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC for the network ACL.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the network ACL.
    """


_ClientDescribeNetworkAclsResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseTypeDef",
    {
        "NetworkAcls": List[ClientDescribeNetworkAclsResponseNetworkAclsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNetworkAclsResponseTypeDef(
    _ClientDescribeNetworkAclsResponseTypeDef
):
    """
    Type definition for `ClientDescribeNetworkAcls` `Response`

    - **NetworkAcls** *(list) --*

      Information about one or more network ACLs.

      - *(dict) --*

        Describes a network ACL.

        - **Associations** *(list) --*

          Any associations between the network ACL and one or more subnets

          - *(dict) --*

            Describes an association between a network ACL and a subnet.

            - **NetworkAclAssociationId** *(string) --*

              The ID of the association between a network ACL and a subnet.

            - **NetworkAclId** *(string) --*

              The ID of the network ACL.

            - **SubnetId** *(string) --*

              The ID of the subnet.

        - **Entries** *(list) --*

          One or more entries (rules) in the network ACL.

          - *(dict) --*

            Describes an entry in a network ACL.

            - **CidrBlock** *(string) --*

              The IPv4 network range to allow or deny, in CIDR notation.

            - **Egress** *(boolean) --*

              Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

            - **IcmpTypeCode** *(dict) --*

              ICMP protocol: The ICMP type and code.

              - **Code** *(integer) --*

                The ICMP code. A value of -1 means all codes for the specified ICMP type.

              - **Type** *(integer) --*

                The ICMP type. A value of -1 means all types.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 network range to allow or deny, in CIDR notation.

            - **PortRange** *(dict) --*

              TCP or UDP protocols: The range of ports the rule applies to.

              - **From** *(integer) --*

                The first port in the range.

              - **To** *(integer) --*

                The last port in the range.

            - **Protocol** *(string) --*

              The protocol number. A value of "-1" means all protocols.

            - **RuleAction** *(string) --*

              Indicates whether to allow or deny the traffic that matches the rule.

            - **RuleNumber** *(integer) --*

              The rule number for the entry. ACL entries are processed in ascending order by rule
              number.

        - **IsDefault** *(boolean) --*

          Indicates whether this is the default network ACL for the VPC.

        - **NetworkAclId** *(string) --*

          The ID of the network ACL.

        - **Tags** *(list) --*

          Any tags assigned to the network ACL.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC for the network ACL.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the network ACL.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaceAttributeResponse` `Attachment`

    The attachment (if any) of the network interface.

    - **AttachTime** *(datetime) --*

      The timestamp indicating when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The device index of the network interface attachment on the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **Status** *(string) --*

      The attachment state.
    """


_ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaceAttributeResponse` `Description`

    The description of the network interface.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaceAttributeResponse` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaceAttributeResponse` `SourceDestCheck`

    Indicates whether source/destination checking is enabled.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeNetworkInterfaceAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseTypeDef",
    {
        "Attachment": ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef,
        "Description": ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef,
        "Groups": List[ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef],
        "NetworkInterfaceId": str,
        "SourceDestCheck": ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef,
    },
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaceAttribute` `Response`

    Contains the output of DescribeNetworkInterfaceAttribute.

    - **Attachment** *(dict) --*

      The attachment (if any) of the network interface.

      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The device index of the network interface attachment on the instance.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **InstanceOwnerId** *(string) --*

        The AWS account ID of the owner of the instance.

      - **Status** *(string) --*

        The attachment state.

    - **Description** *(dict) --*

      The description of the network interface.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **Groups** *(list) --*

      The security groups associated with the network interface.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **SourceDestCheck** *(dict) --*

      Indicates whether source/destination checking is enabled.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeNetworkInterfacePermissionsFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsFiltersTypeDef(
    _ClientDescribeNetworkInterfacePermissionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacePermissions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissions` `PermissionState`

    Information about the state of the permission.

    - **State** *(string) --*

      The state of the permission.

    - **StatusMessage** *(string) --*

      A status message, if applicable.
    """


_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": str,
        "PermissionState": ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef,
    },
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacePermissionsResponse` `NetworkInterfacePermissions`

    Describes a permission for a network interface.

    - **NetworkInterfacePermissionId** *(string) --*

      The ID of the network interface permission.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **AwsAccountId** *(string) --*

      The AWS account ID.

    - **AwsService** *(string) --*

      The AWS service.

    - **Permission** *(string) --*

      The type of permission.

    - **PermissionState** *(dict) --*

      Information about the state of the permission.

      - **State** *(string) --*

        The state of the permission.

      - **StatusMessage** *(string) --*

        A status message, if applicable.
    """


_ClientDescribeNetworkInterfacePermissionsResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseTypeDef",
    {
        "NetworkInterfacePermissions": List[
            ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacePermissions` `Response`

    Contains the output for DescribeNetworkInterfacePermissions.

    - **NetworkInterfacePermissions** *(list) --*

      The network interface permissions.

      - *(dict) --*

        Describes a permission for a network interface.

        - **NetworkInterfacePermissionId** *(string) --*

          The ID of the network interface permission.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **AwsAccountId** *(string) --*

          The AWS account ID.

        - **AwsService** *(string) --*

          The AWS service.

        - **Permission** *(string) --*

          The type of permission.

        - **PermissionState** *(dict) --*

          Information about the state of the permission.

          - **State** *(string) --*

            The state of the permission.

          - **StatusMessage** *(string) --*

            A status message, if applicable.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results.
    """


_ClientDescribeNetworkInterfacesFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNetworkInterfacesFiltersTypeDef(
    _ClientDescribeNetworkInterfacesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaces` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `Association`

    The association information for an Elastic IP address (IPv4) associated with the network
    interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The timestamp indicating when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The device index of the network interface attachment on the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **Status** *(string) --*

      The attachment state.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address associated with a network interface.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddresses` `Association`

    The association information for an Elastic IP address (IPv4) associated with the
    network interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `PrivateIpAddresses`

    Describes the private IPv4 address of a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the
      network interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IPv4 address of the
      network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponseNetworkInterfaces` `TagSet`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef",
    {
        "Association": ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef
        ],
        "InterfaceType": str,
        "Ipv6Addresses": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "TagSet": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfacesResponse` `NetworkInterfaces`

    Describes a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The device index of the network interface attachment on the instance.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **InstanceOwnerId** *(string) --*

        The AWS account ID of the owner of the instance.

      - **Status** *(string) --*

        The attachment state.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **Description** *(string) --*

      A description.

    - **Groups** *(list) --*

      Any security groups for the network interface.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address associated with a network interface.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The AWS account ID of the owner of the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      The private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes the private IPv4 address of a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the
          network interface.

          - **AllocationId** *(string) --*

            The allocation ID.

          - **AssociationId** *(string) --*

            The association ID.

          - **IpOwnerId** *(string) --*

            The ID of the Elastic IP address owner.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The address of the Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IPv4 address of the
          network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address.

    - **RequesterId** *(string) --*

      The ID of the entity that launched the instance on your behalf (for example, AWS
      Management Console or Auto Scaling).

    - **RequesterManaged** *(boolean) --*

      Indicates whether the network interface is being managed by AWS.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether traffic to or from the instance is validated.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **TagSet** *(list) --*

      Any tags assigned to the network interface.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeNetworkInterfacesResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseTypeDef",
    {
        "NetworkInterfaces": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseTypeDef(
    _ClientDescribeNetworkInterfacesResponseTypeDef
):
    """
    Type definition for `ClientDescribeNetworkInterfaces` `Response`

    Contains the output of DescribeNetworkInterfaces.

    - **NetworkInterfaces** *(list) --*

      Information about one or more network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the network
          interface.

          - **AllocationId** *(string) --*

            The allocation ID.

          - **AssociationId** *(string) --*

            The association ID.

          - **IpOwnerId** *(string) --*

            The ID of the Elastic IP address owner.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The address of the Elastic IP address bound to the network interface.

        - **Attachment** *(dict) --*

          The network interface attachment.

          - **AttachTime** *(datetime) --*

            The timestamp indicating when the attachment initiated.

          - **AttachmentId** *(string) --*

            The ID of the network interface attachment.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **DeviceIndex** *(integer) --*

            The device index of the network interface attachment on the instance.

          - **InstanceId** *(string) --*

            The ID of the instance.

          - **InstanceOwnerId** *(string) --*

            The AWS account ID of the owner of the instance.

          - **Status** *(string) --*

            The attachment state.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **Description** *(string) --*

          A description.

        - **Groups** *(list) --*

          Any security groups for the network interface.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses associated with the network interface.

          - *(dict) --*

            Describes an IPv6 address associated with a network interface.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **MacAddress** *(string) --*

          The MAC address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **OwnerId** *(string) --*

          The AWS account ID of the owner of the network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddresses** *(list) --*

          The private IPv4 addresses associated with the network interface.

          - *(dict) --*

            Describes the private IPv4 address of a network interface.

            - **Association** *(dict) --*

              The association information for an Elastic IP address (IPv4) associated with the
              network interface.

              - **AllocationId** *(string) --*

                The allocation ID.

              - **AssociationId** *(string) --*

                The association ID.

              - **IpOwnerId** *(string) --*

                The ID of the Elastic IP address owner.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The address of the Elastic IP address bound to the network interface.

            - **Primary** *(boolean) --*

              Indicates whether this IPv4 address is the primary private IPv4 address of the
              network interface.

            - **PrivateDnsName** *(string) --*

              The private DNS name.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address.

        - **RequesterId** *(string) --*

          The ID of the entity that launched the instance on your behalf (for example, AWS
          Management Console or Auto Scaling).

        - **RequesterManaged** *(boolean) --*

          Indicates whether the network interface is being managed by AWS.

        - **SourceDestCheck** *(boolean) --*

          Indicates whether traffic to or from the instance is validated.

        - **Status** *(string) --*

          The status of the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **TagSet** *(list) --*

          Any tags assigned to the network interface.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribePlacementGroupsFiltersTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribePlacementGroupsFiltersTypeDef(
    _ClientDescribePlacementGroupsFiltersTypeDef
):
    """
    Type definition for `ClientDescribePlacementGroups` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef",
    {"GroupName": str, "State": str, "Strategy": str, "PartitionCount": int},
    total=False,
)


class ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef(
    _ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef
):
    """
    Type definition for `ClientDescribePlacementGroupsResponse` `PlacementGroups`

    Describes a placement group.

    - **GroupName** *(string) --*

      The name of the placement group.

    - **State** *(string) --*

      The state of the placement group.

    - **Strategy** *(string) --*

      The placement strategy.

    - **PartitionCount** *(integer) --*

      The number of partitions. Valid only if **strategy** is set to ``partition`` .
    """


_ClientDescribePlacementGroupsResponseTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsResponseTypeDef",
    {
        "PlacementGroups": List[
            ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef
        ]
    },
    total=False,
)


class ClientDescribePlacementGroupsResponseTypeDef(
    _ClientDescribePlacementGroupsResponseTypeDef
):
    """
    Type definition for `ClientDescribePlacementGroups` `Response`

    - **PlacementGroups** *(list) --*

      Information about the placement groups.

      - *(dict) --*

        Describes a placement group.

        - **GroupName** *(string) --*

          The name of the placement group.

        - **State** *(string) --*

          The state of the placement group.

        - **Strategy** *(string) --*

          The placement strategy.

        - **PartitionCount** *(integer) --*

          The number of partitions. Valid only if **strategy** is set to ``partition`` .
    """


_ClientDescribePrefixListsFiltersTypeDef = TypedDict(
    "_ClientDescribePrefixListsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribePrefixListsFiltersTypeDef(_ClientDescribePrefixListsFiltersTypeDef):
    """
    Type definition for `ClientDescribePrefixLists` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribePrefixListsResponsePrefixListsTypeDef = TypedDict(
    "_ClientDescribePrefixListsResponsePrefixListsTypeDef",
    {"Cidrs": List[str], "PrefixListId": str, "PrefixListName": str},
    total=False,
)


class ClientDescribePrefixListsResponsePrefixListsTypeDef(
    _ClientDescribePrefixListsResponsePrefixListsTypeDef
):
    """
    Type definition for `ClientDescribePrefixListsResponse` `PrefixLists`

    Describes prefixes for AWS services.

    - **Cidrs** *(list) --*

      The IP address range of the AWS service.

      - *(string) --*

    - **PrefixListId** *(string) --*

      The ID of the prefix.

    - **PrefixListName** *(string) --*

      The name of the prefix.
    """


_ClientDescribePrefixListsResponseTypeDef = TypedDict(
    "_ClientDescribePrefixListsResponseTypeDef",
    {
        "NextToken": str,
        "PrefixLists": List[ClientDescribePrefixListsResponsePrefixListsTypeDef],
    },
    total=False,
)


class ClientDescribePrefixListsResponseTypeDef(
    _ClientDescribePrefixListsResponseTypeDef
):
    """
    Type definition for `ClientDescribePrefixLists` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **PrefixLists** *(list) --*

      All available prefix lists.

      - *(dict) --*

        Describes prefixes for AWS services.

        - **Cidrs** *(list) --*

          The IP address range of the AWS service.

          - *(string) --*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

        - **PrefixListName** *(string) --*

          The name of the prefix.
    """


_ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef(
    _ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef
):
    """
    Type definition for `ClientDescribePrincipalIdFormatResponsePrincipals` `Statuses`

    Describes the ID format for a resource.

    - **Deadline** *(datetime) --*

      The date in UTC at which you are permanently switched over to using longer IDs. If a
      deadline is not yet available for this resource type, this field is not returned.

    - **Resource** *(string) --*

      The type of resource.

    - **UseLongIds** *(boolean) --*

      Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef",
    {
        "Arn": str,
        "Statuses": List[
            ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef
        ],
    },
    total=False,
)


class ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef(
    _ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef
):
    """
    Type definition for `ClientDescribePrincipalIdFormatResponse` `Principals`

    PrincipalIdFormat description

    - **Arn** *(string) --*

      PrincipalIdFormatARN description

    - **Statuses** *(list) --*

      PrincipalIdFormatStatuses description

      - *(dict) --*

        Describes the ID format for a resource.

        - **Deadline** *(datetime) --*

          The date in UTC at which you are permanently switched over to using longer IDs. If a
          deadline is not yet available for this resource type, this field is not returned.

        - **Resource** *(string) --*

          The type of resource.

        - **UseLongIds** *(boolean) --*

          Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_ClientDescribePrincipalIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponseTypeDef",
    {
        "Principals": List[ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribePrincipalIdFormatResponseTypeDef(
    _ClientDescribePrincipalIdFormatResponseTypeDef
):
    """
    Type definition for `ClientDescribePrincipalIdFormat` `Response`

    - **Principals** *(list) --*

      Information about the ID format settings for the ARN.

      - *(dict) --*

        PrincipalIdFormat description

        - **Arn** *(string) --*

          PrincipalIdFormatARN description

        - **Statuses** *(list) --*

          PrincipalIdFormatStatuses description

          - *(dict) --*

            Describes the ID format for a resource.

            - **Deadline** *(datetime) --*

              The date in UTC at which you are permanently switched over to using longer IDs. If a
              deadline is not yet available for this resource type, this field is not returned.

            - **Resource** *(string) --*

              The type of resource.

            - **UseLongIds** *(boolean) --*

              Indicates whether longer IDs (17-character IDs) are enabled for the resource.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is null when there are no
      more results to return.
    """


_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    {
        "FirstAddress": str,
        "LastAddress": str,
        "AddressCount": int,
        "AvailableAddressCount": int,
    },
    total=False,
)


class ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef(
    _ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef
):
    """
    Type definition for `ClientDescribePublicIpv4PoolsResponsePublicIpv4Pools` `PoolAddressRanges`

    Describes an address range of an IPv4 address pool.

    - **FirstAddress** *(string) --*

      The first IP address in the range.

    - **LastAddress** *(string) --*

      The last IP address in the range.

    - **AddressCount** *(integer) --*

      The number of addresses in the range.

    - **AvailableAddressCount** *(integer) --*

      The number of available addresses in the range.
    """


_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolAddressRanges": List[
            ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef
        ],
        "TotalAddressCount": int,
        "TotalAvailableAddressCount": int,
    },
    total=False,
)


class ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef(
    _ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef
):
    """
    Type definition for `ClientDescribePublicIpv4PoolsResponse` `PublicIpv4Pools`

    Describes an address pool.

    - **PoolId** *(string) --*

      The ID of the IPv4 address pool.

    - **Description** *(string) --*

      A description of the address pool.

    - **PoolAddressRanges** *(list) --*

      The address ranges.

      - *(dict) --*

        Describes an address range of an IPv4 address pool.

        - **FirstAddress** *(string) --*

          The first IP address in the range.

        - **LastAddress** *(string) --*

          The last IP address in the range.

        - **AddressCount** *(integer) --*

          The number of addresses in the range.

        - **AvailableAddressCount** *(integer) --*

          The number of available addresses in the range.

    - **TotalAddressCount** *(integer) --*

      The total number of addresses.

    - **TotalAvailableAddressCount** *(integer) --*

      The total number of available addresses.
    """


_ClientDescribePublicIpv4PoolsResponseTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponseTypeDef",
    {
        "PublicIpv4Pools": List[
            ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribePublicIpv4PoolsResponseTypeDef(
    _ClientDescribePublicIpv4PoolsResponseTypeDef
):
    """
    Type definition for `ClientDescribePublicIpv4Pools` `Response`

    - **PublicIpv4Pools** *(list) --*

      Information about the address pools.

      - *(dict) --*

        Describes an address pool.

        - **PoolId** *(string) --*

          The ID of the IPv4 address pool.

        - **Description** *(string) --*

          A description of the address pool.

        - **PoolAddressRanges** *(list) --*

          The address ranges.

          - *(dict) --*

            Describes an address range of an IPv4 address pool.

            - **FirstAddress** *(string) --*

              The first IP address in the range.

            - **LastAddress** *(string) --*

              The last IP address in the range.

            - **AddressCount** *(integer) --*

              The number of addresses in the range.

            - **AvailableAddressCount** *(integer) --*

              The number of available addresses in the range.

        - **TotalAddressCount** *(integer) --*

          The total number of addresses.

        - **TotalAvailableAddressCount** *(integer) --*

          The total number of available addresses.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeRegionsFiltersTypeDef = TypedDict(
    "_ClientDescribeRegionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeRegionsFiltersTypeDef(_ClientDescribeRegionsFiltersTypeDef):
    """
    Type definition for `ClientDescribeRegions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeRegionsResponseRegionsTypeDef = TypedDict(
    "_ClientDescribeRegionsResponseRegionsTypeDef",
    {"Endpoint": str, "RegionName": str, "OptInStatus": str},
    total=False,
)


class ClientDescribeRegionsResponseRegionsTypeDef(
    _ClientDescribeRegionsResponseRegionsTypeDef
):
    """
    Type definition for `ClientDescribeRegionsResponse` `Regions`

    Describes a Region.

    - **Endpoint** *(string) --*

      The Region service endpoint.

    - **RegionName** *(string) --*

      The name of the Region.

    - **OptInStatus** *(string) --*

      The Region opt-in status. The possible values are ``opt-in-not-required`` , ``opted-in``
      , and ``not-opted-in`` .
    """


_ClientDescribeRegionsResponseTypeDef = TypedDict(
    "_ClientDescribeRegionsResponseTypeDef",
    {"Regions": List[ClientDescribeRegionsResponseRegionsTypeDef]},
    total=False,
)


class ClientDescribeRegionsResponseTypeDef(_ClientDescribeRegionsResponseTypeDef):
    """
    Type definition for `ClientDescribeRegions` `Response`

    - **Regions** *(list) --*

      Information about the Regions.

      - *(dict) --*

        Describes a Region.

        - **Endpoint** *(string) --*

          The Region service endpoint.

        - **RegionName** *(string) --*

          The name of the Region.

        - **OptInStatus** *(string) --*

          The Region opt-in status. The possible values are ``opt-in-not-required`` , ``opted-in``
          , and ``not-opted-in`` .
    """


_ClientDescribeReservedInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesFiltersTypeDef(
    _ClientDescribeReservedInstancesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstances` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeReservedInstancesListingsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesListingsFiltersTypeDef(
    _ClientDescribeReservedInstancesListingsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListings` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": str},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListingsResponseReservedInstancesListings` `InstanceCounts`

    Describes a Reserved Instance listing state.

    - **InstanceCount** *(integer) --*

      The number of listed Reserved Instances in the state specified by the ``state`` .

    - **State** *(string) --*

      The states of the listed Reserved Instances.
    """


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListingsResponseReservedInstancesListings` `PriceSchedules`

    Describes the price for a Reserved Instance.

    - **Active** *(boolean) --*

      The current price schedule, as determined by the term remaining for the Reserved
      Instance in the listing.

      A specific price schedule is always in effect, but only one price schedule can be
      active at any time. Take, for example, a Reserved Instance listing that has five
      months remaining in its term. When you specify price schedules for five months and
      two months, this means that schedule 1, covering the first three months of the
      remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
      the last two months of the term, will be active for months 2 and 1.

    - **CurrencyCode** *(string) --*

      The currency for transacting the Reserved Instance resale. At this time, the only
      supported currency is ``USD`` .

    - **Price** *(float) --*

      The fixed price for the term.

    - **Term** *(integer) --*

      The number of months remaining in the reservation. For example, 2 is the second to
      the last month before the capacity reservation expires.
    """


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListingsResponseReservedInstancesListings` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": str,
        "StatusMessage": str,
        "Tags": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListingsResponse` `ReservedInstancesListings`

    Describes a Reserved Instance listing.

    - **ClientToken** *(string) --*

      A unique, case-sensitive key supplied by the client to ensure that the request is
      idempotent. For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **CreateDate** *(datetime) --*

      The time the listing was created.

    - **InstanceCounts** *(list) --*

      The number of instances in this state.

      - *(dict) --*

        Describes a Reserved Instance listing state.

        - **InstanceCount** *(integer) --*

          The number of listed Reserved Instances in the state specified by the ``state`` .

        - **State** *(string) --*

          The states of the listed Reserved Instances.

    - **PriceSchedules** *(list) --*

      The price of the Reserved Instance listing.

      - *(dict) --*

        Describes the price for a Reserved Instance.

        - **Active** *(boolean) --*

          The current price schedule, as determined by the term remaining for the Reserved
          Instance in the listing.

          A specific price schedule is always in effect, but only one price schedule can be
          active at any time. Take, for example, a Reserved Instance listing that has five
          months remaining in its term. When you specify price schedules for five months and
          two months, this means that schedule 1, covering the first three months of the
          remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
          the last two months of the term, will be active for months 2 and 1.

        - **CurrencyCode** *(string) --*

          The currency for transacting the Reserved Instance resale. At this time, the only
          supported currency is ``USD`` .

        - **Price** *(float) --*

          The fixed price for the term.

        - **Term** *(integer) --*

          The number of months remaining in the reservation. For example, 2 is the second to
          the last month before the capacity reservation expires.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.

    - **ReservedInstancesListingId** *(string) --*

      The ID of the Reserved Instance listing.

    - **Status** *(string) --*

      The status of the Reserved Instance listing.

    - **StatusMessage** *(string) --*

      The reason for the current status of the Reserved Instance listing. The response can be
      blank.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **UpdateDate** *(datetime) --*

      The last modified timestamp of the listing.
    """


_ClientDescribeReservedInstancesListingsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseTypeDef(
    _ClientDescribeReservedInstancesListingsResponseTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesListings` `Response`

    Contains the output of DescribeReservedInstancesListings.

    - **ReservedInstancesListings** *(list) --*

      Information about the Reserved Instance listing.

      - *(dict) --*

        Describes a Reserved Instance listing.

        - **ClientToken** *(string) --*

          A unique, case-sensitive key supplied by the client to ensure that the request is
          idempotent. For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **CreateDate** *(datetime) --*

          The time the listing was created.

        - **InstanceCounts** *(list) --*

          The number of instances in this state.

          - *(dict) --*

            Describes a Reserved Instance listing state.

            - **InstanceCount** *(integer) --*

              The number of listed Reserved Instances in the state specified by the ``state`` .

            - **State** *(string) --*

              The states of the listed Reserved Instances.

        - **PriceSchedules** *(list) --*

          The price of the Reserved Instance listing.

          - *(dict) --*

            Describes the price for a Reserved Instance.

            - **Active** *(boolean) --*

              The current price schedule, as determined by the term remaining for the Reserved
              Instance in the listing.

              A specific price schedule is always in effect, but only one price schedule can be
              active at any time. Take, for example, a Reserved Instance listing that has five
              months remaining in its term. When you specify price schedules for five months and
              two months, this means that schedule 1, covering the first three months of the
              remaining term, will be active during months 5, 4, and 3. Then schedule 2, covering
              the last two months of the term, will be active for months 2 and 1.

            - **CurrencyCode** *(string) --*

              The currency for transacting the Reserved Instance resale. At this time, the only
              supported currency is ``USD`` .

            - **Price** *(float) --*

              The fixed price for the term.

            - **Term** *(integer) --*

              The number of months remaining in the reservation. For example, 2 is the second to
              the last month before the capacity reservation expires.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

        - **ReservedInstancesListingId** *(string) --*

          The ID of the Reserved Instance listing.

        - **Status** *(string) --*

          The status of the Reserved Instance listing.

        - **StatusMessage** *(string) --*

          The reason for the current status of the Reserved Instance listing. The response can be
          blank.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **UpdateDate** *(datetime) --*

          The last modified timestamp of the listing.
    """


_ClientDescribeReservedInstancesModificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesModificationsFiltersTypeDef(
    _ClientDescribeReservedInstancesModificationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModifications` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": str,
        "Platform": str,
        "Scope": str,
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResults` `TargetConfiguration`

    The target Reserved Instances configurations supplied as part of the modification
    request.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the modified Reserved Instances.

    - **InstanceCount** *(integer) --*

      The number of modified Reserved Instances.

      .. note::

        This is a required field for a request.

    - **InstanceType** *(string) --*

      The instance type for the modified Reserved Instances.

    - **Platform** *(string) --*

      The network platform of the modified Reserved Instances, which is either
      EC2-Classic or EC2-VPC.

    - **Scope** *(string) --*

      Whether the Reserved Instance is applied to instances in a Region or instances in a
      specific Availability Zone.
    """


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef",
    {
        "ReservedInstancesId": str,
        "TargetConfiguration": ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef,
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModificationsResponseReservedInstancesModifications` `ModificationResults`

    Describes the modification request/s.

    - **ReservedInstancesId** *(string) --*

      The ID for the Reserved Instances that were created as part of the modification
      request. This field is only available when the modification is fulfilled.

    - **TargetConfiguration** *(dict) --*

      The target Reserved Instances configurations supplied as part of the modification
      request.

      - **AvailabilityZone** *(string) --*

        The Availability Zone for the modified Reserved Instances.

      - **InstanceCount** *(integer) --*

        The number of modified Reserved Instances.

        .. note::

          This is a required field for a request.

      - **InstanceType** *(string) --*

        The instance type for the modified Reserved Instances.

      - **Platform** *(string) --*

        The network platform of the modified Reserved Instances, which is either
        EC2-Classic or EC2-VPC.

      - **Scope** *(string) --*

        Whether the Reserved Instance is applied to instances in a Region or instances in a
        specific Availability Zone.
    """


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModificationsResponseReservedInstancesModifications` `ReservedInstancesIds`

    Describes the ID of a Reserved Instance.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.
    """


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "EffectiveDate": datetime,
        "ModificationResults": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef
        ],
        "ReservedInstancesIds": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
        ],
        "ReservedInstancesModificationId": str,
        "Status": str,
        "StatusMessage": str,
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModificationsResponse` `ReservedInstancesModifications`

    Describes a Reserved Instance modification.

    - **ClientToken** *(string) --*

      A unique, case-sensitive key supplied by the client to ensure that the request is
      idempotent. For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **CreateDate** *(datetime) --*

      The time when the modification request was created.

    - **EffectiveDate** *(datetime) --*

      The time for the modification to become effective.

    - **ModificationResults** *(list) --*

      Contains target configurations along with their corresponding new Reserved Instance IDs.

      - *(dict) --*

        Describes the modification request/s.

        - **ReservedInstancesId** *(string) --*

          The ID for the Reserved Instances that were created as part of the modification
          request. This field is only available when the modification is fulfilled.

        - **TargetConfiguration** *(dict) --*

          The target Reserved Instances configurations supplied as part of the modification
          request.

          - **AvailabilityZone** *(string) --*

            The Availability Zone for the modified Reserved Instances.

          - **InstanceCount** *(integer) --*

            The number of modified Reserved Instances.

            .. note::

              This is a required field for a request.

          - **InstanceType** *(string) --*

            The instance type for the modified Reserved Instances.

          - **Platform** *(string) --*

            The network platform of the modified Reserved Instances, which is either
            EC2-Classic or EC2-VPC.

          - **Scope** *(string) --*

            Whether the Reserved Instance is applied to instances in a Region or instances in a
            specific Availability Zone.

    - **ReservedInstancesIds** *(list) --*

      The IDs of one or more Reserved Instances.

      - *(dict) --*

        Describes the ID of a Reserved Instance.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

    - **ReservedInstancesModificationId** *(string) --*

      A unique ID for the Reserved Instance modification.

    - **Status** *(string) --*

      The status of the Reserved Instances modification request.

    - **StatusMessage** *(string) --*

      The reason for the status.

    - **UpdateDate** *(datetime) --*

      The time when the modification request was last updated.
    """


_ClientDescribeReservedInstancesModificationsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseTypeDef",
    {
        "NextToken": str,
        "ReservedInstancesModifications": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesModifications` `Response`

    Contains the output of DescribeReservedInstancesModifications.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **ReservedInstancesModifications** *(list) --*

      The Reserved Instance modification information.

      - *(dict) --*

        Describes a Reserved Instance modification.

        - **ClientToken** *(string) --*

          A unique, case-sensitive key supplied by the client to ensure that the request is
          idempotent. For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **CreateDate** *(datetime) --*

          The time when the modification request was created.

        - **EffectiveDate** *(datetime) --*

          The time for the modification to become effective.

        - **ModificationResults** *(list) --*

          Contains target configurations along with their corresponding new Reserved Instance IDs.

          - *(dict) --*

            Describes the modification request/s.

            - **ReservedInstancesId** *(string) --*

              The ID for the Reserved Instances that were created as part of the modification
              request. This field is only available when the modification is fulfilled.

            - **TargetConfiguration** *(dict) --*

              The target Reserved Instances configurations supplied as part of the modification
              request.

              - **AvailabilityZone** *(string) --*

                The Availability Zone for the modified Reserved Instances.

              - **InstanceCount** *(integer) --*

                The number of modified Reserved Instances.

                .. note::

                  This is a required field for a request.

              - **InstanceType** *(string) --*

                The instance type for the modified Reserved Instances.

              - **Platform** *(string) --*

                The network platform of the modified Reserved Instances, which is either
                EC2-Classic or EC2-VPC.

              - **Scope** *(string) --*

                Whether the Reserved Instance is applied to instances in a Region or instances in a
                specific Availability Zone.

        - **ReservedInstancesIds** *(list) --*

          The IDs of one or more Reserved Instances.

          - *(dict) --*

            Describes the ID of a Reserved Instance.

            - **ReservedInstancesId** *(string) --*

              The ID of the Reserved Instance.

        - **ReservedInstancesModificationId** *(string) --*

          A unique ID for the Reserved Instance modification.

        - **Status** *(string) --*

          The status of the Reserved Instances modification request.

        - **StatusMessage** *(string) --*

          The reason for the status.

        - **UpdateDate** *(datetime) --*

          The time when the modification request was last updated.
    """


_ClientDescribeReservedInstancesOfferingsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsFiltersTypeDef(
    _ClientDescribeReservedInstancesOfferingsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesOfferings` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    {"Count": int, "Price": float},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferings` `PricingDetails`

    Describes a Reserved Instance offering.

    - **Count** *(integer) --*

      The number of reservations available for the price.

    - **Price** *(float) --*

      The price per instance.
    """


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferings` `RecurringCharges`

    Describes a recurring charge.

    - **Amount** *(float) --*

      The amount of the recurring charge.

    - **Frequency** *(string) --*

      The frequency of the recurring charge.
    """


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "FixedPrice": float,
        "InstanceType": str,
        "ProductDescription": str,
        "ReservedInstancesOfferingId": str,
        "UsagePrice": float,
        "CurrencyCode": str,
        "InstanceTenancy": str,
        "Marketplace": bool,
        "OfferingClass": str,
        "OfferingType": str,
        "PricingDetails": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef
        ],
        "RecurringCharges": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef
        ],
        "Scope": str,
    },
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesOfferingsResponse` `ReservedInstancesOfferings`

    Describes a Reserved Instance offering.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the Reserved Instance can be used.

    - **Duration** *(integer) --*

      The duration of the Reserved Instance, in seconds.

    - **FixedPrice** *(float) --*

      The purchase price of the Reserved Instance.

    - **InstanceType** *(string) --*

      The instance type on which the Reserved Instance can be used.

    - **ProductDescription** *(string) --*

      The Reserved Instance product platform description.

    - **ReservedInstancesOfferingId** *(string) --*

      The ID of the Reserved Instance offering. This is the offering ID used in
      GetReservedInstancesExchangeQuote to confirm that an exchange can be made.

    - **UsagePrice** *(float) --*

      The usage price of the Reserved Instance, per hour.

    - **CurrencyCode** *(string) --*

      The currency of the Reserved Instance offering you are purchasing. It's specified using
      ISO 4217 standard currency codes. At this time, the only supported currency is ``USD`` .

    - **InstanceTenancy** *(string) --*

      The tenancy of the instance.

    - **Marketplace** *(boolean) --*

      Indicates whether the offering is available through the Reserved Instance Marketplace
      (resale) or AWS. If it's a Reserved Instance Marketplace offering, this is ``true`` .

    - **OfferingClass** *(string) --*

      If ``convertible`` it can be exchanged for Reserved Instances of the same or higher
      monetary value, with different configurations. If ``standard`` , it is not possible to
      perform an exchange.

    - **OfferingType** *(string) --*

      The Reserved Instance offering type.

    - **PricingDetails** *(list) --*

      The pricing details of the Reserved Instance offering.

      - *(dict) --*

        Describes a Reserved Instance offering.

        - **Count** *(integer) --*

          The number of reservations available for the price.

        - **Price** *(float) --*

          The price per instance.

    - **RecurringCharges** *(list) --*

      The recurring charge tag assigned to the resource.

      - *(dict) --*

        Describes a recurring charge.

        - **Amount** *(float) --*

          The amount of the recurring charge.

        - **Frequency** *(string) --*

          The frequency of the recurring charge.

    - **Scope** *(string) --*

      Whether the Reserved Instance is applied to instances in a Region or an Availability Zone.
    """


_ClientDescribeReservedInstancesOfferingsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseTypeDef",
    {
        "ReservedInstancesOfferings": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesOfferings` `Response`

    Contains the output of DescribeReservedInstancesOfferings.

    - **ReservedInstancesOfferings** *(list) --*

      A list of Reserved Instances offerings.

      - *(dict) --*

        Describes a Reserved Instance offering.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which the Reserved Instance can be used.

        - **Duration** *(integer) --*

          The duration of the Reserved Instance, in seconds.

        - **FixedPrice** *(float) --*

          The purchase price of the Reserved Instance.

        - **InstanceType** *(string) --*

          The instance type on which the Reserved Instance can be used.

        - **ProductDescription** *(string) --*

          The Reserved Instance product platform description.

        - **ReservedInstancesOfferingId** *(string) --*

          The ID of the Reserved Instance offering. This is the offering ID used in
          GetReservedInstancesExchangeQuote to confirm that an exchange can be made.

        - **UsagePrice** *(float) --*

          The usage price of the Reserved Instance, per hour.

        - **CurrencyCode** *(string) --*

          The currency of the Reserved Instance offering you are purchasing. It's specified using
          ISO 4217 standard currency codes. At this time, the only supported currency is ``USD`` .

        - **InstanceTenancy** *(string) --*

          The tenancy of the instance.

        - **Marketplace** *(boolean) --*

          Indicates whether the offering is available through the Reserved Instance Marketplace
          (resale) or AWS. If it's a Reserved Instance Marketplace offering, this is ``true`` .

        - **OfferingClass** *(string) --*

          If ``convertible`` it can be exchanged for Reserved Instances of the same or higher
          monetary value, with different configurations. If ``standard`` , it is not possible to
          perform an exchange.

        - **OfferingType** *(string) --*

          The Reserved Instance offering type.

        - **PricingDetails** *(list) --*

          The pricing details of the Reserved Instance offering.

          - *(dict) --*

            Describes a Reserved Instance offering.

            - **Count** *(integer) --*

              The number of reservations available for the price.

            - **Price** *(float) --*

              The price per instance.

        - **RecurringCharges** *(list) --*

          The recurring charge tag assigned to the resource.

          - *(dict) --*

            Describes a recurring charge.

            - **Amount** *(float) --*

              The amount of the recurring charge.

            - **Frequency** *(string) --*

              The frequency of the recurring charge.

        - **Scope** *(string) --*

          Whether the Reserved Instance is applied to instances in a Region or an Availability Zone.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesResponseReservedInstances` `RecurringCharges`

    Describes a recurring charge.

    - **Amount** *(float) --*

      The amount of the recurring charge.

    - **Frequency** *(string) --*

      The frequency of the recurring charge.
    """


_ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesResponseReservedInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeReservedInstancesResponseReservedInstancesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "End": datetime,
        "FixedPrice": float,
        "InstanceCount": int,
        "InstanceType": str,
        "ProductDescription": str,
        "ReservedInstancesId": str,
        "Start": datetime,
        "State": str,
        "UsagePrice": float,
        "CurrencyCode": str,
        "InstanceTenancy": str,
        "OfferingClass": str,
        "OfferingType": str,
        "RecurringCharges": List[
            ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef
        ],
        "Scope": str,
        "Tags": List[
            ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstancesResponse` `ReservedInstances`

    Describes a Reserved Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the Reserved Instance can be used.

    - **Duration** *(integer) --*

      The duration of the Reserved Instance, in seconds.

    - **End** *(datetime) --*

      The time when the Reserved Instance expires.

    - **FixedPrice** *(float) --*

      The purchase price of the Reserved Instance.

    - **InstanceCount** *(integer) --*

      The number of reservations purchased.

    - **InstanceType** *(string) --*

      The instance type on which the Reserved Instance can be used.

    - **ProductDescription** *(string) --*

      The Reserved Instance product platform description.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.

    - **Start** *(datetime) --*

      The date and time the Reserved Instance started.

    - **State** *(string) --*

      The state of the Reserved Instance purchase.

    - **UsagePrice** *(float) --*

      The usage price of the Reserved Instance, per hour.

    - **CurrencyCode** *(string) --*

      The currency of the Reserved Instance. It's specified using ISO 4217 standard currency
      codes. At this time, the only supported currency is ``USD`` .

    - **InstanceTenancy** *(string) --*

      The tenancy of the instance.

    - **OfferingClass** *(string) --*

      The offering class of the Reserved Instance.

    - **OfferingType** *(string) --*

      The Reserved Instance offering type.

    - **RecurringCharges** *(list) --*

      The recurring charge tag assigned to the resource.

      - *(dict) --*

        Describes a recurring charge.

        - **Amount** *(float) --*

          The amount of the recurring charge.

        - **Frequency** *(string) --*

          The frequency of the recurring charge.

    - **Scope** *(string) --*

      The scope of the Reserved Instance.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeReservedInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseTypeDef",
    {
        "ReservedInstances": List[
            ClientDescribeReservedInstancesResponseReservedInstancesTypeDef
        ]
    },
    total=False,
)


class ClientDescribeReservedInstancesResponseTypeDef(
    _ClientDescribeReservedInstancesResponseTypeDef
):
    """
    Type definition for `ClientDescribeReservedInstances` `Response`

    Contains the output for DescribeReservedInstances.

    - **ReservedInstances** *(list) --*

      A list of Reserved Instances.

      - *(dict) --*

        Describes a Reserved Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which the Reserved Instance can be used.

        - **Duration** *(integer) --*

          The duration of the Reserved Instance, in seconds.

        - **End** *(datetime) --*

          The time when the Reserved Instance expires.

        - **FixedPrice** *(float) --*

          The purchase price of the Reserved Instance.

        - **InstanceCount** *(integer) --*

          The number of reservations purchased.

        - **InstanceType** *(string) --*

          The instance type on which the Reserved Instance can be used.

        - **ProductDescription** *(string) --*

          The Reserved Instance product platform description.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

        - **Start** *(datetime) --*

          The date and time the Reserved Instance started.

        - **State** *(string) --*

          The state of the Reserved Instance purchase.

        - **UsagePrice** *(float) --*

          The usage price of the Reserved Instance, per hour.

        - **CurrencyCode** *(string) --*

          The currency of the Reserved Instance. It's specified using ISO 4217 standard currency
          codes. At this time, the only supported currency is ``USD`` .

        - **InstanceTenancy** *(string) --*

          The tenancy of the instance.

        - **OfferingClass** *(string) --*

          The offering class of the Reserved Instance.

        - **OfferingType** *(string) --*

          The Reserved Instance offering type.

        - **RecurringCharges** *(list) --*

          The recurring charge tag assigned to the resource.

          - *(dict) --*

            Describes a recurring charge.

            - **Amount** *(float) --*

              The amount of the recurring charge.

            - **Frequency** *(string) --*

              The frequency of the recurring charge.

        - **Scope** *(string) --*

          The scope of the Reserved Instance.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientDescribeRouteTablesFiltersTypeDef = TypedDict(
    "_ClientDescribeRouteTablesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeRouteTablesFiltersTypeDef(_ClientDescribeRouteTablesFiltersTypeDef):
    """
    Type definition for `ClientDescribeRouteTables` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef",
    {
        "Main": bool,
        "RouteTableAssociationId": str,
        "RouteTableId": str,
        "SubnetId": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef
):
    """
    Type definition for `ClientDescribeRouteTablesResponseRouteTables` `Associations`

    Describes an association between a route table and a subnet.

    - **Main** *(boolean) --*

      Indicates whether this is the main route table.

    - **RouteTableAssociationId** *(string) --*

      The ID of the association between a route table and a subnet.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **SubnetId** *(string) --*

      The ID of the subnet. A subnet ID is not returned for an implicit association.
    """


_ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef
):
    """
    Type definition for `ClientDescribeRouteTablesResponseRouteTables` `PropagatingVgws`

    Describes a virtual private gateway propagating route.

    - **GatewayId** *(string) --*

      The ID of the virtual private gateway.
    """


_ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": str,
        "State": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef
):
    """
    Type definition for `ClientDescribeRouteTablesResponseRouteTables` `Routes`

    Describes a route in a route table.

    - **DestinationCidrBlock** *(string) --*

      The IPv4 CIDR block used for the destination match.

    - **DestinationIpv6CidrBlock** *(string) --*

      The IPv6 CIDR block used for the destination match.

    - **DestinationPrefixListId** *(string) --*

      The prefix of the AWS service.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.

    - **GatewayId** *(string) --*

      The ID of a gateway attached to your VPC.

    - **InstanceId** *(string) --*

      The ID of a NAT instance in your VPC.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **NatGatewayId** *(string) --*

      The ID of a NAT gateway.

    - **TransitGatewayId** *(string) --*

      The ID of a transit gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **Origin** *(string) --*

      Describes how the route was created.

      * ``CreateRouteTable`` - The route was automatically created when the route table was
      created.

      * ``CreateRoute`` - The route was manually added to the route table.

      * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

    - **State** *(string) --*

      The state of the route. The ``blackhole`` state indicates that the route's target
      isn't available (for example, the specified gateway isn't attached to the VPC, or the
      specified NAT instance has been terminated).

    - **VpcPeeringConnectionId** *(string) --*

      The ID of a VPC peering connection.
    """


_ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef
):
    """
    Type definition for `ClientDescribeRouteTablesResponseRouteTables` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeRouteTablesResponseRouteTablesTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesTypeDef",
    {
        "Associations": List[
            ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef
        ],
        "PropagatingVgws": List[
            ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef
        ],
        "RouteTableId": str,
        "Routes": List[ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef],
        "Tags": List[ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesTypeDef
):
    """
    Type definition for `ClientDescribeRouteTablesResponse` `RouteTables`

    Describes a route table.

    - **Associations** *(list) --*

      The associations between the route table and one or more subnets.

      - *(dict) --*

        Describes an association between a route table and a subnet.

        - **Main** *(boolean) --*

          Indicates whether this is the main route table.

        - **RouteTableAssociationId** *(string) --*

          The ID of the association between a route table and a subnet.

        - **RouteTableId** *(string) --*

          The ID of the route table.

        - **SubnetId** *(string) --*

          The ID of the subnet. A subnet ID is not returned for an implicit association.

    - **PropagatingVgws** *(list) --*

      Any virtual private gateway (VGW) propagating routes.

      - *(dict) --*

        Describes a virtual private gateway propagating route.

        - **GatewayId** *(string) --*

          The ID of the virtual private gateway.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **Routes** *(list) --*

      The routes in the route table.

      - *(dict) --*

        Describes a route in a route table.

        - **DestinationCidrBlock** *(string) --*

          The IPv4 CIDR block used for the destination match.

        - **DestinationIpv6CidrBlock** *(string) --*

          The IPv6 CIDR block used for the destination match.

        - **DestinationPrefixListId** *(string) --*

          The prefix of the AWS service.

        - **EgressOnlyInternetGatewayId** *(string) --*

          The ID of the egress-only internet gateway.

        - **GatewayId** *(string) --*

          The ID of a gateway attached to your VPC.

        - **InstanceId** *(string) --*

          The ID of a NAT instance in your VPC.

        - **InstanceOwnerId** *(string) --*

          The AWS account ID of the owner of the instance.

        - **NatGatewayId** *(string) --*

          The ID of a NAT gateway.

        - **TransitGatewayId** *(string) --*

          The ID of a transit gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **Origin** *(string) --*

          Describes how the route was created.

          * ``CreateRouteTable`` - The route was automatically created when the route table was
          created.

          * ``CreateRoute`` - The route was manually added to the route table.

          * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

        - **State** *(string) --*

          The state of the route. The ``blackhole`` state indicates that the route's target
          isn't available (for example, the specified gateway isn't attached to the VPC, or the
          specified NAT instance has been terminated).

        - **VpcPeeringConnectionId** *(string) --*

          The ID of a VPC peering connection.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the route table.
    """


_ClientDescribeRouteTablesResponseTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseTypeDef",
    {
        "RouteTables": List[ClientDescribeRouteTablesResponseRouteTablesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseTypeDef(
    _ClientDescribeRouteTablesResponseTypeDef
):
    """
    Type definition for `ClientDescribeRouteTables` `Response`

    Contains the output of DescribeRouteTables.

    - **RouteTables** *(list) --*

      Information about one or more route tables.

      - *(dict) --*

        Describes a route table.

        - **Associations** *(list) --*

          The associations between the route table and one or more subnets.

          - *(dict) --*

            Describes an association between a route table and a subnet.

            - **Main** *(boolean) --*

              Indicates whether this is the main route table.

            - **RouteTableAssociationId** *(string) --*

              The ID of the association between a route table and a subnet.

            - **RouteTableId** *(string) --*

              The ID of the route table.

            - **SubnetId** *(string) --*

              The ID of the subnet. A subnet ID is not returned for an implicit association.

        - **PropagatingVgws** *(list) --*

          Any virtual private gateway (VGW) propagating routes.

          - *(dict) --*

            Describes a virtual private gateway propagating route.

            - **GatewayId** *(string) --*

              The ID of the virtual private gateway.

        - **RouteTableId** *(string) --*

          The ID of the route table.

        - **Routes** *(list) --*

          The routes in the route table.

          - *(dict) --*

            Describes a route in a route table.

            - **DestinationCidrBlock** *(string) --*

              The IPv4 CIDR block used for the destination match.

            - **DestinationIpv6CidrBlock** *(string) --*

              The IPv6 CIDR block used for the destination match.

            - **DestinationPrefixListId** *(string) --*

              The prefix of the AWS service.

            - **EgressOnlyInternetGatewayId** *(string) --*

              The ID of the egress-only internet gateway.

            - **GatewayId** *(string) --*

              The ID of a gateway attached to your VPC.

            - **InstanceId** *(string) --*

              The ID of a NAT instance in your VPC.

            - **InstanceOwnerId** *(string) --*

              The AWS account ID of the owner of the instance.

            - **NatGatewayId** *(string) --*

              The ID of a NAT gateway.

            - **TransitGatewayId** *(string) --*

              The ID of a transit gateway.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **Origin** *(string) --*

              Describes how the route was created.

              * ``CreateRouteTable`` - The route was automatically created when the route table was
              created.

              * ``CreateRoute`` - The route was manually added to the route table.

              * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

            - **State** *(string) --*

              The state of the route. The ``blackhole`` state indicates that the route's target
              isn't available (for example, the specified gateway isn't attached to the VPC, or the
              specified NAT instance has been terminated).

            - **VpcPeeringConnectionId** *(string) --*

              The ID of a VPC peering connection.

        - **Tags** *(list) --*

          Any tags assigned to the route table.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the route table.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailability` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
)


class ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailability` `FirstSlotStartTimeRange`

    The time period for the first schedule to start.

    - **EarliestTime** *(datetime) --* **[REQUIRED]**

      The earliest date and time, in UTC, for the Scheduled Instance to start.

    - **LatestTime** *(datetime) --* **[REQUIRED]**

      The latest date and time, in UTC, for the Scheduled Instance to start. This value must be later
      than or equal to the earliest date and at most three months in the future.
    """


_ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDays": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailability` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``Frequency`` . For example,
      every 2 weeks or every 2 months.

    - **OccurrenceDays** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a weekly
      schedule, this is one or more days of the week (1-7, where 1 is Sunday). You can't specify this
      value with a daily schedule. If the occurrence is relative to the end of the month, you can
      specify only a single day.

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month. You
      can't specify this value with a daily schedule.

    - **OccurrenceUnit** *(string) --*

      The unit for ``OccurrenceDays`` (``DayOfWeek`` or ``DayOfMonth`` ). This value is required for
      a monthly schedule. You can't specify ``DayOfWeek`` with a weekly schedule. You can't specify
      this value with a daily schedule.
    """


_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySet` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``frequency`` . For
      example, every 2 weeks or every 2 months.

    - **OccurrenceDaySet** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a
      weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month.

    - **OccurrenceUnit** *(string) --*

      The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).
    """


_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailableInstanceCount": int,
        "FirstSlotStartTime": datetime,
        "HourlyPrice": str,
        "InstanceType": str,
        "MaxTermDurationInDays": int,
        "MinTermDurationInDays": int,
        "NetworkPlatform": str,
        "Platform": str,
        "PurchaseToken": str,
        "Recurrence": ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef,
        "SlotDurationInHours": int,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailabilityResponse` `ScheduledInstanceAvailabilitySet`

    Describes a schedule that is available for your Scheduled Instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **AvailableInstanceCount** *(integer) --*

      The number of available instances.

    - **FirstSlotStartTime** *(datetime) --*

      The time period for the first schedule to start.

    - **HourlyPrice** *(string) --*

      The hourly price for a single instance.

    - **InstanceType** *(string) --*

      The instance type. You can specify one of the C3, C4, M4, or R3 instance types.

    - **MaxTermDurationInDays** *(integer) --*

      The maximum term. The only possible value is 365 days.

    - **MinTermDurationInDays** *(integer) --*

      The minimum term. The only possible value is 365 days.

    - **NetworkPlatform** *(string) --*

      The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

    - **Platform** *(string) --*

      The platform (``Linux/UNIX`` or ``Windows`` ).

    - **PurchaseToken** *(string) --*

      The purchase token. This token expires in two hours.

    - **Recurrence** *(dict) --*

      The schedule recurrence.

      - **Frequency** *(string) --*

        The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

      - **Interval** *(integer) --*

        The interval quantity. The interval unit depends on the value of ``frequency`` . For
        example, every 2 weeks or every 2 months.

      - **OccurrenceDaySet** *(list) --*

        The days. For a monthly schedule, this is one or more days of the month (1-31). For a
        weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

        - *(integer) --*

      - **OccurrenceRelativeToEnd** *(boolean) --*

        Indicates whether the occurrence is relative to the end of the specified week or month.

      - **OccurrenceUnit** *(string) --*

        The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

    - **SlotDurationInHours** *(integer) --*

      The number of hours in the schedule.

    - **TotalScheduledInstanceHours** *(integer) --*

      The total number of hours for a single instance for the entire term.
    """


_ClientDescribeScheduledInstanceAvailabilityResponseTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceAvailabilitySet": List[
            ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstanceAvailability` `Response`

    Contains the output of DescribeScheduledInstanceAvailability.

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.

    - **ScheduledInstanceAvailabilitySet** *(list) --*

      Information about the available Scheduled Instances.

      - *(dict) --*

        Describes a schedule that is available for your Scheduled Instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **AvailableInstanceCount** *(integer) --*

          The number of available instances.

        - **FirstSlotStartTime** *(datetime) --*

          The time period for the first schedule to start.

        - **HourlyPrice** *(string) --*

          The hourly price for a single instance.

        - **InstanceType** *(string) --*

          The instance type. You can specify one of the C3, C4, M4, or R3 instance types.

        - **MaxTermDurationInDays** *(integer) --*

          The maximum term. The only possible value is 365 days.

        - **MinTermDurationInDays** *(integer) --*

          The minimum term. The only possible value is 365 days.

        - **NetworkPlatform** *(string) --*

          The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

        - **Platform** *(string) --*

          The platform (``Linux/UNIX`` or ``Windows`` ).

        - **PurchaseToken** *(string) --*

          The purchase token. This token expires in two hours.

        - **Recurrence** *(dict) --*

          The schedule recurrence.

          - **Frequency** *(string) --*

            The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

          - **Interval** *(integer) --*

            The interval quantity. The interval unit depends on the value of ``frequency`` . For
            example, every 2 weeks or every 2 months.

          - **OccurrenceDaySet** *(list) --*

            The days. For a monthly schedule, this is one or more days of the month (1-31). For a
            weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

            - *(integer) --*

          - **OccurrenceRelativeToEnd** *(boolean) --*

            Indicates whether the occurrence is relative to the end of the specified week or month.

          - **OccurrenceUnit** *(string) --*

            The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

        - **SlotDurationInHours** *(integer) --*

          The number of hours in the schedule.

        - **TotalScheduledInstanceHours** *(integer) --*

          The total number of hours for a single instance for the entire term.
    """


_ClientDescribeScheduledInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeScheduledInstancesFiltersTypeDef(
    _ClientDescribeScheduledInstancesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstances` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef(
    _ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstancesResponseScheduledInstanceSet` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``frequency`` . For
      example, every 2 weeks or every 2 months.

    - **OccurrenceDaySet** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a
      weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month.

    - **OccurrenceUnit** *(string) --*

      The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).
    """


_ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef(
    _ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstancesResponse` `ScheduledInstanceSet`

    Describes a Scheduled Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **CreateDate** *(datetime) --*

      The date when the Scheduled Instance was purchased.

    - **HourlyPrice** *(string) --*

      The hourly price for a single instance.

    - **InstanceCount** *(integer) --*

      The number of instances.

    - **InstanceType** *(string) --*

      The instance type.

    - **NetworkPlatform** *(string) --*

      The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

    - **NextSlotStartTime** *(datetime) --*

      The time for the next schedule to start.

    - **Platform** *(string) --*

      The platform (``Linux/UNIX`` or ``Windows`` ).

    - **PreviousSlotEndTime** *(datetime) --*

      The time that the previous schedule ended or will end.

    - **Recurrence** *(dict) --*

      The schedule recurrence.

      - **Frequency** *(string) --*

        The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

      - **Interval** *(integer) --*

        The interval quantity. The interval unit depends on the value of ``frequency`` . For
        example, every 2 weeks or every 2 months.

      - **OccurrenceDaySet** *(list) --*

        The days. For a monthly schedule, this is one or more days of the month (1-31). For a
        weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

        - *(integer) --*

      - **OccurrenceRelativeToEnd** *(boolean) --*

        Indicates whether the occurrence is relative to the end of the specified week or month.

      - **OccurrenceUnit** *(string) --*

        The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

    - **ScheduledInstanceId** *(string) --*

      The Scheduled Instance ID.

    - **SlotDurationInHours** *(integer) --*

      The number of hours in the schedule.

    - **TermEndDate** *(datetime) --*

      The end date for the Scheduled Instance.

    - **TermStartDate** *(datetime) --*

      The start date for the Scheduled Instance.

    - **TotalScheduledInstanceHours** *(integer) --*

      The total number of hours for a single instance for the entire term.
    """


_ClientDescribeScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceSet": List[
            ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseTypeDef(
    _ClientDescribeScheduledInstancesResponseTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstances` `Response`

    Contains the output of DescribeScheduledInstances.

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.

    - **ScheduledInstanceSet** *(list) --*

      Information about the Scheduled Instances.

      - *(dict) --*

        Describes a Scheduled Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **CreateDate** *(datetime) --*

          The date when the Scheduled Instance was purchased.

        - **HourlyPrice** *(string) --*

          The hourly price for a single instance.

        - **InstanceCount** *(integer) --*

          The number of instances.

        - **InstanceType** *(string) --*

          The instance type.

        - **NetworkPlatform** *(string) --*

          The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

        - **NextSlotStartTime** *(datetime) --*

          The time for the next schedule to start.

        - **Platform** *(string) --*

          The platform (``Linux/UNIX`` or ``Windows`` ).

        - **PreviousSlotEndTime** *(datetime) --*

          The time that the previous schedule ended or will end.

        - **Recurrence** *(dict) --*

          The schedule recurrence.

          - **Frequency** *(string) --*

            The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

          - **Interval** *(integer) --*

            The interval quantity. The interval unit depends on the value of ``frequency`` . For
            example, every 2 weeks or every 2 months.

          - **OccurrenceDaySet** *(list) --*

            The days. For a monthly schedule, this is one or more days of the month (1-31). For a
            weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

            - *(integer) --*

          - **OccurrenceRelativeToEnd** *(boolean) --*

            Indicates whether the occurrence is relative to the end of the specified week or month.

          - **OccurrenceUnit** *(string) --*

            The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

        - **ScheduledInstanceId** *(string) --*

          The Scheduled Instance ID.

        - **SlotDurationInHours** *(integer) --*

          The number of hours in the schedule.

        - **TermEndDate** *(datetime) --*

          The end date for the Scheduled Instance.

        - **TermStartDate** *(datetime) --*

          The start date for the Scheduled Instance.

        - **TotalScheduledInstanceHours** *(integer) --*

          The total number of hours for a single instance for the entire term.
    """


_ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
    total=False,
)


class ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef(
    _ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef
):
    """
    Type definition for `ClientDescribeScheduledInstances` `SlotStartTimeRange`

    The time period for the first schedule to start.

    - **EarliestTime** *(datetime) --*

      The earliest date and time, in UTC, for the Scheduled Instance to start.

    - **LatestTime** *(datetime) --*

      The latest date and time, in UTC, for the Scheduled Instance to start.
    """


_ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef",
    {"GroupId": str, "ReferencingVpcId": str, "VpcPeeringConnectionId": str},
    total=False,
)


class ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef(
    _ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupReferencesResponse` `SecurityGroupReferenceSet`

    Describes a VPC with a security group that references your security group.

    - **GroupId** *(string) --*

      The ID of your security group.

    - **ReferencingVpcId** *(string) --*

      The ID of the VPC with the referencing security group.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_ClientDescribeSecurityGroupReferencesResponseTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupReferencesResponseTypeDef",
    {
        "SecurityGroupReferenceSet": List[
            ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSecurityGroupReferencesResponseTypeDef(
    _ClientDescribeSecurityGroupReferencesResponseTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupReferences` `Response`

    - **SecurityGroupReferenceSet** *(list) --*

      Information about the VPCs with the referencing security groups.

      - *(dict) --*

        Describes a VPC with a security group that references your security group.

        - **GroupId** *(string) --*

          The ID of your security group.

        - **ReferencingVpcId** *(string) --*

          The ID of the VPC with the referencing security group.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection.
    """


_ClientDescribeSecurityGroupsFiltersTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSecurityGroupsFiltersTypeDef(
    _ClientDescribeSecurityGroupsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroups` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgress` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgress` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgress` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgress` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroups` `IpPermissionsEgress`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
      A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
      types, you must specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
      `Protocol Numbers
      <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
      rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
      , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
      specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
      ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
      types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
      AWS service to access through a VPC endpoint from instances associated with the
      security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
      of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
      must specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroups` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
      A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
      types, you must specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
      `Protocol Numbers
      <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
      rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
      , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
      specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
      ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
      types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
      AWS service to access through a VPC endpoint from instances associated with the
      security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
      of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
      must specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponseSecurityGroups` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef",
    {
        "Description": str,
        "GroupName": str,
        "IpPermissions": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef
        ],
        "OwnerId": str,
        "GroupId": str,
        "IpPermissionsEgress": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef
        ],
        "Tags": List[ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroupsResponse` `SecurityGroups`

    Describes a security group

    - **Description** *(string) --*

      A description of the security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **IpPermissions** *(list) --*

      The inbound rules associated with the security group.

      - *(dict) --*

        Describes a set of permissions for a security group rule.

        - **FromPort** *(integer) --*

          The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
          A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
          types, you must specify all codes.

        - **IpProtocol** *(string) --*

          The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
          `Protocol Numbers
          <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

          [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
          rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
          , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
          specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
          ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
          types and codes is allowed.

        - **IpRanges** *(list) --*

          The IPv4 ranges.

          - *(dict) --*

            Describes an IPv4 range.

            - **CidrIp** *(string) --*

              The IPv4 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv4 address, use the /32 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv4 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **Ipv6Ranges** *(list) --*

          [VPC only] The IPv6 ranges.

          - *(dict) --*

            [EC2-VPC only] Describes an IPv6 range.

            - **CidrIpv6** *(string) --*

              The IPv6 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv6 address, use the /128 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv6 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListIds** *(list) --*

          [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
          AWS service to access through a VPC endpoint from instances associated with the
          security group.

          - *(dict) --*

            Describes a prefix list ID.

            - **Description** *(string) --*

              A description for the security group rule that references this prefix list ID.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListId** *(string) --*

              The ID of the prefix.

        - **ToPort** *(integer) --*

          The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
          of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
          must specify all codes.

        - **UserIdGroupPairs** *(list) --*

          The security group and AWS account ID pairs.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **OwnerId** *(string) --*

      The AWS account ID of the owner of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **IpPermissionsEgress** *(list) --*

      [VPC only] The outbound rules associated with the security group.

      - *(dict) --*

        Describes a set of permissions for a security group rule.

        - **FromPort** *(integer) --*

          The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
          A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
          types, you must specify all codes.

        - **IpProtocol** *(string) --*

          The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
          `Protocol Numbers
          <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

          [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
          rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
          , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
          specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
          ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
          types and codes is allowed.

        - **IpRanges** *(list) --*

          The IPv4 ranges.

          - *(dict) --*

            Describes an IPv4 range.

            - **CidrIp** *(string) --*

              The IPv4 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv4 address, use the /32 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv4 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **Ipv6Ranges** *(list) --*

          [VPC only] The IPv6 ranges.

          - *(dict) --*

            [EC2-VPC only] Describes an IPv6 range.

            - **CidrIpv6** *(string) --*

              The IPv6 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv6 address, use the /128 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv6 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListIds** *(list) --*

          [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
          AWS service to access through a VPC endpoint from instances associated with the
          security group.

          - *(dict) --*

            Describes a prefix list ID.

            - **Description** *(string) --*

              A description for the security group rule that references this prefix list ID.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListId** *(string) --*

              The ID of the prefix.

        - **ToPort** *(integer) --*

          The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
          of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
          must specify all codes.

        - **UserIdGroupPairs** *(list) --*

          The security group and AWS account ID pairs.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the security group.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      [VPC only] The ID of the VPC for the security group.
    """


_ClientDescribeSecurityGroupsResponseTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseTypeDef",
    {
        "SecurityGroups": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseTypeDef(
    _ClientDescribeSecurityGroupsResponseTypeDef
):
    """
    Type definition for `ClientDescribeSecurityGroups` `Response`

    - **SecurityGroups** *(list) --*

      Information about the security groups.

      - *(dict) --*

        Describes a security group

        - **Description** *(string) --*

          A description of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **IpPermissions** *(list) --*

          The inbound rules associated with the security group.

          - *(dict) --*

            Describes a set of permissions for a security group rule.

            - **FromPort** *(integer) --*

              The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
              A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
              types, you must specify all codes.

            - **IpProtocol** *(string) --*

              The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
              `Protocol Numbers
              <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

              [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
              rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
              , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
              specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
              ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
              types and codes is allowed.

            - **IpRanges** *(list) --*

              The IPv4 ranges.

              - *(dict) --*

                Describes an IPv4 range.

                - **CidrIp** *(string) --*

                  The IPv4 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv4 address, use the /32 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv4 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **Ipv6Ranges** *(list) --*

              [VPC only] The IPv6 ranges.

              - *(dict) --*

                [EC2-VPC only] Describes an IPv6 range.

                - **CidrIpv6** *(string) --*

                  The IPv6 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv6 address, use the /128 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv6 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListIds** *(list) --*

              [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
              AWS service to access through a VPC endpoint from instances associated with the
              security group.

              - *(dict) --*

                Describes a prefix list ID.

                - **Description** *(string) --*

                  A description for the security group rule that references this prefix list ID.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **PrefixListId** *(string) --*

                  The ID of the prefix.

            - **ToPort** *(integer) --*

              The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
              of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
              must specify all codes.

            - **UserIdGroupPairs** *(list) --*

              The security group and AWS account ID pairs.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **OwnerId** *(string) --*

          The AWS account ID of the owner of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **IpPermissionsEgress** *(list) --*

          [VPC only] The outbound rules associated with the security group.

          - *(dict) --*

            Describes a set of permissions for a security group rule.

            - **FromPort** *(integer) --*

              The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
              A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
              types, you must specify all codes.

            - **IpProtocol** *(string) --*

              The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
              `Protocol Numbers
              <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

              [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
              rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
              , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
              specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
              ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
              types and codes is allowed.

            - **IpRanges** *(list) --*

              The IPv4 ranges.

              - *(dict) --*

                Describes an IPv4 range.

                - **CidrIp** *(string) --*

                  The IPv4 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv4 address, use the /32 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv4 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **Ipv6Ranges** *(list) --*

              [VPC only] The IPv6 ranges.

              - *(dict) --*

                [EC2-VPC only] Describes an IPv6 range.

                - **CidrIpv6** *(string) --*

                  The IPv6 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv6 address, use the /128 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv6 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListIds** *(list) --*

              [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
              AWS service to access through a VPC endpoint from instances associated with the
              security group.

              - *(dict) --*

                Describes a prefix list ID.

                - **Description** *(string) --*

                  A description for the security group rule that references this prefix list ID.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **PrefixListId** *(string) --*

                  The ID of the prefix.

            - **ToPort** *(integer) --*

              The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
              of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
              must specify all codes.

            - **UserIdGroupPairs** *(list) --*

              The security group and AWS account ID pairs.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the security group.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          [VPC only] The ID of the VPC for the security group.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef(
    _ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef
):
    """
    Type definition for `ClientDescribeSnapshotAttributeResponse` `CreateVolumePermissions`

    Describes the user or group to be added or removed from the list of create volume
    permissions for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_ClientDescribeSnapshotAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeSnapshotAttributeResponseProductCodesTypeDef(
    _ClientDescribeSnapshotAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeSnapshotAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeSnapshotAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseTypeDef",
    {
        "CreateVolumePermissions": List[
            ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef
        ],
        "ProductCodes": List[
            ClientDescribeSnapshotAttributeResponseProductCodesTypeDef
        ],
        "SnapshotId": str,
    },
    total=False,
)


class ClientDescribeSnapshotAttributeResponseTypeDef(
    _ClientDescribeSnapshotAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeSnapshotAttribute` `Response`

    Contains the output of DescribeSnapshotAttribute.

    - **CreateVolumePermissions** *(list) --*

      The users and groups that have the permissions for creating volumes from the snapshot.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume
        permissions for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **SnapshotId** *(string) --*

      The ID of the EBS snapshot.
    """


_ClientDescribeSnapshotsFiltersTypeDef = TypedDict(
    "_ClientDescribeSnapshotsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSnapshotsFiltersTypeDef(_ClientDescribeSnapshotsFiltersTypeDef):
    """
    Type definition for `ClientDescribeSnapshots` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef(
    _ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef
):
    """
    Type definition for `ClientDescribeSnapshotsResponseSnapshots` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeSnapshotsResponseSnapshotsTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseSnapshotsTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": str,
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeSnapshotsResponseSnapshotsTypeDef(
    _ClientDescribeSnapshotsResponseSnapshotsTypeDef
):
    """
    Type definition for `ClientDescribeSnapshotsResponse` `Snapshots`

    Describes a snapshot.

    - **DataEncryptionKeyId** *(string) --*

      The data encryption key identifier for the snapshot. This value is a unique identifier
      that corresponds to the data encryption key that was used to encrypt the original volume
      or snapshot copy. Because data encryption keys are inherited by volumes created from
      snapshots, and vice versa, if snapshots share the same data encryption key identifier,
      then they belong to the same volume/snapshot lineage. This parameter is only returned by
      DescribeSnapshots .

    - **Description** *(string) --*

      The description for the snapshot.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
      master key (CMK) that was used to protect the volume encryption key for the parent volume.

    - **OwnerId** *(string) --*

      The AWS account ID of the EBS snapshot owner.

    - **Progress** *(string) --*

      The progress of the snapshot, as a percentage.

    - **SnapshotId** *(string) --*

      The ID of the snapshot. Each snapshot receives a unique identifier when it is created.

    - **StartTime** *(datetime) --*

      The time stamp when the snapshot was initiated.

    - **State** *(string) --*

      The snapshot state.

    - **StateMessage** *(string) --*

      Encrypted Amazon EBS snapshots are copied asynchronously. If a snapshot copy operation
      fails (for example, if the proper AWS Key Management Service (AWS KMS) permissions are
      not obtained) this field displays error state details to help you diagnose why the error
      occurred. This parameter is only returned by  DescribeSnapshots .

    - **VolumeId** *(string) --*

      The ID of the volume that was used to create the snapshot. Snapshots created by the
      CopySnapshot action have an arbitrary volume ID that should not be used for any purpose.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **OwnerAlias** *(string) --*

      Value from an Amazon-maintained list (``amazon`` | ``self`` | ``all`` |
      ``aws-marketplace`` | ``microsoft`` ) of snapshot owners. Not to be confused with the
      user-configured AWS account alias, which is set from the IAM console.

    - **Tags** *(list) --*

      Any tags assigned to the snapshot.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeSnapshotsResponseTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseTypeDef",
    {
        "Snapshots": List[ClientDescribeSnapshotsResponseSnapshotsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeSnapshotsResponseTypeDef(_ClientDescribeSnapshotsResponseTypeDef):
    """
    Type definition for `ClientDescribeSnapshots` `Response`

    - **Snapshots** *(list) --*

      Information about the snapshots.

      - *(dict) --*

        Describes a snapshot.

        - **DataEncryptionKeyId** *(string) --*

          The data encryption key identifier for the snapshot. This value is a unique identifier
          that corresponds to the data encryption key that was used to encrypt the original volume
          or snapshot copy. Because data encryption keys are inherited by volumes created from
          snapshots, and vice versa, if snapshots share the same data encryption key identifier,
          then they belong to the same volume/snapshot lineage. This parameter is only returned by
          DescribeSnapshots .

        - **Description** *(string) --*

          The description for the snapshot.

        - **Encrypted** *(boolean) --*

          Indicates whether the snapshot is encrypted.

        - **KmsKeyId** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
          master key (CMK) that was used to protect the volume encryption key for the parent volume.

        - **OwnerId** *(string) --*

          The AWS account ID of the EBS snapshot owner.

        - **Progress** *(string) --*

          The progress of the snapshot, as a percentage.

        - **SnapshotId** *(string) --*

          The ID of the snapshot. Each snapshot receives a unique identifier when it is created.

        - **StartTime** *(datetime) --*

          The time stamp when the snapshot was initiated.

        - **State** *(string) --*

          The snapshot state.

        - **StateMessage** *(string) --*

          Encrypted Amazon EBS snapshots are copied asynchronously. If a snapshot copy operation
          fails (for example, if the proper AWS Key Management Service (AWS KMS) permissions are
          not obtained) this field displays error state details to help you diagnose why the error
          occurred. This parameter is only returned by  DescribeSnapshots .

        - **VolumeId** *(string) --*

          The ID of the volume that was used to create the snapshot. Snapshots created by the
          CopySnapshot action have an arbitrary volume ID that should not be used for any purpose.

        - **VolumeSize** *(integer) --*

          The size of the volume, in GiB.

        - **OwnerAlias** *(string) --*

          Value from an Amazon-maintained list (``amazon`` | ``self`` | ``all`` |
          ``aws-marketplace`` | ``microsoft`` ) of snapshot owners. Not to be confused with the
          user-configured AWS account alias, which is set from the IAM console.

        - **Tags** *(list) --*

          Any tags assigned to the snapshot.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The ``NextToken`` value to include in a future ``DescribeSnapshots`` request. When the
      results of a ``DescribeSnapshots`` request exceed ``MaxResults`` , this value can be used to
      retrieve the next page of results. This value is ``null`` when there are no more results to
      return.
    """


_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef
):
    """
    Type definition for `ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscription` `Fault`

    The fault codes for the Spot Instance request, if any.

    - **Code** *(string) --*

      The reason code for the Spot Instance state change.

    - **Message** *(string) --*

      The message for the Spot Instance state change.
    """


_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    {
        "Bucket": str,
        "Fault": ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef,
        "OwnerId": str,
        "Prefix": str,
        "State": str,
    },
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
):
    """
    Type definition for `ClientDescribeSpotDatafeedSubscriptionResponse` `SpotDatafeedSubscription`

    The Spot Instance data feed subscription.

    - **Bucket** *(string) --*

      The Amazon S3 bucket where the Spot Instance data feed is located.

    - **Fault** *(dict) --*

      The fault codes for the Spot Instance request, if any.

      - **Code** *(string) --*

        The reason code for the Spot Instance state change.

      - **Message** *(string) --*

        The message for the Spot Instance state change.

    - **OwnerId** *(string) --*

      The AWS account ID of the account.

    - **Prefix** *(string) --*

      The prefix that is prepended to data feed files.

    - **State** *(string) --*

      The state of the Spot Instance data feed subscription.
    """


_ClientDescribeSpotDatafeedSubscriptionResponseTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseTypeDef",
    {
        "SpotDatafeedSubscription": ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
    },
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotDatafeedSubscription` `Response`

    Contains the output of DescribeSpotDatafeedSubscription.

    - **SpotDatafeedSubscription** *(dict) --*

      The Spot Instance data feed subscription.

      - **Bucket** *(string) --*

        The Amazon S3 bucket where the Spot Instance data feed is located.

      - **Fault** *(dict) --*

        The fault codes for the Spot Instance request, if any.

        - **Code** *(string) --*

          The reason code for the Spot Instance state change.

        - **Message** *(string) --*

          The message for the Spot Instance state change.

      - **OwnerId** *(string) --*

        The AWS account ID of the account.

      - **Prefix** *(string) --*

        The prefix that is prepended to data feed files.

      - **State** *(string) --*

        The state of the Spot Instance data feed subscription.
    """


_ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": str,
    },
    total=False,
)


class ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef(
    _ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetInstancesResponse` `ActiveInstances`

    Describes a running instance in a Spot Fleet.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **InstanceHealth** *(string) --*

      The health status of the instance. If the status of either the instance status check or
      the system status check is ``impaired`` , the health status of the instance is
      ``unhealthy`` . Otherwise, the health status is ``healthy`` .
    """


_ClientDescribeSpotFleetInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetInstancesResponseTypeDef",
    {
        "ActiveInstances": List[
            ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef
        ],
        "NextToken": str,
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientDescribeSpotFleetInstancesResponseTypeDef(
    _ClientDescribeSpotFleetInstancesResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetInstances` `Response`

    Contains the output of DescribeSpotFleetInstances.

    - **ActiveInstances** *(list) --*

      The running instances. This list is refreshed periodically and might be out of date.

      - *(dict) --*

        Describes a running instance in a Spot Fleet.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **InstanceHealth** *(string) --*

          The health status of the instance. If the status of either the instance status check or
          the system status check is ``impaired`` , the health status of the instance is
          ``unhealthy`` . Otherwise, the health status is ``healthy`` .

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.
    """


_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef",
    {"EventDescription": str, "EventSubType": str, "InstanceId": str},
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestHistoryResponseHistoryRecords` `EventInformation`

    Information about the event.

    - **EventDescription** *(string) --*

      The description of the event.

    - **EventSubType** *(string) --*

      The event.

      The following are the ``error`` events:

      * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
      permissions either to launch or terminate an instance.

      * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
      information, see the description of the event.

      * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
      Instances that you can launch.

      The following are the ``fleetRequestChange`` events:

      * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
      attempting to maintain the target number of running Spot Instances.

      * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
      Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
      instances were terminated.

      * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
      launch additional Spot Instances. Existing Spot Instances continue to run until they
      are interrupted or terminated.

      * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
      Spot Instances are terminating.

      * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
      indicates that the instances were terminated, if the request was created with
      ``TerminateInstancesWithExpiration`` set.

      * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
      accepted and is in progress.

      * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

      * ``price_update`` - The price for a launch configuration was adjusted because it was
      too high. This change is permanent.

      * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
      is preparing to launch the target number of Spot Instances.

      The following are the ``instanceChange`` events:

      * ``launched`` - A request was fulfilled and a new instance was launched.

      * ``terminated`` - An instance was terminated by the user.

      The following are the ``Information`` events:

      * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
      attempts to launch instances have failed. For more information, see the description of
      the event.

      * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
      is below the Spot price or the Spot price is above the On-Demand price.

      * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
      launch specification might become valid if the Spot price changes.

    - **InstanceId** *(string) --*

      The ID of the instance. This information is available only for ``instanceChange``
      events.
    """


_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef",
    {
        "EventInformation": ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef,
        "EventType": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestHistoryResponse` `HistoryRecords`

    Describes an event in the history of the Spot Fleet request.

    - **EventInformation** *(dict) --*

      Information about the event.

      - **EventDescription** *(string) --*

        The description of the event.

      - **EventSubType** *(string) --*

        The event.

        The following are the ``error`` events:

        * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
        permissions either to launch or terminate an instance.

        * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
        information, see the description of the event.

        * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
        Instances that you can launch.

        The following are the ``fleetRequestChange`` events:

        * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
        attempting to maintain the target number of running Spot Instances.

        * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
        Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
        instances were terminated.

        * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
        launch additional Spot Instances. Existing Spot Instances continue to run until they
        are interrupted or terminated.

        * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
        Spot Instances are terminating.

        * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
        indicates that the instances were terminated, if the request was created with
        ``TerminateInstancesWithExpiration`` set.

        * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
        accepted and is in progress.

        * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

        * ``price_update`` - The price for a launch configuration was adjusted because it was
        too high. This change is permanent.

        * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
        is preparing to launch the target number of Spot Instances.

        The following are the ``instanceChange`` events:

        * ``launched`` - A request was fulfilled and a new instance was launched.

        * ``terminated`` - An instance was terminated by the user.

        The following are the ``Information`` events:

        * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
        attempts to launch instances have failed. For more information, see the description of
        the event.

        * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
        is below the Spot price or the Spot price is above the On-Demand price.

        * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
        launch specification might become valid if the Spot price changes.

      - **InstanceId** *(string) --*

        The ID of the instance. This information is available only for ``instanceChange``
        events.

    - **EventType** *(string) --*

      The event type.

      * ``error`` - An error with the Spot Fleet request.

      * ``fleetRequestChange`` - A change in the status or configuration of the Spot Fleet
      request.

      * ``instanceChange`` - An instance was launched or terminated.

      * ``Information`` - An informational event.

    - **Timestamp** *(datetime) --*

      The date and time of the event, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
      :*MM* :*SS* Z).
    """


_ClientDescribeSpotFleetRequestHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseTypeDef",
    {
        "HistoryRecords": List[
            ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef
        ],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "SpotFleetRequestId": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestHistory` `Response`

    Contains the output of DescribeSpotFleetRequestHistory.

    - **HistoryRecords** *(list) --*

      Information about the events in the history of the Spot Fleet request.

      - *(dict) --*

        Describes an event in the history of the Spot Fleet request.

        - **EventInformation** *(dict) --*

          Information about the event.

          - **EventDescription** *(string) --*

            The description of the event.

          - **EventSubType** *(string) --*

            The event.

            The following are the ``error`` events:

            * ``iamFleetRoleInvalid`` - The EC2 Fleet or Spot Fleet did not have the required
            permissions either to launch or terminate an instance.

            * ``spotFleetRequestConfigurationInvalid`` - The configuration is not valid. For more
            information, see the description of the event.

            * ``spotInstanceCountLimitExceeded`` - You've reached the limit on the number of Spot
            Instances that you can launch.

            The following are the ``fleetRequestChange`` events:

            * ``active`` - The EC2 Fleet or Spot Fleet request has been validated and Amazon EC2 is
            attempting to maintain the target number of running Spot Instances.

            * ``cancelled`` - The EC2 Fleet or Spot Fleet request is canceled and has no running
            Spot Instances. The EC2 Fleet or Spot Fleet will be deleted two days after its
            instances were terminated.

            * ``cancelled_running`` - The EC2 Fleet or Spot Fleet request is canceled and does not
            launch additional Spot Instances. Existing Spot Instances continue to run until they
            are interrupted or terminated.

            * ``cancelled_terminating`` - The EC2 Fleet or Spot Fleet request is canceled and its
            Spot Instances are terminating.

            * ``expired`` - The EC2 Fleet or Spot Fleet request has expired. A subsequent event
            indicates that the instances were terminated, if the request was created with
            ``TerminateInstancesWithExpiration`` set.

            * ``modify_in_progress`` - A request to modify the EC2 Fleet or Spot Fleet request was
            accepted and is in progress.

            * ``modify_successful`` - The EC2 Fleet or Spot Fleet request was modified.

            * ``price_update`` - The price for a launch configuration was adjusted because it was
            too high. This change is permanent.

            * ``submitted`` - The EC2 Fleet or Spot Fleet request is being evaluated and Amazon EC2
            is preparing to launch the target number of Spot Instances.

            The following are the ``instanceChange`` events:

            * ``launched`` - A request was fulfilled and a new instance was launched.

            * ``terminated`` - An instance was terminated by the user.

            The following are the ``Information`` events:

            * ``launchSpecTemporarilyBlacklisted`` - The configuration is not valid and several
            attempts to launch instances have failed. For more information, see the description of
            the event.

            * ``launchSpecUnusable`` - The price in a launch specification is not valid because it
            is below the Spot price or the Spot price is above the On-Demand price.

            * ``fleetProgressHalted`` - The price in every launch specification is not valid. A
            launch specification might become valid if the Spot price changes.

          - **InstanceId** *(string) --*

            The ID of the instance. This information is available only for ``instanceChange``
            events.

        - **EventType** *(string) --*

          The event type.

          * ``error`` - An error with the Spot Fleet request.

          * ``fleetRequestChange`` - A change in the status or configuration of the Spot Fleet
          request.

          * ``instanceChange`` - An instance was launched or terminated.

          * ``Information`` - An informational event.

        - **Timestamp** *(datetime) --*

          The date and time of the event, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
          :*MM* :*SS* Z).

    - **LastEvaluatedTime** *(datetime) --*

      The last date and time for the events, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH*
      :*MM* :*SS* Z). All records up to this time were retrieved.

      If ``nextToken`` indicates that there are more results, this value is not present.

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.

    - **StartTime** *(datetime) --*

      The starting date and time for the events, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z).
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is
    launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for
      the volume. For ``gp2`` volumes, this represents the baseline performance of
      the volume and the rate at which the volume accumulates I/O credits for
      bursting. For more information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
      64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
      64,000 is guaranteed only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes;
      it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
      ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a
      volume size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
      Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
      (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
      (``standard`` ) volumes. If you specify a snapshot, the volume size must be
      equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the
      IOPS that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while
      being restored from a backing snapshot. The effect of setting the encryption
      state to ``true`` depends on the volume origin (new or from a snapshot),
      starting encryption state, ownership, and whether encryption by default is
      enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
      CMK under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      , `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can
      specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
      available instance store volumes depends on the instance type. After you
      connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device
      name. Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the
      block device mapping for the instance. When you launch an M3 instance, we
      ignore any instance store volumes specified in the block device mapping for the
      AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is
      launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for
        the volume. For ``gp2`` volumes, this represents the baseline performance of
        the volume and the rate at which the volume accumulates I/O credits for
        bursting. For more information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
        64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
        64,000 is guaranteed only on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes;
        it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
        ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a
        volume size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
        Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
        (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
        (``standard`` ) volumes. If you specify a snapshot, the volume size must be
        equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the
        IOPS that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while
        being restored from a backing snapshot. The effect of setting the encryption
        state to ``true`` depends on the volume origin (new or from a snapshot),
        starting encryption state, ownership, and whether encryption by default is
        enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
        CMK under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
        , `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `Monitoring`

    Enable or disable monitoring for the instances.

    - **Enabled** *(boolean) --*

      Enables monitoring for the instance.

      Default: ``false``
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4
      address. Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in
      a VPC. The public IP address can only be assigned to a network interface for
      eth0, and can only be assigned to a new network interface, not an existing one.
      You cannot specify more than one network interface in the request. If launching
      into a default subnet, the default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated.
      You can specify ``true`` only if creating a new network interface when
      launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network
      interface when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary
      network interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify
      the device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if
      creating a network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2
      chooses the IPv6 addresses from the range of the subnet. You cannot specify
      this option and the option to assign specific IPv6 addresses in the same
      request. You can specify this option if you've specified a minimum number of
      instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot
      specify this option and the option to assign a number of IPv6 addresses in the
      same request. You cannot specify this option if you've specified a minimum
      number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a
      network interface when launching an instance. You cannot specify this option if
      you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one
      private IPv4 address can be designated as primary. You cannot specify this
      option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4
          address. Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option
      and specify more than one private IP address using the private IP addresses
      option. You cannot specify this option if you're launching more than one
      instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if
      creating a network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA),
      specify ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `Placement`

    The placement information.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using
      commas; for example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance
      with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
      tenancy is not supported for Spot Instances.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127
      Unicode characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255
      Unicode characters.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `TagSpecifications`

    The tags for a Spot Fleet resource.

    - **ResourceType** *(string) --*

      The type of resource. Currently, the only resource type that is supported is
      ``instance`` .

    - **Tags** *(list) --*

      The tags.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127
          Unicode characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255
          Unicode characters.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LaunchSpecifications`

    Describes the launch specification for one or more Spot Instances. If you include
    On-Demand capacity in your fleet request, you can't use
    ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
    .

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify
      the IDs of the security groups. When requesting instances in EC2-Classic, you can
      specify the names or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block devices that are mapped to the Spot Instances. You can't specify
      both a snapshot ID and an encryption value. This is because only blank volumes can
      be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
      and its encryption status is used for the volume encryption status.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can
          specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
          available instance store volumes depends on the instance type. After you
          connect to the instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device
          name. Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the
          block device mapping for the instance. When you launch an M3 instance, we
          ignore any instance store volumes specified in the block device mapping for the
          AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is
          launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for
            the volume. For ``gp2`` volumes, this represents the baseline performance of
            the volume and the rate at which the volume accumulates I/O credits for
            bursting. For more information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
            64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
            64,000 is guaranteed only on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes;
            it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
            ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a
            volume size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
            Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
            (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
            (``standard`` ) volumes. If you specify a snapshot, the volume size must be
            equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the
            IOPS that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while
            being restored from a backing snapshot. The effect of setting the encryption
            state to ``true`` depends on the volume origin (new or from a snapshot),
            starting encryption state, ownership, and whether encryption by default is
            enabled. For more information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
            CMK under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            , `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instances are optimized for EBS I/O. This optimization
      provides dedicated throughput to Amazon EBS and an optimized configuration stack to
      provide optimal EBS I/O performance. This optimization isn't available with all
      instance types. Additional usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      Enable or disable monitoring for the instances.

      - **Enabled** *(boolean) --*

        Enables monitoring for the instance.

        Default: ``false``

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must
      specify subnet IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in
          a VPC. The public IP address can only be assigned to a network interface for
          eth0, and can only be assigned to a new network interface, not an existing one.
          You cannot specify more than one network interface in the request. If launching
          into a default subnet, the default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated.
          You can specify ``true`` only if creating a new network interface when
          launching an instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network
          interface when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary
          network interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify
          the device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if
          creating a network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2
          chooses the IPv6 addresses from the range of the subnet. You cannot specify
          this option and the option to assign specific IPv6 addresses in the same
          request. You can specify this option if you've specified a minimum number of
          instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot
          specify this option and the option to assign a number of IPv6 addresses in the
          same request. You cannot specify this option if you've specified a minimum
          number of instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a
          network interface when launching an instance. You cannot specify this option if
          you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one
          private IPv4 address can be designated as primary. You cannot specify this
          option if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4
              address. Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option
          and specify more than one private IP address using the private IP addresses
          option. You cannot specify this option if you're launching more than one
          instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if
          creating a network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA),
          specify ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
          *Amazon Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using
        commas; for example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance
        with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
        tenancy is not supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk. Some kernels require additional drivers at launch. Check
      the kernel requirements for information about whether you need to specify a RAM
      disk. To find kernel requirements, refer to the AWS Resource Center and search for
      the kernel ID.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. If
      this value is not specified, the default is the Spot price specified for the fleet.
      To determine the Spot price per unit hour, divide the Spot price by the value of
      ``WeightedCapacity`` .

    - **SubnetId** *(string) --*

      The IDs of the subnets in which to launch the instances. To specify multiple
      subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
      subnet-0987cdef6example2".

    - **UserData** *(string) --*

      The Base64-encoded user data that instances use when starting up.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type. These are the same
      units that you chose to set the target capacity in terms of instances, or a
      performance characteristic such as vCPUs, memory, or I/O.

      If the target capacity divided by this value is not a whole number, Amazon EC2
      rounds the number of instances to the next whole number. If this value is not
      specified, the default is 1.

    - **TagSpecifications** *(list) --*

      The tags to apply during creation.

      - *(dict) --*

        The tags for a Spot Fleet resource.

        - **ResourceType** *(string) --*

          The type of resource. Currently, the only resource type that is supported is
          ``instance`` .

        - **Tags** *(list) --*

          The tags.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127
              Unicode characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255
              Unicode characters.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If
      **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
      priority to determine which launch template override to use first in fulfilling
      On-Demand capacity. The highest priority is launched first. Valid values are
      whole numbers starting at ``0`` . The lower the number, the higher the
      priority. If no number is set, the launch template override has the lowest
      priority.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If
          **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
          priority to determine which launch template override to use first in fulfilling
          On-Demand capacity. The highest priority is launched first. Valid values are
          whole numbers starting at ``0`` . The lower the number, the higher the
          priority. If no number is set, the launch template override has the lowest
          priority.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfig` `ClassicLoadBalancers`

    Describes a Classic Load Balancer.

    - **Name** *(string) --*

      The name of the load balancer.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfig` `ClassicLoadBalancersConfig`

    The Classic Load Balancers.

    - **ClassicLoadBalancers** *(list) --*

      One or more Classic Load Balancers.

      - *(dict) --*

        Describes a Classic Load Balancer.

        - **Name** *(string) --*

          The name of the load balancer.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfig` `TargetGroups`

    Describes a load balancer target group.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the target group.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfig` `TargetGroupsConfig`

    The target groups.

    - **TargetGroups** *(list) --*

      One or more target groups.

      - *(dict) --*

        Describes a load balancer target group.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the target group.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LoadBalancersConfig`

    One or more Classic Load Balancers and target groups to attach to the Spot Fleet
    request. Spot Fleet registers the running Spot Instances with the specified Classic
    Load Balancers and target groups.

    With Network Load Balancers, Spot Fleet cannot register instances that have the
    following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
    M3, and T1.

    - **ClassicLoadBalancersConfig** *(dict) --*

      The Classic Load Balancers.

      - **ClassicLoadBalancers** *(list) --*

        One or more Classic Load Balancers.

        - *(dict) --*

          Describes a Classic Load Balancer.

          - **Name** *(string) --*

            The name of the load balancer.

    - **TargetGroupsConfig** *(dict) --*

      The target groups.

      - **TargetGroups** *(list) --*

        One or more target groups.

        - *(dict) --*

          Describes a load balancer target group.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the target group.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": str,
        "OnDemandAllocationStrategy": str,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": str,
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": str,
        "LoadBalancersConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigs` `SpotFleetRequestConfig`

    The configuration of the Spot Fleet request.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance
      pools specified by the Spot Fleet request.

      If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
      Spot Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
      the Spot Instance pools that you specify.

      If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
      from Spot Instance pools with optimal capacity for the number of instances that are
      launching.

    - **OnDemandAllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If
      you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
      the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
      that you assign to each Spot Fleet launch template override, launching the highest
      priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

    - **ClientToken** *(string) --*

      A unique, case-sensitive identifier that you provide to ensure the idempotency of your
      listings. This helps to avoid duplicate listings. For more information, see `Ensuring
      Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **ExcessCapacityTerminationPolicy** *(string) --*

      Indicates whether running Spot Instances should be terminated if you decrease the
      target capacity of the Spot Fleet request below the current size of the Spot Fleet.

    - **FulfilledCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target capacity. You
      cannot set this value.

    - **OnDemandFulfilledCapacity** *(float) --*

      The number of On-Demand units fulfilled by this request compared to the set target
      On-Demand capacity.

    - **IamFleetRole** *(string) --*

      The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
      grants the Spot Fleet the permission to request, launch, terminate, and tag instances
      on your behalf. For more information, see `Spot Fleet Prerequisites
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
      in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
      Instances on your behalf when you cancel its Spot Fleet request using
      CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
      ``TerminateInstancesWithExpiration`` .

    - **LaunchSpecifications** *(list) --*

      The launch specifications for the Spot Fleet request. If you specify
      ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
      On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes the launch specification for one or more Spot Instances. If you include
        On-Demand capacity in your fleet request, you can't use
        ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
        .

        - **SecurityGroups** *(list) --*

          One or more security groups. When requesting instances in a VPC, you must specify
          the IDs of the security groups. When requesting instances in EC2-Classic, you can
          specify the names or the IDs of the security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **AddressingType** *(string) --*

          Deprecated.

        - **BlockDeviceMappings** *(list) --*

          One or more block devices that are mapped to the Spot Instances. You can't specify
          both a snapshot ID and an encryption value. This is because only blank volumes can
          be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
          and its encryption status is used for the volume encryption status.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **VirtualName** *(string) --*

              The virtual device name (``ephemeral`` N). Instance store volumes are numbered
              starting from 0. An instance type with 2 available instance store volumes can
              specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
              available instance store volumes depends on the instance type. After you
              connect to the instance, you must mount the volume.

              NVMe instance store volumes are automatically enumerated and assigned a device
              name. Including them in your block device mapping has no effect.

              Constraints: For M3 instances, you must specify instance store volumes in the
              block device mapping for the instance. When you launch an M3 instance, we
              ignore any instance store volumes specified in the block device mapping for the
              AMI.

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is
              launched.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the EBS volume is deleted on instance termination. For more
                information, see `Preserving Amazon EBS Volumes on Instance Termination
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                in the Amazon Elastic Compute Cloud User Guide.

              - **Iops** *(integer) --*

                The number of I/O operations per second (IOPS) that the volume supports. For
                ``io1`` volumes, this represents the number of IOPS that are provisioned for
                the volume. For ``gp2`` volumes, this represents the baseline performance of
                the volume and the rate at which the volume accumulates I/O credits for
                bursting. For more information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                64,000 is guaranteed only on `Nitro-based instances
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                . Other instance families guarantee performance up to 32,000 IOPS. For more
                information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                Condition: This parameter is required for requests to create ``io1`` volumes;
                it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                ``standard`` volumes.

              - **SnapshotId** *(string) --*

                The ID of the snapshot.

              - **VolumeSize** *(integer) --*

                The size of the volume, in GiB.

                Default: If you're creating the volume from a snapshot and don't specify a
                volume size, the default is the snapshot size.

                Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                equal to or larger than the snapshot size.

              - **VolumeType** *(string) --*

                The volume type. If you set the type to ``io1`` , you must also specify the
                IOPS that the volume supports.

                Default: ``gp2``

              - **Encrypted** *(boolean) --*

                Indicates whether the encryption state of an EBS volume is changed while
                being restored from a backing snapshot. The effect of setting the encryption
                state to ``true`` depends on the volume origin (new or from a snapshot),
                starting encryption state, ownership, and whether encryption by default is
                enabled. For more information, see `Amazon EBS Encryption
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                In no case can you remove encryption from an encrypted volume.

                Encrypted volumes can only be attached to instances that support Amazon EBS
                encryption. For more information, see `Supported Instance Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                .

              - **KmsKeyId** *(string) --*

                Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                CMK under which the EBS volume is encrypted.

                This parameter is only supported on ``BlockDeviceMapping`` objects called by
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                , `RequestSpotFleet
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                , and `RequestSpotInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                .

            - **NoDevice** *(string) --*

              Suppresses the specified device included in the block device mapping of the AMI.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instances are optimized for EBS I/O. This optimization
          provides dedicated throughput to Amazon EBS and an optimized configuration stack to
          provide optimal EBS I/O performance. This optimization isn't available with all
          instance types. Additional usage charges apply when using an EBS Optimized instance.

          Default: ``false``

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Name** *(string) --*

            The name of the instance profile.

        - **ImageId** *(string) --*

          The ID of the AMI.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The ID of the kernel.

        - **KeyName** *(string) --*

          The name of the key pair.

        - **Monitoring** *(dict) --*

          Enable or disable monitoring for the instances.

          - **Enabled** *(boolean) --*

            Enables monitoring for the instance.

            Default: ``false``

        - **NetworkInterfaces** *(list) --*

          One or more network interfaces. If you specify a network interface, you must
          specify subnet IDs and security group IDs using the network interface.

          - *(dict) --*

            Describes a network interface.

            - **AssociatePublicIpAddress** *(boolean) --*

              Indicates whether to assign a public IPv4 address to an instance you launch in
              a VPC. The public IP address can only be assigned to a network interface for
              eth0, and can only be assigned to a new network interface, not an existing one.
              You cannot specify more than one network interface in the request. If launching
              into a default subnet, the default value is ``true`` .

            - **DeleteOnTermination** *(boolean) --*

              If set to ``true`` , the interface is deleted when the instance is terminated.
              You can specify ``true`` only if creating a new network interface when
              launching an instance.

            - **Description** *(string) --*

              The description of the network interface. Applies only if creating a network
              interface when launching an instance.

            - **DeviceIndex** *(integer) --*

              The position of the network interface in the attachment order. A primary
              network interface has a device index of 0.

              If you specify a network interface when launching an instance, you must specify
              the device index.

            - **Groups** *(list) --*

              The IDs of the security groups for the network interface. Applies only if
              creating a network interface when launching an instance.

              - *(string) --*

            - **Ipv6AddressCount** *(integer) --*

              A number of IPv6 addresses to assign to the network interface. Amazon EC2
              chooses the IPv6 addresses from the range of the subnet. You cannot specify
              this option and the option to assign specific IPv6 addresses in the same
              request. You can specify this option if you've specified a minimum number of
              instances to launch.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses to assign to the network interface. You cannot
              specify this option and the option to assign a number of IPv6 addresses in the
              same request. You cannot specify this option if you've specified a minimum
              number of instances to launch.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface. Applies only if creating a
              network interface when launching an instance. You cannot specify this option if
              you're launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses to assign to the network interface. Only one
              private IPv4 address can be designated as primary. You cannot specify this
              option if you're launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

              - *(dict) --*

                Describes a secondary private IPv4 address for a network interface.

                - **Primary** *(boolean) --*

                  Indicates whether the private IPv4 address is the primary private IPv4
                  address. Only one IPv4 address can be designated as primary.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 addresses.

            - **SecondaryPrivateIpAddressCount** *(integer) --*

              The number of secondary private IPv4 addresses. You can't specify this option
              and specify more than one private IP address using the private IP addresses
              option. You cannot specify this option if you're launching more than one
              instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **SubnetId** *(string) --*

              The ID of the subnet associated with the network interface. Applies only if
              creating a network interface when launching an instance.

            - **InterfaceType** *(string) --*

              The type of network interface. To create an Elastic Fabric Adapter (EFA),
              specify ``efa`` . For more information, see `Elastic Fabric Adapter
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
              *Amazon Elastic Compute Cloud User Guide* .

              If you are not creating an EFA, specify ``interface`` or omit this parameter.

              Valid values: ``interface`` | ``efa``

        - **Placement** *(dict) --*

          The placement information.

          - **AvailabilityZone** *(string) --*

            The Availability Zone.

            [Spot Fleet only] To specify multiple Availability Zones, separate them using
            commas; for example, "us-west-2a, us-west-2b".

          - **GroupName** *(string) --*

            The name of the placement group.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance
            with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
            tenancy is not supported for Spot Instances.

        - **RamdiskId** *(string) --*

          The ID of the RAM disk. Some kernels require additional drivers at launch. Check
          the kernel requirements for information about whether you need to specify a RAM
          disk. To find kernel requirements, refer to the AWS Resource Center and search for
          the kernel ID.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance. If
          this value is not specified, the default is the Spot price specified for the fleet.
          To determine the Spot price per unit hour, divide the Spot price by the value of
          ``WeightedCapacity`` .

        - **SubnetId** *(string) --*

          The IDs of the subnets in which to launch the instances. To specify multiple
          subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
          subnet-0987cdef6example2".

        - **UserData** *(string) --*

          The Base64-encoded user data that instances use when starting up.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type. These are the same
          units that you chose to set the target capacity in terms of instances, or a
          performance characteristic such as vCPUs, memory, or I/O.

          If the target capacity divided by this value is not a whole number, Amazon EC2
          rounds the number of instances to the next whole number. If this value is not
          specified, the default is 1.

        - **TagSpecifications** *(list) --*

          The tags to apply during creation.

          - *(dict) --*

            The tags for a Spot Fleet resource.

            - **ResourceType** *(string) --*

              The type of resource. Currently, the only resource type that is supported is
              ``instance`` .

            - **Tags** *(list) --*

              The tags.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127
                  Unicode characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255
                  Unicode characters.

    - **LaunchTemplateConfigs** *(list) --*

      The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
      specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
      you must use ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes a launch template and overrides.

        - **LaunchTemplateSpecification** *(dict) --*

          The launch template.

          - **LaunchTemplateId** *(string) --*

            The ID of the launch template. You must specify either a template ID or a
            template name.

          - **LaunchTemplateName** *(string) --*

            The name of the launch template. You must specify either a template name or a
            template ID.

          - **Version** *(string) --*

            The version number of the launch template. You must specify a version number.

        - **Overrides** *(list) --*

          Any parameters that you specify override the same parameters in the launch template.

          - *(dict) --*

            Describes overrides for a launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **SpotPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If
              **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
              priority to determine which launch template override to use first in fulfilling
              On-Demand capacity. The highest priority is launched first. Valid values are
              whole numbers starting at ``0`` . The lower the number, the higher the
              priority. If no number is set, the launch template override has the lowest
              priority.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. The
      default is the On-Demand price.

    - **TargetCapacity** *(integer) --*

      The number of units to request for the Spot Fleet. You can choose to set the target
      capacity in terms of instances or a performance characteristic that is important to
      your application workload, such as vCPUs, memory, or I/O. If the request type is
      ``maintain`` , you can specify a target capacity of 0 and add capacity later.

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request. You can choose to set the target capacity in
      terms of instances or a performance characteristic that is important to your
      application workload, such as vCPUs, memory, or I/O. If the request type is
      ``maintain`` , you can specify a target capacity of 0 and add capacity later.

    - **OnDemandMaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
      use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
      both parameters to ensure that your fleet cost does not exceed your budget. If you set
      a maximum price per hour for the On-Demand Instances and Spot Instances in your
      request, Spot Fleet will launch instances until it reaches the maximum amount you're
      willing to pay. When the maximum amount you're willing to pay is reached, the fleet
      stops launching instances even if it hasn’t met the target capacity.

    - **SpotMaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay. You can use
      the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
      parameters to ensure that your fleet cost does not exceed your budget. If you set a
      maximum price per hour for the On-Demand Instances and Spot Instances in your request,
      Spot Fleet will launch instances until it reaches the maximum amount you're willing to
      pay. When the maximum amount you're willing to pay is reached, the fleet stops
      launching instances even if it hasn’t met the target capacity.

    - **TerminateInstancesWithExpiration** *(boolean) --*

      Indicates whether running Spot Instances are terminated when the Spot Fleet request
      expires.

    - **Type** *(string) --*

      The type of request. Indicates whether the Spot Fleet only requests the target capacity
      or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
      places the required requests. It does not attempt to replenish Spot Instances if
      capacity is diminished, nor does it submit requests in alternative Spot pools if
      capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
      the target capacity. The Spot Fleet places the required requests to meet capacity and
      automatically replenishes any interrupted instances. Default: ``maintain`` .
      ``instant`` is listed but is not used by Spot Fleet.

    - **ValidFrom** *(datetime) --*

      The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

    - **ValidUntil** *(datetime) --*

      The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
      to fulfill the request. If no value is specified, the Spot Fleet request remains until
      you cancel it.

    - **ReplaceUnhealthyInstances** *(boolean) --*

      Indicates whether Spot Fleet should replace unhealthy instances.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **LoadBalancersConfig** *(dict) --*

      One or more Classic Load Balancers and target groups to attach to the Spot Fleet
      request. Spot Fleet registers the running Spot Instances with the specified Classic
      Load Balancers and target groups.

      With Network Load Balancers, Spot Fleet cannot register instances that have the
      following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
      M3, and T1.

      - **ClassicLoadBalancersConfig** *(dict) --*

        The Classic Load Balancers.

        - **ClassicLoadBalancers** *(list) --*

          One or more Classic Load Balancers.

          - *(dict) --*

            Describes a Classic Load Balancer.

            - **Name** *(string) --*

              The name of the load balancer.

      - **TargetGroupsConfig** *(dict) --*

        The target groups.

        - **TargetGroups** *(list) --*

          One or more target groups.

          - *(dict) --*

            Describes a load balancer target group.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the target group.

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only
      when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
      cheapest Spot pools and evenly allocates your target Spot capacity across the number of
      Spot pools that you specify.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef",
    {
        "ActivityStatus": str,
        "CreateTime": datetime,
        "SpotFleetRequestConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef,
        "SpotFleetRequestId": str,
        "SpotFleetRequestState": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequestsResponse` `SpotFleetRequestConfigs`

    Describes a Spot Fleet request.

    - **ActivityStatus** *(string) --*

      The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
      After all requests are placed, the status is ``pending_fulfillment`` . If the size of the
      fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If
      the size of the fleet is decreased, the status is ``pending_termination`` while Spot
      Instances are terminating.

    - **CreateTime** *(datetime) --*

      The creation date and time of the request.

    - **SpotFleetRequestConfig** *(dict) --*

      The configuration of the Spot Fleet request.

      - **AllocationStrategy** *(string) --*

        Indicates how to allocate the target Spot Instance capacity across the Spot Instance
        pools specified by the Spot Fleet request.

        If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
        Spot Instance pools with the lowest price. This is the default allocation strategy.

        If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
        the Spot Instance pools that you specify.

        If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
        from Spot Instance pools with optimal capacity for the number of instances that are
        launching.

      - **OnDemandAllocationStrategy** *(string) --*

        The order of the launch template overrides to use in fulfilling On-Demand capacity. If
        you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
        the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
        that you assign to each Spot Fleet launch template override, launching the highest
        priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

      - **ClientToken** *(string) --*

        A unique, case-sensitive identifier that you provide to ensure the idempotency of your
        listings. This helps to avoid duplicate listings. For more information, see `Ensuring
        Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
        .

      - **ExcessCapacityTerminationPolicy** *(string) --*

        Indicates whether running Spot Instances should be terminated if you decrease the
        target capacity of the Spot Fleet request below the current size of the Spot Fleet.

      - **FulfilledCapacity** *(float) --*

        The number of units fulfilled by this request compared to the set target capacity. You
        cannot set this value.

      - **OnDemandFulfilledCapacity** *(float) --*

        The number of On-Demand units fulfilled by this request compared to the set target
        On-Demand capacity.

      - **IamFleetRole** *(string) --*

        The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
        grants the Spot Fleet the permission to request, launch, terminate, and tag instances
        on your behalf. For more information, see `Spot Fleet Prerequisites
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
        in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
        Instances on your behalf when you cancel its Spot Fleet request using
        CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
        ``TerminateInstancesWithExpiration`` .

      - **LaunchSpecifications** *(list) --*

        The launch specifications for the Spot Fleet request. If you specify
        ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
        On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

        - *(dict) --*

          Describes the launch specification for one or more Spot Instances. If you include
          On-Demand capacity in your fleet request, you can't use
          ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
          .

          - **SecurityGroups** *(list) --*

            One or more security groups. When requesting instances in a VPC, you must specify
            the IDs of the security groups. When requesting instances in EC2-Classic, you can
            specify the names or the IDs of the security groups.

            - *(dict) --*

              Describes a security group.

              - **GroupName** *(string) --*

                The name of the security group.

              - **GroupId** *(string) --*

                The ID of the security group.

          - **AddressingType** *(string) --*

            Deprecated.

          - **BlockDeviceMappings** *(list) --*

            One or more block devices that are mapped to the Spot Instances. You can't specify
            both a snapshot ID and an encryption value. This is because only blank volumes can
            be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
            and its encryption status is used for the volume encryption status.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

              - **VirtualName** *(string) --*

                The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                starting from 0. An instance type with 2 available instance store volumes can
                specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
                available instance store volumes depends on the instance type. After you
                connect to the instance, you must mount the volume.

                NVMe instance store volumes are automatically enumerated and assigned a device
                name. Including them in your block device mapping has no effect.

                Constraints: For M3 instances, you must specify instance store volumes in the
                block device mapping for the instance. When you launch an M3 instance, we
                ignore any instance store volumes specified in the block device mapping for the
                AMI.

              - **Ebs** *(dict) --*

                Parameters used to automatically set up EBS volumes when the instance is
                launched.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination. For more
                  information, see `Preserving Amazon EBS Volumes on Instance Termination
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                  in the Amazon Elastic Compute Cloud User Guide.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports. For
                  ``io1`` volumes, this represents the number of IOPS that are provisioned for
                  the volume. For ``gp2`` volumes, this represents the baseline performance of
                  the volume and the rate at which the volume accumulates I/O credits for
                  bursting. For more information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                  64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                  64,000 is guaranteed only on `Nitro-based instances
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                  . Other instance families guarantee performance up to 32,000 IOPS. For more
                  information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  Condition: This parameter is required for requests to create ``io1`` volumes;
                  it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                  ``standard`` volumes.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                  Default: If you're creating the volume from a snapshot and don't specify a
                  volume size, the default is the snapshot size.

                  Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                  Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                  (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                  (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                  equal to or larger than the snapshot size.

                - **VolumeType** *(string) --*

                  The volume type. If you set the type to ``io1`` , you must also specify the
                  IOPS that the volume supports.

                  Default: ``gp2``

                - **Encrypted** *(boolean) --*

                  Indicates whether the encryption state of an EBS volume is changed while
                  being restored from a backing snapshot. The effect of setting the encryption
                  state to ``true`` depends on the volume origin (new or from a snapshot),
                  starting encryption state, ownership, and whether encryption by default is
                  enabled. For more information, see `Amazon EBS Encryption
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  In no case can you remove encryption from an encrypted volume.

                  Encrypted volumes can only be attached to instances that support Amazon EBS
                  encryption. For more information, see `Supported Instance Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                  .

                - **KmsKeyId** *(string) --*

                  Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                  CMK under which the EBS volume is encrypted.

                  This parameter is only supported on ``BlockDeviceMapping`` objects called by
                  `RunInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                  , `RequestSpotFleet
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                  , and `RequestSpotInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                  .

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instances are optimized for EBS I/O. This optimization
            provides dedicated throughput to Amazon EBS and an optimized configuration stack to
            provide optimal EBS I/O performance. This optimization isn't available with all
            instance types. Additional usage charges apply when using an EBS Optimized instance.

            Default: ``false``

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **ImageId** *(string) --*

            The ID of the AMI.

          - **InstanceType** *(string) --*

            The instance type.

          - **KernelId** *(string) --*

            The ID of the kernel.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **Monitoring** *(dict) --*

            Enable or disable monitoring for the instances.

            - **Enabled** *(boolean) --*

              Enables monitoring for the instance.

              Default: ``false``

          - **NetworkInterfaces** *(list) --*

            One or more network interfaces. If you specify a network interface, you must
            specify subnet IDs and security group IDs using the network interface.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to assign a public IPv4 address to an instance you launch in
                a VPC. The public IP address can only be assigned to a network interface for
                eth0, and can only be assigned to a new network interface, not an existing one.
                You cannot specify more than one network interface in the request. If launching
                into a default subnet, the default value is ``true`` .

              - **DeleteOnTermination** *(boolean) --*

                If set to ``true`` , the interface is deleted when the instance is terminated.
                You can specify ``true`` only if creating a new network interface when
                launching an instance.

              - **Description** *(string) --*

                The description of the network interface. Applies only if creating a network
                interface when launching an instance.

              - **DeviceIndex** *(integer) --*

                The position of the network interface in the attachment order. A primary
                network interface has a device index of 0.

                If you specify a network interface when launching an instance, you must specify
                the device index.

              - **Groups** *(list) --*

                The IDs of the security groups for the network interface. Applies only if
                creating a network interface when launching an instance.

                - *(string) --*

              - **Ipv6AddressCount** *(integer) --*

                A number of IPv6 addresses to assign to the network interface. Amazon EC2
                chooses the IPv6 addresses from the range of the subnet. You cannot specify
                this option and the option to assign specific IPv6 addresses in the same
                request. You can specify this option if you've specified a minimum number of
                instances to launch.

              - **Ipv6Addresses** *(list) --*

                One or more IPv6 addresses to assign to the network interface. You cannot
                specify this option and the option to assign a number of IPv6 addresses in the
                same request. You cannot specify this option if you've specified a minimum
                number of instances to launch.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 address of the network interface. Applies only if creating a
                network interface when launching an instance. You cannot specify this option if
                you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses to assign to the network interface. Only one
                private IPv4 address can be designated as primary. You cannot specify this
                option if you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4
                    address. Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses. You can't specify this option
                and specify more than one private IP address using the private IP addresses
                option. You cannot specify this option if you're launching more than one
                instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **SubnetId** *(string) --*

                The ID of the subnet associated with the network interface. Applies only if
                creating a network interface when launching an instance.

              - **InterfaceType** *(string) --*

                The type of network interface. To create an Elastic Fabric Adapter (EFA),
                specify ``efa`` . For more information, see `Elastic Fabric Adapter
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                If you are not creating an EFA, specify ``interface`` or omit this parameter.

                Valid values: ``interface`` | ``efa``

          - **Placement** *(dict) --*

            The placement information.

            - **AvailabilityZone** *(string) --*

              The Availability Zone.

              [Spot Fleet only] To specify multiple Availability Zones, separate them using
              commas; for example, "us-west-2a, us-west-2b".

            - **GroupName** *(string) --*

              The name of the placement group.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance
              with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
              tenancy is not supported for Spot Instances.

          - **RamdiskId** *(string) --*

            The ID of the RAM disk. Some kernels require additional drivers at launch. Check
            the kernel requirements for information about whether you need to specify a RAM
            disk. To find kernel requirements, refer to the AWS Resource Center and search for
            the kernel ID.

          - **SpotPrice** *(string) --*

            The maximum price per unit hour that you are willing to pay for a Spot Instance. If
            this value is not specified, the default is the Spot price specified for the fleet.
            To determine the Spot price per unit hour, divide the Spot price by the value of
            ``WeightedCapacity`` .

          - **SubnetId** *(string) --*

            The IDs of the subnets in which to launch the instances. To specify multiple
            subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
            subnet-0987cdef6example2".

          - **UserData** *(string) --*

            The Base64-encoded user data that instances use when starting up.

          - **WeightedCapacity** *(float) --*

            The number of units provided by the specified instance type. These are the same
            units that you chose to set the target capacity in terms of instances, or a
            performance characteristic such as vCPUs, memory, or I/O.

            If the target capacity divided by this value is not a whole number, Amazon EC2
            rounds the number of instances to the next whole number. If this value is not
            specified, the default is 1.

          - **TagSpecifications** *(list) --*

            The tags to apply during creation.

            - *(dict) --*

              The tags for a Spot Fleet resource.

              - **ResourceType** *(string) --*

                The type of resource. Currently, the only resource type that is supported is
                ``instance`` .

              - **Tags** *(list) --*

                The tags.

                - *(dict) --*

                  Describes a tag.

                  - **Key** *(string) --*

                    The key of the tag.

                    Constraints: Tag keys are case-sensitive and accept a maximum of 127
                    Unicode characters. May not begin with ``aws:`` .

                  - **Value** *(string) --*

                    The value of the tag.

                    Constraints: Tag values are case-sensitive and accept a maximum of 255
                    Unicode characters.

      - **LaunchTemplateConfigs** *(list) --*

        The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
        specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
        you must use ``LaunchTemplateConfigs`` .

        - *(dict) --*

          Describes a launch template and overrides.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(list) --*

            Any parameters that you specify override the same parameters in the launch template.

            - *(dict) --*

              Describes overrides for a launch template.

              - **InstanceType** *(string) --*

                The instance type.

              - **SpotPrice** *(string) --*

                The maximum price per unit hour that you are willing to pay for a Spot Instance.

              - **SubnetId** *(string) --*

                The ID of the subnet in which to launch the instances.

              - **AvailabilityZone** *(string) --*

                The Availability Zone in which to launch the instances.

              - **WeightedCapacity** *(float) --*

                The number of units provided by the specified instance type.

              - **Priority** *(float) --*

                The priority for the launch template override. If
                **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
                priority to determine which launch template override to use first in fulfilling
                On-Demand capacity. The highest priority is launched first. Valid values are
                whole numbers starting at ``0`` . The lower the number, the higher the
                priority. If no number is set, the launch template override has the lowest
                priority.

      - **SpotPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance. The
        default is the On-Demand price.

      - **TargetCapacity** *(integer) --*

        The number of units to request for the Spot Fleet. You can choose to set the target
        capacity in terms of instances or a performance characteristic that is important to
        your application workload, such as vCPUs, memory, or I/O. If the request type is
        ``maintain`` , you can specify a target capacity of 0 and add capacity later.

      - **OnDemandTargetCapacity** *(integer) --*

        The number of On-Demand units to request. You can choose to set the target capacity in
        terms of instances or a performance characteristic that is important to your
        application workload, such as vCPUs, memory, or I/O. If the request type is
        ``maintain`` , you can specify a target capacity of 0 and add capacity later.

      - **OnDemandMaxTotalPrice** *(string) --*

        The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
        use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
        both parameters to ensure that your fleet cost does not exceed your budget. If you set
        a maximum price per hour for the On-Demand Instances and Spot Instances in your
        request, Spot Fleet will launch instances until it reaches the maximum amount you're
        willing to pay. When the maximum amount you're willing to pay is reached, the fleet
        stops launching instances even if it hasn’t met the target capacity.

      - **SpotMaxTotalPrice** *(string) --*

        The maximum amount per hour for Spot Instances that you're willing to pay. You can use
        the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
        parameters to ensure that your fleet cost does not exceed your budget. If you set a
        maximum price per hour for the On-Demand Instances and Spot Instances in your request,
        Spot Fleet will launch instances until it reaches the maximum amount you're willing to
        pay. When the maximum amount you're willing to pay is reached, the fleet stops
        launching instances even if it hasn’t met the target capacity.

      - **TerminateInstancesWithExpiration** *(boolean) --*

        Indicates whether running Spot Instances are terminated when the Spot Fleet request
        expires.

      - **Type** *(string) --*

        The type of request. Indicates whether the Spot Fleet only requests the target capacity
        or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
        places the required requests. It does not attempt to replenish Spot Instances if
        capacity is diminished, nor does it submit requests in alternative Spot pools if
        capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
        the target capacity. The Spot Fleet places the required requests to meet capacity and
        automatically replenishes any interrupted instances. Default: ``maintain`` .
        ``instant`` is listed but is not used by Spot Fleet.

      - **ValidFrom** *(datetime) --*

        The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
        :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

      - **ValidUntil** *(datetime) --*

        The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
        :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
        to fulfill the request. If no value is specified, the Spot Fleet request remains until
        you cancel it.

      - **ReplaceUnhealthyInstances** *(boolean) --*

        Indicates whether Spot Fleet should replace unhealthy instances.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

      - **LoadBalancersConfig** *(dict) --*

        One or more Classic Load Balancers and target groups to attach to the Spot Fleet
        request. Spot Fleet registers the running Spot Instances with the specified Classic
        Load Balancers and target groups.

        With Network Load Balancers, Spot Fleet cannot register instances that have the
        following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
        M3, and T1.

        - **ClassicLoadBalancersConfig** *(dict) --*

          The Classic Load Balancers.

          - **ClassicLoadBalancers** *(list) --*

            One or more Classic Load Balancers.

            - *(dict) --*

              Describes a Classic Load Balancer.

              - **Name** *(string) --*

                The name of the load balancer.

        - **TargetGroupsConfig** *(dict) --*

          The target groups.

          - **TargetGroups** *(list) --*

            One or more target groups.

            - *(dict) --*

              Describes a load balancer target group.

              - **Arn** *(string) --*

                The Amazon Resource Name (ARN) of the target group.

      - **InstancePoolsToUseCount** *(integer) --*

        The number of Spot pools across which to allocate your target Spot capacity. Valid only
        when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
        cheapest Spot pools and evenly allocates your target Spot capacity across the number of
        Spot pools that you specify.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.

    - **SpotFleetRequestState** *(string) --*

      The state of the Spot Fleet request.
    """


_ClientDescribeSpotFleetRequestsResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseTypeDef",
    {
        "NextToken": str,
        "SpotFleetRequestConfigs": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseTypeDef(
    _ClientDescribeSpotFleetRequestsResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotFleetRequests` `Response`

    Contains the output of DescribeSpotFleetRequests.

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.

    - **SpotFleetRequestConfigs** *(list) --*

      Information about the configuration of your Spot Fleet.

      - *(dict) --*

        Describes a Spot Fleet request.

        - **ActivityStatus** *(string) --*

          The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
          After all requests are placed, the status is ``pending_fulfillment`` . If the size of the
          fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If
          the size of the fleet is decreased, the status is ``pending_termination`` while Spot
          Instances are terminating.

        - **CreateTime** *(datetime) --*

          The creation date and time of the request.

        - **SpotFleetRequestConfig** *(dict) --*

          The configuration of the Spot Fleet request.

          - **AllocationStrategy** *(string) --*

            Indicates how to allocate the target Spot Instance capacity across the Spot Instance
            pools specified by the Spot Fleet request.

            If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
            Spot Instance pools with the lowest price. This is the default allocation strategy.

            If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
            the Spot Instance pools that you specify.

            If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
            from Spot Instance pools with optimal capacity for the number of instances that are
            launching.

          - **OnDemandAllocationStrategy** *(string) --*

            The order of the launch template overrides to use in fulfilling On-Demand capacity. If
            you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
            the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
            that you assign to each Spot Fleet launch template override, launching the highest
            priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

          - **ClientToken** *(string) --*

            A unique, case-sensitive identifier that you provide to ensure the idempotency of your
            listings. This helps to avoid duplicate listings. For more information, see `Ensuring
            Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .

          - **ExcessCapacityTerminationPolicy** *(string) --*

            Indicates whether running Spot Instances should be terminated if you decrease the
            target capacity of the Spot Fleet request below the current size of the Spot Fleet.

          - **FulfilledCapacity** *(float) --*

            The number of units fulfilled by this request compared to the set target capacity. You
            cannot set this value.

          - **OnDemandFulfilledCapacity** *(float) --*

            The number of On-Demand units fulfilled by this request compared to the set target
            On-Demand capacity.

          - **IamFleetRole** *(string) --*

            The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
            grants the Spot Fleet the permission to request, launch, terminate, and tag instances
            on your behalf. For more information, see `Spot Fleet Prerequisites
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
            in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
            Instances on your behalf when you cancel its Spot Fleet request using
            CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
            ``TerminateInstancesWithExpiration`` .

          - **LaunchSpecifications** *(list) --*

            The launch specifications for the Spot Fleet request. If you specify
            ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
            On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

            - *(dict) --*

              Describes the launch specification for one or more Spot Instances. If you include
              On-Demand capacity in your fleet request, you can't use
              ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
              .

              - **SecurityGroups** *(list) --*

                One or more security groups. When requesting instances in a VPC, you must specify
                the IDs of the security groups. When requesting instances in EC2-Classic, you can
                specify the names or the IDs of the security groups.

                - *(dict) --*

                  Describes a security group.

                  - **GroupName** *(string) --*

                    The name of the security group.

                  - **GroupId** *(string) --*

                    The ID of the security group.

              - **AddressingType** *(string) --*

                Deprecated.

              - **BlockDeviceMappings** *(list) --*

                One or more block devices that are mapped to the Spot Instances. You can't specify
                both a snapshot ID and an encryption value. This is because only blank volumes can
                be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
                and its encryption status is used for the volume encryption status.

                - *(dict) --*

                  Describes a block device mapping.

                  - **DeviceName** *(string) --*

                    The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

                  - **VirtualName** *(string) --*

                    The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                    starting from 0. An instance type with 2 available instance store volumes can
                    specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
                    available instance store volumes depends on the instance type. After you
                    connect to the instance, you must mount the volume.

                    NVMe instance store volumes are automatically enumerated and assigned a device
                    name. Including them in your block device mapping has no effect.

                    Constraints: For M3 instances, you must specify instance store volumes in the
                    block device mapping for the instance. When you launch an M3 instance, we
                    ignore any instance store volumes specified in the block device mapping for the
                    AMI.

                  - **Ebs** *(dict) --*

                    Parameters used to automatically set up EBS volumes when the instance is
                    launched.

                    - **DeleteOnTermination** *(boolean) --*

                      Indicates whether the EBS volume is deleted on instance termination. For more
                      information, see `Preserving Amazon EBS Volumes on Instance Termination
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                      in the Amazon Elastic Compute Cloud User Guide.

                    - **Iops** *(integer) --*

                      The number of I/O operations per second (IOPS) that the volume supports. For
                      ``io1`` volumes, this represents the number of IOPS that are provisioned for
                      the volume. For ``gp2`` volumes, this represents the baseline performance of
                      the volume and the rate at which the volume accumulates I/O credits for
                      bursting. For more information, see `Amazon EBS Volume Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                      64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                      64,000 is guaranteed only on `Nitro-based instances
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                      . Other instance families guarantee performance up to 32,000 IOPS. For more
                      information, see `Amazon EBS Volume Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      Condition: This parameter is required for requests to create ``io1`` volumes;
                      it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                      ``standard`` volumes.

                    - **SnapshotId** *(string) --*

                      The ID of the snapshot.

                    - **VolumeSize** *(integer) --*

                      The size of the volume, in GiB.

                      Default: If you're creating the volume from a snapshot and don't specify a
                      volume size, the default is the snapshot size.

                      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                      Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                      (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                      (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                      equal to or larger than the snapshot size.

                    - **VolumeType** *(string) --*

                      The volume type. If you set the type to ``io1`` , you must also specify the
                      IOPS that the volume supports.

                      Default: ``gp2``

                    - **Encrypted** *(boolean) --*

                      Indicates whether the encryption state of an EBS volume is changed while
                      being restored from a backing snapshot. The effect of setting the encryption
                      state to ``true`` depends on the volume origin (new or from a snapshot),
                      starting encryption state, ownership, and whether encryption by default is
                      enabled. For more information, see `Amazon EBS Encryption
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      In no case can you remove encryption from an encrypted volume.

                      Encrypted volumes can only be attached to instances that support Amazon EBS
                      encryption. For more information, see `Supported Instance Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                      .

                    - **KmsKeyId** *(string) --*

                      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                      CMK under which the EBS volume is encrypted.

                      This parameter is only supported on ``BlockDeviceMapping`` objects called by
                      `RunInstances
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                      , `RequestSpotFleet
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                      , and `RequestSpotInstances
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                      .

                  - **NoDevice** *(string) --*

                    Suppresses the specified device included in the block device mapping of the AMI.

              - **EbsOptimized** *(boolean) --*

                Indicates whether the instances are optimized for EBS I/O. This optimization
                provides dedicated throughput to Amazon EBS and an optimized configuration stack to
                provide optimal EBS I/O performance. This optimization isn't available with all
                instance types. Additional usage charges apply when using an EBS Optimized instance.

                Default: ``false``

              - **IamInstanceProfile** *(dict) --*

                The IAM instance profile.

                - **Arn** *(string) --*

                  The Amazon Resource Name (ARN) of the instance profile.

                - **Name** *(string) --*

                  The name of the instance profile.

              - **ImageId** *(string) --*

                The ID of the AMI.

              - **InstanceType** *(string) --*

                The instance type.

              - **KernelId** *(string) --*

                The ID of the kernel.

              - **KeyName** *(string) --*

                The name of the key pair.

              - **Monitoring** *(dict) --*

                Enable or disable monitoring for the instances.

                - **Enabled** *(boolean) --*

                  Enables monitoring for the instance.

                  Default: ``false``

              - **NetworkInterfaces** *(list) --*

                One or more network interfaces. If you specify a network interface, you must
                specify subnet IDs and security group IDs using the network interface.

                - *(dict) --*

                  Describes a network interface.

                  - **AssociatePublicIpAddress** *(boolean) --*

                    Indicates whether to assign a public IPv4 address to an instance you launch in
                    a VPC. The public IP address can only be assigned to a network interface for
                    eth0, and can only be assigned to a new network interface, not an existing one.
                    You cannot specify more than one network interface in the request. If launching
                    into a default subnet, the default value is ``true`` .

                  - **DeleteOnTermination** *(boolean) --*

                    If set to ``true`` , the interface is deleted when the instance is terminated.
                    You can specify ``true`` only if creating a new network interface when
                    launching an instance.

                  - **Description** *(string) --*

                    The description of the network interface. Applies only if creating a network
                    interface when launching an instance.

                  - **DeviceIndex** *(integer) --*

                    The position of the network interface in the attachment order. A primary
                    network interface has a device index of 0.

                    If you specify a network interface when launching an instance, you must specify
                    the device index.

                  - **Groups** *(list) --*

                    The IDs of the security groups for the network interface. Applies only if
                    creating a network interface when launching an instance.

                    - *(string) --*

                  - **Ipv6AddressCount** *(integer) --*

                    A number of IPv6 addresses to assign to the network interface. Amazon EC2
                    chooses the IPv6 addresses from the range of the subnet. You cannot specify
                    this option and the option to assign specific IPv6 addresses in the same
                    request. You can specify this option if you've specified a minimum number of
                    instances to launch.

                  - **Ipv6Addresses** *(list) --*

                    One or more IPv6 addresses to assign to the network interface. You cannot
                    specify this option and the option to assign a number of IPv6 addresses in the
                    same request. You cannot specify this option if you've specified a minimum
                    number of instances to launch.

                    - *(dict) --*

                      Describes an IPv6 address.

                      - **Ipv6Address** *(string) --*

                        The IPv6 address.

                  - **NetworkInterfaceId** *(string) --*

                    The ID of the network interface.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 address of the network interface. Applies only if creating a
                    network interface when launching an instance. You cannot specify this option if
                    you're launching more than one instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                  - **PrivateIpAddresses** *(list) --*

                    One or more private IPv4 addresses to assign to the network interface. Only one
                    private IPv4 address can be designated as primary. You cannot specify this
                    option if you're launching more than one instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                    - *(dict) --*

                      Describes a secondary private IPv4 address for a network interface.

                      - **Primary** *(boolean) --*

                        Indicates whether the private IPv4 address is the primary private IPv4
                        address. Only one IPv4 address can be designated as primary.

                      - **PrivateIpAddress** *(string) --*

                        The private IPv4 addresses.

                  - **SecondaryPrivateIpAddressCount** *(integer) --*

                    The number of secondary private IPv4 addresses. You can't specify this option
                    and specify more than one private IP address using the private IP addresses
                    option. You cannot specify this option if you're launching more than one
                    instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                  - **SubnetId** *(string) --*

                    The ID of the subnet associated with the network interface. Applies only if
                    creating a network interface when launching an instance.

                  - **InterfaceType** *(string) --*

                    The type of network interface. To create an Elastic Fabric Adapter (EFA),
                    specify ``efa`` . For more information, see `Elastic Fabric Adapter
                    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
                    *Amazon Elastic Compute Cloud User Guide* .

                    If you are not creating an EFA, specify ``interface`` or omit this parameter.

                    Valid values: ``interface`` | ``efa``

              - **Placement** *(dict) --*

                The placement information.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone.

                  [Spot Fleet only] To specify multiple Availability Zones, separate them using
                  commas; for example, "us-west-2a, us-west-2b".

                - **GroupName** *(string) --*

                  The name of the placement group.

                - **Tenancy** *(string) --*

                  The tenancy of the instance (if the instance is running in a VPC). An instance
                  with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
                  tenancy is not supported for Spot Instances.

              - **RamdiskId** *(string) --*

                The ID of the RAM disk. Some kernels require additional drivers at launch. Check
                the kernel requirements for information about whether you need to specify a RAM
                disk. To find kernel requirements, refer to the AWS Resource Center and search for
                the kernel ID.

              - **SpotPrice** *(string) --*

                The maximum price per unit hour that you are willing to pay for a Spot Instance. If
                this value is not specified, the default is the Spot price specified for the fleet.
                To determine the Spot price per unit hour, divide the Spot price by the value of
                ``WeightedCapacity`` .

              - **SubnetId** *(string) --*

                The IDs of the subnets in which to launch the instances. To specify multiple
                subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
                subnet-0987cdef6example2".

              - **UserData** *(string) --*

                The Base64-encoded user data that instances use when starting up.

              - **WeightedCapacity** *(float) --*

                The number of units provided by the specified instance type. These are the same
                units that you chose to set the target capacity in terms of instances, or a
                performance characteristic such as vCPUs, memory, or I/O.

                If the target capacity divided by this value is not a whole number, Amazon EC2
                rounds the number of instances to the next whole number. If this value is not
                specified, the default is 1.

              - **TagSpecifications** *(list) --*

                The tags to apply during creation.

                - *(dict) --*

                  The tags for a Spot Fleet resource.

                  - **ResourceType** *(string) --*

                    The type of resource. Currently, the only resource type that is supported is
                    ``instance`` .

                  - **Tags** *(list) --*

                    The tags.

                    - *(dict) --*

                      Describes a tag.

                      - **Key** *(string) --*

                        The key of the tag.

                        Constraints: Tag keys are case-sensitive and accept a maximum of 127
                        Unicode characters. May not begin with ``aws:`` .

                      - **Value** *(string) --*

                        The value of the tag.

                        Constraints: Tag values are case-sensitive and accept a maximum of 255
                        Unicode characters.

          - **LaunchTemplateConfigs** *(list) --*

            The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
            specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
            you must use ``LaunchTemplateConfigs`` .

            - *(dict) --*

              Describes a launch template and overrides.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(list) --*

                Any parameters that you specify override the same parameters in the launch template.

                - *(dict) --*

                  Describes overrides for a launch template.

                  - **InstanceType** *(string) --*

                    The instance type.

                  - **SpotPrice** *(string) --*

                    The maximum price per unit hour that you are willing to pay for a Spot Instance.

                  - **SubnetId** *(string) --*

                    The ID of the subnet in which to launch the instances.

                  - **AvailabilityZone** *(string) --*

                    The Availability Zone in which to launch the instances.

                  - **WeightedCapacity** *(float) --*

                    The number of units provided by the specified instance type.

                  - **Priority** *(float) --*

                    The priority for the launch template override. If
                    **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
                    priority to determine which launch template override to use first in fulfilling
                    On-Demand capacity. The highest priority is launched first. Valid values are
                    whole numbers starting at ``0`` . The lower the number, the higher the
                    priority. If no number is set, the launch template override has the lowest
                    priority.

          - **SpotPrice** *(string) --*

            The maximum price per unit hour that you are willing to pay for a Spot Instance. The
            default is the On-Demand price.

          - **TargetCapacity** *(integer) --*

            The number of units to request for the Spot Fleet. You can choose to set the target
            capacity in terms of instances or a performance characteristic that is important to
            your application workload, such as vCPUs, memory, or I/O. If the request type is
            ``maintain`` , you can specify a target capacity of 0 and add capacity later.

          - **OnDemandTargetCapacity** *(integer) --*

            The number of On-Demand units to request. You can choose to set the target capacity in
            terms of instances or a performance characteristic that is important to your
            application workload, such as vCPUs, memory, or I/O. If the request type is
            ``maintain`` , you can specify a target capacity of 0 and add capacity later.

          - **OnDemandMaxTotalPrice** *(string) --*

            The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
            use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
            both parameters to ensure that your fleet cost does not exceed your budget. If you set
            a maximum price per hour for the On-Demand Instances and Spot Instances in your
            request, Spot Fleet will launch instances until it reaches the maximum amount you're
            willing to pay. When the maximum amount you're willing to pay is reached, the fleet
            stops launching instances even if it hasn’t met the target capacity.

          - **SpotMaxTotalPrice** *(string) --*

            The maximum amount per hour for Spot Instances that you're willing to pay. You can use
            the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
            parameters to ensure that your fleet cost does not exceed your budget. If you set a
            maximum price per hour for the On-Demand Instances and Spot Instances in your request,
            Spot Fleet will launch instances until it reaches the maximum amount you're willing to
            pay. When the maximum amount you're willing to pay is reached, the fleet stops
            launching instances even if it hasn’t met the target capacity.

          - **TerminateInstancesWithExpiration** *(boolean) --*

            Indicates whether running Spot Instances are terminated when the Spot Fleet request
            expires.

          - **Type** *(string) --*

            The type of request. Indicates whether the Spot Fleet only requests the target capacity
            or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
            places the required requests. It does not attempt to replenish Spot Instances if
            capacity is diminished, nor does it submit requests in alternative Spot pools if
            capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
            the target capacity. The Spot Fleet places the required requests to meet capacity and
            automatically replenishes any interrupted instances. Default: ``maintain`` .
            ``instant`` is listed but is not used by Spot Fleet.

          - **ValidFrom** *(datetime) --*

            The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
            :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

          - **ValidUntil** *(datetime) --*

            The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
            :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
            to fulfill the request. If no value is specified, the Spot Fleet request remains until
            you cancel it.

          - **ReplaceUnhealthyInstances** *(boolean) --*

            Indicates whether Spot Fleet should replace unhealthy instances.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

          - **LoadBalancersConfig** *(dict) --*

            One or more Classic Load Balancers and target groups to attach to the Spot Fleet
            request. Spot Fleet registers the running Spot Instances with the specified Classic
            Load Balancers and target groups.

            With Network Load Balancers, Spot Fleet cannot register instances that have the
            following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
            M3, and T1.

            - **ClassicLoadBalancersConfig** *(dict) --*

              The Classic Load Balancers.

              - **ClassicLoadBalancers** *(list) --*

                One or more Classic Load Balancers.

                - *(dict) --*

                  Describes a Classic Load Balancer.

                  - **Name** *(string) --*

                    The name of the load balancer.

            - **TargetGroupsConfig** *(dict) --*

              The target groups.

              - **TargetGroups** *(list) --*

                One or more target groups.

                - *(dict) --*

                  Describes a load balancer target group.

                  - **Arn** *(string) --*

                    The Amazon Resource Name (ARN) of the target group.

          - **InstancePoolsToUseCount** *(integer) --*

            The number of Spot pools across which to allocate your target Spot capacity. Valid only
            when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
            cheapest Spot pools and evenly allocates your target Spot capacity across the number of
            Spot pools that you specify.

        - **SpotFleetRequestId** *(string) --*

          The ID of the Spot Fleet request.

        - **SpotFleetRequestState** *(string) --*

          The state of the Spot Fleet request.
    """


_ClientDescribeSpotInstanceRequestsFiltersTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSpotInstanceRequestsFiltersTypeDef(
    _ClientDescribeSpotInstanceRequestsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequests` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequests` `Fault`

    The fault codes for the Spot Instance request, if any.

    - **Code** *(string) --*

      The reason code for the Spot Instance state change.

    - **Message** *(string) --*

      The message for the Spot Instance state change.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for the
      volume. For ``gp2`` volumes, this represents the baseline performance of the
      volume and the rate at which the volume accumulates I/O credits for bursting. For
      more information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
      for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
      only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it
      is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
      volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume
      size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
      IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
      for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
      specify a snapshot, the volume size must be equal to or larger than the snapshot
      size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS
      that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being
      restored from a backing snapshot. The effect of setting the encryption state to
      ``true`` depends on the volume origin (new or from a snapshot), starting
      encryption state, ownership, and whether encryption by default is enabled. For
      more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
      under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      , `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can
      specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
      instance store volumes depends on the instance type. After you connect to the
      instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device
      name. Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any
      instance store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for the
        volume. For ``gp2`` volumes, this represents the baseline performance of the
        volume and the rate at which the volume accumulates I/O credits for bursting. For
        more information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
        for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
        only on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it
        is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
        volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume
        size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
        IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
        for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
        specify a snapshot, the volume size must be equal to or larger than the snapshot
        size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS
        that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being
        restored from a backing snapshot. The effect of setting the encryption state to
        ``true`` depends on the volume origin (new or from a snapshot), starting
        encryption state, ownership, and whether encryption by default is enabled. For
        more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
        under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
        , `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `Monitoring`

    Describes the monitoring of an instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a
      VPC. The public IP address can only be assigned to a network interface for eth0,
      and can only be assigned to a new network interface, not an existing one. You
      cannot specify more than one network interface in the request. If launching into a
      default subnet, the default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You
      can specify ``true`` only if creating a new network interface when launching an
      instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network
      interface when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network
      interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the
      device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating
      a network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
      the IPv6 addresses from the range of the subnet. You cannot specify this option and
      the option to assign specific IPv6 addresses in the same request. You can specify
      this option if you've specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify
      this option and the option to assign a number of IPv6 addresses in the same
      request. You cannot specify this option if you've specified a minimum number of
      instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a
      network interface when launching an instance. You cannot specify this option if
      you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one
      private IPv4 address can be designated as primary. You cannot specify this option
      if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and
      specify more than one private IP address using the private IP addresses option. You
      cannot specify this option if you're launching more than one instance in a
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if
      creating a network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
      ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `Placement`

    The placement information for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
      for example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for Spot Instances.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecification` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequests` `LaunchSpecification`

    Additional information for launching instances.

    - **UserData** *(string) --*

      The Base64-encoded user data for the instance.

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify the
      IDs of the security groups. When requesting instances in EC2-Classic, you can specify
      the names or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can
          specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
          instance store volumes depends on the instance type. After you connect to the
          instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device
          name. Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any
          instance store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for the
            volume. For ``gp2`` volumes, this represents the baseline performance of the
            volume and the rate at which the volume accumulates I/O credits for bursting. For
            more information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
            for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
            only on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it
            is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
            volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume
            size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
            IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
            for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
            specify a snapshot, the volume size must be equal to or larger than the snapshot
            size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS
            that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being
            restored from a backing snapshot. The effect of setting the encryption state to
            ``true`` depends on the volume origin (new or from a snapshot), starting
            encryption state, ownership, and whether encryption by default is enabled. For
            more information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
            under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            , `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide
      optimal EBS I/O performance. This optimization isn't available with all instance types.
      Additional usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify
      subnet IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in a
          VPC. The public IP address can only be assigned to a network interface for eth0,
          and can only be assigned to a new network interface, not an existing one. You
          cannot specify more than one network interface in the request. If launching into a
          default subnet, the default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated. You
          can specify ``true`` only if creating a new network interface when launching an
          instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network
          interface when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary network
          interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify the
          device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if creating
          a network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
          the IPv6 addresses from the range of the subnet. You cannot specify this option and
          the option to assign specific IPv6 addresses in the same request. You can specify
          this option if you've specified a minimum number of instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot specify
          this option and the option to assign a number of IPv6 addresses in the same
          request. You cannot specify this option if you've specified a minimum number of
          instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a
          network interface when launching an instance. You cannot specify this option if
          you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one
          private IPv4 address can be designated as primary. You cannot specify this option
          if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option and
          specify more than one private IP address using the private IP addresses option. You
          cannot specify this option if you're launching more than one instance in a
          `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if
          creating a network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
          ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
          Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
        for example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instance.

    - **Monitoring** *(dict) --*

      Describes the monitoring of an instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequests` `Status`

    The status code and status message describing the Spot Instance request.

    - **Code** *(string) --*

      The status code. For a list of status codes, see `Spot Status Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
      in the *Amazon EC2 User Guide for Linux Instances* .

    - **Message** *(string) --*

      The description for the status code.

    - **UpdateTime** *(datetime) --*

      The date and time of the most recent status update, in UTC format (for example, *YYYY*
      -*MM* -*DD* T*HH* :*MM* :*SS* Z).
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequests` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": str,
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": str,
        "Status": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef
        ],
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequestsResponse` `SpotInstanceRequests`

    Describes a Spot Instance request.

    - **ActualBlockHourlyPrice** *(string) --*

      If you specified a duration and your Spot Instance request was fulfilled, this is the
      fixed hourly price in effect for the Spot Instance while it runs.

    - **AvailabilityZoneGroup** *(string) --*

      The Availability Zone group. If you specify the same Availability Zone group for all Spot
      Instance requests, all Spot Instances are launched in the same Availability Zone.

    - **BlockDurationMinutes** *(integer) --*

      The duration for the Spot Instance, in minutes.

    - **CreateTime** *(datetime) --*

      The date and time when the Spot Instance request was created, in UTC format (for example,
      *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Fault** *(dict) --*

      The fault codes for the Spot Instance request, if any.

      - **Code** *(string) --*

        The reason code for the Spot Instance state change.

      - **Message** *(string) --*

        The message for the Spot Instance state change.

    - **InstanceId** *(string) --*

      The instance ID, if an instance has been launched to fulfill the Spot Instance request.

    - **LaunchGroup** *(string) --*

      The instance launch group. Launch groups are Spot Instances that launch together and
      terminate together.

    - **LaunchSpecification** *(dict) --*

      Additional information for launching instances.

      - **UserData** *(string) --*

        The Base64-encoded user data for the instance.

      - **SecurityGroups** *(list) --*

        One or more security groups. When requesting instances in a VPC, you must specify the
        IDs of the security groups. When requesting instances in EC2-Classic, you can specify
        the names or the IDs of the security groups.

        - *(dict) --*

          Describes a security group.

          - **GroupName** *(string) --*

            The name of the security group.

          - **GroupId** *(string) --*

            The ID of the security group.

      - **AddressingType** *(string) --*

        Deprecated.

      - **BlockDeviceMappings** *(list) --*

        One or more block device mapping entries.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

          - **VirtualName** *(string) --*

            The virtual device name (``ephemeral`` N). Instance store volumes are numbered
            starting from 0. An instance type with 2 available instance store volumes can
            specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
            instance store volumes depends on the instance type. After you connect to the
            instance, you must mount the volume.

            NVMe instance store volumes are automatically enumerated and assigned a device
            name. Including them in your block device mapping has no effect.

            Constraints: For M3 instances, you must specify instance store volumes in the block
            device mapping for the instance. When you launch an M3 instance, we ignore any
            instance store volumes specified in the block device mapping for the AMI.

          - **Ebs** *(dict) --*

            Parameters used to automatically set up EBS volumes when the instance is launched.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination. For more
              information, see `Preserving Amazon EBS Volumes on Instance Termination
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
              in the Amazon Elastic Compute Cloud User Guide.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports. For
              ``io1`` volumes, this represents the number of IOPS that are provisioned for the
              volume. For ``gp2`` volumes, this represents the baseline performance of the
              volume and the rate at which the volume accumulates I/O credits for bursting. For
              more information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
              for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
              only on `Nitro-based instances
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
              . Other instance families guarantee performance up to 32,000 IOPS. For more
              information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Condition: This parameter is required for requests to create ``io1`` volumes; it
              is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
              volumes.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

              Default: If you're creating the volume from a snapshot and don't specify a volume
              size, the default is the snapshot size.

              Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
              IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
              for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
              specify a snapshot, the volume size must be equal to or larger than the snapshot
              size.

            - **VolumeType** *(string) --*

              The volume type. If you set the type to ``io1`` , you must also specify the IOPS
              that the volume supports.

              Default: ``gp2``

            - **Encrypted** *(boolean) --*

              Indicates whether the encryption state of an EBS volume is changed while being
              restored from a backing snapshot. The effect of setting the encryption state to
              ``true`` depends on the volume origin (new or from a snapshot), starting
              encryption state, ownership, and whether encryption by default is enabled. For
              more information, see `Amazon EBS Encryption
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
              in the *Amazon Elastic Compute Cloud User Guide* .

              In no case can you remove encryption from an encrypted volume.

              Encrypted volumes can only be attached to instances that support Amazon EBS
              encryption. For more information, see `Supported Instance Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
              .

            - **KmsKeyId** *(string) --*

              Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
              under which the EBS volume is encrypted.

              This parameter is only supported on ``BlockDeviceMapping`` objects called by
              `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              , `RequestSpotFleet
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
              , and `RequestSpotInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
              .

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for EBS I/O. This optimization provides
        dedicated throughput to Amazon EBS and an optimized configuration stack to provide
        optimal EBS I/O performance. This optimization isn't available with all instance types.
        Additional usage charges apply when using an EBS Optimized instance.

        Default: ``false``

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **ImageId** *(string) --*

        The ID of the AMI.

      - **InstanceType** *(string) --*

        The instance type.

      - **KernelId** *(string) --*

        The ID of the kernel.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **NetworkInterfaces** *(list) --*

        One or more network interfaces. If you specify a network interface, you must specify
        subnet IDs and security group IDs using the network interface.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to assign a public IPv4 address to an instance you launch in a
            VPC. The public IP address can only be assigned to a network interface for eth0,
            and can only be assigned to a new network interface, not an existing one. You
            cannot specify more than one network interface in the request. If launching into a
            default subnet, the default value is ``true`` .

          - **DeleteOnTermination** *(boolean) --*

            If set to ``true`` , the interface is deleted when the instance is terminated. You
            can specify ``true`` only if creating a new network interface when launching an
            instance.

          - **Description** *(string) --*

            The description of the network interface. Applies only if creating a network
            interface when launching an instance.

          - **DeviceIndex** *(integer) --*

            The position of the network interface in the attachment order. A primary network
            interface has a device index of 0.

            If you specify a network interface when launching an instance, you must specify the
            device index.

          - **Groups** *(list) --*

            The IDs of the security groups for the network interface. Applies only if creating
            a network interface when launching an instance.

            - *(string) --*

          - **Ipv6AddressCount** *(integer) --*

            A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
            the IPv6 addresses from the range of the subnet. You cannot specify this option and
            the option to assign specific IPv6 addresses in the same request. You can specify
            this option if you've specified a minimum number of instances to launch.

          - **Ipv6Addresses** *(list) --*

            One or more IPv6 addresses to assign to the network interface. You cannot specify
            this option and the option to assign a number of IPv6 addresses in the same
            request. You cannot specify this option if you've specified a minimum number of
            instances to launch.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The private IPv4 address of the network interface. Applies only if creating a
            network interface when launching an instance. You cannot specify this option if
            you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses to assign to the network interface. Only one
            private IPv4 address can be designated as primary. You cannot specify this option
            if you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses. You can't specify this option and
            specify more than one private IP address using the private IP addresses option. You
            cannot specify this option if you're launching more than one instance in a
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **SubnetId** *(string) --*

            The ID of the subnet associated with the network interface. Applies only if
            creating a network interface when launching an instance.

          - **InterfaceType** *(string) --*

            The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
            ``efa`` . For more information, see `Elastic Fabric Adapter
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
            Elastic Compute Cloud User Guide* .

            If you are not creating an EFA, specify ``interface`` or omit this parameter.

            Valid values: ``interface`` | ``efa``

      - **Placement** *(dict) --*

        The placement information for the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

          [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
          for example, "us-west-2a, us-west-2b".

        - **GroupName** *(string) --*

          The name of the placement group.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
          supported for Spot Instances.

      - **RamdiskId** *(string) --*

        The ID of the RAM disk.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instance.

      - **Monitoring** *(dict) --*

        Describes the monitoring of an instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

    - **LaunchedAvailabilityZone** *(string) --*

      The Availability Zone in which the request is launched.

    - **ProductDescription** *(string) --*

      The product description associated with the Spot Instance.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **SpotPrice** *(string) --*

      The maximum price per hour that you are willing to pay for a Spot Instance.

    - **State** *(string) --*

      The state of the Spot Instance request. Spot status information helps track your Spot
      Instance requests. For more information, see `Spot Status
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
      *Amazon EC2 User Guide for Linux Instances* .

    - **Status** *(dict) --*

      The status code and status message describing the Spot Instance request.

      - **Code** *(string) --*

        The status code. For a list of status codes, see `Spot Status Codes
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
        in the *Amazon EC2 User Guide for Linux Instances* .

      - **Message** *(string) --*

        The description for the status code.

      - **UpdateTime** *(datetime) --*

        The date and time of the most recent status update, in UTC format (for example, *YYYY*
        -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Type** *(string) --*

      The Spot Instance request type.

    - **ValidFrom** *(datetime) --*

      The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). The request becomes active at this date and time.

    - **ValidUntil** *(datetime) --*

      The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). If this is a one-time request, it remains active until all instances launch,
      the request is canceled, or this date is reached. If the request is persistent, it
      remains active until it is canceled or this date is reached. The default end date is 7
      days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_ClientDescribeSpotInstanceRequestsResponseTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseTypeDef",
    {
        "SpotInstanceRequests": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotInstanceRequests` `Response`

    Contains the output of DescribeSpotInstanceRequests.

    - **SpotInstanceRequests** *(list) --*

      One or more Spot Instance requests.

      - *(dict) --*

        Describes a Spot Instance request.

        - **ActualBlockHourlyPrice** *(string) --*

          If you specified a duration and your Spot Instance request was fulfilled, this is the
          fixed hourly price in effect for the Spot Instance while it runs.

        - **AvailabilityZoneGroup** *(string) --*

          The Availability Zone group. If you specify the same Availability Zone group for all Spot
          Instance requests, all Spot Instances are launched in the same Availability Zone.

        - **BlockDurationMinutes** *(integer) --*

          The duration for the Spot Instance, in minutes.

        - **CreateTime** *(datetime) --*

          The date and time when the Spot Instance request was created, in UTC format (for example,
          *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Fault** *(dict) --*

          The fault codes for the Spot Instance request, if any.

          - **Code** *(string) --*

            The reason code for the Spot Instance state change.

          - **Message** *(string) --*

            The message for the Spot Instance state change.

        - **InstanceId** *(string) --*

          The instance ID, if an instance has been launched to fulfill the Spot Instance request.

        - **LaunchGroup** *(string) --*

          The instance launch group. Launch groups are Spot Instances that launch together and
          terminate together.

        - **LaunchSpecification** *(dict) --*

          Additional information for launching instances.

          - **UserData** *(string) --*

            The Base64-encoded user data for the instance.

          - **SecurityGroups** *(list) --*

            One or more security groups. When requesting instances in a VPC, you must specify the
            IDs of the security groups. When requesting instances in EC2-Classic, you can specify
            the names or the IDs of the security groups.

            - *(dict) --*

              Describes a security group.

              - **GroupName** *(string) --*

                The name of the security group.

              - **GroupId** *(string) --*

                The ID of the security group.

          - **AddressingType** *(string) --*

            Deprecated.

          - **BlockDeviceMappings** *(list) --*

            One or more block device mapping entries.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

              - **VirtualName** *(string) --*

                The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                starting from 0. An instance type with 2 available instance store volumes can
                specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
                instance store volumes depends on the instance type. After you connect to the
                instance, you must mount the volume.

                NVMe instance store volumes are automatically enumerated and assigned a device
                name. Including them in your block device mapping has no effect.

                Constraints: For M3 instances, you must specify instance store volumes in the block
                device mapping for the instance. When you launch an M3 instance, we ignore any
                instance store volumes specified in the block device mapping for the AMI.

              - **Ebs** *(dict) --*

                Parameters used to automatically set up EBS volumes when the instance is launched.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination. For more
                  information, see `Preserving Amazon EBS Volumes on Instance Termination
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                  in the Amazon Elastic Compute Cloud User Guide.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports. For
                  ``io1`` volumes, this represents the number of IOPS that are provisioned for the
                  volume. For ``gp2`` volumes, this represents the baseline performance of the
                  volume and the rate at which the volume accumulates I/O credits for bursting. For
                  more information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
                  for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
                  only on `Nitro-based instances
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                  . Other instance families guarantee performance up to 32,000 IOPS. For more
                  information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Condition: This parameter is required for requests to create ``io1`` volumes; it
                  is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
                  volumes.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                  Default: If you're creating the volume from a snapshot and don't specify a volume
                  size, the default is the snapshot size.

                  Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
                  IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
                  for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
                  specify a snapshot, the volume size must be equal to or larger than the snapshot
                  size.

                - **VolumeType** *(string) --*

                  The volume type. If you set the type to ``io1`` , you must also specify the IOPS
                  that the volume supports.

                  Default: ``gp2``

                - **Encrypted** *(boolean) --*

                  Indicates whether the encryption state of an EBS volume is changed while being
                  restored from a backing snapshot. The effect of setting the encryption state to
                  ``true`` depends on the volume origin (new or from a snapshot), starting
                  encryption state, ownership, and whether encryption by default is enabled. For
                  more information, see `Amazon EBS Encryption
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  In no case can you remove encryption from an encrypted volume.

                  Encrypted volumes can only be attached to instances that support Amazon EBS
                  encryption. For more information, see `Supported Instance Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                  .

                - **KmsKeyId** *(string) --*

                  Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
                  under which the EBS volume is encrypted.

                  This parameter is only supported on ``BlockDeviceMapping`` objects called by
                  `RunInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                  , `RequestSpotFleet
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                  , and `RequestSpotInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                  .

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instance is optimized for EBS I/O. This optimization provides
            dedicated throughput to Amazon EBS and an optimized configuration stack to provide
            optimal EBS I/O performance. This optimization isn't available with all instance types.
            Additional usage charges apply when using an EBS Optimized instance.

            Default: ``false``

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **ImageId** *(string) --*

            The ID of the AMI.

          - **InstanceType** *(string) --*

            The instance type.

          - **KernelId** *(string) --*

            The ID of the kernel.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **NetworkInterfaces** *(list) --*

            One or more network interfaces. If you specify a network interface, you must specify
            subnet IDs and security group IDs using the network interface.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to assign a public IPv4 address to an instance you launch in a
                VPC. The public IP address can only be assigned to a network interface for eth0,
                and can only be assigned to a new network interface, not an existing one. You
                cannot specify more than one network interface in the request. If launching into a
                default subnet, the default value is ``true`` .

              - **DeleteOnTermination** *(boolean) --*

                If set to ``true`` , the interface is deleted when the instance is terminated. You
                can specify ``true`` only if creating a new network interface when launching an
                instance.

              - **Description** *(string) --*

                The description of the network interface. Applies only if creating a network
                interface when launching an instance.

              - **DeviceIndex** *(integer) --*

                The position of the network interface in the attachment order. A primary network
                interface has a device index of 0.

                If you specify a network interface when launching an instance, you must specify the
                device index.

              - **Groups** *(list) --*

                The IDs of the security groups for the network interface. Applies only if creating
                a network interface when launching an instance.

                - *(string) --*

              - **Ipv6AddressCount** *(integer) --*

                A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
                the IPv6 addresses from the range of the subnet. You cannot specify this option and
                the option to assign specific IPv6 addresses in the same request. You can specify
                this option if you've specified a minimum number of instances to launch.

              - **Ipv6Addresses** *(list) --*

                One or more IPv6 addresses to assign to the network interface. You cannot specify
                this option and the option to assign a number of IPv6 addresses in the same
                request. You cannot specify this option if you've specified a minimum number of
                instances to launch.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 address of the network interface. Applies only if creating a
                network interface when launching an instance. You cannot specify this option if
                you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses to assign to the network interface. Only one
                private IPv4 address can be designated as primary. You cannot specify this option
                if you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4 address.
                    Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses. You can't specify this option and
                specify more than one private IP address using the private IP addresses option. You
                cannot specify this option if you're launching more than one instance in a
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **SubnetId** *(string) --*

                The ID of the subnet associated with the network interface. Applies only if
                creating a network interface when launching an instance.

              - **InterfaceType** *(string) --*

                The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
                ``efa`` . For more information, see `Elastic Fabric Adapter
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
                Elastic Compute Cloud User Guide* .

                If you are not creating an EFA, specify ``interface`` or omit this parameter.

                Valid values: ``interface`` | ``efa``

          - **Placement** *(dict) --*

            The placement information for the instance.

            - **AvailabilityZone** *(string) --*

              The Availability Zone.

              [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
              for example, "us-west-2a, us-west-2b".

            - **GroupName** *(string) --*

              The name of the placement group.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance with a
              tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
              supported for Spot Instances.

          - **RamdiskId** *(string) --*

            The ID of the RAM disk.

          - **SubnetId** *(string) --*

            The ID of the subnet in which to launch the instance.

          - **Monitoring** *(dict) --*

            Describes the monitoring of an instance.

            - **Enabled** *(boolean) --*

              Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
              enabled.

        - **LaunchedAvailabilityZone** *(string) --*

          The Availability Zone in which the request is launched.

        - **ProductDescription** *(string) --*

          The product description associated with the Spot Instance.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **SpotPrice** *(string) --*

          The maximum price per hour that you are willing to pay for a Spot Instance.

        - **State** *(string) --*

          The state of the Spot Instance request. Spot status information helps track your Spot
          Instance requests. For more information, see `Spot Status
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
          *Amazon EC2 User Guide for Linux Instances* .

        - **Status** *(dict) --*

          The status code and status message describing the Spot Instance request.

          - **Code** *(string) --*

            The status code. For a list of status codes, see `Spot Status Codes
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
            in the *Amazon EC2 User Guide for Linux Instances* .

          - **Message** *(string) --*

            The description for the status code.

          - **UpdateTime** *(datetime) --*

            The date and time of the most recent status update, in UTC format (for example, *YYYY*
            -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Type** *(string) --*

          The Spot Instance request type.

        - **ValidFrom** *(datetime) --*

          The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). The request becomes active at this date and time.

        - **ValidUntil** *(datetime) --*

          The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). If this is a one-time request, it remains active until all instances launch,
          the request is canceled, or this date is reached. If the request is persistent, it
          remains active until it is canceled or this date is reached. The default end date is 7
          days from the current date.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.

    - **NextToken** *(string) --*

      The token to use to retrieve the next set of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeSpotPriceHistoryFiltersTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSpotPriceHistoryFiltersTypeDef(
    _ClientDescribeSpotPriceHistoryFiltersTypeDef
):
    """
    Type definition for `ClientDescribeSpotPriceHistory` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceType": str,
        "ProductDescription": str,
        "SpotPrice": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef(
    _ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef
):
    """
    Type definition for `ClientDescribeSpotPriceHistoryResponse` `SpotPriceHistory`

    Describes the maximum price per hour that you are willing to pay for a Spot Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **InstanceType** *(string) --*

      The instance type.

    - **ProductDescription** *(string) --*

      A general description of the AMI.

    - **SpotPrice** *(string) --*

      The maximum price per hour that you are willing to pay for a Spot Instance.

    - **Timestamp** *(datetime) --*

      The date and time the request was created, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z).
    """


_ClientDescribeSpotPriceHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryResponseTypeDef",
    {
        "NextToken": str,
        "SpotPriceHistory": List[
            ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotPriceHistoryResponseTypeDef(
    _ClientDescribeSpotPriceHistoryResponseTypeDef
):
    """
    Type definition for `ClientDescribeSpotPriceHistory` `Response`

    Contains the output of DescribeSpotPriceHistory.

    - **NextToken** *(string) --*

      The token required to retrieve the next set of results. This value is null or an empty string
      when there are no more results to return.

    - **SpotPriceHistory** *(list) --*

      The historical Spot prices.

      - *(dict) --*

        Describes the maximum price per hour that you are willing to pay for a Spot Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **InstanceType** *(string) --*

          The instance type.

        - **ProductDescription** *(string) --*

          A general description of the AMI.

        - **SpotPrice** *(string) --*

          The maximum price per hour that you are willing to pay for a Spot Instance.

        - **Timestamp** *(datetime) --*

          The date and time the request was created, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z).
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgress` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSet` `StaleIpPermissionsEgress`

    Describes a stale rule in a security group.

    - **FromPort** *(integer) --*

      The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **IpProtocol** *(string) --*

      The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
      Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
      .

    - **IpRanges** *(list) --*

      The IP ranges. Not applicable for stale security group rules.

      - *(string) --*

    - **PrefixListIds** *(list) --*

      The prefix list IDs for an AWS service. Not applicable for stale security group rules.

      - *(string) --*

    - **ToPort** *(integer) --*

      The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **UserIdGroupPairs** *(list) --*

      The security group pairs. Returns the ID of the referenced security group and VPC,
      and the ID and status of the VPC peering connection.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSet` `StaleIpPermissions`

    Describes a stale rule in a security group.

    - **FromPort** *(integer) --*

      The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **IpProtocol** *(string) --*

      The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
      Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
      .

    - **IpRanges** *(list) --*

      The IP ranges. Not applicable for stale security group rules.

      - *(string) --*

    - **PrefixListIds** *(list) --*

      The prefix list IDs for an AWS service. Not applicable for stale security group rules.

      - *(string) --*

    - **ToPort** *(integer) --*

      The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **UserIdGroupPairs** *(list) --*

      The security group pairs. Returns the ID of the referenced security group and VPC,
      and the ID and status of the VPC peering connection.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "StaleIpPermissions": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
        ],
        "StaleIpPermissionsEgress": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroupsResponse` `StaleSecurityGroupSet`

    Describes a stale security group (a security group that contains stale rules).

    - **Description** *(string) --*

      The description of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **StaleIpPermissions** *(list) --*

      Information about the stale inbound rules in the security group.

      - *(dict) --*

        Describes a stale rule in a security group.

        - **FromPort** *(integer) --*

          The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **IpProtocol** *(string) --*

          The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
          Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
          .

        - **IpRanges** *(list) --*

          The IP ranges. Not applicable for stale security group rules.

          - *(string) --*

        - **PrefixListIds** *(list) --*

          The prefix list IDs for an AWS service. Not applicable for stale security group rules.

          - *(string) --*

        - **ToPort** *(integer) --*

          The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **UserIdGroupPairs** *(list) --*

          The security group pairs. Returns the ID of the referenced security group and VPC,
          and the ID and status of the VPC peering connection.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **StaleIpPermissionsEgress** *(list) --*

      Information about the stale outbound rules in the security group.

      - *(dict) --*

        Describes a stale rule in a security group.

        - **FromPort** *(integer) --*

          The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **IpProtocol** *(string) --*

          The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
          Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
          .

        - **IpRanges** *(list) --*

          The IP ranges. Not applicable for stale security group rules.

          - *(string) --*

        - **PrefixListIds** *(list) --*

          The prefix list IDs for an AWS service. Not applicable for stale security group rules.

          - *(string) --*

        - **ToPort** *(integer) --*

          The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **UserIdGroupPairs** *(list) --*

          The security group pairs. Returns the ID of the referenced security group and VPC,
          and the ID and status of the VPC peering connection.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **VpcId** *(string) --*

      The ID of the VPC for the security group.
    """


_ClientDescribeStaleSecurityGroupsResponseTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseTypeDef",
    {
        "NextToken": str,
        "StaleSecurityGroupSet": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseTypeDef
):
    """
    Type definition for `ClientDescribeStaleSecurityGroups` `Response`

    - **NextToken** *(string) --*

      The token to use when requesting the next set of items. If there are no additional items to
      return, the string is empty.

    - **StaleSecurityGroupSet** *(list) --*

      Information about the stale security groups.

      - *(dict) --*

        Describes a stale security group (a security group that contains stale rules).

        - **Description** *(string) --*

          The description of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **StaleIpPermissions** *(list) --*

          Information about the stale inbound rules in the security group.

          - *(dict) --*

            Describes a stale rule in a security group.

            - **FromPort** *(integer) --*

              The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **IpProtocol** *(string) --*

              The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
              Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
              .

            - **IpRanges** *(list) --*

              The IP ranges. Not applicable for stale security group rules.

              - *(string) --*

            - **PrefixListIds** *(list) --*

              The prefix list IDs for an AWS service. Not applicable for stale security group rules.

              - *(string) --*

            - **ToPort** *(integer) --*

              The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **UserIdGroupPairs** *(list) --*

              The security group pairs. Returns the ID of the referenced security group and VPC,
              and the ID and status of the VPC peering connection.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **StaleIpPermissionsEgress** *(list) --*

          Information about the stale outbound rules in the security group.

          - *(dict) --*

            Describes a stale rule in a security group.

            - **FromPort** *(integer) --*

              The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **IpProtocol** *(string) --*

              The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
              Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
              .

            - **IpRanges** *(list) --*

              The IP ranges. Not applicable for stale security group rules.

              - *(string) --*

            - **PrefixListIds** *(list) --*

              The prefix list IDs for an AWS service. Not applicable for stale security group rules.

              - *(string) --*

            - **ToPort** *(integer) --*

              The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **UserIdGroupPairs** *(list) --*

              The security group pairs. Returns the ID of the referenced security group and VPC,
              and the ID and status of the VPC peering connection.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **VpcId** *(string) --*

          The ID of the VPC for the security group.
    """


_ClientDescribeSubnetsFiltersTypeDef = TypedDict(
    "_ClientDescribeSubnetsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSubnetsFiltersTypeDef(_ClientDescribeSubnetsFiltersTypeDef):
    """
    Type definition for `ClientDescribeSubnets` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef(
    _ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientDescribeSubnetsResponseSubnets` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a subnet.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeSubnetsResponseSubnetsTagsTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsTagsTypeDef(
    _ClientDescribeSubnetsResponseSubnetsTagsTypeDef
):
    """
    Type definition for `ClientDescribeSubnetsResponseSubnets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeSubnetsResponseSubnetsTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientDescribeSubnetsResponseSubnetsTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsTypeDef(
    _ClientDescribeSubnetsResponseSubnetsTypeDef
):
    """
    Type definition for `ClientDescribeSubnetsResponse` `Subnets`

    Describes a subnet.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the subnet.

    - **AvailabilityZoneId** *(string) --*

      The AZ ID of the subnet.

    - **AvailableIpAddressCount** *(integer) --*

      The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
      stopped instances are considered unavailable.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block assigned to the subnet.

    - **DefaultForAz** *(boolean) --*

      Indicates whether this is the default subnet for the Availability Zone.

    - **MapPublicIpOnLaunch** *(boolean) --*

      Indicates whether instances launched in this subnet receive a public IPv4 address.

    - **State** *(string) --*

      The current state of the subnet.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC the subnet is in.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the subnet.

    - **AssignIpv6AddressOnCreation** *(boolean) --*

      Indicates whether a network interface created in this subnet (including a network
      interface created by  RunInstances ) receives an IPv6 address.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the subnet.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a subnet.

        - **AssociationId** *(string) --*

          The association ID for the CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of a CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the subnet.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **SubnetArn** *(string) --*

      The Amazon Resource Name (ARN) of the subnet.
    """


_ClientDescribeSubnetsResponseTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseTypeDef",
    {"Subnets": List[ClientDescribeSubnetsResponseSubnetsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeSubnetsResponseTypeDef(_ClientDescribeSubnetsResponseTypeDef):
    """
    Type definition for `ClientDescribeSubnets` `Response`

    - **Subnets** *(list) --*

      Information about one or more subnets.

      - *(dict) --*

        Describes a subnet.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the subnet.

        - **AvailabilityZoneId** *(string) --*

          The AZ ID of the subnet.

        - **AvailableIpAddressCount** *(integer) --*

          The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
          stopped instances are considered unavailable.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block assigned to the subnet.

        - **DefaultForAz** *(boolean) --*

          Indicates whether this is the default subnet for the Availability Zone.

        - **MapPublicIpOnLaunch** *(boolean) --*

          Indicates whether instances launched in this subnet receive a public IPv4 address.

        - **State** *(string) --*

          The current state of the subnet.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **VpcId** *(string) --*

          The ID of the VPC the subnet is in.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the subnet.

        - **AssignIpv6AddressOnCreation** *(boolean) --*

          Indicates whether a network interface created in this subnet (including a network
          interface created by  RunInstances ) receives an IPv6 address.

        - **Ipv6CidrBlockAssociationSet** *(list) --*

          Information about the IPv6 CIDR blocks associated with the subnet.

          - *(dict) --*

            Describes an IPv6 CIDR block associated with a subnet.

            - **AssociationId** *(string) --*

              The association ID for the CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

            - **Ipv6CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of a CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the subnet.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **SubnetArn** *(string) --*

          The Amazon Resource Name (ARN) of the subnet.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTagsFiltersTypeDef = TypedDict(
    "_ClientDescribeTagsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeTagsFiltersTypeDef(_ClientDescribeTagsFiltersTypeDef):
    """
    Type definition for `ClientDescribeTags` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTagsResponseTagsTypeDef = TypedDict(
    "_ClientDescribeTagsResponseTagsTypeDef",
    {"Key": str, "ResourceId": str, "ResourceType": str, "Value": str},
    total=False,
)


class ClientDescribeTagsResponseTagsTypeDef(_ClientDescribeTagsResponseTagsTypeDef):
    """
    Type definition for `ClientDescribeTagsResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The tag key.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **Value** *(string) --*

      The tag value.
    """


_ClientDescribeTagsResponseTypeDef = TypedDict(
    "_ClientDescribeTagsResponseTypeDef",
    {"NextToken": str, "Tags": List[ClientDescribeTagsResponseTagsTypeDef]},
    total=False,
)


class ClientDescribeTagsResponseTypeDef(_ClientDescribeTagsResponseTypeDef):
    """
    Type definition for `ClientDescribeTags` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **Tags** *(list) --*

      The tags.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The tag key.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **Value** *(string) --*

          The tag value.
    """


_ClientDescribeTrafficMirrorFiltersFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersFiltersTypeDef(
    _ClientDescribeTrafficMirrorFiltersFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFilters` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFilters` `EgressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFilters` `IngressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFilters` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFiltersResponse` `TrafficMirrorFilters`

    Describes the Traffic Mirror filter.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **IngressFilterRules** *(list) --*

      Information about the ingress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **EgressFilterRules** *(list) --*

      Information about the egress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **NetworkServices** *(list) --*

      The network service traffic that is associated with the Traffic Mirror filter.

      - *(string) --*

    - **Description** *(string) --*

      The description of the Traffic Mirror filter.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror filter.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTrafficMirrorFiltersResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTypeDef",
    {
        "TrafficMirrorFilters": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorFilters` `Response`

    - **TrafficMirrorFilters** *(list) --*

      Information about one or more Traffic Mirror filters.

      - *(dict) --*

        Describes the Traffic Mirror filter.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.

        - **IngressFilterRules** *(list) --*

          Information about the ingress rules that are associated with the Traffic Mirror filter.

          - *(dict) --*

            Describes the Traffic Mirror rule.

            - **TrafficMirrorFilterRuleId** *(string) --*

              The ID of the Traffic Mirror rule.

            - **TrafficMirrorFilterId** *(string) --*

              The ID of the Traffic Mirror filter that the rule is associated with.

            - **TrafficDirection** *(string) --*

              The traffic direction assigned to the Traffic Mirror rule.

            - **RuleNumber** *(integer) --*

              The rule number of the Traffic Mirror rule.

            - **RuleAction** *(string) --*

              The action assigned to the Traffic Mirror rule.

            - **Protocol** *(integer) --*

              The protocol assigned to the Traffic Mirror rule.

            - **DestinationPortRange** *(dict) --*

              The destination port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **SourcePortRange** *(dict) --*

              The source port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **DestinationCidrBlock** *(string) --*

              The destination CIDR block assigned to the Traffic Mirror rule.

            - **SourceCidrBlock** *(string) --*

              The source CIDR block assigned to the Traffic Mirror rule.

            - **Description** *(string) --*

              The description of the Traffic Mirror rule.

        - **EgressFilterRules** *(list) --*

          Information about the egress rules that are associated with the Traffic Mirror filter.

          - *(dict) --*

            Describes the Traffic Mirror rule.

            - **TrafficMirrorFilterRuleId** *(string) --*

              The ID of the Traffic Mirror rule.

            - **TrafficMirrorFilterId** *(string) --*

              The ID of the Traffic Mirror filter that the rule is associated with.

            - **TrafficDirection** *(string) --*

              The traffic direction assigned to the Traffic Mirror rule.

            - **RuleNumber** *(integer) --*

              The rule number of the Traffic Mirror rule.

            - **RuleAction** *(string) --*

              The action assigned to the Traffic Mirror rule.

            - **Protocol** *(integer) --*

              The protocol assigned to the Traffic Mirror rule.

            - **DestinationPortRange** *(dict) --*

              The destination port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **SourcePortRange** *(dict) --*

              The source port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **DestinationCidrBlock** *(string) --*

              The destination CIDR block assigned to the Traffic Mirror rule.

            - **SourceCidrBlock** *(string) --*

              The source CIDR block assigned to the Traffic Mirror rule.

            - **Description** *(string) --*

              The description of the Traffic Mirror rule.

        - **NetworkServices** *(list) --*

          The network service traffic that is associated with the Traffic Mirror filter.

          - *(string) --*

        - **Description** *(string) --*

          The description of the Traffic Mirror filter.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror filter.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. The value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTrafficMirrorSessionsFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorSessionsFiltersTypeDef(
    _ClientDescribeTrafficMirrorSessionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorSessions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessions` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[
            ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorSessionsResponse` `TrafficMirrorSessions`

    Describes a Traffic Mirror session.

    - **TrafficMirrorSessionId** *(string) --*

      The ID for the Traffic Mirror session.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **NetworkInterfaceId** *(string) --*

      The ID of the Traffic Mirror session's network interface.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror session.

    - **PacketLength** *(integer) --*

      The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
      To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
      this value to 100, then the first 100 bytes that meet the filter criteria are copied to
      the target. Do not specify this parameter when you want to mirror the entire packet

    - **SessionNumber** *(integer) --*

      The session number determines the order in which sessions are evaluated when an interface
      is used by multiple sessions. The first session with a matching filter is the one that
      mirrors the packets.

      Valid values are 1-32766.

    - **VirtualNetworkId** *(integer) --*

      The virtual network ID associated with the Traffic Mirror session.

    - **Description** *(string) --*

      The description of the Traffic Mirror session.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror session.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTrafficMirrorSessionsResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTypeDef",
    {
        "TrafficMirrorSessions": List[
            ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorSessions` `Response`

    - **TrafficMirrorSessions** *(list) --*

      Describes one or more Traffic Mirror sessions. By default, all Traffic Mirror sessions are
      described. Alternatively, you can filter the results.

      - *(dict) --*

        Describes a Traffic Mirror session.

        - **TrafficMirrorSessionId** *(string) --*

          The ID for the Traffic Mirror session.

        - **TrafficMirrorTargetId** *(string) --*

          The ID of the Traffic Mirror target.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.

        - **NetworkInterfaceId** *(string) --*

          The ID of the Traffic Mirror session's network interface.

        - **OwnerId** *(string) --*

          The ID of the account that owns the Traffic Mirror session.

        - **PacketLength** *(integer) --*

          The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
          To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
          this value to 100, then the first 100 bytes that meet the filter criteria are copied to
          the target. Do not specify this parameter when you want to mirror the entire packet

        - **SessionNumber** *(integer) --*

          The session number determines the order in which sessions are evaluated when an interface
          is used by multiple sessions. The first session with a matching filter is the one that
          mirrors the packets.

          Valid values are 1-32766.

        - **VirtualNetworkId** *(integer) --*

          The virtual network ID associated with the Traffic Mirror session.

        - **Description** *(string) --*

          The description of the Traffic Mirror session.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror session.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. The value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTrafficMirrorTargetsFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorTargetsFiltersTypeDef(
    _ClientDescribeTrafficMirrorTargetsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorTargets` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": str,
        "Description": str,
        "OwnerId": str,
        "Tags": List[
            ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorTargetsResponse` `TrafficMirrorTargets`

    Describes a Traffic Mirror target.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **NetworkInterfaceId** *(string) --*

      The network interface ID that is attached to the target.

    - **NetworkLoadBalancerArn** *(string) --*

      The Amazon Resource Name (ARN) of the Network Load Balancer.

    - **Type** *(string) --*

      The type of Traffic Mirror target.

    - **Description** *(string) --*

      Information about the Traffic Mirror target.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror target.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror target.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTrafficMirrorTargetsResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTypeDef",
    {
        "TrafficMirrorTargets": List[
            ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTypeDef
):
    """
    Type definition for `ClientDescribeTrafficMirrorTargets` `Response`

    - **TrafficMirrorTargets** *(list) --*

      Information about one or more Traffic Mirror targets.

      - *(dict) --*

        Describes a Traffic Mirror target.

        - **TrafficMirrorTargetId** *(string) --*

          The ID of the Traffic Mirror target.

        - **NetworkInterfaceId** *(string) --*

          The network interface ID that is attached to the target.

        - **NetworkLoadBalancerArn** *(string) --*

          The Amazon Resource Name (ARN) of the Network Load Balancer.

        - **Type** *(string) --*

          The type of Traffic Mirror target.

        - **Description** *(string) --*

          Information about the Traffic Mirror target.

        - **OwnerId** *(string) --*

          The ID of the account that owns the Traffic Mirror target.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror target.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. The value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTransitGatewayAttachmentsFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsFiltersTypeDef(
    _ClientDescribeTransitGatewayAttachmentsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayAttachments` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef",
    {"TransitGatewayRouteTableId": str, "State": str},
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachments` `Association`

    The association.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the route table for the transit gateway.

    - **State** *(string) --*

      The state of the association.
    """


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachments` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "TransitGatewayOwnerId": str,
        "ResourceOwnerId": str,
        "ResourceType": str,
        "ResourceId": str,
        "State": str,
        "Association": ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef,
        "CreationTime": datetime,
        "Tags": List[
            ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayAttachmentsResponse` `TransitGatewayAttachments`

    Describes an attachment between a resource and a transit gateway.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayOwnerId** *(string) --*

      The ID of the AWS account that owns the transit gateway.

    - **ResourceOwnerId** *(string) --*

      The ID of the AWS account that owns the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **State** *(string) --*

      The attachment state.

    - **Association** *(dict) --*

      The association.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the route table for the transit gateway.

      - **State** *(string) --*

        The state of the association.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      The tags for the attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTransitGatewayAttachmentsResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTypeDef",
    {
        "TransitGatewayAttachments": List[
            ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayAttachments` `Response`

    - **TransitGatewayAttachments** *(list) --*

      Information about the attachments.

      - *(dict) --*

        Describes an attachment between a resource and a transit gateway.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **TransitGatewayOwnerId** *(string) --*

          The ID of the AWS account that owns the transit gateway.

        - **ResourceOwnerId** *(string) --*

          The ID of the AWS account that owns the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **State** *(string) --*

          The attachment state.

        - **Association** *(dict) --*

          The association.

          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the route table for the transit gateway.

          - **State** *(string) --*

            The state of the association.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Tags** *(list) --*

          The tags for the attachment.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTransitGatewayRouteTablesFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesFiltersTypeDef(
    _ClientDescribeTransitGatewayRouteTablesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayRouteTables` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTables` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": str,
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayRouteTablesResponse` `TransitGatewayRouteTables`

    Describes a transit gateway route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway route table.

    - **DefaultAssociationRouteTable** *(boolean) --*

      Indicates whether this is the default association route table for the transit gateway.

    - **DefaultPropagationRouteTable** *(boolean) --*

      Indicates whether this is the default propagation route table for the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTransitGatewayRouteTablesResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTypeDef",
    {
        "TransitGatewayRouteTables": List[
            ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayRouteTables` `Response`

    - **TransitGatewayRouteTables** *(list) --*

      Information about the transit gateway route tables.

      - *(dict) --*

        Describes a transit gateway route table.

        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **State** *(string) --*

          The state of the transit gateway route table.

        - **DefaultAssociationRouteTable** *(boolean) --*

          Indicates whether this is the default association route table for the transit gateway.

        - **DefaultPropagationRouteTable** *(boolean) --*

          Indicates whether this is the default propagation route table for the transit gateway.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Tags** *(list) --*

          Any tags assigned to the route table.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayVpcAttachments` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachments` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachments` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef,
        "Tags": List[
            ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayVpcAttachmentsResponse` `TransitGatewayVpcAttachments`

    Describes a VPC attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef",
    {
        "TransitGatewayVpcAttachments": List[
            ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewayVpcAttachments` `Response`

    - **TransitGatewayVpcAttachments** *(list) --*

      Information about the VPC attachments.

      - *(dict) --*

        Describes a VPC attachment.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **VpcOwnerId** *(string) --*

          The ID of the AWS account that owns the VPC.

        - **State** *(string) --*

          The state of the VPC attachment.

        - **SubnetIds** *(list) --*

          The IDs of the subnets.

          - *(string) --*

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Options** *(dict) --*

          The VPC attachment options.

          - **DnsSupport** *(string) --*

            Indicates whether DNS support is enabled.

          - **Ipv6Support** *(string) --*

            Indicates whether IPv6 support is enabled.

        - **Tags** *(list) --*

          The tags for the VPC attachment.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeTransitGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewaysFiltersTypeDef(
    _ClientDescribeTransitGatewaysFiltersTypeDef
):
    """
    Type definition for `ClientDescribeTransitGateways` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": str,
        "DefaultRouteTableAssociation": str,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": str,
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": str,
        "DnsSupport": str,
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewaysResponseTransitGateways` `Options`

    The transit gateway options.

    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
      range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

    - **AutoAcceptSharedAttachments** *(string) --*

      Indicates whether attachment requests are automatically accepted.

    - **DefaultRouteTableAssociation** *(string) --*

      Indicates whether resource attachments are automatically associated with the default
      association route table.

    - **AssociationDefaultRouteTableId** *(string) --*

      The ID of the default association route table.

    - **DefaultRouteTablePropagation** *(string) --*

      Indicates whether resource attachments automatically propagate routes to the default
      propagation route table.

    - **PropagationDefaultRouteTableId** *(string) --*

      The ID of the default propagation route table.

    - **VpnEcmpSupport** *(string) --*

      Indicates whether Equal Cost Multipath Protocol support is enabled.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.
    """


_ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewaysResponseTransitGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": str,
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef,
        "Tags": List[ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeTransitGatewaysResponse` `TransitGateways`

    Describes a transit gateway.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayArn** *(string) --*

      The Amazon Resource Name (ARN) of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account ID that owns the transit gateway.

    - **Description** *(string) --*

      The description of the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The transit gateway options.

      - **AmazonSideAsn** *(integer) --*

        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
        range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

      - **AutoAcceptSharedAttachments** *(string) --*

        Indicates whether attachment requests are automatically accepted.

      - **DefaultRouteTableAssociation** *(string) --*

        Indicates whether resource attachments are automatically associated with the default
        association route table.

      - **AssociationDefaultRouteTableId** *(string) --*

        The ID of the default association route table.

      - **DefaultRouteTablePropagation** *(string) --*

        Indicates whether resource attachments automatically propagate routes to the default
        propagation route table.

      - **PropagationDefaultRouteTableId** *(string) --*

        The ID of the default propagation route table.

      - **VpnEcmpSupport** *(string) --*

        Indicates whether Equal Cost Multipath Protocol support is enabled.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

    - **Tags** *(list) --*

      The tags for the transit gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeTransitGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTypeDef",
    {
        "TransitGateways": List[
            ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTypeDef(
    _ClientDescribeTransitGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeTransitGateways` `Response`

    - **TransitGateways** *(list) --*

      Information about the transit gateways.

      - *(dict) --*

        Describes a transit gateway.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **TransitGatewayArn** *(string) --*

          The Amazon Resource Name (ARN) of the transit gateway.

        - **State** *(string) --*

          The state of the transit gateway.

        - **OwnerId** *(string) --*

          The ID of the AWS account ID that owns the transit gateway.

        - **Description** *(string) --*

          The description of the transit gateway.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Options** *(dict) --*

          The transit gateway options.

          - **AmazonSideAsn** *(integer) --*

            A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
            range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

          - **AutoAcceptSharedAttachments** *(string) --*

            Indicates whether attachment requests are automatically accepted.

          - **DefaultRouteTableAssociation** *(string) --*

            Indicates whether resource attachments are automatically associated with the default
            association route table.

          - **AssociationDefaultRouteTableId** *(string) --*

            The ID of the default association route table.

          - **DefaultRouteTablePropagation** *(string) --*

            Indicates whether resource attachments automatically propagate routes to the default
            propagation route table.

          - **PropagationDefaultRouteTableId** *(string) --*

            The ID of the default propagation route table.

          - **VpnEcmpSupport** *(string) --*

            Indicates whether Equal Cost Multipath Protocol support is enabled.

          - **DnsSupport** *(string) --*

            Indicates whether DNS support is enabled.

        - **Tags** *(list) --*

          The tags for the transit gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef(
    _ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef
):
    """
    Type definition for `ClientDescribeVolumeAttributeResponse` `AutoEnableIO`

    The state of ``autoEnableIO`` attribute.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVolumeAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientDescribeVolumeAttributeResponseProductCodesTypeDef(
    _ClientDescribeVolumeAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `ClientDescribeVolumeAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientDescribeVolumeAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseTypeDef",
    {
        "AutoEnableIO": ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef,
        "ProductCodes": List[ClientDescribeVolumeAttributeResponseProductCodesTypeDef],
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeVolumeAttributeResponseTypeDef(
    _ClientDescribeVolumeAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeVolumeAttribute` `Response`

    Contains the output of DescribeVolumeAttribute.

    - **AutoEnableIO** *(dict) --*

      The state of ``autoEnableIO`` attribute.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **ProductCodes** *(list) --*

      A list of product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **VolumeId** *(string) --*

      The ID of the volume.
    """


_ClientDescribeVolumeStatusFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVolumeStatusFiltersTypeDef(
    _ClientDescribeVolumeStatusFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatus` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatusResponseVolumeStatuses` `Actions`

    Describes a volume status operation code.

    - **Code** *(string) --*

      The code identifying the operation, for example, ``enable-volume-io`` .

    - **Description** *(string) --*

      A description of the operation.

    - **EventId** *(string) --*

      The ID of the event associated with this operation.

    - **EventType** *(string) --*

      The event type associated with this operation.
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatusResponseVolumeStatuses` `Events`

    Describes a volume status event.

    - **Description** *(string) --*

      A description of the event.

    - **EventId** *(string) --*

      The ID of this event.

    - **EventType** *(string) --*

      The type of this event.

    - **NotAfter** *(datetime) --*

      The latest end time of the event.

    - **NotBefore** *(datetime) --*

      The earliest start time of the event.
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": str, "Status": str},
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatus` `Details`

    Describes a volume status.

    - **Name** *(string) --*

      The name of the volume status.

    - **Status** *(string) --*

      The intended status of the volume status.
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[
            ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatusResponseVolumeStatuses` `VolumeStatus`

    The volume status.

    - **Details** *(list) --*

      The details of the volume status.

      - *(dict) --*

        Describes a volume status.

        - **Name** *(string) --*

          The name of the volume status.

        - **Status** *(string) --*

          The intended status of the volume status.

    - **Status** *(string) --*

      The status of the volume.
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef",
    {
        "Actions": List[ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef],
        "AvailabilityZone": str,
        "Events": List[ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatusResponse` `VolumeStatuses`

    Describes the volume status.

    - **Actions** *(list) --*

      The details of the operation.

      - *(dict) --*

        Describes a volume status operation code.

        - **Code** *(string) --*

          The code identifying the operation, for example, ``enable-volume-io`` .

        - **Description** *(string) --*

          A description of the operation.

        - **EventId** *(string) --*

          The ID of the event associated with this operation.

        - **EventType** *(string) --*

          The event type associated with this operation.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the volume.

    - **Events** *(list) --*

      A list of events associated with the volume.

      - *(dict) --*

        Describes a volume status event.

        - **Description** *(string) --*

          A description of the event.

        - **EventId** *(string) --*

          The ID of this event.

        - **EventType** *(string) --*

          The type of this event.

        - **NotAfter** *(datetime) --*

          The latest end time of the event.

        - **NotBefore** *(datetime) --*

          The earliest start time of the event.

    - **VolumeId** *(string) --*

      The volume ID.

    - **VolumeStatus** *(dict) --*

      The volume status.

      - **Details** *(list) --*

        The details of the volume status.

        - *(dict) --*

          Describes a volume status.

          - **Name** *(string) --*

            The name of the volume status.

          - **Status** *(string) --*

            The intended status of the volume status.

      - **Status** *(string) --*

        The status of the volume.
    """


_ClientDescribeVolumeStatusResponseTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseTypeDef",
    {
        "NextToken": str,
        "VolumeStatuses": List[ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef],
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseTypeDef(
    _ClientDescribeVolumeStatusResponseTypeDef
):
    """
    Type definition for `ClientDescribeVolumeStatus` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **VolumeStatuses** *(list) --*

      Information about the status of the volumes.

      - *(dict) --*

        Describes the volume status.

        - **Actions** *(list) --*

          The details of the operation.

          - *(dict) --*

            Describes a volume status operation code.

            - **Code** *(string) --*

              The code identifying the operation, for example, ``enable-volume-io`` .

            - **Description** *(string) --*

              A description of the operation.

            - **EventId** *(string) --*

              The ID of the event associated with this operation.

            - **EventType** *(string) --*

              The event type associated with this operation.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the volume.

        - **Events** *(list) --*

          A list of events associated with the volume.

          - *(dict) --*

            Describes a volume status event.

            - **Description** *(string) --*

              A description of the event.

            - **EventId** *(string) --*

              The ID of this event.

            - **EventType** *(string) --*

              The type of this event.

            - **NotAfter** *(datetime) --*

              The latest end time of the event.

            - **NotBefore** *(datetime) --*

              The earliest start time of the event.

        - **VolumeId** *(string) --*

          The volume ID.

        - **VolumeStatus** *(dict) --*

          The volume status.

          - **Details** *(list) --*

            The details of the volume status.

            - *(dict) --*

              Describes a volume status.

              - **Name** *(string) --*

                The name of the volume status.

              - **Status** *(string) --*

                The intended status of the volume status.

          - **Status** *(string) --*

            The status of the volume.
    """


_ClientDescribeVolumesFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVolumesFiltersTypeDef(_ClientDescribeVolumesFiltersTypeDef):
    """
    Type definition for `ClientDescribeVolumes` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVolumesModificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVolumesModificationsFiltersTypeDef(
    _ClientDescribeVolumesModificationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVolumesModifications` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef",
    {
        "VolumeId": str,
        "ModificationState": str,
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": str,
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": str,
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef(
    _ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef
):
    """
    Type definition for `ClientDescribeVolumesModificationsResponse` `VolumesModifications`

    Describes the modification status of an EBS volume.

    If the volume has never been modified, some element values will be null.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **ModificationState** *(string) --*

      The current modification state. The modification state is null for unmodified volumes.

    - **StatusMessage** *(string) --*

      A status message about the modification progress or failure.

    - **TargetSize** *(integer) --*

      The target size of the volume, in GiB.

    - **TargetIops** *(integer) --*

      The target IOPS rate of the volume.

    - **TargetVolumeType** *(string) --*

      The target EBS volume type of the volume.

    - **OriginalSize** *(integer) --*

      The original size of the volume.

    - **OriginalIops** *(integer) --*

      The original IOPS rate of the volume.

    - **OriginalVolumeType** *(string) --*

      The original EBS volume type of the volume.

    - **Progress** *(integer) --*

      The modification progress, from 0 to 100 percent complete.

    - **StartTime** *(datetime) --*

      The modification start time.

    - **EndTime** *(datetime) --*

      The modification completion or failure time.
    """


_ClientDescribeVolumesModificationsResponseTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsResponseTypeDef",
    {
        "VolumesModifications": List[
            ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVolumesModificationsResponseTypeDef(
    _ClientDescribeVolumesModificationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVolumesModifications` `Response`

    - **VolumesModifications** *(list) --*

      Information about the volume modifications.

      - *(dict) --*

        Describes the modification status of an EBS volume.

        If the volume has never been modified, some element values will be null.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **ModificationState** *(string) --*

          The current modification state. The modification state is null for unmodified volumes.

        - **StatusMessage** *(string) --*

          A status message about the modification progress or failure.

        - **TargetSize** *(integer) --*

          The target size of the volume, in GiB.

        - **TargetIops** *(integer) --*

          The target IOPS rate of the volume.

        - **TargetVolumeType** *(string) --*

          The target EBS volume type of the volume.

        - **OriginalSize** *(integer) --*

          The original size of the volume.

        - **OriginalIops** *(integer) --*

          The original IOPS rate of the volume.

        - **OriginalVolumeType** *(string) --*

          The original EBS volume type of the volume.

        - **Progress** *(integer) --*

          The modification progress, from 0 to 100 percent complete.

        - **StartTime** *(datetime) --*

          The modification start time.

        - **EndTime** *(datetime) --*

          The modification completion or failure time.

    - **NextToken** *(string) --*

      Token for pagination, null if there are no more results
    """


_ClientDescribeVolumesResponseVolumesAttachmentsTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientDescribeVolumesResponseVolumesAttachmentsTypeDef(
    _ClientDescribeVolumesResponseVolumesAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeVolumesResponseVolumes` `Attachments`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_ClientDescribeVolumesResponseVolumesTagsTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVolumesResponseVolumesTagsTypeDef(
    _ClientDescribeVolumesResponseVolumesTagsTypeDef
):
    """
    Type definition for `ClientDescribeVolumesResponseVolumes` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVolumesResponseVolumesTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesTypeDef",
    {
        "Attachments": List[ClientDescribeVolumesResponseVolumesAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": str,
        "VolumeId": str,
        "Iops": int,
        "Tags": List[ClientDescribeVolumesResponseVolumesTagsTypeDef],
        "VolumeType": str,
    },
    total=False,
)


class ClientDescribeVolumesResponseVolumesTypeDef(
    _ClientDescribeVolumesResponseVolumesTypeDef
):
    """
    Type definition for `ClientDescribeVolumesResponse` `Volumes`

    Describes a volume.

    - **Attachments** *(list) --*

      Information about the volume attachments.

      - *(dict) --*

        Describes volume attachment details.

        - **AttachTime** *(datetime) --*

          The time stamp when the attachment initiated.

        - **Device** *(string) --*

          The device name.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **State** *(string) --*

          The attachment state of the volume.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the EBS volume is deleted on instance termination.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the volume.

    - **CreateTime** *(datetime) --*

      The time stamp when volume creation was initiated.

    - **Encrypted** *(boolean) --*

      Indicates whether the volume is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
      master key (CMK) that was used to protect the volume encryption key for the volume.

    - **Size** *(integer) --*

      The size of the volume, in GiBs.

    - **SnapshotId** *(string) --*

      The snapshot from which the volume was created, if applicable.

    - **State** *(string) --*

      The volume state.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For Provisioned
      IOPS SSD volumes, this represents the number of IOPS that are provisioned for the volume.
      For General Purpose SSD volumes, this represents the baseline performance of the volume
      and the rate at which the volume accumulates I/O credits for bursting. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes, in most Regions. The maximum IOPS for ``io1`` of 64,000 is guaranteed
      only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS.

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **Tags** *(list) --*

      Any tags assigned to the volume.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VolumeType** *(string) --*

      The volume type. This can be ``gp2`` for General Purpose SSD, ``io1`` for Provisioned
      IOPS SSD, ``st1`` for Throughput Optimized HDD, ``sc1`` for Cold HDD, or ``standard`` for
      Magnetic volumes.
    """


_ClientDescribeVolumesResponseTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseTypeDef",
    {"Volumes": List[ClientDescribeVolumesResponseVolumesTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeVolumesResponseTypeDef(_ClientDescribeVolumesResponseTypeDef):
    """
    Type definition for `ClientDescribeVolumes` `Response`

    - **Volumes** *(list) --*

      Information about the volumes.

      - *(dict) --*

        Describes a volume.

        - **Attachments** *(list) --*

          Information about the volume attachments.

          - *(dict) --*

            Describes volume attachment details.

            - **AttachTime** *(datetime) --*

              The time stamp when the attachment initiated.

            - **Device** *(string) --*

              The device name.

            - **InstanceId** *(string) --*

              The ID of the instance.

            - **State** *(string) --*

              The attachment state of the volume.

            - **VolumeId** *(string) --*

              The ID of the volume.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

        - **AvailabilityZone** *(string) --*

          The Availability Zone for the volume.

        - **CreateTime** *(datetime) --*

          The time stamp when volume creation was initiated.

        - **Encrypted** *(boolean) --*

          Indicates whether the volume is encrypted.

        - **KmsKeyId** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
          master key (CMK) that was used to protect the volume encryption key for the volume.

        - **Size** *(integer) --*

          The size of the volume, in GiBs.

        - **SnapshotId** *(string) --*

          The snapshot from which the volume was created, if applicable.

        - **State** *(string) --*

          The volume state.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **Iops** *(integer) --*

          The number of I/O operations per second (IOPS) that the volume supports. For Provisioned
          IOPS SSD volumes, this represents the number of IOPS that are provisioned for the volume.
          For General Purpose SSD volumes, this represents the baseline performance of the volume
          and the rate at which the volume accumulates I/O credits for bursting. For more
          information, see `Amazon EBS Volume Types
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
          *Amazon Elastic Compute Cloud User Guide* .

          Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
          ``io1`` volumes, in most Regions. The maximum IOPS for ``io1`` of 64,000 is guaranteed
          only on `Nitro-based instances
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
          . Other instance families guarantee performance up to 32,000 IOPS.

          Condition: This parameter is required for requests to create ``io1`` volumes; it is not
          used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

        - **Tags** *(list) --*

          Any tags assigned to the volume.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VolumeType** *(string) --*

          The volume type. This can be ``gp2`` for General Purpose SSD, ``io1`` for Provisioned
          IOPS SSD, ``st1`` for Throughput Optimized HDD, ``sc1`` for Cold HDD, or ``standard`` for
          Magnetic volumes.

    - **NextToken** *(string) --*

      The ``NextToken`` value to include in a future ``DescribeVolumes`` request. When the results
      of a ``DescribeVolumes`` request exceed ``MaxResults`` , this value can be used to retrieve
      the next page of results. This value is ``null`` when there are no more results to return.
    """


_ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef(
    _ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef
):
    """
    Type definition for `ClientDescribeVpcAttributeResponse` `EnableDnsHostnames`

    Indicates whether the instances launched in the VPC get DNS hostnames. If this attribute is
    ``true`` , instances in the VPC get DNS hostnames; otherwise, they do not.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef(
    _ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef
):
    """
    Type definition for `ClientDescribeVpcAttributeResponse` `EnableDnsSupport`

    Indicates whether DNS resolution is enabled for the VPC. If this attribute is ``true`` , the
    Amazon DNS server resolves DNS hostnames for your instances to their corresponding IP
    addresses; otherwise, it does not.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVpcAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseTypeDef",
    {
        "VpcId": str,
        "EnableDnsHostnames": ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef,
        "EnableDnsSupport": ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef,
    },
    total=False,
)


class ClientDescribeVpcAttributeResponseTypeDef(
    _ClientDescribeVpcAttributeResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcAttribute` `Response`

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **EnableDnsHostnames** *(dict) --*

      Indicates whether the instances launched in the VPC get DNS hostnames. If this attribute is
      ``true`` , instances in the VPC get DNS hostnames; otherwise, they do not.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EnableDnsSupport** *(dict) --*

      Indicates whether DNS resolution is enabled for the VPC. If this attribute is ``true`` , the
      Amazon DNS server resolves DNS hostnames for your instances to their corresponding IP
      addresses; otherwise, it does not.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef",
    {"ClassicLinkDnsSupported": bool, "VpcId": str},
    total=False,
)


class ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef(
    _ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLinkDnsSupportResponse` `Vpcs`

    Describes the ClassicLink DNS support status of a VPC.

    - **ClassicLinkDnsSupported** *(boolean) --*

      Indicates whether ClassicLink DNS support is enabled for the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef",
    {
        "NextToken": str,
        "Vpcs": List[ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef],
    },
    total=False,
)


class ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLinkDnsSupport` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **Vpcs** *(list) --*

      Information about the ClassicLink DNS support status of the VPCs.

      - *(dict) --*

        Describes the ClassicLink DNS support status of a VPC.

        - **ClassicLinkDnsSupported** *(boolean) --*

          Indicates whether ClassicLink DNS support is enabled for the VPC.

        - **VpcId** *(string) --*

          The ID of the VPC.
    """


_ClientDescribeVpcClassicLinkFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcClassicLinkFiltersTypeDef(
    _ClientDescribeVpcClassicLinkFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLink` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef(
    _ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLinkResponseVpcs` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcClassicLinkResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseVpcsTypeDef",
    {
        "ClassicLinkEnabled": bool,
        "Tags": List[ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeVpcClassicLinkResponseVpcsTypeDef(
    _ClientDescribeVpcClassicLinkResponseVpcsTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLinkResponse` `Vpcs`

    Describes whether a VPC is enabled for ClassicLink.

    - **ClassicLinkEnabled** *(boolean) --*

      Indicates whether the VPC is enabled for ClassicLink.

    - **Tags** *(list) --*

      Any tags assigned to the VPC.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseTypeDef",
    {"Vpcs": List[ClientDescribeVpcClassicLinkResponseVpcsTypeDef]},
    total=False,
)


class ClientDescribeVpcClassicLinkResponseTypeDef(
    _ClientDescribeVpcClassicLinkResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcClassicLink` `Response`

    - **Vpcs** *(list) --*

      The ClassicLink status of one or more VPCs.

      - *(dict) --*

        Describes whether a VPC is enabled for ClassicLink.

        - **ClassicLinkEnabled** *(boolean) --*

          Indicates whether the VPC is enabled for ClassicLink.

        - **Tags** *(list) --*

          Any tags assigned to the VPC.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.
    """


_ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnectionNotifications` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnectionNotificationsResponse` `ConnectionNotificationSet`

    Describes a connection notification for a VPC endpoint or VPC endpoint service.

    - **ConnectionNotificationId** *(string) --*

      The ID of the notification.

    - **ServiceId** *(string) --*

      The ID of the endpoint service.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **ConnectionNotificationType** *(string) --*

      The type of notification.

    - **ConnectionNotificationArn** *(string) --*

      The ARN of the SNS topic for the notification.

    - **ConnectionEvents** *(list) --*

      The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
      and ``Reject`` .

      - *(string) --*

    - **ConnectionNotificationState** *(string) --*

      The state of the notification.
    """


_ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef",
    {
        "ConnectionNotificationSet": List[
            ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnectionNotifications` `Response`

    - **ConnectionNotificationSet** *(list) --*

      One or more notifications.

      - *(dict) --*

        Describes a connection notification for a VPC endpoint or VPC endpoint service.

        - **ConnectionNotificationId** *(string) --*

          The ID of the notification.

        - **ServiceId** *(string) --*

          The ID of the endpoint service.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **ConnectionNotificationType** *(string) --*

          The type of notification.

        - **ConnectionNotificationArn** *(string) --*

          The ARN of the SNS topic for the notification.

        - **ConnectionEvents** *(list) --*

          The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
          and ``Reject`` .

          - *(string) --*

        - **ConnectionNotificationState** *(string) --*

          The state of the notification.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpcEndpointConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointConnectionsFiltersTypeDef(
    _ClientDescribeVpcEndpointConnectionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnections` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnections` `DnsEntries`

    Describes a DNS entry.

    - **DnsName** *(string) --*

      The DNS name.

    - **HostedZoneId** *(string) --*

      The ID of the private hosted zone.
    """


_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointId": str,
        "VpcEndpointOwner": str,
        "VpcEndpointState": str,
        "CreationTimestamp": datetime,
        "DnsEntries": List[
            ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef
        ],
        "NetworkLoadBalancerArns": List[str],
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnectionsResponse` `VpcEndpointConnections`

    Describes a VPC endpoint connection to a service.

    - **ServiceId** *(string) --*

      The ID of the service to which the endpoint is connected.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **VpcEndpointOwner** *(string) --*

      The AWS account ID of the owner of the VPC endpoint.

    - **VpcEndpointState** *(string) --*

      The state of the VPC endpoint.

    - **CreationTimestamp** *(datetime) --*

      The date and time the VPC endpoint was created.

    - **DnsEntries** *(list) --*

      The DNS entries for the VPC endpoint.

      - *(dict) --*

        Describes a DNS entry.

        - **DnsName** *(string) --*

          The DNS name.

        - **HostedZoneId** *(string) --*

          The ID of the private hosted zone.

    - **NetworkLoadBalancerArns** *(list) --*

      The Amazon Resource Names (ARNs) of the network load balancers for the service.

      - *(string) --*
    """


_ClientDescribeVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseTypeDef",
    {
        "VpcEndpointConnections": List[
            ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointConnections` `Response`

    - **VpcEndpointConnections** *(list) --*

      Information about one or more VPC endpoint connections.

      - *(dict) --*

        Describes a VPC endpoint connection to a service.

        - **ServiceId** *(string) --*

          The ID of the service to which the endpoint is connected.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **VpcEndpointOwner** *(string) --*

          The AWS account ID of the owner of the VPC endpoint.

        - **VpcEndpointState** *(string) --*

          The state of the VPC endpoint.

        - **CreationTimestamp** *(datetime) --*

          The date and time the VPC endpoint was created.

        - **DnsEntries** *(list) --*

          The DNS entries for the VPC endpoint.

          - *(dict) --*

            Describes a DNS entry.

            - **DnsName** *(string) --*

              The DNS name.

            - **HostedZoneId** *(string) --*

              The ID of the private hosted zone.

        - **NetworkLoadBalancerArns** *(list) --*

          The Amazon Resource Names (ARNs) of the network load balancers for the service.

          - *(string) --*

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServiceConfigurations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef",
    {"ServiceType": str},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurations` `ServiceType`

    Describes the type of service for a VPC endpoint.

    - **ServiceType** *(string) --*

      The type of service.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurations` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef",
    {
        "ServiceType": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": str,
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServiceConfigurationsResponse` `ServiceConfigurations`

    Describes a service configuration for a VPC endpoint service.

    - **ServiceType** *(list) --*

      The type of service.

      - *(dict) --*

        Describes the type of service for a VPC endpoint.

        - **ServiceType** *(string) --*

          The type of service.

    - **ServiceId** *(string) --*

      The ID of the service.

    - **ServiceName** *(string) --*

      The name of the service.

    - **ServiceState** *(string) --*

      The service state.

    - **AvailabilityZones** *(list) --*

      In the Availability Zones in which the service is available.

      - *(string) --*

    - **AcceptanceRequired** *(boolean) --*

      Indicates whether requests from other AWS accounts to create an endpoint to the service
      must first be accepted.

    - **ManagesVpcEndpoints** *(boolean) --*

      Indicates whether the service manages it's VPC endpoints. Management of the service VPC
      endpoints using the VPC endpoint API is restricted.

    - **NetworkLoadBalancerArns** *(list) --*

      The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

      - *(string) --*

    - **BaseEndpointDnsNames** *(list) --*

      The DNS names for the service.

      - *(string) --*

    - **PrivateDnsName** *(string) --*

      The private DNS name for the service.

    - **Tags** *(list) --*

      Any tags assigned to the service.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef",
    {
        "ServiceConfigurations": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServiceConfigurations` `Response`

    - **ServiceConfigurations** *(list) --*

      Information about one or more services.

      - *(dict) --*

        Describes a service configuration for a VPC endpoint service.

        - **ServiceType** *(list) --*

          The type of service.

          - *(dict) --*

            Describes the type of service for a VPC endpoint.

            - **ServiceType** *(string) --*

              The type of service.

        - **ServiceId** *(string) --*

          The ID of the service.

        - **ServiceName** *(string) --*

          The name of the service.

        - **ServiceState** *(string) --*

          The service state.

        - **AvailabilityZones** *(list) --*

          In the Availability Zones in which the service is available.

          - *(string) --*

        - **AcceptanceRequired** *(boolean) --*

          Indicates whether requests from other AWS accounts to create an endpoint to the service
          must first be accepted.

        - **ManagesVpcEndpoints** *(boolean) --*

          Indicates whether the service manages it's VPC endpoints. Management of the service VPC
          endpoints using the VPC endpoint API is restricted.

        - **NetworkLoadBalancerArns** *(list) --*

          The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

          - *(string) --*

        - **BaseEndpointDnsNames** *(list) --*

          The DNS names for the service.

          - *(string) --*

        - **PrivateDnsName** *(string) --*

          The private DNS name for the service.

        - **Tags** *(list) --*

          Any tags assigned to the service.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicePermissions` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef",
    {"PrincipalType": str, "Principal": str},
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicePermissionsResponse` `AllowedPrincipals`

    Describes a principal.

    - **PrincipalType** *(string) --*

      The type of principal.

    - **Principal** *(string) --*

      The Amazon Resource Name (ARN) of the principal.
    """


_ClientDescribeVpcEndpointServicePermissionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsResponseTypeDef",
    {
        "AllowedPrincipals": List[
            ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsResponseTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicePermissions` `Response`

    - **AllowedPrincipals** *(list) --*

      Information about one or more allowed principals.

      - *(dict) --*

        Describes a principal.

        - **PrincipalType** *(string) --*

          The type of principal.

        - **Principal** *(string) --*

          The Amazon Resource Name (ARN) of the principal.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpcEndpointServicesFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServicesFiltersTypeDef(
    _ClientDescribeVpcEndpointServicesFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServices` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef",
    {"ServiceType": str},
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicesResponseServiceDetails` `ServiceType`

    Describes the type of service for a VPC endpoint.

    - **ServiceType** *(string) --*

      The type of service.
    """


_ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicesResponseServiceDetails` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef",
    {
        "ServiceName": str,
        "ServiceId": str,
        "ServiceType": List[
            ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef
        ],
        "AvailabilityZones": List[str],
        "Owner": str,
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "VpcEndpointPolicySupported": bool,
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "Tags": List[
            ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServicesResponse` `ServiceDetails`

    Describes a VPC endpoint service.

    - **ServiceName** *(string) --*

      The Amazon Resource Name (ARN) of the service.

    - **ServiceId** *(string) --*

      The ID of the endpoint service.

    - **ServiceType** *(list) --*

      The type of service.

      - *(dict) --*

        Describes the type of service for a VPC endpoint.

        - **ServiceType** *(string) --*

          The type of service.

    - **AvailabilityZones** *(list) --*

      The Availability Zones in which the service is available.

      - *(string) --*

    - **Owner** *(string) --*

      The AWS account ID of the service owner.

    - **BaseEndpointDnsNames** *(list) --*

      The DNS names for the service.

      - *(string) --*

    - **PrivateDnsName** *(string) --*

      The private DNS name for the service.

    - **VpcEndpointPolicySupported** *(boolean) --*

      Indicates whether the service supports endpoint policies.

    - **AcceptanceRequired** *(boolean) --*

      Indicates whether VPC endpoint connection requests to the service must be accepted by the
      service owner.

    - **ManagesVpcEndpoints** *(boolean) --*

      Indicates whether the service manages it's VPC endpoints. Management of the service VPC
      endpoints using the VPC endpoint API is restricted.

    - **Tags** *(list) --*

      Any tags assigned to the service.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeVpcEndpointServicesResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseTypeDef",
    {
        "ServiceNames": List[str],
        "ServiceDetails": List[
            ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseTypeDef(
    _ClientDescribeVpcEndpointServicesResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointServices` `Response`

    Contains the output of DescribeVpcEndpointServices.

    - **ServiceNames** *(list) --*

      A list of supported services.

      - *(string) --*

    - **ServiceDetails** *(list) --*

      Information about the service.

      - *(dict) --*

        Describes a VPC endpoint service.

        - **ServiceName** *(string) --*

          The Amazon Resource Name (ARN) of the service.

        - **ServiceId** *(string) --*

          The ID of the endpoint service.

        - **ServiceType** *(list) --*

          The type of service.

          - *(dict) --*

            Describes the type of service for a VPC endpoint.

            - **ServiceType** *(string) --*

              The type of service.

        - **AvailabilityZones** *(list) --*

          The Availability Zones in which the service is available.

          - *(string) --*

        - **Owner** *(string) --*

          The AWS account ID of the service owner.

        - **BaseEndpointDnsNames** *(list) --*

          The DNS names for the service.

          - *(string) --*

        - **PrivateDnsName** *(string) --*

          The private DNS name for the service.

        - **VpcEndpointPolicySupported** *(boolean) --*

          Indicates whether the service supports endpoint policies.

        - **AcceptanceRequired** *(boolean) --*

          Indicates whether VPC endpoint connection requests to the service must be accepted by the
          service owner.

        - **ManagesVpcEndpoints** *(boolean) --*

          Indicates whether the service manages it's VPC endpoints. Management of the service VPC
          endpoints using the VPC endpoint API is restricted.

        - **Tags** *(list) --*

          Any tags assigned to the service.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use when requesting the next set of items. If there are no additional items to
      return, the string is empty.
    """


_ClientDescribeVpcEndpointsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointsFiltersTypeDef(
    _ClientDescribeVpcEndpointsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpoints` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointsResponseVpcEndpoints` `DnsEntries`

    Describes a DNS entry.

    - **DnsName** *(string) --*

      The DNS name.

    - **HostedZoneId** *(string) --*

      The ID of the private hosted zone.
    """


_ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointsResponseVpcEndpoints` `Groups`

    Describes a security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group.
    """


_ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointsResponseVpcEndpoints` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": str,
        "VpcId": str,
        "ServiceName": str,
        "State": str,
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[
            ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef
        ],
        "CreationTimestamp": datetime,
        "Tags": List[ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpointsResponse` `VpcEndpoints`

    Describes a VPC endpoint.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **VpcEndpointType** *(string) --*

      The type of endpoint.

    - **VpcId** *(string) --*

      The ID of the VPC to which the endpoint is associated.

    - **ServiceName** *(string) --*

      The name of the service to which the endpoint is associated.

    - **State** *(string) --*

      The state of the VPC endpoint.

    - **PolicyDocument** *(string) --*

      The policy document associated with the endpoint, if applicable.

    - **RouteTableIds** *(list) --*

      (Gateway endpoint) One or more route tables associated with the endpoint.

      - *(string) --*

    - **SubnetIds** *(list) --*

      (Interface endpoint) One or more subnets in which the endpoint is located.

      - *(string) --*

    - **Groups** *(list) --*

      (Interface endpoint) Information about the security groups associated with the network
      interface.

      - *(dict) --*

        Describes a security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

    - **PrivateDnsEnabled** *(boolean) --*

      (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

    - **RequesterManaged** *(boolean) --*

      Indicates whether the VPC endpoint is being managed by its service.

    - **NetworkInterfaceIds** *(list) --*

      (Interface endpoint) One or more network interfaces for the endpoint.

      - *(string) --*

    - **DnsEntries** *(list) --*

      (Interface endpoint) The DNS entries for the endpoint.

      - *(dict) --*

        Describes a DNS entry.

        - **DnsName** *(string) --*

          The DNS name.

        - **HostedZoneId** *(string) --*

          The ID of the private hosted zone.

    - **CreationTimestamp** *(datetime) --*

      The date and time the VPC endpoint was created.

    - **Tags** *(list) --*

      Any tags assigned to the VPC endpoint.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC endpoint.
    """


_ClientDescribeVpcEndpointsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseTypeDef",
    {
        "VpcEndpoints": List[ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointsResponseTypeDef(
    _ClientDescribeVpcEndpointsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcEndpoints` `Response`

    Contains the output of DescribeVpcEndpoints.

    - **VpcEndpoints** *(list) --*

      Information about the endpoints.

      - *(dict) --*

        Describes a VPC endpoint.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **VpcEndpointType** *(string) --*

          The type of endpoint.

        - **VpcId** *(string) --*

          The ID of the VPC to which the endpoint is associated.

        - **ServiceName** *(string) --*

          The name of the service to which the endpoint is associated.

        - **State** *(string) --*

          The state of the VPC endpoint.

        - **PolicyDocument** *(string) --*

          The policy document associated with the endpoint, if applicable.

        - **RouteTableIds** *(list) --*

          (Gateway endpoint) One or more route tables associated with the endpoint.

          - *(string) --*

        - **SubnetIds** *(list) --*

          (Interface endpoint) One or more subnets in which the endpoint is located.

          - *(string) --*

        - **Groups** *(list) --*

          (Interface endpoint) Information about the security groups associated with the network
          interface.

          - *(dict) --*

            Describes a security group.

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group.

        - **PrivateDnsEnabled** *(boolean) --*

          (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

        - **RequesterManaged** *(boolean) --*

          Indicates whether the VPC endpoint is being managed by its service.

        - **NetworkInterfaceIds** *(list) --*

          (Interface endpoint) One or more network interfaces for the endpoint.

          - *(string) --*

        - **DnsEntries** *(list) --*

          (Interface endpoint) The DNS entries for the endpoint.

          - *(dict) --*

            Describes a DNS entry.

            - **DnsName** *(string) --*

              The DNS name.

            - **HostedZoneId** *(string) --*

              The ID of the private hosted zone.

        - **CreationTimestamp** *(datetime) --*

          The date and time the VPC endpoint was created.

        - **Tags** *(list) --*

          Any tags assigned to the VPC endpoint.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the VPC endpoint.

    - **NextToken** *(string) --*

      The token to use when requesting the next set of items. If there are no additional items to
      return, the string is empty.
    """


_ClientDescribeVpcPeeringConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsFiltersTypeDef(
    _ClientDescribeVpcPeeringConnectionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnections` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP
      addresses when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC
      over the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the
      peer VPC over the VPC peering connection.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnections` `AccepterVpcInfo`

    Information about the accepter VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP
        addresses when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC
        over the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the
        peer VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP
      addresses when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC
      over the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the
      peer VPC over the VPC peering connection.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnections` `RequesterVpcInfo`

    Information about the requester VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP
        addresses when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC
        over the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the
        peer VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnections` `Status`

    The status of the VPC peering connection.

    - **Code** *(string) --*

      The status of the VPC peering connection.

    - **Message** *(string) --*

      A message that provides more information about the status, if applicable.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnections` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef",
    {
        "AccepterVpcInfo": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef,
        "Status": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef,
        "Tags": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef
        ],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnectionsResponse` `VpcPeeringConnections`

    Describes a VPC peering connection.

    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP
          addresses when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC
          over the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the
          peer VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **ExpirationTime** *(datetime) --*

      The time that an unaccepted VPC peering connection will expire.

    - **RequesterVpcInfo** *(dict) --*

      Information about the requester VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP
          addresses when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC
          over the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the
          peer VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **Status** *(dict) --*

      The status of the VPC peering connection.

      - **Code** *(string) --*

        The status of the VPC peering connection.

      - **Message** *(string) --*

        A message that provides more information about the status, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_ClientDescribeVpcPeeringConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseTypeDef",
    {
        "VpcPeeringConnections": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpcPeeringConnections` `Response`

    - **VpcPeeringConnections** *(list) --*

      Information about the VPC peering connections.

      - *(dict) --*

        Describes a VPC peering connection.

        - **AccepterVpcInfo** *(dict) --*

          Information about the accepter VPC. CIDR block information is only returned when
          describing an active VPC peering connection.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.

          - **Ipv6CidrBlockSet** *(list) --*

            The IPv6 CIDR block for the VPC.

            - *(dict) --*

              Describes an IPv6 CIDR block.

              - **Ipv6CidrBlock** *(string) --*

                The IPv6 CIDR block.

          - **CidrBlockSet** *(list) --*

            Information about the IPv4 CIDR blocks for the VPC.

            - *(dict) --*

              Describes an IPv4 CIDR block.

              - **CidrBlock** *(string) --*

                The IPv4 CIDR block.

          - **OwnerId** *(string) --*

            The AWS account ID of the VPC owner.

          - **PeeringOptions** *(dict) --*

            Information about the VPC peering connection options for the accepter or requester VPC.

            - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

              Indicates whether a local VPC can resolve public DNS hostnames to private IP
              addresses when queried from instances in a peer VPC.

            - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

              Indicates whether a local ClassicLink connection can communicate with the peer VPC
              over the VPC peering connection.

            - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

              Indicates whether a local VPC can communicate with a ClassicLink connection in the
              peer VPC over the VPC peering connection.

          - **VpcId** *(string) --*

            The ID of the VPC.

          - **Region** *(string) --*

            The Region in which the VPC is located.

        - **ExpirationTime** *(datetime) --*

          The time that an unaccepted VPC peering connection will expire.

        - **RequesterVpcInfo** *(dict) --*

          Information about the requester VPC. CIDR block information is only returned when
          describing an active VPC peering connection.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.

          - **Ipv6CidrBlockSet** *(list) --*

            The IPv6 CIDR block for the VPC.

            - *(dict) --*

              Describes an IPv6 CIDR block.

              - **Ipv6CidrBlock** *(string) --*

                The IPv6 CIDR block.

          - **CidrBlockSet** *(list) --*

            Information about the IPv4 CIDR blocks for the VPC.

            - *(dict) --*

              Describes an IPv4 CIDR block.

              - **CidrBlock** *(string) --*

                The IPv4 CIDR block.

          - **OwnerId** *(string) --*

            The AWS account ID of the VPC owner.

          - **PeeringOptions** *(dict) --*

            Information about the VPC peering connection options for the accepter or requester VPC.

            - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

              Indicates whether a local VPC can resolve public DNS hostnames to private IP
              addresses when queried from instances in a peer VPC.

            - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

              Indicates whether a local ClassicLink connection can communicate with the peer VPC
              over the VPC peering connection.

            - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

              Indicates whether a local VPC can communicate with a ClassicLink connection in the
              peer VPC over the VPC peering connection.

          - **VpcId** *(string) --*

            The ID of the VPC.

          - **Region** *(string) --*

            The Region in which the VPC is located.

        - **Status** *(dict) --*

          The status of the VPC peering connection.

          - **Code** *(string) --*

            The status of the VPC peering connection.

          - **Message** *(string) --*

            A message that provides more information about the status, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpcsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpcsFiltersTypeDef(_ClientDescribeVpcsFiltersTypeDef):
    """
    Type definition for `ClientDescribeVpcs` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef
):
    """
    Type definition for `ClientDescribeVpcsResponseVpcsCidrBlockAssociationSet` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef(
    _ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcsResponseVpcs` `CidrBlockAssociationSet`

    Describes an IPv4 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef(
    _ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `ClientDescribeVpcsResponseVpcs` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDescribeVpcsResponseVpcsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcsResponseVpcsTagsTypeDef(
    _ClientDescribeVpcsResponseVpcsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpcsResponseVpcs` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpcsResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": str,
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": str,
        "Ipv6CidrBlockAssociationSet": List[
            ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[ClientDescribeVpcsResponseVpcsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsTypeDef(_ClientDescribeVpcsResponseVpcsTypeDef):
    """
    Type definition for `ClientDescribeVpcsResponse` `Vpcs`

    Describes a VPC.

    - **CidrBlock** *(string) --*

      The primary IPv4 CIDR block for the VPC.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
      default options are associated with the VPC).

    - **State** *(string) --*

      The current state of the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **InstanceTenancy** *(string) --*

      The allowed tenancy of instances launched into the VPC.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociationSet** *(list) --*

      Information about the IPv4 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

        - **CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **IsDefault** *(boolean) --*

      Indicates whether the VPC is the default VPC.

    - **Tags** *(list) --*

      Any tags assigned to the VPC.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeVpcsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseTypeDef",
    {"Vpcs": List[ClientDescribeVpcsResponseVpcsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeVpcsResponseTypeDef(_ClientDescribeVpcsResponseTypeDef):
    """
    Type definition for `ClientDescribeVpcs` `Response`

    - **Vpcs** *(list) --*

      Information about one or more VPCs.

      - *(dict) --*

        Describes a VPC.

        - **CidrBlock** *(string) --*

          The primary IPv4 CIDR block for the VPC.

        - **DhcpOptionsId** *(string) --*

          The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
          default options are associated with the VPC).

        - **State** *(string) --*

          The current state of the VPC.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the VPC.

        - **InstanceTenancy** *(string) --*

          The allowed tenancy of instances launched into the VPC.

        - **Ipv6CidrBlockAssociationSet** *(list) --*

          Information about the IPv6 CIDR blocks associated with the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block associated with a VPC.

            - **AssociationId** *(string) --*

              The association ID for the IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

            - **Ipv6CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of the CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **CidrBlockAssociationSet** *(list) --*

          Information about the IPv4 CIDR blocks associated with the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block associated with a VPC.

            - **AssociationId** *(string) --*

              The association ID for the IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

            - **CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of the CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **IsDefault** *(boolean) --*

          Indicates whether the VPC is the default VPC.

        - **Tags** *(list) --*

          Any tags assigned to the VPC.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientDescribeVpnConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpnConnectionsFiltersTypeDef(
    _ClientDescribeVpnConnectionsFiltersTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnections` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `IkeVersions`

    The internet key exchange (IKE) version permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase1DHGroupNumbers`

    The Diffie-Hellmann group number for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    The encryption algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    The integrity algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase2DHGroupNumbers`

    The Diffie-Hellmann group number for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    The encryption algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    The integrity algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnectionsOptions` `TunnelOptions`

    The VPN tunnel options.

    - **OutsideIpAddress** *(string) --*

      The external IP address of the VPN tunnel.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel.

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual
      private gateway and the customer gateway.

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the
      AWS side of the VPN connection performs an IKE rekey.

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
      which the rekey time is randomly selected.

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

    - **DpdTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

    - **Phase1EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IkeVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      - *(dict) --*

        The internet key exchange (IKE) version permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnections` `Options`

    The VPN connection options.

    - **StaticRoutesOnly** *(boolean) --*

      Indicates whether the VPN connection uses static routes only. Static routes must be
      used for devices that don't support BGP.

    - **TunnelOptions** *(list) --*

      Indicates the VPN tunnel options.

      - *(dict) --*

        The VPN tunnel options.

        - **OutsideIpAddress** *(string) --*

          The external IP address of the VPN tunnel.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel.

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual
          private gateway and the customer gateway.

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the
          AWS side of the VPN connection performs an IKE rekey.

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
          which the rekey time is randomly selected.

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

        - **DpdTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

        - **Phase1EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IkeVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          - *(dict) --*

            The internet key exchange (IKE) version permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef",
    {"DestinationCidrBlock": str, "Source": str, "State": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnections` `Routes`

    Describes a static route for a VPN connection.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block associated with the local subnet of the customer data center.

    - **Source** *(string) --*

      Indicates how the routes were provided.

    - **State** *(string) --*

      The current state of the static route.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnections` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": str,
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponseVpnConnections` `VgwTelemetry`

    Describes telemetry for a VPN tunnel.

    - **AcceptedRouteCount** *(integer) --*

      The number of accepted routes.

    - **LastStatusChange** *(datetime) --*

      The date and time of the last change in status.

    - **OutsideIpAddress** *(string) --*

      The Internet-routable IP address of the virtual private gateway's outside interface.

    - **Status** *(string) --*

      The status of the VPN tunnel.

    - **StatusMessage** *(string) --*

      If an error occurs, a description of the error.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": str,
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef,
        "Routes": List[ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef],
        "Tags": List[ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef],
        "VgwTelemetry": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnectionsResponse` `VpnConnections`

    Describes a VPN connection.

    - **CustomerGatewayConfiguration** *(string) --*

      The configuration information for the VPN connection's customer gateway (in the native
      XML format). This element is always present in the  CreateVpnConnection response;
      however, it's present in the  DescribeVpnConnections response only if the VPN connection
      is in the ``pending`` or ``available`` state.

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway at your end of the VPN connection.

    - **Category** *(string) --*

      The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
      value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

    - **State** *(string) --*

      The current state of the VPN connection.

    - **Type** *(string) --*

      The type of VPN connection.

    - **VpnConnectionId** *(string) --*

      The ID of the VPN connection.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway at the AWS side of the VPN connection.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway associated with the VPN connection.

    - **Options** *(dict) --*

      The VPN connection options.

      - **StaticRoutesOnly** *(boolean) --*

        Indicates whether the VPN connection uses static routes only. Static routes must be
        used for devices that don't support BGP.

      - **TunnelOptions** *(list) --*

        Indicates the VPN tunnel options.

        - *(dict) --*

          The VPN tunnel options.

          - **OutsideIpAddress** *(string) --*

            The external IP address of the VPN tunnel.

          - **TunnelInsideCidr** *(string) --*

            The range of inside IP addresses for the tunnel.

          - **PreSharedKey** *(string) --*

            The pre-shared key (PSK) to establish initial authentication between the virtual
            private gateway and the customer gateway.

          - **Phase1LifetimeSeconds** *(integer) --*

            The lifetime for phase 1 of the IKE negotiation, in seconds.

          - **Phase2LifetimeSeconds** *(integer) --*

            The lifetime for phase 2 of the IKE negotiation, in seconds.

          - **RekeyMarginTimeSeconds** *(integer) --*

            The margin time, in seconds, before the phase 2 lifetime expires, during which the
            AWS side of the VPN connection performs an IKE rekey.

          - **RekeyFuzzPercentage** *(integer) --*

            The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
            which the rekey time is randomly selected.

          - **ReplayWindowSize** *(integer) --*

            The number of packets in an IKE replay window.

          - **DpdTimeoutSeconds** *(integer) --*

            The number of seconds after which a DPD timeout occurs.

          - **Phase1EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the encryption algorithm.

          - **Phase2EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The encryption algorithm.

          - **Phase1IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the integrity algorithm.

          - **Phase2IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The integrity algorithm.

          - **Phase1DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 1 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **Phase2DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 2 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **IkeVersions** *(list) --*

            The IKE versions that are permitted for the VPN tunnel.

            - *(dict) --*

              The internet key exchange (IKE) version permitted for the VPN tunnel.

              - **Value** *(string) --*

                The IKE version.

    - **Routes** *(list) --*

      The static routes associated with the VPN connection.

      - *(dict) --*

        Describes a static route for a VPN connection.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block associated with the local subnet of the customer data center.

        - **Source** *(string) --*

          Indicates how the routes were provided.

        - **State** *(string) --*

          The current state of the static route.

    - **Tags** *(list) --*

      Any tags assigned to the VPN connection.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VgwTelemetry** *(list) --*

      Information about the VPN tunnel.

      - *(dict) --*

        Describes telemetry for a VPN tunnel.

        - **AcceptedRouteCount** *(integer) --*

          The number of accepted routes.

        - **LastStatusChange** *(datetime) --*

          The date and time of the last change in status.

        - **OutsideIpAddress** *(string) --*

          The Internet-routable IP address of the virtual private gateway's outside interface.

        - **Status** *(string) --*

          The status of the VPN tunnel.

        - **StatusMessage** *(string) --*

          If an error occurs, a description of the error.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientDescribeVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseTypeDef",
    {"VpnConnections": List[ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef]},
    total=False,
)


class ClientDescribeVpnConnectionsResponseTypeDef(
    _ClientDescribeVpnConnectionsResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpnConnections` `Response`

    Contains the output of DescribeVpnConnections.

    - **VpnConnections** *(list) --*

      Information about one or more VPN connections.

      - *(dict) --*

        Describes a VPN connection.

        - **CustomerGatewayConfiguration** *(string) --*

          The configuration information for the VPN connection's customer gateway (in the native
          XML format). This element is always present in the  CreateVpnConnection response;
          however, it's present in the  DescribeVpnConnections response only if the VPN connection
          is in the ``pending`` or ``available`` state.

        - **CustomerGatewayId** *(string) --*

          The ID of the customer gateway at your end of the VPN connection.

        - **Category** *(string) --*

          The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
          value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

        - **State** *(string) --*

          The current state of the VPN connection.

        - **Type** *(string) --*

          The type of VPN connection.

        - **VpnConnectionId** *(string) --*

          The ID of the VPN connection.

        - **VpnGatewayId** *(string) --*

          The ID of the virtual private gateway at the AWS side of the VPN connection.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway associated with the VPN connection.

        - **Options** *(dict) --*

          The VPN connection options.

          - **StaticRoutesOnly** *(boolean) --*

            Indicates whether the VPN connection uses static routes only. Static routes must be
            used for devices that don't support BGP.

          - **TunnelOptions** *(list) --*

            Indicates the VPN tunnel options.

            - *(dict) --*

              The VPN tunnel options.

              - **OutsideIpAddress** *(string) --*

                The external IP address of the VPN tunnel.

              - **TunnelInsideCidr** *(string) --*

                The range of inside IP addresses for the tunnel.

              - **PreSharedKey** *(string) --*

                The pre-shared key (PSK) to establish initial authentication between the virtual
                private gateway and the customer gateway.

              - **Phase1LifetimeSeconds** *(integer) --*

                The lifetime for phase 1 of the IKE negotiation, in seconds.

              - **Phase2LifetimeSeconds** *(integer) --*

                The lifetime for phase 2 of the IKE negotiation, in seconds.

              - **RekeyMarginTimeSeconds** *(integer) --*

                The margin time, in seconds, before the phase 2 lifetime expires, during which the
                AWS side of the VPN connection performs an IKE rekey.

              - **RekeyFuzzPercentage** *(integer) --*

                The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
                which the rekey time is randomly selected.

              - **ReplayWindowSize** *(integer) --*

                The number of packets in an IKE replay window.

              - **DpdTimeoutSeconds** *(integer) --*

                The number of seconds after which a DPD timeout occurs.

              - **Phase1EncryptionAlgorithms** *(list) --*

                The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

                - *(dict) --*

                  The encryption algorithm for phase 1 IKE negotiations.

                  - **Value** *(string) --*

                    The value for the encryption algorithm.

              - **Phase2EncryptionAlgorithms** *(list) --*

                The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

                - *(dict) --*

                  The encryption algorithm for phase 2 IKE negotiations.

                  - **Value** *(string) --*

                    The encryption algorithm.

              - **Phase1IntegrityAlgorithms** *(list) --*

                The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

                - *(dict) --*

                  The integrity algorithm for phase 1 IKE negotiations.

                  - **Value** *(string) --*

                    The value for the integrity algorithm.

              - **Phase2IntegrityAlgorithms** *(list) --*

                The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

                - *(dict) --*

                  The integrity algorithm for phase 2 IKE negotiations.

                  - **Value** *(string) --*

                    The integrity algorithm.

              - **Phase1DHGroupNumbers** *(list) --*

                The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
                negotiations.

                - *(dict) --*

                  The Diffie-Hellmann group number for phase 1 IKE negotiations.

                  - **Value** *(integer) --*

                    The Diffie-Hellmann group number.

              - **Phase2DHGroupNumbers** *(list) --*

                The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
                negotiations.

                - *(dict) --*

                  The Diffie-Hellmann group number for phase 2 IKE negotiations.

                  - **Value** *(integer) --*

                    The Diffie-Hellmann group number.

              - **IkeVersions** *(list) --*

                The IKE versions that are permitted for the VPN tunnel.

                - *(dict) --*

                  The internet key exchange (IKE) version permitted for the VPN tunnel.

                  - **Value** *(string) --*

                    The IKE version.

        - **Routes** *(list) --*

          The static routes associated with the VPN connection.

          - *(dict) --*

            Describes a static route for a VPN connection.

            - **DestinationCidrBlock** *(string) --*

              The CIDR block associated with the local subnet of the customer data center.

            - **Source** *(string) --*

              Indicates how the routes were provided.

            - **State** *(string) --*

              The current state of the static route.

        - **Tags** *(list) --*

          Any tags assigned to the VPN connection.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VgwTelemetry** *(list) --*

          Information about the VPN tunnel.

          - *(dict) --*

            Describes telemetry for a VPN tunnel.

            - **AcceptedRouteCount** *(integer) --*

              The number of accepted routes.

            - **LastStatusChange** *(datetime) --*

              The date and time of the last change in status.

            - **OutsideIpAddress** *(string) --*

              The Internet-routable IP address of the virtual private gateway's outside interface.

            - **Status** *(string) --*

              The status of the VPN tunnel.

            - **StatusMessage** *(string) --*

              If an error occurs, a description of the error.

            - **CertificateArn** *(string) --*

              The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientDescribeVpnGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpnGatewaysFiltersTypeDef(_ClientDescribeVpnGatewaysFiltersTypeDef):
    """
    Type definition for `ClientDescribeVpnGateways` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef
):
    """
    Type definition for `ClientDescribeVpnGatewaysResponseVpnGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef
):
    """
    Type definition for `ClientDescribeVpnGatewaysResponseVpnGateways` `VpcAttachments`

    Describes an attachment between a virtual private gateway and a VPC.

    - **State** *(string) --*

      The current state of the attachment.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef",
    {
        "AvailabilityZone": str,
        "State": str,
        "Type": str,
        "VpcAttachments": List[
            ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef
        ],
        "VpnGatewayId": str,
        "AmazonSideAsn": int,
        "Tags": List[ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef
):
    """
    Type definition for `ClientDescribeVpnGatewaysResponse` `VpnGateways`

    Describes a virtual private gateway.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the virtual private gateway was created, if applicable. This
      field may be empty or not returned.

    - **State** *(string) --*

      The current state of the virtual private gateway.

    - **Type** *(string) --*

      The type of VPN connection the virtual private gateway supports.

    - **VpcAttachments** *(list) --*

      Any VPCs attached to the virtual private gateway.

      - *(dict) --*

        Describes an attachment between a virtual private gateway and a VPC.

        - **State** *(string) --*

          The current state of the attachment.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway.

    - **AmazonSideAsn** *(integer) --*

      The private Autonomous System Number (ASN) for the Amazon side of a BGP session.

    - **Tags** *(list) --*

      Any tags assigned to the virtual private gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientDescribeVpnGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseTypeDef",
    {"VpnGateways": List[ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef]},
    total=False,
)


class ClientDescribeVpnGatewaysResponseTypeDef(
    _ClientDescribeVpnGatewaysResponseTypeDef
):
    """
    Type definition for `ClientDescribeVpnGateways` `Response`

    Contains the output of DescribeVpnGateways.

    - **VpnGateways** *(list) --*

      Information about one or more virtual private gateways.

      - *(dict) --*

        Describes a virtual private gateway.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the virtual private gateway was created, if applicable. This
          field may be empty or not returned.

        - **State** *(string) --*

          The current state of the virtual private gateway.

        - **Type** *(string) --*

          The type of VPN connection the virtual private gateway supports.

        - **VpcAttachments** *(list) --*

          Any VPCs attached to the virtual private gateway.

          - *(dict) --*

            Describes an attachment between a virtual private gateway and a VPC.

            - **State** *(string) --*

              The current state of the attachment.

            - **VpcId** *(string) --*

              The ID of the VPC.

        - **VpnGatewayId** *(string) --*

          The ID of the virtual private gateway.

        - **AmazonSideAsn** *(integer) --*

          The private Autonomous System Number (ASN) for the Amazon side of a BGP session.

        - **Tags** *(list) --*

          Any tags assigned to the virtual private gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientDetachClassicLinkVpcResponseTypeDef = TypedDict(
    "_ClientDetachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class ClientDetachClassicLinkVpcResponseTypeDef(
    _ClientDetachClassicLinkVpcResponseTypeDef
):
    """
    Type definition for `ClientDetachClassicLinkVpc` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDetachVolumeResponseTypeDef = TypedDict(
    "_ClientDetachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientDetachVolumeResponseTypeDef(_ClientDetachVolumeResponseTypeDef):
    """
    Type definition for `ClientDetachVolume` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_ClientDisableEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientDisableEbsEncryptionByDefaultResponseTypeDef",
    {"EbsEncryptionByDefault": bool},
    total=False,
)


class ClientDisableEbsEncryptionByDefaultResponseTypeDef(
    _ClientDisableEbsEncryptionByDefaultResponseTypeDef
):
    """
    Type definition for `ClientDisableEbsEncryptionByDefault` `Response`

    - **EbsEncryptionByDefault** *(boolean) --*

      The updated status of encryption by default.
    """


_ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef = TypedDict(
    "_ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "TransitGatewayRouteTableId": str,
        "State": str,
    },
    total=False,
)


class ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef(
    _ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
):
    """
    Type definition for `ClientDisableTransitGatewayRouteTablePropagationResponse` `Propagation`

    Information about route propagation.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **State** *(string) --*

      The state.
    """


_ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef = TypedDict(
    "_ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef",
    {
        "Propagation": ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
    },
    total=False,
)


class ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef(
    _ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef
):
    """
    Type definition for `ClientDisableTransitGatewayRouteTablePropagation` `Response`

    - **Propagation** *(dict) --*

      Information about route propagation.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **ResourceId** *(string) --*

        The ID of the resource.

      - **ResourceType** *(string) --*

        The resource type.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **State** *(string) --*

        The state.
    """


_ClientDisableVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientDisableVpcClassicLinkDnsSupportResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientDisableVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientDisableVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    Type definition for `ClientDisableVpcClassicLinkDnsSupport` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDisableVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientDisableVpcClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class ClientDisableVpcClassicLinkResponseTypeDef(
    _ClientDisableVpcClassicLinkResponseTypeDef
):
    """
    Type definition for `ClientDisableVpcClassicLink` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef = TypedDict(
    "_ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef(
    _ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef
):
    """
    Type definition for `ClientDisassociateClientVpnTargetNetworkResponse` `Status`

    The current state of the target network association.

    - **Code** *(string) --*

      The state of the target network association.

    - **Message** *(string) --*

      A message about the status of the target network association, if applicable.
    """


_ClientDisassociateClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientDisassociateClientVpnTargetNetworkResponseTypeDef",
    {
        "AssociationId": str,
        "Status": ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef,
    },
    total=False,
)


class ClientDisassociateClientVpnTargetNetworkResponseTypeDef(
    _ClientDisassociateClientVpnTargetNetworkResponseTypeDef
):
    """
    Type definition for `ClientDisassociateClientVpnTargetNetwork` `Response`

    - **AssociationId** *(string) --*

      The ID of the target network association.

    - **Status** *(dict) --*

      The current state of the target network association.

      - **Code** *(string) --*

        The state of the target network association.

      - **Message** *(string) --*

        A message about the status of the target network association, if applicable.
    """


_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociation` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef(
    _ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
):
    """
    Type definition for `ClientDisassociateIamInstanceProfileResponse` `IamInstanceProfileAssociation`

    Information about the IAM instance profile association.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **State** *(string) --*

      The state of the association.

    - **Timestamp** *(datetime) --*

      The time the IAM instance profile was associated with the instance.
    """


_ClientDisassociateIamInstanceProfileResponseTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseTypeDef(
    _ClientDisassociateIamInstanceProfileResponseTypeDef
):
    """
    Type definition for `ClientDisassociateIamInstanceProfile` `Response`

    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.

      - **AssociationId** *(string) --*

        The ID of the association.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Id** *(string) --*

          The ID of the instance profile.

      - **State** *(string) --*

        The state of the association.

      - **Timestamp** *(datetime) --*

        The time the IAM instance profile was associated with the instance.
    """


_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociation` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientDisassociateSubnetCidrBlockResponse` `Ipv6CidrBlockAssociation`

    Information about the IPv6 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateSubnetCidrBlockResponseTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "SubnetId": str,
    },
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseTypeDef
):
    """
    Type definition for `ClientDisassociateSubnetCidrBlock` `Response`

    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the CIDR block.

      - **Ipv6CidrBlock** *(string) --*

        The IPv6 CIDR block.

      - **Ipv6CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of a CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef = TypedDict(
    "_ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef(
    _ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef
):
    """
    Type definition for `ClientDisassociateTransitGatewayRouteTableResponse` `Association`

    Information about the association.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **State** *(string) --*

      The state of the association.
    """


_ClientDisassociateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientDisassociateTransitGatewayRouteTableResponseTypeDef",
    {
        "Association": ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef
    },
    total=False,
)


class ClientDisassociateTransitGatewayRouteTableResponseTypeDef(
    _ClientDisassociateTransitGatewayRouteTableResponseTypeDef
):
    """
    Type definition for `ClientDisassociateTransitGatewayRouteTable` `Response`

    - **Association** *(dict) --*

      Information about the association.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **ResourceId** *(string) --*

        The ID of the resource.

      - **ResourceType** *(string) --*

        The resource type.

      - **State** *(string) --*

        The state of the association.
    """


_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef(
    _ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef
):
    """
    Type definition for `ClientDisassociateVpcCidrBlockResponseCidrBlockAssociation` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef(
    _ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientDisassociateVpcCidrBlockResponse` `CidrBlockAssociation`

    Information about the IPv4 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociation` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    Type definition for `ClientDisassociateVpcCidrBlockResponse` `Ipv6CidrBlockAssociation`

    Information about the IPv6 CIDR block association.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_ClientDisassociateVpcCidrBlockResponseTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "CidrBlockAssociation": ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef,
        "VpcId": str,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseTypeDef(
    _ClientDisassociateVpcCidrBlockResponseTypeDef
):
    """
    Type definition for `ClientDisassociateVpcCidrBlock` `Response`

    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the IPv6 CIDR block.

      - **Ipv6CidrBlock** *(string) --*

        The IPv6 CIDR block.

      - **Ipv6CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of the CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociation** *(dict) --*

      Information about the IPv4 CIDR block association.

      - **AssociationId** *(string) --*

        The association ID for the IPv4 CIDR block.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block.

      - **CidrBlockState** *(dict) --*

        Information about the state of the CIDR block.

        - **State** *(string) --*

          The state of the CIDR block.

        - **StatusMessage** *(string) --*

          A message about the status of the CIDR block, if applicable.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_ClientEnableEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientEnableEbsEncryptionByDefaultResponseTypeDef",
    {"EbsEncryptionByDefault": bool},
    total=False,
)


class ClientEnableEbsEncryptionByDefaultResponseTypeDef(
    _ClientEnableEbsEncryptionByDefaultResponseTypeDef
):
    """
    Type definition for `ClientEnableEbsEncryptionByDefault` `Response`

    - **EbsEncryptionByDefault** *(boolean) --*

      The updated status of encryption by default.
    """


_ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef = TypedDict(
    "_ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "TransitGatewayRouteTableId": str,
        "State": str,
    },
    total=False,
)


class ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef(
    _ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
):
    """
    Type definition for `ClientEnableTransitGatewayRouteTablePropagationResponse` `Propagation`

    Information about route propagation.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **State** *(string) --*

      The state.
    """


_ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef = TypedDict(
    "_ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef",
    {
        "Propagation": ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
    },
    total=False,
)


class ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef(
    _ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef
):
    """
    Type definition for `ClientEnableTransitGatewayRouteTablePropagation` `Response`

    - **Propagation** *(dict) --*

      Information about route propagation.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **ResourceId** *(string) --*

        The ID of the resource.

      - **ResourceType** *(string) --*

        The resource type.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.

      - **State** *(string) --*

        The state.
    """


_ClientEnableVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientEnableVpcClassicLinkDnsSupportResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientEnableVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientEnableVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    Type definition for `ClientEnableVpcClassicLinkDnsSupport` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientEnableVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientEnableVpcClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class ClientEnableVpcClassicLinkResponseTypeDef(
    _ClientEnableVpcClassicLinkResponseTypeDef
):
    """
    Type definition for `ClientEnableVpcClassicLink` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef = TypedDict(
    "_ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef(
    _ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef
):
    """
    Type definition for `ClientExportClientVpnClientCertificateRevocationListResponse` `Status`

    The current state of the client certificate revocation list.

    - **Code** *(string) --*

      The state of the client certificate revocation list.

    - **Message** *(string) --*

      A message about the status of the client certificate revocation list, if applicable.
    """


_ClientExportClientVpnClientCertificateRevocationListResponseTypeDef = TypedDict(
    "_ClientExportClientVpnClientCertificateRevocationListResponseTypeDef",
    {
        "CertificateRevocationList": str,
        "Status": ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef,
    },
    total=False,
)


class ClientExportClientVpnClientCertificateRevocationListResponseTypeDef(
    _ClientExportClientVpnClientCertificateRevocationListResponseTypeDef
):
    """
    Type definition for `ClientExportClientVpnClientCertificateRevocationList` `Response`

    - **CertificateRevocationList** *(string) --*

      Information about the client certificate revocation list.

    - **Status** *(dict) --*

      The current state of the client certificate revocation list.

      - **Code** *(string) --*

        The state of the client certificate revocation list.

      - **Message** *(string) --*

        A message about the status of the client certificate revocation list, if applicable.
    """


_ClientExportClientVpnClientConfigurationResponseTypeDef = TypedDict(
    "_ClientExportClientVpnClientConfigurationResponseTypeDef",
    {"ClientConfiguration": str},
    total=False,
)


class ClientExportClientVpnClientConfigurationResponseTypeDef(
    _ClientExportClientVpnClientConfigurationResponseTypeDef
):
    """
    Type definition for `ClientExportClientVpnClientConfiguration` `Response`

    - **ClientConfiguration** *(string) --*

      The contents of the Client VPN endpoint configuration file.
    """


_ClientExportImageResponseS3ExportLocationTypeDef = TypedDict(
    "_ClientExportImageResponseS3ExportLocationTypeDef",
    {"S3Bucket": str, "S3Prefix": str},
    total=False,
)


class ClientExportImageResponseS3ExportLocationTypeDef(
    _ClientExportImageResponseS3ExportLocationTypeDef
):
    """
    Type definition for `ClientExportImageResponse` `S3ExportLocation`

    Information about the destination S3 bucket.

    - **S3Bucket** *(string) --*

      The destination S3 bucket.

    - **S3Prefix** *(string) --*

      The prefix (logical hierarchy) in the bucket.
    """


_ClientExportImageResponseTypeDef = TypedDict(
    "_ClientExportImageResponseTypeDef",
    {
        "Description": str,
        "DiskImageFormat": str,
        "ExportImageTaskId": str,
        "ImageId": str,
        "RoleName": str,
        "Progress": str,
        "S3ExportLocation": ClientExportImageResponseS3ExportLocationTypeDef,
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientExportImageResponseTypeDef(_ClientExportImageResponseTypeDef):
    """
    Type definition for `ClientExportImage` `Response`

    - **Description** *(string) --*

      A description of the image being exported.

    - **DiskImageFormat** *(string) --*

      The disk image format for the exported image.

    - **ExportImageTaskId** *(string) --*

      The ID of the export image task.

    - **ImageId** *(string) --*

      The ID of the image.

    - **RoleName** *(string) --*

      The name of the role that grants VM Import/Export permission to export images to your S3
      bucket.

    - **Progress** *(string) --*

      The percent complete of the export image task.

    - **S3ExportLocation** *(dict) --*

      Information about the destination S3 bucket.

      - **S3Bucket** *(string) --*

        The destination S3 bucket.

      - **S3Prefix** *(string) --*

        The prefix (logical hierarchy) in the bucket.

    - **Status** *(string) --*

      The status of the export image task. The possible values are ``active`` , ``completed`` ,
      ``deleting`` , and ``deleted`` .

    - **StatusMessage** *(string) --*

      The status message for the export image task.
    """


_RequiredClientExportImageS3ExportLocationTypeDef = TypedDict(
    "_RequiredClientExportImageS3ExportLocationTypeDef", {"S3Bucket": str}
)
_OptionalClientExportImageS3ExportLocationTypeDef = TypedDict(
    "_OptionalClientExportImageS3ExportLocationTypeDef", {"S3Prefix": str}, total=False
)


class ClientExportImageS3ExportLocationTypeDef(
    _RequiredClientExportImageS3ExportLocationTypeDef,
    _OptionalClientExportImageS3ExportLocationTypeDef,
):
    """
    Type definition for `ClientExportImage` `S3ExportLocation`

    Information about the destination S3 bucket. The bucket must exist and grant WRITE and READ_ACP
    permissions to the AWS account vm-import-export@amazon.com.

    - **S3Bucket** *(string) --* **[REQUIRED]**

      The destination S3 bucket.

    - **S3Prefix** *(string) --*

      The prefix (logical hierarchy) in the bucket.
    """


_ClientExportTransitGatewayRoutesFiltersTypeDef = TypedDict(
    "_ClientExportTransitGatewayRoutesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientExportTransitGatewayRoutesFiltersTypeDef(
    _ClientExportTransitGatewayRoutesFiltersTypeDef
):
    """
    Type definition for `ClientExportTransitGatewayRoutes` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientExportTransitGatewayRoutesResponseTypeDef = TypedDict(
    "_ClientExportTransitGatewayRoutesResponseTypeDef", {"S3Location": str}, total=False
)


class ClientExportTransitGatewayRoutesResponseTypeDef(
    _ClientExportTransitGatewayRoutesResponseTypeDef
):
    """
    Type definition for `ClientExportTransitGatewayRoutes` `Response`

    - **S3Location** *(string) --*

      The URL of the exported file in Amazon S3. For example, s3://*bucket_name*
      /VPCTransitGateway/TransitGatewayRouteTables/*file_name* .
    """


_ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef = TypedDict(
    "_ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef",
    {"AccountId": str, "UsedInstanceCount": int},
    total=False,
)


class ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef(
    _ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef
):
    """
    Type definition for `ClientGetCapacityReservationUsageResponse` `InstanceUsages`

    Information about the Capacity Reservation usage.

    - **AccountId** *(string) --*

      The ID of the AWS account that is making use of the Capacity Reservation.

    - **UsedInstanceCount** *(integer) --*

      The number of instances the AWS account currently has in the Capacity Reservation.
    """


_ClientGetCapacityReservationUsageResponseTypeDef = TypedDict(
    "_ClientGetCapacityReservationUsageResponseTypeDef",
    {
        "NextToken": str,
        "CapacityReservationId": str,
        "InstanceType": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "State": str,
        "InstanceUsages": List[
            ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef
        ],
    },
    total=False,
)


class ClientGetCapacityReservationUsageResponseTypeDef(
    _ClientGetCapacityReservationUsageResponseTypeDef
):
    """
    Type definition for `ClientGetCapacityReservationUsage` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **InstanceType** *(string) --*

      The type of instance for which the Capacity Reservation reserves capacity.

    - **TotalInstanceCount** *(integer) --*

      The number of instances for which the Capacity Reservation reserves capacity.

    - **AvailableInstanceCount** *(integer) --*

      The remaining capacity. Indicates the number of instances that can be launched in the
      Capacity Reservation.

    - **State** *(string) --*

      The current state of the Capacity Reservation. A Capacity Reservation can be in one of the
      following states:

      * ``active`` - The Capacity Reservation is active and the capacity is available for your use.

      * ``expired`` - The Capacity Reservation expired automatically at the date and time specified
      in your request. The reserved capacity is no longer available for your use.

      * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity is
      no longer available for your use.

      * ``pending`` - The Capacity Reservation request was successful but the capacity provisioning
      is still pending.

      * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
      invalid request parameters, capacity constraints, or instance limit constraints. Failed
      requests are retained for 60 minutes.

    - **InstanceUsages** *(list) --*

      Information about the Capacity Reservation usage.

      - *(dict) --*

        Information about the Capacity Reservation usage.

        - **AccountId** *(string) --*

          The ID of the AWS account that is making use of the Capacity Reservation.

        - **UsedInstanceCount** *(integer) --*

          The number of instances the AWS account currently has in the Capacity Reservation.
    """


_ClientGetConsoleOutputResponseTypeDef = TypedDict(
    "_ClientGetConsoleOutputResponseTypeDef",
    {"InstanceId": str, "Output": str, "Timestamp": datetime},
    total=False,
)


class ClientGetConsoleOutputResponseTypeDef(_ClientGetConsoleOutputResponseTypeDef):
    """
    Type definition for `ClientGetConsoleOutput` `Response`

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Output** *(string) --*

      The console output, base64-encoded. If you are using a command line tool, the tool decodes
      the output for you.

    - **Timestamp** *(datetime) --*

      The time at which the output was last updated.
    """


_ClientGetConsoleScreenshotResponseTypeDef = TypedDict(
    "_ClientGetConsoleScreenshotResponseTypeDef",
    {"ImageData": str, "InstanceId": str},
    total=False,
)


class ClientGetConsoleScreenshotResponseTypeDef(
    _ClientGetConsoleScreenshotResponseTypeDef
):
    """
    Type definition for `ClientGetConsoleScreenshot` `Response`

    - **ImageData** *(string) --*

      The data that comprises the image.

    - **InstanceId** *(string) --*

      The ID of the instance.
    """


_ClientGetEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientGetEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientGetEbsDefaultKmsKeyIdResponseTypeDef(
    _ClientGetEbsDefaultKmsKeyIdResponseTypeDef
):
    """
    Type definition for `ClientGetEbsDefaultKmsKeyId` `Response`

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the default CMK for encryption by default.
    """


_ClientGetEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientGetEbsEncryptionByDefaultResponseTypeDef",
    {"EbsEncryptionByDefault": bool},
    total=False,
)


class ClientGetEbsEncryptionByDefaultResponseTypeDef(
    _ClientGetEbsEncryptionByDefaultResponseTypeDef
):
    """
    Type definition for `ClientGetEbsEncryptionByDefault` `Response`

    - **EbsEncryptionByDefault** *(boolean) --*

      Indicates whether encryption by default is enabled.
    """


_ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef = TypedDict(
    "_ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "PaymentOption": str,
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef(
    _ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef
):
    """
    Type definition for `ClientGetHostReservationPurchasePreviewResponse` `Purchase`

    Describes the result of the purchase.

    - **CurrencyCode** *(string) --*

      The currency in which the ``UpfrontPrice`` and ``HourlyPrice`` amounts are specified. At
      this time, the only supported currency is ``USD`` .

    - **Duration** *(integer) --*

      The duration of the reservation's term in seconds.

    - **HostIdSet** *(list) --*

      The IDs of the Dedicated Hosts associated with the reservation.

      - *(string) --*

    - **HostReservationId** *(string) --*

      The ID of the reservation.

    - **HourlyPrice** *(string) --*

      The hourly price of the reservation per hour.

    - **InstanceFamily** *(string) --*

      The instance family on the Dedicated Host that the reservation can be associated with.

    - **PaymentOption** *(string) --*

      The payment option for the reservation.

    - **UpfrontPrice** *(string) --*

      The upfront price of the reservation.
    """


_ClientGetHostReservationPurchasePreviewResponseTypeDef = TypedDict(
    "_ClientGetHostReservationPurchasePreviewResponseTypeDef",
    {
        "CurrencyCode": str,
        "Purchase": List[
            ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef
        ],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
    },
    total=False,
)


class ClientGetHostReservationPurchasePreviewResponseTypeDef(
    _ClientGetHostReservationPurchasePreviewResponseTypeDef
):
    """
    Type definition for `ClientGetHostReservationPurchasePreview` `Response`

    - **CurrencyCode** *(string) --*

      The currency in which the ``totalUpfrontPrice`` and ``totalHourlyPrice`` amounts are
      specified. At this time, the only supported currency is ``USD`` .

    - **Purchase** *(list) --*

      The purchase information of the Dedicated Host reservation and the Dedicated Hosts associated
      with it.

      - *(dict) --*

        Describes the result of the purchase.

        - **CurrencyCode** *(string) --*

          The currency in which the ``UpfrontPrice`` and ``HourlyPrice`` amounts are specified. At
          this time, the only supported currency is ``USD`` .

        - **Duration** *(integer) --*

          The duration of the reservation's term in seconds.

        - **HostIdSet** *(list) --*

          The IDs of the Dedicated Hosts associated with the reservation.

          - *(string) --*

        - **HostReservationId** *(string) --*

          The ID of the reservation.

        - **HourlyPrice** *(string) --*

          The hourly price of the reservation per hour.

        - **InstanceFamily** *(string) --*

          The instance family on the Dedicated Host that the reservation can be associated with.

        - **PaymentOption** *(string) --*

          The payment option for the reservation.

        - **UpfrontPrice** *(string) --*

          The upfront price of the reservation.

    - **TotalHourlyPrice** *(string) --*

      The potential total hourly price of the reservation per hour.

    - **TotalUpfrontPrice** *(string) --*

      The potential total upfront price. This is billed immediately.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Information about the block device for an EBS volume.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **VolumeType** *(string) --*

      The volume type.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name.

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN).

    - **Ebs** *(dict) --*

      Information about the block device for an EBS volume.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `ElasticGpuSpecifications`

    Describes an elastic GPU.

    - **Type** *(string) --*

      The elastic GPU type.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --*

      The type of elastic inference accelerator. The possible values are eia1.medium,
      eia1.large, and eia1.xlarge.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is configured for hibernation. For more information, see
    `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
    Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , the instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes.
      This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until
      all instances launch, the request is canceled, or this date is reached. If the request
      is persistent, it remains active until it is canceled or this date and time is reached.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes.
        This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until
        all instances launch, the request is canceled, or this date is reached. If the request
        is persistent, it remains active until it is canceled or this date and time is reached.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to associate a public IPv4 address with eth0 for a new network
      interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses for the network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses for the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses for the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `Placement`

    The placement of the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponseLaunchTemplateData` `TagSpecifications`

    The tag specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource.

    - **Tags** *(list) --*

      The tags for the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateDataResponse` `LaunchTemplateData`

    The instance data.

    - **KernelId** *(string) --*

      The ID of the kernel, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mappings.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name.

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN).

        - **Ebs** *(dict) --*

          Information about the block device for an EBS volume.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      The network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to associate a public IPv4 address with eth0 for a new network
          interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses for the network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses for the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses for the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI that was used to launch the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.

    - **Placement** *(dict) --*

      The placement of the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk, if applicable.

    - **DisableApiTermination** *(boolean) --*

      If set to ``true`` , indicates that the instance cannot be terminated using the Amazon EC2
      console, command line tool, or API.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

    - **UserData** *(string) --*

      The user data for the instance.

    - **TagSpecifications** *(list) --*

      The tags.

      - *(dict) --*

        The tag specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource.

        - **Tags** *(list) --*

          The tags for the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      The elastic GPU specification.

      - *(dict) --*

        Describes an elastic GPU.

        - **Type** *(string) --*

          The elastic GPU type.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --*

          The type of elastic inference accelerator. The possible values are eia1.medium,
          eia1.large, and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      The security group IDs.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      The security group names.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in minutes.
          This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active until
          all instances launch, the request is canceled, or this date is reached. If the request
          is persistent, it remains active until it is canceled or this date and time is reached.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance.

      - **CpuCredits** *(string) --*

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
        ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
        attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is configured for hibernation. For more information, see
      `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , the instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.
    """


_ClientGetLaunchTemplateDataResponseTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseTypeDef",
    {
        "LaunchTemplateData": ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseTypeDef(
    _ClientGetLaunchTemplateDataResponseTypeDef
):
    """
    Type definition for `ClientGetLaunchTemplateData` `Response`

    - **LaunchTemplateData** *(dict) --*

      The instance data.

      - **KernelId** *(string) --*

        The ID of the kernel, if applicable.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for Amazon EBS I/O.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **BlockDeviceMappings** *(list) --*

        The block device mappings.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name.

          - **VirtualName** *(string) --*

            The virtual device name (ephemeralN).

          - **Ebs** *(dict) --*

            Information about the block device for an EBS volume.

            - **Encrypted** *(boolean) --*

              Indicates whether the EBS volume is encrypted.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports.

            - **KmsKeyId** *(string) --*

              The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

            - **VolumeType** *(string) --*

              The volume type.

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **NetworkInterfaces** *(list) --*

        The network interfaces.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to associate a public IPv4 address with eth0 for a new network
            interface.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **Description** *(string) --*

            A description for the network interface.

          - **DeviceIndex** *(integer) --*

            The device index for the network interface attachment.

          - **Groups** *(list) --*

            The IDs of one or more security groups.

            - *(string) --*

          - **InterfaceType** *(string) --*

            The type of network interface.

          - **Ipv6AddressCount** *(integer) --*

            The number of IPv6 addresses for the network interface.

          - **Ipv6Addresses** *(list) --*

            The IPv6 addresses for the network interface.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The primary private IPv4 address of the network interface.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses for the network interface.

          - **SubnetId** *(string) --*

            The ID of the subnet for the network interface.

      - **ImageId** *(string) --*

        The ID of the AMI that was used to launch the instance.

      - **InstanceType** *(string) --*

        The instance type.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **Monitoring** *(dict) --*

        The monitoring for the instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.

      - **Placement** *(dict) --*

        The placement of the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Affinity** *(string) --*

          The affinity setting for the instance on the Dedicated Host.

        - **GroupName** *(string) --*

          The name of the placement group for the instance.

        - **HostId** *(string) --*

          The ID of the Dedicated Host for the instance.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware.

        - **SpreadDomain** *(string) --*

          Reserved for future use.

      - **RamDiskId** *(string) --*

        The ID of the RAM disk, if applicable.

      - **DisableApiTermination** *(boolean) --*

        If set to ``true`` , indicates that the instance cannot be terminated using the Amazon EC2
        console, command line tool, or API.

      - **InstanceInitiatedShutdownBehavior** *(string) --*

        Indicates whether an instance stops or terminates when you initiate shutdown from the
        instance (using the operating system command for system shutdown).

      - **UserData** *(string) --*

        The user data for the instance.

      - **TagSpecifications** *(list) --*

        The tags.

        - *(dict) --*

          The tag specification for the launch template.

          - **ResourceType** *(string) --*

            The type of resource.

          - **Tags** *(list) --*

            The tags for the resource.

            - *(dict) --*

              Describes a tag.

              - **Key** *(string) --*

                The key of the tag.

                Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                characters. May not begin with ``aws:`` .

              - **Value** *(string) --*

                The value of the tag.

                Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                characters.

      - **ElasticGpuSpecifications** *(list) --*

        The elastic GPU specification.

        - *(dict) --*

          Describes an elastic GPU.

          - **Type** *(string) --*

            The elastic GPU type.

      - **ElasticInferenceAccelerators** *(list) --*

        The elastic inference accelerator for the instance.

        - *(dict) --*

          Describes an elastic inference accelerator.

          - **Type** *(string) --*

            The type of elastic inference accelerator. The possible values are eia1.medium,
            eia1.large, and eia1.xlarge.

      - **SecurityGroupIds** *(list) --*

        The security group IDs.

        - *(string) --*

      - **SecurityGroups** *(list) --*

        The security group names.

        - *(string) --*

      - **InstanceMarketOptions** *(dict) --*

        The market (purchasing) option for the instances.

        - **MarketType** *(string) --*

          The market type.

        - **SpotOptions** *(dict) --*

          The options for Spot Instances.

          - **MaxPrice** *(string) --*

            The maximum hourly price you're willing to pay for the Spot Instances.

          - **SpotInstanceType** *(string) --*

            The Spot Instance request type.

          - **BlockDurationMinutes** *(integer) --*

            The required duration for the Spot Instances (also known as Spot blocks), in minutes.
            This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

          - **ValidUntil** *(datetime) --*

            The end date of the request. For a one-time request, the request remains active until
            all instances launch, the request is canceled, or this date is reached. If the request
            is persistent, it remains active until it is canceled or this date and time is reached.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted.

      - **CreditSpecification** *(dict) --*

        The credit option for CPU usage of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
          ``unlimited`` .

      - **CpuOptions** *(dict) --*

        The CPU options for the instance. For more information, see `Optimizing CPU Options
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        - **CoreCount** *(integer) --*

          The number of CPU cores for the instance.

        - **ThreadsPerCore** *(integer) --*

          The number of threads per CPU core.

      - **CapacityReservationSpecification** *(dict) --*

        Information about the Capacity Reservation targeting option.

        - **CapacityReservationPreference** *(string) --*

          Indicates the instance's Capacity Reservation preferences. Possible preferences include:

          * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
          attributes (instance type, platform, Availability Zone).

          * ``none`` - The instance avoids running in a Capacity Reservation even if one is
          available. The instance runs in On-Demand capacity.

        - **CapacityReservationTarget** *(dict) --*

          Information about the target Capacity Reservation.

          - **CapacityReservationId** *(string) --*

            The ID of the Capacity Reservation.

      - **LicenseSpecifications** *(list) --*

        The license configurations.

        - *(dict) --*

          Describes a license configuration.

          - **LicenseConfigurationArn** *(string) --*

            The Amazon Resource Name (ARN) of the license configuration.

      - **HibernationOptions** *(dict) --*

        Indicates whether an instance is configured for hibernation. For more information, see
        `Hibernate Your Instance
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        - **Configured** *(boolean) --*

          If this parameter is set to ``true`` , the instance is enabled for hibernation;
          otherwise, it is not enabled for hibernation.
    """


_ClientGetPasswordDataResponseTypeDef = TypedDict(
    "_ClientGetPasswordDataResponseTypeDef",
    {"InstanceId": str, "PasswordData": str, "Timestamp": datetime},
    total=False,
)


class ClientGetPasswordDataResponseTypeDef(_ClientGetPasswordDataResponseTypeDef):
    """
    Type definition for `ClientGetPasswordData` `Response`

    - **InstanceId** *(string) --*

      The ID of the Windows instance.

    - **PasswordData** *(string) --*

      The password of the instance. Returns an empty string if the password is not available.

    - **Timestamp** *(datetime) --*

      The time the data was last updated.
    """


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponse` `ReservedInstanceValueRollup`

    The cost associated with the Reserved Instance.

    - **HourlyPrice** *(string) --*

      The hourly rate of the reservation.

    - **RemainingTotalValue** *(string) --*

      The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number of
      hours remaining).

    - **RemainingUpfrontValue** *(string) --*

      The remaining upfront cost of the reservation.
    """


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSet` `ReservationValue`

    The total value of the Convertible Reserved Instance that you are exchanging.

    - **HourlyPrice** *(string) --*

      The hourly rate of the reservation.

    - **RemainingTotalValue** *(string) --*

      The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
      of hours remaining).

    - **RemainingUpfrontValue** *(string) --*

      The remaining upfront cost of the reservation.
    """


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef",
    {
        "ReservationValue": ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef,
        "ReservedInstanceId": str,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponse` `ReservedInstanceValueSet`

    The total value of the Convertible Reserved Instance.

    - **ReservationValue** *(dict) --*

      The total value of the Convertible Reserved Instance that you are exchanging.

      - **HourlyPrice** *(string) --*

        The hourly rate of the reservation.

      - **RemainingTotalValue** *(string) --*

        The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
        of hours remaining).

      - **RemainingUpfrontValue** *(string) --*

        The remaining upfront cost of the reservation.

    - **ReservedInstanceId** *(string) --*

      The ID of the Convertible Reserved Instance that you are exchanging.
    """


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponse` `TargetConfigurationValueRollup`

    The cost associated with the Reserved Instance.

    - **HourlyPrice** *(string) --*

      The hourly rate of the reservation.

    - **RemainingTotalValue** *(string) --*

      The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number of
      hours remaining).

    - **RemainingUpfrontValue** *(string) --*

      The remaining upfront cost of the reservation.
    """


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSet` `ReservationValue`

    The total value of the Convertible Reserved Instances that make up the exchange. This is
    the sum of the list value, remaining upfront price, and additional upfront cost of the
    exchange.

    - **HourlyPrice** *(string) --*

      The hourly rate of the reservation.

    - **RemainingTotalValue** *(string) --*

      The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
      of hours remaining).

    - **RemainingUpfrontValue** *(string) --*

      The remaining upfront cost of the reservation.
    """


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef",
    {"InstanceCount": int, "OfferingId": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSet` `TargetConfiguration`

    The configuration of the Convertible Reserved Instances that make up the exchange.

    - **InstanceCount** *(integer) --*

      The number of instances the Convertible Reserved Instance offering can be applied to.
      This parameter is reserved and cannot be specified in a request

    - **OfferingId** *(string) --*

      The ID of the Convertible Reserved Instance offering.
    """


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef",
    {
        "ReservationValue": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef,
        "TargetConfiguration": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuoteResponse` `TargetConfigurationValueSet`

    The total value of the new Convertible Reserved Instances.

    - **ReservationValue** *(dict) --*

      The total value of the Convertible Reserved Instances that make up the exchange. This is
      the sum of the list value, remaining upfront price, and additional upfront cost of the
      exchange.

      - **HourlyPrice** *(string) --*

        The hourly rate of the reservation.

      - **RemainingTotalValue** *(string) --*

        The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
        of hours remaining).

      - **RemainingUpfrontValue** *(string) --*

        The remaining upfront cost of the reservation.

    - **TargetConfiguration** *(dict) --*

      The configuration of the Convertible Reserved Instances that make up the exchange.

      - **InstanceCount** *(integer) --*

        The number of instances the Convertible Reserved Instance offering can be applied to.
        This parameter is reserved and cannot be specified in a request

      - **OfferingId** *(string) --*

        The ID of the Convertible Reserved Instance offering.
    """


_ClientGetReservedInstancesExchangeQuoteResponseTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTypeDef",
    {
        "CurrencyCode": str,
        "IsValidExchange": bool,
        "OutputReservedInstancesWillExpireAt": datetime,
        "PaymentDue": str,
        "ReservedInstanceValueRollup": ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef,
        "ReservedInstanceValueSet": List[
            ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef
        ],
        "TargetConfigurationValueRollup": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef,
        "TargetConfigurationValueSet": List[
            ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef
        ],
        "ValidationFailureReason": str,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTypeDef
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuote` `Response`

    Contains the output of GetReservedInstancesExchangeQuote.

    - **CurrencyCode** *(string) --*

      The currency of the transaction.

    - **IsValidExchange** *(boolean) --*

      If ``true`` , the exchange is valid. If ``false`` , the exchange cannot be completed.

    - **OutputReservedInstancesWillExpireAt** *(datetime) --*

      The new end date of the reservation term.

    - **PaymentDue** *(string) --*

      The total true upfront charge for the exchange.

    - **ReservedInstanceValueRollup** *(dict) --*

      The cost associated with the Reserved Instance.

      - **HourlyPrice** *(string) --*

        The hourly rate of the reservation.

      - **RemainingTotalValue** *(string) --*

        The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number of
        hours remaining).

      - **RemainingUpfrontValue** *(string) --*

        The remaining upfront cost of the reservation.

    - **ReservedInstanceValueSet** *(list) --*

      The configuration of your Convertible Reserved Instances.

      - *(dict) --*

        The total value of the Convertible Reserved Instance.

        - **ReservationValue** *(dict) --*

          The total value of the Convertible Reserved Instance that you are exchanging.

          - **HourlyPrice** *(string) --*

            The hourly rate of the reservation.

          - **RemainingTotalValue** *(string) --*

            The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
            of hours remaining).

          - **RemainingUpfrontValue** *(string) --*

            The remaining upfront cost of the reservation.

        - **ReservedInstanceId** *(string) --*

          The ID of the Convertible Reserved Instance that you are exchanging.

    - **TargetConfigurationValueRollup** *(dict) --*

      The cost associated with the Reserved Instance.

      - **HourlyPrice** *(string) --*

        The hourly rate of the reservation.

      - **RemainingTotalValue** *(string) --*

        The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number of
        hours remaining).

      - **RemainingUpfrontValue** *(string) --*

        The remaining upfront cost of the reservation.

    - **TargetConfigurationValueSet** *(list) --*

      The values of the target Convertible Reserved Instances.

      - *(dict) --*

        The total value of the new Convertible Reserved Instances.

        - **ReservationValue** *(dict) --*

          The total value of the Convertible Reserved Instances that make up the exchange. This is
          the sum of the list value, remaining upfront price, and additional upfront cost of the
          exchange.

          - **HourlyPrice** *(string) --*

            The hourly rate of the reservation.

          - **RemainingTotalValue** *(string) --*

            The balance of the total value (the sum of remainingUpfrontValue + hourlyPrice * number
            of hours remaining).

          - **RemainingUpfrontValue** *(string) --*

            The remaining upfront cost of the reservation.

        - **TargetConfiguration** *(dict) --*

          The configuration of the Convertible Reserved Instances that make up the exchange.

          - **InstanceCount** *(integer) --*

            The number of instances the Convertible Reserved Instance offering can be applied to.
            This parameter is reserved and cannot be specified in a request

          - **OfferingId** *(string) --*

            The ID of the Convertible Reserved Instance offering.

    - **ValidationFailureReason** *(string) --*

      Describes the reason why the exchange cannot be completed.
    """


_RequiredClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_RequiredClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"OfferingId": str},
)
_OptionalClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_OptionalClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"InstanceCount": int},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef(
    _RequiredClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef,
    _OptionalClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef,
):
    """
    Type definition for `ClientGetReservedInstancesExchangeQuote` `TargetConfigurations`

    Details about the target configuration.

    - **InstanceCount** *(integer) --*

      The number of instances the Covertible Reserved Instance offering can be applied to. This
      parameter is reserved and cannot be specified in a request

    - **OfferingId** *(string) --* **[REQUIRED]**

      The Convertible Reserved Instance offering ID.
    """


_ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayAttachmentPropagations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef",
    {"TransitGatewayRouteTableId": str, "State": str},
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayAttachmentPropagationsResponse` `TransitGatewayAttachmentPropagations`

    Describes a propagation route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the propagation route table.

    - **State** *(string) --*

      The state of the propagation route table.
    """


_ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef",
    {
        "TransitGatewayAttachmentPropagations": List[
            ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayAttachmentPropagations` `Response`

    - **TransitGatewayAttachmentPropagations** *(list) --*

      Information about the propagation route tables.

      - *(dict) --*

        Describes a propagation route table.

        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the propagation route table.

        - **State** *(string) --*

          The state of the propagation route table.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTableAssociations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTableAssociationsResponse` `Associations`

    Describes an association between a route table and a resource attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **State** *(string) --*

      The state of the association.
    """


_ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef",
    {
        "Associations": List[
            ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTableAssociations` `Response`

    - **Associations** *(list) --*

      Information about the associations.

      - *(dict) --*

        Describes an association between a route table and a resource attachment.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **State** *(string) --*

          The state of the association.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTablePropagations` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTablePropagationsResponse` `TransitGatewayRouteTablePropagations`

    Describes a route table propagation.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The type of resource.

    - **State** *(string) --*

      The state of the resource.
    """


_ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef",
    {
        "TransitGatewayRouteTablePropagations": List[
            ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef
):
    """
    Type definition for `ClientGetTransitGatewayRouteTablePropagations` `Response`

    - **TransitGatewayRouteTablePropagations** *(list) --*

      Information about the route table propagations.

      - *(dict) --*

        Describes a route table propagation.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The type of resource.

        - **State** *(string) --*

          The state of the resource.

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.
    """


_ClientImportClientVpnClientCertificateRevocationListResponseTypeDef = TypedDict(
    "_ClientImportClientVpnClientCertificateRevocationListResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientImportClientVpnClientCertificateRevocationListResponseTypeDef(
    _ClientImportClientVpnClientCertificateRevocationListResponseTypeDef
):
    """
    Type definition for `ClientImportClientVpnClientCertificateRevocationList` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientImportImageClientDataTypeDef = TypedDict(
    "_ClientImportImageClientDataTypeDef",
    {
        "Comment": str,
        "UploadEnd": datetime,
        "UploadSize": float,
        "UploadStart": datetime,
    },
    total=False,
)


class ClientImportImageClientDataTypeDef(_ClientImportImageClientDataTypeDef):
    """
    Type definition for `ClientImportImage` `ClientData`

    The client-specific data.

    - **Comment** *(string) --*

      A user-defined comment about the disk upload.

    - **UploadEnd** *(datetime) --*

      The time that the disk upload ends.

    - **UploadSize** *(float) --*

      The size of the uploaded disk image, in GiB.

    - **UploadStart** *(datetime) --*

      The time that the disk upload starts.
    """


_ClientImportImageDiskContainersUserBucketTypeDef = TypedDict(
    "_ClientImportImageDiskContainersUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportImageDiskContainersUserBucketTypeDef(
    _ClientImportImageDiskContainersUserBucketTypeDef
):
    """
    Type definition for `ClientImportImageDiskContainers` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The name of the S3 bucket where the disk image is located.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientImportImageDiskContainersTypeDef = TypedDict(
    "_ClientImportImageDiskContainersTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "Format": str,
        "SnapshotId": str,
        "Url": str,
        "UserBucket": ClientImportImageDiskContainersUserBucketTypeDef,
    },
    total=False,
)


class ClientImportImageDiskContainersTypeDef(_ClientImportImageDiskContainersTypeDef):
    """
    Type definition for `ClientImportImage` `DiskContainers`

    Describes the disk container object for an import image task.

    - **Description** *(string) --*

      The description of the disk image.

    - **DeviceName** *(string) --*

      The block device mapping for the disk.

    - **Format** *(string) --*

      The format of the disk image being imported.

      Valid values: ``VHD`` | ``VMDK`` | ``OVA``

    - **SnapshotId** *(string) --*

      The ID of the EBS snapshot to be used for importing the snapshot.

    - **Url** *(string) --*

      The URL to the Amazon S3-based disk image being imported. The URL can either be a https URL
      (https://..) or an Amazon S3 URL (s3://..)

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The name of the S3 bucket where the disk image is located.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientImportImageResponseSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_ClientImportImageResponseSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportImageResponseSnapshotDetailsUserBucketTypeDef(
    _ClientImportImageResponseSnapshotDetailsUserBucketTypeDef
):
    """
    Type definition for `ClientImportImageResponseSnapshotDetails` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientImportImageResponseSnapshotDetailsTypeDef = TypedDict(
    "_ClientImportImageResponseSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientImportImageResponseSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class ClientImportImageResponseSnapshotDetailsTypeDef(
    _ClientImportImageResponseSnapshotDetailsTypeDef
):
    """
    Type definition for `ClientImportImageResponse` `SnapshotDetails`

    Describes the snapshot created from the imported disk.

    - **Description** *(string) --*

      A description for the snapshot.

    - **DeviceName** *(string) --*

      The block device mapping for the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **Progress** *(string) --*

      The percentage of progress for the task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status of the snapshot creation.

    - **StatusMessage** *(string) --*

      A detailed status message for the snapshot creation.

    - **Url** *(string) --*

      The URL used to access the disk image.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientImportImageResponseTypeDef = TypedDict(
    "_ClientImportImageResponseTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[ClientImportImageResponseSnapshotDetailsTypeDef],
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientImportImageResponseTypeDef(_ClientImportImageResponseTypeDef):
    """
    Type definition for `ClientImportImage` `Response`

    - **Architecture** *(string) --*

      The architecture of the virtual machine.

    - **Description** *(string) --*

      A description of the import task.

    - **Encrypted** *(boolean) --*

      Indicates whether the AMI is encypted.

    - **Hypervisor** *(string) --*

      The target hypervisor of the import task.

    - **ImageId** *(string) --*

      The ID of the Amazon Machine Image (AMI) created by the import task.

    - **ImportTaskId** *(string) --*

      The task ID of the import image task.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK) that
      was used to create the encrypted AMI.

    - **LicenseType** *(string) --*

      The license type of the virtual machine.

    - **Platform** *(string) --*

      The operating system of the virtual machine.

    - **Progress** *(string) --*

      The progress of the task.

    - **SnapshotDetails** *(list) --*

      Information about the snapshots.

      - *(dict) --*

        Describes the snapshot created from the imported disk.

        - **Description** *(string) --*

          A description for the snapshot.

        - **DeviceName** *(string) --*

          The block device mapping for the snapshot.

        - **DiskImageSize** *(float) --*

          The size of the disk in the snapshot, in GiB.

        - **Format** *(string) --*

          The format of the disk image from which the snapshot is created.

        - **Progress** *(string) --*

          The percentage of progress for the task.

        - **SnapshotId** *(string) --*

          The snapshot ID of the disk being imported.

        - **Status** *(string) --*

          A brief status of the snapshot creation.

        - **StatusMessage** *(string) --*

          A detailed status message for the snapshot creation.

        - **Url** *(string) --*

          The URL used to access the disk image.

        - **UserBucket** *(dict) --*

          The S3 bucket for the disk image.

          - **S3Bucket** *(string) --*

            The S3 bucket from which the disk image was created.

          - **S3Key** *(string) --*

            The file name of the disk image.

    - **Status** *(string) --*

      A brief status of the task.

    - **StatusMessage** *(string) --*

      A detailed status message of the import task.
    """


_ClientImportInstanceDiskImagesImageTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesImageTypeDef",
    {"Bytes": int, "Format": str, "ImportManifestUrl": str},
)


class ClientImportInstanceDiskImagesImageTypeDef(
    _ClientImportInstanceDiskImagesImageTypeDef
):
    """
    Type definition for `ClientImportInstanceDiskImages` `Image`

    Information about the disk image.

    - **Bytes** *(integer) --* **[REQUIRED]**

      The size of the disk image, in GiB.

    - **Format** *(string) --* **[REQUIRED]**

      The disk image format.

    - **ImportManifestUrl** *(string) --* **[REQUIRED]**

      A presigned URL for the import manifest stored in Amazon S3 and presented here as an Amazon
      S3 presigned URL. For information about creating a presigned URL for an Amazon S3 object,
      read the "Query String Request Authentication Alternative" section of the `Authenticating
      REST Requests <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
      topic in the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM Import
      Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .
    """


_ClientImportInstanceDiskImagesVolumeTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesVolumeTypeDef", {"Size": int}
)


class ClientImportInstanceDiskImagesVolumeTypeDef(
    _ClientImportInstanceDiskImagesVolumeTypeDef
):
    """
    Type definition for `ClientImportInstanceDiskImages` `Volume`

    Information about the volume.

    - **Size** *(integer) --* **[REQUIRED]**

      The size of the volume, in GiB.
    """


_ClientImportInstanceDiskImagesTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesTypeDef",
    {
        "Description": str,
        "Image": ClientImportInstanceDiskImagesImageTypeDef,
        "Volume": ClientImportInstanceDiskImagesVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceDiskImagesTypeDef(_ClientImportInstanceDiskImagesTypeDef):
    """
    Type definition for `ClientImportInstance` `DiskImages`

    Describes a disk image.

    - **Description** *(string) --*

      A description of the disk image.

    - **Image** *(dict) --*

      Information about the disk image.

      - **Bytes** *(integer) --* **[REQUIRED]**

        The size of the disk image, in GiB.

      - **Format** *(string) --* **[REQUIRED]**

        The disk image format.

      - **ImportManifestUrl** *(string) --* **[REQUIRED]**

        A presigned URL for the import manifest stored in Amazon S3 and presented here as an Amazon
        S3 presigned URL. For information about creating a presigned URL for an Amazon S3 object,
        read the "Query String Request Authentication Alternative" section of the `Authenticating
        REST Requests <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__
        topic in the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM Import
        Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Volume** *(dict) --*

      Information about the volume.

      - **Size** *(integer) --* **[REQUIRED]**

        The size of the volume, in GiB.
    """


_ClientImportInstanceLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientImportInstanceLaunchSpecificationPlacementTypeDef(
    _ClientImportInstanceLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `ClientImportInstanceLaunchSpecification` `Placement`

    The placement information for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not supported
      for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group strategy is
      set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not supported
      for the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for
      the  ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientImportInstanceLaunchSpecificationUserDataTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationUserDataTypeDef",
    {"Data": str},
    total=False,
)


class ClientImportInstanceLaunchSpecificationUserDataTypeDef(
    _ClientImportInstanceLaunchSpecificationUserDataTypeDef
):
    """
    Type definition for `ClientImportInstanceLaunchSpecification` `UserData`

    The Base64-encoded user data to make available to the instance.

    - **Data** *(string) --*

      The user data. If you are using an AWS SDK or command line tool, Base64-encoding is performed
      for you, and you can load the text from a file. Otherwise, you must provide Base64-encoded
      text.
    """


_ClientImportInstanceLaunchSpecificationTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationTypeDef",
    {
        "AdditionalInfo": str,
        "Architecture": str,
        "GroupIds": List[str],
        "GroupNames": List[str],
        "InstanceInitiatedShutdownBehavior": str,
        "InstanceType": str,
        "Monitoring": bool,
        "Placement": ClientImportInstanceLaunchSpecificationPlacementTypeDef,
        "PrivateIpAddress": str,
        "SubnetId": str,
        "UserData": ClientImportInstanceLaunchSpecificationUserDataTypeDef,
    },
    total=False,
)


class ClientImportInstanceLaunchSpecificationTypeDef(
    _ClientImportInstanceLaunchSpecificationTypeDef
):
    """
    Type definition for `ClientImportInstance` `LaunchSpecification`

    The launch specification.

    - **AdditionalInfo** *(string) --*

      Reserved.

    - **Architecture** *(string) --*

      The architecture of the instance.

    - **GroupIds** *(list) --*

      The security group IDs.

      - *(string) --*

    - **GroupNames** *(list) --*

      The security group names.

      - *(string) --*

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the instance
      (using the operating system command for system shutdown).

    - **InstanceType** *(string) --*

      The instance type. For more information about the instance types that you can import, see
      `Instance Types
      <https://docs.aws.amazon.com/vm-import/latest/userguide/vmie_prereqs.html#vmimport-instance-types>`__
      in the VM Import/Export User Guide.

    - **Monitoring** *(boolean) --*

      Indicates whether monitoring is enabled.

    - **Placement** *(dict) --*

      The placement information for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

        If not specified, an Availability Zone will be automatically chosen for you based on the load
        balancing criteria for the Region.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host. This parameter is not supported
        for the  ImportInstance command.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.

      - **PartitionNumber** *(integer) --*

        The number of the partition the instance is in. Valid only if the placement group strategy is
        set to ``partition`` .

      - **HostId** *(string) --*

        The ID of the Dedicated Host on which the instance resides. This parameter is not supported
        for the  ImportInstance command.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
        of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for
        the  ImportInstance command.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **PrivateIpAddress** *(string) --*

      [EC2-VPC] An available IP address from the IP address range of the subnet.

    - **SubnetId** *(string) --*

      [EC2-VPC] The ID of the subnet in which to launch the instance.

    - **UserData** *(dict) --*

      The Base64-encoded user data to make available to the instance.

      - **Data** *(string) --*

        The user data. If you are using an AWS SDK or command line tool, Base64-encoding is performed
        for you, and you can load the text from a file. Otherwise, you must provide Base64-encoded
        text.
    """


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTaskImportInstanceVolumes` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information about
      creating a presigned URL for an Amazon S3 object, read the "Query String Request
      Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
      in the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM
      Import Manifest
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTaskImportInstanceVolumes` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTaskImportInstance` `Volumes`

    Describes an import volume task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting instance will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      A description of the task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information about
        creating a presigned URL for an Amazon S3 object, read the "Query String Request
        Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
        in the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM
        Import Manifest
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Status** *(string) --*

      The status of the import of this particular disk image.

    - **StatusMessage** *(string) --*

      The status information or errors related to the disk image.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportInstanceTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[
            ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef
        ],
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTask` `ImportInstance`

    If the task is for importing an instance, this contains information about the import
    instance task.

    - **Description** *(string) --*

      A description of the task.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Platform** *(string) --*

      The instance operating system.

    - **Volumes** *(list) --*

      The volumes.

      - *(dict) --*

        Describes an import volume task.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the resulting instance will reside.

        - **BytesConverted** *(integer) --*

          The number of bytes converted so far.

        - **Description** *(string) --*

          A description of the task.

        - **Image** *(dict) --*

          The image.

          - **Checksum** *(string) --*

            The checksum computed for the disk image.

          - **Format** *(string) --*

            The disk image format.

          - **ImportManifestUrl** *(string) --*

            A presigned URL for the import manifest stored in Amazon S3. For information about
            creating a presigned URL for an Amazon S3 object, read the "Query String Request
            Authentication Alternative" section of the `Authenticating REST Requests
            <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
            in the *Amazon Simple Storage Service Developer Guide* .

            For information about the import manifest referenced by this API action, see `VM
            Import Manifest
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

          - **Size** *(integer) --*

            The size of the disk image, in GiB.

        - **Status** *(string) --*

          The status of the import of this particular disk image.

        - **StatusMessage** *(string) --*

          The status information or errors related to the disk image.

        - **Volume** *(dict) --*

          The volume.

          - **Id** *(string) --*

            The volume identifier.

          - **Size** *(integer) --*

            The size of the volume, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTaskImportVolume` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information about
      creating a presigned URL for an Amazon S3 object, read the "Query String Request
      Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
      the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM Import
      Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTaskImportVolume` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientImportInstanceResponseConversionTaskImportVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef,
        "Volume": ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTask` `ImportVolume`

    If the task is for importing a volume, this contains information about the import volume
    task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting volume will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      The description you provided when starting the import volume task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information about
        creating a presigned URL for an Amazon S3 object, read the "Query String Request
        Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
        the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM Import
        Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientImportInstanceResponseConversionTaskTagsTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientImportInstanceResponseConversionTaskTagsTypeDef(
    _ClientImportInstanceResponseConversionTaskTagsTypeDef
):
    """
    Type definition for `ClientImportInstanceResponseConversionTask` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientImportInstanceResponseConversionTaskTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientImportInstanceResponseConversionTaskImportInstanceTypeDef,
        "ImportVolume": ClientImportInstanceResponseConversionTaskImportVolumeTypeDef,
        "State": str,
        "StatusMessage": str,
        "Tags": List[ClientImportInstanceResponseConversionTaskTagsTypeDef],
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskTypeDef(
    _ClientImportInstanceResponseConversionTaskTypeDef
):
    """
    Type definition for `ClientImportInstanceResponse` `ConversionTask`

    Information about the conversion task.

    - **ConversionTaskId** *(string) --*

      The ID of the conversion task.

    - **ExpirationTime** *(string) --*

      The time when the task expires. If the upload isn't complete before the expiration time, we
      automatically cancel the task.

    - **ImportInstance** *(dict) --*

      If the task is for importing an instance, this contains information about the import
      instance task.

      - **Description** *(string) --*

        A description of the task.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **Platform** *(string) --*

        The instance operating system.

      - **Volumes** *(list) --*

        The volumes.

        - *(dict) --*

          Describes an import volume task.

          - **AvailabilityZone** *(string) --*

            The Availability Zone where the resulting instance will reside.

          - **BytesConverted** *(integer) --*

            The number of bytes converted so far.

          - **Description** *(string) --*

            A description of the task.

          - **Image** *(dict) --*

            The image.

            - **Checksum** *(string) --*

              The checksum computed for the disk image.

            - **Format** *(string) --*

              The disk image format.

            - **ImportManifestUrl** *(string) --*

              A presigned URL for the import manifest stored in Amazon S3. For information about
              creating a presigned URL for an Amazon S3 object, read the "Query String Request
              Authentication Alternative" section of the `Authenticating REST Requests
              <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
              in the *Amazon Simple Storage Service Developer Guide* .

              For information about the import manifest referenced by this API action, see `VM
              Import Manifest
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

            - **Size** *(integer) --*

              The size of the disk image, in GiB.

          - **Status** *(string) --*

            The status of the import of this particular disk image.

          - **StatusMessage** *(string) --*

            The status information or errors related to the disk image.

          - **Volume** *(dict) --*

            The volume.

            - **Id** *(string) --*

              The volume identifier.

            - **Size** *(integer) --*

              The size of the volume, in GiB.

    - **ImportVolume** *(dict) --*

      If the task is for importing a volume, this contains information about the import volume
      task.

      - **AvailabilityZone** *(string) --*

        The Availability Zone where the resulting volume will reside.

      - **BytesConverted** *(integer) --*

        The number of bytes converted so far.

      - **Description** *(string) --*

        The description you provided when starting the import volume task.

      - **Image** *(dict) --*

        The image.

        - **Checksum** *(string) --*

          The checksum computed for the disk image.

        - **Format** *(string) --*

          The disk image format.

        - **ImportManifestUrl** *(string) --*

          A presigned URL for the import manifest stored in Amazon S3. For information about
          creating a presigned URL for an Amazon S3 object, read the "Query String Request
          Authentication Alternative" section of the `Authenticating REST Requests
          <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
          the *Amazon Simple Storage Service Developer Guide* .

          For information about the import manifest referenced by this API action, see `VM Import
          Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

        - **Size** *(integer) --*

          The size of the disk image, in GiB.

      - **Volume** *(dict) --*

        The volume.

        - **Id** *(string) --*

          The volume identifier.

        - **Size** *(integer) --*

          The size of the volume, in GiB.

    - **State** *(string) --*

      The state of the conversion task.

    - **StatusMessage** *(string) --*

      The status message related to the conversion task.

    - **Tags** *(list) --*

      Any tags assigned to the task.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientImportInstanceResponseTypeDef = TypedDict(
    "_ClientImportInstanceResponseTypeDef",
    {"ConversionTask": ClientImportInstanceResponseConversionTaskTypeDef},
    total=False,
)


class ClientImportInstanceResponseTypeDef(_ClientImportInstanceResponseTypeDef):
    """
    Type definition for `ClientImportInstance` `Response`

    - **ConversionTask** *(dict) --*

      Information about the conversion task.

      - **ConversionTaskId** *(string) --*

        The ID of the conversion task.

      - **ExpirationTime** *(string) --*

        The time when the task expires. If the upload isn't complete before the expiration time, we
        automatically cancel the task.

      - **ImportInstance** *(dict) --*

        If the task is for importing an instance, this contains information about the import
        instance task.

        - **Description** *(string) --*

          A description of the task.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Platform** *(string) --*

          The instance operating system.

        - **Volumes** *(list) --*

          The volumes.

          - *(dict) --*

            Describes an import volume task.

            - **AvailabilityZone** *(string) --*

              The Availability Zone where the resulting instance will reside.

            - **BytesConverted** *(integer) --*

              The number of bytes converted so far.

            - **Description** *(string) --*

              A description of the task.

            - **Image** *(dict) --*

              The image.

              - **Checksum** *(string) --*

                The checksum computed for the disk image.

              - **Format** *(string) --*

                The disk image format.

              - **ImportManifestUrl** *(string) --*

                A presigned URL for the import manifest stored in Amazon S3. For information about
                creating a presigned URL for an Amazon S3 object, read the "Query String Request
                Authentication Alternative" section of the `Authenticating REST Requests
                <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
                in the *Amazon Simple Storage Service Developer Guide* .

                For information about the import manifest referenced by this API action, see `VM
                Import Manifest
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

              - **Size** *(integer) --*

                The size of the disk image, in GiB.

            - **Status** *(string) --*

              The status of the import of this particular disk image.

            - **StatusMessage** *(string) --*

              The status information or errors related to the disk image.

            - **Volume** *(dict) --*

              The volume.

              - **Id** *(string) --*

                The volume identifier.

              - **Size** *(integer) --*

                The size of the volume, in GiB.

      - **ImportVolume** *(dict) --*

        If the task is for importing a volume, this contains information about the import volume
        task.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the resulting volume will reside.

        - **BytesConverted** *(integer) --*

          The number of bytes converted so far.

        - **Description** *(string) --*

          The description you provided when starting the import volume task.

        - **Image** *(dict) --*

          The image.

          - **Checksum** *(string) --*

            The checksum computed for the disk image.

          - **Format** *(string) --*

            The disk image format.

          - **ImportManifestUrl** *(string) --*

            A presigned URL for the import manifest stored in Amazon S3. For information about
            creating a presigned URL for an Amazon S3 object, read the "Query String Request
            Authentication Alternative" section of the `Authenticating REST Requests
            <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
            the *Amazon Simple Storage Service Developer Guide* .

            For information about the import manifest referenced by this API action, see `VM Import
            Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

          - **Size** *(integer) --*

            The size of the disk image, in GiB.

        - **Volume** *(dict) --*

          The volume.

          - **Id** *(string) --*

            The volume identifier.

          - **Size** *(integer) --*

            The size of the volume, in GiB.

      - **State** *(string) --*

        The state of the conversion task.

      - **StatusMessage** *(string) --*

        The status message related to the conversion task.

      - **Tags** *(list) --*

        Any tags assigned to the task.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientImportKeyPairResponseTypeDef = TypedDict(
    "_ClientImportKeyPairResponseTypeDef",
    {"KeyFingerprint": str, "KeyName": str},
    total=False,
)


class ClientImportKeyPairResponseTypeDef(_ClientImportKeyPairResponseTypeDef):
    """
    Type definition for `ClientImportKeyPair` `Response`

    - **KeyFingerprint** *(string) --*

      The MD5 public key fingerprint as specified in section 4 of RFC 4716.

    - **KeyName** *(string) --*

      The key pair name you provided.
    """


_ClientImportSnapshotClientDataTypeDef = TypedDict(
    "_ClientImportSnapshotClientDataTypeDef",
    {
        "Comment": str,
        "UploadEnd": datetime,
        "UploadSize": float,
        "UploadStart": datetime,
    },
    total=False,
)


class ClientImportSnapshotClientDataTypeDef(_ClientImportSnapshotClientDataTypeDef):
    """
    Type definition for `ClientImportSnapshot` `ClientData`

    The client-specific data.

    - **Comment** *(string) --*

      A user-defined comment about the disk upload.

    - **UploadEnd** *(datetime) --*

      The time that the disk upload ends.

    - **UploadSize** *(float) --*

      The size of the uploaded disk image, in GiB.

    - **UploadStart** *(datetime) --*

      The time that the disk upload starts.
    """


_ClientImportSnapshotDiskContainerUserBucketTypeDef = TypedDict(
    "_ClientImportSnapshotDiskContainerUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportSnapshotDiskContainerUserBucketTypeDef(
    _ClientImportSnapshotDiskContainerUserBucketTypeDef
):
    """
    Type definition for `ClientImportSnapshotDiskContainer` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The name of the S3 bucket where the disk image is located.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientImportSnapshotDiskContainerTypeDef = TypedDict(
    "_ClientImportSnapshotDiskContainerTypeDef",
    {
        "Description": str,
        "Format": str,
        "Url": str,
        "UserBucket": ClientImportSnapshotDiskContainerUserBucketTypeDef,
    },
    total=False,
)


class ClientImportSnapshotDiskContainerTypeDef(
    _ClientImportSnapshotDiskContainerTypeDef
):
    """
    Type definition for `ClientImportSnapshot` `DiskContainer`

    Information about the disk container.

    - **Description** *(string) --*

      The description of the disk image being imported.

    - **Format** *(string) --*

      The format of the disk image being imported.

      Valid values: ``VHD`` | ``VMDK``

    - **Url** *(string) --*

      The URL to the Amazon S3-based disk image being imported. It can either be a https URL
      (https://..) or an Amazon S3 URL (s3://..).

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The name of the S3 bucket where the disk image is located.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef(
    _ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef
):
    """
    Type definition for `ClientImportSnapshotResponseSnapshotTaskDetail` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_ClientImportSnapshotResponseSnapshotTaskDetailTypeDef = TypedDict(
    "_ClientImportSnapshotResponseSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class ClientImportSnapshotResponseSnapshotTaskDetailTypeDef(
    _ClientImportSnapshotResponseSnapshotTaskDetailTypeDef
):
    """
    Type definition for `ClientImportSnapshotResponse` `SnapshotTaskDetail`

    Information about the import snapshot task.

    - **Description** *(string) --*

      The description of the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK) that
      was used to create the encrypted snapshot.

    - **Progress** *(string) --*

      The percentage of completion for the import snapshot task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status for the import snapshot task.

    - **StatusMessage** *(string) --*

      A detailed status message for the import snapshot task.

    - **Url** *(string) --*

      The URL of the disk image from which the snapshot is created.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_ClientImportSnapshotResponseTypeDef = TypedDict(
    "_ClientImportSnapshotResponseTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": ClientImportSnapshotResponseSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class ClientImportSnapshotResponseTypeDef(_ClientImportSnapshotResponseTypeDef):
    """
    Type definition for `ClientImportSnapshot` `Response`

    - **Description** *(string) --*

      A description of the import snapshot task.

    - **ImportTaskId** *(string) --*

      The ID of the import snapshot task.

    - **SnapshotTaskDetail** *(dict) --*

      Information about the import snapshot task.

      - **Description** *(string) --*

        The description of the snapshot.

      - **DiskImageSize** *(float) --*

        The size of the disk in the snapshot, in GiB.

      - **Encrypted** *(boolean) --*

        Indicates whether the snapshot is encrypted.

      - **Format** *(string) --*

        The format of the disk image from which the snapshot is created.

      - **KmsKeyId** *(string) --*

        The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK) that
        was used to create the encrypted snapshot.

      - **Progress** *(string) --*

        The percentage of completion for the import snapshot task.

      - **SnapshotId** *(string) --*

        The snapshot ID of the disk being imported.

      - **Status** *(string) --*

        A brief status for the import snapshot task.

      - **StatusMessage** *(string) --*

        A detailed status message for the import snapshot task.

      - **Url** *(string) --*

        The URL of the disk image from which the snapshot is created.

      - **UserBucket** *(dict) --*

        The S3 bucket for the disk image.

        - **S3Bucket** *(string) --*

          The S3 bucket from which the disk image was created.

        - **S3Key** *(string) --*

          The file name of the disk image.
    """


_ClientImportVolumeImageTypeDef = TypedDict(
    "_ClientImportVolumeImageTypeDef",
    {"Bytes": int, "Format": str, "ImportManifestUrl": str},
)


class ClientImportVolumeImageTypeDef(_ClientImportVolumeImageTypeDef):
    """
    Type definition for `ClientImportVolume` `Image`

    The disk image.

    - **Bytes** *(integer) --* **[REQUIRED]**

      The size of the disk image, in GiB.

    - **Format** *(string) --* **[REQUIRED]**

      The disk image format.

    - **ImportManifestUrl** *(string) --* **[REQUIRED]**

      A presigned URL for the import manifest stored in Amazon S3 and presented here as an Amazon S3
      presigned URL. For information about creating a presigned URL for an Amazon S3 object, read the
      "Query String Request Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in the
      *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM Import
      Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .
    """


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTaskImportInstanceVolumes` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information about
      creating a presigned URL for an Amazon S3 object, read the "Query String Request
      Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
      in the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM
      Import Manifest
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTaskImportInstanceVolumes` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTaskImportInstance` `Volumes`

    Describes an import volume task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting instance will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      A description of the task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information about
        creating a presigned URL for an Amazon S3 object, read the "Query String Request
        Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
        in the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM
        Import Manifest
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Status** *(string) --*

      The status of the import of this particular disk image.

    - **StatusMessage** *(string) --*

      The status information or errors related to the disk image.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportInstanceTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[
            ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef
        ],
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTask` `ImportInstance`

    If the task is for importing an instance, this contains information about the import
    instance task.

    - **Description** *(string) --*

      A description of the task.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Platform** *(string) --*

      The instance operating system.

    - **Volumes** *(list) --*

      The volumes.

      - *(dict) --*

        Describes an import volume task.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the resulting instance will reside.

        - **BytesConverted** *(integer) --*

          The number of bytes converted so far.

        - **Description** *(string) --*

          A description of the task.

        - **Image** *(dict) --*

          The image.

          - **Checksum** *(string) --*

            The checksum computed for the disk image.

          - **Format** *(string) --*

            The disk image format.

          - **ImportManifestUrl** *(string) --*

            A presigned URL for the import manifest stored in Amazon S3. For information about
            creating a presigned URL for an Amazon S3 object, read the "Query String Request
            Authentication Alternative" section of the `Authenticating REST Requests
            <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
            in the *Amazon Simple Storage Service Developer Guide* .

            For information about the import manifest referenced by this API action, see `VM
            Import Manifest
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

          - **Size** *(integer) --*

            The size of the disk image, in GiB.

        - **Status** *(string) --*

          The status of the import of this particular disk image.

        - **StatusMessage** *(string) --*

          The status information or errors related to the disk image.

        - **Volume** *(dict) --*

          The volume.

          - **Id** *(string) --*

            The volume identifier.

          - **Size** *(integer) --*

            The size of the volume, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef",
    {"Checksum": str, "Format": str, "ImportManifestUrl": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTaskImportVolume` `Image`

    The image.

    - **Checksum** *(string) --*

      The checksum computed for the disk image.

    - **Format** *(string) --*

      The disk image format.

    - **ImportManifestUrl** *(string) --*

      A presigned URL for the import manifest stored in Amazon S3. For information about
      creating a presigned URL for an Amazon S3 object, read the "Query String Request
      Authentication Alternative" section of the `Authenticating REST Requests
      <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
      the *Amazon Simple Storage Service Developer Guide* .

      For information about the import manifest referenced by this API action, see `VM Import
      Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

    - **Size** *(integer) --*

      The size of the disk image, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTaskImportVolume` `Volume`

    The volume.

    - **Id** *(string) --*

      The volume identifier.

    - **Size** *(integer) --*

      The size of the volume, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef,
        "Volume": ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTask` `ImportVolume`

    If the task is for importing a volume, this contains information about the import volume
    task.

    - **AvailabilityZone** *(string) --*

      The Availability Zone where the resulting volume will reside.

    - **BytesConverted** *(integer) --*

      The number of bytes converted so far.

    - **Description** *(string) --*

      The description you provided when starting the import volume task.

    - **Image** *(dict) --*

      The image.

      - **Checksum** *(string) --*

        The checksum computed for the disk image.

      - **Format** *(string) --*

        The disk image format.

      - **ImportManifestUrl** *(string) --*

        A presigned URL for the import manifest stored in Amazon S3. For information about
        creating a presigned URL for an Amazon S3 object, read the "Query String Request
        Authentication Alternative" section of the `Authenticating REST Requests
        <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
        the *Amazon Simple Storage Service Developer Guide* .

        For information about the import manifest referenced by this API action, see `VM Import
        Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

      - **Size** *(integer) --*

        The size of the disk image, in GiB.

    - **Volume** *(dict) --*

      The volume.

      - **Id** *(string) --*

        The volume identifier.

      - **Size** *(integer) --*

        The size of the volume, in GiB.
    """


_ClientImportVolumeResponseConversionTaskTagsTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientImportVolumeResponseConversionTaskTagsTypeDef(
    _ClientImportVolumeResponseConversionTaskTagsTypeDef
):
    """
    Type definition for `ClientImportVolumeResponseConversionTask` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientImportVolumeResponseConversionTaskTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientImportVolumeResponseConversionTaskImportInstanceTypeDef,
        "ImportVolume": ClientImportVolumeResponseConversionTaskImportVolumeTypeDef,
        "State": str,
        "StatusMessage": str,
        "Tags": List[ClientImportVolumeResponseConversionTaskTagsTypeDef],
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskTypeDef(
    _ClientImportVolumeResponseConversionTaskTypeDef
):
    """
    Type definition for `ClientImportVolumeResponse` `ConversionTask`

    Information about the conversion task.

    - **ConversionTaskId** *(string) --*

      The ID of the conversion task.

    - **ExpirationTime** *(string) --*

      The time when the task expires. If the upload isn't complete before the expiration time, we
      automatically cancel the task.

    - **ImportInstance** *(dict) --*

      If the task is for importing an instance, this contains information about the import
      instance task.

      - **Description** *(string) --*

        A description of the task.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **Platform** *(string) --*

        The instance operating system.

      - **Volumes** *(list) --*

        The volumes.

        - *(dict) --*

          Describes an import volume task.

          - **AvailabilityZone** *(string) --*

            The Availability Zone where the resulting instance will reside.

          - **BytesConverted** *(integer) --*

            The number of bytes converted so far.

          - **Description** *(string) --*

            A description of the task.

          - **Image** *(dict) --*

            The image.

            - **Checksum** *(string) --*

              The checksum computed for the disk image.

            - **Format** *(string) --*

              The disk image format.

            - **ImportManifestUrl** *(string) --*

              A presigned URL for the import manifest stored in Amazon S3. For information about
              creating a presigned URL for an Amazon S3 object, read the "Query String Request
              Authentication Alternative" section of the `Authenticating REST Requests
              <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
              in the *Amazon Simple Storage Service Developer Guide* .

              For information about the import manifest referenced by this API action, see `VM
              Import Manifest
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

            - **Size** *(integer) --*

              The size of the disk image, in GiB.

          - **Status** *(string) --*

            The status of the import of this particular disk image.

          - **StatusMessage** *(string) --*

            The status information or errors related to the disk image.

          - **Volume** *(dict) --*

            The volume.

            - **Id** *(string) --*

              The volume identifier.

            - **Size** *(integer) --*

              The size of the volume, in GiB.

    - **ImportVolume** *(dict) --*

      If the task is for importing a volume, this contains information about the import volume
      task.

      - **AvailabilityZone** *(string) --*

        The Availability Zone where the resulting volume will reside.

      - **BytesConverted** *(integer) --*

        The number of bytes converted so far.

      - **Description** *(string) --*

        The description you provided when starting the import volume task.

      - **Image** *(dict) --*

        The image.

        - **Checksum** *(string) --*

          The checksum computed for the disk image.

        - **Format** *(string) --*

          The disk image format.

        - **ImportManifestUrl** *(string) --*

          A presigned URL for the import manifest stored in Amazon S3. For information about
          creating a presigned URL for an Amazon S3 object, read the "Query String Request
          Authentication Alternative" section of the `Authenticating REST Requests
          <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
          the *Amazon Simple Storage Service Developer Guide* .

          For information about the import manifest referenced by this API action, see `VM Import
          Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

        - **Size** *(integer) --*

          The size of the disk image, in GiB.

      - **Volume** *(dict) --*

        The volume.

        - **Id** *(string) --*

          The volume identifier.

        - **Size** *(integer) --*

          The size of the volume, in GiB.

    - **State** *(string) --*

      The state of the conversion task.

    - **StatusMessage** *(string) --*

      The status message related to the conversion task.

    - **Tags** *(list) --*

      Any tags assigned to the task.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientImportVolumeResponseTypeDef = TypedDict(
    "_ClientImportVolumeResponseTypeDef",
    {"ConversionTask": ClientImportVolumeResponseConversionTaskTypeDef},
    total=False,
)


class ClientImportVolumeResponseTypeDef(_ClientImportVolumeResponseTypeDef):
    """
    Type definition for `ClientImportVolume` `Response`

    - **ConversionTask** *(dict) --*

      Information about the conversion task.

      - **ConversionTaskId** *(string) --*

        The ID of the conversion task.

      - **ExpirationTime** *(string) --*

        The time when the task expires. If the upload isn't complete before the expiration time, we
        automatically cancel the task.

      - **ImportInstance** *(dict) --*

        If the task is for importing an instance, this contains information about the import
        instance task.

        - **Description** *(string) --*

          A description of the task.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Platform** *(string) --*

          The instance operating system.

        - **Volumes** *(list) --*

          The volumes.

          - *(dict) --*

            Describes an import volume task.

            - **AvailabilityZone** *(string) --*

              The Availability Zone where the resulting instance will reside.

            - **BytesConverted** *(integer) --*

              The number of bytes converted so far.

            - **Description** *(string) --*

              A description of the task.

            - **Image** *(dict) --*

              The image.

              - **Checksum** *(string) --*

                The checksum computed for the disk image.

              - **Format** *(string) --*

                The disk image format.

              - **ImportManifestUrl** *(string) --*

                A presigned URL for the import manifest stored in Amazon S3. For information about
                creating a presigned URL for an Amazon S3 object, read the "Query String Request
                Authentication Alternative" section of the `Authenticating REST Requests
                <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic
                in the *Amazon Simple Storage Service Developer Guide* .

                For information about the import manifest referenced by this API action, see `VM
                Import Manifest
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

              - **Size** *(integer) --*

                The size of the disk image, in GiB.

            - **Status** *(string) --*

              The status of the import of this particular disk image.

            - **StatusMessage** *(string) --*

              The status information or errors related to the disk image.

            - **Volume** *(dict) --*

              The volume.

              - **Id** *(string) --*

                The volume identifier.

              - **Size** *(integer) --*

                The size of the volume, in GiB.

      - **ImportVolume** *(dict) --*

        If the task is for importing a volume, this contains information about the import volume
        task.

        - **AvailabilityZone** *(string) --*

          The Availability Zone where the resulting volume will reside.

        - **BytesConverted** *(integer) --*

          The number of bytes converted so far.

        - **Description** *(string) --*

          The description you provided when starting the import volume task.

        - **Image** *(dict) --*

          The image.

          - **Checksum** *(string) --*

            The checksum computed for the disk image.

          - **Format** *(string) --*

            The disk image format.

          - **ImportManifestUrl** *(string) --*

            A presigned URL for the import manifest stored in Amazon S3. For information about
            creating a presigned URL for an Amazon S3 object, read the "Query String Request
            Authentication Alternative" section of the `Authenticating REST Requests
            <https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html>`__ topic in
            the *Amazon Simple Storage Service Developer Guide* .

            For information about the import manifest referenced by this API action, see `VM Import
            Manifest <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html>`__ .

          - **Size** *(integer) --*

            The size of the disk image, in GiB.

        - **Volume** *(dict) --*

          The volume.

          - **Id** *(string) --*

            The volume identifier.

          - **Size** *(integer) --*

            The size of the volume, in GiB.

      - **State** *(string) --*

        The state of the conversion task.

      - **StatusMessage** *(string) --*

        The status message related to the conversion task.

      - **Tags** *(list) --*

        Any tags assigned to the task.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientImportVolumeVolumeTypeDef = TypedDict(
    "_ClientImportVolumeVolumeTypeDef", {"Size": int}
)


class ClientImportVolumeVolumeTypeDef(_ClientImportVolumeVolumeTypeDef):
    """
    Type definition for `ClientImportVolume` `Volume`

    The volume size.

    - **Size** *(integer) --* **[REQUIRED]**

      The size of the volume, in GiB.
    """


_ClientModifyCapacityReservationResponseTypeDef = TypedDict(
    "_ClientModifyCapacityReservationResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyCapacityReservationResponseTypeDef(
    _ClientModifyCapacityReservationResponseTypeDef
):
    """
    Type definition for `ClientModifyCapacityReservation` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef(
    _ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef
):
    """
    Type definition for `ClientModifyClientVpnEndpoint` `ConnectionLogOptions`

    Information about the client connection logging options.

    If you enable client connection logging, data about client connections is sent to a Cloudwatch
    Logs log stream. The following information is logged:

    * Client connection requests

    * Client connection results (successful and unsuccessful)

    * Reasons for unsuccessful client connection requests

    * Client connection termination time

    - **Enabled** *(boolean) --*

      Indicates whether connection logging is enabled.

    - **CloudwatchLogGroup** *(string) --*

      The name of the CloudWatch Logs log group.

    - **CloudwatchLogStream** *(string) --*

      The name of the CloudWatch Logs log stream to which the connection data is published.
    """


_ClientModifyClientVpnEndpointDnsServersTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointDnsServersTypeDef",
    {"CustomDnsServers": List[str], "Enabled": bool},
    total=False,
)


class ClientModifyClientVpnEndpointDnsServersTypeDef(
    _ClientModifyClientVpnEndpointDnsServersTypeDef
):
    """
    Type definition for `ClientModifyClientVpnEndpoint` `DnsServers`

    Information about the DNS servers to be used by Client VPN connections. A Client VPN endpoint can
    have up to two DNS servers.

    - **CustomDnsServers** *(list) --*

      The IPv4 address range, in CIDR notation, of the DNS servers to be used. You can specify up to
      two DNS servers. Ensure that the DNS servers can be reached by the clients. The specified
      values overwrite the existing values.

      - *(string) --*

    - **Enabled** *(boolean) --*

      Indicates whether DNS servers should be used. Specify ``False`` to delete the existing DNS
      servers.
    """


_ClientModifyClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyClientVpnEndpointResponseTypeDef(
    _ClientModifyClientVpnEndpointResponseTypeDef
):
    """
    Type definition for `ClientModifyClientVpnEndpoint` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientModifyEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientModifyEbsDefaultKmsKeyIdResponseTypeDef(
    _ClientModifyEbsDefaultKmsKeyIdResponseTypeDef
):
    """
    Type definition for `ClientModifyEbsDefaultKmsKeyId` `Response`

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the default CMK for encryption by default.
    """


_ClientModifyFleetResponseTypeDef = TypedDict(
    "_ClientModifyFleetResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyFleetResponseTypeDef(_ClientModifyFleetResponseTypeDef):
    """
    Type definition for `ClientModifyFleet` `Response`

    - **Return** *(boolean) --*

      Is ``true`` if the request succeeds, and an error otherwise.
    """


_RequiredClientModifyFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_RequiredClientModifyFleetTargetCapacitySpecificationTypeDef",
    {"TotalTargetCapacity": int},
)
_OptionalClientModifyFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_OptionalClientModifyFleetTargetCapacitySpecificationTypeDef",
    {
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": str,
    },
    total=False,
)


class ClientModifyFleetTargetCapacitySpecificationTypeDef(
    _RequiredClientModifyFleetTargetCapacitySpecificationTypeDef,
    _OptionalClientModifyFleetTargetCapacitySpecificationTypeDef,
):
    """
    Type definition for `ClientModifyFleet` `TargetCapacitySpecification`

    The size of the EC2 Fleet.

    - **TotalTargetCapacity** *(integer) --* **[REQUIRED]**

      The number of units to request, filled using ``DefaultTargetCapacityType`` .

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request.

    - **SpotTargetCapacity** *(integer) --*

      The number of Spot units to request.

    - **DefaultTargetCapacityType** *(string) --*

      The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .
    """


_ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttributeLoadPermission` `Add`

    Describes a load permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttributeLoadPermission` `Remove`

    Describes a load permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ClientModifyFpgaImageAttributeLoadPermissionTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionTypeDef",
    {
        "Add": List[ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef],
        "Remove": List[ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef],
    },
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttribute` `LoadPermission`

    The load permission for the AFI.

    - **Add** *(list) --*

      The load permissions to add.

      - *(dict) --*

        Describes a load permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.

    - **Remove** *(list) --*

      The load permissions to remove.

      - *(dict) --*

        Describes a load permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.
    """


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    {"UserId": str, "Group": str},
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttributeResponseFpgaImageAttribute` `LoadPermissions`

    Describes a load permission.

    - **UserId** *(string) --*

      The AWS account ID.

    - **Group** *(string) --*

      The name of the group.
    """


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttributeResponseFpgaImageAttribute` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    {
        "FpgaImageId": str,
        "Name": str,
        "Description": str,
        "LoadPermissions": List[
            ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
        ],
        "ProductCodes": List[
            ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
        ],
    },
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttributeResponse` `FpgaImageAttribute`

    Information about the attribute.

    - **FpgaImageId** *(string) --*

      The ID of the AFI.

    - **Name** *(string) --*

      The name of the AFI.

    - **Description** *(string) --*

      The description of the AFI.

    - **LoadPermissions** *(list) --*

      The load permissions.

      - *(dict) --*

        Describes a load permission.

        - **UserId** *(string) --*

          The AWS account ID.

        - **Group** *(string) --*

          The name of the group.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.
    """


_ClientModifyFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseTypeDef",
    {
        "FpgaImageAttribute": ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef
    },
    total=False,
)


class ClientModifyFpgaImageAttributeResponseTypeDef(
    _ClientModifyFpgaImageAttributeResponseTypeDef
):
    """
    Type definition for `ClientModifyFpgaImageAttribute` `Response`

    - **FpgaImageAttribute** *(dict) --*

      Information about the attribute.

      - **FpgaImageId** *(string) --*

        The ID of the AFI.

      - **Name** *(string) --*

        The name of the AFI.

      - **Description** *(string) --*

        The description of the AFI.

      - **LoadPermissions** *(list) --*

        The load permissions.

        - *(dict) --*

          Describes a load permission.

          - **UserId** *(string) --*

            The AWS account ID.

          - **Group** *(string) --*

            The name of the group.

      - **ProductCodes** *(list) --*

        The product codes.

        - *(dict) --*

          Describes a product code.

          - **ProductCodeId** *(string) --*

            The product code.

          - **ProductCodeType** *(string) --*

            The type of product code.
    """


_ClientModifyHostsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientModifyHostsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientModifyHostsResponseUnsuccessfulErrorTypeDef(
    _ClientModifyHostsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientModifyHostsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientModifyHostsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientModifyHostsResponseUnsuccessfulTypeDef",
    {"Error": ClientModifyHostsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientModifyHostsResponseUnsuccessfulTypeDef(
    _ClientModifyHostsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientModifyHostsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientModifyHostsResponseTypeDef = TypedDict(
    "_ClientModifyHostsResponseTypeDef",
    {
        "Successful": List[str],
        "Unsuccessful": List[ClientModifyHostsResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientModifyHostsResponseTypeDef(_ClientModifyHostsResponseTypeDef):
    """
    Type definition for `ClientModifyHosts` `Response`

    - **Successful** *(list) --*

      The IDs of the Dedicated Hosts that were successfully modified.

      - *(string) --*

    - **Unsuccessful** *(list) --*

      The IDs of the Dedicated Hosts that could not be modified. Check whether the setting you
      requested can be used.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientModifyImageAttributeDescriptionTypeDef = TypedDict(
    "_ClientModifyImageAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class ClientModifyImageAttributeDescriptionTypeDef(
    _ClientModifyImageAttributeDescriptionTypeDef
):
    """
    Type definition for `ClientModifyImageAttribute` `Description`

    A new description for the AMI.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyImageAttributeLaunchPermissionAddTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionAddTypeDef(
    _ClientModifyImageAttributeLaunchPermissionAddTypeDef
):
    """
    Type definition for `ClientModifyImageAttributeLaunchPermission` `Add`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ClientModifyImageAttributeLaunchPermissionRemoveTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionRemoveTypeDef(
    _ClientModifyImageAttributeLaunchPermissionRemoveTypeDef
):
    """
    Type definition for `ClientModifyImageAttributeLaunchPermission` `Remove`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ClientModifyImageAttributeLaunchPermissionTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionTypeDef",
    {
        "Add": List[ClientModifyImageAttributeLaunchPermissionAddTypeDef],
        "Remove": List[ClientModifyImageAttributeLaunchPermissionRemoveTypeDef],
    },
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionTypeDef(
    _ClientModifyImageAttributeLaunchPermissionTypeDef
):
    """
    Type definition for `ClientModifyImageAttribute` `LaunchPermission`

    A new launch permission for the AMI.

    - **Add** *(list) --*

      The AWS account ID to add to the list of launch permissions for the AMI.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.

    - **Remove** *(list) --*

      The AWS account ID to remove from the list of launch permissions for the AMI.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.
    """


_ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef",
    {"DeleteOnTermination": bool, "VolumeId": str},
    total=False,
)


class ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef(
    _ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttributeBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef(
    _ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `BlockDeviceMappings`

    Describes a block device mapping entry.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.

    - **NoDevice** *(string) --*

      suppress the specified device included in the block device mapping.

    - **VirtualName** *(string) --*

      The virtual device name.
    """


_ClientModifyInstanceAttributeDisableApiTerminationTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeDisableApiTerminationTypeDef",
    {"Value": bool},
    total=False,
)


class ClientModifyInstanceAttributeDisableApiTerminationTypeDef(
    _ClientModifyInstanceAttributeDisableApiTerminationTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `DisableApiTermination`

    If the value is ``true`` , you can't terminate the instance using the Amazon EC2 console, CLI, or
    API; otherwise, you can. You cannot use this parameter for Spot Instances.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeEbsOptimizedTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeEbsOptimizedTypeDef(
    _ClientModifyInstanceAttributeEbsOptimizedTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `EbsOptimized`

    Specifies whether the instance is optimized for Amazon EBS I/O. This optimization provides
    dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS
    I/O performance. This optimization isn't available with all instance types. Additional usage
    charges apply when using an EBS Optimized instance.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeEnaSupportTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeEnaSupportTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeEnaSupportTypeDef(
    _ClientModifyInstanceAttributeEnaSupportTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `EnaSupport`

    Set to ``true`` to enable enhanced networking with ENA for the instance.

    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef(
    _ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `InstanceInitiatedShutdownBehavior`

    Specifies whether an instance stops or terminates when you initiate shutdown from the instance
    (using the operating system command for system shutdown).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeInstanceTypeTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeInstanceTypeTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeInstanceTypeTypeDef(
    _ClientModifyInstanceAttributeInstanceTypeTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `InstanceType`

    Changes the instance type to the specified value. For more information, see `Instance Types
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ . If the instance
    type is not valid, the error returned is ``InvalidInstanceAttributeValue`` .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeKernelTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeKernelTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeKernelTypeDef(
    _ClientModifyInstanceAttributeKernelTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `Kernel`

    Changes the instance's kernel to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeRamdiskTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeRamdiskTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeRamdiskTypeDef(
    _ClientModifyInstanceAttributeRamdiskTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `Ramdisk`

    Changes the instance's RAM disk to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeSourceDestCheckTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeSourceDestCheckTypeDef(
    _ClientModifyInstanceAttributeSourceDestCheckTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `SourceDestCheck`

    Specifies whether source/destination checking is enabled. A value of ``true`` means that checking
    is enabled, and ``false`` means that checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeSriovNetSupportTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeSriovNetSupportTypeDef(
    _ClientModifyInstanceAttributeSriovNetSupportTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `SriovNetSupport`

    Set to ``simple`` to enable enhanced networking with the Intel 82599 Virtual Function interface
    for the instance.

    There is no way to disable enhanced networking with the Intel 82599 Virtual Function interface at
    this time.

    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeUserDataTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeUserDataTypeDef", {"Value": bytes}, total=False
)


class ClientModifyInstanceAttributeUserDataTypeDef(
    _ClientModifyInstanceAttributeUserDataTypeDef
):
    """
    Type definition for `ClientModifyInstanceAttribute` `UserData`

    Changes the instance's user data to the specified value. If you are using an AWS SDK or command
    line tool, base64-encoding is performed for you, and you can load the text from a file.
    Otherwise, you must provide base64-encoded text.

    - **Value** *(bytes) --*
    """


_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientModifyInstanceCapacityReservationAttributes` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientModifyInstanceCapacityReservationAttributesResponseTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesResponseTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesResponseTypeDef
):
    """
    Type definition for `ClientModifyInstanceCapacityReservationAttributes` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef
):
    """
    Type definition for `ClientModifyInstanceCreditSpecification` `InstanceCreditSpecifications`

    Describes the credit option for CPU usage of a T2 or T3 instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of the instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str},
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef
):
    """
    Type definition for `ClientModifyInstanceCreditSpecificationResponse` `SuccessfulInstanceCreditSpecifications`

    Describes the T2 or T3 instance whose credit option for CPU usage was successfully modified.

    - **InstanceId** *(string) --*

      The ID of the instance.
    """


_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef
):
    """
    Type definition for `ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecifications` `Error`

    The applicable error for the T2 or T3 instance whose credit option for CPU usage was not
    modified.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The applicable error message.
    """


_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef",
    {
        "InstanceId": str,
        "Error": ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef,
    },
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef
):
    """
    Type definition for `ClientModifyInstanceCreditSpecificationResponse` `UnsuccessfulInstanceCreditSpecifications`

    Describes the T2 or T3 instance whose credit option for CPU usage was not modified.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Error** *(dict) --*

      The applicable error for the T2 or T3 instance whose credit option for CPU usage was not
      modified.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The applicable error message.
    """


_ClientModifyInstanceCreditSpecificationResponseTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseTypeDef",
    {
        "SuccessfulInstanceCreditSpecifications": List[
            ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef
        ],
        "UnsuccessfulInstanceCreditSpecifications": List[
            ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseTypeDef
):
    """
    Type definition for `ClientModifyInstanceCreditSpecification` `Response`

    - **SuccessfulInstanceCreditSpecifications** *(list) --*

      Information about the instances whose credit option for CPU usage was successfully modified.

      - *(dict) --*

        Describes the T2 or T3 instance whose credit option for CPU usage was successfully modified.

        - **InstanceId** *(string) --*

          The ID of the instance.

    - **UnsuccessfulInstanceCreditSpecifications** *(list) --*

      Information about the instances whose credit option for CPU usage was not modified.

      - *(dict) --*

        Describes the T2 or T3 instance whose credit option for CPU usage was not modified.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Error** *(dict) --*

          The applicable error for the T2 or T3 instance whose credit option for CPU usage was not
          modified.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The applicable error message.
    """


_ClientModifyInstanceEventStartTimeResponseEventTypeDef = TypedDict(
    "_ClientModifyInstanceEventStartTimeResponseEventTypeDef",
    {
        "InstanceEventId": str,
        "Code": str,
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class ClientModifyInstanceEventStartTimeResponseEventTypeDef(
    _ClientModifyInstanceEventStartTimeResponseEventTypeDef
):
    """
    Type definition for `ClientModifyInstanceEventStartTimeResponse` `Event`

    Describes a scheduled event for an instance.

    - **InstanceEventId** *(string) --*

      The ID of the event.

    - **Code** *(string) --*

      The event code.

    - **Description** *(string) --*

      A description of the event.

      After a scheduled event is completed, it can still be described for up to a week. If the
      event has been completed, this description starts with the following text: [Completed].

    - **NotAfter** *(datetime) --*

      The latest scheduled end time for the event.

    - **NotBefore** *(datetime) --*

      The earliest scheduled start time for the event.

    - **NotBeforeDeadline** *(datetime) --*

      The deadline for starting the event.
    """


_ClientModifyInstanceEventStartTimeResponseTypeDef = TypedDict(
    "_ClientModifyInstanceEventStartTimeResponseTypeDef",
    {"Event": ClientModifyInstanceEventStartTimeResponseEventTypeDef},
    total=False,
)


class ClientModifyInstanceEventStartTimeResponseTypeDef(
    _ClientModifyInstanceEventStartTimeResponseTypeDef
):
    """
    Type definition for `ClientModifyInstanceEventStartTime` `Response`

    - **Event** *(dict) --*

      Describes a scheduled event for an instance.

      - **InstanceEventId** *(string) --*

        The ID of the event.

      - **Code** *(string) --*

        The event code.

      - **Description** *(string) --*

        A description of the event.

        After a scheduled event is completed, it can still be described for up to a week. If the
        event has been completed, this description starts with the following text: [Completed].

      - **NotAfter** *(datetime) --*

        The latest scheduled end time for the event.

      - **NotBefore** *(datetime) --*

        The earliest scheduled start time for the event.

      - **NotBeforeDeadline** *(datetime) --*

        The deadline for starting the event.
    """


_ClientModifyInstancePlacementResponseTypeDef = TypedDict(
    "_ClientModifyInstancePlacementResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyInstancePlacementResponseTypeDef(
    _ClientModifyInstancePlacementResponseTypeDef
):
    """
    Type definition for `ClientModifyInstancePlacement` `Response`

    - **Return** *(boolean) --*

      Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    """
    Type definition for `ClientModifyLaunchTemplateResponseLaunchTemplate` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    Type definition for `ClientModifyLaunchTemplateResponse` `LaunchTemplate`

    Information about the launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **CreateTime** *(datetime) --*

      The time launch template was created.

    - **CreatedBy** *(string) --*

      The principal that created the launch template.

    - **DefaultVersionNumber** *(integer) --*

      The version number of the default version of the launch template.

    - **LatestVersionNumber** *(integer) --*

      The version number of the latest version of the launch template.

    - **Tags** *(list) --*

      The tags for the launch template.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientModifyLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientModifyLaunchTemplateResponseTypeDef(
    _ClientModifyLaunchTemplateResponseTypeDef
):
    """
    Type definition for `ClientModifyLaunchTemplate` `Response`

    - **LaunchTemplate** *(dict) --*

      Information about the launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template.

      - **CreateTime** *(datetime) --*

        The time launch template was created.

      - **CreatedBy** *(string) --*

        The principal that created the launch template.

      - **DefaultVersionNumber** *(integer) --*

        The version number of the default version of the launch template.

      - **LatestVersionNumber** *(integer) --*

        The version number of the latest version of the launch template.

      - **Tags** *(list) --*

        The tags for the launch template.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientModifyNetworkInterfaceAttributeAttachmentTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeAttachmentTypeDef",
    {"AttachmentId": str, "DeleteOnTermination": bool},
    total=False,
)


class ClientModifyNetworkInterfaceAttributeAttachmentTypeDef(
    _ClientModifyNetworkInterfaceAttributeAttachmentTypeDef
):
    """
    Type definition for `ClientModifyNetworkInterfaceAttribute` `Attachment`

    Information about the interface attachment. If modifying the 'delete on termination' attribute,
    you must specify the ID of the interface attachment.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.
    """


_ClientModifyNetworkInterfaceAttributeDescriptionTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeDescriptionTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyNetworkInterfaceAttributeDescriptionTypeDef(
    _ClientModifyNetworkInterfaceAttributeDescriptionTypeDef
):
    """
    Type definition for `ClientModifyNetworkInterfaceAttribute` `Description`

    A description for the network interface.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef(
    _ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef
):
    """
    Type definition for `ClientModifyNetworkInterfaceAttribute` `SourceDestCheck`

    Indicates whether source/destination checking is enabled. A value of ``true`` means checking is
    enabled, and ``false`` means checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT. For more information, see `NAT Instances
    <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the *Amazon
    Virtual Private Cloud User Guide* .

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyReservedInstancesResponseTypeDef = TypedDict(
    "_ClientModifyReservedInstancesResponseTypeDef",
    {"ReservedInstancesModificationId": str},
    total=False,
)


class ClientModifyReservedInstancesResponseTypeDef(
    _ClientModifyReservedInstancesResponseTypeDef
):
    """
    Type definition for `ClientModifyReservedInstances` `Response`

    Contains the output of ModifyReservedInstances.

    - **ReservedInstancesModificationId** *(string) --*

      The ID for the modification.
    """


_ClientModifyReservedInstancesTargetConfigurationsTypeDef = TypedDict(
    "_ClientModifyReservedInstancesTargetConfigurationsTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": str,
        "Platform": str,
        "Scope": str,
    },
    total=False,
)


class ClientModifyReservedInstancesTargetConfigurationsTypeDef(
    _ClientModifyReservedInstancesTargetConfigurationsTypeDef
):
    """
    Type definition for `ClientModifyReservedInstances` `TargetConfigurations`

    Describes the configuration settings for the modified Reserved Instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the modified Reserved Instances.

    - **InstanceCount** *(integer) --*

      The number of modified Reserved Instances.

      .. note::

        This is a required field for a request.

    - **InstanceType** *(string) --*

      The instance type for the modified Reserved Instances.

    - **Platform** *(string) --*

      The network platform of the modified Reserved Instances, which is either EC2-Classic or
      EC2-VPC.

    - **Scope** *(string) --*

      Whether the Reserved Instance is applied to instances in a Region or instances in a specific
      Availability Zone.
    """


_ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef
):
    """
    Type definition for `ClientModifySnapshotAttributeCreateVolumePermission` `Add`

    Describes the user or group to be added or removed from the list of create volume permissions
    for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef
):
    """
    Type definition for `ClientModifySnapshotAttributeCreateVolumePermission` `Remove`

    Describes the user or group to be added or removed from the list of create volume permissions
    for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_ClientModifySnapshotAttributeCreateVolumePermissionTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionTypeDef",
    {
        "Add": List[ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef],
        "Remove": List[
            ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef
        ],
    },
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionTypeDef
):
    """
    Type definition for `ClientModifySnapshotAttribute` `CreateVolumePermission`

    A JSON representation of the snapshot attribute modification.

    - **Add** *(list) --*

      Adds the specified AWS account ID or group to the list.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume permissions
        for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.

    - **Remove** *(list) --*

      Removes the specified AWS account ID or group from the list.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume permissions
        for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.
    """


_ClientModifySpotFleetRequestResponseTypeDef = TypedDict(
    "_ClientModifySpotFleetRequestResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifySpotFleetRequestResponseTypeDef(
    _ClientModifySpotFleetRequestResponseTypeDef
):
    """
    Type definition for `ClientModifySpotFleetRequest` `Response`

    Contains the output of ModifySpotFleetRequest.

    - **Return** *(boolean) --*

      Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef = TypedDict(
    "_ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef",
    {"Value": bool},
    total=False,
)


class ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef(
    _ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef
):
    """
    Type definition for `ClientModifySubnetAttribute` `AssignIpv6AddressOnCreation`

    Specify ``true`` to indicate that network interfaces created in the specified subnet should be
    assigned an IPv6 address. This includes a network interface that's created when launching an
    instance into the subnet (the instance therefore receives an IPv6 address).

    If you enable the IPv6 addressing feature for your subnet, your network interface or instance
    only receives an IPv6 address if it's created using version ``2016-11-15`` or later of the Amazon
    EC2 API.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef = TypedDict(
    "_ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef",
    {"Value": bool},
    total=False,
)


class ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef(
    _ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef
):
    """
    Type definition for `ClientModifySubnetAttribute` `MapPublicIpOnLaunch`

    Specify ``true`` to indicate that ENIs attached to instances created in the specified subnet
    should be assigned a public IPv4 address.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilter` `EgressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilter` `IngressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilter` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef
        ],
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServicesResponse` `TrafficMirrorFilter`

    The Traffic Mirror filter that the network service is associated with.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **IngressFilterRules** *(list) --*

      Information about the ingress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **EgressFilterRules** *(list) --*

      Information about the egress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **NetworkServices** *(list) --*

      The network service traffic that is associated with the Traffic Mirror filter.

      - *(string) --*

    - **Description** *(string) --*

      The description of the Traffic Mirror filter.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror filter.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef",
    {
        "TrafficMirrorFilter": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterNetworkServices` `Response`

    - **TrafficMirrorFilter** *(dict) --*

      The Traffic Mirror filter that the network service is associated with.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.

      - **IngressFilterRules** *(list) --*

        Information about the ingress rules that are associated with the Traffic Mirror filter.

        - *(dict) --*

          Describes the Traffic Mirror rule.

          - **TrafficMirrorFilterRuleId** *(string) --*

            The ID of the Traffic Mirror rule.

          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter that the rule is associated with.

          - **TrafficDirection** *(string) --*

            The traffic direction assigned to the Traffic Mirror rule.

          - **RuleNumber** *(integer) --*

            The rule number of the Traffic Mirror rule.

          - **RuleAction** *(string) --*

            The action assigned to the Traffic Mirror rule.

          - **Protocol** *(integer) --*

            The protocol assigned to the Traffic Mirror rule.

          - **DestinationPortRange** *(dict) --*

            The destination port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **SourcePortRange** *(dict) --*

            The source port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **DestinationCidrBlock** *(string) --*

            The destination CIDR block assigned to the Traffic Mirror rule.

          - **SourceCidrBlock** *(string) --*

            The source CIDR block assigned to the Traffic Mirror rule.

          - **Description** *(string) --*

            The description of the Traffic Mirror rule.

      - **EgressFilterRules** *(list) --*

        Information about the egress rules that are associated with the Traffic Mirror filter.

        - *(dict) --*

          Describes the Traffic Mirror rule.

          - **TrafficMirrorFilterRuleId** *(string) --*

            The ID of the Traffic Mirror rule.

          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter that the rule is associated with.

          - **TrafficDirection** *(string) --*

            The traffic direction assigned to the Traffic Mirror rule.

          - **RuleNumber** *(integer) --*

            The rule number of the Traffic Mirror rule.

          - **RuleAction** *(string) --*

            The action assigned to the Traffic Mirror rule.

          - **Protocol** *(integer) --*

            The protocol assigned to the Traffic Mirror rule.

          - **DestinationPortRange** *(dict) --*

            The destination port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **SourcePortRange** *(dict) --*

            The source port range assigned to the Traffic Mirror rule.

            - **FromPort** *(integer) --*

              The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **ToPort** *(integer) --*

              The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

          - **DestinationCidrBlock** *(string) --*

            The destination CIDR block assigned to the Traffic Mirror rule.

          - **SourceCidrBlock** *(string) --*

            The source CIDR block assigned to the Traffic Mirror rule.

          - **Description** *(string) --*

            The description of the Traffic Mirror rule.

      - **NetworkServices** *(list) --*

        The network service traffic that is associated with the Traffic Mirror filter.

        - *(string) --*

      - **Description** *(string) --*

        The description of the Traffic Mirror filter.

      - **Tags** *(list) --*

        The tags assigned to the Traffic Mirror filter.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRule` `DestinationPortRange`

    The destination ports that are associated with the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The last port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRule` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRule` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRuleResponse` `TrafficMirrorFilterRule`

    Modifies a Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTypeDef",
    {
        "TrafficMirrorFilterRule": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRule` `Response`

    - **TrafficMirrorFilterRule** *(dict) --*

      Modifies a Traffic Mirror rule.

      - **TrafficMirrorFilterRuleId** *(string) --*

        The ID of the Traffic Mirror rule.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter that the rule is associated with.

      - **TrafficDirection** *(string) --*

        The traffic direction assigned to the Traffic Mirror rule.

      - **RuleNumber** *(integer) --*

        The rule number of the Traffic Mirror rule.

      - **RuleAction** *(string) --*

        The action assigned to the Traffic Mirror rule.

      - **Protocol** *(integer) --*

        The protocol assigned to the Traffic Mirror rule.

      - **DestinationPortRange** *(dict) --*

        The destination port range assigned to the Traffic Mirror rule.

        - **FromPort** *(integer) --*

          The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **ToPort** *(integer) --*

          The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **SourcePortRange** *(dict) --*

        The source port range assigned to the Traffic Mirror rule.

        - **FromPort** *(integer) --*

          The start of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **ToPort** *(integer) --*

          The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

      - **DestinationCidrBlock** *(string) --*

        The destination CIDR block assigned to the Traffic Mirror rule.

      - **SourceCidrBlock** *(string) --*

        The source CIDR block assigned to the Traffic Mirror rule.

      - **Description** *(string) --*

        The description of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorFilterRule` `SourcePortRange`

    The port range to assign to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **ToPort** *(integer) --*

      The last port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorSessionResponseTrafficMirrorSession` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[
            ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
        ],
    },
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorSessionResponse` `TrafficMirrorSession`

    Information about the Traffic Mirror session.

    - **TrafficMirrorSessionId** *(string) --*

      The ID for the Traffic Mirror session.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **NetworkInterfaceId** *(string) --*

      The ID of the Traffic Mirror session's network interface.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror session.

    - **PacketLength** *(integer) --*

      The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
      To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
      this value to 100, then the first 100 bytes that meet the filter criteria are copied to the
      target. Do not specify this parameter when you want to mirror the entire packet

    - **SessionNumber** *(integer) --*

      The session number determines the order in which sessions are evaluated when an interface
      is used by multiple sessions. The first session with a matching filter is the one that
      mirrors the packets.

      Valid values are 1-32766.

    - **VirtualNetworkId** *(integer) --*

      The virtual network ID associated with the Traffic Mirror session.

    - **Description** *(string) --*

      The description of the Traffic Mirror session.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror session.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientModifyTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTypeDef",
    {
        "TrafficMirrorSession": ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef
    },
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTypeDef
):
    """
    Type definition for `ClientModifyTrafficMirrorSession` `Response`

    - **TrafficMirrorSession** *(dict) --*

      Information about the Traffic Mirror session.

      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.

      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.

      - **NetworkInterfaceId** *(string) --*

        The ID of the Traffic Mirror session's network interface.

      - **OwnerId** *(string) --*

        The ID of the account that owns the Traffic Mirror session.

      - **PacketLength** *(integer) --*

        The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
        To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
        this value to 100, then the first 100 bytes that meet the filter criteria are copied to the
        target. Do not specify this parameter when you want to mirror the entire packet

      - **SessionNumber** *(integer) --*

        The session number determines the order in which sessions are evaluated when an interface
        is used by multiple sessions. The first session with a matching filter is the one that
        mirrors the packets.

        Valid values are 1-32766.

      - **VirtualNetworkId** *(integer) --*

        The virtual network ID associated with the Traffic Mirror session.

      - **Description** *(string) --*

        The description of the Traffic Mirror session.

      - **Tags** *(list) --*

        The tags assigned to the Traffic Mirror session.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientModifyTransitGatewayVpcAttachment` `Options`

    The new VPC attachment options.

    - **DnsSupport** *(string) --*

      Enable or disable DNS support. The default is ``enable`` .

    - **Ipv6Support** *(string) --*

      Enable or disable IPv6 support. The default is ``enable`` .
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    """
    Type definition for `ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    Type definition for `ClientModifyTransitGatewayVpcAttachmentResponse` `TransitGatewayVpcAttachment`

    Information about the modified attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    Type definition for `ClientModifyTransitGatewayVpcAttachment` `Response`

    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the modified attachment.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **VpcOwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **State** *(string) --*

        The state of the VPC attachment.

      - **SubnetIds** *(list) --*

        The IDs of the subnets.

        - *(string) --*

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The VPC attachment options.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

        - **Ipv6Support** *(string) --*

          Indicates whether IPv6 support is enabled.

      - **Tags** *(list) --*

        The tags for the VPC attachment.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientModifyVolumeAttributeAutoEnableIOTypeDef = TypedDict(
    "_ClientModifyVolumeAttributeAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class ClientModifyVolumeAttributeAutoEnableIOTypeDef(
    _ClientModifyVolumeAttributeAutoEnableIOTypeDef
):
    """
    Type definition for `ClientModifyVolumeAttribute` `AutoEnableIO`

    Indicates whether the volume should be auto-enabled for I/O operations.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVolumeResponseVolumeModificationTypeDef = TypedDict(
    "_ClientModifyVolumeResponseVolumeModificationTypeDef",
    {
        "VolumeId": str,
        "ModificationState": str,
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": str,
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": str,
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class ClientModifyVolumeResponseVolumeModificationTypeDef(
    _ClientModifyVolumeResponseVolumeModificationTypeDef
):
    """
    Type definition for `ClientModifyVolumeResponse` `VolumeModification`

    Information about the volume modification.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **ModificationState** *(string) --*

      The current modification state. The modification state is null for unmodified volumes.

    - **StatusMessage** *(string) --*

      A status message about the modification progress or failure.

    - **TargetSize** *(integer) --*

      The target size of the volume, in GiB.

    - **TargetIops** *(integer) --*

      The target IOPS rate of the volume.

    - **TargetVolumeType** *(string) --*

      The target EBS volume type of the volume.

    - **OriginalSize** *(integer) --*

      The original size of the volume.

    - **OriginalIops** *(integer) --*

      The original IOPS rate of the volume.

    - **OriginalVolumeType** *(string) --*

      The original EBS volume type of the volume.

    - **Progress** *(integer) --*

      The modification progress, from 0 to 100 percent complete.

    - **StartTime** *(datetime) --*

      The modification start time.

    - **EndTime** *(datetime) --*

      The modification completion or failure time.
    """


_ClientModifyVolumeResponseTypeDef = TypedDict(
    "_ClientModifyVolumeResponseTypeDef",
    {"VolumeModification": ClientModifyVolumeResponseVolumeModificationTypeDef},
    total=False,
)


class ClientModifyVolumeResponseTypeDef(_ClientModifyVolumeResponseTypeDef):
    """
    Type definition for `ClientModifyVolume` `Response`

    - **VolumeModification** *(dict) --*

      Information about the volume modification.

      - **VolumeId** *(string) --*

        The ID of the volume.

      - **ModificationState** *(string) --*

        The current modification state. The modification state is null for unmodified volumes.

      - **StatusMessage** *(string) --*

        A status message about the modification progress or failure.

      - **TargetSize** *(integer) --*

        The target size of the volume, in GiB.

      - **TargetIops** *(integer) --*

        The target IOPS rate of the volume.

      - **TargetVolumeType** *(string) --*

        The target EBS volume type of the volume.

      - **OriginalSize** *(integer) --*

        The original size of the volume.

      - **OriginalIops** *(integer) --*

        The original IOPS rate of the volume.

      - **OriginalVolumeType** *(string) --*

        The original EBS volume type of the volume.

      - **Progress** *(integer) --*

        The modification progress, from 0 to 100 percent complete.

      - **StartTime** *(datetime) --*

        The modification start time.

      - **EndTime** *(datetime) --*

        The modification completion or failure time.
    """


_ClientModifyVpcAttributeEnableDnsHostnamesTypeDef = TypedDict(
    "_ClientModifyVpcAttributeEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class ClientModifyVpcAttributeEnableDnsHostnamesTypeDef(
    _ClientModifyVpcAttributeEnableDnsHostnamesTypeDef
):
    """
    Type definition for `ClientModifyVpcAttribute` `EnableDnsHostnames`

    Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in
    the VPC get DNS hostnames; otherwise, they do not.

    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS
    support.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVpcAttributeEnableDnsSupportTypeDef = TypedDict(
    "_ClientModifyVpcAttributeEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class ClientModifyVpcAttributeEnableDnsSupportTypeDef(
    _ClientModifyVpcAttributeEnableDnsSupportTypeDef
):
    """
    Type definition for `ClientModifyVpcAttribute` `EnableDnsSupport`

    Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to the Amazon
    provided DNS server at the 169.254.169.253 IP address, or the reserved IP address at the base of
    the VPC network range "plus two" succeed. If disabled, the Amazon provided DNS service in the VPC
    that resolves public DNS hostnames to IP addresses is not enabled.

    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVpcEndpointConnectionNotificationResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointConnectionNotificationResponseTypeDef",
    {"ReturnValue": bool},
    total=False,
)


class ClientModifyVpcEndpointConnectionNotificationResponseTypeDef(
    _ClientModifyVpcEndpointConnectionNotificationResponseTypeDef
):
    """
    Type definition for `ClientModifyVpcEndpointConnectionNotification` `Response`

    - **ReturnValue** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyVpcEndpointResponseTypeDef(_ClientModifyVpcEndpointResponseTypeDef):
    """
    Type definition for `ClientModifyVpcEndpoint` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointServiceConfigurationResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointServiceConfigurationResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientModifyVpcEndpointServiceConfigurationResponseTypeDef(
    _ClientModifyVpcEndpointServiceConfigurationResponseTypeDef
):
    """
    Type definition for `ClientModifyVpcEndpointServiceConfiguration` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointServicePermissionsResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointServicePermissionsResponseTypeDef",
    {"ReturnValue": bool},
    total=False,
)


class ClientModifyVpcEndpointServicePermissionsResponseTypeDef(
    _ClientModifyVpcEndpointServicePermissionsResponseTypeDef
):
    """
    Type definition for `ClientModifyVpcEndpointServicePermissions` `Response`

    - **ReturnValue** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpcPeeringConnectionOptions` `AccepterPeeringConnectionOptions`

    The VPC peering connection options for the accepter VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, enables a local VPC to resolve public DNS hostnames to private IP addresses when
      queried from instances in the peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      If true, enables outbound communication from an EC2-Classic instance that's linked to a local
      VPC using ClassicLink to instances in a peer VPC.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      If true, enables outbound communication from instances in a local VPC to an EC2-Classic
      instance that's linked to a peer VPC using ClassicLink.
    """


_ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpcPeeringConnectionOptions` `RequesterPeeringConnectionOptions`

    The VPC peering connection options for the requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, enables a local VPC to resolve public DNS hostnames to private IP addresses when
      queried from instances in the peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      If true, enables outbound communication from an EC2-Classic instance that's linked to a local
      VPC using ClassicLink to instances in a peer VPC.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      If true, enables outbound communication from instances in a local VPC to an EC2-Classic
      instance that's linked to a peer VPC using ClassicLink.
    """


_ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpcPeeringConnectionOptionsResponse` `AccepterPeeringConnectionOptions`

    Information about the VPC peering connection options for the accepter VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
      addresses when queried from instances in the peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      If true, enables outbound communication from an EC2-Classic instance that's linked to a
      local VPC using ClassicLink to instances in a peer VPC.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      If true, enables outbound communication from instances in a local VPC to an EC2-Classic
      instance that's linked to a peer VPC using ClassicLink.
    """


_ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpcPeeringConnectionOptionsResponse` `RequesterPeeringConnectionOptions`

    Information about the VPC peering connection options for the requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
      addresses when queried from instances in the peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      If true, enables outbound communication from an EC2-Classic instance that's linked to a
      local VPC using ClassicLink to instances in a peer VPC.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      If true, enables outbound communication from instances in a local VPC to an EC2-Classic
      instance that's linked to a peer VPC using ClassicLink.
    """


_ClientModifyVpcPeeringConnectionOptionsResponseTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseTypeDef",
    {
        "AccepterPeeringConnectionOptions": ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef,
        "RequesterPeeringConnectionOptions": ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseTypeDef
):
    """
    Type definition for `ClientModifyVpcPeeringConnectionOptions` `Response`

    - **AccepterPeeringConnectionOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
        addresses when queried from instances in the peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        If true, enables outbound communication from an EC2-Classic instance that's linked to a
        local VPC using ClassicLink to instances in a peer VPC.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        If true, enables outbound communication from instances in a local VPC to an EC2-Classic
        instance that's linked to a peer VPC using ClassicLink.

    - **RequesterPeeringConnectionOptions** *(dict) --*

      Information about the VPC peering connection options for the requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
        addresses when queried from instances in the peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        If true, enables outbound communication from an EC2-Classic instance that's linked to a
        local VPC using ClassicLink to instances in a peer VPC.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        If true, enables outbound communication from instances in a local VPC to an EC2-Classic
        instance that's linked to a peer VPC using ClassicLink.
    """


_ClientModifyVpcTenancyResponseTypeDef = TypedDict(
    "_ClientModifyVpcTenancyResponseTypeDef", {"ReturnValue": bool}, total=False
)


class ClientModifyVpcTenancyResponseTypeDef(_ClientModifyVpcTenancyResponseTypeDef):
    """
    Type definition for `ClientModifyVpcTenancy` `Response`

    - **ReturnValue** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `IkeVersions`

    The internet key exchange (IKE) version permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1DHGroupNumbers`

    The Diffie-Hellmann group number for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    The encryption algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    The integrity algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2DHGroupNumbers`

    The Diffie-Hellmann group number for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    The encryption algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    The integrity algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnectionOptions` `TunnelOptions`

    The VPN tunnel options.

    - **OutsideIpAddress** *(string) --*

      The external IP address of the VPN tunnel.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel.

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual
      private gateway and the customer gateway.

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the
      AWS side of the VPN connection performs an IKE rekey.

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
      which the rekey time is randomly selected.

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

    - **DpdTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

    - **Phase1EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IkeVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      - *(dict) --*

        The internet key exchange (IKE) version permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnection` `Options`

    The VPN connection options.

    - **StaticRoutesOnly** *(boolean) --*

      Indicates whether the VPN connection uses static routes only. Static routes must be used
      for devices that don't support BGP.

    - **TunnelOptions** *(list) --*

      Indicates the VPN tunnel options.

      - *(dict) --*

        The VPN tunnel options.

        - **OutsideIpAddress** *(string) --*

          The external IP address of the VPN tunnel.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel.

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual
          private gateway and the customer gateway.

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the
          AWS side of the VPN connection performs an IKE rekey.

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
          which the rekey time is randomly selected.

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

        - **DpdTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

        - **Phase1EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IkeVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          - *(dict) --*

            The internet key exchange (IKE) version permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef",
    {"DestinationCidrBlock": str, "Source": str, "State": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnection` `Routes`

    Describes a static route for a VPN connection.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block associated with the local subnet of the customer data center.

    - **Source** *(string) --*

      Indicates how the routes were provided.

    - **State** *(string) --*

      The current state of the static route.
    """


_ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": str,
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponseVpnConnection` `VgwTelemetry`

    Describes telemetry for a VPN tunnel.

    - **AcceptedRouteCount** *(integer) --*

      The number of accepted routes.

    - **LastStatusChange** *(datetime) --*

      The date and time of the last change in status.

    - **OutsideIpAddress** *(string) --*

      The Internet-routable IP address of the virtual private gateway's outside interface.

    - **Status** *(string) --*

      The status of the VPN tunnel.

    - **StatusMessage** *(string) --*

      If an error occurs, a description of the error.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnConnectionResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": str,
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[
            ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionTypeDef
):
    """
    Type definition for `ClientModifyVpnConnectionResponse` `VpnConnection`

    Describes a VPN connection.

    - **CustomerGatewayConfiguration** *(string) --*

      The configuration information for the VPN connection's customer gateway (in the native XML
      format). This element is always present in the  CreateVpnConnection response; however, it's
      present in the  DescribeVpnConnections response only if the VPN connection is in the
      ``pending`` or ``available`` state.

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway at your end of the VPN connection.

    - **Category** *(string) --*

      The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
      value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

    - **State** *(string) --*

      The current state of the VPN connection.

    - **Type** *(string) --*

      The type of VPN connection.

    - **VpnConnectionId** *(string) --*

      The ID of the VPN connection.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway at the AWS side of the VPN connection.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway associated with the VPN connection.

    - **Options** *(dict) --*

      The VPN connection options.

      - **StaticRoutesOnly** *(boolean) --*

        Indicates whether the VPN connection uses static routes only. Static routes must be used
        for devices that don't support BGP.

      - **TunnelOptions** *(list) --*

        Indicates the VPN tunnel options.

        - *(dict) --*

          The VPN tunnel options.

          - **OutsideIpAddress** *(string) --*

            The external IP address of the VPN tunnel.

          - **TunnelInsideCidr** *(string) --*

            The range of inside IP addresses for the tunnel.

          - **PreSharedKey** *(string) --*

            The pre-shared key (PSK) to establish initial authentication between the virtual
            private gateway and the customer gateway.

          - **Phase1LifetimeSeconds** *(integer) --*

            The lifetime for phase 1 of the IKE negotiation, in seconds.

          - **Phase2LifetimeSeconds** *(integer) --*

            The lifetime for phase 2 of the IKE negotiation, in seconds.

          - **RekeyMarginTimeSeconds** *(integer) --*

            The margin time, in seconds, before the phase 2 lifetime expires, during which the
            AWS side of the VPN connection performs an IKE rekey.

          - **RekeyFuzzPercentage** *(integer) --*

            The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
            which the rekey time is randomly selected.

          - **ReplayWindowSize** *(integer) --*

            The number of packets in an IKE replay window.

          - **DpdTimeoutSeconds** *(integer) --*

            The number of seconds after which a DPD timeout occurs.

          - **Phase1EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the encryption algorithm.

          - **Phase2EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The encryption algorithm.

          - **Phase1IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the integrity algorithm.

          - **Phase2IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The integrity algorithm.

          - **Phase1DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 1 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **Phase2DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 2 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **IkeVersions** *(list) --*

            The IKE versions that are permitted for the VPN tunnel.

            - *(dict) --*

              The internet key exchange (IKE) version permitted for the VPN tunnel.

              - **Value** *(string) --*

                The IKE version.

    - **Routes** *(list) --*

      The static routes associated with the VPN connection.

      - *(dict) --*

        Describes a static route for a VPN connection.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block associated with the local subnet of the customer data center.

        - **Source** *(string) --*

          Indicates how the routes were provided.

        - **State** *(string) --*

          The current state of the static route.

    - **Tags** *(list) --*

      Any tags assigned to the VPN connection.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VgwTelemetry** *(list) --*

      Information about the VPN tunnel.

      - *(dict) --*

        Describes telemetry for a VPN tunnel.

        - **AcceptedRouteCount** *(integer) --*

          The number of accepted routes.

        - **LastStatusChange** *(datetime) --*

          The date and time of the last change in status.

        - **OutsideIpAddress** *(string) --*

          The Internet-routable IP address of the virtual private gateway's outside interface.

        - **Status** *(string) --*

          The status of the VPN tunnel.

        - **StatusMessage** *(string) --*

          If an error occurs, a description of the error.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnConnectionResponseTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseTypeDef",
    {"VpnConnection": ClientModifyVpnConnectionResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnConnectionResponseTypeDef(
    _ClientModifyVpnConnectionResponseTypeDef
):
    """
    Type definition for `ClientModifyVpnConnection` `Response`

    - **VpnConnection** *(dict) --*

      Describes a VPN connection.

      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.

      - **CustomerGatewayId** *(string) --*

        The ID of the customer gateway at your end of the VPN connection.

      - **Category** *(string) --*

        The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
        value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

      - **State** *(string) --*

        The current state of the VPN connection.

      - **Type** *(string) --*

        The type of VPN connection.

      - **VpnConnectionId** *(string) --*

        The ID of the VPN connection.

      - **VpnGatewayId** *(string) --*

        The ID of the virtual private gateway at the AWS side of the VPN connection.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway associated with the VPN connection.

      - **Options** *(dict) --*

        The VPN connection options.

        - **StaticRoutesOnly** *(boolean) --*

          Indicates whether the VPN connection uses static routes only. Static routes must be used
          for devices that don't support BGP.

        - **TunnelOptions** *(list) --*

          Indicates the VPN tunnel options.

          - *(dict) --*

            The VPN tunnel options.

            - **OutsideIpAddress** *(string) --*

              The external IP address of the VPN tunnel.

            - **TunnelInsideCidr** *(string) --*

              The range of inside IP addresses for the tunnel.

            - **PreSharedKey** *(string) --*

              The pre-shared key (PSK) to establish initial authentication between the virtual
              private gateway and the customer gateway.

            - **Phase1LifetimeSeconds** *(integer) --*

              The lifetime for phase 1 of the IKE negotiation, in seconds.

            - **Phase2LifetimeSeconds** *(integer) --*

              The lifetime for phase 2 of the IKE negotiation, in seconds.

            - **RekeyMarginTimeSeconds** *(integer) --*

              The margin time, in seconds, before the phase 2 lifetime expires, during which the
              AWS side of the VPN connection performs an IKE rekey.

            - **RekeyFuzzPercentage** *(integer) --*

              The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
              which the rekey time is randomly selected.

            - **ReplayWindowSize** *(integer) --*

              The number of packets in an IKE replay window.

            - **DpdTimeoutSeconds** *(integer) --*

              The number of seconds after which a DPD timeout occurs.

            - **Phase1EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the encryption algorithm.

            - **Phase2EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The encryption algorithm.

            - **Phase1IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the integrity algorithm.

            - **Phase2IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The integrity algorithm.

            - **Phase1DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 1 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **Phase2DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 2 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **IkeVersions** *(list) --*

              The IKE versions that are permitted for the VPN tunnel.

              - *(dict) --*

                The internet key exchange (IKE) version permitted for the VPN tunnel.

                - **Value** *(string) --*

                  The IKE version.

      - **Routes** *(list) --*

        The static routes associated with the VPN connection.

        - *(dict) --*

          Describes a static route for a VPN connection.

          - **DestinationCidrBlock** *(string) --*

            The CIDR block associated with the local subnet of the customer data center.

          - **Source** *(string) --*

            Indicates how the routes were provided.

          - **State** *(string) --*

            The current state of the static route.

      - **Tags** *(list) --*

        Any tags assigned to the VPN connection.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VgwTelemetry** *(list) --*

        Information about the VPN tunnel.

        - *(dict) --*

          Describes telemetry for a VPN tunnel.

          - **AcceptedRouteCount** *(integer) --*

            The number of accepted routes.

          - **LastStatusChange** *(datetime) --*

            The date and time of the last change in status.

          - **OutsideIpAddress** *(string) --*

            The Internet-routable IP address of the virtual private gateway's outside interface.

          - **Status** *(string) --*

            The status of the VPN tunnel.

          - **StatusMessage** *(string) --*

            If an error occurs, a description of the error.

          - **CertificateArn** *(string) --*

            The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `IkeVersions`

    The internet key exchange (IKE) version permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase1DHGroupNumbers`

    The Diffie-Hellmann group number for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    The encryption algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    The integrity algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase2DHGroupNumbers`

    The Diffie-Hellmann group number for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    The encryption algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    The integrity algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnectionOptions` `TunnelOptions`

    The VPN tunnel options.

    - **OutsideIpAddress** *(string) --*

      The external IP address of the VPN tunnel.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel.

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual
      private gateway and the customer gateway.

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the
      AWS side of the VPN connection performs an IKE rekey.

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
      which the rekey time is randomly selected.

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

    - **DpdTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

    - **Phase1EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IkeVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      - *(dict) --*

        The internet key exchange (IKE) version permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnection` `Options`

    The VPN connection options.

    - **StaticRoutesOnly** *(boolean) --*

      Indicates whether the VPN connection uses static routes only. Static routes must be used
      for devices that don't support BGP.

    - **TunnelOptions** *(list) --*

      Indicates the VPN tunnel options.

      - *(dict) --*

        The VPN tunnel options.

        - **OutsideIpAddress** *(string) --*

          The external IP address of the VPN tunnel.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel.

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual
          private gateway and the customer gateway.

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the
          AWS side of the VPN connection performs an IKE rekey.

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
          which the rekey time is randomly selected.

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

        - **DpdTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

        - **Phase1EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IkeVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          - *(dict) --*

            The internet key exchange (IKE) version permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef",
    {"DestinationCidrBlock": str, "Source": str, "State": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnection` `Routes`

    Describes a static route for a VPN connection.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block associated with the local subnet of the customer data center.

    - **Source** *(string) --*

      Indicates how the routes were provided.

    - **State** *(string) --*

      The current state of the static route.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": str,
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponseVpnConnection` `VgwTelemetry`

    Describes telemetry for a VPN tunnel.

    - **AcceptedRouteCount** *(integer) --*

      The number of accepted routes.

    - **LastStatusChange** *(datetime) --*

      The date and time of the last change in status.

    - **OutsideIpAddress** *(string) --*

      The Internet-routable IP address of the virtual private gateway's outside interface.

    - **Status** *(string) --*

      The status of the VPN tunnel.

    - **StatusMessage** *(string) --*

      If an error occurs, a description of the error.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": str,
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef,
        "Routes": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef
        ],
        "Tags": List[ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificateResponse` `VpnConnection`

    Describes a VPN connection.

    - **CustomerGatewayConfiguration** *(string) --*

      The configuration information for the VPN connection's customer gateway (in the native XML
      format). This element is always present in the  CreateVpnConnection response; however, it's
      present in the  DescribeVpnConnections response only if the VPN connection is in the
      ``pending`` or ``available`` state.

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway at your end of the VPN connection.

    - **Category** *(string) --*

      The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
      value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

    - **State** *(string) --*

      The current state of the VPN connection.

    - **Type** *(string) --*

      The type of VPN connection.

    - **VpnConnectionId** *(string) --*

      The ID of the VPN connection.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway at the AWS side of the VPN connection.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway associated with the VPN connection.

    - **Options** *(dict) --*

      The VPN connection options.

      - **StaticRoutesOnly** *(boolean) --*

        Indicates whether the VPN connection uses static routes only. Static routes must be used
        for devices that don't support BGP.

      - **TunnelOptions** *(list) --*

        Indicates the VPN tunnel options.

        - *(dict) --*

          The VPN tunnel options.

          - **OutsideIpAddress** *(string) --*

            The external IP address of the VPN tunnel.

          - **TunnelInsideCidr** *(string) --*

            The range of inside IP addresses for the tunnel.

          - **PreSharedKey** *(string) --*

            The pre-shared key (PSK) to establish initial authentication between the virtual
            private gateway and the customer gateway.

          - **Phase1LifetimeSeconds** *(integer) --*

            The lifetime for phase 1 of the IKE negotiation, in seconds.

          - **Phase2LifetimeSeconds** *(integer) --*

            The lifetime for phase 2 of the IKE negotiation, in seconds.

          - **RekeyMarginTimeSeconds** *(integer) --*

            The margin time, in seconds, before the phase 2 lifetime expires, during which the
            AWS side of the VPN connection performs an IKE rekey.

          - **RekeyFuzzPercentage** *(integer) --*

            The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
            which the rekey time is randomly selected.

          - **ReplayWindowSize** *(integer) --*

            The number of packets in an IKE replay window.

          - **DpdTimeoutSeconds** *(integer) --*

            The number of seconds after which a DPD timeout occurs.

          - **Phase1EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the encryption algorithm.

          - **Phase2EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The encryption algorithm.

          - **Phase1IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the integrity algorithm.

          - **Phase2IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The integrity algorithm.

          - **Phase1DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 1 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **Phase2DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 2 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **IkeVersions** *(list) --*

            The IKE versions that are permitted for the VPN tunnel.

            - *(dict) --*

              The internet key exchange (IKE) version permitted for the VPN tunnel.

              - **Value** *(string) --*

                The IKE version.

    - **Routes** *(list) --*

      The static routes associated with the VPN connection.

      - *(dict) --*

        Describes a static route for a VPN connection.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block associated with the local subnet of the customer data center.

        - **Source** *(string) --*

          Indicates how the routes were provided.

        - **State** *(string) --*

          The current state of the static route.

    - **Tags** *(list) --*

      Any tags assigned to the VPN connection.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VgwTelemetry** *(list) --*

      Information about the VPN tunnel.

      - *(dict) --*

        Describes telemetry for a VPN tunnel.

        - **AcceptedRouteCount** *(integer) --*

          The number of accepted routes.

        - **LastStatusChange** *(datetime) --*

          The date and time of the last change in status.

        - **OutsideIpAddress** *(string) --*

          The Internet-routable IP address of the virtual private gateway's outside interface.

        - **Status** *(string) --*

          The status of the VPN tunnel.

        - **StatusMessage** *(string) --*

          If an error occurs, a description of the error.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelCertificateResponseTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseTypeDef",
    {"VpnConnection": ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseTypeDef(
    _ClientModifyVpnTunnelCertificateResponseTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelCertificate` `Response`

    - **VpnConnection** *(dict) --*

      Describes a VPN connection.

      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.

      - **CustomerGatewayId** *(string) --*

        The ID of the customer gateway at your end of the VPN connection.

      - **Category** *(string) --*

        The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
        value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

      - **State** *(string) --*

        The current state of the VPN connection.

      - **Type** *(string) --*

        The type of VPN connection.

      - **VpnConnectionId** *(string) --*

        The ID of the VPN connection.

      - **VpnGatewayId** *(string) --*

        The ID of the virtual private gateway at the AWS side of the VPN connection.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway associated with the VPN connection.

      - **Options** *(dict) --*

        The VPN connection options.

        - **StaticRoutesOnly** *(boolean) --*

          Indicates whether the VPN connection uses static routes only. Static routes must be used
          for devices that don't support BGP.

        - **TunnelOptions** *(list) --*

          Indicates the VPN tunnel options.

          - *(dict) --*

            The VPN tunnel options.

            - **OutsideIpAddress** *(string) --*

              The external IP address of the VPN tunnel.

            - **TunnelInsideCidr** *(string) --*

              The range of inside IP addresses for the tunnel.

            - **PreSharedKey** *(string) --*

              The pre-shared key (PSK) to establish initial authentication between the virtual
              private gateway and the customer gateway.

            - **Phase1LifetimeSeconds** *(integer) --*

              The lifetime for phase 1 of the IKE negotiation, in seconds.

            - **Phase2LifetimeSeconds** *(integer) --*

              The lifetime for phase 2 of the IKE negotiation, in seconds.

            - **RekeyMarginTimeSeconds** *(integer) --*

              The margin time, in seconds, before the phase 2 lifetime expires, during which the
              AWS side of the VPN connection performs an IKE rekey.

            - **RekeyFuzzPercentage** *(integer) --*

              The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
              which the rekey time is randomly selected.

            - **ReplayWindowSize** *(integer) --*

              The number of packets in an IKE replay window.

            - **DpdTimeoutSeconds** *(integer) --*

              The number of seconds after which a DPD timeout occurs.

            - **Phase1EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the encryption algorithm.

            - **Phase2EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The encryption algorithm.

            - **Phase1IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the integrity algorithm.

            - **Phase2IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The integrity algorithm.

            - **Phase1DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 1 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **Phase2DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 2 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **IkeVersions** *(list) --*

              The IKE versions that are permitted for the VPN tunnel.

              - *(dict) --*

                The internet key exchange (IKE) version permitted for the VPN tunnel.

                - **Value** *(string) --*

                  The IKE version.

      - **Routes** *(list) --*

        The static routes associated with the VPN connection.

        - *(dict) --*

          Describes a static route for a VPN connection.

          - **DestinationCidrBlock** *(string) --*

            The CIDR block associated with the local subnet of the customer data center.

          - **Source** *(string) --*

            Indicates how the routes were provided.

          - **State** *(string) --*

            The current state of the static route.

      - **Tags** *(list) --*

        Any tags assigned to the VPN connection.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VgwTelemetry** *(list) --*

        Information about the VPN tunnel.

        - *(dict) --*

          Describes telemetry for a VPN tunnel.

          - **AcceptedRouteCount** *(integer) --*

            The number of accepted routes.

          - **LastStatusChange** *(datetime) --*

            The date and time of the last change in status.

          - **OutsideIpAddress** *(string) --*

            The Internet-routable IP address of the virtual private gateway's outside interface.

          - **Status** *(string) --*

            The status of the VPN tunnel.

          - **StatusMessage** *(string) --*

            If an error occurs, a description of the error.

          - **CertificateArn** *(string) --*

            The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `IkeVersions`

    The internet key exchange (IKE) version permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase1DHGroupNumbers`

    The Diffie-Hellmann group number for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    The encryption algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    The integrity algorithm for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase2DHGroupNumbers`

    The Diffie-Hellmann group number for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    The encryption algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    The integrity algorithm for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnectionOptions` `TunnelOptions`

    The VPN tunnel options.

    - **OutsideIpAddress** *(string) --*

      The external IP address of the VPN tunnel.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel.

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual
      private gateway and the customer gateway.

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the
      AWS side of the VPN connection performs an IKE rekey.

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
      which the rekey time is randomly selected.

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

    - **DpdTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

    - **Phase1EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The encryption algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

      - *(dict) --*

        The integrity algorithm for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
      negotiations.

      - *(dict) --*

        The Diffie-Hellmann group number for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IkeVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      - *(dict) --*

        The internet key exchange (IKE) version permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnection` `Options`

    The VPN connection options.

    - **StaticRoutesOnly** *(boolean) --*

      Indicates whether the VPN connection uses static routes only. Static routes must be used
      for devices that don't support BGP.

    - **TunnelOptions** *(list) --*

      Indicates the VPN tunnel options.

      - *(dict) --*

        The VPN tunnel options.

        - **OutsideIpAddress** *(string) --*

          The external IP address of the VPN tunnel.

        - **TunnelInsideCidr** *(string) --*

          The range of inside IP addresses for the tunnel.

        - **PreSharedKey** *(string) --*

          The pre-shared key (PSK) to establish initial authentication between the virtual
          private gateway and the customer gateway.

        - **Phase1LifetimeSeconds** *(integer) --*

          The lifetime for phase 1 of the IKE negotiation, in seconds.

        - **Phase2LifetimeSeconds** *(integer) --*

          The lifetime for phase 2 of the IKE negotiation, in seconds.

        - **RekeyMarginTimeSeconds** *(integer) --*

          The margin time, in seconds, before the phase 2 lifetime expires, during which the
          AWS side of the VPN connection performs an IKE rekey.

        - **RekeyFuzzPercentage** *(integer) --*

          The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
          which the rekey time is randomly selected.

        - **ReplayWindowSize** *(integer) --*

          The number of packets in an IKE replay window.

        - **DpdTimeoutSeconds** *(integer) --*

          The number of seconds after which a DPD timeout occurs.

        - **Phase1EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the encryption algorithm.

        - **Phase2EncryptionAlgorithms** *(list) --*

          The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The encryption algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The encryption algorithm.

        - **Phase1IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 1 IKE negotiations.

            - **Value** *(string) --*

              The value for the integrity algorithm.

        - **Phase2IntegrityAlgorithms** *(list) --*

          The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

          - *(dict) --*

            The integrity algorithm for phase 2 IKE negotiations.

            - **Value** *(string) --*

              The integrity algorithm.

        - **Phase1DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 1 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **Phase2DHGroupNumbers** *(list) --*

          The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
          negotiations.

          - *(dict) --*

            The Diffie-Hellmann group number for phase 2 IKE negotiations.

            - **Value** *(integer) --*

              The Diffie-Hellmann group number.

        - **IkeVersions** *(list) --*

          The IKE versions that are permitted for the VPN tunnel.

          - *(dict) --*

            The internet key exchange (IKE) version permitted for the VPN tunnel.

            - **Value** *(string) --*

              The IKE version.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef",
    {"DestinationCidrBlock": str, "Source": str, "State": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnection` `Routes`

    Describes a static route for a VPN connection.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block associated with the local subnet of the customer data center.

    - **Source** *(string) --*

      Indicates how the routes were provided.

    - **State** *(string) --*

      The current state of the static route.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": str,
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponseVpnConnection` `VgwTelemetry`

    Describes telemetry for a VPN tunnel.

    - **AcceptedRouteCount** *(integer) --*

      The number of accepted routes.

    - **LastStatusChange** *(datetime) --*

      The date and time of the last change in status.

    - **OutsideIpAddress** *(string) --*

      The Internet-routable IP address of the virtual private gateway's outside interface.

    - **Status** *(string) --*

      The status of the VPN tunnel.

    - **StatusMessage** *(string) --*

      If an error occurs, a description of the error.

    - **CertificateArn** *(string) --*

      The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": str,
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsResponse` `VpnConnection`

    Describes a VPN connection.

    - **CustomerGatewayConfiguration** *(string) --*

      The configuration information for the VPN connection's customer gateway (in the native XML
      format). This element is always present in the  CreateVpnConnection response; however, it's
      present in the  DescribeVpnConnections response only if the VPN connection is in the
      ``pending`` or ``available`` state.

    - **CustomerGatewayId** *(string) --*

      The ID of the customer gateway at your end of the VPN connection.

    - **Category** *(string) --*

      The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
      value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

    - **State** *(string) --*

      The current state of the VPN connection.

    - **Type** *(string) --*

      The type of VPN connection.

    - **VpnConnectionId** *(string) --*

      The ID of the VPN connection.

    - **VpnGatewayId** *(string) --*

      The ID of the virtual private gateway at the AWS side of the VPN connection.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway associated with the VPN connection.

    - **Options** *(dict) --*

      The VPN connection options.

      - **StaticRoutesOnly** *(boolean) --*

        Indicates whether the VPN connection uses static routes only. Static routes must be used
        for devices that don't support BGP.

      - **TunnelOptions** *(list) --*

        Indicates the VPN tunnel options.

        - *(dict) --*

          The VPN tunnel options.

          - **OutsideIpAddress** *(string) --*

            The external IP address of the VPN tunnel.

          - **TunnelInsideCidr** *(string) --*

            The range of inside IP addresses for the tunnel.

          - **PreSharedKey** *(string) --*

            The pre-shared key (PSK) to establish initial authentication between the virtual
            private gateway and the customer gateway.

          - **Phase1LifetimeSeconds** *(integer) --*

            The lifetime for phase 1 of the IKE negotiation, in seconds.

          - **Phase2LifetimeSeconds** *(integer) --*

            The lifetime for phase 2 of the IKE negotiation, in seconds.

          - **RekeyMarginTimeSeconds** *(integer) --*

            The margin time, in seconds, before the phase 2 lifetime expires, during which the
            AWS side of the VPN connection performs an IKE rekey.

          - **RekeyFuzzPercentage** *(integer) --*

            The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
            which the rekey time is randomly selected.

          - **ReplayWindowSize** *(integer) --*

            The number of packets in an IKE replay window.

          - **DpdTimeoutSeconds** *(integer) --*

            The number of seconds after which a DPD timeout occurs.

          - **Phase1EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the encryption algorithm.

          - **Phase2EncryptionAlgorithms** *(list) --*

            The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The encryption algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The encryption algorithm.

          - **Phase1IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 1 IKE negotiations.

              - **Value** *(string) --*

                The value for the integrity algorithm.

          - **Phase2IntegrityAlgorithms** *(list) --*

            The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

            - *(dict) --*

              The integrity algorithm for phase 2 IKE negotiations.

              - **Value** *(string) --*

                The integrity algorithm.

          - **Phase1DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 1 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **Phase2DHGroupNumbers** *(list) --*

            The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
            negotiations.

            - *(dict) --*

              The Diffie-Hellmann group number for phase 2 IKE negotiations.

              - **Value** *(integer) --*

                The Diffie-Hellmann group number.

          - **IkeVersions** *(list) --*

            The IKE versions that are permitted for the VPN tunnel.

            - *(dict) --*

              The internet key exchange (IKE) version permitted for the VPN tunnel.

              - **Value** *(string) --*

                The IKE version.

    - **Routes** *(list) --*

      The static routes associated with the VPN connection.

      - *(dict) --*

        Describes a static route for a VPN connection.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block associated with the local subnet of the customer data center.

        - **Source** *(string) --*

          Indicates how the routes were provided.

        - **State** *(string) --*

          The current state of the static route.

    - **Tags** *(list) --*

      Any tags assigned to the VPN connection.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VgwTelemetry** *(list) --*

      Information about the VPN tunnel.

      - *(dict) --*

        Describes telemetry for a VPN tunnel.

        - **AcceptedRouteCount** *(integer) --*

          The number of accepted routes.

        - **LastStatusChange** *(datetime) --*

          The date and time of the last change in status.

        - **OutsideIpAddress** *(string) --*

          The Internet-routable IP address of the virtual private gateway's outside interface.

        - **Status** *(string) --*

          The status of the VPN tunnel.

        - **StatusMessage** *(string) --*

          If an error occurs, a description of the error.

        - **CertificateArn** *(string) --*

          The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelOptionsResponseTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseTypeDef",
    {"VpnConnection": ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseTypeDef(
    _ClientModifyVpnTunnelOptionsResponseTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptions` `Response`

    - **VpnConnection** *(dict) --*

      Describes a VPN connection.

      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.

      - **CustomerGatewayId** *(string) --*

        The ID of the customer gateway at your end of the VPN connection.

      - **Category** *(string) --*

        The category of the VPN connection. A value of ``VPN`` indicates an AWS VPN connection. A
        value of ``VPN-Classic`` indicates an AWS Classic VPN connection.

      - **State** *(string) --*

        The current state of the VPN connection.

      - **Type** *(string) --*

        The type of VPN connection.

      - **VpnConnectionId** *(string) --*

        The ID of the VPN connection.

      - **VpnGatewayId** *(string) --*

        The ID of the virtual private gateway at the AWS side of the VPN connection.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway associated with the VPN connection.

      - **Options** *(dict) --*

        The VPN connection options.

        - **StaticRoutesOnly** *(boolean) --*

          Indicates whether the VPN connection uses static routes only. Static routes must be used
          for devices that don't support BGP.

        - **TunnelOptions** *(list) --*

          Indicates the VPN tunnel options.

          - *(dict) --*

            The VPN tunnel options.

            - **OutsideIpAddress** *(string) --*

              The external IP address of the VPN tunnel.

            - **TunnelInsideCidr** *(string) --*

              The range of inside IP addresses for the tunnel.

            - **PreSharedKey** *(string) --*

              The pre-shared key (PSK) to establish initial authentication between the virtual
              private gateway and the customer gateway.

            - **Phase1LifetimeSeconds** *(integer) --*

              The lifetime for phase 1 of the IKE negotiation, in seconds.

            - **Phase2LifetimeSeconds** *(integer) --*

              The lifetime for phase 2 of the IKE negotiation, in seconds.

            - **RekeyMarginTimeSeconds** *(integer) --*

              The margin time, in seconds, before the phase 2 lifetime expires, during which the
              AWS side of the VPN connection performs an IKE rekey.

            - **RekeyFuzzPercentage** *(integer) --*

              The percentage of the rekey window determined by ``RekeyMarginTimeSeconds`` during
              which the rekey time is randomly selected.

            - **ReplayWindowSize** *(integer) --*

              The number of packets in an IKE replay window.

            - **DpdTimeoutSeconds** *(integer) --*

              The number of seconds after which a DPD timeout occurs.

            - **Phase1EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the encryption algorithm.

            - **Phase2EncryptionAlgorithms** *(list) --*

              The permitted encryption algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The encryption algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The encryption algorithm.

            - **Phase1IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 1 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 1 IKE negotiations.

                - **Value** *(string) --*

                  The value for the integrity algorithm.

            - **Phase2IntegrityAlgorithms** *(list) --*

              The permitted integrity algorithms for the VPN tunnel for phase 2 IKE negotiations.

              - *(dict) --*

                The integrity algorithm for phase 2 IKE negotiations.

                - **Value** *(string) --*

                  The integrity algorithm.

            - **Phase1DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 1 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 1 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **Phase2DHGroupNumbers** *(list) --*

              The permitted Diffie-Hellman group numbers for the VPN tunnel for phase 2 IKE
              negotiations.

              - *(dict) --*

                The Diffie-Hellmann group number for phase 2 IKE negotiations.

                - **Value** *(integer) --*

                  The Diffie-Hellmann group number.

            - **IkeVersions** *(list) --*

              The IKE versions that are permitted for the VPN tunnel.

              - *(dict) --*

                The internet key exchange (IKE) version permitted for the VPN tunnel.

                - **Value** *(string) --*

                  The IKE version.

      - **Routes** *(list) --*

        The static routes associated with the VPN connection.

        - *(dict) --*

          Describes a static route for a VPN connection.

          - **DestinationCidrBlock** *(string) --*

            The CIDR block associated with the local subnet of the customer data center.

          - **Source** *(string) --*

            Indicates how the routes were provided.

          - **State** *(string) --*

            The current state of the static route.

      - **Tags** *(list) --*

        Any tags assigned to the VPN connection.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VgwTelemetry** *(list) --*

        Information about the VPN tunnel.

        - *(dict) --*

          Describes telemetry for a VPN tunnel.

          - **AcceptedRouteCount** *(integer) --*

            The number of accepted routes.

          - **LastStatusChange** *(datetime) --*

            The date and time of the last change in status.

          - **OutsideIpAddress** *(string) --*

            The Internet-routable IP address of the virtual private gateway's outside interface.

          - **Status** *(string) --*

            The status of the VPN tunnel.

          - **StatusMessage** *(string) --*

            If an error occurs, a description of the error.

          - **CertificateArn** *(string) --*

            The Amazon Resource Name (ARN) of the VPN tunnel endpoint certificate.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `IKEVersions`

    The IKE version that is permitted for the VPN tunnel.

    - **Value** *(string) --*

      The IKE version.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase1DHGroupNumbers`

    Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase1EncryptionAlgorithms`

    Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the encryption algorithm.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase1IntegrityAlgorithms`

    Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE negotiations.

    - **Value** *(string) --*

      The value for the integrity algorithm.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase2DHGroupNumbers`

    Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(integer) --*

      The Diffie-Hellmann group number.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase2EncryptionAlgorithms`

    Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The encryption algorithm.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptionsTunnelOptions` `Phase2IntegrityAlgorithms`

    Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE negotiations.

    - **Value** *(string) --*

      The integrity algorithm.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef",
    {
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IKEVersions": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef
):
    """
    Type definition for `ClientModifyVpnTunnelOptions` `TunnelOptions`

    The tunnel options to modify.

    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel. Any specified CIDR blocks must be unique
      across all VPN connections that use the same virtual private gateway.

      Constraints: A size /30 CIDR block from the ``169.254.0.0/16`` range. The following CIDR blocks
      are reserved and cannot be used:

      * ``169.254.0.0/30``

      * ``169.254.1.0/30``

      * ``169.254.2.0/30``

      * ``169.254.3.0/30``

      * ``169.254.4.0/30``

      * ``169.254.5.0/30``

      * ``169.254.169.252/30``

    - **PreSharedKey** *(string) --*

      The pre-shared key (PSK) to establish initial authentication between the virtual private
      gateway and the customer gateway.

      Constraints: Allowed characters are alphanumeric characters, periods (.), and underscores (_).
      Must be between 8 and 64 characters in length and cannot start with zero (0).

    - **Phase1LifetimeSeconds** *(integer) --*

      The lifetime for phase 1 of the IKE negotiation, in seconds.

      Constraints: A value between 900 and 28,800.

      Default: ``28800``

    - **Phase2LifetimeSeconds** *(integer) --*

      The lifetime for phase 2 of the IKE negotiation, in seconds.

      Constraints: A value between 900 and 3,600. The value must be less than the value for
      ``Phase1LifetimeSeconds`` .

      Default: ``3600``

    - **RekeyMarginTimeSeconds** *(integer) --*

      The margin time, in seconds, before the phase 2 lifetime expires, during which the AWS side of
      the VPN connection performs an IKE rekey. The exact time of the rekey is randomly selected
      based on the value for ``RekeyFuzzPercentage`` .

      Constraints: A value between 60 and half of ``Phase2LifetimeSeconds`` .

      Default: ``540``

    - **RekeyFuzzPercentage** *(integer) --*

      The percentage of the rekey window (determined by ``RekeyMarginTimeSeconds`` ) during which the
      rekey time is randomly selected.

      Constraints: A value between 0 and 100.

      Default: ``100``

    - **ReplayWindowSize** *(integer) --*

      The number of packets in an IKE replay window.

      Constraints: A value between 64 and 2048.

      Default: ``1024``

    - **DPDTimeoutSeconds** *(integer) --*

      The number of seconds after which a DPD timeout occurs.

      Constraints: A value between 0 and 30.

      Default: ``30``

    - **Phase1EncryptionAlgorithms** *(list) --*

      One or more encryption algorithms that are permitted for the VPN tunnel for phase 1 IKE
      negotiations.

      Valid values: ``AES128`` | ``AES256``

      - *(dict) --*

        Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the encryption algorithm.

    - **Phase2EncryptionAlgorithms** *(list) --*

      One or more encryption algorithms that are permitted for the VPN tunnel for phase 2 IKE
      negotiations.

      Valid values: ``AES128`` | ``AES256``

      - *(dict) --*

        Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The encryption algorithm.

    - **Phase1IntegrityAlgorithms** *(list) --*

      One or more integrity algorithms that are permitted for the VPN tunnel for phase 1 IKE
      negotiations.

      Valid values: ``SHA1`` | ``SHA2-256``

      - *(dict) --*

        Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(string) --*

          The value for the integrity algorithm.

    - **Phase2IntegrityAlgorithms** *(list) --*

      One or more integrity algorithms that are permitted for the VPN tunnel for phase 2 IKE
      negotiations.

      Valid values: ``SHA1`` | ``SHA2-256``

      - *(dict) --*

        Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(string) --*

          The integrity algorithm.

    - **Phase1DHGroupNumbers** *(list) --*

      One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 1 IKE
      negotiations.

      Valid values: ``2`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23`` | ``24``

      - *(dict) --*

        Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **Phase2DHGroupNumbers** *(list) --*

      One or more Diffie-Hellman group numbers that are permitted for the VPN tunnel for phase 2 IKE
      negotiations.

      Valid values: ``2`` | ``5`` | ``14`` | ``15`` | ``16`` | ``17`` | ``18`` | ``22`` | ``23`` |
      ``24``

      - *(dict) --*

        Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2 IKE negotiations.

        - **Value** *(integer) --*

          The Diffie-Hellmann group number.

    - **IKEVersions** *(list) --*

      The IKE versions that are permitted for the VPN tunnel.

      Valid values: ``ikev1`` | ``ikev2``

      - *(dict) --*

        The IKE version that is permitted for the VPN tunnel.

        - **Value** *(string) --*

          The IKE version.
    """


_ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef(
    _ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `ClientMonitorInstancesResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientMonitorInstancesResponseInstanceMonitoringsTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class ClientMonitorInstancesResponseInstanceMonitoringsTypeDef(
    _ClientMonitorInstancesResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `ClientMonitorInstancesResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_ClientMonitorInstancesResponseTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseTypeDef",
    {
        "InstanceMonitorings": List[
            ClientMonitorInstancesResponseInstanceMonitoringsTypeDef
        ]
    },
    total=False,
)


class ClientMonitorInstancesResponseTypeDef(_ClientMonitorInstancesResponseTypeDef):
    """
    Type definition for `ClientMonitorInstances` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_ClientMoveAddressToVpcResponseTypeDef = TypedDict(
    "_ClientMoveAddressToVpcResponseTypeDef",
    {"AllocationId": str, "Status": str},
    total=False,
)


class ClientMoveAddressToVpcResponseTypeDef(_ClientMoveAddressToVpcResponseTypeDef):
    """
    Type definition for `ClientMoveAddressToVpc` `Response`

    - **AllocationId** *(string) --*

      The allocation ID for the Elastic IP address.

    - **Status** *(string) --*

      The status of the move of the IP address.
    """


_ClientProvisionByoipCidrCidrAuthorizationContextTypeDef = TypedDict(
    "_ClientProvisionByoipCidrCidrAuthorizationContextTypeDef",
    {"Message": str, "Signature": str},
)


class ClientProvisionByoipCidrCidrAuthorizationContextTypeDef(
    _ClientProvisionByoipCidrCidrAuthorizationContextTypeDef
):
    """
    Type definition for `ClientProvisionByoipCidr` `CidrAuthorizationContext`

    A signed document that proves that you are authorized to bring the specified IP address range to
    Amazon using BYOIP.

    - **Message** *(string) --* **[REQUIRED]**

      The plain-text authorization message for the prefix and account.

    - **Signature** *(string) --* **[REQUIRED]**

      The signed authorization message for the prefix and account.
    """


_ClientProvisionByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientProvisionByoipCidrResponseByoipCidrTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class ClientProvisionByoipCidrResponseByoipCidrTypeDef(
    _ClientProvisionByoipCidrResponseByoipCidrTypeDef
):
    """
    Type definition for `ClientProvisionByoipCidrResponse` `ByoipCidr`

    Information about the address pool.

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_ClientProvisionByoipCidrResponseTypeDef = TypedDict(
    "_ClientProvisionByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientProvisionByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientProvisionByoipCidrResponseTypeDef(_ClientProvisionByoipCidrResponseTypeDef):
    """
    Type definition for `ClientProvisionByoipCidr` `Response`

    - **ByoipCidr** *(dict) --*

      Information about the address pool.

      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.

      - **Description** *(string) --*

        The description of the address range.

      - **StatusMessage** *(string) --*

        Upon success, contains the ID of the address pool. Otherwise, contains an error message.

      - **State** *(string) --*

        The state of the address pool.
    """


_ClientPurchaseHostReservationResponsePurchaseTypeDef = TypedDict(
    "_ClientPurchaseHostReservationResponsePurchaseTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "PaymentOption": str,
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientPurchaseHostReservationResponsePurchaseTypeDef(
    _ClientPurchaseHostReservationResponsePurchaseTypeDef
):
    """
    Type definition for `ClientPurchaseHostReservationResponse` `Purchase`

    Describes the result of the purchase.

    - **CurrencyCode** *(string) --*

      The currency in which the ``UpfrontPrice`` and ``HourlyPrice`` amounts are specified. At
      this time, the only supported currency is ``USD`` .

    - **Duration** *(integer) --*

      The duration of the reservation's term in seconds.

    - **HostIdSet** *(list) --*

      The IDs of the Dedicated Hosts associated with the reservation.

      - *(string) --*

    - **HostReservationId** *(string) --*

      The ID of the reservation.

    - **HourlyPrice** *(string) --*

      The hourly price of the reservation per hour.

    - **InstanceFamily** *(string) --*

      The instance family on the Dedicated Host that the reservation can be associated with.

    - **PaymentOption** *(string) --*

      The payment option for the reservation.

    - **UpfrontPrice** *(string) --*

      The upfront price of the reservation.
    """


_ClientPurchaseHostReservationResponseTypeDef = TypedDict(
    "_ClientPurchaseHostReservationResponseTypeDef",
    {
        "ClientToken": str,
        "CurrencyCode": str,
        "Purchase": List[ClientPurchaseHostReservationResponsePurchaseTypeDef],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
    },
    total=False,
)


class ClientPurchaseHostReservationResponseTypeDef(
    _ClientPurchaseHostReservationResponseTypeDef
):
    """
    Type definition for `ClientPurchaseHostReservation` `Response`

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
      For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .

    - **CurrencyCode** *(string) --*

      The currency in which the ``totalUpfrontPrice`` and ``totalHourlyPrice`` amounts are
      specified. At this time, the only supported currency is ``USD`` .

    - **Purchase** *(list) --*

      Describes the details of the purchase.

      - *(dict) --*

        Describes the result of the purchase.

        - **CurrencyCode** *(string) --*

          The currency in which the ``UpfrontPrice`` and ``HourlyPrice`` amounts are specified. At
          this time, the only supported currency is ``USD`` .

        - **Duration** *(integer) --*

          The duration of the reservation's term in seconds.

        - **HostIdSet** *(list) --*

          The IDs of the Dedicated Hosts associated with the reservation.

          - *(string) --*

        - **HostReservationId** *(string) --*

          The ID of the reservation.

        - **HourlyPrice** *(string) --*

          The hourly price of the reservation per hour.

        - **InstanceFamily** *(string) --*

          The instance family on the Dedicated Host that the reservation can be associated with.

        - **PaymentOption** *(string) --*

          The payment option for the reservation.

        - **UpfrontPrice** *(string) --*

          The upfront price of the reservation.

    - **TotalHourlyPrice** *(string) --*

      The total hourly price of the reservation calculated per hour.

    - **TotalUpfrontPrice** *(string) --*

      The total amount charged to your account when you purchase the reservation.
    """


_ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef = TypedDict(
    "_ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef",
    {"Amount": float, "CurrencyCode": str},
    total=False,
)


class ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef(
    _ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef
):
    """
    Type definition for `ClientPurchaseReservedInstancesOffering` `LimitPrice`

    Specified for Reserved Instance Marketplace offerings to limit the total order and ensure that
    the Reserved Instances are not purchased at unexpected prices.

    - **Amount** *(float) --*

      Used for Reserved Instance Marketplace offerings. Specifies the limit price on the total order
      (instanceCount * price).

    - **CurrencyCode** *(string) --*

      The currency in which the ``limitPrice`` amount is specified. At this time, the only supported
      currency is ``USD`` .
    """


_ClientPurchaseReservedInstancesOfferingResponseTypeDef = TypedDict(
    "_ClientPurchaseReservedInstancesOfferingResponseTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientPurchaseReservedInstancesOfferingResponseTypeDef(
    _ClientPurchaseReservedInstancesOfferingResponseTypeDef
):
    """
    Type definition for `ClientPurchaseReservedInstancesOffering` `Response`

    Contains the output of PurchaseReservedInstancesOffering.

    - **ReservedInstancesId** *(string) --*

      The IDs of the purchased Reserved Instances.
    """


_ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef",
    {"InstanceCount": int, "PurchaseToken": str},
)


class ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef(
    _ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef
):
    """
    Type definition for `ClientPurchaseScheduledInstances` `PurchaseRequests`

    Describes a request to purchase Scheduled Instances.

    - **InstanceCount** *(integer) --* **[REQUIRED]**

      The number of instances.

    - **PurchaseToken** *(string) --* **[REQUIRED]**

      The purchase token.
    """


_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef(
    _ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef
):
    """
    Type definition for `ClientPurchaseScheduledInstancesResponseScheduledInstanceSet` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``frequency`` . For
      example, every 2 weeks or every 2 months.

    - **OccurrenceDaySet** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a
      weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month.

    - **OccurrenceUnit** *(string) --*

      The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).
    """


_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef(
    _ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef
):
    """
    Type definition for `ClientPurchaseScheduledInstancesResponse` `ScheduledInstanceSet`

    Describes a Scheduled Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **CreateDate** *(datetime) --*

      The date when the Scheduled Instance was purchased.

    - **HourlyPrice** *(string) --*

      The hourly price for a single instance.

    - **InstanceCount** *(integer) --*

      The number of instances.

    - **InstanceType** *(string) --*

      The instance type.

    - **NetworkPlatform** *(string) --*

      The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

    - **NextSlotStartTime** *(datetime) --*

      The time for the next schedule to start.

    - **Platform** *(string) --*

      The platform (``Linux/UNIX`` or ``Windows`` ).

    - **PreviousSlotEndTime** *(datetime) --*

      The time that the previous schedule ended or will end.

    - **Recurrence** *(dict) --*

      The schedule recurrence.

      - **Frequency** *(string) --*

        The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

      - **Interval** *(integer) --*

        The interval quantity. The interval unit depends on the value of ``frequency`` . For
        example, every 2 weeks or every 2 months.

      - **OccurrenceDaySet** *(list) --*

        The days. For a monthly schedule, this is one or more days of the month (1-31). For a
        weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

        - *(integer) --*

      - **OccurrenceRelativeToEnd** *(boolean) --*

        Indicates whether the occurrence is relative to the end of the specified week or month.

      - **OccurrenceUnit** *(string) --*

        The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

    - **ScheduledInstanceId** *(string) --*

      The Scheduled Instance ID.

    - **SlotDurationInHours** *(integer) --*

      The number of hours in the schedule.

    - **TermEndDate** *(datetime) --*

      The end date for the Scheduled Instance.

    - **TermStartDate** *(datetime) --*

      The start date for the Scheduled Instance.

    - **TotalScheduledInstanceHours** *(integer) --*

      The total number of hours for a single instance for the entire term.
    """


_ClientPurchaseScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseTypeDef",
    {
        "ScheduledInstanceSet": List[
            ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef
        ]
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseTypeDef(
    _ClientPurchaseScheduledInstancesResponseTypeDef
):
    """
    Type definition for `ClientPurchaseScheduledInstances` `Response`

    Contains the output of PurchaseScheduledInstances.

    - **ScheduledInstanceSet** *(list) --*

      Information about the Scheduled Instances.

      - *(dict) --*

        Describes a Scheduled Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **CreateDate** *(datetime) --*

          The date when the Scheduled Instance was purchased.

        - **HourlyPrice** *(string) --*

          The hourly price for a single instance.

        - **InstanceCount** *(integer) --*

          The number of instances.

        - **InstanceType** *(string) --*

          The instance type.

        - **NetworkPlatform** *(string) --*

          The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

        - **NextSlotStartTime** *(datetime) --*

          The time for the next schedule to start.

        - **Platform** *(string) --*

          The platform (``Linux/UNIX`` or ``Windows`` ).

        - **PreviousSlotEndTime** *(datetime) --*

          The time that the previous schedule ended or will end.

        - **Recurrence** *(dict) --*

          The schedule recurrence.

          - **Frequency** *(string) --*

            The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

          - **Interval** *(integer) --*

            The interval quantity. The interval unit depends on the value of ``frequency`` . For
            example, every 2 weeks or every 2 months.

          - **OccurrenceDaySet** *(list) --*

            The days. For a monthly schedule, this is one or more days of the month (1-31). For a
            weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

            - *(integer) --*

          - **OccurrenceRelativeToEnd** *(boolean) --*

            Indicates whether the occurrence is relative to the end of the specified week or month.

          - **OccurrenceUnit** *(string) --*

            The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

        - **ScheduledInstanceId** *(string) --*

          The Scheduled Instance ID.

        - **SlotDurationInHours** *(integer) --*

          The number of hours in the schedule.

        - **TermEndDate** *(datetime) --*

          The end date for the Scheduled Instance.

        - **TermStartDate** *(datetime) --*

          The start date for the Scheduled Instance.

        - **TotalScheduledInstanceHours** *(integer) --*

          The total number of hours for a single instance for the entire term.
    """


_ClientRegisterImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRegisterImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRegisterImageBlockDeviceMappingsEbsTypeDef(
    _ClientRegisterImageBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRegisterImageBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_ClientRegisterImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRegisterImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRegisterImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRegisterImageBlockDeviceMappingsTypeDef(
    _ClientRegisterImageBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRegisterImage` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientRegisterImageResponseTypeDef = TypedDict(
    "_ClientRegisterImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientRegisterImageResponseTypeDef(_ClientRegisterImageResponseTypeDef):
    """
    Type definition for `ClientRegisterImage` `Response`

    Contains the output of RegisterImage.

    - **ImageId** *(string) --*

      The ID of the newly registered AMI.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    Type definition for `ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    """
    Type definition for `ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachment` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    Type definition for `ClientRejectTransitGatewayVpcAttachmentResponse` `TransitGatewayVpcAttachment`

    Information about the attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    Type definition for `ClientRejectTransitGatewayVpcAttachment` `Response`

    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the attachment.

      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.

      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **VpcOwnerId** *(string) --*

        The ID of the AWS account that owns the VPC.

      - **State** *(string) --*

        The state of the VPC attachment.

      - **SubnetIds** *(list) --*

        The IDs of the subnets.

        - *(string) --*

      - **CreationTime** *(datetime) --*

        The creation time.

      - **Options** *(dict) --*

        The VPC attachment options.

        - **DnsSupport** *(string) --*

          Indicates whether DNS support is enabled.

        - **Ipv6Support** *(string) --*

          Indicates whether IPv6 support is enabled.

      - **Tags** *(list) --*

        The tags for the VPC attachment.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.
    """


_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientRejectVpcEndpointConnectionsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientRejectVpcEndpointConnectionsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientRejectVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseTypeDef",
    {
        "Unsuccessful": List[
            ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef
        ]
    },
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseTypeDef
):
    """
    Type definition for `ClientRejectVpcEndpointConnections` `Response`

    - **Unsuccessful** *(list) --*

      Information about the endpoints that were not rejected, if applicable.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientRejectVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientRejectVpcPeeringConnectionResponseTypeDef", {"Return": bool}, total=False
)


class ClientRejectVpcPeeringConnectionResponseTypeDef(
    _ClientRejectVpcPeeringConnectionResponseTypeDef
):
    """
    Type definition for `ClientRejectVpcPeeringConnection` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientReleaseHostsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientReleaseHostsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientReleaseHostsResponseUnsuccessfulErrorTypeDef(
    _ClientReleaseHostsResponseUnsuccessfulErrorTypeDef
):
    """
    Type definition for `ClientReleaseHostsResponseUnsuccessful` `Error`

    Information about the error.

    - **Code** *(string) --*

      The error code.

    - **Message** *(string) --*

      The error message accompanying the error code.
    """


_ClientReleaseHostsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientReleaseHostsResponseUnsuccessfulTypeDef",
    {"Error": ClientReleaseHostsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientReleaseHostsResponseUnsuccessfulTypeDef(
    _ClientReleaseHostsResponseUnsuccessfulTypeDef
):
    """
    Type definition for `ClientReleaseHostsResponse` `Unsuccessful`

    Information about items that were not successfully processed in a batch call.

    - **Error** *(dict) --*

      Information about the error.

      - **Code** *(string) --*

        The error code.

      - **Message** *(string) --*

        The error message accompanying the error code.

    - **ResourceId** *(string) --*

      The ID of the resource.
    """


_ClientReleaseHostsResponseTypeDef = TypedDict(
    "_ClientReleaseHostsResponseTypeDef",
    {
        "Successful": List[str],
        "Unsuccessful": List[ClientReleaseHostsResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientReleaseHostsResponseTypeDef(_ClientReleaseHostsResponseTypeDef):
    """
    Type definition for `ClientReleaseHosts` `Response`

    - **Successful** *(list) --*

      The IDs of the Dedicated Hosts that were successfully released.

      - *(string) --*

    - **Unsuccessful** *(list) --*

      The IDs of the Dedicated Hosts that could not be released, including an error message.

      - *(dict) --*

        Information about items that were not successfully processed in a batch call.

        - **Error** *(dict) --*

          Information about the error.

          - **Code** *(string) --*

            The error code.

          - **Message** *(string) --*

            The error message accompanying the error code.

        - **ResourceId** *(string) --*

          The ID of the resource.
    """


_ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientReplaceIamInstanceProfileAssociation` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociation` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef
):
    """
    Type definition for `ClientReplaceIamInstanceProfileAssociationResponse` `IamInstanceProfileAssociation`

    Information about the IAM instance profile association.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **State** *(string) --*

      The state of the association.

    - **Timestamp** *(datetime) --*

      The time the IAM instance profile was associated with the instance.
    """


_ClientReplaceIamInstanceProfileAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseTypeDef
):
    """
    Type definition for `ClientReplaceIamInstanceProfileAssociation` `Response`

    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.

      - **AssociationId** *(string) --*

        The ID of the association.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Id** *(string) --*

          The ID of the instance profile.

      - **State** *(string) --*

        The state of the association.

      - **Timestamp** *(datetime) --*

        The time the IAM instance profile was associated with the instance.
    """


_ClientReplaceNetworkAclAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceNetworkAclAssociationResponseTypeDef",
    {"NewAssociationId": str},
    total=False,
)


class ClientReplaceNetworkAclAssociationResponseTypeDef(
    _ClientReplaceNetworkAclAssociationResponseTypeDef
):
    """
    Type definition for `ClientReplaceNetworkAclAssociation` `Response`

    - **NewAssociationId** *(string) --*

      The ID of the new association.
    """


_ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef = TypedDict(
    "_ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef(
    _ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef
):
    """
    Type definition for `ClientReplaceNetworkAclEntry` `IcmpTypeCode`

    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_ClientReplaceNetworkAclEntryPortRangeTypeDef = TypedDict(
    "_ClientReplaceNetworkAclEntryPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientReplaceNetworkAclEntryPortRangeTypeDef(
    _ClientReplaceNetworkAclEntryPortRangeTypeDef
):
    """
    Type definition for `ClientReplaceNetworkAclEntry` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_ClientReplaceRouteTableAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceRouteTableAssociationResponseTypeDef",
    {"NewAssociationId": str},
    total=False,
)


class ClientReplaceRouteTableAssociationResponseTypeDef(
    _ClientReplaceRouteTableAssociationResponseTypeDef
):
    """
    Type definition for `ClientReplaceRouteTableAssociation` `Response`

    - **NewAssociationId** *(string) --*

      The ID of the new association.
    """


_ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {"ResourceId": str, "TransitGatewayAttachmentId": str, "ResourceType": str},
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientReplaceTransitGatewayRouteResponseRoute` `TransitGatewayAttachments`

    Describes a route attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceType** *(string) --*

      The resource type.
    """


_ClientReplaceTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": str,
        "State": str,
    },
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseRouteTypeDef(
    _ClientReplaceTransitGatewayRouteResponseRouteTypeDef
):
    """
    Type definition for `ClientReplaceTransitGatewayRouteResponse` `Route`

    Information about the modified route.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block used for destination matches.

    - **TransitGatewayAttachments** *(list) --*

      The attachments.

      - *(dict) --*

        Describes a route attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceType** *(string) --*

          The resource type.

    - **Type** *(string) --*

      The route type.

    - **State** *(string) --*

      The state of the route.
    """


_ClientReplaceTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseTypeDef",
    {"Route": ClientReplaceTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseTypeDef(
    _ClientReplaceTransitGatewayRouteResponseTypeDef
):
    """
    Type definition for `ClientReplaceTransitGatewayRoute` `Response`

    - **Route** *(dict) --*

      Information about the modified route.

      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.

      - **TransitGatewayAttachments** *(list) --*

        The attachments.

        - *(dict) --*

          Describes a route attachment.

          - **ResourceId** *(string) --*

            The ID of the resource.

          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.

          - **ResourceType** *(string) --*

            The resource type.

      - **Type** *(string) --*

        The route type.

      - **State** *(string) --*

        The state of the route.
    """


_ClientRequestSpotFleetResponseTypeDef = TypedDict(
    "_ClientRequestSpotFleetResponseTypeDef", {"SpotFleetRequestId": str}, total=False
)


class ClientRequestSpotFleetResponseTypeDef(_ClientRequestSpotFleetResponseTypeDef):
    """
    Type definition for `ClientRequestSpotFleet` `Response`

    Contains the output of RequestSpotFleet.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate
      at which the volume accumulates I/O credits for bursting. For more information, see
      `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
      `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is
      not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume
      size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
      SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
      HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
      snapshot, the volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
      the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being
      restored from a backing snapshot. The effect of setting the encryption state to
      ``true`` depends on the volume origin (new or from a snapshot), starting encryption
      state, ownership, and whether encryption by default is enabled. For more information,
      see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
      which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
      from 0. An instance type with 2 available instance store volumes can specify mappings
      for ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
      depends on the instance type. After you connect to the instance, you must mount the
      volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any instance
      store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate
        at which the volume accumulates I/O credits for bursting. For more information, see
        `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
        ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
        `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is
        not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume
        size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
        SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
        HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
        snapshot, the volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
        the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being
        restored from a backing snapshot. The effect of setting the encryption state to
        ``true`` depends on the volume origin (new or from a snapshot), starting encryption
        state, ownership, and whether encryption by default is enabled. For more information,
        see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
        which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `Monitoring`

    Enable or disable monitoring for the instances.

    - **Enabled** *(boolean) --*

      Enables monitoring for the instance.

      Default: ``false``
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a VPC.
      The public IP address can only be assigned to a network interface for eth0, and can
      only be assigned to a new network interface, not an existing one. You cannot specify
      more than one network interface in the request. If launching into a default subnet, the
      default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You can
      specify ``true`` only if creating a new network interface when launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network interface
      when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network
      interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the
      device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating a
      network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the
      IPv6 addresses from the range of the subnet. You cannot specify this option and the
      option to assign specific IPv6 addresses in the same request. You can specify this
      option if you've specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify this
      option and the option to assign a number of IPv6 addresses in the same request. You
      cannot specify this option if you've specified a minimum number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a network
      interface when launching an instance. You cannot specify this option if you're
      launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one private
      IPv4 address can be designated as primary. You cannot specify this option if you're
      launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and
      specify more than one private IP address using the private IP addresses option. You
      cannot specify this option if you're launching more than one instance in a
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if creating a
      network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
      ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `Placement`

    The placement information.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using commas; for
      example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for Spot Instances.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecifications` `TagSpecifications`

    The tags for a Spot Fleet resource.

    - **ResourceType** *(string) --*

      The type of resource. Currently, the only resource type that is supported is
      ``instance`` .

    - **Tags** *(list) --*

      The tags.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfig` `LaunchSpecifications`

    Describes the launch specification for one or more Spot Instances. If you include On-Demand
    capacity in your fleet request, you can't use ``SpotFleetLaunchSpecification`` ; you must use
    `LaunchTemplateConfig
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__ .

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify the IDs
      of the security groups. When requesting instances in EC2-Classic, you can specify the names
      or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block devices that are mapped to the Spot Instances. You can't specify both a
      snapshot ID and an encryption value. This is because only blank volumes can be encrypted on
      creation. If a snapshot is the basis for a volume, it is not blank and its encryption
      status is used for the volume encryption status.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
          from 0. An instance type with 2 available instance store volumes can specify mappings
          for ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
          depends on the instance type. After you connect to the instance, you must mount the
          volume.

          NVMe instance store volumes are automatically enumerated and assigned a device name.
          Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any instance
          store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
            volumes, this represents the number of IOPS that are provisioned for the volume. For
            ``gp2`` volumes, this represents the baseline performance of the volume and the rate
            at which the volume accumulates I/O credits for bursting. For more information, see
            `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
            ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
            `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it is
            not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume
            size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
            SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
            HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
            snapshot, the volume size must be equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
            the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being
            restored from a backing snapshot. The effect of setting the encryption state to
            ``true`` depends on the volume origin (new or from a snapshot), starting encryption
            state, ownership, and whether encryption by default is enabled. For more information,
            see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
            which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
            `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instances are optimized for EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal
      EBS I/O performance. This optimization isn't available with all instance types. Additional
      usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      Enable or disable monitoring for the instances.

      - **Enabled** *(boolean) --*

        Enables monitoring for the instance.

        Default: ``false``

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify subnet
      IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in a VPC.
          The public IP address can only be assigned to a network interface for eth0, and can
          only be assigned to a new network interface, not an existing one. You cannot specify
          more than one network interface in the request. If launching into a default subnet, the
          default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated. You can
          specify ``true`` only if creating a new network interface when launching an instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network interface
          when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary network
          interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify the
          device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if creating a
          network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the
          IPv6 addresses from the range of the subnet. You cannot specify this option and the
          option to assign specific IPv6 addresses in the same request. You can specify this
          option if you've specified a minimum number of instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot specify this
          option and the option to assign a number of IPv6 addresses in the same request. You
          cannot specify this option if you've specified a minimum number of instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a network
          interface when launching an instance. You cannot specify this option if you're
          launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one private
          IPv4 address can be designated as primary. You cannot specify this option if you're
          launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option and
          specify more than one private IP address using the private IP addresses option. You
          cannot specify this option if you're launching more than one instance in a
          `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if creating a
          network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
          ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
          Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using commas; for
        example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk. Some kernels require additional drivers at launch. Check the kernel
      requirements for information about whether you need to specify a RAM disk. To find kernel
      requirements, refer to the AWS Resource Center and search for the kernel ID.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. If this
      value is not specified, the default is the Spot price specified for the fleet. To determine
      the Spot price per unit hour, divide the Spot price by the value of ``WeightedCapacity`` .

    - **SubnetId** *(string) --*

      The IDs of the subnets in which to launch the instances. To specify multiple subnets,
      separate them using commas; for example, "subnet-1234abcdeexample1,
      subnet-0987cdef6example2".

    - **UserData** *(string) --*

      The Base64-encoded user data that instances use when starting up.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type. These are the same units that
      you chose to set the target capacity in terms of instances, or a performance characteristic
      such as vCPUs, memory, or I/O.

      If the target capacity divided by this value is not a whole number, Amazon EC2 rounds the
      number of instances to the next whole number. If this value is not specified, the default
      is 1.

    - **TagSpecifications** *(list) --*

      The tags to apply during creation.

      - *(dict) --*

        The tags for a Spot Fleet resource.

        - **ResourceType** *(string) --*

          The type of resource. Currently, the only resource type that is supported is
          ``instance`` .

        - **Tags** *(list) --*

          The tags.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **OnDemandAllocationStrategy** is set
      to ``prioritized`` , Spot Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the launch template override has
      the lowest priority.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfig` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **OnDemandAllocationStrategy** is set
          to ``prioritized`` , Spot Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the launch template override has
          the lowest priority.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfig` `ClassicLoadBalancers`

    Describes a Classic Load Balancer.

    - **Name** *(string) --*

      The name of the load balancer.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfig` `ClassicLoadBalancersConfig`

    The Classic Load Balancers.

    - **ClassicLoadBalancers** *(list) --*

      One or more Classic Load Balancers.

      - *(dict) --*

        Describes a Classic Load Balancer.

        - **Name** *(string) --*

          The name of the load balancer.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfig` `TargetGroups`

    Describes a load balancer target group.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the target group.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfig` `TargetGroupsConfig`

    The target groups.

    - **TargetGroups** *(list) --*

      One or more target groups.

      - *(dict) --*

        Describes a load balancer target group.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the target group.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    """
    Type definition for `ClientRequestSpotFleetSpotFleetRequestConfig` `LoadBalancersConfig`

    One or more Classic Load Balancers and target groups to attach to the Spot Fleet request. Spot
    Fleet registers the running Spot Instances with the specified Classic Load Balancers and target
    groups.

    With Network Load Balancers, Spot Fleet cannot register instances that have the following
    instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2, M3, and T1.

    - **ClassicLoadBalancersConfig** *(dict) --*

      The Classic Load Balancers.

      - **ClassicLoadBalancers** *(list) --*

        One or more Classic Load Balancers.

        - *(dict) --*

          Describes a Classic Load Balancer.

          - **Name** *(string) --*

            The name of the load balancer.

    - **TargetGroupsConfig** *(dict) --*

      The target groups.

      - **TargetGroups** *(list) --*

        One or more target groups.

        - *(dict) --*

          Describes a load balancer target group.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the target group.
    """


_RequiredClientRequestSpotFleetSpotFleetRequestConfigTypeDef = TypedDict(
    "_RequiredClientRequestSpotFleetSpotFleetRequestConfigTypeDef",
    {"IamFleetRole": str, "TargetCapacity": int},
)
_OptionalClientRequestSpotFleetSpotFleetRequestConfigTypeDef = TypedDict(
    "_OptionalClientRequestSpotFleetSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": str,
        "OnDemandAllocationStrategy": str,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": str,
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "LaunchSpecifications": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": str,
        "LoadBalancersConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigTypeDef(
    _RequiredClientRequestSpotFleetSpotFleetRequestConfigTypeDef,
    _OptionalClientRequestSpotFleetSpotFleetRequestConfigTypeDef,
):
    """
    Type definition for `ClientRequestSpotFleet` `SpotFleetRequestConfig`

    The configuration for the Spot Fleet request.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance pools
      specified by the Spot Fleet request.

      If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the Spot
      Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all the Spot
      Instance pools that you specify.

      If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances from Spot
      Instance pools with optimal capacity for the number of instances that are launching.

    - **OnDemandAllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If you
      specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching the lowest
      price first. If you specify ``prioritized`` , Spot Fleet uses the priority that you assign to
      each Spot Fleet launch template override, launching the highest priority first. If you do not
      specify a value, Spot Fleet defaults to ``lowestPrice`` .

    - **ClientToken** *(string) --*

      A unique, case-sensitive identifier that you provide to ensure the idempotency of your
      listings. This helps to avoid duplicate listings. For more information, see `Ensuring
      Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .

    - **ExcessCapacityTerminationPolicy** *(string) --*

      Indicates whether running Spot Instances should be terminated if you decrease the target
      capacity of the Spot Fleet request below the current size of the Spot Fleet.

    - **FulfilledCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target capacity. You cannot
      set this value.

    - **OnDemandFulfilledCapacity** *(float) --*

      The number of On-Demand units fulfilled by this request compared to the set target On-Demand
      capacity.

    - **IamFleetRole** *(string) --* **[REQUIRED]**

      The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that grants
      the Spot Fleet the permission to request, launch, terminate, and tag instances on your behalf.
      For more information, see `Spot Fleet Prerequisites
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
      in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot Instances on
      your behalf when you cancel its Spot Fleet request using  CancelSpotFleetRequests or when the
      Spot Fleet request expires, if you set ``TerminateInstancesWithExpiration`` .

    - **LaunchSpecifications** *(list) --*

      The launch specifications for the Spot Fleet request. If you specify ``LaunchSpecifications`` ,
      you can't specify ``LaunchTemplateConfigs`` . If you include On-Demand capacity in your
      request, you must use ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes the launch specification for one or more Spot Instances. If you include On-Demand
        capacity in your fleet request, you can't use ``SpotFleetLaunchSpecification`` ; you must use
        `LaunchTemplateConfig
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__ .

        - **SecurityGroups** *(list) --*

          One or more security groups. When requesting instances in a VPC, you must specify the IDs
          of the security groups. When requesting instances in EC2-Classic, you can specify the names
          or the IDs of the security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **AddressingType** *(string) --*

          Deprecated.

        - **BlockDeviceMappings** *(list) --*

          One or more block devices that are mapped to the Spot Instances. You can't specify both a
          snapshot ID and an encryption value. This is because only blank volumes can be encrypted on
          creation. If a snapshot is the basis for a volume, it is not blank and its encryption
          status is used for the volume encryption status.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **VirtualName** *(string) --*

              The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
              from 0. An instance type with 2 available instance store volumes can specify mappings
              for ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
              depends on the instance type. After you connect to the instance, you must mount the
              volume.

              NVMe instance store volumes are automatically enumerated and assigned a device name.
              Including them in your block device mapping has no effect.

              Constraints: For M3 instances, you must specify instance store volumes in the block
              device mapping for the instance. When you launch an M3 instance, we ignore any instance
              store volumes specified in the block device mapping for the AMI.

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is launched.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the EBS volume is deleted on instance termination. For more
                information, see `Preserving Amazon EBS Volumes on Instance Termination
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                in the Amazon Elastic Compute Cloud User Guide.

              - **Iops** *(integer) --*

                The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
                volumes, this represents the number of IOPS that are provisioned for the volume. For
                ``gp2`` volumes, this represents the baseline performance of the volume and the rate
                at which the volume accumulates I/O credits for bursting. For more information, see
                `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
                ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
                `Nitro-based instances
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                . Other instance families guarantee performance up to 32,000 IOPS. For more
                information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                Condition: This parameter is required for requests to create ``io1`` volumes; it is
                not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

              - **SnapshotId** *(string) --*

                The ID of the snapshot.

              - **VolumeSize** *(integer) --*

                The size of the volume, in GiB.

                Default: If you're creating the volume from a snapshot and don't specify a volume
                size, the default is the snapshot size.

                Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
                SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
                HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
                snapshot, the volume size must be equal to or larger than the snapshot size.

              - **VolumeType** *(string) --*

                The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
                the volume supports.

                Default: ``gp2``

              - **Encrypted** *(boolean) --*

                Indicates whether the encryption state of an EBS volume is changed while being
                restored from a backing snapshot. The effect of setting the encryption state to
                ``true`` depends on the volume origin (new or from a snapshot), starting encryption
                state, ownership, and whether encryption by default is enabled. For more information,
                see `Amazon EBS Encryption
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                In no case can you remove encryption from an encrypted volume.

                Encrypted volumes can only be attached to instances that support Amazon EBS
                encryption. For more information, see `Supported Instance Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                .

              - **KmsKeyId** *(string) --*

                Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
                which the EBS volume is encrypted.

                This parameter is only supported on ``BlockDeviceMapping`` objects called by
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
                `RequestSpotFleet
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                , and `RequestSpotInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                .

            - **NoDevice** *(string) --*

              Suppresses the specified device included in the block device mapping of the AMI.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instances are optimized for EBS I/O. This optimization provides
          dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal
          EBS I/O performance. This optimization isn't available with all instance types. Additional
          usage charges apply when using an EBS Optimized instance.

          Default: ``false``

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Name** *(string) --*

            The name of the instance profile.

        - **ImageId** *(string) --*

          The ID of the AMI.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The ID of the kernel.

        - **KeyName** *(string) --*

          The name of the key pair.

        - **Monitoring** *(dict) --*

          Enable or disable monitoring for the instances.

          - **Enabled** *(boolean) --*

            Enables monitoring for the instance.

            Default: ``false``

        - **NetworkInterfaces** *(list) --*

          One or more network interfaces. If you specify a network interface, you must specify subnet
          IDs and security group IDs using the network interface.

          - *(dict) --*

            Describes a network interface.

            - **AssociatePublicIpAddress** *(boolean) --*

              Indicates whether to assign a public IPv4 address to an instance you launch in a VPC.
              The public IP address can only be assigned to a network interface for eth0, and can
              only be assigned to a new network interface, not an existing one. You cannot specify
              more than one network interface in the request. If launching into a default subnet, the
              default value is ``true`` .

            - **DeleteOnTermination** *(boolean) --*

              If set to ``true`` , the interface is deleted when the instance is terminated. You can
              specify ``true`` only if creating a new network interface when launching an instance.

            - **Description** *(string) --*

              The description of the network interface. Applies only if creating a network interface
              when launching an instance.

            - **DeviceIndex** *(integer) --*

              The position of the network interface in the attachment order. A primary network
              interface has a device index of 0.

              If you specify a network interface when launching an instance, you must specify the
              device index.

            - **Groups** *(list) --*

              The IDs of the security groups for the network interface. Applies only if creating a
              network interface when launching an instance.

              - *(string) --*

            - **Ipv6AddressCount** *(integer) --*

              A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the
              IPv6 addresses from the range of the subnet. You cannot specify this option and the
              option to assign specific IPv6 addresses in the same request. You can specify this
              option if you've specified a minimum number of instances to launch.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses to assign to the network interface. You cannot specify this
              option and the option to assign a number of IPv6 addresses in the same request. You
              cannot specify this option if you've specified a minimum number of instances to launch.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface. Applies only if creating a network
              interface when launching an instance. You cannot specify this option if you're
              launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses to assign to the network interface. Only one private
              IPv4 address can be designated as primary. You cannot specify this option if you're
              launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

              - *(dict) --*

                Describes a secondary private IPv4 address for a network interface.

                - **Primary** *(boolean) --*

                  Indicates whether the private IPv4 address is the primary private IPv4 address.
                  Only one IPv4 address can be designated as primary.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 addresses.

            - **SecondaryPrivateIpAddressCount** *(integer) --*

              The number of secondary private IPv4 addresses. You can't specify this option and
              specify more than one private IP address using the private IP addresses option. You
              cannot specify this option if you're launching more than one instance in a
              `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **SubnetId** *(string) --*

              The ID of the subnet associated with the network interface. Applies only if creating a
              network interface when launching an instance.

            - **InterfaceType** *(string) --*

              The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
              ``efa`` . For more information, see `Elastic Fabric Adapter
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
              Elastic Compute Cloud User Guide* .

              If you are not creating an EFA, specify ``interface`` or omit this parameter.

              Valid values: ``interface`` | ``efa``

        - **Placement** *(dict) --*

          The placement information.

          - **AvailabilityZone** *(string) --*

            The Availability Zone.

            [Spot Fleet only] To specify multiple Availability Zones, separate them using commas; for
            example, "us-west-2a, us-west-2b".

          - **GroupName** *(string) --*

            The name of the placement group.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with a
            tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
            supported for Spot Instances.

        - **RamdiskId** *(string) --*

          The ID of the RAM disk. Some kernels require additional drivers at launch. Check the kernel
          requirements for information about whether you need to specify a RAM disk. To find kernel
          requirements, refer to the AWS Resource Center and search for the kernel ID.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance. If this
          value is not specified, the default is the Spot price specified for the fleet. To determine
          the Spot price per unit hour, divide the Spot price by the value of ``WeightedCapacity`` .

        - **SubnetId** *(string) --*

          The IDs of the subnets in which to launch the instances. To specify multiple subnets,
          separate them using commas; for example, "subnet-1234abcdeexample1,
          subnet-0987cdef6example2".

        - **UserData** *(string) --*

          The Base64-encoded user data that instances use when starting up.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type. These are the same units that
          you chose to set the target capacity in terms of instances, or a performance characteristic
          such as vCPUs, memory, or I/O.

          If the target capacity divided by this value is not a whole number, Amazon EC2 rounds the
          number of instances to the next whole number. If this value is not specified, the default
          is 1.

        - **TagSpecifications** *(list) --*

          The tags to apply during creation.

          - *(dict) --*

            The tags for a Spot Fleet resource.

            - **ResourceType** *(string) --*

              The type of resource. Currently, the only resource type that is supported is
              ``instance`` .

            - **Tags** *(list) --*

              The tags.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                  characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                  characters.

    - **LaunchTemplateConfigs** *(list) --*

      The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't specify
      ``LaunchSpecifications`` . If you include On-Demand capacity in your request, you must use
      ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes a launch template and overrides.

        - **LaunchTemplateSpecification** *(dict) --*

          The launch template.

          - **LaunchTemplateId** *(string) --*

            The ID of the launch template. You must specify either a template ID or a template name.

          - **LaunchTemplateName** *(string) --*

            The name of the launch template. You must specify either a template name or a template ID.

          - **Version** *(string) --*

            The version number of the launch template. You must specify a version number.

        - **Overrides** *(list) --*

          Any parameters that you specify override the same parameters in the launch template.

          - *(dict) --*

            Describes overrides for a launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **SpotPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **OnDemandAllocationStrategy** is set
              to ``prioritized`` , Spot Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the launch template override has
              the lowest priority.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. The default is
      the On-Demand price.

    - **TargetCapacity** *(integer) --* **[REQUIRED]**

      The number of units to request for the Spot Fleet. You can choose to set the target capacity in
      terms of instances or a performance characteristic that is important to your application
      workload, such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify
      a target capacity of 0 and add capacity later.

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request. You can choose to set the target capacity in terms of
      instances or a performance characteristic that is important to your application workload, such
      as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a target
      capacity of 0 and add capacity later.

    - **OnDemandMaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay. You can use the
      ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or both parameters to
      ensure that your fleet cost does not exceed your budget. If you set a maximum price per hour
      for the On-Demand Instances and Spot Instances in your request, Spot Fleet will launch
      instances until it reaches the maximum amount you're willing to pay. When the maximum amount
      you're willing to pay is reached, the fleet stops launching instances even if it hasn’t met the
      target capacity.

    - **SpotMaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay. You can use the
      ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both parameters
      to ensure that your fleet cost does not exceed your budget. If you set a maximum price per hour
      for the On-Demand Instances and Spot Instances in your request, Spot Fleet will launch
      instances until it reaches the maximum amount you're willing to pay. When the maximum amount
      you're willing to pay is reached, the fleet stops launching instances even if it hasn’t met the
      target capacity.

    - **TerminateInstancesWithExpiration** *(boolean) --*

      Indicates whether running Spot Instances are terminated when the Spot Fleet request expires.

    - **Type** *(string) --*

      The type of request. Indicates whether the Spot Fleet only requests the target capacity or also
      attempts to maintain it. When this value is ``request`` , the Spot Fleet only places the
      required requests. It does not attempt to replenish Spot Instances if capacity is diminished,
      nor does it submit requests in alternative Spot pools if capacity is not available. When this
      value is ``maintain`` , the Spot Fleet maintains the target capacity. The Spot Fleet places the
      required requests to meet capacity and automatically replenishes any interrupted instances.
      Default: ``maintain`` . ``instant`` is listed but is not used by Spot Fleet.

    - **ValidFrom** *(datetime) --*

      The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).
      By default, Amazon EC2 starts fulfilling the request immediately.

    - **ValidUntil** *(datetime) --*

      The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).
      After the end date and time, no new Spot Instance requests are placed or able to fulfill the
      request. If no value is specified, the Spot Fleet request remains until you cancel it.

    - **ReplaceUnhealthyInstances** *(boolean) --*

      Indicates whether Spot Fleet should replace unhealthy instances.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **LoadBalancersConfig** *(dict) --*

      One or more Classic Load Balancers and target groups to attach to the Spot Fleet request. Spot
      Fleet registers the running Spot Instances with the specified Classic Load Balancers and target
      groups.

      With Network Load Balancers, Spot Fleet cannot register instances that have the following
      instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2, M3, and T1.

      - **ClassicLoadBalancersConfig** *(dict) --*

        The Classic Load Balancers.

        - **ClassicLoadBalancers** *(list) --*

          One or more Classic Load Balancers.

          - *(dict) --*

            Describes a Classic Load Balancer.

            - **Name** *(string) --*

              The name of the load balancer.

      - **TargetGroupsConfig** *(dict) --*

        The target groups.

        - **TargetGroups** *(list) --*

          One or more target groups.

          - *(dict) --*

            Describes a load balancer target group.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the target group.

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only when
      Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the cheapest Spot
      pools and evenly allocates your target Spot capacity across the number of Spot pools that you
      specify.
    """


_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
      `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot,
      the volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends
      on the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS
      Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
      For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
      which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
      and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecification` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
      from 0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends
      on the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
        ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
        `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot,
        the volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends
        on the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS
        Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
        For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
        which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
        and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecification` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef", {"Enabled": bool}
)


class ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecification` `Monitoring`

    Indicates whether basic or detailed monitoring is enabled for the instance.

    Default: Disabled

    - **Enabled** *(boolean) --* **[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecificationNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecificationNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only
      one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecification` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
      public IP address can only be assigned to a network interface for eth0, and can only be
      assigned to a new network interface, not an existing one. You cannot specify more than one
      network interface in the request. If launching into a default subnet, the default value is
      ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You can
      specify ``true`` only if creating a new network interface when launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network interface when
      launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network interface
      has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the device
      index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating a
      network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the IPv6
      addresses from the range of the subnet. You cannot specify this option and the option to
      assign specific IPv6 addresses in the same request. You can specify this option if you've
      specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify this
      option and the option to assign a number of IPv6 addresses in the same request. You cannot
      specify this option if you've specified a minimum number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a network
      interface when launching an instance. You cannot specify this option if you're launching
      more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one private
      IPv4 address can be designated as primary. You cannot specify this option if you're
      launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only
          one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and specify
      more than one private IP address using the private IP addresses option. You cannot specify
      this option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if creating a
      network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesLaunchSpecification` `Placement`

    The placement information for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using commas; for
      example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for
      Spot Instances.
    """


_ClientRequestSpotInstancesLaunchSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationTypeDef",
    {
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationTypeDef
):
    """
    Type definition for `ClientRequestSpotInstances` `LaunchSpecification`

    The launch specification.

    - **SecurityGroupIds** *(list) --*

      One or more security group IDs.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify the IDs of
      the security groups. When requesting instances in EC2-Classic, you can specify the names or the
      IDs of the security groups.

      - *(string) --*

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block device mapping entries. You can't specify both a snapshot ID and an
      encryption value. This is because only blank volumes can be encrypted on creation. If a
      snapshot is the basis for a volume, it is not blank and its encryption status is used for the
      volume encryption status.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
          from 0. An instance type with 2 available instance store volumes can specify mappings for
          ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends
          on the instance type. After you connect to the instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device name.
          Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block device
          mapping for the instance. When you launch an M3 instance, we ignore any instance store
          volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
            volumes, this represents the number of IOPS that are provisioned for the volume. For
            ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
            which the volume accumulates I/O credits for bursting. For more information, see `Amazon
            EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
            ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
            `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more information,
            see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it is not
            used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
            (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
            (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot,
            the volume size must be equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
            volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being restored
            from a backing snapshot. The effect of setting the encryption state to ``true`` depends
            on the volume origin (new or from a snapshot), starting encryption state, ownership, and
            whether encryption by default is enabled. For more information, see `Amazon EBS
            Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
            For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
            which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
            `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
            and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for EBS I/O. This optimization provides dedicated
      throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS I/O
      performance. This optimization isn't available with all instance types. Additional usage
      charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      Indicates whether basic or detailed monitoring is enabled for the instance.

      Default: Disabled

      - **Enabled** *(boolean) --* **[REQUIRED]**

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify subnet IDs
      and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
          public IP address can only be assigned to a network interface for eth0, and can only be
          assigned to a new network interface, not an existing one. You cannot specify more than one
          network interface in the request. If launching into a default subnet, the default value is
          ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated. You can
          specify ``true`` only if creating a new network interface when launching an instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network interface when
          launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary network interface
          has a device index of 0.

          If you specify a network interface when launching an instance, you must specify the device
          index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if creating a
          network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the IPv6
          addresses from the range of the subnet. You cannot specify this option and the option to
          assign specific IPv6 addresses in the same request. You can specify this option if you've
          specified a minimum number of instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot specify this
          option and the option to assign a number of IPv6 addresses in the same request. You cannot
          specify this option if you've specified a minimum number of instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a network
          interface when launching an instance. You cannot specify this option if you're launching
          more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one private
          IPv4 address can be designated as primary. You cannot specify this option if you're
          launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address. Only
              one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option and specify
          more than one private IP address using the private IP addresses option. You cannot specify
          this option if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if creating a
          network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
          For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
          Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using commas; for
        example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
        of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for
        Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk.

    - **SubnetId** *(string) --*

      The IDs of the subnets in which to launch the instance. To specify multiple subnets, separate
      them using commas; for example, "subnet-1234abcdeexample1, subnet-0987cdef6example2".

    - **UserData** *(string) --*

      The Base64-encoded user data for the instance. User data is limited to 16 KB.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequests` `Fault`

    The fault codes for the Spot Instance request, if any.

    - **Code** *(string) --*

      The reason code for the Spot Instance state change.

    - **Message** *(string) --*

      The message for the Spot Instance state change.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for the
      volume. For ``gp2`` volumes, this represents the baseline performance of the
      volume and the rate at which the volume accumulates I/O credits for bursting. For
      more information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
      for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
      only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it
      is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
      volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume
      size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
      IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
      for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
      specify a snapshot, the volume size must be equal to or larger than the snapshot
      size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS
      that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being
      restored from a backing snapshot. The effect of setting the encryption state to
      ``true`` depends on the volume origin (new or from a snapshot), starting
      encryption state, ownership, and whether encryption by default is enabled. For
      more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
      under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      , `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can
      specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
      instance store volumes depends on the instance type. After you connect to the
      instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device
      name. Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any
      instance store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for the
        volume. For ``gp2`` volumes, this represents the baseline performance of the
        volume and the rate at which the volume accumulates I/O credits for bursting. For
        more information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
        for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
        only on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it
        is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
        volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume
        size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
        IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
        for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
        specify a snapshot, the volume size must be equal to or larger than the snapshot
        size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS
        that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being
        restored from a backing snapshot. The effect of setting the encryption state to
        ``true`` depends on the volume origin (new or from a snapshot), starting
        encryption state, ownership, and whether encryption by default is enabled. For
        more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
        under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
        , `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `Monitoring`

    Describes the monitoring of an instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a
      VPC. The public IP address can only be assigned to a network interface for eth0,
      and can only be assigned to a new network interface, not an existing one. You
      cannot specify more than one network interface in the request. If launching into a
      default subnet, the default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You
      can specify ``true`` only if creating a new network interface when launching an
      instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network
      interface when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network
      interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the
      device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating
      a network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
      the IPv6 addresses from the range of the subnet. You cannot specify this option and
      the option to assign specific IPv6 addresses in the same request. You can specify
      this option if you've specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify
      this option and the option to assign a number of IPv6 addresses in the same
      request. You cannot specify this option if you've specified a minimum number of
      instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a
      network interface when launching an instance. You cannot specify this option if
      you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one
      private IPv4 address can be designated as primary. You cannot specify this option
      if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and
      specify more than one private IP address using the private IP addresses option. You
      cannot specify this option if you're launching more than one instance in a
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if
      creating a network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
      ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `Placement`

    The placement information for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
      for example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for Spot Instances.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecification` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequests` `LaunchSpecification`

    Additional information for launching instances.

    - **UserData** *(string) --*

      The Base64-encoded user data for the instance.

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify the
      IDs of the security groups. When requesting instances in EC2-Classic, you can specify
      the names or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can
          specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
          instance store volumes depends on the instance type. After you connect to the
          instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device
          name. Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any
          instance store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for the
            volume. For ``gp2`` volumes, this represents the baseline performance of the
            volume and the rate at which the volume accumulates I/O credits for bursting. For
            more information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
            for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
            only on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it
            is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
            volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume
            size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
            IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
            for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
            specify a snapshot, the volume size must be equal to or larger than the snapshot
            size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS
            that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being
            restored from a backing snapshot. The effect of setting the encryption state to
            ``true`` depends on the volume origin (new or from a snapshot), starting
            encryption state, ownership, and whether encryption by default is enabled. For
            more information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
            under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            , `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide
      optimal EBS I/O performance. This optimization isn't available with all instance types.
      Additional usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify
      subnet IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in a
          VPC. The public IP address can only be assigned to a network interface for eth0,
          and can only be assigned to a new network interface, not an existing one. You
          cannot specify more than one network interface in the request. If launching into a
          default subnet, the default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated. You
          can specify ``true`` only if creating a new network interface when launching an
          instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network
          interface when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary network
          interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify the
          device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if creating
          a network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
          the IPv6 addresses from the range of the subnet. You cannot specify this option and
          the option to assign specific IPv6 addresses in the same request. You can specify
          this option if you've specified a minimum number of instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot specify
          this option and the option to assign a number of IPv6 addresses in the same
          request. You cannot specify this option if you've specified a minimum number of
          instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a
          network interface when launching an instance. You cannot specify this option if
          you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one
          private IPv4 address can be designated as primary. You cannot specify this option
          if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option and
          specify more than one private IP address using the private IP addresses option. You
          cannot specify this option if you're launching more than one instance in a
          `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if
          creating a network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
          ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
          Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
        for example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instance.

    - **Monitoring** *(dict) --*

      Describes the monitoring of an instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequests` `Status`

    The status code and status message describing the Spot Instance request.

    - **Code** *(string) --*

      The status code. For a list of status codes, see `Spot Status Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
      in the *Amazon EC2 User Guide for Linux Instances* .

    - **Message** *(string) --*

      The description for the status code.

    - **UpdateTime** *(datetime) --*

      The date and time of the most recent status update, in UTC format (for example, *YYYY*
      -*MM* -*DD* T*HH* :*MM* :*SS* Z).
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponseSpotInstanceRequests` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": str,
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": str,
        "Status": ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef],
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef
):
    """
    Type definition for `ClientRequestSpotInstancesResponse` `SpotInstanceRequests`

    Describes a Spot Instance request.

    - **ActualBlockHourlyPrice** *(string) --*

      If you specified a duration and your Spot Instance request was fulfilled, this is the
      fixed hourly price in effect for the Spot Instance while it runs.

    - **AvailabilityZoneGroup** *(string) --*

      The Availability Zone group. If you specify the same Availability Zone group for all Spot
      Instance requests, all Spot Instances are launched in the same Availability Zone.

    - **BlockDurationMinutes** *(integer) --*

      The duration for the Spot Instance, in minutes.

    - **CreateTime** *(datetime) --*

      The date and time when the Spot Instance request was created, in UTC format (for example,
      *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Fault** *(dict) --*

      The fault codes for the Spot Instance request, if any.

      - **Code** *(string) --*

        The reason code for the Spot Instance state change.

      - **Message** *(string) --*

        The message for the Spot Instance state change.

    - **InstanceId** *(string) --*

      The instance ID, if an instance has been launched to fulfill the Spot Instance request.

    - **LaunchGroup** *(string) --*

      The instance launch group. Launch groups are Spot Instances that launch together and
      terminate together.

    - **LaunchSpecification** *(dict) --*

      Additional information for launching instances.

      - **UserData** *(string) --*

        The Base64-encoded user data for the instance.

      - **SecurityGroups** *(list) --*

        One or more security groups. When requesting instances in a VPC, you must specify the
        IDs of the security groups. When requesting instances in EC2-Classic, you can specify
        the names or the IDs of the security groups.

        - *(dict) --*

          Describes a security group.

          - **GroupName** *(string) --*

            The name of the security group.

          - **GroupId** *(string) --*

            The ID of the security group.

      - **AddressingType** *(string) --*

        Deprecated.

      - **BlockDeviceMappings** *(list) --*

        One or more block device mapping entries.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

          - **VirtualName** *(string) --*

            The virtual device name (``ephemeral`` N). Instance store volumes are numbered
            starting from 0. An instance type with 2 available instance store volumes can
            specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
            instance store volumes depends on the instance type. After you connect to the
            instance, you must mount the volume.

            NVMe instance store volumes are automatically enumerated and assigned a device
            name. Including them in your block device mapping has no effect.

            Constraints: For M3 instances, you must specify instance store volumes in the block
            device mapping for the instance. When you launch an M3 instance, we ignore any
            instance store volumes specified in the block device mapping for the AMI.

          - **Ebs** *(dict) --*

            Parameters used to automatically set up EBS volumes when the instance is launched.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination. For more
              information, see `Preserving Amazon EBS Volumes on Instance Termination
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
              in the Amazon Elastic Compute Cloud User Guide.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports. For
              ``io1`` volumes, this represents the number of IOPS that are provisioned for the
              volume. For ``gp2`` volumes, this represents the baseline performance of the
              volume and the rate at which the volume accumulates I/O credits for bursting. For
              more information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
              for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
              only on `Nitro-based instances
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
              . Other instance families guarantee performance up to 32,000 IOPS. For more
              information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Condition: This parameter is required for requests to create ``io1`` volumes; it
              is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
              volumes.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

              Default: If you're creating the volume from a snapshot and don't specify a volume
              size, the default is the snapshot size.

              Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
              IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
              for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
              specify a snapshot, the volume size must be equal to or larger than the snapshot
              size.

            - **VolumeType** *(string) --*

              The volume type. If you set the type to ``io1`` , you must also specify the IOPS
              that the volume supports.

              Default: ``gp2``

            - **Encrypted** *(boolean) --*

              Indicates whether the encryption state of an EBS volume is changed while being
              restored from a backing snapshot. The effect of setting the encryption state to
              ``true`` depends on the volume origin (new or from a snapshot), starting
              encryption state, ownership, and whether encryption by default is enabled. For
              more information, see `Amazon EBS Encryption
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
              in the *Amazon Elastic Compute Cloud User Guide* .

              In no case can you remove encryption from an encrypted volume.

              Encrypted volumes can only be attached to instances that support Amazon EBS
              encryption. For more information, see `Supported Instance Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
              .

            - **KmsKeyId** *(string) --*

              Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
              under which the EBS volume is encrypted.

              This parameter is only supported on ``BlockDeviceMapping`` objects called by
              `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              , `RequestSpotFleet
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
              , and `RequestSpotInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
              .

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for EBS I/O. This optimization provides
        dedicated throughput to Amazon EBS and an optimized configuration stack to provide
        optimal EBS I/O performance. This optimization isn't available with all instance types.
        Additional usage charges apply when using an EBS Optimized instance.

        Default: ``false``

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **ImageId** *(string) --*

        The ID of the AMI.

      - **InstanceType** *(string) --*

        The instance type.

      - **KernelId** *(string) --*

        The ID of the kernel.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **NetworkInterfaces** *(list) --*

        One or more network interfaces. If you specify a network interface, you must specify
        subnet IDs and security group IDs using the network interface.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to assign a public IPv4 address to an instance you launch in a
            VPC. The public IP address can only be assigned to a network interface for eth0,
            and can only be assigned to a new network interface, not an existing one. You
            cannot specify more than one network interface in the request. If launching into a
            default subnet, the default value is ``true`` .

          - **DeleteOnTermination** *(boolean) --*

            If set to ``true`` , the interface is deleted when the instance is terminated. You
            can specify ``true`` only if creating a new network interface when launching an
            instance.

          - **Description** *(string) --*

            The description of the network interface. Applies only if creating a network
            interface when launching an instance.

          - **DeviceIndex** *(integer) --*

            The position of the network interface in the attachment order. A primary network
            interface has a device index of 0.

            If you specify a network interface when launching an instance, you must specify the
            device index.

          - **Groups** *(list) --*

            The IDs of the security groups for the network interface. Applies only if creating
            a network interface when launching an instance.

            - *(string) --*

          - **Ipv6AddressCount** *(integer) --*

            A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
            the IPv6 addresses from the range of the subnet. You cannot specify this option and
            the option to assign specific IPv6 addresses in the same request. You can specify
            this option if you've specified a minimum number of instances to launch.

          - **Ipv6Addresses** *(list) --*

            One or more IPv6 addresses to assign to the network interface. You cannot specify
            this option and the option to assign a number of IPv6 addresses in the same
            request. You cannot specify this option if you've specified a minimum number of
            instances to launch.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The private IPv4 address of the network interface. Applies only if creating a
            network interface when launching an instance. You cannot specify this option if
            you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses to assign to the network interface. Only one
            private IPv4 address can be designated as primary. You cannot specify this option
            if you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses. You can't specify this option and
            specify more than one private IP address using the private IP addresses option. You
            cannot specify this option if you're launching more than one instance in a
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **SubnetId** *(string) --*

            The ID of the subnet associated with the network interface. Applies only if
            creating a network interface when launching an instance.

          - **InterfaceType** *(string) --*

            The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
            ``efa`` . For more information, see `Elastic Fabric Adapter
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
            Elastic Compute Cloud User Guide* .

            If you are not creating an EFA, specify ``interface`` or omit this parameter.

            Valid values: ``interface`` | ``efa``

      - **Placement** *(dict) --*

        The placement information for the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

          [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
          for example, "us-west-2a, us-west-2b".

        - **GroupName** *(string) --*

          The name of the placement group.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
          supported for Spot Instances.

      - **RamdiskId** *(string) --*

        The ID of the RAM disk.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instance.

      - **Monitoring** *(dict) --*

        Describes the monitoring of an instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

    - **LaunchedAvailabilityZone** *(string) --*

      The Availability Zone in which the request is launched.

    - **ProductDescription** *(string) --*

      The product description associated with the Spot Instance.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **SpotPrice** *(string) --*

      The maximum price per hour that you are willing to pay for a Spot Instance.

    - **State** *(string) --*

      The state of the Spot Instance request. Spot status information helps track your Spot
      Instance requests. For more information, see `Spot Status
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
      *Amazon EC2 User Guide for Linux Instances* .

    - **Status** *(dict) --*

      The status code and status message describing the Spot Instance request.

      - **Code** *(string) --*

        The status code. For a list of status codes, see `Spot Status Codes
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
        in the *Amazon EC2 User Guide for Linux Instances* .

      - **Message** *(string) --*

        The description for the status code.

      - **UpdateTime** *(datetime) --*

        The date and time of the most recent status update, in UTC format (for example, *YYYY*
        -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Type** *(string) --*

      The Spot Instance request type.

    - **ValidFrom** *(datetime) --*

      The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). The request becomes active at this date and time.

    - **ValidUntil** *(datetime) --*

      The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). If this is a one-time request, it remains active until all instances launch,
      the request is canceled, or this date is reached. If the request is persistent, it
      remains active until it is canceled or this date is reached. The default end date is 7
      days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_ClientRequestSpotInstancesResponseTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseTypeDef",
    {
        "SpotInstanceRequests": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef
        ]
    },
    total=False,
)


class ClientRequestSpotInstancesResponseTypeDef(
    _ClientRequestSpotInstancesResponseTypeDef
):
    """
    Type definition for `ClientRequestSpotInstances` `Response`

    Contains the output of RequestSpotInstances.

    - **SpotInstanceRequests** *(list) --*

      One or more Spot Instance requests.

      - *(dict) --*

        Describes a Spot Instance request.

        - **ActualBlockHourlyPrice** *(string) --*

          If you specified a duration and your Spot Instance request was fulfilled, this is the
          fixed hourly price in effect for the Spot Instance while it runs.

        - **AvailabilityZoneGroup** *(string) --*

          The Availability Zone group. If you specify the same Availability Zone group for all Spot
          Instance requests, all Spot Instances are launched in the same Availability Zone.

        - **BlockDurationMinutes** *(integer) --*

          The duration for the Spot Instance, in minutes.

        - **CreateTime** *(datetime) --*

          The date and time when the Spot Instance request was created, in UTC format (for example,
          *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Fault** *(dict) --*

          The fault codes for the Spot Instance request, if any.

          - **Code** *(string) --*

            The reason code for the Spot Instance state change.

          - **Message** *(string) --*

            The message for the Spot Instance state change.

        - **InstanceId** *(string) --*

          The instance ID, if an instance has been launched to fulfill the Spot Instance request.

        - **LaunchGroup** *(string) --*

          The instance launch group. Launch groups are Spot Instances that launch together and
          terminate together.

        - **LaunchSpecification** *(dict) --*

          Additional information for launching instances.

          - **UserData** *(string) --*

            The Base64-encoded user data for the instance.

          - **SecurityGroups** *(list) --*

            One or more security groups. When requesting instances in a VPC, you must specify the
            IDs of the security groups. When requesting instances in EC2-Classic, you can specify
            the names or the IDs of the security groups.

            - *(dict) --*

              Describes a security group.

              - **GroupName** *(string) --*

                The name of the security group.

              - **GroupId** *(string) --*

                The ID of the security group.

          - **AddressingType** *(string) --*

            Deprecated.

          - **BlockDeviceMappings** *(list) --*

            One or more block device mapping entries.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

              - **VirtualName** *(string) --*

                The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                starting from 0. An instance type with 2 available instance store volumes can
                specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
                instance store volumes depends on the instance type. After you connect to the
                instance, you must mount the volume.

                NVMe instance store volumes are automatically enumerated and assigned a device
                name. Including them in your block device mapping has no effect.

                Constraints: For M3 instances, you must specify instance store volumes in the block
                device mapping for the instance. When you launch an M3 instance, we ignore any
                instance store volumes specified in the block device mapping for the AMI.

              - **Ebs** *(dict) --*

                Parameters used to automatically set up EBS volumes when the instance is launched.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination. For more
                  information, see `Preserving Amazon EBS Volumes on Instance Termination
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                  in the Amazon Elastic Compute Cloud User Guide.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports. For
                  ``io1`` volumes, this represents the number of IOPS that are provisioned for the
                  volume. For ``gp2`` volumes, this represents the baseline performance of the
                  volume and the rate at which the volume accumulates I/O credits for bursting. For
                  more information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
                  for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
                  only on `Nitro-based instances
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                  . Other instance families guarantee performance up to 32,000 IOPS. For more
                  information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Condition: This parameter is required for requests to create ``io1`` volumes; it
                  is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
                  volumes.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                  Default: If you're creating the volume from a snapshot and don't specify a volume
                  size, the default is the snapshot size.

                  Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
                  IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
                  for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
                  specify a snapshot, the volume size must be equal to or larger than the snapshot
                  size.

                - **VolumeType** *(string) --*

                  The volume type. If you set the type to ``io1`` , you must also specify the IOPS
                  that the volume supports.

                  Default: ``gp2``

                - **Encrypted** *(boolean) --*

                  Indicates whether the encryption state of an EBS volume is changed while being
                  restored from a backing snapshot. The effect of setting the encryption state to
                  ``true`` depends on the volume origin (new or from a snapshot), starting
                  encryption state, ownership, and whether encryption by default is enabled. For
                  more information, see `Amazon EBS Encryption
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  In no case can you remove encryption from an encrypted volume.

                  Encrypted volumes can only be attached to instances that support Amazon EBS
                  encryption. For more information, see `Supported Instance Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                  .

                - **KmsKeyId** *(string) --*

                  Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
                  under which the EBS volume is encrypted.

                  This parameter is only supported on ``BlockDeviceMapping`` objects called by
                  `RunInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                  , `RequestSpotFleet
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                  , and `RequestSpotInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                  .

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instance is optimized for EBS I/O. This optimization provides
            dedicated throughput to Amazon EBS and an optimized configuration stack to provide
            optimal EBS I/O performance. This optimization isn't available with all instance types.
            Additional usage charges apply when using an EBS Optimized instance.

            Default: ``false``

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **ImageId** *(string) --*

            The ID of the AMI.

          - **InstanceType** *(string) --*

            The instance type.

          - **KernelId** *(string) --*

            The ID of the kernel.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **NetworkInterfaces** *(list) --*

            One or more network interfaces. If you specify a network interface, you must specify
            subnet IDs and security group IDs using the network interface.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to assign a public IPv4 address to an instance you launch in a
                VPC. The public IP address can only be assigned to a network interface for eth0,
                and can only be assigned to a new network interface, not an existing one. You
                cannot specify more than one network interface in the request. If launching into a
                default subnet, the default value is ``true`` .

              - **DeleteOnTermination** *(boolean) --*

                If set to ``true`` , the interface is deleted when the instance is terminated. You
                can specify ``true`` only if creating a new network interface when launching an
                instance.

              - **Description** *(string) --*

                The description of the network interface. Applies only if creating a network
                interface when launching an instance.

              - **DeviceIndex** *(integer) --*

                The position of the network interface in the attachment order. A primary network
                interface has a device index of 0.

                If you specify a network interface when launching an instance, you must specify the
                device index.

              - **Groups** *(list) --*

                The IDs of the security groups for the network interface. Applies only if creating
                a network interface when launching an instance.

                - *(string) --*

              - **Ipv6AddressCount** *(integer) --*

                A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
                the IPv6 addresses from the range of the subnet. You cannot specify this option and
                the option to assign specific IPv6 addresses in the same request. You can specify
                this option if you've specified a minimum number of instances to launch.

              - **Ipv6Addresses** *(list) --*

                One or more IPv6 addresses to assign to the network interface. You cannot specify
                this option and the option to assign a number of IPv6 addresses in the same
                request. You cannot specify this option if you've specified a minimum number of
                instances to launch.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 address of the network interface. Applies only if creating a
                network interface when launching an instance. You cannot specify this option if
                you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses to assign to the network interface. Only one
                private IPv4 address can be designated as primary. You cannot specify this option
                if you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4 address.
                    Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses. You can't specify this option and
                specify more than one private IP address using the private IP addresses option. You
                cannot specify this option if you're launching more than one instance in a
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **SubnetId** *(string) --*

                The ID of the subnet associated with the network interface. Applies only if
                creating a network interface when launching an instance.

              - **InterfaceType** *(string) --*

                The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
                ``efa`` . For more information, see `Elastic Fabric Adapter
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
                Elastic Compute Cloud User Guide* .

                If you are not creating an EFA, specify ``interface`` or omit this parameter.

                Valid values: ``interface`` | ``efa``

          - **Placement** *(dict) --*

            The placement information for the instance.

            - **AvailabilityZone** *(string) --*

              The Availability Zone.

              [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
              for example, "us-west-2a, us-west-2b".

            - **GroupName** *(string) --*

              The name of the placement group.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance with a
              tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
              supported for Spot Instances.

          - **RamdiskId** *(string) --*

            The ID of the RAM disk.

          - **SubnetId** *(string) --*

            The ID of the subnet in which to launch the instance.

          - **Monitoring** *(dict) --*

            Describes the monitoring of an instance.

            - **Enabled** *(boolean) --*

              Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
              enabled.

        - **LaunchedAvailabilityZone** *(string) --*

          The Availability Zone in which the request is launched.

        - **ProductDescription** *(string) --*

          The product description associated with the Spot Instance.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **SpotPrice** *(string) --*

          The maximum price per hour that you are willing to pay for a Spot Instance.

        - **State** *(string) --*

          The state of the Spot Instance request. Spot status information helps track your Spot
          Instance requests. For more information, see `Spot Status
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
          *Amazon EC2 User Guide for Linux Instances* .

        - **Status** *(dict) --*

          The status code and status message describing the Spot Instance request.

          - **Code** *(string) --*

            The status code. For a list of status codes, see `Spot Status Codes
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
            in the *Amazon EC2 User Guide for Linux Instances* .

          - **Message** *(string) --*

            The description for the status code.

          - **UpdateTime** *(datetime) --*

            The date and time of the most recent status update, in UTC format (for example, *YYYY*
            -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Type** *(string) --*

          The Spot Instance request type.

        - **ValidFrom** *(datetime) --*

          The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). The request becomes active at this date and time.

        - **ValidUntil** *(datetime) --*

          The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). If this is a one-time request, it remains active until all instances launch,
          the request is canceled, or this date is reached. If the request is persistent, it
          remains active until it is canceled or this date is reached. The default end date is 7
          days from the current date.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.
    """


_ClientResetEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientResetEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientResetEbsDefaultKmsKeyIdResponseTypeDef(
    _ClientResetEbsDefaultKmsKeyIdResponseTypeDef
):
    """
    Type definition for `ClientResetEbsDefaultKmsKeyId` `Response`

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the default CMK for EBS encryption by default.
    """


_ClientResetFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientResetFpgaImageAttributeResponseTypeDef", {"Return": bool}, total=False
)


class ClientResetFpgaImageAttributeResponseTypeDef(
    _ClientResetFpgaImageAttributeResponseTypeDef
):
    """
    Type definition for `ClientResetFpgaImageAttribute` `Response`

    - **Return** *(boolean) --*

      Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientRestoreAddressToClassicResponseTypeDef = TypedDict(
    "_ClientRestoreAddressToClassicResponseTypeDef",
    {"PublicIp": str, "Status": str},
    total=False,
)


class ClientRestoreAddressToClassicResponseTypeDef(
    _ClientRestoreAddressToClassicResponseTypeDef
):
    """
    Type definition for `ClientRestoreAddressToClassic` `Response`

    - **PublicIp** *(string) --*

      The Elastic IP address.

    - **Status** *(string) --*

      The move status for the IP address.
    """


_ClientRevokeClientVpnIngressResponseStatusTypeDef = TypedDict(
    "_ClientRevokeClientVpnIngressResponseStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRevokeClientVpnIngressResponseStatusTypeDef(
    _ClientRevokeClientVpnIngressResponseStatusTypeDef
):
    """
    Type definition for `ClientRevokeClientVpnIngressResponse` `Status`

    The current state of the authorization rule.

    - **Code** *(string) --*

      The state of the authorization rule.

    - **Message** *(string) --*

      A message about the status of the authorization rule, if applicable.
    """


_ClientRevokeClientVpnIngressResponseTypeDef = TypedDict(
    "_ClientRevokeClientVpnIngressResponseTypeDef",
    {"Status": ClientRevokeClientVpnIngressResponseStatusTypeDef},
    total=False,
)


class ClientRevokeClientVpnIngressResponseTypeDef(
    _ClientRevokeClientVpnIngressResponseTypeDef
):
    """
    Type definition for `ClientRevokeClientVpnIngress` `Response`

    - **Status** *(dict) --*

      The current state of the authorization rule.

      - **Code** *(string) --*

        The state of the authorization rule.

      - **Message** *(string) --*

        A message about the status of the authorization rule, if applicable.
    """


_ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupEgressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupEgressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupEgressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupEgressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientRevokeSecurityGroupEgressIpPermissionsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[
            ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupEgress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupIngressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupIngressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupIngressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupIngressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientRevokeSecurityGroupIngressIpPermissionsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[
            ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsTypeDef
):
    """
    Type definition for `ClientRevokeSecurityGroupIngress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientRunInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRunInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientRunInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRunInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_ClientRunInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRunInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRunInstancesBlockDeviceMappingsTypeDef(
    _ClientRunInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRunInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientRunInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientRunInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientRunInstancesCapacityReservationSpecificationTypeDef(
    _ClientRunInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientRunInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables it
    to run in any open Capacity Reservation that has matching attributes (instance type, platform,
    Availability Zone).

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientRunInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientRunInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientRunInstancesCpuOptionsTypeDef(_ClientRunInstancesCpuOptionsTypeDef):
    """
    Type definition for `ClientRunInstances` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core. To disable multithreading for the instance, specify a value
      of ``1`` . Otherwise, specify the default value of ``2`` .
    """


_ClientRunInstancesCreditSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class ClientRunInstancesCreditSpecificationTypeDef(
    _ClientRunInstancesCreditSpecificationTypeDef
):
    """
    Type definition for `ClientRunInstances` `CreditSpecification`

    The credit option for CPU usage of the T2 or T3 instance. Valid values are ``standard`` and
    ``unlimited`` . To change this attribute after launch, use `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    Default: ``standard`` (T2 instances) or ``unlimited`` (T3 instances)

    - **CpuCredits** *(string) --* **[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientRunInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class ClientRunInstancesElasticGpuSpecificationTypeDef(
    _ClientRunInstancesElasticGpuSpecificationTypeDef
):
    """
    Type definition for `ClientRunInstances` `ElasticGpuSpecification`

    A specification for an Elastic Graphics accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of Elastic Graphics accelerator.
    """


_ClientRunInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientRunInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class ClientRunInstancesElasticInferenceAcceleratorsTypeDef(
    _ClientRunInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ClientRunInstances` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
      ``eia1.medium`` , and ``eia1.large`` .
    """


_ClientRunInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientRunInstancesHibernationOptionsTypeDef", {"Configured": bool}, total=False
)


class ClientRunInstancesHibernationOptionsTypeDef(
    _ClientRunInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `ClientRunInstances` `HibernationOptions`

    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.

      Default: ``false``
    """


_ClientRunInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRunInstancesIamInstanceProfileTypeDef(
    _ClientRunInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRunInstances` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ClientRunInstancesInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances. The default is the
      On-Demand price.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
      only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
      ``stop`` .

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
      value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until all
      instances launch, the request is canceled, or this date is reached. If the request is
      persistent, it remains active until it is canceled or this date and time is reached. The
      default end date is 7 days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientRunInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientRunInstancesInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientRunInstancesInstanceMarketOptionsTypeDef(
    _ClientRunInstancesInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ClientRunInstances` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances. The default is the
        On-Demand price.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
        only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
        ``stop`` .

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
        value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until all
        instances launch, the request is canceled, or this date is reached. If the request is
        persistent, it remains active until it is canceled or this date and time is reached. The
        default end date is 7 days from the current date.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ClientRunInstancesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ClientRunInstancesIpv6AddressesTypeDef(_ClientRunInstancesIpv6AddressesTypeDef):
    """
    Type definition for `ClientRunInstances` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRunInstancesLaunchTemplateTypeDef = TypedDict(
    "_ClientRunInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientRunInstancesLaunchTemplateTypeDef(_ClientRunInstancesLaunchTemplateTypeDef):
    """
    Type definition for `ClientRunInstances` `LaunchTemplate`

    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the name
    or ID of a launch template, but not both.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **Version** *(string) --*

      The version number of the launch template.

      Default: The default version for the launch template.
    """


_ClientRunInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_ClientRunInstancesLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientRunInstancesLicenseSpecificationsTypeDef(
    _ClientRunInstancesLicenseSpecificationsTypeDef
):
    """
    Type definition for `ClientRunInstances` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientRunInstancesMonitoringTypeDef = TypedDict(
    "_ClientRunInstancesMonitoringTypeDef", {"Enabled": bool}
)


class ClientRunInstancesMonitoringTypeDef(_ClientRunInstancesMonitoringTypeDef):
    """
    Type definition for `ClientRunInstances` `Monitoring`

    Specifies whether detailed monitoring is enabled for the instance.

    - **Enabled** *(boolean) --* **[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRunInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientRunInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
      IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ClientRunInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRunInstancesNetworkInterfacesTypeDef(
    _ClientRunInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRunInstances` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
      public IP address can only be assigned to a network interface for eth0, and can only be
      assigned to a new network interface, not an existing one. You cannot specify more than one
      network interface in the request. If launching into a default subnet, the default value is
      ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You can
      specify ``true`` only if creating a new network interface when launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network interface when
      launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network interface
      has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the device
      index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating a network
      interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the IPv6
      addresses from the range of the subnet. You cannot specify this option and the option to
      assign specific IPv6 addresses in the same request. You can specify this option if you've
      specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify this option
      and the option to assign a number of IPv6 addresses in the same request. You cannot specify
      this option if you've specified a minimum number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a network
      interface when launching an instance. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one private IPv4
      address can be designated as primary. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
          IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and specify
      more than one private IP address using the private IP addresses option. You cannot specify
      this option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if creating a
      network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ClientRunInstancesPlacementTypeDef = TypedDict(
    "_ClientRunInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientRunInstancesPlacementTypeDef(_ClientRunInstancesPlacementTypeDef):
    """
    Type definition for `ClientRunInstances` `Placement`

    The placement for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not supported
      for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group strategy is
      set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not supported for
      the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for the
      ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientRunInstancesResponseGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRunInstancesResponseGroupsTypeDef(_ClientRunInstancesResponseGroupsTypeDef):
    """
    Type definition for `ClientRunInstancesResponse` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": str,
        "VolumeId": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Status** *(string) --*

      The attachment state.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef(
    _ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Status** *(string) --*

        The attachment state.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.
    """


_ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the targeted Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef(
    _ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Describes the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the targeted Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientRunInstancesResponseInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientRunInstancesResponseInstancesCpuOptionsTypeDef(
    _ClientRunInstancesResponseInstancesCpuOptionsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `CpuOptions`

    The CPU options for the instance.

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef(
    _ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `ElasticGpuAssociations`

    Describes the association between an instance and an Elastic Graphics accelerator.

    - **ElasticGpuId** *(string) --*

      The ID of the Elastic Graphics accelerator.

    - **ElasticGpuAssociationId** *(string) --*

      The ID of the association.

    - **ElasticGpuAssociationState** *(string) --*

      The state of the association between the instance and the Elastic Graphics
      accelerator.

    - **ElasticGpuAssociationTime** *(string) --*

      The time the Elastic Graphics accelerator was associated with the instance.
    """


_ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `ElasticInferenceAcceleratorAssociations`

    Describes the association between an instance and an elastic inference accelerator.

    - **ElasticInferenceAcceleratorArn** *(string) --*

      The Amazon Resource Name (ARN) of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationId** *(string) --*

      The ID of the association.

    - **ElasticInferenceAcceleratorAssociationState** *(string) --*

      The state of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

      The time at which the elastic inference accelerator is associated with an instance.
    """


_ClientRunInstancesResponseInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientRunInstancesResponseInstancesHibernationOptionsTypeDef(
    _ClientRunInstancesResponseInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `HibernationOptions`

    Indicates whether the instance is enabled for hibernation.

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , your instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef(
    _ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `IamInstanceProfile`

    The IAM instance profile associated with the instance, if applicable.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_ClientRunInstancesResponseInstancesLicensesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientRunInstancesResponseInstancesLicensesTypeDef(
    _ClientRunInstancesResponseInstancesLicensesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `Licenses`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientRunInstancesResponseInstancesMonitoringTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesMonitoringTypeDef", {"State": str}, total=False
)


class ClientRunInstancesResponseInstancesMonitoringTypeDef(
    _ClientRunInstancesResponseInstancesMonitoringTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfaces` `Association`

    The association information for an Elastic IPv4 associated with the network interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfaces` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The index of the device on the instance for the network interface attachment.

    - **Status** *(string) --*

      The attachment state.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfaces` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddresses` `Association`

    The association information for an Elastic IP address for the network interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a private IPv4 address.

    - **Association** *(dict) --*

      The association information for an Elastic IP address for the network interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IP address of the
      network interface.

    - **PrivateDnsName** *(string) --*

      The private IPv4 DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface.
    """


_ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef",
    {
        "Association": ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef
        ],
        "Ipv6Addresses": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `NetworkInterfaces`

    Describes a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IPv4 associated with the network interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The index of the device on the instance for the network interface attachment.

      - **Status** *(string) --*

        The attachment state.

    - **Description** *(string) --*

      The description.

    - **Groups** *(list) --*

      One or more security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The ID of the AWS account that created the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes a private IPv4 address.

        - **Association** *(dict) --*

          The association information for an Elastic IP address for the network interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IP address of the
          network interface.

        - **PrivateDnsName** *(string) --*

          The private IPv4 DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether to validate network traffic to or from this network interface.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **InterfaceType** *(string) --*

      Describes the type of network interface.

      Valid values: ``interface`` | ``efa``
    """


_ClientRunInstancesResponseInstancesPlacementTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesPlacementTypeDef(
    _ClientRunInstancesResponseInstancesPlacementTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `Placement`

    The location where the instance launched, if applicable.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on
      the load balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not
      supported for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group
      strategy is set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not
      supported for the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for the  ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ClientRunInstancesResponseInstancesProductCodesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ClientRunInstancesResponseInstancesProductCodesTypeDef(
    _ClientRunInstancesResponseInstancesProductCodesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ClientRunInstancesResponseInstancesSecurityGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesSecurityGroupsTypeDef(
    _ClientRunInstancesResponseInstancesSecurityGroupsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_ClientRunInstancesResponseInstancesStateReasonTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRunInstancesResponseInstancesStateReasonTypeDef(
    _ClientRunInstancesResponseInstancesStateReasonTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `StateReason`

    The reason for the most recent state transition.

    - **Code** *(string) --*

      The reason code for the state change.

    - **Message** *(string) --*

      The message for the state change.

      * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
      to satisfy the launch request.

      * ``Server.InternalError`` : An internal error caused the instance to terminate during
      launch.

      * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

      * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
      requests with a maximum price equal to or higher than the Spot price exceeded available
      capacity or because of an increase in the Spot price.

      * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
      of Spot requests with a maximum price equal to or higher than the Spot price exceeded
      available capacity or because of an increase in the Spot price.

      * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
      ``shutdown -h`` command from the instance.

      * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
      creation.

      * ``Client.InternalError`` : A client error caused the instance to terminate during
      launch.

      * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

      * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

      * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
      API.

      * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
      storage was exceeded. Decrease usage or request an increase in your account limits.
    """


_ClientRunInstancesResponseInstancesStateTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientRunInstancesResponseInstancesStateTypeDef(
    _ClientRunInstancesResponseInstancesStateTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `State`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientRunInstancesResponseInstancesTagsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRunInstancesResponseInstancesTagsTypeDef(
    _ClientRunInstancesResponseInstancesTagsTypeDef
):
    """
    Type definition for `ClientRunInstancesResponseInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_ClientRunInstancesResponseInstancesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": ClientRunInstancesResponseInstancesMonitoringTypeDef,
        "Placement": ClientRunInstancesResponseInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[ClientRunInstancesResponseInstancesProductCodesTypeDef],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": ClientRunInstancesResponseInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": str,
        "BlockDeviceMappings": List[
            ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef
        ],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": str,
        "IamInstanceProfile": ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": str,
        "ElasticGpuAssociations": List[
            ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef
        ],
        "RootDeviceName": str,
        "RootDeviceType": str,
        "SecurityGroups": List[
            ClientRunInstancesResponseInstancesSecurityGroupsTypeDef
        ],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": ClientRunInstancesResponseInstancesStateReasonTypeDef,
        "Tags": List[ClientRunInstancesResponseInstancesTagsTypeDef],
        "VirtualizationType": str,
        "CpuOptions": ClientRunInstancesResponseInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": ClientRunInstancesResponseInstancesHibernationOptionsTypeDef,
        "Licenses": List[ClientRunInstancesResponseInstancesLicensesTypeDef],
    },
    total=False,
)


class ClientRunInstancesResponseInstancesTypeDef(
    _ClientRunInstancesResponseInstancesTypeDef
):
    """
    Type definition for `ClientRunInstancesResponse` `Instances`

    Describes an instance.

    - **AmiLaunchIndex** *(integer) --*

      The AMI launch index, which can be used to find this instance in the launch group.

    - **ImageId** *(string) --*

      The ID of the AMI used to launch the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The kernel associated with this instance, if applicable.

    - **KeyName** *(string) --*

      The name of the key pair, if this instance was launched with an associated key pair.

    - **LaunchTime** *(datetime) --*

      The time the instance was launched.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

        If not specified, an Availability Zone will be automatically chosen for you based on
        the load balancing criteria for the Region.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host. This parameter is not
        supported for the  ImportInstance command.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.

      - **PartitionNumber** *(integer) --*

        The number of the partition the instance is in. Valid only if the placement group
        strategy is set to ``partition`` .

      - **HostId** *(string) --*

        The ID of the Dedicated Host on which the instance resides. This parameter is not
        supported for the  ImportInstance command.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for the  ImportInstance command.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.

    - **PrivateDnsName** *(string) --*

      (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname can
      only be used inside the Amazon EC2 network. This name is not available until the instance
      enters the ``running`` state.

      [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS hostnames
      if you've enabled DNS resolution and DNS hostnames in your VPC. If you are not using the
      Amazon-provided DNS server in your VPC, your custom domain name servers must resolve the
      hostname as appropriate.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address assigned to the instance.

    - **ProductCodes** *(list) --*

      The product codes attached to this instance, if applicable.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **PublicDnsName** *(string) --*

      (IPv4 only) The public DNS name assigned to the instance. This name is not available
      until the instance enters the ``running`` state. For EC2-VPC, this name is only available
      if you've enabled DNS hostnames for your VPC.

    - **PublicIpAddress** *(string) --*

      The public IPv4 address assigned to the instance, if applicable.

    - **RamdiskId** *(string) --*

      The RAM disk associated with this instance, if applicable.

    - **State** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **StateTransitionReason** *(string) --*

      The reason for the most recent state transition. This might be an empty string.

    - **SubnetId** *(string) --*

      [EC2-VPC] The ID of the subnet in which the instance is running.

    - **VpcId** *(string) --*

      [EC2-VPC] The ID of the VPC in which the instance is running.

    - **Architecture** *(string) --*

      The architecture of the image.

    - **BlockDeviceMappings** *(list) --*

      Any block device mapping entries for the instance.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Status** *(string) --*

            The attachment state.

          - **VolumeId** *(string) --*

            The ID of the EBS volume.

    - **ClientToken** *(string) --*

      The idempotency token you provided when you launched the instance, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
      provides dedicated throughput to Amazon EBS and an optimized configuration stack to
      provide optimal I/O performance. This optimization isn't available with all instance
      types. Additional usage charges apply when using an EBS Optimized instance.

    - **EnaSupport** *(boolean) --*

      Specifies whether enhanced networking with ENA is enabled.

    - **Hypervisor** *(string) --*

      The hypervisor type of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile associated with the instance, if applicable.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **InstanceLifecycle** *(string) --*

      Indicates whether this is a Spot Instance or a Scheduled Instance.

    - **ElasticGpuAssociations** *(list) --*

      The Elastic GPU associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an Elastic Graphics accelerator.

        - **ElasticGpuId** *(string) --*

          The ID of the Elastic Graphics accelerator.

        - **ElasticGpuAssociationId** *(string) --*

          The ID of the association.

        - **ElasticGpuAssociationState** *(string) --*

          The state of the association between the instance and the Elastic Graphics
          accelerator.

        - **ElasticGpuAssociationTime** *(string) --*

          The time the Elastic Graphics accelerator was associated with the instance.

    - **ElasticInferenceAcceleratorAssociations** *(list) --*

      The elastic inference accelerator associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an elastic inference accelerator.

        - **ElasticInferenceAcceleratorArn** *(string) --*

          The Amazon Resource Name (ARN) of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationId** *(string) --*

          The ID of the association.

        - **ElasticInferenceAcceleratorAssociationState** *(string) --*

          The state of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

          The time at which the elastic inference accelerator is associated with an instance.

    - **NetworkInterfaces** *(list) --*

      [EC2-VPC] The network interfaces for the instance.

      - *(dict) --*

        Describes a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IPv4 associated with the network interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Attachment** *(dict) --*

          The network interface attachment.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **AttachmentId** *(string) --*

            The ID of the network interface attachment.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **DeviceIndex** *(integer) --*

            The index of the device on the instance for the network interface attachment.

          - **Status** *(string) --*

            The attachment state.

        - **Description** *(string) --*

          The description.

        - **Groups** *(list) --*

          One or more security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses associated with the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **MacAddress** *(string) --*

          The MAC address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **OwnerId** *(string) --*

          The ID of the AWS account that created the network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses associated with the network interface.

          - *(dict) --*

            Describes a private IPv4 address.

            - **Association** *(dict) --*

              The association information for an Elastic IP address for the network interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Primary** *(boolean) --*

              Indicates whether this IPv4 address is the primary private IP address of the
              network interface.

            - **PrivateDnsName** *(string) --*

              The private IPv4 DNS name.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface.

        - **SourceDestCheck** *(boolean) --*

          Indicates whether to validate network traffic to or from this network interface.

        - **Status** *(string) --*

          The status of the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **InterfaceType** *(string) --*

          Describes the type of network interface.

          Valid values: ``interface`` | ``efa``

    - **RootDeviceName** *(string) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **RootDeviceType** *(string) --*

      The root device type used by the AMI. The AMI can use an EBS volume or an instance store
      volume.

    - **SecurityGroups** *(list) --*

      The security groups for the instance.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **SourceDestCheck** *(boolean) --*

      Specifies whether to enable an instance launched in a VPC to perform NAT. This controls
      whether source/destination checking is enabled on the instance. A value of ``true`` means
      that checking is enabled, and ``false`` means that checking is disabled. The value must
      be ``false`` for the instance to perform NAT. For more information, see `NAT Instances
      <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the
      *Amazon Virtual Private Cloud User Guide* .

    - **SpotInstanceRequestId** *(string) --*

      If the request is a Spot Instance request, the ID of the request.

    - **SriovNetSupport** *(string) --*

      Specifies whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

    - **StateReason** *(dict) --*

      The reason for the most recent state transition.

      - **Code** *(string) --*

        The reason code for the state change.

      - **Message** *(string) --*

        The message for the state change.

        * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
        to satisfy the launch request.

        * ``Server.InternalError`` : An internal error caused the instance to terminate during
        launch.

        * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

        * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
        requests with a maximum price equal to or higher than the Spot price exceeded available
        capacity or because of an increase in the Spot price.

        * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
        of Spot requests with a maximum price equal to or higher than the Spot price exceeded
        available capacity or because of an increase in the Spot price.

        * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
        ``shutdown -h`` command from the instance.

        * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
        creation.

        * ``Client.InternalError`` : A client error caused the instance to terminate during
        launch.

        * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

        * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

        * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
        API.

        * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
        storage was exceeded. Decrease usage or request an increase in your account limits.

    - **Tags** *(list) --*

      Any tags assigned to the instance.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VirtualizationType** *(string) --*

      The virtualization type of the instance.

    - **CpuOptions** *(dict) --*

      The CPU options for the instance.

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Describes the instance's Capacity Reservation preferences. Possible preferences include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the targeted Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **HibernationOptions** *(dict) --*

      Indicates whether the instance is enabled for hibernation.

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , your instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.

    - **Licenses** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientRunInstancesResponseTypeDef = TypedDict(
    "_ClientRunInstancesResponseTypeDef",
    {
        "Groups": List[ClientRunInstancesResponseGroupsTypeDef],
        "Instances": List[ClientRunInstancesResponseInstancesTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class ClientRunInstancesResponseTypeDef(_ClientRunInstancesResponseTypeDef):
    """
    Type definition for `ClientRunInstances` `Response`

    Describes a reservation.

    - **Groups** *(list) --*

      [EC2-Classic only] The security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Instances** *(list) --*

      The instances.

      - *(dict) --*

        Describes an instance.

        - **AmiLaunchIndex** *(integer) --*

          The AMI launch index, which can be used to find this instance in the launch group.

        - **ImageId** *(string) --*

          The ID of the AMI used to launch the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The kernel associated with this instance, if applicable.

        - **KeyName** *(string) --*

          The name of the key pair, if this instance was launched with an associated key pair.

        - **LaunchTime** *(datetime) --*

          The time the instance was launched.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.

            If not specified, an Availability Zone will be automatically chosen for you based on
            the load balancing criteria for the Region.

          - **Affinity** *(string) --*

            The affinity setting for the instance on the Dedicated Host. This parameter is not
            supported for the  ImportInstance command.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

          - **PartitionNumber** *(integer) --*

            The number of the partition the instance is in. Valid only if the placement group
            strategy is set to ``partition`` .

          - **HostId** *(string) --*

            The ID of the Dedicated Host on which the instance resides. This parameter is not
            supported for the  ImportInstance command.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with a
            tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
            supported for the  ImportInstance command.

          - **SpreadDomain** *(string) --*

            Reserved for future use.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.

        - **PrivateDnsName** *(string) --*

          (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname can
          only be used inside the Amazon EC2 network. This name is not available until the instance
          enters the ``running`` state.

          [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS hostnames
          if you've enabled DNS resolution and DNS hostnames in your VPC. If you are not using the
          Amazon-provided DNS server in your VPC, your custom domain name servers must resolve the
          hostname as appropriate.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address assigned to the instance.

        - **ProductCodes** *(list) --*

          The product codes attached to this instance, if applicable.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **PublicDnsName** *(string) --*

          (IPv4 only) The public DNS name assigned to the instance. This name is not available
          until the instance enters the ``running`` state. For EC2-VPC, this name is only available
          if you've enabled DNS hostnames for your VPC.

        - **PublicIpAddress** *(string) --*

          The public IPv4 address assigned to the instance, if applicable.

        - **RamdiskId** *(string) --*

          The RAM disk associated with this instance, if applicable.

        - **State** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **StateTransitionReason** *(string) --*

          The reason for the most recent state transition. This might be an empty string.

        - **SubnetId** *(string) --*

          [EC2-VPC] The ID of the subnet in which the instance is running.

        - **VpcId** *(string) --*

          [EC2-VPC] The ID of the VPC in which the instance is running.

        - **Architecture** *(string) --*

          The architecture of the image.

        - **BlockDeviceMappings** *(list) --*

          Any block device mapping entries for the instance.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is launched.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the volume is deleted on instance termination.

              - **Status** *(string) --*

                The attachment state.

              - **VolumeId** *(string) --*

                The ID of the EBS volume.

        - **ClientToken** *(string) --*

          The idempotency token you provided when you launched the instance, if applicable.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
          provides dedicated throughput to Amazon EBS and an optimized configuration stack to
          provide optimal I/O performance. This optimization isn't available with all instance
          types. Additional usage charges apply when using an EBS Optimized instance.

        - **EnaSupport** *(boolean) --*

          Specifies whether enhanced networking with ENA is enabled.

        - **Hypervisor** *(string) --*

          The hypervisor type of the instance.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile associated with the instance, if applicable.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Id** *(string) --*

            The ID of the instance profile.

        - **InstanceLifecycle** *(string) --*

          Indicates whether this is a Spot Instance or a Scheduled Instance.

        - **ElasticGpuAssociations** *(list) --*

          The Elastic GPU associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an Elastic Graphics accelerator.

            - **ElasticGpuId** *(string) --*

              The ID of the Elastic Graphics accelerator.

            - **ElasticGpuAssociationId** *(string) --*

              The ID of the association.

            - **ElasticGpuAssociationState** *(string) --*

              The state of the association between the instance and the Elastic Graphics
              accelerator.

            - **ElasticGpuAssociationTime** *(string) --*

              The time the Elastic Graphics accelerator was associated with the instance.

        - **ElasticInferenceAcceleratorAssociations** *(list) --*

          The elastic inference accelerator associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an elastic inference accelerator.

            - **ElasticInferenceAcceleratorArn** *(string) --*

              The Amazon Resource Name (ARN) of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationId** *(string) --*

              The ID of the association.

            - **ElasticInferenceAcceleratorAssociationState** *(string) --*

              The state of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

              The time at which the elastic inference accelerator is associated with an instance.

        - **NetworkInterfaces** *(list) --*

          [EC2-VPC] The network interfaces for the instance.

          - *(dict) --*

            Describes a network interface.

            - **Association** *(dict) --*

              The association information for an Elastic IPv4 associated with the network interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Attachment** *(dict) --*

              The network interface attachment.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **AttachmentId** *(string) --*

                The ID of the network interface attachment.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the network interface is deleted when the instance is terminated.

              - **DeviceIndex** *(integer) --*

                The index of the device on the instance for the network interface attachment.

              - **Status** *(string) --*

                The attachment state.

            - **Description** *(string) --*

              The description.

            - **Groups** *(list) --*

              One or more security groups.

              - *(dict) --*

                Describes a security group.

                - **GroupName** *(string) --*

                  The name of the security group.

                - **GroupId** *(string) --*

                  The ID of the security group.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses associated with the network interface.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **MacAddress** *(string) --*

              The MAC address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **OwnerId** *(string) --*

              The ID of the AWS account that created the network interface.

            - **PrivateDnsName** *(string) --*

              The private DNS name.

            - **PrivateIpAddress** *(string) --*

              The IPv4 address of the network interface within the subnet.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses associated with the network interface.

              - *(dict) --*

                Describes a private IPv4 address.

                - **Association** *(dict) --*

                  The association information for an Elastic IP address for the network interface.

                  - **IpOwnerId** *(string) --*

                    The ID of the owner of the Elastic IP address.

                  - **PublicDnsName** *(string) --*

                    The public DNS name.

                  - **PublicIp** *(string) --*

                    The public IP address or Elastic IP address bound to the network interface.

                - **Primary** *(boolean) --*

                  Indicates whether this IPv4 address is the primary private IP address of the
                  network interface.

                - **PrivateDnsName** *(string) --*

                  The private IPv4 DNS name.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 address of the network interface.

            - **SourceDestCheck** *(boolean) --*

              Indicates whether to validate network traffic to or from this network interface.

            - **Status** *(string) --*

              The status of the network interface.

            - **SubnetId** *(string) --*

              The ID of the subnet.

            - **VpcId** *(string) --*

              The ID of the VPC.

            - **InterfaceType** *(string) --*

              Describes the type of network interface.

              Valid values: ``interface`` | ``efa``

        - **RootDeviceName** *(string) --*

          The device name of the root device volume (for example, ``/dev/sda1`` ).

        - **RootDeviceType** *(string) --*

          The root device type used by the AMI. The AMI can use an EBS volume or an instance store
          volume.

        - **SecurityGroups** *(list) --*

          The security groups for the instance.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **SourceDestCheck** *(boolean) --*

          Specifies whether to enable an instance launched in a VPC to perform NAT. This controls
          whether source/destination checking is enabled on the instance. A value of ``true`` means
          that checking is enabled, and ``false`` means that checking is disabled. The value must
          be ``false`` for the instance to perform NAT. For more information, see `NAT Instances
          <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the
          *Amazon Virtual Private Cloud User Guide* .

        - **SpotInstanceRequestId** *(string) --*

          If the request is a Spot Instance request, the ID of the request.

        - **SriovNetSupport** *(string) --*

          Specifies whether enhanced networking with the Intel 82599 Virtual Function interface is
          enabled.

        - **StateReason** *(dict) --*

          The reason for the most recent state transition.

          - **Code** *(string) --*

            The reason code for the state change.

          - **Message** *(string) --*

            The message for the state change.

            * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity available
            to satisfy the launch request.

            * ``Server.InternalError`` : An internal error caused the instance to terminate during
            launch.

            * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

            * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of Spot
            requests with a maximum price equal to or higher than the Spot price exceeded available
            capacity or because of an increase in the Spot price.

            * ``Server.SpotInstanceTermination`` : The instance was terminated because the number
            of Spot requests with a maximum price equal to or higher than the Spot price exceeded
            available capacity or because of an increase in the Spot price.

            * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
            ``shutdown -h`` command from the instance.

            * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during AMI
            creation.

            * ``Client.InternalError`` : A client error caused the instance to terminate during
            launch.

            * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

            * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

            * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon EC2
            API.

            * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
            storage was exceeded. Decrease usage or request an increase in your account limits.

        - **Tags** *(list) --*

          Any tags assigned to the instance.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VirtualizationType** *(string) --*

          The virtualization type of the instance.

        - **CpuOptions** *(dict) --*

          The CPU options for the instance.

          - **CoreCount** *(integer) --*

            The number of CPU cores for the instance.

          - **ThreadsPerCore** *(integer) --*

            The number of threads per CPU core.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

        - **CapacityReservationSpecification** *(dict) --*

          Information about the Capacity Reservation targeting option.

          - **CapacityReservationPreference** *(string) --*

            Describes the instance's Capacity Reservation preferences. Possible preferences include:

            * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
            matching attributes (instance type, platform, Availability Zone).

            * ``none`` - The instance avoids running in a Capacity Reservation even if one is
            available. The instance runs in On-Demand capacity.

          - **CapacityReservationTarget** *(dict) --*

            Information about the targeted Capacity Reservation.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

        - **HibernationOptions** *(dict) --*

          Indicates whether the instance is enabled for hibernation.

          - **Configured** *(boolean) --*

            If this parameter is set to ``true`` , your instance is enabled for hibernation;
            otherwise, it is not enabled for hibernation.

        - **Licenses** *(list) --*

          The license configurations.

          - *(dict) --*

            Describes a license configuration.

            - **LicenseConfigurationArn** *(string) --*

              The Amazon Resource Name (ARN) of the license configuration.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the reservation.

    - **RequesterId** *(string) --*

      The ID of the requester that launched the instances on your behalf (for example, AWS
      Management Console or Auto Scaling).

    - **ReservationId** *(string) --*

      The ID of the reservation.
    """


_ClientRunInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientRunInstancesTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRunInstancesTagSpecificationsTagsTypeDef(
    _ClientRunInstancesTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ClientRunInstancesTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientRunInstancesTagSpecificationsTypeDef = TypedDict(
    "_ClientRunInstancesTagSpecificationsTypeDef",
    {"ResourceType": str, "Tags": List[ClientRunInstancesTagSpecificationsTagsTypeDef]},
    total=False,
)


class ClientRunInstancesTagSpecificationsTypeDef(
    _ClientRunInstancesTagSpecificationsTypeDef
):
    """
    Type definition for `ClientRunInstances` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Encrypted": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappings` `Ebs`

    Parameters used to set up EBS volumes automatically when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Encrypted** *(boolean) --*

      Indicates whether the volume is encrypted. You can attached encrypted volumes only to
      instances that support them.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For io1 volumes,
      this represents the number of IOPS that are provisioned for the volume. For ``gp2``
      volumes, this represents the baseline performance of the volume and the rate at which the
      volume accumulates I/O credits for bursting. For more information about ``gp2`` baseline
      performance, I/O credits, and bursting, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraint: Range is 100-20000 IOPS for ``io1`` volumes and 100-10000 IOPS for ``gp2``
      volumes.

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. ``gp2`` for General Purpose SSD, ``io1`` for Provisioned IOPS SSD,
      Throughput Optimized HDD for ``st1`` , Cold HDD for ``sc1`` , or ``standard`` for
      Magnetic.

      Default: ``gp2``
    """


_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecification` `BlockDeviceMappings`

    Describes a block device mapping for a Scheduled Instance.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to set up EBS volumes automatically when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Encrypted** *(boolean) --*

        Indicates whether the volume is encrypted. You can attached encrypted volumes only to
        instances that support them.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For io1 volumes,
        this represents the number of IOPS that are provisioned for the volume. For ``gp2``
        volumes, this represents the baseline performance of the volume and the rate at which the
        volume accumulates I/O credits for bursting. For more information about ``gp2`` baseline
        performance, I/O credits, and bursting, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraint: Range is 100-20000 IOPS for ``io1`` volumes and 100-10000 IOPS for ``gp2``
        volumes.

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. ``gp2`` for General Purpose SSD, ``io1`` for Provisioned IOPS SSD,
        Throughput Optimized HDD for ``st1`` , Cold HDD for ``sc1`` , or ``standard`` for
        Magnetic.

        Default: ``gp2``

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
      from 0. An instance type with two available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends
      on the instance type. After you connect to the instance, you must mount the volume.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.
    """


_ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecification` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN).

    - **Name** *(string) --*

      The name.
    """


_ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecification` `Monitoring`

    Enable or disable monitoring for the instances.

    - **Enabled** *(boolean) --*

      Indicates whether monitoring is enabled.
    """


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecificationNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecificationNetworkInterfaces` `PrivateIpAddressConfigs`

    Describes a private IPv4 address for a Scheduled Instance.

    - **Primary** *(boolean) --*

      Indicates whether this is a primary IPv4 address. Otherwise, this is a secondary IPv4
      address.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address.
    """


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddressConfigs": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecification` `NetworkInterfaces`

    Describes a network interface for a Scheduled Instance.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to instances launched in a VPC. The
      public IPv4 address can only be assigned to a network interface for eth0, and can only be
      assigned to a new network interface, not an existing one. You cannot specify more than one
      network interface in the request. If launching into a default subnet, the default value is
      ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether to delete the interface when the instance is terminated.

    - **Description** *(string) --*

      The description.

    - **DeviceIndex** *(integer) --*

      The index of the device for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of the security groups.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses to assign to the network interface. The IPv6 addresses are
      automatically selected from the subnet range.

    - **Ipv6Addresses** *(list) --*

      The specific IPv6 addresses from the subnet range.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddressConfigs** *(list) --*

      The private IPv4 addresses.

      - *(dict) --*

        Describes a private IPv4 address for a Scheduled Instance.

        - **Primary** *(boolean) --*

          Indicates whether this is a primary IPv4 address. Otherwise, this is a secondary IPv4
          address.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `ClientRunScheduledInstancesLaunchSpecification` `Placement`

    The placement information.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **GroupName** *(string) --*

      The name of the placement group.
    """


_RequiredClientRunScheduledInstancesLaunchSpecificationTypeDef = TypedDict(
    "_RequiredClientRunScheduledInstancesLaunchSpecificationTypeDef", {"ImageId": str}
)
_OptionalClientRunScheduledInstancesLaunchSpecificationTypeDef = TypedDict(
    "_OptionalClientRunScheduledInstancesLaunchSpecificationTypeDef",
    {
        "BlockDeviceMappings": List[
            ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": List[str],
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationTypeDef(
    _RequiredClientRunScheduledInstancesLaunchSpecificationTypeDef,
    _OptionalClientRunScheduledInstancesLaunchSpecificationTypeDef,
):
    """
    Type definition for `ClientRunScheduledInstances` `LaunchSpecification`

    The launch specification. You must match the instance type, Availability Zone, network, and
    platform of the schedule that you purchased.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping entries.

      - *(dict) --*

        Describes a block device mapping for a Scheduled Instance.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to set up EBS volumes automatically when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Encrypted** *(boolean) --*

            Indicates whether the volume is encrypted. You can attached encrypted volumes only to
            instances that support them.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For io1 volumes,
            this represents the number of IOPS that are provisioned for the volume. For ``gp2``
            volumes, this represents the baseline performance of the volume and the rate at which the
            volume accumulates I/O credits for bursting. For more information about ``gp2`` baseline
            performance, I/O credits, and bursting, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraint: Range is 100-20000 IOPS for ``io1`` volumes and 100-10000 IOPS for ``gp2``
            volumes.

            Condition: This parameter is required for requests to create ``io1`` volumes; it is not
            used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. ``gp2`` for General Purpose SSD, ``io1`` for Provisioned IOPS SSD,
            Throughput Optimized HDD for ``st1`` , Cold HDD for ``sc1`` , or ``standard`` for
            Magnetic.

            Default: ``gp2``

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
          from 0. An instance type with two available instance store volumes can specify mappings for
          ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends
          on the instance type. After you connect to the instance, you must mount the volume.

          Constraints: For M3 instances, you must specify instance store volumes in the block device
          mapping for the instance. When you launch an M3 instance, we ignore any instance store
          volumes specified in the block device mapping for the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instances are optimized for EBS I/O. This optimization provides dedicated
      throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS I/O
      performance. This optimization isn't available with all instance types. Additional usage
      charges apply when using an EBS-optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN).

      - **Name** *(string) --*

        The name.

    - **ImageId** *(string) --* **[REQUIRED]**

      The ID of the Amazon Machine Image (AMI).

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      Enable or disable monitoring for the instances.

      - **Enabled** *(boolean) --*

        Indicates whether monitoring is enabled.

    - **NetworkInterfaces** *(list) --*

      The network interfaces.

      - *(dict) --*

        Describes a network interface for a Scheduled Instance.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to instances launched in a VPC. The
          public IPv4 address can only be assigned to a network interface for eth0, and can only be
          assigned to a new network interface, not an existing one. You cannot specify more than one
          network interface in the request. If launching into a default subnet, the default value is
          ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether to delete the interface when the instance is terminated.

        - **Description** *(string) --*

          The description.

        - **DeviceIndex** *(integer) --*

          The index of the device for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of the security groups.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses to assign to the network interface. The IPv6 addresses are
          automatically selected from the subnet range.

        - **Ipv6Addresses** *(list) --*

          The specific IPv6 addresses from the subnet range.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddressConfigs** *(list) --*

          The private IPv4 addresses.

          - *(dict) --*

            Describes a private IPv4 address for a Scheduled Instance.

            - **Primary** *(boolean) --*

              Indicates whether this is a primary IPv4 address. Otherwise, this is a secondary IPv4
              address.

            - **PrivateIpAddress** *(string) --*

              The IPv4 address.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses.

        - **SubnetId** *(string) --*

          The ID of the subnet.

    - **Placement** *(dict) --*

      The placement information.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

      - **GroupName** *(string) --*

        The name of the placement group.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk.

    - **SecurityGroupIds** *(list) --*

      The IDs of the security groups.

      - *(string) --*

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **UserData** *(string) --*

      The base64-encoded MIME user data.
    """


_ClientRunScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientRunScheduledInstancesResponseTypeDef",
    {"InstanceIdSet": List[str]},
    total=False,
)


class ClientRunScheduledInstancesResponseTypeDef(
    _ClientRunScheduledInstancesResponseTypeDef
):
    """
    Type definition for `ClientRunScheduledInstances` `Response`

    Contains the output of RunScheduledInstances.

    - **InstanceIdSet** *(list) --*

      The IDs of the newly launched instances.

      - *(string) --*
    """


_ClientSearchTransitGatewayRoutesFiltersTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientSearchTransitGatewayRoutesFiltersTypeDef(
    _ClientSearchTransitGatewayRoutesFiltersTypeDef
):
    """
    Type definition for `ClientSearchTransitGatewayRoutes` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef",
    {"ResourceId": str, "TransitGatewayAttachmentId": str, "ResourceType": str},
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef(
    _ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `ClientSearchTransitGatewayRoutesResponseRoutes` `TransitGatewayAttachments`

    Describes a route attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceType** *(string) --*

      The resource type.
    """


_ClientSearchTransitGatewayRoutesResponseRoutesTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef
        ],
        "Type": str,
        "State": str,
    },
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseRoutesTypeDef(
    _ClientSearchTransitGatewayRoutesResponseRoutesTypeDef
):
    """
    Type definition for `ClientSearchTransitGatewayRoutesResponse` `Routes`

    Describes a route for a transit gateway route table.

    - **DestinationCidrBlock** *(string) --*

      The CIDR block used for destination matches.

    - **TransitGatewayAttachments** *(list) --*

      The attachments.

      - *(dict) --*

        Describes a route attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceType** *(string) --*

          The resource type.

    - **Type** *(string) --*

      The route type.

    - **State** *(string) --*

      The state of the route.
    """


_ClientSearchTransitGatewayRoutesResponseTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseTypeDef",
    {
        "Routes": List[ClientSearchTransitGatewayRoutesResponseRoutesTypeDef],
        "AdditionalRoutesAvailable": bool,
    },
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseTypeDef(
    _ClientSearchTransitGatewayRoutesResponseTypeDef
):
    """
    Type definition for `ClientSearchTransitGatewayRoutes` `Response`

    - **Routes** *(list) --*

      Information about the routes.

      - *(dict) --*

        Describes a route for a transit gateway route table.

        - **DestinationCidrBlock** *(string) --*

          The CIDR block used for destination matches.

        - **TransitGatewayAttachments** *(list) --*

          The attachments.

          - *(dict) --*

            Describes a route attachment.

            - **ResourceId** *(string) --*

              The ID of the resource.

            - **TransitGatewayAttachmentId** *(string) --*

              The ID of the attachment.

            - **ResourceType** *(string) --*

              The resource type.

        - **Type** *(string) --*

          The route type.

        - **State** *(string) --*

          The state of the route.

    - **AdditionalRoutesAvailable** *(boolean) --*

      Indicates whether there are additional routes available.
    """


_ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef(
    _ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef
):
    """
    Type definition for `ClientStartInstancesResponseStartingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef(
    _ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef
):
    """
    Type definition for `ClientStartInstancesResponseStartingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientStartInstancesResponseStartingInstancesTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesTypeDef",
    {
        "CurrentState": ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientStartInstancesResponseStartingInstancesTypeDef(
    _ClientStartInstancesResponseStartingInstancesTypeDef
):
    """
    Type definition for `ClientStartInstancesResponse` `StartingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_ClientStartInstancesResponseTypeDef = TypedDict(
    "_ClientStartInstancesResponseTypeDef",
    {"StartingInstances": List[ClientStartInstancesResponseStartingInstancesTypeDef]},
    total=False,
)


class ClientStartInstancesResponseTypeDef(_ClientStartInstancesResponseTypeDef):
    """
    Type definition for `ClientStartInstances` `Response`

    - **StartingInstances** *(list) --*

      Information about the started instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef(
    _ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef
):
    """
    Type definition for `ClientStopInstancesResponseStoppingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef(
    _ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef
):
    """
    Type definition for `ClientStopInstancesResponseStoppingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientStopInstancesResponseStoppingInstancesTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesTypeDef",
    {
        "CurrentState": ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesTypeDef(
    _ClientStopInstancesResponseStoppingInstancesTypeDef
):
    """
    Type definition for `ClientStopInstancesResponse` `StoppingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_ClientStopInstancesResponseTypeDef = TypedDict(
    "_ClientStopInstancesResponseTypeDef",
    {"StoppingInstances": List[ClientStopInstancesResponseStoppingInstancesTypeDef]},
    total=False,
)


class ClientStopInstancesResponseTypeDef(_ClientStopInstancesResponseTypeDef):
    """
    Type definition for `ClientStopInstances` `Response`

    - **StoppingInstances** *(list) --*

      Information about the stopped instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef
):
    """
    Type definition for `ClientTerminateClientVpnConnectionsResponseConnectionStatuses` `CurrentStatus`

    A message about the status of the client connection, if applicable.

    - **Code** *(string) --*

      The state of the client connection.

    - **Message** *(string) --*

      A message about the status of the client connection, if applicable.
    """


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef
):
    """
    Type definition for `ClientTerminateClientVpnConnectionsResponseConnectionStatuses` `PreviousStatus`

    The state of the client connection.

    - **Code** *(string) --*

      The state of the client connection.

    - **Message** *(string) --*

      A message about the status of the client connection, if applicable.
    """


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef",
    {
        "ConnectionId": str,
        "PreviousStatus": ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef,
        "CurrentStatus": ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef,
    },
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef
):
    """
    Type definition for `ClientTerminateClientVpnConnectionsResponse` `ConnectionStatuses`

    Information about a terminated Client VPN endpoint client connection.

    - **ConnectionId** *(string) --*

      The ID of the client connection.

    - **PreviousStatus** *(dict) --*

      The state of the client connection.

      - **Code** *(string) --*

        The state of the client connection.

      - **Message** *(string) --*

        A message about the status of the client connection, if applicable.

    - **CurrentStatus** *(dict) --*

      A message about the status of the client connection, if applicable.

      - **Code** *(string) --*

        The state of the client connection.

      - **Message** *(string) --*

        A message about the status of the client connection, if applicable.
    """


_ClientTerminateClientVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Username": str,
        "ConnectionStatuses": List[
            ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef
        ],
    },
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseTypeDef(
    _ClientTerminateClientVpnConnectionsResponseTypeDef
):
    """
    Type definition for `ClientTerminateClientVpnConnections` `Response`

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint.

    - **Username** *(string) --*

      The user who established the terminated client connections.

    - **ConnectionStatuses** *(list) --*

      The current state of the client connections.

      - *(dict) --*

        Information about a terminated Client VPN endpoint client connection.

        - **ConnectionId** *(string) --*

          The ID of the client connection.

        - **PreviousStatus** *(dict) --*

          The state of the client connection.

          - **Code** *(string) --*

            The state of the client connection.

          - **Message** *(string) --*

            A message about the status of the client connection, if applicable.

        - **CurrentStatus** *(dict) --*

          A message about the status of the client connection, if applicable.

          - **Code** *(string) --*

            The state of the client connection.

          - **Message** *(string) --*

            A message about the status of the client connection, if applicable.
    """


_ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    Type definition for `ClientTerminateInstancesResponseTerminatingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef
):
    """
    Type definition for `ClientTerminateInstancesResponseTerminatingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_ClientTerminateInstancesResponseTerminatingInstancesTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesTypeDef
):
    """
    Type definition for `ClientTerminateInstancesResponse` `TerminatingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_ClientTerminateInstancesResponseTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTypeDef",
    {
        "TerminatingInstances": List[
            ClientTerminateInstancesResponseTerminatingInstancesTypeDef
        ]
    },
    total=False,
)


class ClientTerminateInstancesResponseTypeDef(_ClientTerminateInstancesResponseTypeDef):
    """
    Type definition for `ClientTerminateInstances` `Response`

    - **TerminatingInstances** *(list) --*

      Information about the terminated instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_ClientUnassignIpv6AddressesResponseTypeDef = TypedDict(
    "_ClientUnassignIpv6AddressesResponseTypeDef",
    {"NetworkInterfaceId": str, "UnassignedIpv6Addresses": List[str]},
    total=False,
)


class ClientUnassignIpv6AddressesResponseTypeDef(
    _ClientUnassignIpv6AddressesResponseTypeDef
):
    """
    Type definition for `ClientUnassignIpv6Addresses` `Response`

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **UnassignedIpv6Addresses** *(list) --*

      The IPv6 addresses that have been unassigned from the network interface.

      - *(string) --*
    """


_ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef(
    _ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `ClientUnmonitorInstancesResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef(
    _ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `ClientUnmonitorInstancesResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_ClientUnmonitorInstancesResponseTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseTypeDef",
    {
        "InstanceMonitorings": List[
            ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef
        ]
    },
    total=False,
)


class ClientUnmonitorInstancesResponseTypeDef(_ClientUnmonitorInstancesResponseTypeDef):
    """
    Type definition for `ClientUnmonitorInstances` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsEgress` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef
):
    """
    Type definition for `ClientUpdateSecurityGroupRuleDescriptionsIngress` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientWithdrawByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientWithdrawByoipCidrResponseByoipCidrTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class ClientWithdrawByoipCidrResponseByoipCidrTypeDef(
    _ClientWithdrawByoipCidrResponseByoipCidrTypeDef
):
    """
    Type definition for `ClientWithdrawByoipCidrResponse` `ByoipCidr`

    Information about the address pool.

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_ClientWithdrawByoipCidrResponseTypeDef = TypedDict(
    "_ClientWithdrawByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientWithdrawByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientWithdrawByoipCidrResponseTypeDef(_ClientWithdrawByoipCidrResponseTypeDef):
    """
    Type definition for `ClientWithdrawByoipCidr` `Response`

    - **ByoipCidr** *(dict) --*

      Information about the address pool.

      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.

      - **Description** *(string) --*

        The description of the address range.

      - **StatusMessage** *(string) --*

        Upon success, contains the ID of the address pool. Otherwise, contains an error message.

      - **State** *(string) --*

        The state of the address pool.
    """


_ConversionTaskCancelledWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskCancelledWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ConversionTaskCancelledWaitWaiterConfigTypeDef(
    _ConversionTaskCancelledWaitWaiterConfigTypeDef
):
    """
    Type definition for `ConversionTaskCancelledWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ConversionTaskCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskCompletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ConversionTaskCompletedWaitWaiterConfigTypeDef(
    _ConversionTaskCompletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `ConversionTaskCompletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ConversionTaskDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskDeletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ConversionTaskDeletedWaitWaiterConfigTypeDef(
    _ConversionTaskDeletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `ConversionTaskDeletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_CustomerGatewayAvailableWaitFiltersTypeDef = TypedDict(
    "_CustomerGatewayAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class CustomerGatewayAvailableWaitFiltersTypeDef(
    _CustomerGatewayAvailableWaitFiltersTypeDef
):
    """
    Type definition for `CustomerGatewayAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_CustomerGatewayAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_CustomerGatewayAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class CustomerGatewayAvailableWaitWaiterConfigTypeDef(
    _CustomerGatewayAvailableWaitWaiterConfigTypeDef
):
    """
    Type definition for `CustomerGatewayAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_DescribeByoipCidrsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeByoipCidrsPaginatePaginationConfigTypeDef(
    _DescribeByoipCidrsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeByoipCidrsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef",
    {"Cidr": str, "Description": str, "StatusMessage": str, "State": str},
    total=False,
)


class DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef(
    _DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef
):
    """
    Type definition for `DescribeByoipCidrsPaginateResponse` `ByoipCidrs`

    Information about an address range that is provisioned for use with your AWS resources
    through bring your own IP addresses (BYOIP).

    - **Cidr** *(string) --*

      The public IPv4 address range, in CIDR notation.

    - **Description** *(string) --*

      The description of the address range.

    - **StatusMessage** *(string) --*

      Upon success, contains the ID of the address pool. Otherwise, contains an error message.

    - **State** *(string) --*

      The state of the address pool.
    """


_DescribeByoipCidrsPaginateResponseTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginateResponseTypeDef",
    {"ByoipCidrs": List[DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef]},
    total=False,
)


class DescribeByoipCidrsPaginateResponseTypeDef(
    _DescribeByoipCidrsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeByoipCidrsPaginate` `Response`

    - **ByoipCidrs** *(list) --*

      Information about your address ranges.

      - *(dict) --*

        Information about an address range that is provisioned for use with your AWS resources
        through bring your own IP addresses (BYOIP).

        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.

        - **Description** *(string) --*

          The description of the address range.

        - **StatusMessage** *(string) --*

          Upon success, contains the ID of the address pool. Otherwise, contains an error message.

        - **State** *(string) --*

          The state of the address pool.
    """


_DescribeCapacityReservationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeCapacityReservationsPaginateFiltersTypeDef(
    _DescribeCapacityReservationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeCapacityReservationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeCapacityReservationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeCapacityReservationsPaginatePaginationConfigTypeDef(
    _DescribeCapacityReservationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeCapacityReservationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef(
    _DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef
):
    """
    Type definition for `DescribeCapacityReservationsPaginateResponseCapacityReservations` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": str,
        "AvailabilityZone": str,
        "Tenancy": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": str,
        "EndDate": datetime,
        "EndDateType": str,
        "InstanceMatchCriteria": str,
        "CreateDate": datetime,
        "Tags": List[
            DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef(
    _DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef
):
    """
    Type definition for `DescribeCapacityReservationsPaginateResponse` `CapacityReservations`

    Describes a Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the Capacity Reservation.

    - **CapacityReservationArn** *(string) --*

      The Amazon Resource Name (ARN) of the Capacity Reservation.

    - **AvailabilityZoneId** *(string) --*

      The Availability Zone ID of the Capacity Reservation.

    - **InstanceType** *(string) --*

      The type of instance for which the Capacity Reservation reserves capacity.

    - **InstancePlatform** *(string) --*

      The type of operating system for which the Capacity Reservation reserves capacity.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the capacity is reserved.

    - **Tenancy** *(string) --*

      Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
      the following tenancy settings:

      * ``default`` - The Capacity Reservation is created on hardware that is shared with other
      AWS accounts.

      * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
      dedicated to a single AWS account.

    - **TotalInstanceCount** *(integer) --*

      The total number of instances for which the Capacity Reservation reserves capacity.

    - **AvailableInstanceCount** *(integer) --*

      The remaining capacity. Indicates the number of instances that can be launched in the
      Capacity Reservation.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the Capacity Reservation supports EBS-optimized instances. This
      optimization provides dedicated throughput to Amazon EBS and an optimized configuration
      stack to provide optimal I/O performance. This optimization isn't available with all
      instance types. Additional usage charges apply when using an EBS- optimized instance.

    - **EphemeralStorage** *(boolean) --*

      Indicates whether the Capacity Reservation supports instances with temporary, block-level
      storage.

    - **State** *(string) --*

      The current state of the Capacity Reservation. A Capacity Reservation can be in one of
      the following states:

      * ``active`` - The Capacity Reservation is active and the capacity is available for your
      use.

      * ``expired`` - The Capacity Reservation expired automatically at the date and time
      specified in your request. The reserved capacity is no longer available for your use.

      * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity
      is no longer available for your use.

      * ``pending`` - The Capacity Reservation request was successful but the capacity
      provisioning is still pending.

      * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
      invalid request parameters, capacity constraints, or instance limit constraints. Failed
      requests are retained for 60 minutes.

    - **EndDate** *(datetime) --*

      The date and time at which the Capacity Reservation expires. When a Capacity Reservation
      expires, the reserved capacity is released and you can no longer launch instances into
      it. The Capacity Reservation's state changes to ``expired`` when it reaches its end date
      and time.

    - **EndDateType** *(string) --*

      Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
      one of the following end types:

      * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

      * ``limited`` - The Capacity Reservation expires automatically at a specified date and
      time.

    - **InstanceMatchCriteria** *(string) --*

      Indicates the type of instance launches that the Capacity Reservation accepts. The
      options include:

      * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
      (instance type, platform, and Availability Zone). Instances that have matching attributes
      launch into the Capacity Reservation automatically without specifying any additional
      parameters.

      * ``targeted`` - The Capacity Reservation only accepts instances that have matching
      attributes (instance type, platform, and Availability Zone), and explicitly target the
      Capacity Reservation. This ensures that only permitted instances can use the reserved
      capacity.

    - **CreateDate** *(datetime) --*

      The date and time at which the Capacity Reservation was created.

    - **Tags** *(list) --*

      Any tags assigned to the Capacity Reservation.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeCapacityReservationsPaginateResponseTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseTypeDef",
    {
        "CapacityReservations": List[
            DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef
        ]
    },
    total=False,
)


class DescribeCapacityReservationsPaginateResponseTypeDef(
    _DescribeCapacityReservationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeCapacityReservationsPaginate` `Response`

    - **CapacityReservations** *(list) --*

      Information about the Capacity Reservations.

      - *(dict) --*

        Describes a Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the Capacity Reservation.

        - **CapacityReservationArn** *(string) --*

          The Amazon Resource Name (ARN) of the Capacity Reservation.

        - **AvailabilityZoneId** *(string) --*

          The Availability Zone ID of the Capacity Reservation.

        - **InstanceType** *(string) --*

          The type of instance for which the Capacity Reservation reserves capacity.

        - **InstancePlatform** *(string) --*

          The type of operating system for which the Capacity Reservation reserves capacity.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which the capacity is reserved.

        - **Tenancy** *(string) --*

          Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of
          the following tenancy settings:

          * ``default`` - The Capacity Reservation is created on hardware that is shared with other
          AWS accounts.

          * ``dedicated`` - The Capacity Reservation is created on single-tenant hardware that is
          dedicated to a single AWS account.

        - **TotalInstanceCount** *(integer) --*

          The total number of instances for which the Capacity Reservation reserves capacity.

        - **AvailableInstanceCount** *(integer) --*

          The remaining capacity. Indicates the number of instances that can be launched in the
          Capacity Reservation.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the Capacity Reservation supports EBS-optimized instances. This
          optimization provides dedicated throughput to Amazon EBS and an optimized configuration
          stack to provide optimal I/O performance. This optimization isn't available with all
          instance types. Additional usage charges apply when using an EBS- optimized instance.

        - **EphemeralStorage** *(boolean) --*

          Indicates whether the Capacity Reservation supports instances with temporary, block-level
          storage.

        - **State** *(string) --*

          The current state of the Capacity Reservation. A Capacity Reservation can be in one of
          the following states:

          * ``active`` - The Capacity Reservation is active and the capacity is available for your
          use.

          * ``expired`` - The Capacity Reservation expired automatically at the date and time
          specified in your request. The reserved capacity is no longer available for your use.

          * ``cancelled`` - The Capacity Reservation was manually cancelled. The reserved capacity
          is no longer available for your use.

          * ``pending`` - The Capacity Reservation request was successful but the capacity
          provisioning is still pending.

          * ``failed`` - The Capacity Reservation request has failed. A request might fail due to
          invalid request parameters, capacity constraints, or instance limit constraints. Failed
          requests are retained for 60 minutes.

        - **EndDate** *(datetime) --*

          The date and time at which the Capacity Reservation expires. When a Capacity Reservation
          expires, the reserved capacity is released and you can no longer launch instances into
          it. The Capacity Reservation's state changes to ``expired`` when it reaches its end date
          and time.

        - **EndDateType** *(string) --*

          Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have
          one of the following end types:

          * ``unlimited`` - The Capacity Reservation remains active until you explicitly cancel it.

          * ``limited`` - The Capacity Reservation expires automatically at a specified date and
          time.

        - **InstanceMatchCriteria** *(string) --*

          Indicates the type of instance launches that the Capacity Reservation accepts. The
          options include:

          * ``open`` - The Capacity Reservation accepts all instances that have matching attributes
          (instance type, platform, and Availability Zone). Instances that have matching attributes
          launch into the Capacity Reservation automatically without specifying any additional
          parameters.

          * ``targeted`` - The Capacity Reservation only accepts instances that have matching
          attributes (instance type, platform, and Availability Zone), and explicitly target the
          Capacity Reservation. This ensures that only permitted instances can use the reserved
          capacity.

        - **CreateDate** *(datetime) --*

          The date and time at which the Capacity Reservation was created.

        - **Tags** *(list) --*

          Any tags assigned to the Capacity Reservation.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeClassicLinkInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClassicLinkInstancesPaginateFiltersTypeDef(
    _DescribeClassicLinkInstancesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef(
    _DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginateResponseInstances` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginateResponseInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef",
    {
        "Groups": List[
            DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef
        ],
        "InstanceId": str,
        "Tags": List[DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginateResponse` `Instances`

    Describes a linked EC2-Classic instance.

    - **Groups** *(list) --*

      A list of security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Tags** *(list) --*

      Any tags assigned to the instance.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_DescribeClassicLinkInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseTypeDef",
    {"Instances": List[DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef]},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClassicLinkInstancesPaginate` `Response`

    - **Instances** *(list) --*

      Information about one or more linked EC2-Classic instances.

      - *(dict) --*

        Describes a linked EC2-Classic instance.

        - **Groups** *(list) --*

          A list of security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Tags** *(list) --*

          Any tags assigned to the instance.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.
    """


_DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClientVpnAuthorizationRulesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClientVpnAuthorizationRulesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef
):
    """
    Type definition for `DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRules` `Status`

    The current state of the authorization rule.

    - **Code** *(string) --*

      The state of the authorization rule.

    - **Message** *(string) --*

      A message about the status of the authorization rule, if applicable.
    """


_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "GroupId": str,
        "AccessAll": bool,
        "DestinationCidr": str,
        "Status": DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef,
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef
):
    """
    Type definition for `DescribeClientVpnAuthorizationRulesPaginateResponse` `AuthorizationRules`

    Information about an authorization rule.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the authorization rule is associated.

    - **Description** *(string) --*

      A brief description of the authorization rule.

    - **GroupId** *(string) --*

      The ID of the Active Directory group to which the authorization rule grants access.

    - **AccessAll** *(boolean) --*

      Indicates whether the authorization rule grants access to all clients.

    - **DestinationCidr** *(string) --*

      The IPv4 address range, in CIDR notation, of the network to which the authorization rule
      applies.

    - **Status** *(dict) --*

      The current state of the authorization rule.

      - **Code** *(string) --*

        The state of the authorization rule.

      - **Message** *(string) --*

        A message about the status of the authorization rule, if applicable.
    """


_DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef",
    {
        "AuthorizationRules": List[
            DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClientVpnAuthorizationRulesPaginate` `Response`

    - **AuthorizationRules** *(list) --*

      Information about the authorization rules.

      - *(dict) --*

        Information about an authorization rule.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the authorization rule is associated.

        - **Description** *(string) --*

          A brief description of the authorization rule.

        - **GroupId** *(string) --*

          The ID of the Active Directory group to which the authorization rule grants access.

        - **AccessAll** *(boolean) --*

          Indicates whether the authorization rule grants access to all clients.

        - **DestinationCidr** *(string) --*

          The IPv4 address range, in CIDR notation, of the network to which the authorization rule
          applies.

        - **Status** *(dict) --*

          The current state of the authorization rule.

          - **Code** *(string) --*

            The state of the authorization rule.

          - **Message** *(string) --*

            A message about the status of the authorization rule, if applicable.
    """


_DescribeClientVpnConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnConnectionsPaginateFiltersTypeDef(
    _DescribeClientVpnConnectionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClientVpnConnectionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef(
    _DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClientVpnConnectionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef
):
    """
    Type definition for `DescribeClientVpnConnectionsPaginateResponseConnections` `Status`

    The current state of the client connection.

    - **Code** *(string) --*

      The state of the client connection.

    - **Message** *(string) --*

      A message about the status of the client connection, if applicable.
    """


_DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Timestamp": str,
        "ConnectionId": str,
        "Username": str,
        "ConnectionEstablishedTime": str,
        "IngressBytes": str,
        "EgressBytes": str,
        "IngressPackets": str,
        "EgressPackets": str,
        "ClientIp": str,
        "CommonName": str,
        "Status": DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef,
        "ConnectionEndTime": str,
    },
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef
):
    """
    Type definition for `DescribeClientVpnConnectionsPaginateResponse` `Connections`

    Describes a client connection.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint to which the client is connected.

    - **Timestamp** *(string) --*

      The current date and time.

    - **ConnectionId** *(string) --*

      The ID of the client connection.

    - **Username** *(string) --*

      The username of the client who established the client connection. This information is
      only provided if Active Directory client authentication is used.

    - **ConnectionEstablishedTime** *(string) --*

      The date and time the client connection was established.

    - **IngressBytes** *(string) --*

      The number of bytes sent by the client.

    - **EgressBytes** *(string) --*

      The number of bytes received by the client.

    - **IngressPackets** *(string) --*

      The number of packets sent by the client.

    - **EgressPackets** *(string) --*

      The number of packets received by the client.

    - **ClientIp** *(string) --*

      The IP address of the client.

    - **CommonName** *(string) --*

      The common name associated with the client. This is either the name of the client
      certificate, or the Active Directory user name.

    - **Status** *(dict) --*

      The current state of the client connection.

      - **Code** *(string) --*

        The state of the client connection.

      - **Message** *(string) --*

        A message about the status of the client connection, if applicable.

    - **ConnectionEndTime** *(string) --*

      The date and time the client connection was terminated.
    """


_DescribeClientVpnConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseTypeDef",
    {
        "Connections": List[
            DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClientVpnConnectionsPaginate` `Response`

    - **Connections** *(list) --*

      Information about the active and terminated client connections.

      - *(dict) --*

        Describes a client connection.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint to which the client is connected.

        - **Timestamp** *(string) --*

          The current date and time.

        - **ConnectionId** *(string) --*

          The ID of the client connection.

        - **Username** *(string) --*

          The username of the client who established the client connection. This information is
          only provided if Active Directory client authentication is used.

        - **ConnectionEstablishedTime** *(string) --*

          The date and time the client connection was established.

        - **IngressBytes** *(string) --*

          The number of bytes sent by the client.

        - **EgressBytes** *(string) --*

          The number of bytes received by the client.

        - **IngressPackets** *(string) --*

          The number of packets sent by the client.

        - **EgressPackets** *(string) --*

          The number of packets received by the client.

        - **ClientIp** *(string) --*

          The IP address of the client.

        - **CommonName** *(string) --*

          The common name associated with the client. This is either the name of the client
          certificate, or the Active Directory user name.

        - **Status** *(dict) --*

          The current state of the client connection.

          - **Code** *(string) --*

            The state of the client connection.

          - **Message** *(string) --*

            A message about the status of the client connection, if applicable.

        - **ConnectionEndTime** *(string) --*

          The date and time the client connection was terminated.
    """


_DescribeClientVpnEndpointsPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnEndpointsPaginateFiltersTypeDef(
    _DescribeClientVpnEndpointsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef(
    _DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    {"NetworkId": str, "NetworkType": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpoints` `AssociatedTargetNetworks`

    Describes a target network that is associated with a Client VPN endpoint. A target
    network is a subnet in a VPC.

    - **NetworkId** *(string) --*

      The ID of the subnet.

    - **NetworkType** *(string) --*

      The target network type.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptions` `ActiveDirectory`

    Information about the Active Directory, if applicable.

    - **DirectoryId** *(string) --*

      The ID of the Active Directory used for authentication.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChain": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptions` `MutualAuthentication`

    Information about the authentication certificates, if applicable.

    - **ClientRootCertificateChain** *(string) --*

      The ARN of the client certificate.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    {
        "Type": str,
        "ActiveDirectory": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpoints` `AuthenticationOptions`

    Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
    Active Directory and mutual authentication. For more information, see `Authentication
    <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
    in the *AWS Client VPN Administrator Guide* .

    - **Type** *(string) --*

      The authentication type used.

    - **ActiveDirectory** *(dict) --*

      Information about the Active Directory, if applicable.

      - **DirectoryId** *(string) --*

        The ID of the Active Directory used for authentication.

    - **MutualAuthentication** *(dict) --*

      Information about the authentication certificates, if applicable.

      - **ClientRootCertificateChain** *(string) --*

        The ARN of the client certificate.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpoints` `ConnectionLogOptions`

    Information about the client connection logging options for the Client VPN endpoint.

    - **Enabled** *(boolean) --*

      Indicates whether client connection logging is enabled for the Client VPN endpoint.

    - **CloudwatchLogGroup** *(string) --*

      The name of the Amazon CloudWatch Logs log group to which connection logging data is
      published.

    - **CloudwatchLogStream** *(string) --*

      The name of the Amazon CloudWatch Logs log stream to which connection logging data is
      published.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpoints` `Status`

    The current state of the Client VPN endpoint.

    - **Code** *(string) --*

      The state of the Client VPN endpoint. Possible states include:

      * ``pending-associate`` - The Client VPN endpoint has been created but no target
      networks have been associated. The Client VPN endpoint cannot accept connections.

      * ``available`` - The Client VPN endpoint has been created and a target network has
      been associated. The Client VPN endpoint can accept connections.

      * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
      cannot accept connections.

      * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
      cannot accept connections.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponseClientVpnEndpoints` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "Status": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef,
        "CreationTime": str,
        "DeletionTime": str,
        "DnsName": str,
        "ClientCidrBlock": str,
        "DnsServers": List[str],
        "SplitTunnel": bool,
        "VpnProtocol": str,
        "TransportProtocol": str,
        "AssociatedTargetNetworks": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
        ],
        "ServerCertificateArn": str,
        "AuthenticationOptions": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef
        ],
        "ConnectionLogOptions": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef,
        "Tags": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginateResponse` `ClientVpnEndpoints`

    Describes a Client VPN endpoint.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint.

    - **Description** *(string) --*

      A brief description of the endpoint.

    - **Status** *(dict) --*

      The current state of the Client VPN endpoint.

      - **Code** *(string) --*

        The state of the Client VPN endpoint. Possible states include:

        * ``pending-associate`` - The Client VPN endpoint has been created but no target
        networks have been associated. The Client VPN endpoint cannot accept connections.

        * ``available`` - The Client VPN endpoint has been created and a target network has
        been associated. The Client VPN endpoint can accept connections.

        * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
        cannot accept connections.

        * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
        cannot accept connections.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint.

    - **CreationTime** *(string) --*

      The date and time the Client VPN endpoint was created.

    - **DeletionTime** *(string) --*

      The date and time the Client VPN endpoint was deleted, if applicable.

    - **DnsName** *(string) --*

      The DNS name to be used by clients when connecting to the Client VPN endpoint.

    - **ClientCidrBlock** *(string) --*

      The IPv4 address range, in CIDR notation, from which client IP addresses are assigned.

    - **DnsServers** *(list) --*

      Information about the DNS servers to be used for DNS resolution.

      - *(string) --*

    - **SplitTunnel** *(boolean) --*

      Indicates whether split-tunnel is enabled in the AWS Client VPN endpoint.

      For information about split-tunnel VPN endpoints, see `Split-Tunnel AWS Client VPN
      Endpoint
      <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html>`__ in the
      *AWS Client VPN Administrator Guide* .

    - **VpnProtocol** *(string) --*

      The protocol used by the VPN session.

    - **TransportProtocol** *(string) --*

      The transport protocol used by the Client VPN endpoint.

    - **AssociatedTargetNetworks** *(list) --*

      Information about the associated target networks. A target network is a subnet in a VPC.

      - *(dict) --*

        Describes a target network that is associated with a Client VPN endpoint. A target
        network is a subnet in a VPC.

        - **NetworkId** *(string) --*

          The ID of the subnet.

        - **NetworkType** *(string) --*

          The target network type.

    - **ServerCertificateArn** *(string) --*

      The ARN of the server certificate.

    - **AuthenticationOptions** *(list) --*

      Information about the authentication method used by the Client VPN endpoint.

      - *(dict) --*

        Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
        Active Directory and mutual authentication. For more information, see `Authentication
        <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
        in the *AWS Client VPN Administrator Guide* .

        - **Type** *(string) --*

          The authentication type used.

        - **ActiveDirectory** *(dict) --*

          Information about the Active Directory, if applicable.

          - **DirectoryId** *(string) --*

            The ID of the Active Directory used for authentication.

        - **MutualAuthentication** *(dict) --*

          Information about the authentication certificates, if applicable.

          - **ClientRootCertificateChain** *(string) --*

            The ARN of the client certificate.

    - **ConnectionLogOptions** *(dict) --*

      Information about the client connection logging options for the Client VPN endpoint.

      - **Enabled** *(boolean) --*

        Indicates whether client connection logging is enabled for the Client VPN endpoint.

      - **CloudwatchLogGroup** *(string) --*

        The name of the Amazon CloudWatch Logs log group to which connection logging data is
        published.

      - **CloudwatchLogStream** *(string) --*

        The name of the Amazon CloudWatch Logs log stream to which connection logging data is
        published.

    - **Tags** *(list) --*

      Any tags assigned to the Client VPN endpoint.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeClientVpnEndpointsPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseTypeDef",
    {
        "ClientVpnEndpoints": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClientVpnEndpointsPaginate` `Response`

    - **ClientVpnEndpoints** *(list) --*

      Information about the Client VPN endpoints.

      - *(dict) --*

        Describes a Client VPN endpoint.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint.

        - **Description** *(string) --*

          A brief description of the endpoint.

        - **Status** *(dict) --*

          The current state of the Client VPN endpoint.

          - **Code** *(string) --*

            The state of the Client VPN endpoint. Possible states include:

            * ``pending-associate`` - The Client VPN endpoint has been created but no target
            networks have been associated. The Client VPN endpoint cannot accept connections.

            * ``available`` - The Client VPN endpoint has been created and a target network has
            been associated. The Client VPN endpoint can accept connections.

            * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint
            cannot accept connections.

            * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint
            cannot accept connections.

          - **Message** *(string) --*

            A message about the status of the Client VPN endpoint.

        - **CreationTime** *(string) --*

          The date and time the Client VPN endpoint was created.

        - **DeletionTime** *(string) --*

          The date and time the Client VPN endpoint was deleted, if applicable.

        - **DnsName** *(string) --*

          The DNS name to be used by clients when connecting to the Client VPN endpoint.

        - **ClientCidrBlock** *(string) --*

          The IPv4 address range, in CIDR notation, from which client IP addresses are assigned.

        - **DnsServers** *(list) --*

          Information about the DNS servers to be used for DNS resolution.

          - *(string) --*

        - **SplitTunnel** *(boolean) --*

          Indicates whether split-tunnel is enabled in the AWS Client VPN endpoint.

          For information about split-tunnel VPN endpoints, see `Split-Tunnel AWS Client VPN
          Endpoint
          <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html>`__ in the
          *AWS Client VPN Administrator Guide* .

        - **VpnProtocol** *(string) --*

          The protocol used by the VPN session.

        - **TransportProtocol** *(string) --*

          The transport protocol used by the Client VPN endpoint.

        - **AssociatedTargetNetworks** *(list) --*

          Information about the associated target networks. A target network is a subnet in a VPC.

          - *(dict) --*

            Describes a target network that is associated with a Client VPN endpoint. A target
            network is a subnet in a VPC.

            - **NetworkId** *(string) --*

              The ID of the subnet.

            - **NetworkType** *(string) --*

              The target network type.

        - **ServerCertificateArn** *(string) --*

          The ARN of the server certificate.

        - **AuthenticationOptions** *(list) --*

          Information about the authentication method used by the Client VPN endpoint.

          - *(dict) --*

            Describes the authentication methods used by a Client VPN endpoint. Client VPN supports
            Active Directory and mutual authentication. For more information, see `Authentication
            <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
            in the *AWS Client VPN Administrator Guide* .

            - **Type** *(string) --*

              The authentication type used.

            - **ActiveDirectory** *(dict) --*

              Information about the Active Directory, if applicable.

              - **DirectoryId** *(string) --*

                The ID of the Active Directory used for authentication.

            - **MutualAuthentication** *(dict) --*

              Information about the authentication certificates, if applicable.

              - **ClientRootCertificateChain** *(string) --*

                The ARN of the client certificate.

        - **ConnectionLogOptions** *(dict) --*

          Information about the client connection logging options for the Client VPN endpoint.

          - **Enabled** *(boolean) --*

            Indicates whether client connection logging is enabled for the Client VPN endpoint.

          - **CloudwatchLogGroup** *(string) --*

            The name of the Amazon CloudWatch Logs log group to which connection logging data is
            published.

          - **CloudwatchLogStream** *(string) --*

            The name of the Amazon CloudWatch Logs log stream to which connection logging data is
            published.

        - **Tags** *(list) --*

          Any tags assigned to the Client VPN endpoint.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeClientVpnRoutesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnRoutesPaginateFiltersTypeDef(
    _DescribeClientVpnRoutesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClientVpnRoutesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClientVpnRoutesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnRoutesPaginatePaginationConfigTypeDef(
    _DescribeClientVpnRoutesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClientVpnRoutesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef(
    _DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef
):
    """
    Type definition for `DescribeClientVpnRoutesPaginateResponseRoutes` `Status`

    The current state of the route.

    - **Code** *(string) --*

      The state of the Client VPN endpoint route.

    - **Message** *(string) --*

      A message about the status of the Client VPN endpoint route, if applicable.
    """


_DescribeClientVpnRoutesPaginateResponseRoutesTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseRoutesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidr": str,
        "TargetSubnet": str,
        "Type": str,
        "Origin": str,
        "Status": DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef,
        "Description": str,
    },
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseRoutesTypeDef(
    _DescribeClientVpnRoutesPaginateResponseRoutesTypeDef
):
    """
    Type definition for `DescribeClientVpnRoutesPaginateResponse` `Routes`

    Information about a Client VPN endpoint route.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the route is associated.

    - **DestinationCidr** *(string) --*

      The IPv4 address range, in CIDR notation, of the route destination.

    - **TargetSubnet** *(string) --*

      The ID of the subnet through which traffic is routed.

    - **Type** *(string) --*

      The route type.

    - **Origin** *(string) --*

      Indicates how the route was associated with the Client VPN endpoint. ``associate``
      indicates that the route was automatically added when the target network was associated
      with the Client VPN endpoint. ``add-route`` indicates that the route was manually added
      using the **CreateClientVpnRoute** action.

    - **Status** *(dict) --*

      The current state of the route.

      - **Code** *(string) --*

        The state of the Client VPN endpoint route.

      - **Message** *(string) --*

        A message about the status of the Client VPN endpoint route, if applicable.

    - **Description** *(string) --*

      A brief description of the route.
    """


_DescribeClientVpnRoutesPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseTypeDef",
    {"Routes": List[DescribeClientVpnRoutesPaginateResponseRoutesTypeDef]},
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseTypeDef(
    _DescribeClientVpnRoutesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClientVpnRoutesPaginate` `Response`

    - **Routes** *(list) --*

      Information about the Client VPN endpoint routes.

      - *(dict) --*

        Information about a Client VPN endpoint route.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the route is associated.

        - **DestinationCidr** *(string) --*

          The IPv4 address range, in CIDR notation, of the route destination.

        - **TargetSubnet** *(string) --*

          The ID of the subnet through which traffic is routed.

        - **Type** *(string) --*

          The route type.

        - **Origin** *(string) --*

          Indicates how the route was associated with the Client VPN endpoint. ``associate``
          indicates that the route was automatically added when the target network was associated
          with the Client VPN endpoint. ``add-route`` indicates that the route was manually added
          using the **CreateClientVpnRoute** action.

        - **Status** *(dict) --*

          The current state of the route.

          - **Code** *(string) --*

            The state of the Client VPN endpoint route.

          - **Message** *(string) --*

            A message about the status of the Client VPN endpoint route, if applicable.

        - **Description** *(string) --*

          A brief description of the route.
    """


_DescribeClientVpnTargetNetworksPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateFiltersTypeDef(
    _DescribeClientVpnTargetNetworksPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeClientVpnTargetNetworksPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef(
    _DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeClientVpnTargetNetworksPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef
):
    """
    Type definition for `DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworks` `Status`

    The current state of the target network association.

    - **Code** *(string) --*

      The state of the target network association.

    - **Message** *(string) --*

      A message about the status of the target network association, if applicable.
    """


_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef",
    {
        "AssociationId": str,
        "VpcId": str,
        "TargetNetworkId": str,
        "ClientVpnEndpointId": str,
        "Status": DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef,
        "SecurityGroups": List[str],
    },
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef
):
    """
    Type definition for `DescribeClientVpnTargetNetworksPaginateResponse` `ClientVpnTargetNetworks`

    Describes a target network associated with a Client VPN endpoint.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **VpcId** *(string) --*

      The ID of the VPC in which the target network (subnet) is located.

    - **TargetNetworkId** *(string) --*

      The ID of the subnet specified as the target network.

    - **ClientVpnEndpointId** *(string) --*

      The ID of the Client VPN endpoint with which the target network is associated.

    - **Status** *(dict) --*

      The current state of the target network association.

      - **Code** *(string) --*

        The state of the target network association.

      - **Message** *(string) --*

        A message about the status of the target network association, if applicable.

    - **SecurityGroups** *(list) --*

      The IDs of the security groups applied to the target network association.

      - *(string) --*
    """


_DescribeClientVpnTargetNetworksPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseTypeDef",
    {
        "ClientVpnTargetNetworks": List[
            DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseTypeDef
):
    """
    Type definition for `DescribeClientVpnTargetNetworksPaginate` `Response`

    - **ClientVpnTargetNetworks** *(list) --*

      Information about the associated target networks.

      - *(dict) --*

        Describes a target network associated with a Client VPN endpoint.

        - **AssociationId** *(string) --*

          The ID of the association.

        - **VpcId** *(string) --*

          The ID of the VPC in which the target network (subnet) is located.

        - **TargetNetworkId** *(string) --*

          The ID of the subnet specified as the target network.

        - **ClientVpnEndpointId** *(string) --*

          The ID of the Client VPN endpoint with which the target network is associated.

        - **Status** *(dict) --*

          The current state of the target network association.

          - **Code** *(string) --*

            The state of the target network association.

          - **Message** *(string) --*

            A message about the status of the target network association, if applicable.

        - **SecurityGroups** *(list) --*

          The IDs of the security groups applied to the target network association.

          - *(string) --*
    """


_DescribeDhcpOptionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeDhcpOptionsPaginateFiltersTypeDef(
    _DescribeDhcpOptionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeDhcpOptionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeDhcpOptionsPaginatePaginationConfigTypeDef(
    _DescribeDhcpOptionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurations` `Values`

    Describes a value for a resource attribute that is a String.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[
            DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
        ],
    },
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginateResponseDhcpOptions` `DhcpConfigurations`

    Describes a DHCP configuration option.

    - **Key** *(string) --*

      The name of a DHCP option.

    - **Values** *(list) --*

      One or more values for the DHCP option.

      - *(dict) --*

        Describes a value for a resource attribute that is a String.

        - **Value** *(string) --*

          The attribute value. The value is case-sensitive.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginateResponseDhcpOptions` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginateResponse` `DhcpOptions`

    Describes a set of DHCP options.

    - **DhcpConfigurations** *(list) --*

      One or more DHCP options in the set.

      - *(dict) --*

        Describes a DHCP configuration option.

        - **Key** *(string) --*

          The name of a DHCP option.

        - **Values** *(list) --*

          One or more values for the DHCP option.

          - *(dict) --*

            Describes a value for a resource attribute that is a String.

            - **Value** *(string) --*

              The attribute value. The value is case-sensitive.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the DHCP options set.

    - **Tags** *(list) --*

      Any tags assigned to the DHCP options set.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeDhcpOptionsPaginateResponseTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseTypeDef",
    {"DhcpOptions": List[DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef]},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseTypeDef(
    _DescribeDhcpOptionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeDhcpOptionsPaginate` `Response`

    - **DhcpOptions** *(list) --*

      Information about one or more DHCP options sets.

      - *(dict) --*

        Describes a set of DHCP options.

        - **DhcpConfigurations** *(list) --*

          One or more DHCP options in the set.

          - *(dict) --*

            Describes a DHCP configuration option.

            - **Key** *(string) --*

              The name of a DHCP option.

            - **Values** *(list) --*

              One or more values for the DHCP option.

              - *(dict) --*

                Describes a value for a resource attribute that is a String.

                - **Value** *(string) --*

                  The attribute value. The value is case-sensitive.

        - **DhcpOptionsId** *(string) --*

          The ID of the set of DHCP options.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the DHCP options set.

        - **Tags** *(list) --*

          Any tags assigned to the DHCP options set.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeEgressOnlyInternetGatewaysPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
):
    """
    Type definition for `DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGateways` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef",
    {
        "Attachments": List[
            DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef
):
    """
    Type definition for `DescribeEgressOnlyInternetGatewaysPaginateResponse` `EgressOnlyInternetGateways`

    Describes an egress-only internet gateway.

    - **Attachments** *(list) --*

      Information about the attachment of the egress-only internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef",
    {
        "EgressOnlyInternetGateways": List[
            DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef
        ]
    },
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef
):
    """
    Type definition for `DescribeEgressOnlyInternetGatewaysPaginate` `Response`

    - **EgressOnlyInternetGateways** *(list) --*

      Information about the egress-only internet gateways.

      - *(dict) --*

        Describes an egress-only internet gateway.

        - **Attachments** *(list) --*

          Information about the attachment of the egress-only internet gateway.

          - *(dict) --*

            Describes the attachment of a VPC to an internet gateway or an egress-only internet
            gateway.

            - **State** *(string) --*

              The current state of the attachment. For an internet gateway, the state is
              ``available`` when attached to a VPC; otherwise, this value is not returned.

            - **VpcId** *(string) --*

              The ID of the VPC.

        - **EgressOnlyInternetGatewayId** *(string) --*

          The ID of the egress-only internet gateway.
    """


_DescribeFleetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeFleetsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeFleetsPaginateFiltersTypeDef(_DescribeFleetsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeFleetsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeFleetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFleetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFleetsPaginatePaginationConfigTypeDef(
    _DescribeFleetsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeFleetsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsErrors` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the
    launch template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set
        to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
        override to use first in fulfilling On-Demand capacity. The highest priority is
        launched first. Valid values are whole numbers starting at ``0`` . The lower the
        number, the higher the priority. If no number is set, the override has the lowest
        priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsErrorsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `Errors`

    Describes the instances that could not be launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the
      launch template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a
          template name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that could not be launched was a Spot Instance or On-Demand
      Instance.

    - **ErrorCode** *(string) --*

      The error code that indicates why the instance could not be launched. For more
      information about error codes, see `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
      .

    - **ErrorMessage** *(string) --*

      The error message that describes why the instance could not be launched. For more
      information about error messages, see ee `Error Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
      .
    """


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverrides` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverrides` `Overrides`

    Any parameters that you specify override the same parameters in the launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsInstances` `LaunchTemplateAndOverrides`

    The launch templates and overrides that were used for launching the instances. Any
    parameters that you specify in the Overrides override the same parameters in the
    launch template.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(dict) --*

      Any parameters that you specify override the same parameters in the launch template.

      - **InstanceType** *(string) --*

        The instance type.

      - **MaxPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instances.

      - **AvailabilityZone** *(string) --*

        The Availability Zone in which to launch the instances.

      - **WeightedCapacity** *(float) --*

        The number of units provided by the specified instance type.

      - **Priority** *(float) --*

        The priority for the launch template override. If **AllocationStrategy** is set
        to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
        override to use first in fulfilling On-Demand capacity. The highest priority is
        launched first. Valid values are whole numbers starting at ``0`` . The lower the
        number, the higher the priority. If no number is set, the override has the lowest
        priority.

      - **Placement** *(dict) --*

        The location where the instance launched, if applicable.

        - **GroupName** *(string) --*

          The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsInstancesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": str,
        "InstanceIds": List[str],
        "InstanceType": str,
        "Platform": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `Instances`

    Describes the instances that were launched by the fleet.

    - **LaunchTemplateAndOverrides** *(dict) --*

      The launch templates and overrides that were used for launching the instances. Any
      parameters that you specify in the Overrides override the same parameters in the
      launch template.

      - **LaunchTemplateSpecification** *(dict) --*

        The launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template. You must specify either a template ID or a
          template name.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template. You must specify either a template name or a
          template ID.

        - **Version** *(string) --*

          The version number of the launch template. You must specify a version number.

      - **Overrides** *(dict) --*

        Any parameters that you specify override the same parameters in the launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

    - **Lifecycle** *(string) --*

      Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

    - **InstanceIds** *(list) --*

      The IDs of the instances.

      - *(string) --*

    - **InstanceType** *(string) --*

      The instance type.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.
    """


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a template
      name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverrides` `Placement`

    The location where the instance launched, if applicable.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **MaxPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If **AllocationStrategy** is set
      to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
      override to use first in fulfilling On-Demand capacity. The highest priority is
      launched first. Valid values are whole numbers starting at ``0`` . The lower the
      number, the higher the priority. If no number is set, the override has the lowest
      priority.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a template
        name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **MaxPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If **AllocationStrategy** is set
          to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
          override to use first in fulfilling On-Demand capacity. The highest priority is
          launched first. Valid values are whole numbers starting at ``0`` . The lower the
          number, the higher the priority. If no number is set, the override has the lowest
          priority.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.
    """


_DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef(
    _DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `OnDemandOptions`

    The allocation strategy of On-Demand Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If
      you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
      the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
      that you assigned to each launch template override, launching the highest priority
      first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all On-Demand Instances
      in the fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all On-Demand Instances into a single Availability
      Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
      capacity is not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay.
    """


_DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef",
    {
        "AllocationStrategy": str,
        "InstanceInterruptionBehavior": str,
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef(
    _DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `SpotOptions`

    The configuration of Spot Instances in an EC2 Fleet.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance
      pools specified by the EC2 Fleet.

      If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
      Spot Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
      the Spot Instance pools that you specify.

      If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
      from Spot Instance pools with optimal capacity for the number of instances that are
      launching.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only
      when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
      Spot pools and evenly allocates your target Spot capacity across the number of Spot
      pools that you specify.

    - **SingleInstanceType** *(boolean) --*

      Indicates that the fleet uses a single instance type to launch all Spot Instances in
      the fleet.

    - **SingleAvailabilityZone** *(boolean) --*

      Indicates that the fleet launches all Spot Instances into a single Availability Zone.

    - **MinTargetCapacity** *(integer) --*

      The minimum target capacity for Spot Instances in the fleet. If the minimum target
      capacity is not reached, the fleet launches no instances.

    - **MaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay.
    """


_DescribeFleetsPaginateResponseFleetsTagsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsTagsTypeDef(
    _DescribeFleetsPaginateResponseFleetsTagsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef",
    {
        "TotalTargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponseFleets` `TargetCapacitySpecification`

    The number of units to request. You can choose to set the target capacity in terms of
    instances or a performance characteristic that is important to your application workload,
    such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
    target capacity of 0 and add capacity later.

    - **TotalTargetCapacity** *(integer) --*

      The number of units to request, filled using ``DefaultTargetCapacityType`` .

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request. If you specify a target capacity for Spot
      units, you cannot specify a target capacity for On-Demand units.

    - **SpotTargetCapacity** *(integer) --*

      The maximum number of Spot units to launch. If you specify a target capacity for
      On-Demand units, you cannot specify a target capacity for Spot units.

    - **DefaultTargetCapacityType** *(string) --*

      The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .
    """


_DescribeFleetsPaginateResponseFleetsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTypeDef",
    {
        "ActivityStatus": str,
        "CreateTime": datetime,
        "FleetId": str,
        "FleetState": str,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": str,
        "FulfilledCapacity": float,
        "FulfilledOnDemandCapacity": float,
        "LaunchTemplateConfigs": List[
            DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef
        ],
        "TargetCapacitySpecification": DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef,
        "TerminateInstancesWithExpiration": bool,
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "SpotOptions": DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef,
        "OnDemandOptions": DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef,
        "Tags": List[DescribeFleetsPaginateResponseFleetsTagsTypeDef],
        "Errors": List[DescribeFleetsPaginateResponseFleetsErrorsTypeDef],
        "Instances": List[DescribeFleetsPaginateResponseFleetsInstancesTypeDef],
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsTypeDef(
    _DescribeFleetsPaginateResponseFleetsTypeDef
):
    """
    Type definition for `DescribeFleetsPaginateResponse` `Fleets`

    Describes an EC2 Fleet.

    - **ActivityStatus** *(string) --*

      The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
      requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2 Fleet
      is equal to or greater than its target capacity, the status is ``fulfilled`` . If the
      size of the EC2 Fleet is decreased, the status is ``pending_termination`` while instances
      are terminating.

    - **CreateTime** *(datetime) --*

      The creation date and time of the EC2 Fleet.

    - **FleetId** *(string) --*

      The ID of the EC2 Fleet.

    - **FleetState** *(string) --*

      The state of the EC2 Fleet.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
      For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

      Constraints: Maximum 64 ASCII characters

    - **ExcessCapacityTerminationPolicy** *(string) --*

      Indicates whether running instances should be terminated if the target capacity of the
      EC2 Fleet is decreased below the current size of the EC2 Fleet.

    - **FulfilledCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target capacity.

    - **FulfilledOnDemandCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target On-Demand
      capacity.

    - **LaunchTemplateConfigs** *(list) --*

      The launch template and overrides.

      - *(dict) --*

        Describes a launch template and overrides.

        - **LaunchTemplateSpecification** *(dict) --*

          The launch template.

          - **LaunchTemplateId** *(string) --*

            The ID of the launch template. You must specify either a template ID or a template
            name.

          - **LaunchTemplateName** *(string) --*

            The name of the launch template. You must specify either a template name or a
            template ID.

          - **Version** *(string) --*

            The version number of the launch template. You must specify a version number.

        - **Overrides** *(list) --*

          Any parameters that you specify override the same parameters in the launch template.

          - *(dict) --*

            Describes overrides for a launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

    - **TargetCapacitySpecification** *(dict) --*

      The number of units to request. You can choose to set the target capacity in terms of
      instances or a performance characteristic that is important to your application workload,
      such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
      target capacity of 0 and add capacity later.

      - **TotalTargetCapacity** *(integer) --*

        The number of units to request, filled using ``DefaultTargetCapacityType`` .

      - **OnDemandTargetCapacity** *(integer) --*

        The number of On-Demand units to request. If you specify a target capacity for Spot
        units, you cannot specify a target capacity for On-Demand units.

      - **SpotTargetCapacity** *(integer) --*

        The maximum number of Spot units to launch. If you specify a target capacity for
        On-Demand units, you cannot specify a target capacity for Spot units.

      - **DefaultTargetCapacityType** *(string) --*

        The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .

    - **TerminateInstancesWithExpiration** *(boolean) --*

      Indicates whether running instances should be terminated when the EC2 Fleet expires.

    - **Type** *(string) --*

      The type of request. Indicates whether the EC2 Fleet only ``requests`` the target
      capacity, or also attempts to ``maintain`` it. If you request a certain target capacity,
      EC2 Fleet only places the required requests; it does not attempt to replenish instances
      if capacity is diminished, and does not submit requests in alternative capacity pools if
      capacity is unavailable. To maintain a certain target capacity, EC2 Fleet places the
      required requests to meet this target capacity. It also automatically replenishes any
      interrupted Spot Instances. Default: ``maintain`` .

    - **ValidFrom** *(datetime) --*

      The start date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z). The default is to start fulfilling the request immediately.

    - **ValidUntil** *(datetime) --*

      The end date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z). At this point, no new instance requests are placed or able to
      fulfill the request. The default end date is 7 days from the current date.

    - **ReplaceUnhealthyInstances** *(boolean) --*

      Indicates whether EC2 Fleet should replace unhealthy instances.

    - **SpotOptions** *(dict) --*

      The configuration of Spot Instances in an EC2 Fleet.

      - **AllocationStrategy** *(string) --*

        Indicates how to allocate the target Spot Instance capacity across the Spot Instance
        pools specified by the EC2 Fleet.

        If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
        Spot Instance pools with the lowest price. This is the default allocation strategy.

        If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
        the Spot Instance pools that you specify.

        If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
        from Spot Instance pools with optimal capacity for the number of instances that are
        launching.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

      - **InstancePoolsToUseCount** *(integer) --*

        The number of Spot pools across which to allocate your target Spot capacity. Valid only
        when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
        Spot pools and evenly allocates your target Spot capacity across the number of Spot
        pools that you specify.

      - **SingleInstanceType** *(boolean) --*

        Indicates that the fleet uses a single instance type to launch all Spot Instances in
        the fleet.

      - **SingleAvailabilityZone** *(boolean) --*

        Indicates that the fleet launches all Spot Instances into a single Availability Zone.

      - **MinTargetCapacity** *(integer) --*

        The minimum target capacity for Spot Instances in the fleet. If the minimum target
        capacity is not reached, the fleet launches no instances.

      - **MaxTotalPrice** *(string) --*

        The maximum amount per hour for Spot Instances that you're willing to pay.

    - **OnDemandOptions** *(dict) --*

      The allocation strategy of On-Demand Instances in an EC2 Fleet.

      - **AllocationStrategy** *(string) --*

        The order of the launch template overrides to use in fulfilling On-Demand capacity. If
        you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
        the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
        that you assigned to each launch template override, launching the highest priority
        first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

      - **SingleInstanceType** *(boolean) --*

        Indicates that the fleet uses a single instance type to launch all On-Demand Instances
        in the fleet.

      - **SingleAvailabilityZone** *(boolean) --*

        Indicates that the fleet launches all On-Demand Instances into a single Availability
        Zone.

      - **MinTargetCapacity** *(integer) --*

        The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
        capacity is not reached, the fleet launches no instances.

      - **MaxTotalPrice** *(string) --*

        The maximum amount per hour for On-Demand Instances that you're willing to pay.

    - **Tags** *(list) --*

      The tags for an EC2 Fleet resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Errors** *(list) --*

      Information about the instances that could not be launched by the fleet. Valid only when
      **Type** is set to ``instant`` .

      - *(dict) --*

        Describes the instances that could not be launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the
          launch template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that could not be launched was a Spot Instance or On-Demand
          Instance.

        - **ErrorCode** *(string) --*

          The error code that indicates why the instance could not be launched. For more
          information about error codes, see `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
          .

        - **ErrorMessage** *(string) --*

          The error message that describes why the instance could not be launched. For more
          information about error messages, see ee `Error Codes
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
          .

    - **Instances** *(list) --*

      Information about the instances that were launched by the fleet. Valid only when **Type**
      is set to ``instant`` .

      - *(dict) --*

        Describes the instances that were launched by the fleet.

        - **LaunchTemplateAndOverrides** *(dict) --*

          The launch templates and overrides that were used for launching the instances. Any
          parameters that you specify in the Overrides override the same parameters in the
          launch template.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(dict) --*

            Any parameters that you specify override the same parameters in the launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **MaxPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If **AllocationStrategy** is set
              to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
              override to use first in fulfilling On-Demand capacity. The highest priority is
              launched first. Valid values are whole numbers starting at ``0`` . The lower the
              number, the higher the priority. If no number is set, the override has the lowest
              priority.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

        - **Lifecycle** *(string) --*

          Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

        - **InstanceIds** *(list) --*

          The IDs of the instances.

          - *(string) --*

        - **InstanceType** *(string) --*

          The instance type.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.
    """


_DescribeFleetsPaginateResponseTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseTypeDef",
    {"Fleets": List[DescribeFleetsPaginateResponseFleetsTypeDef]},
    total=False,
)


class DescribeFleetsPaginateResponseTypeDef(_DescribeFleetsPaginateResponseTypeDef):
    """
    Type definition for `DescribeFleetsPaginate` `Response`

    - **Fleets** *(list) --*

      Information about the EC2 Fleets.

      - *(dict) --*

        Describes an EC2 Fleet.

        - **ActivityStatus** *(string) --*

          The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
          requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2 Fleet
          is equal to or greater than its target capacity, the status is ``fulfilled`` . If the
          size of the EC2 Fleet is decreased, the status is ``pending_termination`` while instances
          are terminating.

        - **CreateTime** *(datetime) --*

          The creation date and time of the EC2 Fleet.

        - **FleetId** *(string) --*

          The ID of the EC2 Fleet.

        - **FleetState** *(string) --*

          The state of the EC2 Fleet.

        - **ClientToken** *(string) --*

          Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
          For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

          Constraints: Maximum 64 ASCII characters

        - **ExcessCapacityTerminationPolicy** *(string) --*

          Indicates whether running instances should be terminated if the target capacity of the
          EC2 Fleet is decreased below the current size of the EC2 Fleet.

        - **FulfilledCapacity** *(float) --*

          The number of units fulfilled by this request compared to the set target capacity.

        - **FulfilledOnDemandCapacity** *(float) --*

          The number of units fulfilled by this request compared to the set target On-Demand
          capacity.

        - **LaunchTemplateConfigs** *(list) --*

          The launch template and overrides.

          - *(dict) --*

            Describes a launch template and overrides.

            - **LaunchTemplateSpecification** *(dict) --*

              The launch template.

              - **LaunchTemplateId** *(string) --*

                The ID of the launch template. You must specify either a template ID or a template
                name.

              - **LaunchTemplateName** *(string) --*

                The name of the launch template. You must specify either a template name or a
                template ID.

              - **Version** *(string) --*

                The version number of the launch template. You must specify a version number.

            - **Overrides** *(list) --*

              Any parameters that you specify override the same parameters in the launch template.

              - *(dict) --*

                Describes overrides for a launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

        - **TargetCapacitySpecification** *(dict) --*

          The number of units to request. You can choose to set the target capacity in terms of
          instances or a performance characteristic that is important to your application workload,
          such as vCPUs, memory, or I/O. If the request type is ``maintain`` , you can specify a
          target capacity of 0 and add capacity later.

          - **TotalTargetCapacity** *(integer) --*

            The number of units to request, filled using ``DefaultTargetCapacityType`` .

          - **OnDemandTargetCapacity** *(integer) --*

            The number of On-Demand units to request. If you specify a target capacity for Spot
            units, you cannot specify a target capacity for On-Demand units.

          - **SpotTargetCapacity** *(integer) --*

            The maximum number of Spot units to launch. If you specify a target capacity for
            On-Demand units, you cannot specify a target capacity for Spot units.

          - **DefaultTargetCapacityType** *(string) --*

            The default ``TotalTargetCapacity`` , which is either ``Spot`` or ``On-Demand`` .

        - **TerminateInstancesWithExpiration** *(boolean) --*

          Indicates whether running instances should be terminated when the EC2 Fleet expires.

        - **Type** *(string) --*

          The type of request. Indicates whether the EC2 Fleet only ``requests`` the target
          capacity, or also attempts to ``maintain`` it. If you request a certain target capacity,
          EC2 Fleet only places the required requests; it does not attempt to replenish instances
          if capacity is diminished, and does not submit requests in alternative capacity pools if
          capacity is unavailable. To maintain a certain target capacity, EC2 Fleet places the
          required requests to meet this target capacity. It also automatically replenishes any
          interrupted Spot Instances. Default: ``maintain`` .

        - **ValidFrom** *(datetime) --*

          The start date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z). The default is to start fulfilling the request immediately.

        - **ValidUntil** *(datetime) --*

          The end date and time of the request, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z). At this point, no new instance requests are placed or able to
          fulfill the request. The default end date is 7 days from the current date.

        - **ReplaceUnhealthyInstances** *(boolean) --*

          Indicates whether EC2 Fleet should replace unhealthy instances.

        - **SpotOptions** *(dict) --*

          The configuration of Spot Instances in an EC2 Fleet.

          - **AllocationStrategy** *(string) --*

            Indicates how to allocate the target Spot Instance capacity across the Spot Instance
            pools specified by the EC2 Fleet.

            If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the
            Spot Instance pools with the lowest price. This is the default allocation strategy.

            If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all
            the Spot Instance pools that you specify.

            If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances
            from Spot Instance pools with optimal capacity for the number of instances that are
            launching.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

          - **InstancePoolsToUseCount** *(integer) --*

            The number of Spot pools across which to allocate your target Spot capacity. Valid only
            when **AllocationStrategy** is set to ``lowest-price`` . EC2 Fleet selects the cheapest
            Spot pools and evenly allocates your target Spot capacity across the number of Spot
            pools that you specify.

          - **SingleInstanceType** *(boolean) --*

            Indicates that the fleet uses a single instance type to launch all Spot Instances in
            the fleet.

          - **SingleAvailabilityZone** *(boolean) --*

            Indicates that the fleet launches all Spot Instances into a single Availability Zone.

          - **MinTargetCapacity** *(integer) --*

            The minimum target capacity for Spot Instances in the fleet. If the minimum target
            capacity is not reached, the fleet launches no instances.

          - **MaxTotalPrice** *(string) --*

            The maximum amount per hour for Spot Instances that you're willing to pay.

        - **OnDemandOptions** *(dict) --*

          The allocation strategy of On-Demand Instances in an EC2 Fleet.

          - **AllocationStrategy** *(string) --*

            The order of the launch template overrides to use in fulfilling On-Demand capacity. If
            you specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching
            the lowest price first. If you specify ``prioritized`` , EC2 Fleet uses the priority
            that you assigned to each launch template override, launching the highest priority
            first. If you do not specify a value, EC2 Fleet defaults to ``lowest-price`` .

          - **SingleInstanceType** *(boolean) --*

            Indicates that the fleet uses a single instance type to launch all On-Demand Instances
            in the fleet.

          - **SingleAvailabilityZone** *(boolean) --*

            Indicates that the fleet launches all On-Demand Instances into a single Availability
            Zone.

          - **MinTargetCapacity** *(integer) --*

            The minimum target capacity for On-Demand Instances in the fleet. If the minimum target
            capacity is not reached, the fleet launches no instances.

          - **MaxTotalPrice** *(string) --*

            The maximum amount per hour for On-Demand Instances that you're willing to pay.

        - **Tags** *(list) --*

          The tags for an EC2 Fleet resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Errors** *(list) --*

          Information about the instances that could not be launched by the fleet. Valid only when
          **Type** is set to ``instant`` .

          - *(dict) --*

            Describes the instances that could not be launched by the fleet.

            - **LaunchTemplateAndOverrides** *(dict) --*

              The launch templates and overrides that were used for launching the instances. Any
              parameters that you specify in the Overrides override the same parameters in the
              launch template.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(dict) --*

                Any parameters that you specify override the same parameters in the launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

            - **Lifecycle** *(string) --*

              Indicates if the instance that could not be launched was a Spot Instance or On-Demand
              Instance.

            - **ErrorCode** *(string) --*

              The error code that indicates why the instance could not be launched. For more
              information about error codes, see `Error Codes
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
              .

            - **ErrorMessage** *(string) --*

              The error message that describes why the instance could not be launched. For more
              information about error messages, see ee `Error Codes
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html>`__
              .

        - **Instances** *(list) --*

          Information about the instances that were launched by the fleet. Valid only when **Type**
          is set to ``instant`` .

          - *(dict) --*

            Describes the instances that were launched by the fleet.

            - **LaunchTemplateAndOverrides** *(dict) --*

              The launch templates and overrides that were used for launching the instances. Any
              parameters that you specify in the Overrides override the same parameters in the
              launch template.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(dict) --*

                Any parameters that you specify override the same parameters in the launch template.

                - **InstanceType** *(string) --*

                  The instance type.

                - **MaxPrice** *(string) --*

                  The maximum price per unit hour that you are willing to pay for a Spot Instance.

                - **SubnetId** *(string) --*

                  The ID of the subnet in which to launch the instances.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone in which to launch the instances.

                - **WeightedCapacity** *(float) --*

                  The number of units provided by the specified instance type.

                - **Priority** *(float) --*

                  The priority for the launch template override. If **AllocationStrategy** is set
                  to ``prioritized`` , EC2 Fleet uses priority to determine which launch template
                  override to use first in fulfilling On-Demand capacity. The highest priority is
                  launched first. Valid values are whole numbers starting at ``0`` . The lower the
                  number, the higher the priority. If no number is set, the override has the lowest
                  priority.

                - **Placement** *(dict) --*

                  The location where the instance launched, if applicable.

                  - **GroupName** *(string) --*

                    The name of the placement group the instance is in.

            - **Lifecycle** *(string) --*

              Indicates if the instance that was launched is a Spot Instance or On-Demand Instance.

            - **InstanceIds** *(list) --*

              The IDs of the instances.

              - *(string) --*

            - **InstanceType** *(string) --*

              The instance type.

            - **Platform** *(string) --*

              The value is ``Windows`` for Windows instances; otherwise blank.
    """


_DescribeFlowLogsPaginateFiltersTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeFlowLogsPaginateFiltersTypeDef(_DescribeFlowLogsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeFlowLogsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeFlowLogsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFlowLogsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFlowLogsPaginatePaginationConfigTypeDef(
    _DescribeFlowLogsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeFlowLogsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeFlowLogsPaginateResponseFlowLogsTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateResponseFlowLogsTypeDef",
    {
        "CreationTime": datetime,
        "DeliverLogsErrorMessage": str,
        "DeliverLogsPermissionArn": str,
        "DeliverLogsStatus": str,
        "FlowLogId": str,
        "FlowLogStatus": str,
        "LogGroupName": str,
        "ResourceId": str,
        "TrafficType": str,
        "LogDestinationType": str,
        "LogDestination": str,
        "LogFormat": str,
    },
    total=False,
)


class DescribeFlowLogsPaginateResponseFlowLogsTypeDef(
    _DescribeFlowLogsPaginateResponseFlowLogsTypeDef
):
    """
    Type definition for `DescribeFlowLogsPaginateResponse` `FlowLogs`

    Describes a flow log.

    - **CreationTime** *(datetime) --*

      The date and time the flow log was created.

    - **DeliverLogsErrorMessage** *(string) --*

      Information about the error that occurred. ``Rate limited`` indicates that CloudWatch
      Logs throttling has been applied for one or more network interfaces, or that you've
      reached the limit on the number of log groups that you can create. ``Access error``
      indicates that the IAM role associated with the flow log does not have sufficient
      permissions to publish to CloudWatch Logs. ``Unknown error`` indicates an internal error.

    - **DeliverLogsPermissionArn** *(string) --*

      The ARN of the IAM role that posts logs to CloudWatch Logs.

    - **DeliverLogsStatus** *(string) --*

      The status of the logs delivery (``SUCCESS`` | ``FAILED`` ).

    - **FlowLogId** *(string) --*

      The flow log ID.

    - **FlowLogStatus** *(string) --*

      The status of the flow log (``ACTIVE`` ).

    - **LogGroupName** *(string) --*

      The name of the flow log group.

    - **ResourceId** *(string) --*

      The ID of the resource on which the flow log was created.

    - **TrafficType** *(string) --*

      The type of traffic captured for the flow log.

    - **LogDestinationType** *(string) --*

      Specifies the type of destination to which the flow log data is published. Flow log data
      can be published to CloudWatch Logs or Amazon S3.

    - **LogDestination** *(string) --*

      Specifies the destination to which the flow log data is published. Flow log data can be
      published to an CloudWatch Logs log group or an Amazon S3 bucket. If the flow log
      publishes to CloudWatch Logs, this element indicates the Amazon Resource Name (ARN) of
      the CloudWatch Logs log group to which the data is published. If the flow log publishes
      to Amazon S3, this element indicates the ARN of the Amazon S3 bucket to which the data is
      published.

    - **LogFormat** *(string) --*

      The format of the flow log record.
    """


_DescribeFlowLogsPaginateResponseTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateResponseTypeDef",
    {"FlowLogs": List[DescribeFlowLogsPaginateResponseFlowLogsTypeDef]},
    total=False,
)


class DescribeFlowLogsPaginateResponseTypeDef(_DescribeFlowLogsPaginateResponseTypeDef):
    """
    Type definition for `DescribeFlowLogsPaginate` `Response`

    - **FlowLogs** *(list) --*

      Information about the flow logs.

      - *(dict) --*

        Describes a flow log.

        - **CreationTime** *(datetime) --*

          The date and time the flow log was created.

        - **DeliverLogsErrorMessage** *(string) --*

          Information about the error that occurred. ``Rate limited`` indicates that CloudWatch
          Logs throttling has been applied for one or more network interfaces, or that you've
          reached the limit on the number of log groups that you can create. ``Access error``
          indicates that the IAM role associated with the flow log does not have sufficient
          permissions to publish to CloudWatch Logs. ``Unknown error`` indicates an internal error.

        - **DeliverLogsPermissionArn** *(string) --*

          The ARN of the IAM role that posts logs to CloudWatch Logs.

        - **DeliverLogsStatus** *(string) --*

          The status of the logs delivery (``SUCCESS`` | ``FAILED`` ).

        - **FlowLogId** *(string) --*

          The flow log ID.

        - **FlowLogStatus** *(string) --*

          The status of the flow log (``ACTIVE`` ).

        - **LogGroupName** *(string) --*

          The name of the flow log group.

        - **ResourceId** *(string) --*

          The ID of the resource on which the flow log was created.

        - **TrafficType** *(string) --*

          The type of traffic captured for the flow log.

        - **LogDestinationType** *(string) --*

          Specifies the type of destination to which the flow log data is published. Flow log data
          can be published to CloudWatch Logs or Amazon S3.

        - **LogDestination** *(string) --*

          Specifies the destination to which the flow log data is published. Flow log data can be
          published to an CloudWatch Logs log group or an Amazon S3 bucket. If the flow log
          publishes to CloudWatch Logs, this element indicates the Amazon Resource Name (ARN) of
          the CloudWatch Logs log group to which the data is published. If the flow log publishes
          to Amazon S3, this element indicates the ARN of the Amazon S3 bucket to which the data is
          published.

        - **LogFormat** *(string) --*

          The format of the flow log record.
    """


_DescribeFpgaImagesPaginateFiltersTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeFpgaImagesPaginateFiltersTypeDef(
    _DescribeFpgaImagesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeFpgaImagesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFpgaImagesPaginatePaginationConfigTypeDef(
    _DescribeFpgaImagesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef",
    {"DeviceId": str, "VendorId": str, "SubsystemId": str, "SubsystemVendorId": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginateResponseFpgaImages` `PciId`

    Information about the PCI bus.

    - **DeviceId** *(string) --*

      The ID of the device.

    - **VendorId** *(string) --*

      The ID of the vendor.

    - **SubsystemId** *(string) --*

      The ID of the subsystem.

    - **SubsystemVendorId** *(string) --*

      The ID of the vendor for the subsystem.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginateResponseFpgaImages` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginateResponseFpgaImages` `State`

    Information about the state of the AFI.

    - **Code** *(string) --*

      The state. The following are the possible values:

      * ``pending`` - AFI bitstream generation is in progress.

      * ``available`` - The AFI is available for use.

      * ``failed`` - AFI bitstream generation failed.

      * ``unavailable`` - The AFI is no longer available for use.

    - **Message** *(string) --*

      If the state is ``failed`` , this is the error message.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginateResponseFpgaImages` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "Name": str,
        "Description": str,
        "ShellVersion": str,
        "PciId": DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef,
        "State": DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef,
        "CreateTime": datetime,
        "UpdateTime": datetime,
        "OwnerId": str,
        "OwnerAlias": str,
        "ProductCodes": List[
            DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef
        ],
        "Tags": List[DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef],
        "Public": bool,
        "DataRetentionSupport": bool,
    },
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginateResponse` `FpgaImages`

    Describes an Amazon FPGA image (AFI).

    - **FpgaImageId** *(string) --*

      The FPGA image identifier (AFI ID).

    - **FpgaImageGlobalId** *(string) --*

      The global FPGA image identifier (AGFI ID).

    - **Name** *(string) --*

      The name of the AFI.

    - **Description** *(string) --*

      The description of the AFI.

    - **ShellVersion** *(string) --*

      The version of the AWS Shell that was used to create the bitstream.

    - **PciId** *(dict) --*

      Information about the PCI bus.

      - **DeviceId** *(string) --*

        The ID of the device.

      - **VendorId** *(string) --*

        The ID of the vendor.

      - **SubsystemId** *(string) --*

        The ID of the subsystem.

      - **SubsystemVendorId** *(string) --*

        The ID of the vendor for the subsystem.

    - **State** *(dict) --*

      Information about the state of the AFI.

      - **Code** *(string) --*

        The state. The following are the possible values:

        * ``pending`` - AFI bitstream generation is in progress.

        * ``available`` - The AFI is available for use.

        * ``failed`` - AFI bitstream generation failed.

        * ``unavailable`` - The AFI is no longer available for use.

      - **Message** *(string) --*

        If the state is ``failed`` , this is the error message.

    - **CreateTime** *(datetime) --*

      The date and time the AFI was created.

    - **UpdateTime** *(datetime) --*

      The time of the most recent update to the AFI.

    - **OwnerId** *(string) --*

      The AWS account ID of the AFI owner.

    - **OwnerAlias** *(string) --*

      The alias of the AFI owner. Possible values include ``self`` , ``amazon`` , and
      ``aws-marketplace`` .

    - **ProductCodes** *(list) --*

      The product codes for the AFI.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **Tags** *(list) --*

      Any tags assigned to the AFI.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Public** *(boolean) --*

      Indicates whether the AFI is public.

    - **DataRetentionSupport** *(boolean) --*

      Indicates whether data retention support is enabled for the AFI.
    """


_DescribeFpgaImagesPaginateResponseTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseTypeDef",
    {"FpgaImages": List[DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef]},
    total=False,
)


class DescribeFpgaImagesPaginateResponseTypeDef(
    _DescribeFpgaImagesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeFpgaImagesPaginate` `Response`

    - **FpgaImages** *(list) --*

      Information about the FPGA images.

      - *(dict) --*

        Describes an Amazon FPGA image (AFI).

        - **FpgaImageId** *(string) --*

          The FPGA image identifier (AFI ID).

        - **FpgaImageGlobalId** *(string) --*

          The global FPGA image identifier (AGFI ID).

        - **Name** *(string) --*

          The name of the AFI.

        - **Description** *(string) --*

          The description of the AFI.

        - **ShellVersion** *(string) --*

          The version of the AWS Shell that was used to create the bitstream.

        - **PciId** *(dict) --*

          Information about the PCI bus.

          - **DeviceId** *(string) --*

            The ID of the device.

          - **VendorId** *(string) --*

            The ID of the vendor.

          - **SubsystemId** *(string) --*

            The ID of the subsystem.

          - **SubsystemVendorId** *(string) --*

            The ID of the vendor for the subsystem.

        - **State** *(dict) --*

          Information about the state of the AFI.

          - **Code** *(string) --*

            The state. The following are the possible values:

            * ``pending`` - AFI bitstream generation is in progress.

            * ``available`` - The AFI is available for use.

            * ``failed`` - AFI bitstream generation failed.

            * ``unavailable`` - The AFI is no longer available for use.

          - **Message** *(string) --*

            If the state is ``failed`` , this is the error message.

        - **CreateTime** *(datetime) --*

          The date and time the AFI was created.

        - **UpdateTime** *(datetime) --*

          The time of the most recent update to the AFI.

        - **OwnerId** *(string) --*

          The AWS account ID of the AFI owner.

        - **OwnerAlias** *(string) --*

          The alias of the AFI owner. Possible values include ``self`` , ``amazon`` , and
          ``aws-marketplace`` .

        - **ProductCodes** *(list) --*

          The product codes for the AFI.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **Tags** *(list) --*

          Any tags assigned to the AFI.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Public** *(boolean) --*

          Indicates whether the AFI is public.

        - **DataRetentionSupport** *(boolean) --*

          Indicates whether data retention support is enabled for the AFI.
    """


_DescribeHostReservationOfferingsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeHostReservationOfferingsPaginateFiltersTypeDef(
    _DescribeHostReservationOfferingsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeHostReservationOfferingsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef(
    _DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeHostReservationOfferingsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": str,
        "UpfrontPrice": str,
    },
    total=False,
)


class DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef(
    _DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef
):
    """
    Type definition for `DescribeHostReservationOfferingsPaginateResponse` `OfferingSet`

    Details about the Dedicated Host Reservation offering.

    - **CurrencyCode** *(string) --*

      The currency of the offering.

    - **Duration** *(integer) --*

      The duration of the offering (in seconds).

    - **HourlyPrice** *(string) --*

      The hourly price of the offering.

    - **InstanceFamily** *(string) --*

      The instance family of the offering.

    - **OfferingId** *(string) --*

      The ID of the offering.

    - **PaymentOption** *(string) --*

      The available payment option.

    - **UpfrontPrice** *(string) --*

      The upfront price of the offering. Does not apply to No Upfront offerings.
    """


_DescribeHostReservationOfferingsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateResponseTypeDef",
    {
        "OfferingSet": List[
            DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef
        ]
    },
    total=False,
)


class DescribeHostReservationOfferingsPaginateResponseTypeDef(
    _DescribeHostReservationOfferingsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeHostReservationOfferingsPaginate` `Response`

    - **OfferingSet** *(list) --*

      Information about the offerings.

      - *(dict) --*

        Details about the Dedicated Host Reservation offering.

        - **CurrencyCode** *(string) --*

          The currency of the offering.

        - **Duration** *(integer) --*

          The duration of the offering (in seconds).

        - **HourlyPrice** *(string) --*

          The hourly price of the offering.

        - **InstanceFamily** *(string) --*

          The instance family of the offering.

        - **OfferingId** *(string) --*

          The ID of the offering.

        - **PaymentOption** *(string) --*

          The available payment option.

        - **UpfrontPrice** *(string) --*

          The upfront price of the offering. Does not apply to No Upfront offerings.
    """


_DescribeHostReservationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeHostReservationsPaginateFiltersTypeDef(
    _DescribeHostReservationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeHostReservationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeHostReservationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostReservationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostReservationsPaginatePaginationConfigTypeDef(
    _DescribeHostReservationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeHostReservationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef(
    _DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef
):
    """
    Type definition for `DescribeHostReservationsPaginateResponseHostReservationSet` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeHostReservationsPaginateResponseHostReservationSetTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseHostReservationSetTypeDef",
    {
        "Count": int,
        "CurrencyCode": str,
        "Duration": int,
        "End": datetime,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": str,
        "Start": datetime,
        "State": str,
        "UpfrontPrice": str,
        "Tags": List[
            DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef
        ],
    },
    total=False,
)


class DescribeHostReservationsPaginateResponseHostReservationSetTypeDef(
    _DescribeHostReservationsPaginateResponseHostReservationSetTypeDef
):
    """
    Type definition for `DescribeHostReservationsPaginateResponse` `HostReservationSet`

    Details about the Dedicated Host Reservation and associated Dedicated Hosts.

    - **Count** *(integer) --*

      The number of Dedicated Hosts the reservation is associated with.

    - **CurrencyCode** *(string) --*

      The currency in which the ``upfrontPrice`` and ``hourlyPrice`` amounts are specified. At
      this time, the only supported currency is ``USD`` .

    - **Duration** *(integer) --*

      The length of the reservation's term, specified in seconds. Can be ``31536000 (1 year)``
      | ``94608000 (3 years)`` .

    - **End** *(datetime) --*

      The date and time that the reservation ends.

    - **HostIdSet** *(list) --*

      The IDs of the Dedicated Hosts associated with the reservation.

      - *(string) --*

    - **HostReservationId** *(string) --*

      The ID of the reservation that specifies the associated Dedicated Hosts.

    - **HourlyPrice** *(string) --*

      The hourly price of the reservation.

    - **InstanceFamily** *(string) --*

      The instance family of the Dedicated Host Reservation. The instance family on the
      Dedicated Host must be the same in order for it to benefit from the reservation.

    - **OfferingId** *(string) --*

      The ID of the reservation. This remains the same regardless of which Dedicated Hosts are
      associated with it.

    - **PaymentOption** *(string) --*

      The payment option selected for this reservation.

    - **Start** *(datetime) --*

      The date and time that the reservation started.

    - **State** *(string) --*

      The state of the reservation.

    - **UpfrontPrice** *(string) --*

      The upfront price of the reservation.

    - **Tags** *(list) --*

      Any tags assigned to the Dedicated Host Reservation.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeHostReservationsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseTypeDef",
    {
        "HostReservationSet": List[
            DescribeHostReservationsPaginateResponseHostReservationSetTypeDef
        ]
    },
    total=False,
)


class DescribeHostReservationsPaginateResponseTypeDef(
    _DescribeHostReservationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeHostReservationsPaginate` `Response`

    - **HostReservationSet** *(list) --*

      Details about the reservation's configuration.

      - *(dict) --*

        Details about the Dedicated Host Reservation and associated Dedicated Hosts.

        - **Count** *(integer) --*

          The number of Dedicated Hosts the reservation is associated with.

        - **CurrencyCode** *(string) --*

          The currency in which the ``upfrontPrice`` and ``hourlyPrice`` amounts are specified. At
          this time, the only supported currency is ``USD`` .

        - **Duration** *(integer) --*

          The length of the reservation's term, specified in seconds. Can be ``31536000 (1 year)``
          | ``94608000 (3 years)`` .

        - **End** *(datetime) --*

          The date and time that the reservation ends.

        - **HostIdSet** *(list) --*

          The IDs of the Dedicated Hosts associated with the reservation.

          - *(string) --*

        - **HostReservationId** *(string) --*

          The ID of the reservation that specifies the associated Dedicated Hosts.

        - **HourlyPrice** *(string) --*

          The hourly price of the reservation.

        - **InstanceFamily** *(string) --*

          The instance family of the Dedicated Host Reservation. The instance family on the
          Dedicated Host must be the same in order for it to benefit from the reservation.

        - **OfferingId** *(string) --*

          The ID of the reservation. This remains the same regardless of which Dedicated Hosts are
          associated with it.

        - **PaymentOption** *(string) --*

          The payment option selected for this reservation.

        - **Start** *(datetime) --*

          The date and time that the reservation started.

        - **State** *(string) --*

          The state of the reservation.

        - **UpfrontPrice** *(string) --*

          The upfront price of the reservation.

        - **Tags** *(list) --*

          Any tags assigned to the Dedicated Host Reservation.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeHostsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeHostsPaginateFiltersTypeDef(_DescribeHostsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeHostsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeHostsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostsPaginatePaginationConfigTypeDef(
    _DescribeHostsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeHostsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    {"AvailableCapacity": int, "InstanceType": str, "TotalCapacity": int},
    total=False,
)


class DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef(
    _DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponseHostsAvailableCapacity` `AvailableInstanceCapacity`

    Information about the instance type that the Dedicated Host supports.

    - **AvailableCapacity** *(integer) --*

      The number of instances that can still be launched onto the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size supported by the Dedicated Host.

    - **TotalCapacity** *(integer) --*

      The total number of instances that can be launched onto the Dedicated Host.
    """


_DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef",
    {
        "AvailableInstanceCapacity": List[
            DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
        ],
        "AvailableVCpus": int,
    },
    total=False,
)


class DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef(
    _DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponseHosts` `AvailableCapacity`

    The number of new instances that can be launched onto the Dedicated Host.

    - **AvailableInstanceCapacity** *(list) --*

      The total number of instances supported by the Dedicated Host.

      - *(dict) --*

        Information about the instance type that the Dedicated Host supports.

        - **AvailableCapacity** *(integer) --*

          The number of instances that can still be launched onto the Dedicated Host.

        - **InstanceType** *(string) --*

          The instance type size supported by the Dedicated Host.

        - **TotalCapacity** *(integer) --*

          The total number of instances that can be launched onto the Dedicated Host.

    - **AvailableVCpus** *(integer) --*

      The number of vCPUs available on the Dedicated Host.
    """


_DescribeHostsPaginateResponseHostsHostPropertiesTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsHostPropertiesTypeDef",
    {"Cores": int, "InstanceType": str, "Sockets": int, "TotalVCpus": int},
    total=False,
)


class DescribeHostsPaginateResponseHostsHostPropertiesTypeDef(
    _DescribeHostsPaginateResponseHostsHostPropertiesTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponseHosts` `HostProperties`

    The hardware specifications of the Dedicated Host.

    - **Cores** *(integer) --*

      The number of cores on the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

    - **Sockets** *(integer) --*

      The number of sockets on the Dedicated Host.

    - **TotalVCpus** *(integer) --*

      The number of vCPUs on the Dedicated Host.
    """


_DescribeHostsPaginateResponseHostsInstancesTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsInstancesTypeDef",
    {"InstanceId": str, "InstanceType": str},
    total=False,
)


class DescribeHostsPaginateResponseHostsInstancesTypeDef(
    _DescribeHostsPaginateResponseHostsInstancesTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponseHosts` `Instances`

    Describes an instance running on a Dedicated Host.

    - **InstanceId** *(string) --*

      the IDs of instances that are running on the Dedicated Host.

    - **InstanceType** *(string) --*

      The instance type size (for example, ``m3.medium`` ) of the running instance.
    """


_DescribeHostsPaginateResponseHostsTagsTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeHostsPaginateResponseHostsTagsTypeDef(
    _DescribeHostsPaginateResponseHostsTagsTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponseHosts` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeHostsPaginateResponseHostsTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsTypeDef",
    {
        "AutoPlacement": str,
        "AvailabilityZone": str,
        "AvailableCapacity": DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef,
        "ClientToken": str,
        "HostId": str,
        "HostProperties": DescribeHostsPaginateResponseHostsHostPropertiesTypeDef,
        "HostReservationId": str,
        "Instances": List[DescribeHostsPaginateResponseHostsInstancesTypeDef],
        "State": str,
        "AllocationTime": datetime,
        "ReleaseTime": datetime,
        "Tags": List[DescribeHostsPaginateResponseHostsTagsTypeDef],
        "HostRecovery": str,
    },
    total=False,
)


class DescribeHostsPaginateResponseHostsTypeDef(
    _DescribeHostsPaginateResponseHostsTypeDef
):
    """
    Type definition for `DescribeHostsPaginateResponse` `Hosts`

    Describes the properties of the Dedicated Host.

    - **AutoPlacement** *(string) --*

      Whether auto-placement is on or off.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the Dedicated Host.

    - **AvailableCapacity** *(dict) --*

      The number of new instances that can be launched onto the Dedicated Host.

      - **AvailableInstanceCapacity** *(list) --*

        The total number of instances supported by the Dedicated Host.

        - *(dict) --*

          Information about the instance type that the Dedicated Host supports.

          - **AvailableCapacity** *(integer) --*

            The number of instances that can still be launched onto the Dedicated Host.

          - **InstanceType** *(string) --*

            The instance type size supported by the Dedicated Host.

          - **TotalCapacity** *(integer) --*

            The total number of instances that can be launched onto the Dedicated Host.

      - **AvailableVCpus** *(integer) --*

        The number of vCPUs available on the Dedicated Host.

    - **ClientToken** *(string) --*

      Unique, case-sensitive identifier that you provide to ensure the idempotency of the
      request. For more information, see `How to Ensure Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **HostId** *(string) --*

      The ID of the Dedicated Host.

    - **HostProperties** *(dict) --*

      The hardware specifications of the Dedicated Host.

      - **Cores** *(integer) --*

        The number of cores on the Dedicated Host.

      - **InstanceType** *(string) --*

        The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

      - **Sockets** *(integer) --*

        The number of sockets on the Dedicated Host.

      - **TotalVCpus** *(integer) --*

        The number of vCPUs on the Dedicated Host.

    - **HostReservationId** *(string) --*

      The reservation ID of the Dedicated Host. This returns a ``null`` response if the
      Dedicated Host doesn't have an associated reservation.

    - **Instances** *(list) --*

      The IDs and instance type that are currently running on the Dedicated Host.

      - *(dict) --*

        Describes an instance running on a Dedicated Host.

        - **InstanceId** *(string) --*

          the IDs of instances that are running on the Dedicated Host.

        - **InstanceType** *(string) --*

          The instance type size (for example, ``m3.medium`` ) of the running instance.

    - **State** *(string) --*

      The Dedicated Host's state.

    - **AllocationTime** *(datetime) --*

      The time that the Dedicated Host was allocated.

    - **ReleaseTime** *(datetime) --*

      The time that the Dedicated Host was released.

    - **Tags** *(list) --*

      Any tags assigned to the Dedicated Host.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **HostRecovery** *(string) --*

      Indicates whether host recovery is enabled or disabled for the Dedicated Host.
    """


_DescribeHostsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseTypeDef",
    {"Hosts": List[DescribeHostsPaginateResponseHostsTypeDef]},
    total=False,
)


class DescribeHostsPaginateResponseTypeDef(_DescribeHostsPaginateResponseTypeDef):
    """
    Type definition for `DescribeHostsPaginate` `Response`

    - **Hosts** *(list) --*

      Information about the Dedicated Hosts.

      - *(dict) --*

        Describes the properties of the Dedicated Host.

        - **AutoPlacement** *(string) --*

          Whether auto-placement is on or off.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the Dedicated Host.

        - **AvailableCapacity** *(dict) --*

          The number of new instances that can be launched onto the Dedicated Host.

          - **AvailableInstanceCapacity** *(list) --*

            The total number of instances supported by the Dedicated Host.

            - *(dict) --*

              Information about the instance type that the Dedicated Host supports.

              - **AvailableCapacity** *(integer) --*

                The number of instances that can still be launched onto the Dedicated Host.

              - **InstanceType** *(string) --*

                The instance type size supported by the Dedicated Host.

              - **TotalCapacity** *(integer) --*

                The total number of instances that can be launched onto the Dedicated Host.

          - **AvailableVCpus** *(integer) --*

            The number of vCPUs available on the Dedicated Host.

        - **ClientToken** *(string) --*

          Unique, case-sensitive identifier that you provide to ensure the idempotency of the
          request. For more information, see `How to Ensure Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **HostId** *(string) --*

          The ID of the Dedicated Host.

        - **HostProperties** *(dict) --*

          The hardware specifications of the Dedicated Host.

          - **Cores** *(integer) --*

            The number of cores on the Dedicated Host.

          - **InstanceType** *(string) --*

            The instance type size that the Dedicated Host supports (for example, ``m3.medium`` ).

          - **Sockets** *(integer) --*

            The number of sockets on the Dedicated Host.

          - **TotalVCpus** *(integer) --*

            The number of vCPUs on the Dedicated Host.

        - **HostReservationId** *(string) --*

          The reservation ID of the Dedicated Host. This returns a ``null`` response if the
          Dedicated Host doesn't have an associated reservation.

        - **Instances** *(list) --*

          The IDs and instance type that are currently running on the Dedicated Host.

          - *(dict) --*

            Describes an instance running on a Dedicated Host.

            - **InstanceId** *(string) --*

              the IDs of instances that are running on the Dedicated Host.

            - **InstanceType** *(string) --*

              The instance type size (for example, ``m3.medium`` ) of the running instance.

        - **State** *(string) --*

          The Dedicated Host's state.

        - **AllocationTime** *(datetime) --*

          The time that the Dedicated Host was allocated.

        - **ReleaseTime** *(datetime) --*

          The time that the Dedicated Host was released.

        - **Tags** *(list) --*

          Any tags assigned to the Dedicated Host.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **HostRecovery** *(string) --*

          Indicates whether host recovery is enabled or disabled for the Dedicated Host.
    """


_DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeIamInstanceProfileAssociationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeIamInstanceProfileAssociationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef
):
    """
    Type definition for `DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociations` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef,
        "State": str,
        "Timestamp": datetime,
    },
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef
):
    """
    Type definition for `DescribeIamInstanceProfileAssociationsPaginateResponse` `IamInstanceProfileAssociations`

    Describes an association between an IAM instance profile and an instance.

    - **AssociationId** *(string) --*

      The ID of the association.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **State** *(string) --*

      The state of the association.

    - **Timestamp** *(datetime) --*

      The time the IAM instance profile was associated with the instance.
    """


_DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef",
    {
        "IamInstanceProfileAssociations": List[
            DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef
        ]
    },
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeIamInstanceProfileAssociationsPaginate` `Response`

    - **IamInstanceProfileAssociations** *(list) --*

      Information about the IAM instance profile associations.

      - *(dict) --*

        Describes an association between an IAM instance profile and an instance.

        - **AssociationId** *(string) --*

          The ID of the association.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Id** *(string) --*

            The ID of the instance profile.

        - **State** *(string) --*

          The state of the association.

        - **Timestamp** *(datetime) --*

          The time the IAM instance profile was associated with the instance.
    """


_DescribeImportImageTasksPaginateFiltersTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeImportImageTasksPaginateFiltersTypeDef(
    _DescribeImportImageTasksPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeImportImageTasksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeImportImageTasksPaginatePaginationConfigTypeDef(
    _DescribeImportImageTasksPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetails` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginateResponseImportImageTasks` `SnapshotDetails`

    Describes the snapshot created from the imported disk.

    - **Description** *(string) --*

      A description for the snapshot.

    - **DeviceName** *(string) --*

      The block device mapping for the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **Progress** *(string) --*

      The percentage of progress for the task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status of the snapshot creation.

    - **StatusMessage** *(string) --*

      A detailed status message for the snapshot creation.

    - **Url** *(string) --*

      The URL used to access the disk image.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[
            DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef
        ],
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginateResponse` `ImportImageTasks`

    Describes an import image task.

    - **Architecture** *(string) --*

      The architecture of the virtual machine.

      Valid values: ``i386`` | ``x86_64`` | ``arm64``

    - **Description** *(string) --*

      A description of the import task.

    - **Encrypted** *(boolean) --*

      Indicates whether the image is encrypted.

    - **Hypervisor** *(string) --*

      The target hypervisor for the import task.

      Valid values: ``xen``

    - **ImageId** *(string) --*

      The ID of the Amazon Machine Image (AMI) of the imported virtual machine.

    - **ImportTaskId** *(string) --*

      The ID of the import image task.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
      that was used to create the encrypted image.

    - **LicenseType** *(string) --*

      The license type of the virtual machine.

    - **Platform** *(string) --*

      The description string for the import image task.

    - **Progress** *(string) --*

      The percentage of progress of the import image task.

    - **SnapshotDetails** *(list) --*

      Information about the snapshots.

      - *(dict) --*

        Describes the snapshot created from the imported disk.

        - **Description** *(string) --*

          A description for the snapshot.

        - **DeviceName** *(string) --*

          The block device mapping for the snapshot.

        - **DiskImageSize** *(float) --*

          The size of the disk in the snapshot, in GiB.

        - **Format** *(string) --*

          The format of the disk image from which the snapshot is created.

        - **Progress** *(string) --*

          The percentage of progress for the task.

        - **SnapshotId** *(string) --*

          The snapshot ID of the disk being imported.

        - **Status** *(string) --*

          A brief status of the snapshot creation.

        - **StatusMessage** *(string) --*

          A detailed status message for the snapshot creation.

        - **Url** *(string) --*

          The URL used to access the disk image.

        - **UserBucket** *(dict) --*

          The S3 bucket for the disk image.

          - **S3Bucket** *(string) --*

            The S3 bucket from which the disk image was created.

          - **S3Key** *(string) --*

            The file name of the disk image.

    - **Status** *(string) --*

      A brief status for the import image task.

    - **StatusMessage** *(string) --*

      A descriptive status message for the import image task.
    """


_DescribeImportImageTasksPaginateResponseTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseTypeDef",
    {
        "ImportImageTasks": List[
            DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef
        ]
    },
    total=False,
)


class DescribeImportImageTasksPaginateResponseTypeDef(
    _DescribeImportImageTasksPaginateResponseTypeDef
):
    """
    Type definition for `DescribeImportImageTasksPaginate` `Response`

    - **ImportImageTasks** *(list) --*

      A list of zero or more import image tasks that are currently active or were completed or
      canceled in the previous 7 days.

      - *(dict) --*

        Describes an import image task.

        - **Architecture** *(string) --*

          The architecture of the virtual machine.

          Valid values: ``i386`` | ``x86_64`` | ``arm64``

        - **Description** *(string) --*

          A description of the import task.

        - **Encrypted** *(boolean) --*

          Indicates whether the image is encrypted.

        - **Hypervisor** *(string) --*

          The target hypervisor for the import task.

          Valid values: ``xen``

        - **ImageId** *(string) --*

          The ID of the Amazon Machine Image (AMI) of the imported virtual machine.

        - **ImportTaskId** *(string) --*

          The ID of the import image task.

        - **KmsKeyId** *(string) --*

          The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
          that was used to create the encrypted image.

        - **LicenseType** *(string) --*

          The license type of the virtual machine.

        - **Platform** *(string) --*

          The description string for the import image task.

        - **Progress** *(string) --*

          The percentage of progress of the import image task.

        - **SnapshotDetails** *(list) --*

          Information about the snapshots.

          - *(dict) --*

            Describes the snapshot created from the imported disk.

            - **Description** *(string) --*

              A description for the snapshot.

            - **DeviceName** *(string) --*

              The block device mapping for the snapshot.

            - **DiskImageSize** *(float) --*

              The size of the disk in the snapshot, in GiB.

            - **Format** *(string) --*

              The format of the disk image from which the snapshot is created.

            - **Progress** *(string) --*

              The percentage of progress for the task.

            - **SnapshotId** *(string) --*

              The snapshot ID of the disk being imported.

            - **Status** *(string) --*

              A brief status of the snapshot creation.

            - **StatusMessage** *(string) --*

              A detailed status message for the snapshot creation.

            - **Url** *(string) --*

              The URL used to access the disk image.

            - **UserBucket** *(dict) --*

              The S3 bucket for the disk image.

              - **S3Bucket** *(string) --*

                The S3 bucket from which the disk image was created.

              - **S3Key** *(string) --*

                The file name of the disk image.

        - **Status** *(string) --*

          A brief status for the import image task.

        - **StatusMessage** *(string) --*

          A descriptive status message for the import image task.
    """


_DescribeImportSnapshotTasksPaginateFiltersTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeImportSnapshotTasksPaginateFiltersTypeDef(
    _DescribeImportSnapshotTasksPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef(
    _DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetail` `UserBucket`

    The S3 bucket for the disk image.

    - **S3Bucket** *(string) --*

      The S3 bucket from which the disk image was created.

    - **S3Key** *(string) --*

      The file name of the disk image.
    """


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasks` `SnapshotTaskDetail`

    Describes an import snapshot task.

    - **Description** *(string) --*

      The description of the snapshot.

    - **DiskImageSize** *(float) --*

      The size of the disk in the snapshot, in GiB.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **Format** *(string) --*

      The format of the disk image from which the snapshot is created.

    - **KmsKeyId** *(string) --*

      The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
      that was used to create the encrypted snapshot.

    - **Progress** *(string) --*

      The percentage of completion for the import snapshot task.

    - **SnapshotId** *(string) --*

      The snapshot ID of the disk being imported.

    - **Status** *(string) --*

      A brief status for the import snapshot task.

    - **StatusMessage** *(string) --*

      A detailed status message for the import snapshot task.

    - **Url** *(string) --*

      The URL of the disk image from which the snapshot is created.

    - **UserBucket** *(dict) --*

      The S3 bucket for the disk image.

      - **S3Bucket** *(string) --*

        The S3 bucket from which the disk image was created.

      - **S3Key** *(string) --*

        The file name of the disk image.
    """


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginateResponse` `ImportSnapshotTasks`

    Describes an import snapshot task.

    - **Description** *(string) --*

      A description of the import snapshot task.

    - **ImportTaskId** *(string) --*

      The ID of the import snapshot task.

    - **SnapshotTaskDetail** *(dict) --*

      Describes an import snapshot task.

      - **Description** *(string) --*

        The description of the snapshot.

      - **DiskImageSize** *(float) --*

        The size of the disk in the snapshot, in GiB.

      - **Encrypted** *(boolean) --*

        Indicates whether the snapshot is encrypted.

      - **Format** *(string) --*

        The format of the disk image from which the snapshot is created.

      - **KmsKeyId** *(string) --*

        The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
        that was used to create the encrypted snapshot.

      - **Progress** *(string) --*

        The percentage of completion for the import snapshot task.

      - **SnapshotId** *(string) --*

        The snapshot ID of the disk being imported.

      - **Status** *(string) --*

        A brief status for the import snapshot task.

      - **StatusMessage** *(string) --*

        A detailed status message for the import snapshot task.

      - **Url** *(string) --*

        The URL of the disk image from which the snapshot is created.

      - **UserBucket** *(dict) --*

        The S3 bucket for the disk image.

        - **S3Bucket** *(string) --*

          The S3 bucket from which the disk image was created.

        - **S3Key** *(string) --*

          The file name of the disk image.
    """


_DescribeImportSnapshotTasksPaginateResponseTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseTypeDef",
    {
        "ImportSnapshotTasks": List[
            DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef
        ]
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseTypeDef
):
    """
    Type definition for `DescribeImportSnapshotTasksPaginate` `Response`

    - **ImportSnapshotTasks** *(list) --*

      A list of zero or more import snapshot tasks that are currently active or were completed or
      canceled in the previous 7 days.

      - *(dict) --*

        Describes an import snapshot task.

        - **Description** *(string) --*

          A description of the import snapshot task.

        - **ImportTaskId** *(string) --*

          The ID of the import snapshot task.

        - **SnapshotTaskDetail** *(dict) --*

          Describes an import snapshot task.

          - **Description** *(string) --*

            The description of the snapshot.

          - **DiskImageSize** *(float) --*

            The size of the disk in the snapshot, in GiB.

          - **Encrypted** *(boolean) --*

            Indicates whether the snapshot is encrypted.

          - **Format** *(string) --*

            The format of the disk image from which the snapshot is created.

          - **KmsKeyId** *(string) --*

            The identifier for the AWS Key Management Service (AWS KMS) customer master key (CMK)
            that was used to create the encrypted snapshot.

          - **Progress** *(string) --*

            The percentage of completion for the import snapshot task.

          - **SnapshotId** *(string) --*

            The snapshot ID of the disk being imported.

          - **Status** *(string) --*

            A brief status for the import snapshot task.

          - **StatusMessage** *(string) --*

            A detailed status message for the import snapshot task.

          - **Url** *(string) --*

            The URL of the disk image from which the snapshot is created.

          - **UserBucket** *(dict) --*

            The S3 bucket for the disk image.

            - **S3Bucket** *(string) --*

              The S3 bucket from which the disk image was created.

            - **S3Key** *(string) --*

              The file name of the disk image.
    """


_DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeInstanceCreditSpecificationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef(
    _DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeInstanceCreditSpecificationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef
):
    """
    Type definition for `DescribeInstanceCreditSpecificationsPaginateResponse` `InstanceCreditSpecifications`

    Describes the credit option for CPU usage of a T2 or T3 instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of the instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_DescribeInstanceCreditSpecificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateResponseTypeDef",
    {
        "InstanceCreditSpecifications": List[
            DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef
        ]
    },
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateResponseTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeInstanceCreditSpecificationsPaginate` `Response`

    - **InstanceCreditSpecifications** *(list) --*

      Information about the credit option for CPU usage of an instance.

      - *(dict) --*

        Describes the credit option for CPU usage of a T2 or T3 instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of the instance. Valid values are ``standard`` and
          ``unlimited`` .
    """


_DescribeInstanceStatusPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInstanceStatusPaginateFiltersTypeDef(
    _DescribeInstanceStatusPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeInstanceStatusPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstanceStatusPaginatePaginationConfigTypeDef(
    _DescribeInstanceStatusPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef",
    {
        "InstanceEventId": str,
        "Code": str,
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatuses` `Events`

    Describes a scheduled event for an instance.

    - **InstanceEventId** *(string) --*

      The ID of the event.

    - **Code** *(string) --*

      The event code.

    - **Description** *(string) --*

      A description of the event.

      After a scheduled event is completed, it can still be described for up to a week. If
      the event has been completed, this description starts with the following text:
      [Completed].

    - **NotAfter** *(datetime) --*

      The latest scheduled end time for the event.

    - **NotBefore** *(datetime) --*

      The earliest scheduled start time for the event.

    - **NotBeforeDeadline** *(datetime) --*

      The deadline for starting the event.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatuses` `InstanceState`

    The intended state of the instance.  DescribeInstanceStatus requires that an instance be
    in the ``running`` state.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    {"ImpairedSince": datetime, "Name": str, "Status": str},
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatus` `Details`

    Describes the instance status.

    - **ImpairedSince** *(datetime) --*

      The time when a status check failed. For an instance that was launched and
      impaired, this is the time when the instance was launched.

    - **Name** *(string) --*

      The type of instance status.

    - **Status** *(string) --*

      The status.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef",
    {
        "Details": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatuses` `InstanceStatus`

    Reports impaired functionality that stems from issues internal to the instance, such as
    impaired reachability.

    - **Details** *(list) --*

      The system instance health or application instance health.

      - *(dict) --*

        Describes the instance status.

        - **ImpairedSince** *(datetime) --*

          The time when a status check failed. For an instance that was launched and
          impaired, this is the time when the instance was launched.

        - **Name** *(string) --*

          The type of instance status.

        - **Status** *(string) --*

          The status.

    - **Status** *(string) --*

      The status.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef",
    {"ImpairedSince": datetime, "Name": str, "Status": str},
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatus` `Details`

    Describes the instance status.

    - **ImpairedSince** *(datetime) --*

      The time when a status check failed. For an instance that was launched and
      impaired, this is the time when the instance was launched.

    - **Name** *(string) --*

      The type of instance status.

    - **Status** *(string) --*

      The status.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef",
    {
        "Details": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponseInstanceStatuses` `SystemStatus`

    Reports impaired functionality that stems from issues related to the systems that support
    an instance, such as hardware failures and network connectivity problems.

    - **Details** *(list) --*

      The system instance health or application instance health.

      - *(dict) --*

        Describes the instance status.

        - **ImpairedSince** *(datetime) --*

          The time when a status check failed. For an instance that was launched and
          impaired, this is the time when the instance was launched.

        - **Name** *(string) --*

          The type of instance status.

        - **Status** *(string) --*

          The status.

    - **Status** *(string) --*

      The status.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef",
    {
        "AvailabilityZone": str,
        "Events": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef
        ],
        "InstanceId": str,
        "InstanceState": DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef,
        "InstanceStatus": DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef,
        "SystemStatus": DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginateResponse` `InstanceStatuses`

    Describes the status of an instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Events** *(list) --*

      Any scheduled events associated with the instance.

      - *(dict) --*

        Describes a scheduled event for an instance.

        - **InstanceEventId** *(string) --*

          The ID of the event.

        - **Code** *(string) --*

          The event code.

        - **Description** *(string) --*

          A description of the event.

          After a scheduled event is completed, it can still be described for up to a week. If
          the event has been completed, this description starts with the following text:
          [Completed].

        - **NotAfter** *(datetime) --*

          The latest scheduled end time for the event.

        - **NotBefore** *(datetime) --*

          The earliest scheduled start time for the event.

        - **NotBeforeDeadline** *(datetime) --*

          The deadline for starting the event.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceState** *(dict) --*

      The intended state of the instance.  DescribeInstanceStatus requires that an instance be
      in the ``running`` state.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceStatus** *(dict) --*

      Reports impaired functionality that stems from issues internal to the instance, such as
      impaired reachability.

      - **Details** *(list) --*

        The system instance health or application instance health.

        - *(dict) --*

          Describes the instance status.

          - **ImpairedSince** *(datetime) --*

            The time when a status check failed. For an instance that was launched and
            impaired, this is the time when the instance was launched.

          - **Name** *(string) --*

            The type of instance status.

          - **Status** *(string) --*

            The status.

      - **Status** *(string) --*

        The status.

    - **SystemStatus** *(dict) --*

      Reports impaired functionality that stems from issues related to the systems that support
      an instance, such as hardware failures and network connectivity problems.

      - **Details** *(list) --*

        The system instance health or application instance health.

        - *(dict) --*

          Describes the instance status.

          - **ImpairedSince** *(datetime) --*

            The time when a status check failed. For an instance that was launched and
            impaired, this is the time when the instance was launched.

          - **Name** *(string) --*

            The type of instance status.

          - **Status** *(string) --*

            The status.

      - **Status** *(string) --*

        The status.
    """


_DescribeInstanceStatusPaginateResponseTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseTypeDef",
    {
        "InstanceStatuses": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef
        ]
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseTypeDef(
    _DescribeInstanceStatusPaginateResponseTypeDef
):
    """
    Type definition for `DescribeInstanceStatusPaginate` `Response`

    - **InstanceStatuses** *(list) --*

      Information about the status of the instances.

      - *(dict) --*

        Describes the status of an instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Events** *(list) --*

          Any scheduled events associated with the instance.

          - *(dict) --*

            Describes a scheduled event for an instance.

            - **InstanceEventId** *(string) --*

              The ID of the event.

            - **Code** *(string) --*

              The event code.

            - **Description** *(string) --*

              A description of the event.

              After a scheduled event is completed, it can still be described for up to a week. If
              the event has been completed, this description starts with the following text:
              [Completed].

            - **NotAfter** *(datetime) --*

              The latest scheduled end time for the event.

            - **NotBefore** *(datetime) --*

              The earliest scheduled start time for the event.

            - **NotBeforeDeadline** *(datetime) --*

              The deadline for starting the event.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceState** *(dict) --*

          The intended state of the instance.  DescribeInstanceStatus requires that an instance be
          in the ``running`` state.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceStatus** *(dict) --*

          Reports impaired functionality that stems from issues internal to the instance, such as
          impaired reachability.

          - **Details** *(list) --*

            The system instance health or application instance health.

            - *(dict) --*

              Describes the instance status.

              - **ImpairedSince** *(datetime) --*

                The time when a status check failed. For an instance that was launched and
                impaired, this is the time when the instance was launched.

              - **Name** *(string) --*

                The type of instance status.

              - **Status** *(string) --*

                The status.

          - **Status** *(string) --*

            The status.

        - **SystemStatus** *(dict) --*

          Reports impaired functionality that stems from issues related to the systems that support
          an instance, such as hardware failures and network connectivity problems.

          - **Details** *(list) --*

            The system instance health or application instance health.

            - *(dict) --*

              Describes the instance status.

              - **ImpairedSince** *(datetime) --*

                The time when a status check failed. For an instance that was launched and
                impaired, this is the time when the instance was launched.

              - **Name** *(string) --*

                The type of instance status.

              - **Status** *(string) --*

                The status.

          - **Status** *(string) --*

            The status.
    """


_DescribeInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstancesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInstancesPaginateFiltersTypeDef(_DescribeInstancesPaginateFiltersTypeDef):
    """
    Type definition for `DescribeInstancesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstancesPaginatePaginationConfigTypeDef(
    _DescribeInstancesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeInstancesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeInstancesPaginateResponseReservationsGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsGroupsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservations` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": str,
        "VolumeId": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Status** *(string) --*

      The attachment state.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Status** *(string) --*

        The attachment state.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.
    """


_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the targeted Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Describes the instance's Capacity Reservation preferences. Possible preferences
      include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the targeted Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `CpuOptions`

    The CPU options for the instance.

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `ElasticGpuAssociations`

    Describes the association between an instance and an Elastic Graphics accelerator.

    - **ElasticGpuId** *(string) --*

      The ID of the Elastic Graphics accelerator.

    - **ElasticGpuAssociationId** *(string) --*

      The ID of the association.

    - **ElasticGpuAssociationState** *(string) --*

      The state of the association between the instance and the Elastic Graphics
      accelerator.

    - **ElasticGpuAssociationTime** *(string) --*

      The time the Elastic Graphics accelerator was associated with the instance.
    """


_DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `ElasticInferenceAcceleratorAssociations`

    Describes the association between an instance and an elastic inference accelerator.

    - **ElasticInferenceAcceleratorArn** *(string) --*

      The Amazon Resource Name (ARN) of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationId** *(string) --*

      The ID of the association.

    - **ElasticInferenceAcceleratorAssociationState** *(string) --*

      The state of the elastic inference accelerator.

    - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

      The time at which the elastic inference accelerator is associated with an
      instance.
    """


_DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `HibernationOptions`

    Indicates whether the instance is enabled for hibernation.

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , your instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `IamInstanceProfile`

    The IAM instance profile associated with the instance, if applicable.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Id** *(string) --*

      The ID of the instance profile.
    """


_DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `Licenses`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef",
    {"State": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfaces` `Association`

    The association information for an Elastic IPv4 associated with the network
    interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfaces` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is
      terminated.

    - **DeviceIndex** *(integer) --*

      The index of the device on the instance for the network interface attachment.

    - **Status** *(string) --*

      The attachment state.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfaces` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddresses` `Association`

    The association information for an Elastic IP address for the network
    interface.

    - **IpOwnerId** *(string) --*

      The ID of the owner of the Elastic IP address.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The public IP address or Elastic IP address bound to the network interface.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a private IPv4 address.

    - **Association** *(dict) --*

      The association information for an Elastic IP address for the network
      interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IP address of the
      network interface.

    - **PrivateDnsName** *(string) --*

      The private IPv4 DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface.
    """


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef",
    {
        "Association": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
        ],
        "Ipv6Addresses": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `NetworkInterfaces`

    Describes a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IPv4 associated with the network
      interface.

      - **IpOwnerId** *(string) --*

        The ID of the owner of the Elastic IP address.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The public IP address or Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is
        terminated.

      - **DeviceIndex** *(integer) --*

        The index of the device on the instance for the network interface attachment.

      - **Status** *(string) --*

        The attachment state.

    - **Description** *(string) --*

      The description.

    - **Groups** *(list) --*

      One or more security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The ID of the AWS account that created the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes a private IPv4 address.

        - **Association** *(dict) --*

          The association information for an Elastic IP address for the network
          interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IP address of the
          network interface.

        - **PrivateDnsName** *(string) --*

          The private IPv4 DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether to validate network traffic to or from this network interface.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **InterfaceType** *(string) --*

      Describes the type of network interface.

      Valid values: ``interface`` | ``efa``
    """


_DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `Placement`

    The location where the instance launched, if applicable.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based
      on the load balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not
      supported for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group
      strategy is set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not
      supported for the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with
      a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
      not supported for the  ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `StateReason`

    The reason for the most recent state transition.

    - **Code** *(string) --*

      The reason code for the state change.

    - **Message** *(string) --*

      The message for the state change.

      * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
      available to satisfy the launch request.

      * ``Server.InternalError`` : An internal error caused the instance to terminate
      during launch.

      * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

      * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
      Spot requests with a maximum price equal to or higher than the Spot price exceeded
      available capacity or because of an increase in the Spot price.

      * ``Server.SpotInstanceTermination`` : The instance was terminated because the
      number of Spot requests with a maximum price equal to or higher than the Spot price
      exceeded available capacity or because of an increase in the Spot price.

      * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
      ``shutdown -h`` command from the instance.

      * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
      AMI creation.

      * ``Client.InternalError`` : A client error caused the instance to terminate during
      launch.

      * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

      * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

      * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
      EC2 API.

      * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
      storage was exceeded. Decrease usage or request an increase in your account limits.
    """


_DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `State`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
      values between 256 and 65,535. These numerical values are used for internal
      purposes and should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
      values between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte
      and they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
      in decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservationsInstances` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeInstancesPaginateResponseReservationsInstancesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef,
        "Placement": DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[
            DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef
        ],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": str,
        "BlockDeviceMappings": List[
            DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef
        ],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": str,
        "IamInstanceProfile": DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": str,
        "ElasticGpuAssociations": List[
            DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef
        ],
        "RootDeviceName": str,
        "RootDeviceType": str,
        "SecurityGroups": List[
            DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef
        ],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef,
        "Tags": List[DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef],
        "VirtualizationType": str,
        "CpuOptions": DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef,
        "Licenses": List[
            DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef
        ],
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponseReservations` `Instances`

    Describes an instance.

    - **AmiLaunchIndex** *(integer) --*

      The AMI launch index, which can be used to find this instance in the launch group.

    - **ImageId** *(string) --*

      The ID of the AMI used to launch the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The kernel associated with this instance, if applicable.

    - **KeyName** *(string) --*

      The name of the key pair, if this instance was launched with an associated key pair.

    - **LaunchTime** *(datetime) --*

      The time the instance was launched.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The location where the instance launched, if applicable.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

        If not specified, an Availability Zone will be automatically chosen for you based
        on the load balancing criteria for the Region.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host. This parameter is not
        supported for the  ImportInstance command.

      - **GroupName** *(string) --*

        The name of the placement group the instance is in.

      - **PartitionNumber** *(integer) --*

        The number of the partition the instance is in. Valid only if the placement group
        strategy is set to ``partition`` .

      - **HostId** *(string) --*

        The ID of the Dedicated Host on which the instance resides. This parameter is not
        supported for the  ImportInstance command.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with
        a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
        not supported for the  ImportInstance command.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **Platform** *(string) --*

      The value is ``Windows`` for Windows instances; otherwise blank.

    - **PrivateDnsName** *(string) --*

      (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
      can only be used inside the Amazon EC2 network. This name is not available until the
      instance enters the ``running`` state.

      [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
      hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
      not using the Amazon-provided DNS server in your VPC, your custom domain name servers
      must resolve the hostname as appropriate.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address assigned to the instance.

    - **ProductCodes** *(list) --*

      The product codes attached to this instance, if applicable.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **PublicDnsName** *(string) --*

      (IPv4 only) The public DNS name assigned to the instance. This name is not available
      until the instance enters the ``running`` state. For EC2-VPC, this name is only
      available if you've enabled DNS hostnames for your VPC.

    - **PublicIpAddress** *(string) --*

      The public IPv4 address assigned to the instance, if applicable.

    - **RamdiskId** *(string) --*

      The RAM disk associated with this instance, if applicable.

    - **State** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
        values between 256 and 65,535. These numerical values are used for internal
        purposes and should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
        values between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte
        and they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
        in decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **StateTransitionReason** *(string) --*

      The reason for the most recent state transition. This might be an empty string.

    - **SubnetId** *(string) --*

      [EC2-VPC] The ID of the subnet in which the instance is running.

    - **VpcId** *(string) --*

      [EC2-VPC] The ID of the VPC in which the instance is running.

    - **Architecture** *(string) --*

      The architecture of the image.

    - **BlockDeviceMappings** *(list) --*

      Any block device mapping entries for the instance.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Status** *(string) --*

            The attachment state.

          - **VolumeId** *(string) --*

            The ID of the EBS volume.

    - **ClientToken** *(string) --*

      The idempotency token you provided when you launched the instance, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
      provides dedicated throughput to Amazon EBS and an optimized configuration stack to
      provide optimal I/O performance. This optimization isn't available with all instance
      types. Additional usage charges apply when using an EBS Optimized instance.

    - **EnaSupport** *(boolean) --*

      Specifies whether enhanced networking with ENA is enabled.

    - **Hypervisor** *(string) --*

      The hypervisor type of the instance.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile associated with the instance, if applicable.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Id** *(string) --*

        The ID of the instance profile.

    - **InstanceLifecycle** *(string) --*

      Indicates whether this is a Spot Instance or a Scheduled Instance.

    - **ElasticGpuAssociations** *(list) --*

      The Elastic GPU associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an Elastic Graphics accelerator.

        - **ElasticGpuId** *(string) --*

          The ID of the Elastic Graphics accelerator.

        - **ElasticGpuAssociationId** *(string) --*

          The ID of the association.

        - **ElasticGpuAssociationState** *(string) --*

          The state of the association between the instance and the Elastic Graphics
          accelerator.

        - **ElasticGpuAssociationTime** *(string) --*

          The time the Elastic Graphics accelerator was associated with the instance.

    - **ElasticInferenceAcceleratorAssociations** *(list) --*

      The elastic inference accelerator associated with the instance.

      - *(dict) --*

        Describes the association between an instance and an elastic inference accelerator.

        - **ElasticInferenceAcceleratorArn** *(string) --*

          The Amazon Resource Name (ARN) of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationId** *(string) --*

          The ID of the association.

        - **ElasticInferenceAcceleratorAssociationState** *(string) --*

          The state of the elastic inference accelerator.

        - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

          The time at which the elastic inference accelerator is associated with an
          instance.

    - **NetworkInterfaces** *(list) --*

      [EC2-VPC] The network interfaces for the instance.

      - *(dict) --*

        Describes a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IPv4 associated with the network
          interface.

          - **IpOwnerId** *(string) --*

            The ID of the owner of the Elastic IP address.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The public IP address or Elastic IP address bound to the network interface.

        - **Attachment** *(dict) --*

          The network interface attachment.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **AttachmentId** *(string) --*

            The ID of the network interface attachment.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is
            terminated.

          - **DeviceIndex** *(integer) --*

            The index of the device on the instance for the network interface attachment.

          - **Status** *(string) --*

            The attachment state.

        - **Description** *(string) --*

          The description.

        - **Groups** *(list) --*

          One or more security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses associated with the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **MacAddress** *(string) --*

          The MAC address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **OwnerId** *(string) --*

          The ID of the AWS account that created the network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses associated with the network interface.

          - *(dict) --*

            Describes a private IPv4 address.

            - **Association** *(dict) --*

              The association information for an Elastic IP address for the network
              interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Primary** *(boolean) --*

              Indicates whether this IPv4 address is the primary private IP address of the
              network interface.

            - **PrivateDnsName** *(string) --*

              The private IPv4 DNS name.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface.

        - **SourceDestCheck** *(boolean) --*

          Indicates whether to validate network traffic to or from this network interface.

        - **Status** *(string) --*

          The status of the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **InterfaceType** *(string) --*

          Describes the type of network interface.

          Valid values: ``interface`` | ``efa``

    - **RootDeviceName** *(string) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **RootDeviceType** *(string) --*

      The root device type used by the AMI. The AMI can use an EBS volume or an instance
      store volume.

    - **SecurityGroups** *(list) --*

      The security groups for the instance.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **SourceDestCheck** *(boolean) --*

      Specifies whether to enable an instance launched in a VPC to perform NAT. This
      controls whether source/destination checking is enabled on the instance. A value of
      ``true`` means that checking is enabled, and ``false`` means that checking is
      disabled. The value must be ``false`` for the instance to perform NAT. For more
      information, see `NAT Instances
      <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
      the *Amazon Virtual Private Cloud User Guide* .

    - **SpotInstanceRequestId** *(string) --*

      If the request is a Spot Instance request, the ID of the request.

    - **SriovNetSupport** *(string) --*

      Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
      is enabled.

    - **StateReason** *(dict) --*

      The reason for the most recent state transition.

      - **Code** *(string) --*

        The reason code for the state change.

      - **Message** *(string) --*

        The message for the state change.

        * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
        available to satisfy the launch request.

        * ``Server.InternalError`` : An internal error caused the instance to terminate
        during launch.

        * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

        * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
        Spot requests with a maximum price equal to or higher than the Spot price exceeded
        available capacity or because of an increase in the Spot price.

        * ``Server.SpotInstanceTermination`` : The instance was terminated because the
        number of Spot requests with a maximum price equal to or higher than the Spot price
        exceeded available capacity or because of an increase in the Spot price.

        * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
        ``shutdown -h`` command from the instance.

        * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
        AMI creation.

        * ``Client.InternalError`` : A client error caused the instance to terminate during
        launch.

        * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

        * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

        * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
        EC2 API.

        * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
        storage was exceeded. Decrease usage or request an increase in your account limits.

    - **Tags** *(list) --*

      Any tags assigned to the instance.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VirtualizationType** *(string) --*

      The virtualization type of the instance.

    - **CpuOptions** *(dict) --*

      The CPU options for the instance.

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Describes the instance's Capacity Reservation preferences. Possible preferences
        include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the targeted Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **HibernationOptions** *(dict) --*

      Indicates whether the instance is enabled for hibernation.

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , your instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.

    - **Licenses** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.
    """


_DescribeInstancesPaginateResponseReservationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsTypeDef",
    {
        "Groups": List[DescribeInstancesPaginateResponseReservationsGroupsTypeDef],
        "Instances": List[
            DescribeInstancesPaginateResponseReservationsInstancesTypeDef
        ],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsTypeDef
):
    """
    Type definition for `DescribeInstancesPaginateResponse` `Reservations`

    Describes a reservation.

    - **Groups** *(list) --*

      [EC2-Classic only] The security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **Instances** *(list) --*

      The instances.

      - *(dict) --*

        Describes an instance.

        - **AmiLaunchIndex** *(integer) --*

          The AMI launch index, which can be used to find this instance in the launch group.

        - **ImageId** *(string) --*

          The ID of the AMI used to launch the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The kernel associated with this instance, if applicable.

        - **KeyName** *(string) --*

          The name of the key pair, if this instance was launched with an associated key pair.

        - **LaunchTime** *(datetime) --*

          The time the instance was launched.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.

        - **Placement** *(dict) --*

          The location where the instance launched, if applicable.

          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.

            If not specified, an Availability Zone will be automatically chosen for you based
            on the load balancing criteria for the Region.

          - **Affinity** *(string) --*

            The affinity setting for the instance on the Dedicated Host. This parameter is not
            supported for the  ImportInstance command.

          - **GroupName** *(string) --*

            The name of the placement group the instance is in.

          - **PartitionNumber** *(integer) --*

            The number of the partition the instance is in. Valid only if the placement group
            strategy is set to ``partition`` .

          - **HostId** *(string) --*

            The ID of the Dedicated Host on which the instance resides. This parameter is not
            supported for the  ImportInstance command.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance with
            a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
            not supported for the  ImportInstance command.

          - **SpreadDomain** *(string) --*

            Reserved for future use.

        - **Platform** *(string) --*

          The value is ``Windows`` for Windows instances; otherwise blank.

        - **PrivateDnsName** *(string) --*

          (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
          can only be used inside the Amazon EC2 network. This name is not available until the
          instance enters the ``running`` state.

          [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
          hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
          not using the Amazon-provided DNS server in your VPC, your custom domain name servers
          must resolve the hostname as appropriate.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address assigned to the instance.

        - **ProductCodes** *(list) --*

          The product codes attached to this instance, if applicable.

          - *(dict) --*

            Describes a product code.

            - **ProductCodeId** *(string) --*

              The product code.

            - **ProductCodeType** *(string) --*

              The type of product code.

        - **PublicDnsName** *(string) --*

          (IPv4 only) The public DNS name assigned to the instance. This name is not available
          until the instance enters the ``running`` state. For EC2-VPC, this name is only
          available if you've enabled DNS hostnames for your VPC.

        - **PublicIpAddress** *(string) --*

          The public IPv4 address assigned to the instance, if applicable.

        - **RamdiskId** *(string) --*

          The RAM disk associated with this instance, if applicable.

        - **State** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
            values between 256 and 65,535. These numerical values are used for internal
            purposes and should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
            values between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte
            and they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
            in decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **StateTransitionReason** *(string) --*

          The reason for the most recent state transition. This might be an empty string.

        - **SubnetId** *(string) --*

          [EC2-VPC] The ID of the subnet in which the instance is running.

        - **VpcId** *(string) --*

          [EC2-VPC] The ID of the VPC in which the instance is running.

        - **Architecture** *(string) --*

          The architecture of the image.

        - **BlockDeviceMappings** *(list) --*

          Any block device mapping entries for the instance.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is launched.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the volume is deleted on instance termination.

              - **Status** *(string) --*

                The attachment state.

              - **VolumeId** *(string) --*

                The ID of the EBS volume.

        - **ClientToken** *(string) --*

          The idempotency token you provided when you launched the instance, if applicable.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
          provides dedicated throughput to Amazon EBS and an optimized configuration stack to
          provide optimal I/O performance. This optimization isn't available with all instance
          types. Additional usage charges apply when using an EBS Optimized instance.

        - **EnaSupport** *(boolean) --*

          Specifies whether enhanced networking with ENA is enabled.

        - **Hypervisor** *(string) --*

          The hypervisor type of the instance.

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile associated with the instance, if applicable.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Id** *(string) --*

            The ID of the instance profile.

        - **InstanceLifecycle** *(string) --*

          Indicates whether this is a Spot Instance or a Scheduled Instance.

        - **ElasticGpuAssociations** *(list) --*

          The Elastic GPU associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an Elastic Graphics accelerator.

            - **ElasticGpuId** *(string) --*

              The ID of the Elastic Graphics accelerator.

            - **ElasticGpuAssociationId** *(string) --*

              The ID of the association.

            - **ElasticGpuAssociationState** *(string) --*

              The state of the association between the instance and the Elastic Graphics
              accelerator.

            - **ElasticGpuAssociationTime** *(string) --*

              The time the Elastic Graphics accelerator was associated with the instance.

        - **ElasticInferenceAcceleratorAssociations** *(list) --*

          The elastic inference accelerator associated with the instance.

          - *(dict) --*

            Describes the association between an instance and an elastic inference accelerator.

            - **ElasticInferenceAcceleratorArn** *(string) --*

              The Amazon Resource Name (ARN) of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationId** *(string) --*

              The ID of the association.

            - **ElasticInferenceAcceleratorAssociationState** *(string) --*

              The state of the elastic inference accelerator.

            - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

              The time at which the elastic inference accelerator is associated with an
              instance.

        - **NetworkInterfaces** *(list) --*

          [EC2-VPC] The network interfaces for the instance.

          - *(dict) --*

            Describes a network interface.

            - **Association** *(dict) --*

              The association information for an Elastic IPv4 associated with the network
              interface.

              - **IpOwnerId** *(string) --*

                The ID of the owner of the Elastic IP address.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The public IP address or Elastic IP address bound to the network interface.

            - **Attachment** *(dict) --*

              The network interface attachment.

              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.

              - **AttachmentId** *(string) --*

                The ID of the network interface attachment.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the network interface is deleted when the instance is
                terminated.

              - **DeviceIndex** *(integer) --*

                The index of the device on the instance for the network interface attachment.

              - **Status** *(string) --*

                The attachment state.

            - **Description** *(string) --*

              The description.

            - **Groups** *(list) --*

              One or more security groups.

              - *(dict) --*

                Describes a security group.

                - **GroupName** *(string) --*

                  The name of the security group.

                - **GroupId** *(string) --*

                  The ID of the security group.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses associated with the network interface.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **MacAddress** *(string) --*

              The MAC address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **OwnerId** *(string) --*

              The ID of the AWS account that created the network interface.

            - **PrivateDnsName** *(string) --*

              The private DNS name.

            - **PrivateIpAddress** *(string) --*

              The IPv4 address of the network interface within the subnet.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses associated with the network interface.

              - *(dict) --*

                Describes a private IPv4 address.

                - **Association** *(dict) --*

                  The association information for an Elastic IP address for the network
                  interface.

                  - **IpOwnerId** *(string) --*

                    The ID of the owner of the Elastic IP address.

                  - **PublicDnsName** *(string) --*

                    The public DNS name.

                  - **PublicIp** *(string) --*

                    The public IP address or Elastic IP address bound to the network interface.

                - **Primary** *(boolean) --*

                  Indicates whether this IPv4 address is the primary private IP address of the
                  network interface.

                - **PrivateDnsName** *(string) --*

                  The private IPv4 DNS name.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 address of the network interface.

            - **SourceDestCheck** *(boolean) --*

              Indicates whether to validate network traffic to or from this network interface.

            - **Status** *(string) --*

              The status of the network interface.

            - **SubnetId** *(string) --*

              The ID of the subnet.

            - **VpcId** *(string) --*

              The ID of the VPC.

            - **InterfaceType** *(string) --*

              Describes the type of network interface.

              Valid values: ``interface`` | ``efa``

        - **RootDeviceName** *(string) --*

          The device name of the root device volume (for example, ``/dev/sda1`` ).

        - **RootDeviceType** *(string) --*

          The root device type used by the AMI. The AMI can use an EBS volume or an instance
          store volume.

        - **SecurityGroups** *(list) --*

          The security groups for the instance.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **SourceDestCheck** *(boolean) --*

          Specifies whether to enable an instance launched in a VPC to perform NAT. This
          controls whether source/destination checking is enabled on the instance. A value of
          ``true`` means that checking is enabled, and ``false`` means that checking is
          disabled. The value must be ``false`` for the instance to perform NAT. For more
          information, see `NAT Instances
          <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
          the *Amazon Virtual Private Cloud User Guide* .

        - **SpotInstanceRequestId** *(string) --*

          If the request is a Spot Instance request, the ID of the request.

        - **SriovNetSupport** *(string) --*

          Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
          is enabled.

        - **StateReason** *(dict) --*

          The reason for the most recent state transition.

          - **Code** *(string) --*

            The reason code for the state change.

          - **Message** *(string) --*

            The message for the state change.

            * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
            available to satisfy the launch request.

            * ``Server.InternalError`` : An internal error caused the instance to terminate
            during launch.

            * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

            * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
            Spot requests with a maximum price equal to or higher than the Spot price exceeded
            available capacity or because of an increase in the Spot price.

            * ``Server.SpotInstanceTermination`` : The instance was terminated because the
            number of Spot requests with a maximum price equal to or higher than the Spot price
            exceeded available capacity or because of an increase in the Spot price.

            * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
            ``shutdown -h`` command from the instance.

            * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
            AMI creation.

            * ``Client.InternalError`` : A client error caused the instance to terminate during
            launch.

            * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

            * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

            * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
            EC2 API.

            * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
            storage was exceeded. Decrease usage or request an increase in your account limits.

        - **Tags** *(list) --*

          Any tags assigned to the instance.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VirtualizationType** *(string) --*

          The virtualization type of the instance.

        - **CpuOptions** *(dict) --*

          The CPU options for the instance.

          - **CoreCount** *(integer) --*

            The number of CPU cores for the instance.

          - **ThreadsPerCore** *(integer) --*

            The number of threads per CPU core.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

        - **CapacityReservationSpecification** *(dict) --*

          Information about the Capacity Reservation targeting option.

          - **CapacityReservationPreference** *(string) --*

            Describes the instance's Capacity Reservation preferences. Possible preferences
            include:

            * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
            matching attributes (instance type, platform, Availability Zone).

            * ``none`` - The instance avoids running in a Capacity Reservation even if one is
            available. The instance runs in On-Demand capacity.

          - **CapacityReservationTarget** *(dict) --*

            Information about the targeted Capacity Reservation.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

        - **HibernationOptions** *(dict) --*

          Indicates whether the instance is enabled for hibernation.

          - **Configured** *(boolean) --*

            If this parameter is set to ``true`` , your instance is enabled for hibernation;
            otherwise, it is not enabled for hibernation.

        - **Licenses** *(list) --*

          The license configurations.

          - *(dict) --*

            Describes a license configuration.

            - **LicenseConfigurationArn** *(string) --*

              The Amazon Resource Name (ARN) of the license configuration.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the reservation.

    - **RequesterId** *(string) --*

      The ID of the requester that launched the instances on your behalf (for example, AWS
      Management Console or Auto Scaling).

    - **ReservationId** *(string) --*

      The ID of the reservation.
    """


_DescribeInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseTypeDef",
    {"Reservations": List[DescribeInstancesPaginateResponseReservationsTypeDef]},
    total=False,
)


class DescribeInstancesPaginateResponseTypeDef(
    _DescribeInstancesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeInstancesPaginate` `Response`

    - **Reservations** *(list) --*

      Information about the reservations.

      - *(dict) --*

        Describes a reservation.

        - **Groups** *(list) --*

          [EC2-Classic only] The security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **Instances** *(list) --*

          The instances.

          - *(dict) --*

            Describes an instance.

            - **AmiLaunchIndex** *(integer) --*

              The AMI launch index, which can be used to find this instance in the launch group.

            - **ImageId** *(string) --*

              The ID of the AMI used to launch the instance.

            - **InstanceId** *(string) --*

              The ID of the instance.

            - **InstanceType** *(string) --*

              The instance type.

            - **KernelId** *(string) --*

              The kernel associated with this instance, if applicable.

            - **KeyName** *(string) --*

              The name of the key pair, if this instance was launched with an associated key pair.

            - **LaunchTime** *(datetime) --*

              The time the instance was launched.

            - **Monitoring** *(dict) --*

              The monitoring for the instance.

              - **State** *(string) --*

                Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
                enabled.

            - **Placement** *(dict) --*

              The location where the instance launched, if applicable.

              - **AvailabilityZone** *(string) --*

                The Availability Zone of the instance.

                If not specified, an Availability Zone will be automatically chosen for you based
                on the load balancing criteria for the Region.

              - **Affinity** *(string) --*

                The affinity setting for the instance on the Dedicated Host. This parameter is not
                supported for the  ImportInstance command.

              - **GroupName** *(string) --*

                The name of the placement group the instance is in.

              - **PartitionNumber** *(integer) --*

                The number of the partition the instance is in. Valid only if the placement group
                strategy is set to ``partition`` .

              - **HostId** *(string) --*

                The ID of the Dedicated Host on which the instance resides. This parameter is not
                supported for the  ImportInstance command.

              - **Tenancy** *(string) --*

                The tenancy of the instance (if the instance is running in a VPC). An instance with
                a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is
                not supported for the  ImportInstance command.

              - **SpreadDomain** *(string) --*

                Reserved for future use.

            - **Platform** *(string) --*

              The value is ``Windows`` for Windows instances; otherwise blank.

            - **PrivateDnsName** *(string) --*

              (IPv4 only) The private DNS hostname name assigned to the instance. This DNS hostname
              can only be used inside the Amazon EC2 network. This name is not available until the
              instance enters the ``running`` state.

              [EC2-VPC] The Amazon-provided DNS server resolves Amazon-provided private DNS
              hostnames if you've enabled DNS resolution and DNS hostnames in your VPC. If you are
              not using the Amazon-provided DNS server in your VPC, your custom domain name servers
              must resolve the hostname as appropriate.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address assigned to the instance.

            - **ProductCodes** *(list) --*

              The product codes attached to this instance, if applicable.

              - *(dict) --*

                Describes a product code.

                - **ProductCodeId** *(string) --*

                  The product code.

                - **ProductCodeType** *(string) --*

                  The type of product code.

            - **PublicDnsName** *(string) --*

              (IPv4 only) The public DNS name assigned to the instance. This name is not available
              until the instance enters the ``running`` state. For EC2-VPC, this name is only
              available if you've enabled DNS hostnames for your VPC.

            - **PublicIpAddress** *(string) --*

              The public IPv4 address assigned to the instance, if applicable.

            - **RamdiskId** *(string) --*

              The RAM disk associated with this instance, if applicable.

            - **State** *(dict) --*

              The current state of the instance.

              - **Code** *(integer) --*

                The state of the instance as a 16-bit unsigned integer.

                The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal
                values between 256 and 65,535. These numerical values are used for internal
                purposes and should be ignored.

                The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal
                values between 0 and 255.

                The valid values for instance-state-code will all be in the range of the low byte
                and they are:

                * ``0`` : ``pending``

                * ``16`` : ``running``

                * ``32`` : ``shutting-down``

                * ``48`` : ``terminated``

                * ``64`` : ``stopping``

                * ``80`` : ``stopped``

                You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256
                in decimal.

              - **Name** *(string) --*

                The current state of the instance.

            - **StateTransitionReason** *(string) --*

              The reason for the most recent state transition. This might be an empty string.

            - **SubnetId** *(string) --*

              [EC2-VPC] The ID of the subnet in which the instance is running.

            - **VpcId** *(string) --*

              [EC2-VPC] The ID of the VPC in which the instance is running.

            - **Architecture** *(string) --*

              The architecture of the image.

            - **BlockDeviceMappings** *(list) --*

              Any block device mapping entries for the instance.

              - *(dict) --*

                Describes a block device mapping.

                - **DeviceName** *(string) --*

                  The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

                - **Ebs** *(dict) --*

                  Parameters used to automatically set up EBS volumes when the instance is launched.

                  - **AttachTime** *(datetime) --*

                    The time stamp when the attachment initiated.

                  - **DeleteOnTermination** *(boolean) --*

                    Indicates whether the volume is deleted on instance termination.

                  - **Status** *(string) --*

                    The attachment state.

                  - **VolumeId** *(string) --*

                    The ID of the EBS volume.

            - **ClientToken** *(string) --*

              The idempotency token you provided when you launched the instance, if applicable.

            - **EbsOptimized** *(boolean) --*

              Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
              provides dedicated throughput to Amazon EBS and an optimized configuration stack to
              provide optimal I/O performance. This optimization isn't available with all instance
              types. Additional usage charges apply when using an EBS Optimized instance.

            - **EnaSupport** *(boolean) --*

              Specifies whether enhanced networking with ENA is enabled.

            - **Hypervisor** *(string) --*

              The hypervisor type of the instance.

            - **IamInstanceProfile** *(dict) --*

              The IAM instance profile associated with the instance, if applicable.

              - **Arn** *(string) --*

                The Amazon Resource Name (ARN) of the instance profile.

              - **Id** *(string) --*

                The ID of the instance profile.

            - **InstanceLifecycle** *(string) --*

              Indicates whether this is a Spot Instance or a Scheduled Instance.

            - **ElasticGpuAssociations** *(list) --*

              The Elastic GPU associated with the instance.

              - *(dict) --*

                Describes the association between an instance and an Elastic Graphics accelerator.

                - **ElasticGpuId** *(string) --*

                  The ID of the Elastic Graphics accelerator.

                - **ElasticGpuAssociationId** *(string) --*

                  The ID of the association.

                - **ElasticGpuAssociationState** *(string) --*

                  The state of the association between the instance and the Elastic Graphics
                  accelerator.

                - **ElasticGpuAssociationTime** *(string) --*

                  The time the Elastic Graphics accelerator was associated with the instance.

            - **ElasticInferenceAcceleratorAssociations** *(list) --*

              The elastic inference accelerator associated with the instance.

              - *(dict) --*

                Describes the association between an instance and an elastic inference accelerator.

                - **ElasticInferenceAcceleratorArn** *(string) --*

                  The Amazon Resource Name (ARN) of the elastic inference accelerator.

                - **ElasticInferenceAcceleratorAssociationId** *(string) --*

                  The ID of the association.

                - **ElasticInferenceAcceleratorAssociationState** *(string) --*

                  The state of the elastic inference accelerator.

                - **ElasticInferenceAcceleratorAssociationTime** *(datetime) --*

                  The time at which the elastic inference accelerator is associated with an
                  instance.

            - **NetworkInterfaces** *(list) --*

              [EC2-VPC] The network interfaces for the instance.

              - *(dict) --*

                Describes a network interface.

                - **Association** *(dict) --*

                  The association information for an Elastic IPv4 associated with the network
                  interface.

                  - **IpOwnerId** *(string) --*

                    The ID of the owner of the Elastic IP address.

                  - **PublicDnsName** *(string) --*

                    The public DNS name.

                  - **PublicIp** *(string) --*

                    The public IP address or Elastic IP address bound to the network interface.

                - **Attachment** *(dict) --*

                  The network interface attachment.

                  - **AttachTime** *(datetime) --*

                    The time stamp when the attachment initiated.

                  - **AttachmentId** *(string) --*

                    The ID of the network interface attachment.

                  - **DeleteOnTermination** *(boolean) --*

                    Indicates whether the network interface is deleted when the instance is
                    terminated.

                  - **DeviceIndex** *(integer) --*

                    The index of the device on the instance for the network interface attachment.

                  - **Status** *(string) --*

                    The attachment state.

                - **Description** *(string) --*

                  The description.

                - **Groups** *(list) --*

                  One or more security groups.

                  - *(dict) --*

                    Describes a security group.

                    - **GroupName** *(string) --*

                      The name of the security group.

                    - **GroupId** *(string) --*

                      The ID of the security group.

                - **Ipv6Addresses** *(list) --*

                  One or more IPv6 addresses associated with the network interface.

                  - *(dict) --*

                    Describes an IPv6 address.

                    - **Ipv6Address** *(string) --*

                      The IPv6 address.

                - **MacAddress** *(string) --*

                  The MAC address.

                - **NetworkInterfaceId** *(string) --*

                  The ID of the network interface.

                - **OwnerId** *(string) --*

                  The ID of the AWS account that created the network interface.

                - **PrivateDnsName** *(string) --*

                  The private DNS name.

                - **PrivateIpAddress** *(string) --*

                  The IPv4 address of the network interface within the subnet.

                - **PrivateIpAddresses** *(list) --*

                  One or more private IPv4 addresses associated with the network interface.

                  - *(dict) --*

                    Describes a private IPv4 address.

                    - **Association** *(dict) --*

                      The association information for an Elastic IP address for the network
                      interface.

                      - **IpOwnerId** *(string) --*

                        The ID of the owner of the Elastic IP address.

                      - **PublicDnsName** *(string) --*

                        The public DNS name.

                      - **PublicIp** *(string) --*

                        The public IP address or Elastic IP address bound to the network interface.

                    - **Primary** *(boolean) --*

                      Indicates whether this IPv4 address is the primary private IP address of the
                      network interface.

                    - **PrivateDnsName** *(string) --*

                      The private IPv4 DNS name.

                    - **PrivateIpAddress** *(string) --*

                      The private IPv4 address of the network interface.

                - **SourceDestCheck** *(boolean) --*

                  Indicates whether to validate network traffic to or from this network interface.

                - **Status** *(string) --*

                  The status of the network interface.

                - **SubnetId** *(string) --*

                  The ID of the subnet.

                - **VpcId** *(string) --*

                  The ID of the VPC.

                - **InterfaceType** *(string) --*

                  Describes the type of network interface.

                  Valid values: ``interface`` | ``efa``

            - **RootDeviceName** *(string) --*

              The device name of the root device volume (for example, ``/dev/sda1`` ).

            - **RootDeviceType** *(string) --*

              The root device type used by the AMI. The AMI can use an EBS volume or an instance
              store volume.

            - **SecurityGroups** *(list) --*

              The security groups for the instance.

              - *(dict) --*

                Describes a security group.

                - **GroupName** *(string) --*

                  The name of the security group.

                - **GroupId** *(string) --*

                  The ID of the security group.

            - **SourceDestCheck** *(boolean) --*

              Specifies whether to enable an instance launched in a VPC to perform NAT. This
              controls whether source/destination checking is enabled on the instance. A value of
              ``true`` means that checking is enabled, and ``false`` means that checking is
              disabled. The value must be ``false`` for the instance to perform NAT. For more
              information, see `NAT Instances
              <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in
              the *Amazon Virtual Private Cloud User Guide* .

            - **SpotInstanceRequestId** *(string) --*

              If the request is a Spot Instance request, the ID of the request.

            - **SriovNetSupport** *(string) --*

              Specifies whether enhanced networking with the Intel 82599 Virtual Function interface
              is enabled.

            - **StateReason** *(dict) --*

              The reason for the most recent state transition.

              - **Code** *(string) --*

                The reason code for the state change.

              - **Message** *(string) --*

                The message for the state change.

                * ``Server.InsufficientInstanceCapacity`` : There was insufficient capacity
                available to satisfy the launch request.

                * ``Server.InternalError`` : An internal error caused the instance to terminate
                during launch.

                * ``Server.ScheduledStop`` : The instance was stopped due to a scheduled retirement.

                * ``Server.SpotInstanceShutdown`` : The instance was stopped because the number of
                Spot requests with a maximum price equal to or higher than the Spot price exceeded
                available capacity or because of an increase in the Spot price.

                * ``Server.SpotInstanceTermination`` : The instance was terminated because the
                number of Spot requests with a maximum price equal to or higher than the Spot price
                exceeded available capacity or because of an increase in the Spot price.

                * ``Client.InstanceInitiatedShutdown`` : The instance was shut down using the
                ``shutdown -h`` command from the instance.

                * ``Client.InstanceTerminated`` : The instance was terminated or rebooted during
                AMI creation.

                * ``Client.InternalError`` : A client error caused the instance to terminate during
                launch.

                * ``Client.InvalidSnapshot.NotFound`` : The specified snapshot was not found.

                * ``Client.UserInitiatedHibernate`` : Hibernation was initiated on the instance.

                * ``Client.UserInitiatedShutdown`` : The instance was shut down using the Amazon
                EC2 API.

                * ``Client.VolumeLimitExceeded`` : The limit on the number of EBS volumes or total
                storage was exceeded. Decrease usage or request an increase in your account limits.

            - **Tags** *(list) --*

              Any tags assigned to the instance.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                  characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                  characters.

            - **VirtualizationType** *(string) --*

              The virtualization type of the instance.

            - **CpuOptions** *(dict) --*

              The CPU options for the instance.

              - **CoreCount** *(integer) --*

                The number of CPU cores for the instance.

              - **ThreadsPerCore** *(integer) --*

                The number of threads per CPU core.

            - **CapacityReservationId** *(string) --*

              The ID of the Capacity Reservation.

            - **CapacityReservationSpecification** *(dict) --*

              Information about the Capacity Reservation targeting option.

              - **CapacityReservationPreference** *(string) --*

                Describes the instance's Capacity Reservation preferences. Possible preferences
                include:

                * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
                matching attributes (instance type, platform, Availability Zone).

                * ``none`` - The instance avoids running in a Capacity Reservation even if one is
                available. The instance runs in On-Demand capacity.

              - **CapacityReservationTarget** *(dict) --*

                Information about the targeted Capacity Reservation.

                - **CapacityReservationId** *(string) --*

                  The ID of the Capacity Reservation.

            - **HibernationOptions** *(dict) --*

              Indicates whether the instance is enabled for hibernation.

              - **Configured** *(boolean) --*

                If this parameter is set to ``true`` , your instance is enabled for hibernation;
                otherwise, it is not enabled for hibernation.

            - **Licenses** *(list) --*

              The license configurations.

              - *(dict) --*

                Describes a license configuration.

                - **LicenseConfigurationArn** *(string) --*

                  The Amazon Resource Name (ARN) of the license configuration.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the reservation.

        - **RequesterId** *(string) --*

          The ID of the requester that launched the instances on your behalf (for example, AWS
          Management Console or Auto Scaling).

        - **ReservationId** *(string) --*

          The ID of the reservation.
    """


_DescribeInternetGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInternetGatewaysPaginateFiltersTypeDef(
    _DescribeInternetGatewaysPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeInternetGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInternetGatewaysPaginatePaginationConfigTypeDef(
    _DescribeInternetGatewaysPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef",
    {"State": str, "VpcId": str},
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginateResponseInternetGateways` `Attachments`

    Describes the attachment of a VPC to an internet gateway or an egress-only internet
    gateway.

    - **State** *(string) --*

      The current state of the attachment. For an internet gateway, the state is
      ``available`` when attached to a VPC; otherwise, this value is not returned.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginateResponseInternetGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef",
    {
        "Attachments": List[
            DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef
        ],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[
            DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef
        ],
    },
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginateResponse` `InternetGateways`

    Describes an internet gateway.

    - **Attachments** *(list) --*

      Any VPCs attached to the internet gateway.

      - *(dict) --*

        Describes the attachment of a VPC to an internet gateway or an egress-only internet
        gateway.

        - **State** *(string) --*

          The current state of the attachment. For an internet gateway, the state is
          ``available`` when attached to a VPC; otherwise, this value is not returned.

        - **VpcId** *(string) --*

          The ID of the VPC.

    - **InternetGatewayId** *(string) --*

      The ID of the internet gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the internet gateway.

    - **Tags** *(list) --*

      Any tags assigned to the internet gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeInternetGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseTypeDef",
    {
        "InternetGateways": List[
            DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef
        ]
    },
    total=False,
)


class DescribeInternetGatewaysPaginateResponseTypeDef(
    _DescribeInternetGatewaysPaginateResponseTypeDef
):
    """
    Type definition for `DescribeInternetGatewaysPaginate` `Response`

    - **InternetGateways** *(list) --*

      Information about one or more internet gateways.

      - *(dict) --*

        Describes an internet gateway.

        - **Attachments** *(list) --*

          Any VPCs attached to the internet gateway.

          - *(dict) --*

            Describes the attachment of a VPC to an internet gateway or an egress-only internet
            gateway.

            - **State** *(string) --*

              The current state of the attachment. For an internet gateway, the state is
              ``available`` when attached to a VPC; otherwise, this value is not returned.

            - **VpcId** *(string) --*

              The ID of the VPC.

        - **InternetGatewayId** *(string) --*

          The ID of the internet gateway.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the internet gateway.

        - **Tags** *(list) --*

          Any tags assigned to the internet gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeLaunchTemplateVersionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateFiltersTypeDef(
    _DescribeLaunchTemplateVersionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef(
    _DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappings` `Ebs`

    Information about the block device for an EBS volume.

    - **Encrypted** *(boolean) --*

      Indicates whether the EBS volume is encrypted.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports.

    - **KmsKeyId** *(string) --*

      The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **VolumeType** *(string) --*

      The volume type.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name.

    - **VirtualName** *(string) --*

      The virtual device name (ephemeralN).

    - **Ebs** *(dict) --*

      Information about the block device for an EBS volume.

      - **Encrypted** *(boolean) --*

        Indicates whether the EBS volume is encrypted.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports.

      - **KmsKeyId** *(string) --*

        The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

      - **VolumeType** *(string) --*

        The volume type.

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option.

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences
      include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
      matching attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is
      available. The instance runs in On-Demand capacity.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `CreditSpecification`

    The credit option for CPU usage of the instance.

    - **CpuCredits** *(string) --*

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
      and ``unlimited`` .
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `ElasticGpuSpecifications`

    Describes an elastic GPU.

    - **Type** *(string) --*

      The elastic GPU type.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --*

      The type of elastic inference accelerator. The possible values are eia1.medium,
      eia1.large, and eia1.xlarge.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `HibernationOptions`

    Indicates whether an instance is configured for hibernation. For more information, see
    `Hibernate Your Instance
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
    Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If this parameter is set to ``true`` , the instance is enabled for hibernation;
      otherwise, it is not enabled for hibernation.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type.

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in
      minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active
      until all instances launch, the request is canceled, or this date is reached. If
      the request is persistent, it remains active until it is canceled or this date and
      time is reached.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type.

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in
        minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active
        until all instances launch, the request is canceled, or this date is reached. If
        the request is persistent, it remains active until it is canceled or this date and
        time is reached.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `Monitoring`

    The monitoring for the instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to associate a public IPv4 address with eth0 for a new network
      interface.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **Description** *(string) --*

      A description for the network interface.

    - **DeviceIndex** *(integer) --*

      The device index for the network interface attachment.

    - **Groups** *(list) --*

      The IDs of one or more security groups.

      - *(string) --*

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6AddressCount** *(integer) --*

      The number of IPv6 addresses for the network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses for the network interface.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The primary private IPv4 address of the network interface.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses for the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet for the network interface.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `Placement`

    The placement of the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host.

    - **GroupName** *(string) --*

      The name of the placement group for the instance.

    - **HostId** *(string) --*

      The ID of the Dedicated Host for the instance.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateData` `TagSpecifications`

    The tag specification for the launch template.

    - **ResourceType** *(string) --*

      The type of resource.

    - **Tags** *(list) --*

      The tags for the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": str,
        "KeyName": str,
        "Monitoring": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef,
        "Placement": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": str,
        "UserData": str,
        "TagSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersions` `LaunchTemplateData`

    Information about the launch template.

    - **KernelId** *(string) --*

      The ID of the kernel, if applicable.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **BlockDeviceMappings** *(list) --*

      The block device mappings.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name.

        - **VirtualName** *(string) --*

          The virtual device name (ephemeralN).

        - **Ebs** *(dict) --*

          Information about the block device for an EBS volume.

          - **Encrypted** *(boolean) --*

            Indicates whether the EBS volume is encrypted.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports.

          - **KmsKeyId** *(string) --*

            The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

          - **VolumeType** *(string) --*

            The volume type.

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **NetworkInterfaces** *(list) --*

      The network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to associate a public IPv4 address with eth0 for a new network
          interface.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the network interface is deleted when the instance is terminated.

        - **Description** *(string) --*

          A description for the network interface.

        - **DeviceIndex** *(integer) --*

          The device index for the network interface attachment.

        - **Groups** *(list) --*

          The IDs of one or more security groups.

          - *(string) --*

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6AddressCount** *(integer) --*

          The number of IPv6 addresses for the network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses for the network interface.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The primary private IPv4 address of the network interface.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses for the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet for the network interface.

    - **ImageId** *(string) --*

      The ID of the AMI that was used to launch the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.

    - **Placement** *(dict) --*

      The placement of the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.

      - **Affinity** *(string) --*

        The affinity setting for the instance on the Dedicated Host.

      - **GroupName** *(string) --*

        The name of the placement group for the instance.

      - **HostId** *(string) --*

        The ID of the Dedicated Host for the instance.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware.

      - **SpreadDomain** *(string) --*

        Reserved for future use.

    - **RamDiskId** *(string) --*

      The ID of the RAM disk, if applicable.

    - **DisableApiTermination** *(boolean) --*

      If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
      EC2 console, command line tool, or API.

    - **InstanceInitiatedShutdownBehavior** *(string) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

    - **UserData** *(string) --*

      The user data for the instance.

    - **TagSpecifications** *(list) --*

      The tags.

      - *(dict) --*

        The tag specification for the launch template.

        - **ResourceType** *(string) --*

          The type of resource.

        - **Tags** *(list) --*

          The tags for the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

    - **ElasticGpuSpecifications** *(list) --*

      The elastic GPU specification.

      - *(dict) --*

        Describes an elastic GPU.

        - **Type** *(string) --*

          The elastic GPU type.

    - **ElasticInferenceAccelerators** *(list) --*

      The elastic inference accelerator for the instance.

      - *(dict) --*

        Describes an elastic inference accelerator.

        - **Type** *(string) --*

          The type of elastic inference accelerator. The possible values are eia1.medium,
          eia1.large, and eia1.xlarge.

    - **SecurityGroupIds** *(list) --*

      The security group IDs.

      - *(string) --*

    - **SecurityGroups** *(list) --*

      The security group names.

      - *(string) --*

    - **InstanceMarketOptions** *(dict) --*

      The market (purchasing) option for the instances.

      - **MarketType** *(string) --*

        The market type.

      - **SpotOptions** *(dict) --*

        The options for Spot Instances.

        - **MaxPrice** *(string) --*

          The maximum hourly price you're willing to pay for the Spot Instances.

        - **SpotInstanceType** *(string) --*

          The Spot Instance request type.

        - **BlockDurationMinutes** *(integer) --*

          The required duration for the Spot Instances (also known as Spot blocks), in
          minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

        - **ValidUntil** *(datetime) --*

          The end date of the request. For a one-time request, the request remains active
          until all instances launch, the request is canceled, or this date is reached. If
          the request is persistent, it remains active until it is canceled or this date and
          time is reached.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.

    - **CreditSpecification** *(dict) --*

      The credit option for CPU usage of the instance.

      - **CpuCredits** *(string) --*

        The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
        and ``unlimited`` .

    - **CpuOptions** *(dict) --*

      The CPU options for the instance. For more information, see `Optimizing CPU Options
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      - **CoreCount** *(integer) --*

        The number of CPU cores for the instance.

      - **ThreadsPerCore** *(integer) --*

        The number of threads per CPU core.

    - **CapacityReservationSpecification** *(dict) --*

      Information about the Capacity Reservation targeting option.

      - **CapacityReservationPreference** *(string) --*

        Indicates the instance's Capacity Reservation preferences. Possible preferences
        include:

        * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
        matching attributes (instance type, platform, Availability Zone).

        * ``none`` - The instance avoids running in a Capacity Reservation even if one is
        available. The instance runs in On-Demand capacity.

      - **CapacityReservationTarget** *(dict) --*

        Information about the target Capacity Reservation.

        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.

    - **LicenseSpecifications** *(list) --*

      The license configurations.

      - *(dict) --*

        Describes a license configuration.

        - **LicenseConfigurationArn** *(string) --*

          The Amazon Resource Name (ARN) of the license configuration.

    - **HibernationOptions** *(dict) --*

      Indicates whether an instance is configured for hibernation. For more information, see
      `Hibernate Your Instance
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      - **Configured** *(boolean) --*

        If this parameter is set to ``true`` , the instance is enabled for hibernation;
        otherwise, it is not enabled for hibernation.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginateResponse` `LaunchTemplateVersions`

    Describes a launch template version.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **VersionNumber** *(integer) --*

      The version number.

    - **VersionDescription** *(string) --*

      The description for the version.

    - **CreateTime** *(datetime) --*

      The time the version was created.

    - **CreatedBy** *(string) --*

      The principal that created the version.

    - **DefaultVersion** *(boolean) --*

      Indicates whether the version is the default version.

    - **LaunchTemplateData** *(dict) --*

      Information about the launch template.

      - **KernelId** *(string) --*

        The ID of the kernel, if applicable.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for Amazon EBS I/O.

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **BlockDeviceMappings** *(list) --*

        The block device mappings.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name.

          - **VirtualName** *(string) --*

            The virtual device name (ephemeralN).

          - **Ebs** *(dict) --*

            Information about the block device for an EBS volume.

            - **Encrypted** *(boolean) --*

              Indicates whether the EBS volume is encrypted.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports.

            - **KmsKeyId** *(string) --*

              The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

            - **VolumeType** *(string) --*

              The volume type.

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **NetworkInterfaces** *(list) --*

        The network interfaces.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to associate a public IPv4 address with eth0 for a new network
            interface.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **Description** *(string) --*

            A description for the network interface.

          - **DeviceIndex** *(integer) --*

            The device index for the network interface attachment.

          - **Groups** *(list) --*

            The IDs of one or more security groups.

            - *(string) --*

          - **InterfaceType** *(string) --*

            The type of network interface.

          - **Ipv6AddressCount** *(integer) --*

            The number of IPv6 addresses for the network interface.

          - **Ipv6Addresses** *(list) --*

            The IPv6 addresses for the network interface.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The primary private IPv4 address of the network interface.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses for the network interface.

          - **SubnetId** *(string) --*

            The ID of the subnet for the network interface.

      - **ImageId** *(string) --*

        The ID of the AMI that was used to launch the instance.

      - **InstanceType** *(string) --*

        The instance type.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **Monitoring** *(dict) --*

        The monitoring for the instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

      - **Placement** *(dict) --*

        The placement of the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the instance.

        - **Affinity** *(string) --*

          The affinity setting for the instance on the Dedicated Host.

        - **GroupName** *(string) --*

          The name of the placement group for the instance.

        - **HostId** *(string) --*

          The ID of the Dedicated Host for the instance.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware.

        - **SpreadDomain** *(string) --*

          Reserved for future use.

      - **RamDiskId** *(string) --*

        The ID of the RAM disk, if applicable.

      - **DisableApiTermination** *(boolean) --*

        If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
        EC2 console, command line tool, or API.

      - **InstanceInitiatedShutdownBehavior** *(string) --*

        Indicates whether an instance stops or terminates when you initiate shutdown from the
        instance (using the operating system command for system shutdown).

      - **UserData** *(string) --*

        The user data for the instance.

      - **TagSpecifications** *(list) --*

        The tags.

        - *(dict) --*

          The tag specification for the launch template.

          - **ResourceType** *(string) --*

            The type of resource.

          - **Tags** *(list) --*

            The tags for the resource.

            - *(dict) --*

              Describes a tag.

              - **Key** *(string) --*

                The key of the tag.

                Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                characters. May not begin with ``aws:`` .

              - **Value** *(string) --*

                The value of the tag.

                Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                characters.

      - **ElasticGpuSpecifications** *(list) --*

        The elastic GPU specification.

        - *(dict) --*

          Describes an elastic GPU.

          - **Type** *(string) --*

            The elastic GPU type.

      - **ElasticInferenceAccelerators** *(list) --*

        The elastic inference accelerator for the instance.

        - *(dict) --*

          Describes an elastic inference accelerator.

          - **Type** *(string) --*

            The type of elastic inference accelerator. The possible values are eia1.medium,
            eia1.large, and eia1.xlarge.

      - **SecurityGroupIds** *(list) --*

        The security group IDs.

        - *(string) --*

      - **SecurityGroups** *(list) --*

        The security group names.

        - *(string) --*

      - **InstanceMarketOptions** *(dict) --*

        The market (purchasing) option for the instances.

        - **MarketType** *(string) --*

          The market type.

        - **SpotOptions** *(dict) --*

          The options for Spot Instances.

          - **MaxPrice** *(string) --*

            The maximum hourly price you're willing to pay for the Spot Instances.

          - **SpotInstanceType** *(string) --*

            The Spot Instance request type.

          - **BlockDurationMinutes** *(integer) --*

            The required duration for the Spot Instances (also known as Spot blocks), in
            minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

          - **ValidUntil** *(datetime) --*

            The end date of the request. For a one-time request, the request remains active
            until all instances launch, the request is canceled, or this date is reached. If
            the request is persistent, it remains active until it is canceled or this date and
            time is reached.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted.

      - **CreditSpecification** *(dict) --*

        The credit option for CPU usage of the instance.

        - **CpuCredits** *(string) --*

          The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
          and ``unlimited`` .

      - **CpuOptions** *(dict) --*

        The CPU options for the instance. For more information, see `Optimizing CPU Options
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        - **CoreCount** *(integer) --*

          The number of CPU cores for the instance.

        - **ThreadsPerCore** *(integer) --*

          The number of threads per CPU core.

      - **CapacityReservationSpecification** *(dict) --*

        Information about the Capacity Reservation targeting option.

        - **CapacityReservationPreference** *(string) --*

          Indicates the instance's Capacity Reservation preferences. Possible preferences
          include:

          * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
          matching attributes (instance type, platform, Availability Zone).

          * ``none`` - The instance avoids running in a Capacity Reservation even if one is
          available. The instance runs in On-Demand capacity.

        - **CapacityReservationTarget** *(dict) --*

          Information about the target Capacity Reservation.

          - **CapacityReservationId** *(string) --*

            The ID of the Capacity Reservation.

      - **LicenseSpecifications** *(list) --*

        The license configurations.

        - *(dict) --*

          Describes a license configuration.

          - **LicenseConfigurationArn** *(string) --*

            The Amazon Resource Name (ARN) of the license configuration.

      - **HibernationOptions** *(dict) --*

        Indicates whether an instance is configured for hibernation. For more information, see
        `Hibernate Your Instance
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        - **Configured** *(boolean) --*

          If this parameter is set to ``true`` , the instance is enabled for hibernation;
          otherwise, it is not enabled for hibernation.
    """


_DescribeLaunchTemplateVersionsPaginateResponseTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseTypeDef",
    {
        "LaunchTemplateVersions": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef
        ]
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeLaunchTemplateVersionsPaginate` `Response`

    - **LaunchTemplateVersions** *(list) --*

      Information about the launch template versions.

      - *(dict) --*

        Describes a launch template version.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **VersionNumber** *(integer) --*

          The version number.

        - **VersionDescription** *(string) --*

          The description for the version.

        - **CreateTime** *(datetime) --*

          The time the version was created.

        - **CreatedBy** *(string) --*

          The principal that created the version.

        - **DefaultVersion** *(boolean) --*

          Indicates whether the version is the default version.

        - **LaunchTemplateData** *(dict) --*

          Information about the launch template.

          - **KernelId** *(string) --*

            The ID of the kernel, if applicable.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instance is optimized for Amazon EBS I/O.

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **BlockDeviceMappings** *(list) --*

            The block device mappings.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name.

              - **VirtualName** *(string) --*

                The virtual device name (ephemeralN).

              - **Ebs** *(dict) --*

                Information about the block device for an EBS volume.

                - **Encrypted** *(boolean) --*

                  Indicates whether the EBS volume is encrypted.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports.

                - **KmsKeyId** *(string) --*

                  The ARN of the AWS Key Management Service (AWS KMS) CMK used for encryption.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                - **VolumeType** *(string) --*

                  The volume type.

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **NetworkInterfaces** *(list) --*

            The network interfaces.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to associate a public IPv4 address with eth0 for a new network
                interface.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the network interface is deleted when the instance is terminated.

              - **Description** *(string) --*

                A description for the network interface.

              - **DeviceIndex** *(integer) --*

                The device index for the network interface attachment.

              - **Groups** *(list) --*

                The IDs of one or more security groups.

                - *(string) --*

              - **InterfaceType** *(string) --*

                The type of network interface.

              - **Ipv6AddressCount** *(integer) --*

                The number of IPv6 addresses for the network interface.

              - **Ipv6Addresses** *(list) --*

                The IPv6 addresses for the network interface.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The primary private IPv4 address of the network interface.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4 address.
                    Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses for the network interface.

              - **SubnetId** *(string) --*

                The ID of the subnet for the network interface.

          - **ImageId** *(string) --*

            The ID of the AMI that was used to launch the instance.

          - **InstanceType** *(string) --*

            The instance type.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **Monitoring** *(dict) --*

            The monitoring for the instance.

            - **Enabled** *(boolean) --*

              Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
              enabled.

          - **Placement** *(dict) --*

            The placement of the instance.

            - **AvailabilityZone** *(string) --*

              The Availability Zone of the instance.

            - **Affinity** *(string) --*

              The affinity setting for the instance on the Dedicated Host.

            - **GroupName** *(string) --*

              The name of the placement group for the instance.

            - **HostId** *(string) --*

              The ID of the Dedicated Host for the instance.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance with a
              tenancy of ``dedicated`` runs on single-tenant hardware.

            - **SpreadDomain** *(string) --*

              Reserved for future use.

          - **RamDiskId** *(string) --*

            The ID of the RAM disk, if applicable.

          - **DisableApiTermination** *(boolean) --*

            If set to ``true`` , indicates that the instance cannot be terminated using the Amazon
            EC2 console, command line tool, or API.

          - **InstanceInitiatedShutdownBehavior** *(string) --*

            Indicates whether an instance stops or terminates when you initiate shutdown from the
            instance (using the operating system command for system shutdown).

          - **UserData** *(string) --*

            The user data for the instance.

          - **TagSpecifications** *(list) --*

            The tags.

            - *(dict) --*

              The tag specification for the launch template.

              - **ResourceType** *(string) --*

                The type of resource.

              - **Tags** *(list) --*

                The tags for the resource.

                - *(dict) --*

                  Describes a tag.

                  - **Key** *(string) --*

                    The key of the tag.

                    Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
                    characters. May not begin with ``aws:`` .

                  - **Value** *(string) --*

                    The value of the tag.

                    Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
                    characters.

          - **ElasticGpuSpecifications** *(list) --*

            The elastic GPU specification.

            - *(dict) --*

              Describes an elastic GPU.

              - **Type** *(string) --*

                The elastic GPU type.

          - **ElasticInferenceAccelerators** *(list) --*

            The elastic inference accelerator for the instance.

            - *(dict) --*

              Describes an elastic inference accelerator.

              - **Type** *(string) --*

                The type of elastic inference accelerator. The possible values are eia1.medium,
                eia1.large, and eia1.xlarge.

          - **SecurityGroupIds** *(list) --*

            The security group IDs.

            - *(string) --*

          - **SecurityGroups** *(list) --*

            The security group names.

            - *(string) --*

          - **InstanceMarketOptions** *(dict) --*

            The market (purchasing) option for the instances.

            - **MarketType** *(string) --*

              The market type.

            - **SpotOptions** *(dict) --*

              The options for Spot Instances.

              - **MaxPrice** *(string) --*

                The maximum hourly price you're willing to pay for the Spot Instances.

              - **SpotInstanceType** *(string) --*

                The Spot Instance request type.

              - **BlockDurationMinutes** *(integer) --*

                The required duration for the Spot Instances (also known as Spot blocks), in
                minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

              - **ValidUntil** *(datetime) --*

                The end date of the request. For a one-time request, the request remains active
                until all instances launch, the request is canceled, or this date is reached. If
                the request is persistent, it remains active until it is canceled or this date and
                time is reached.

              - **InstanceInterruptionBehavior** *(string) --*

                The behavior when a Spot Instance is interrupted.

          - **CreditSpecification** *(dict) --*

            The credit option for CPU usage of the instance.

            - **CpuCredits** *(string) --*

              The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard``
              and ``unlimited`` .

          - **CpuOptions** *(dict) --*

            The CPU options for the instance. For more information, see `Optimizing CPU Options
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            - **CoreCount** *(integer) --*

              The number of CPU cores for the instance.

            - **ThreadsPerCore** *(integer) --*

              The number of threads per CPU core.

          - **CapacityReservationSpecification** *(dict) --*

            Information about the Capacity Reservation targeting option.

            - **CapacityReservationPreference** *(string) --*

              Indicates the instance's Capacity Reservation preferences. Possible preferences
              include:

              * ``open`` - The instance can run in any ``open`` Capacity Reservation that has
              matching attributes (instance type, platform, Availability Zone).

              * ``none`` - The instance avoids running in a Capacity Reservation even if one is
              available. The instance runs in On-Demand capacity.

            - **CapacityReservationTarget** *(dict) --*

              Information about the target Capacity Reservation.

              - **CapacityReservationId** *(string) --*

                The ID of the Capacity Reservation.

          - **LicenseSpecifications** *(list) --*

            The license configurations.

            - *(dict) --*

              Describes a license configuration.

              - **LicenseConfigurationArn** *(string) --*

                The Amazon Resource Name (ARN) of the license configuration.

          - **HibernationOptions** *(dict) --*

            Indicates whether an instance is configured for hibernation. For more information, see
            `Hibernate Your Instance
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the *Amazon
            Elastic Compute Cloud User Guide* .

            - **Configured** *(boolean) --*

              If this parameter is set to ``true`` , the instance is enabled for hibernation;
              otherwise, it is not enabled for hibernation.
    """


_DescribeLaunchTemplatesPaginateFiltersTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeLaunchTemplatesPaginateFiltersTypeDef(
    _DescribeLaunchTemplatesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeLaunchTemplatesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeLaunchTemplatesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeLaunchTemplatesPaginatePaginationConfigTypeDef(
    _DescribeLaunchTemplatesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeLaunchTemplatesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef(
    _DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef
):
    """
    Type definition for `DescribeLaunchTemplatesPaginateResponseLaunchTemplates` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef],
    },
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef(
    _DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef
):
    """
    Type definition for `DescribeLaunchTemplatesPaginateResponse` `LaunchTemplates`

    Describes a launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **CreateTime** *(datetime) --*

      The time launch template was created.

    - **CreatedBy** *(string) --*

      The principal that created the launch template.

    - **DefaultVersionNumber** *(integer) --*

      The version number of the default version of the launch template.

    - **LatestVersionNumber** *(integer) --*

      The version number of the latest version of the launch template.

    - **Tags** *(list) --*

      The tags for the launch template.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeLaunchTemplatesPaginateResponseTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseTypeDef",
    {
        "LaunchTemplates": List[
            DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef
        ]
    },
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseTypeDef(
    _DescribeLaunchTemplatesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeLaunchTemplatesPaginate` `Response`

    - **LaunchTemplates** *(list) --*

      Information about the launch templates.

      - *(dict) --*

        Describes a launch template.

        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.

        - **LaunchTemplateName** *(string) --*

          The name of the launch template.

        - **CreateTime** *(datetime) --*

          The time launch template was created.

        - **CreatedBy** *(string) --*

          The principal that created the launch template.

        - **DefaultVersionNumber** *(integer) --*

          The version number of the default version of the launch template.

        - **LatestVersionNumber** *(integer) --*

          The version number of the latest version of the launch template.

        - **Tags** *(list) --*

          The tags for the launch template.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeMovingAddressesPaginateFiltersTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeMovingAddressesPaginateFiltersTypeDef(
    _DescribeMovingAddressesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeMovingAddressesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeMovingAddressesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeMovingAddressesPaginatePaginationConfigTypeDef(
    _DescribeMovingAddressesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeMovingAddressesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef",
    {"MoveStatus": str, "PublicIp": str},
    total=False,
)


class DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef(
    _DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef
):
    """
    Type definition for `DescribeMovingAddressesPaginateResponse` `MovingAddressStatuses`

    Describes the status of a moving Elastic IP address.

    - **MoveStatus** *(string) --*

      The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
      restored to the EC2-Classic platform.

    - **PublicIp** *(string) --*

      The Elastic IP address.
    """


_DescribeMovingAddressesPaginateResponseTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateResponseTypeDef",
    {
        "MovingAddressStatuses": List[
            DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef
        ]
    },
    total=False,
)


class DescribeMovingAddressesPaginateResponseTypeDef(
    _DescribeMovingAddressesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeMovingAddressesPaginate` `Response`

    - **MovingAddressStatuses** *(list) --*

      The status for each Elastic IP address.

      - *(dict) --*

        Describes the status of a moving Elastic IP address.

        - **MoveStatus** *(string) --*

          The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
          restored to the EC2-Classic platform.

        - **PublicIp** *(string) --*

          The Elastic IP address.
    """


_DescribeNatGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNatGatewaysPaginateFiltersTypeDef(
    _DescribeNatGatewaysPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeNatGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNatGatewaysPaginatePaginationConfigTypeDef(
    _DescribeNatGatewaysPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginateResponseNatGateways` `NatGatewayAddresses`

    Describes the IP addresses and network interface associated with a NAT gateway.

    - **AllocationId** *(string) --*

      The allocation ID of the Elastic IP address that's associated with the NAT gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface associated with the NAT gateway.

    - **PrivateIp** *(string) --*

      The private IP address associated with the Elastic IP address.

    - **PublicIp** *(string) --*

      The Elastic IP address associated with the NAT gateway.
    """


_DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginateResponseNatGateways` `ProvisionedBandwidth`

    Reserved. If you need to sustain traffic greater than the `documented limits
    <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
    through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **ProvisionTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Provisioned** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **RequestTime** *(datetime) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Requested** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **Status** *(string) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .
    """


_DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginateResponseNatGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef],
    },
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginateResponse` `NatGateways`

    Describes a NAT gateway.

    - **CreateTime** *(datetime) --*

      The date and time the NAT gateway was created.

    - **DeleteTime** *(datetime) --*

      The date and time the NAT gateway was deleted, if applicable.

    - **FailureCode** *(string) --*

      If the NAT gateway could not be created, specifies the error code for the failure.
      (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
      ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
      ``InvalidSubnetID.NotFound`` )

    - **FailureMessage** *(string) --*

      If the NAT gateway could not be created, specifies the error message for the failure,
      that corresponds to the error code.

      * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to
      create this NAT gateway"

      * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

      * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
      associated with this NAT gateway"

      * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
      associated"

      * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
      NAT gateway is in an invalid state. Please try again."

      * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
      could not be found."

    - **NatGatewayAddresses** *(list) --*

      Information about the IP addresses and network interface associated with the NAT gateway.

      - *(dict) --*

        Describes the IP addresses and network interface associated with a NAT gateway.

        - **AllocationId** *(string) --*

          The allocation ID of the Elastic IP address that's associated with the NAT gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface associated with the NAT gateway.

        - **PrivateIp** *(string) --*

          The private IP address associated with the Elastic IP address.

        - **PublicIp** *(string) --*

          The Elastic IP address associated with the NAT gateway.

    - **NatGatewayId** *(string) --*

      The ID of the NAT gateway.

    - **ProvisionedBandwidth** *(dict) --*

      Reserved. If you need to sustain traffic greater than the `documented limits
      <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
      through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **ProvisionTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Provisioned** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **RequestTime** *(datetime) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Requested** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

      - **Status** *(string) --*

        Reserved. If you need to sustain traffic greater than the `documented limits
        <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
        through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

    - **State** *(string) --*

      The state of the NAT gateway.

      * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

      * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
      ``failureMessage`` fields for the reason.

      * ``available`` : The NAT gateway is able to process traffic. This status remains until
      you delete the NAT gateway, and does not indicate the health of the NAT gateway.

      * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
      processing traffic.

      * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

    - **SubnetId** *(string) --*

      The ID of the subnet in which the NAT gateway is located.

    - **VpcId** *(string) --*

      The ID of the VPC in which the NAT gateway is located.

    - **Tags** *(list) --*

      The tags for the NAT gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeNatGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseTypeDef",
    {"NatGateways": List[DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef]},
    total=False,
)


class DescribeNatGatewaysPaginateResponseTypeDef(
    _DescribeNatGatewaysPaginateResponseTypeDef
):
    """
    Type definition for `DescribeNatGatewaysPaginate` `Response`

    - **NatGateways** *(list) --*

      Information about the NAT gateways.

      - *(dict) --*

        Describes a NAT gateway.

        - **CreateTime** *(datetime) --*

          The date and time the NAT gateway was created.

        - **DeleteTime** *(datetime) --*

          The date and time the NAT gateway was deleted, if applicable.

        - **FailureCode** *(string) --*

          If the NAT gateway could not be created, specifies the error code for the failure.
          (``InsufficientFreeAddressesInSubnet`` | ``Gateway.NotAttached`` |
          ``InvalidAllocationID.NotFound`` | ``Resource.AlreadyAssociated`` | ``InternalError`` |
          ``InvalidSubnetID.NotFound`` )

        - **FailureMessage** *(string) --*

          If the NAT gateway could not be created, specifies the error message for the failure,
          that corresponds to the error code.

          * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient free addresses to
          create this NAT gateway"

          * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet gateway attached"

          * For InvalidAllocationID.NotFound: "Elastic IP address eipalloc-xxxxxxxx could not be
          associated with this NAT gateway"

          * For Resource.AlreadyAssociated: "Elastic IP address eipalloc-xxxxxxxx is already
          associated"

          * For InternalError: "Network interface eni-xxxxxxxx, created and used internally by this
          NAT gateway is in an invalid state. Please try again."

          * For InvalidSubnetID.NotFound: "The specified subnet subnet-xxxxxxxx does not exist or
          could not be found."

        - **NatGatewayAddresses** *(list) --*

          Information about the IP addresses and network interface associated with the NAT gateway.

          - *(dict) --*

            Describes the IP addresses and network interface associated with a NAT gateway.

            - **AllocationId** *(string) --*

              The allocation ID of the Elastic IP address that's associated with the NAT gateway.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface associated with the NAT gateway.

            - **PrivateIp** *(string) --*

              The private IP address associated with the Elastic IP address.

            - **PublicIp** *(string) --*

              The Elastic IP address associated with the NAT gateway.

        - **NatGatewayId** *(string) --*

          The ID of the NAT gateway.

        - **ProvisionedBandwidth** *(dict) --*

          Reserved. If you need to sustain traffic greater than the `documented limits
          <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
          through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **ProvisionTime** *(datetime) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Provisioned** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **RequestTime** *(datetime) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Requested** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

          - **Status** *(string) --*

            Reserved. If you need to sustain traffic greater than the `documented limits
            <https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html>`__ , contact us
            through the `Support Center <https://console.aws.amazon.com/support/home?>`__ .

        - **State** *(string) --*

          The state of the NAT gateway.

          * ``pending`` : The NAT gateway is being created and is not ready to process traffic.

          * ``failed`` : The NAT gateway could not be created. Check the ``failureCode`` and
          ``failureMessage`` fields for the reason.

          * ``available`` : The NAT gateway is able to process traffic. This status remains until
          you delete the NAT gateway, and does not indicate the health of the NAT gateway.

          * ``deleting`` : The NAT gateway is in the process of being terminated and may still be
          processing traffic.

          * ``deleted`` : The NAT gateway has been terminated and is no longer processing traffic.

        - **SubnetId** *(string) --*

          The ID of the subnet in which the NAT gateway is located.

        - **VpcId** *(string) --*

          The ID of the VPC in which the NAT gateway is located.

        - **Tags** *(list) --*

          The tags for the NAT gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeNetworkAclsPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNetworkAclsPaginateFiltersTypeDef(
    _DescribeNetworkAclsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeNetworkAclsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkAclsPaginatePaginationConfigTypeDef(
    _DescribeNetworkAclsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponseNetworkAcls` `Associations`

    Describes an association between a network ACL and a subnet.

    - **NetworkAclAssociationId** *(string) --*

      The ID of the association between a network ACL and a subnet.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **SubnetId** *(string) --*

      The ID of the subnet.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponseNetworkAclsEntries` `IcmpTypeCode`

    ICMP protocol: The ICMP type and code.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponseNetworkAclsEntries` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to.

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": str,
        "RuleNumber": int,
    },
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponseNetworkAcls` `Entries`

    Describes an entry in a network ACL.

    - **CidrBlock** *(string) --*

      The IPv4 network range to allow or deny, in CIDR notation.

    - **Egress** *(boolean) --*

      Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

    - **IcmpTypeCode** *(dict) --*

      ICMP protocol: The ICMP type and code.

      - **Code** *(integer) --*

        The ICMP code. A value of -1 means all codes for the specified ICMP type.

      - **Type** *(integer) --*

        The ICMP type. A value of -1 means all types.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 network range to allow or deny, in CIDR notation.

    - **PortRange** *(dict) --*

      TCP or UDP protocols: The range of ports the rule applies to.

      - **From** *(integer) --*

        The first port in the range.

      - **To** *(integer) --*

        The last port in the range.

    - **Protocol** *(string) --*

      The protocol number. A value of "-1" means all protocols.

    - **RuleAction** *(string) --*

      Indicates whether to allow or deny the traffic that matches the rule.

    - **RuleNumber** *(integer) --*

      The rule number for the entry. ACL entries are processed in ascending order by rule
      number.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponseNetworkAcls` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef",
    {
        "Associations": List[
            DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef
        ],
        "Entries": List[DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginateResponse` `NetworkAcls`

    Describes a network ACL.

    - **Associations** *(list) --*

      Any associations between the network ACL and one or more subnets

      - *(dict) --*

        Describes an association between a network ACL and a subnet.

        - **NetworkAclAssociationId** *(string) --*

          The ID of the association between a network ACL and a subnet.

        - **NetworkAclId** *(string) --*

          The ID of the network ACL.

        - **SubnetId** *(string) --*

          The ID of the subnet.

    - **Entries** *(list) --*

      One or more entries (rules) in the network ACL.

      - *(dict) --*

        Describes an entry in a network ACL.

        - **CidrBlock** *(string) --*

          The IPv4 network range to allow or deny, in CIDR notation.

        - **Egress** *(boolean) --*

          Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

        - **IcmpTypeCode** *(dict) --*

          ICMP protocol: The ICMP type and code.

          - **Code** *(integer) --*

            The ICMP code. A value of -1 means all codes for the specified ICMP type.

          - **Type** *(integer) --*

            The ICMP type. A value of -1 means all types.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 network range to allow or deny, in CIDR notation.

        - **PortRange** *(dict) --*

          TCP or UDP protocols: The range of ports the rule applies to.

          - **From** *(integer) --*

            The first port in the range.

          - **To** *(integer) --*

            The last port in the range.

        - **Protocol** *(string) --*

          The protocol number. A value of "-1" means all protocols.

        - **RuleAction** *(string) --*

          Indicates whether to allow or deny the traffic that matches the rule.

        - **RuleNumber** *(integer) --*

          The rule number for the entry. ACL entries are processed in ascending order by rule
          number.

    - **IsDefault** *(boolean) --*

      Indicates whether this is the default network ACL for the VPC.

    - **NetworkAclId** *(string) --*

      The ID of the network ACL.

    - **Tags** *(list) --*

      Any tags assigned to the network ACL.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC for the network ACL.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the network ACL.
    """


_DescribeNetworkAclsPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseTypeDef",
    {"NetworkAcls": List[DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef]},
    total=False,
)


class DescribeNetworkAclsPaginateResponseTypeDef(
    _DescribeNetworkAclsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeNetworkAclsPaginate` `Response`

    - **NetworkAcls** *(list) --*

      Information about one or more network ACLs.

      - *(dict) --*

        Describes a network ACL.

        - **Associations** *(list) --*

          Any associations between the network ACL and one or more subnets

          - *(dict) --*

            Describes an association between a network ACL and a subnet.

            - **NetworkAclAssociationId** *(string) --*

              The ID of the association between a network ACL and a subnet.

            - **NetworkAclId** *(string) --*

              The ID of the network ACL.

            - **SubnetId** *(string) --*

              The ID of the subnet.

        - **Entries** *(list) --*

          One or more entries (rules) in the network ACL.

          - *(dict) --*

            Describes an entry in a network ACL.

            - **CidrBlock** *(string) --*

              The IPv4 network range to allow or deny, in CIDR notation.

            - **Egress** *(boolean) --*

              Indicates whether the rule is an egress rule (applied to traffic leaving the subnet).

            - **IcmpTypeCode** *(dict) --*

              ICMP protocol: The ICMP type and code.

              - **Code** *(integer) --*

                The ICMP code. A value of -1 means all codes for the specified ICMP type.

              - **Type** *(integer) --*

                The ICMP type. A value of -1 means all types.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 network range to allow or deny, in CIDR notation.

            - **PortRange** *(dict) --*

              TCP or UDP protocols: The range of ports the rule applies to.

              - **From** *(integer) --*

                The first port in the range.

              - **To** *(integer) --*

                The last port in the range.

            - **Protocol** *(string) --*

              The protocol number. A value of "-1" means all protocols.

            - **RuleAction** *(string) --*

              Indicates whether to allow or deny the traffic that matches the rule.

            - **RuleNumber** *(integer) --*

              The rule number for the entry. ACL entries are processed in ascending order by rule
              number.

        - **IsDefault** *(boolean) --*

          Indicates whether this is the default network ACL for the VPC.

        - **NetworkAclId** *(string) --*

          The ID of the network ACL.

        - **Tags** *(list) --*

          Any tags assigned to the network ACL.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC for the network ACL.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the network ACL.
    """


_DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacePermissionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef(
    _DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacePermissionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissions` `PermissionState`

    Information about the state of the permission.

    - **State** *(string) --*

      The state of the permission.

    - **StatusMessage** *(string) --*

      A status message, if applicable.
    """


_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": str,
        "PermissionState": DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef,
    },
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacePermissionsPaginateResponse` `NetworkInterfacePermissions`

    Describes a permission for a network interface.

    - **NetworkInterfacePermissionId** *(string) --*

      The ID of the network interface permission.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **AwsAccountId** *(string) --*

      The AWS account ID.

    - **AwsService** *(string) --*

      The AWS service.

    - **Permission** *(string) --*

      The type of permission.

    - **PermissionState** *(dict) --*

      Information about the state of the permission.

      - **State** *(string) --*

        The state of the permission.

      - **StatusMessage** *(string) --*

        A status message, if applicable.
    """


_DescribeNetworkInterfacePermissionsPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseTypeDef",
    {
        "NetworkInterfacePermissions": List[
            DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef
        ]
    },
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacePermissionsPaginate` `Response`

    Contains the output for DescribeNetworkInterfacePermissions.

    - **NetworkInterfacePermissions** *(list) --*

      The network interface permissions.

      - *(dict) --*

        Describes a permission for a network interface.

        - **NetworkInterfacePermissionId** *(string) --*

          The ID of the network interface permission.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **AwsAccountId** *(string) --*

          The AWS account ID.

        - **AwsService** *(string) --*

          The AWS service.

        - **Permission** *(string) --*

          The type of permission.

        - **PermissionState** *(dict) --*

          Information about the state of the permission.

          - **State** *(string) --*

            The state of the permission.

          - **StatusMessage** *(string) --*

            A status message, if applicable.
    """


_DescribeNetworkInterfacesPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNetworkInterfacesPaginateFiltersTypeDef(
    _DescribeNetworkInterfacesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeNetworkInterfacesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkInterfacesPaginatePaginationConfigTypeDef(
    _DescribeNetworkInterfacesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `Association`

    The association information for an Elastic IP address (IPv4) associated with the network
    interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `Attachment`

    The network interface attachment.

    - **AttachTime** *(datetime) --*

      The timestamp indicating when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The device index of the network interface attachment on the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **Status** *(string) --*

      The attachment state.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address associated with a network interface.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddresses` `Association`

    The association information for an Elastic IP address (IPv4) associated with the
    network interface.

    - **AllocationId** *(string) --*

      The allocation ID.

    - **AssociationId** *(string) --*

      The association ID.

    - **IpOwnerId** *(string) --*

      The ID of the Elastic IP address owner.

    - **PublicDnsName** *(string) --*

      The public DNS name.

    - **PublicIp** *(string) --*

      The address of the Elastic IP address bound to the network interface.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `PrivateIpAddresses`

    Describes the private IPv4 address of a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the
      network interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Primary** *(boolean) --*

      Indicates whether this IPv4 address is the primary private IPv4 address of the
      network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponseNetworkInterfaces` `TagSet`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef",
    {
        "Association": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef,
        "Attachment": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef
        ],
        "InterfaceType": str,
        "Ipv6Addresses": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": str,
        "SubnetId": str,
        "TagSet": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginateResponse` `NetworkInterfaces`

    Describes a network interface.

    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.

      - **AllocationId** *(string) --*

        The allocation ID.

      - **AssociationId** *(string) --*

        The association ID.

      - **IpOwnerId** *(string) --*

        The ID of the Elastic IP address owner.

      - **PublicDnsName** *(string) --*

        The public DNS name.

      - **PublicIp** *(string) --*

        The address of the Elastic IP address bound to the network interface.

    - **Attachment** *(dict) --*

      The network interface attachment.

      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The device index of the network interface attachment on the instance.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **InstanceOwnerId** *(string) --*

        The AWS account ID of the owner of the instance.

      - **Status** *(string) --*

        The attachment state.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **Description** *(string) --*

      A description.

    - **Groups** *(list) --*

      Any security groups for the network interface.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **InterfaceType** *(string) --*

      The type of network interface.

    - **Ipv6Addresses** *(list) --*

      The IPv6 addresses associated with the network interface.

      - *(dict) --*

        Describes an IPv6 address associated with a network interface.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **MacAddress** *(string) --*

      The MAC address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **OwnerId** *(string) --*

      The AWS account ID of the owner of the network interface.

    - **PrivateDnsName** *(string) --*

      The private DNS name.

    - **PrivateIpAddress** *(string) --*

      The IPv4 address of the network interface within the subnet.

    - **PrivateIpAddresses** *(list) --*

      The private IPv4 addresses associated with the network interface.

      - *(dict) --*

        Describes the private IPv4 address of a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the
          network interface.

          - **AllocationId** *(string) --*

            The allocation ID.

          - **AssociationId** *(string) --*

            The association ID.

          - **IpOwnerId** *(string) --*

            The ID of the Elastic IP address owner.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The address of the Elastic IP address bound to the network interface.

        - **Primary** *(boolean) --*

          Indicates whether this IPv4 address is the primary private IPv4 address of the
          network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address.

    - **RequesterId** *(string) --*

      The ID of the entity that launched the instance on your behalf (for example, AWS
      Management Console or Auto Scaling).

    - **RequesterManaged** *(boolean) --*

      Indicates whether the network interface is being managed by AWS.

    - **SourceDestCheck** *(boolean) --*

      Indicates whether traffic to or from the instance is validated.

    - **Status** *(string) --*

      The status of the network interface.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **TagSet** *(list) --*

      Any tags assigned to the network interface.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_DescribeNetworkInterfacesPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseTypeDef",
    {
        "NetworkInterfaces": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef
        ]
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseTypeDef(
    _DescribeNetworkInterfacesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeNetworkInterfacesPaginate` `Response`

    Contains the output of DescribeNetworkInterfaces.

    - **NetworkInterfaces** *(list) --*

      Information about one or more network interfaces.

      - *(dict) --*

        Describes a network interface.

        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the network
          interface.

          - **AllocationId** *(string) --*

            The allocation ID.

          - **AssociationId** *(string) --*

            The association ID.

          - **IpOwnerId** *(string) --*

            The ID of the Elastic IP address owner.

          - **PublicDnsName** *(string) --*

            The public DNS name.

          - **PublicIp** *(string) --*

            The address of the Elastic IP address bound to the network interface.

        - **Attachment** *(dict) --*

          The network interface attachment.

          - **AttachTime** *(datetime) --*

            The timestamp indicating when the attachment initiated.

          - **AttachmentId** *(string) --*

            The ID of the network interface attachment.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the network interface is deleted when the instance is terminated.

          - **DeviceIndex** *(integer) --*

            The device index of the network interface attachment on the instance.

          - **InstanceId** *(string) --*

            The ID of the instance.

          - **InstanceOwnerId** *(string) --*

            The AWS account ID of the owner of the instance.

          - **Status** *(string) --*

            The attachment state.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **Description** *(string) --*

          A description.

        - **Groups** *(list) --*

          Any security groups for the network interface.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **InterfaceType** *(string) --*

          The type of network interface.

        - **Ipv6Addresses** *(list) --*

          The IPv6 addresses associated with the network interface.

          - *(dict) --*

            Describes an IPv6 address associated with a network interface.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **MacAddress** *(string) --*

          The MAC address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **OwnerId** *(string) --*

          The AWS account ID of the owner of the network interface.

        - **PrivateDnsName** *(string) --*

          The private DNS name.

        - **PrivateIpAddress** *(string) --*

          The IPv4 address of the network interface within the subnet.

        - **PrivateIpAddresses** *(list) --*

          The private IPv4 addresses associated with the network interface.

          - *(dict) --*

            Describes the private IPv4 address of a network interface.

            - **Association** *(dict) --*

              The association information for an Elastic IP address (IPv4) associated with the
              network interface.

              - **AllocationId** *(string) --*

                The allocation ID.

              - **AssociationId** *(string) --*

                The association ID.

              - **IpOwnerId** *(string) --*

                The ID of the Elastic IP address owner.

              - **PublicDnsName** *(string) --*

                The public DNS name.

              - **PublicIp** *(string) --*

                The address of the Elastic IP address bound to the network interface.

            - **Primary** *(boolean) --*

              Indicates whether this IPv4 address is the primary private IPv4 address of the
              network interface.

            - **PrivateDnsName** *(string) --*

              The private DNS name.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address.

        - **RequesterId** *(string) --*

          The ID of the entity that launched the instance on your behalf (for example, AWS
          Management Console or Auto Scaling).

        - **RequesterManaged** *(boolean) --*

          Indicates whether the network interface is being managed by AWS.

        - **SourceDestCheck** *(boolean) --*

          Indicates whether traffic to or from the instance is validated.

        - **Status** *(string) --*

          The status of the network interface.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **TagSet** *(list) --*

          Any tags assigned to the network interface.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.
    """


_DescribePrefixListsPaginateFiltersTypeDef = TypedDict(
    "_DescribePrefixListsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribePrefixListsPaginateFiltersTypeDef(
    _DescribePrefixListsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribePrefixListsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribePrefixListsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePrefixListsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePrefixListsPaginatePaginationConfigTypeDef(
    _DescribePrefixListsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribePrefixListsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribePrefixListsPaginateResponsePrefixListsTypeDef = TypedDict(
    "_DescribePrefixListsPaginateResponsePrefixListsTypeDef",
    {"Cidrs": List[str], "PrefixListId": str, "PrefixListName": str},
    total=False,
)


class DescribePrefixListsPaginateResponsePrefixListsTypeDef(
    _DescribePrefixListsPaginateResponsePrefixListsTypeDef
):
    """
    Type definition for `DescribePrefixListsPaginateResponse` `PrefixLists`

    Describes prefixes for AWS services.

    - **Cidrs** *(list) --*

      The IP address range of the AWS service.

      - *(string) --*

    - **PrefixListId** *(string) --*

      The ID of the prefix.

    - **PrefixListName** *(string) --*

      The name of the prefix.
    """


_DescribePrefixListsPaginateResponseTypeDef = TypedDict(
    "_DescribePrefixListsPaginateResponseTypeDef",
    {"PrefixLists": List[DescribePrefixListsPaginateResponsePrefixListsTypeDef]},
    total=False,
)


class DescribePrefixListsPaginateResponseTypeDef(
    _DescribePrefixListsPaginateResponseTypeDef
):
    """
    Type definition for `DescribePrefixListsPaginate` `Response`

    - **PrefixLists** *(list) --*

      All available prefix lists.

      - *(dict) --*

        Describes prefixes for AWS services.

        - **Cidrs** *(list) --*

          The IP address range of the AWS service.

          - *(string) --*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

        - **PrefixListName** *(string) --*

          The name of the prefix.
    """


_DescribePrincipalIdFormatPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePrincipalIdFormatPaginatePaginationConfigTypeDef(
    _DescribePrincipalIdFormatPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribePrincipalIdFormatPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef(
    _DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef
):
    """
    Type definition for `DescribePrincipalIdFormatPaginateResponsePrincipals` `Statuses`

    Describes the ID format for a resource.

    - **Deadline** *(datetime) --*

      The date in UTC at which you are permanently switched over to using longer IDs. If a
      deadline is not yet available for this resource type, this field is not returned.

    - **Resource** *(string) --*

      The type of resource.

    - **UseLongIds** *(boolean) --*

      Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef",
    {
        "Arn": str,
        "Statuses": List[
            DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef
        ],
    },
    total=False,
)


class DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef(
    _DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef
):
    """
    Type definition for `DescribePrincipalIdFormatPaginateResponse` `Principals`

    PrincipalIdFormat description

    - **Arn** *(string) --*

      PrincipalIdFormatARN description

    - **Statuses** *(list) --*

      PrincipalIdFormatStatuses description

      - *(dict) --*

        Describes the ID format for a resource.

        - **Deadline** *(datetime) --*

          The date in UTC at which you are permanently switched over to using longer IDs. If a
          deadline is not yet available for this resource type, this field is not returned.

        - **Resource** *(string) --*

          The type of resource.

        - **UseLongIds** *(boolean) --*

          Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_DescribePrincipalIdFormatPaginateResponseTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponseTypeDef",
    {"Principals": List[DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef]},
    total=False,
)


class DescribePrincipalIdFormatPaginateResponseTypeDef(
    _DescribePrincipalIdFormatPaginateResponseTypeDef
):
    """
    Type definition for `DescribePrincipalIdFormatPaginate` `Response`

    - **Principals** *(list) --*

      Information about the ID format settings for the ARN.

      - *(dict) --*

        PrincipalIdFormat description

        - **Arn** *(string) --*

          PrincipalIdFormatARN description

        - **Statuses** *(list) --*

          PrincipalIdFormatStatuses description

          - *(dict) --*

            Describes the ID format for a resource.

            - **Deadline** *(datetime) --*

              The date in UTC at which you are permanently switched over to using longer IDs. If a
              deadline is not yet available for this resource type, this field is not returned.

            - **Resource** *(string) --*

              The type of resource.

            - **UseLongIds** *(boolean) --*

              Indicates whether longer IDs (17-character IDs) are enabled for the resource.
    """


_DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef(
    _DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribePublicIpv4PoolsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    {
        "FirstAddress": str,
        "LastAddress": str,
        "AddressCount": int,
        "AvailableAddressCount": int,
    },
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef(
    _DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef
):
    """
    Type definition for `DescribePublicIpv4PoolsPaginateResponsePublicIpv4Pools` `PoolAddressRanges`

    Describes an address range of an IPv4 address pool.

    - **FirstAddress** *(string) --*

      The first IP address in the range.

    - **LastAddress** *(string) --*

      The last IP address in the range.

    - **AddressCount** *(integer) --*

      The number of addresses in the range.

    - **AvailableAddressCount** *(integer) --*

      The number of available addresses in the range.
    """


_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolAddressRanges": List[
            DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef
        ],
        "TotalAddressCount": int,
        "TotalAvailableAddressCount": int,
    },
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef(
    _DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef
):
    """
    Type definition for `DescribePublicIpv4PoolsPaginateResponse` `PublicIpv4Pools`

    Describes an address pool.

    - **PoolId** *(string) --*

      The ID of the IPv4 address pool.

    - **Description** *(string) --*

      A description of the address pool.

    - **PoolAddressRanges** *(list) --*

      The address ranges.

      - *(dict) --*

        Describes an address range of an IPv4 address pool.

        - **FirstAddress** *(string) --*

          The first IP address in the range.

        - **LastAddress** *(string) --*

          The last IP address in the range.

        - **AddressCount** *(integer) --*

          The number of addresses in the range.

        - **AvailableAddressCount** *(integer) --*

          The number of available addresses in the range.

    - **TotalAddressCount** *(integer) --*

      The total number of addresses.

    - **TotalAvailableAddressCount** *(integer) --*

      The total number of available addresses.
    """


_DescribePublicIpv4PoolsPaginateResponseTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponseTypeDef",
    {
        "PublicIpv4Pools": List[
            DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef
        ]
    },
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponseTypeDef(
    _DescribePublicIpv4PoolsPaginateResponseTypeDef
):
    """
    Type definition for `DescribePublicIpv4PoolsPaginate` `Response`

    - **PublicIpv4Pools** *(list) --*

      Information about the address pools.

      - *(dict) --*

        Describes an address pool.

        - **PoolId** *(string) --*

          The ID of the IPv4 address pool.

        - **Description** *(string) --*

          A description of the address pool.

        - **PoolAddressRanges** *(list) --*

          The address ranges.

          - *(dict) --*

            Describes an address range of an IPv4 address pool.

            - **FirstAddress** *(string) --*

              The first IP address in the range.

            - **LastAddress** *(string) --*

              The last IP address in the range.

            - **AddressCount** *(integer) --*

              The number of addresses in the range.

            - **AvailableAddressCount** *(integer) --*

              The number of available addresses in the range.

        - **TotalAddressCount** *(integer) --*

          The total number of addresses.

        - **TotalAvailableAddressCount** *(integer) --*

          The total number of available addresses.
    """


_DescribeReservedInstancesModificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeReservedInstancesModificationsPaginateFiltersTypeDef(
    _DescribeReservedInstancesModificationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "StartingToken": str},
    total=False,
)


class DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef(
    _DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": str,
        "Platform": str,
        "Scope": str,
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResults` `TargetConfiguration`

    The target Reserved Instances configurations supplied as part of the modification
    request.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the modified Reserved Instances.

    - **InstanceCount** *(integer) --*

      The number of modified Reserved Instances.

      .. note::

        This is a required field for a request.

    - **InstanceType** *(string) --*

      The instance type for the modified Reserved Instances.

    - **Platform** *(string) --*

      The network platform of the modified Reserved Instances, which is either
      EC2-Classic or EC2-VPC.

    - **Scope** *(string) --*

      Whether the Reserved Instance is applied to instances in a Region or instances in a
      specific Availability Zone.
    """


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef",
    {
        "ReservedInstancesId": str,
        "TargetConfiguration": DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef,
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModifications` `ModificationResults`

    Describes the modification request/s.

    - **ReservedInstancesId** *(string) --*

      The ID for the Reserved Instances that were created as part of the modification
      request. This field is only available when the modification is fulfilled.

    - **TargetConfiguration** *(dict) --*

      The target Reserved Instances configurations supplied as part of the modification
      request.

      - **AvailabilityZone** *(string) --*

        The Availability Zone for the modified Reserved Instances.

      - **InstanceCount** *(integer) --*

        The number of modified Reserved Instances.

        .. note::

          This is a required field for a request.

      - **InstanceType** *(string) --*

        The instance type for the modified Reserved Instances.

      - **Platform** *(string) --*

        The network platform of the modified Reserved Instances, which is either
        EC2-Classic or EC2-VPC.

      - **Scope** *(string) --*

        Whether the Reserved Instance is applied to instances in a Region or instances in a
        specific Availability Zone.
    """


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModifications` `ReservedInstancesIds`

    Describes the ID of a Reserved Instance.

    - **ReservedInstancesId** *(string) --*

      The ID of the Reserved Instance.
    """


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "EffectiveDate": datetime,
        "ModificationResults": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef
        ],
        "ReservedInstancesIds": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
        ],
        "ReservedInstancesModificationId": str,
        "Status": str,
        "StatusMessage": str,
        "UpdateDate": datetime,
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginateResponse` `ReservedInstancesModifications`

    Describes a Reserved Instance modification.

    - **ClientToken** *(string) --*

      A unique, case-sensitive key supplied by the client to ensure that the request is
      idempotent. For more information, see `Ensuring Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **CreateDate** *(datetime) --*

      The time when the modification request was created.

    - **EffectiveDate** *(datetime) --*

      The time for the modification to become effective.

    - **ModificationResults** *(list) --*

      Contains target configurations along with their corresponding new Reserved Instance IDs.

      - *(dict) --*

        Describes the modification request/s.

        - **ReservedInstancesId** *(string) --*

          The ID for the Reserved Instances that were created as part of the modification
          request. This field is only available when the modification is fulfilled.

        - **TargetConfiguration** *(dict) --*

          The target Reserved Instances configurations supplied as part of the modification
          request.

          - **AvailabilityZone** *(string) --*

            The Availability Zone for the modified Reserved Instances.

          - **InstanceCount** *(integer) --*

            The number of modified Reserved Instances.

            .. note::

              This is a required field for a request.

          - **InstanceType** *(string) --*

            The instance type for the modified Reserved Instances.

          - **Platform** *(string) --*

            The network platform of the modified Reserved Instances, which is either
            EC2-Classic or EC2-VPC.

          - **Scope** *(string) --*

            Whether the Reserved Instance is applied to instances in a Region or instances in a
            specific Availability Zone.

    - **ReservedInstancesIds** *(list) --*

      The IDs of one or more Reserved Instances.

      - *(dict) --*

        Describes the ID of a Reserved Instance.

        - **ReservedInstancesId** *(string) --*

          The ID of the Reserved Instance.

    - **ReservedInstancesModificationId** *(string) --*

      A unique ID for the Reserved Instance modification.

    - **Status** *(string) --*

      The status of the Reserved Instances modification request.

    - **StatusMessage** *(string) --*

      The reason for the status.

    - **UpdateDate** *(datetime) --*

      The time when the modification request was last updated.
    """


_DescribeReservedInstancesModificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseTypeDef",
    {
        "ReservedInstancesModifications": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef
        ]
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeReservedInstancesModificationsPaginate` `Response`

    Contains the output of DescribeReservedInstancesModifications.

    - **ReservedInstancesModifications** *(list) --*

      The Reserved Instance modification information.

      - *(dict) --*

        Describes a Reserved Instance modification.

        - **ClientToken** *(string) --*

          A unique, case-sensitive key supplied by the client to ensure that the request is
          idempotent. For more information, see `Ensuring Idempotency
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
          .

        - **CreateDate** *(datetime) --*

          The time when the modification request was created.

        - **EffectiveDate** *(datetime) --*

          The time for the modification to become effective.

        - **ModificationResults** *(list) --*

          Contains target configurations along with their corresponding new Reserved Instance IDs.

          - *(dict) --*

            Describes the modification request/s.

            - **ReservedInstancesId** *(string) --*

              The ID for the Reserved Instances that were created as part of the modification
              request. This field is only available when the modification is fulfilled.

            - **TargetConfiguration** *(dict) --*

              The target Reserved Instances configurations supplied as part of the modification
              request.

              - **AvailabilityZone** *(string) --*

                The Availability Zone for the modified Reserved Instances.

              - **InstanceCount** *(integer) --*

                The number of modified Reserved Instances.

                .. note::

                  This is a required field for a request.

              - **InstanceType** *(string) --*

                The instance type for the modified Reserved Instances.

              - **Platform** *(string) --*

                The network platform of the modified Reserved Instances, which is either
                EC2-Classic or EC2-VPC.

              - **Scope** *(string) --*

                Whether the Reserved Instance is applied to instances in a Region or instances in a
                specific Availability Zone.

        - **ReservedInstancesIds** *(list) --*

          The IDs of one or more Reserved Instances.

          - *(dict) --*

            Describes the ID of a Reserved Instance.

            - **ReservedInstancesId** *(string) --*

              The ID of the Reserved Instance.

        - **ReservedInstancesModificationId** *(string) --*

          A unique ID for the Reserved Instance modification.

        - **Status** *(string) --*

          The status of the Reserved Instances modification request.

        - **StatusMessage** *(string) --*

          The reason for the status.

        - **UpdateDate** *(datetime) --*

          The time when the modification request was last updated.
    """


_DescribeReservedInstancesOfferingsPaginateFiltersTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateFiltersTypeDef(
    _DescribeReservedInstancesOfferingsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef(
    _DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    {"Count": int, "Price": float},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferings` `PricingDetails`

    Describes a Reserved Instance offering.

    - **Count** *(integer) --*

      The number of reservations available for the price.

    - **Price** *(float) --*

      The price per instance.
    """


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferings` `RecurringCharges`

    Describes a recurring charge.

    - **Amount** *(float) --*

      The amount of the recurring charge.

    - **Frequency** *(string) --*

      The frequency of the recurring charge.
    """


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "FixedPrice": float,
        "InstanceType": str,
        "ProductDescription": str,
        "ReservedInstancesOfferingId": str,
        "UsagePrice": float,
        "CurrencyCode": str,
        "InstanceTenancy": str,
        "Marketplace": bool,
        "OfferingClass": str,
        "OfferingType": str,
        "PricingDetails": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef
        ],
        "RecurringCharges": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef
        ],
        "Scope": str,
    },
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginateResponse` `ReservedInstancesOfferings`

    Describes a Reserved Instance offering.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which the Reserved Instance can be used.

    - **Duration** *(integer) --*

      The duration of the Reserved Instance, in seconds.

    - **FixedPrice** *(float) --*

      The purchase price of the Reserved Instance.

    - **InstanceType** *(string) --*

      The instance type on which the Reserved Instance can be used.

    - **ProductDescription** *(string) --*

      The Reserved Instance product platform description.

    - **ReservedInstancesOfferingId** *(string) --*

      The ID of the Reserved Instance offering. This is the offering ID used in
      GetReservedInstancesExchangeQuote to confirm that an exchange can be made.

    - **UsagePrice** *(float) --*

      The usage price of the Reserved Instance, per hour.

    - **CurrencyCode** *(string) --*

      The currency of the Reserved Instance offering you are purchasing. It's specified using
      ISO 4217 standard currency codes. At this time, the only supported currency is ``USD`` .

    - **InstanceTenancy** *(string) --*

      The tenancy of the instance.

    - **Marketplace** *(boolean) --*

      Indicates whether the offering is available through the Reserved Instance Marketplace
      (resale) or AWS. If it's a Reserved Instance Marketplace offering, this is ``true`` .

    - **OfferingClass** *(string) --*

      If ``convertible`` it can be exchanged for Reserved Instances of the same or higher
      monetary value, with different configurations. If ``standard`` , it is not possible to
      perform an exchange.

    - **OfferingType** *(string) --*

      The Reserved Instance offering type.

    - **PricingDetails** *(list) --*

      The pricing details of the Reserved Instance offering.

      - *(dict) --*

        Describes a Reserved Instance offering.

        - **Count** *(integer) --*

          The number of reservations available for the price.

        - **Price** *(float) --*

          The price per instance.

    - **RecurringCharges** *(list) --*

      The recurring charge tag assigned to the resource.

      - *(dict) --*

        Describes a recurring charge.

        - **Amount** *(float) --*

          The amount of the recurring charge.

        - **Frequency** *(string) --*

          The frequency of the recurring charge.

    - **Scope** *(string) --*

      Whether the Reserved Instance is applied to instances in a Region or an Availability Zone.
    """


_DescribeReservedInstancesOfferingsPaginateResponseTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseTypeDef",
    {
        "ReservedInstancesOfferings": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef
        ]
    },
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeReservedInstancesOfferingsPaginate` `Response`

    Contains the output of DescribeReservedInstancesOfferings.

    - **ReservedInstancesOfferings** *(list) --*

      A list of Reserved Instances offerings.

      - *(dict) --*

        Describes a Reserved Instance offering.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which the Reserved Instance can be used.

        - **Duration** *(integer) --*

          The duration of the Reserved Instance, in seconds.

        - **FixedPrice** *(float) --*

          The purchase price of the Reserved Instance.

        - **InstanceType** *(string) --*

          The instance type on which the Reserved Instance can be used.

        - **ProductDescription** *(string) --*

          The Reserved Instance product platform description.

        - **ReservedInstancesOfferingId** *(string) --*

          The ID of the Reserved Instance offering. This is the offering ID used in
          GetReservedInstancesExchangeQuote to confirm that an exchange can be made.

        - **UsagePrice** *(float) --*

          The usage price of the Reserved Instance, per hour.

        - **CurrencyCode** *(string) --*

          The currency of the Reserved Instance offering you are purchasing. It's specified using
          ISO 4217 standard currency codes. At this time, the only supported currency is ``USD`` .

        - **InstanceTenancy** *(string) --*

          The tenancy of the instance.

        - **Marketplace** *(boolean) --*

          Indicates whether the offering is available through the Reserved Instance Marketplace
          (resale) or AWS. If it's a Reserved Instance Marketplace offering, this is ``true`` .

        - **OfferingClass** *(string) --*

          If ``convertible`` it can be exchanged for Reserved Instances of the same or higher
          monetary value, with different configurations. If ``standard`` , it is not possible to
          perform an exchange.

        - **OfferingType** *(string) --*

          The Reserved Instance offering type.

        - **PricingDetails** *(list) --*

          The pricing details of the Reserved Instance offering.

          - *(dict) --*

            Describes a Reserved Instance offering.

            - **Count** *(integer) --*

              The number of reservations available for the price.

            - **Price** *(float) --*

              The price per instance.

        - **RecurringCharges** *(list) --*

          The recurring charge tag assigned to the resource.

          - *(dict) --*

            Describes a recurring charge.

            - **Amount** *(float) --*

              The amount of the recurring charge.

            - **Frequency** *(string) --*

              The frequency of the recurring charge.

        - **Scope** *(string) --*

          Whether the Reserved Instance is applied to instances in a Region or an Availability Zone.
    """


_DescribeRouteTablesPaginateFiltersTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeRouteTablesPaginateFiltersTypeDef(
    _DescribeRouteTablesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeRouteTablesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeRouteTablesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeRouteTablesPaginatePaginationConfigTypeDef(
    _DescribeRouteTablesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef",
    {
        "Main": bool,
        "RouteTableAssociationId": str,
        "RouteTableId": str,
        "SubnetId": str,
    },
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginateResponseRouteTables` `Associations`

    Describes an association between a route table and a subnet.

    - **Main** *(boolean) --*

      Indicates whether this is the main route table.

    - **RouteTableAssociationId** *(string) --*

      The ID of the association between a route table and a subnet.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **SubnetId** *(string) --*

      The ID of the subnet. A subnet ID is not returned for an implicit association.
    """


_DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginateResponseRouteTables` `PropagatingVgws`

    Describes a virtual private gateway propagating route.

    - **GatewayId** *(string) --*

      The ID of the virtual private gateway.
    """


_DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": str,
        "State": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginateResponseRouteTables` `Routes`

    Describes a route in a route table.

    - **DestinationCidrBlock** *(string) --*

      The IPv4 CIDR block used for the destination match.

    - **DestinationIpv6CidrBlock** *(string) --*

      The IPv6 CIDR block used for the destination match.

    - **DestinationPrefixListId** *(string) --*

      The prefix of the AWS service.

    - **EgressOnlyInternetGatewayId** *(string) --*

      The ID of the egress-only internet gateway.

    - **GatewayId** *(string) --*

      The ID of a gateway attached to your VPC.

    - **InstanceId** *(string) --*

      The ID of a NAT instance in your VPC.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **NatGatewayId** *(string) --*

      The ID of a NAT gateway.

    - **TransitGatewayId** *(string) --*

      The ID of a transit gateway.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **Origin** *(string) --*

      Describes how the route was created.

      * ``CreateRouteTable`` - The route was automatically created when the route table was
      created.

      * ``CreateRoute`` - The route was manually added to the route table.

      * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

    - **State** *(string) --*

      The state of the route. The ``blackhole`` state indicates that the route's target
      isn't available (for example, the specified gateway isn't attached to the VPC, or the
      specified NAT instance has been terminated).

    - **VpcPeeringConnectionId** *(string) --*

      The ID of a VPC peering connection.
    """


_DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginateResponseRouteTables` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeRouteTablesPaginateResponseRouteTablesTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesTypeDef",
    {
        "Associations": List[
            DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef
        ],
        "PropagatingVgws": List[
            DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef
        ],
        "RouteTableId": str,
        "Routes": List[DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef],
        "Tags": List[DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginateResponse` `RouteTables`

    Describes a route table.

    - **Associations** *(list) --*

      The associations between the route table and one or more subnets.

      - *(dict) --*

        Describes an association between a route table and a subnet.

        - **Main** *(boolean) --*

          Indicates whether this is the main route table.

        - **RouteTableAssociationId** *(string) --*

          The ID of the association between a route table and a subnet.

        - **RouteTableId** *(string) --*

          The ID of the route table.

        - **SubnetId** *(string) --*

          The ID of the subnet. A subnet ID is not returned for an implicit association.

    - **PropagatingVgws** *(list) --*

      Any virtual private gateway (VGW) propagating routes.

      - *(dict) --*

        Describes a virtual private gateway propagating route.

        - **GatewayId** *(string) --*

          The ID of the virtual private gateway.

    - **RouteTableId** *(string) --*

      The ID of the route table.

    - **Routes** *(list) --*

      The routes in the route table.

      - *(dict) --*

        Describes a route in a route table.

        - **DestinationCidrBlock** *(string) --*

          The IPv4 CIDR block used for the destination match.

        - **DestinationIpv6CidrBlock** *(string) --*

          The IPv6 CIDR block used for the destination match.

        - **DestinationPrefixListId** *(string) --*

          The prefix of the AWS service.

        - **EgressOnlyInternetGatewayId** *(string) --*

          The ID of the egress-only internet gateway.

        - **GatewayId** *(string) --*

          The ID of a gateway attached to your VPC.

        - **InstanceId** *(string) --*

          The ID of a NAT instance in your VPC.

        - **InstanceOwnerId** *(string) --*

          The AWS account ID of the owner of the instance.

        - **NatGatewayId** *(string) --*

          The ID of a NAT gateway.

        - **TransitGatewayId** *(string) --*

          The ID of a transit gateway.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **Origin** *(string) --*

          Describes how the route was created.

          * ``CreateRouteTable`` - The route was automatically created when the route table was
          created.

          * ``CreateRoute`` - The route was manually added to the route table.

          * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

        - **State** *(string) --*

          The state of the route. The ``blackhole`` state indicates that the route's target
          isn't available (for example, the specified gateway isn't attached to the VPC, or the
          specified NAT instance has been terminated).

        - **VpcPeeringConnectionId** *(string) --*

          The ID of a VPC peering connection.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the route table.
    """


_DescribeRouteTablesPaginateResponseTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseTypeDef",
    {"RouteTables": List[DescribeRouteTablesPaginateResponseRouteTablesTypeDef]},
    total=False,
)


class DescribeRouteTablesPaginateResponseTypeDef(
    _DescribeRouteTablesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeRouteTablesPaginate` `Response`

    Contains the output of DescribeRouteTables.

    - **RouteTables** *(list) --*

      Information about one or more route tables.

      - *(dict) --*

        Describes a route table.

        - **Associations** *(list) --*

          The associations between the route table and one or more subnets.

          - *(dict) --*

            Describes an association between a route table and a subnet.

            - **Main** *(boolean) --*

              Indicates whether this is the main route table.

            - **RouteTableAssociationId** *(string) --*

              The ID of the association between a route table and a subnet.

            - **RouteTableId** *(string) --*

              The ID of the route table.

            - **SubnetId** *(string) --*

              The ID of the subnet. A subnet ID is not returned for an implicit association.

        - **PropagatingVgws** *(list) --*

          Any virtual private gateway (VGW) propagating routes.

          - *(dict) --*

            Describes a virtual private gateway propagating route.

            - **GatewayId** *(string) --*

              The ID of the virtual private gateway.

        - **RouteTableId** *(string) --*

          The ID of the route table.

        - **Routes** *(list) --*

          The routes in the route table.

          - *(dict) --*

            Describes a route in a route table.

            - **DestinationCidrBlock** *(string) --*

              The IPv4 CIDR block used for the destination match.

            - **DestinationIpv6CidrBlock** *(string) --*

              The IPv6 CIDR block used for the destination match.

            - **DestinationPrefixListId** *(string) --*

              The prefix of the AWS service.

            - **EgressOnlyInternetGatewayId** *(string) --*

              The ID of the egress-only internet gateway.

            - **GatewayId** *(string) --*

              The ID of a gateway attached to your VPC.

            - **InstanceId** *(string) --*

              The ID of a NAT instance in your VPC.

            - **InstanceOwnerId** *(string) --*

              The AWS account ID of the owner of the instance.

            - **NatGatewayId** *(string) --*

              The ID of a NAT gateway.

            - **TransitGatewayId** *(string) --*

              The ID of a transit gateway.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **Origin** *(string) --*

              Describes how the route was created.

              * ``CreateRouteTable`` - The route was automatically created when the route table was
              created.

              * ``CreateRoute`` - The route was manually added to the route table.

              * ``EnableVgwRoutePropagation`` - The route was propagated by route propagation.

            - **State** *(string) --*

              The state of the route. The ``blackhole`` state indicates that the route's target
              isn't available (for example, the specified gateway isn't attached to the VPC, or the
              specified NAT instance has been terminated).

            - **VpcPeeringConnectionId** *(string) --*

              The ID of a VPC peering connection.

        - **Tags** *(list) --*

          Any tags assigned to the route table.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the route table.
    """


_DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
)


class DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginate` `FirstSlotStartTimeRange`

    The time period for the first schedule to start.

    - **EarliestTime** *(datetime) --* **[REQUIRED]**

      The earliest date and time, in UTC, for the Scheduled Instance to start.

    - **LatestTime** *(datetime) --* **[REQUIRED]**

      The latest date and time, in UTC, for the Scheduled Instance to start. This value must be later
      than or equal to the earliest date and at most three months in the future.
    """


_DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDays": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginate` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``Frequency`` . For example,
      every 2 weeks or every 2 months.

    - **OccurrenceDays** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a weekly
      schedule, this is one or more days of the week (1-7, where 1 is Sunday). You can't specify this
      value with a daily schedule. If the occurrence is relative to the end of the month, you can
      specify only a single day.

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month. You
      can't specify this value with a daily schedule.

    - **OccurrenceUnit** *(string) --*

      The unit for ``OccurrenceDays`` (``DayOfWeek`` or ``DayOfMonth`` ). This value is required for
      a monthly schedule. You can't specify ``DayOfWeek`` with a weekly schedule. You can't specify
      this value with a daily schedule.
    """


_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySet` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``frequency`` . For
      example, every 2 weeks or every 2 months.

    - **OccurrenceDaySet** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a
      weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month.

    - **OccurrenceUnit** *(string) --*

      The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).
    """


_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailableInstanceCount": int,
        "FirstSlotStartTime": datetime,
        "HourlyPrice": str,
        "InstanceType": str,
        "MaxTermDurationInDays": int,
        "MinTermDurationInDays": int,
        "NetworkPlatform": str,
        "Platform": str,
        "PurchaseToken": str,
        "Recurrence": DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef,
        "SlotDurationInHours": int,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginateResponse` `ScheduledInstanceAvailabilitySet`

    Describes a schedule that is available for your Scheduled Instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **AvailableInstanceCount** *(integer) --*

      The number of available instances.

    - **FirstSlotStartTime** *(datetime) --*

      The time period for the first schedule to start.

    - **HourlyPrice** *(string) --*

      The hourly price for a single instance.

    - **InstanceType** *(string) --*

      The instance type. You can specify one of the C3, C4, M4, or R3 instance types.

    - **MaxTermDurationInDays** *(integer) --*

      The maximum term. The only possible value is 365 days.

    - **MinTermDurationInDays** *(integer) --*

      The minimum term. The only possible value is 365 days.

    - **NetworkPlatform** *(string) --*

      The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

    - **Platform** *(string) --*

      The platform (``Linux/UNIX`` or ``Windows`` ).

    - **PurchaseToken** *(string) --*

      The purchase token. This token expires in two hours.

    - **Recurrence** *(dict) --*

      The schedule recurrence.

      - **Frequency** *(string) --*

        The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

      - **Interval** *(integer) --*

        The interval quantity. The interval unit depends on the value of ``frequency`` . For
        example, every 2 weeks or every 2 months.

      - **OccurrenceDaySet** *(list) --*

        The days. For a monthly schedule, this is one or more days of the month (1-31). For a
        weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

        - *(integer) --*

      - **OccurrenceRelativeToEnd** *(boolean) --*

        Indicates whether the occurrence is relative to the end of the specified week or month.

      - **OccurrenceUnit** *(string) --*

        The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

    - **SlotDurationInHours** *(integer) --*

      The number of hours in the schedule.

    - **TotalScheduledInstanceHours** *(integer) --*

      The total number of hours for a single instance for the entire term.
    """


_DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef",
    {
        "ScheduledInstanceAvailabilitySet": List[
            DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef
        ]
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef
):
    """
    Type definition for `DescribeScheduledInstanceAvailabilityPaginate` `Response`

    Contains the output of DescribeScheduledInstanceAvailability.

    - **ScheduledInstanceAvailabilitySet** *(list) --*

      Information about the available Scheduled Instances.

      - *(dict) --*

        Describes a schedule that is available for your Scheduled Instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **AvailableInstanceCount** *(integer) --*

          The number of available instances.

        - **FirstSlotStartTime** *(datetime) --*

          The time period for the first schedule to start.

        - **HourlyPrice** *(string) --*

          The hourly price for a single instance.

        - **InstanceType** *(string) --*

          The instance type. You can specify one of the C3, C4, M4, or R3 instance types.

        - **MaxTermDurationInDays** *(integer) --*

          The maximum term. The only possible value is 365 days.

        - **MinTermDurationInDays** *(integer) --*

          The minimum term. The only possible value is 365 days.

        - **NetworkPlatform** *(string) --*

          The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

        - **Platform** *(string) --*

          The platform (``Linux/UNIX`` or ``Windows`` ).

        - **PurchaseToken** *(string) --*

          The purchase token. This token expires in two hours.

        - **Recurrence** *(dict) --*

          The schedule recurrence.

          - **Frequency** *(string) --*

            The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

          - **Interval** *(integer) --*

            The interval quantity. The interval unit depends on the value of ``frequency`` . For
            example, every 2 weeks or every 2 months.

          - **OccurrenceDaySet** *(list) --*

            The days. For a monthly schedule, this is one or more days of the month (1-31). For a
            weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

            - *(integer) --*

          - **OccurrenceRelativeToEnd** *(boolean) --*

            Indicates whether the occurrence is relative to the end of the specified week or month.

          - **OccurrenceUnit** *(string) --*

            The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

        - **SlotDurationInHours** *(integer) --*

          The number of hours in the schedule.

        - **TotalScheduledInstanceHours** *(integer) --*

          The total number of hours for a single instance for the entire term.
    """


_DescribeScheduledInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeScheduledInstancesPaginateFiltersTypeDef(
    _DescribeScheduledInstancesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeScheduledInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeScheduledInstancesPaginatePaginationConfigTypeDef(
    _DescribeScheduledInstancesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef(
    _DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginateResponseScheduledInstanceSet` `Recurrence`

    The schedule recurrence.

    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

    - **Interval** *(integer) --*

      The interval quantity. The interval unit depends on the value of ``frequency`` . For
      example, every 2 weeks or every 2 months.

    - **OccurrenceDaySet** *(list) --*

      The days. For a monthly schedule, this is one or more days of the month (1-31). For a
      weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

      - *(integer) --*

    - **OccurrenceRelativeToEnd** *(boolean) --*

      Indicates whether the occurrence is relative to the end of the specified week or month.

    - **OccurrenceUnit** *(string) --*

      The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).
    """


_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef(
    _DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginateResponse` `ScheduledInstanceSet`

    Describes a Scheduled Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **CreateDate** *(datetime) --*

      The date when the Scheduled Instance was purchased.

    - **HourlyPrice** *(string) --*

      The hourly price for a single instance.

    - **InstanceCount** *(integer) --*

      The number of instances.

    - **InstanceType** *(string) --*

      The instance type.

    - **NetworkPlatform** *(string) --*

      The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

    - **NextSlotStartTime** *(datetime) --*

      The time for the next schedule to start.

    - **Platform** *(string) --*

      The platform (``Linux/UNIX`` or ``Windows`` ).

    - **PreviousSlotEndTime** *(datetime) --*

      The time that the previous schedule ended or will end.

    - **Recurrence** *(dict) --*

      The schedule recurrence.

      - **Frequency** *(string) --*

        The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

      - **Interval** *(integer) --*

        The interval quantity. The interval unit depends on the value of ``frequency`` . For
        example, every 2 weeks or every 2 months.

      - **OccurrenceDaySet** *(list) --*

        The days. For a monthly schedule, this is one or more days of the month (1-31). For a
        weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

        - *(integer) --*

      - **OccurrenceRelativeToEnd** *(boolean) --*

        Indicates whether the occurrence is relative to the end of the specified week or month.

      - **OccurrenceUnit** *(string) --*

        The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

    - **ScheduledInstanceId** *(string) --*

      The Scheduled Instance ID.

    - **SlotDurationInHours** *(integer) --*

      The number of hours in the schedule.

    - **TermEndDate** *(datetime) --*

      The end date for the Scheduled Instance.

    - **TermStartDate** *(datetime) --*

      The start date for the Scheduled Instance.

    - **TotalScheduledInstanceHours** *(integer) --*

      The total number of hours for a single instance for the entire term.
    """


_DescribeScheduledInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseTypeDef",
    {
        "ScheduledInstanceSet": List[
            DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef
        ]
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseTypeDef(
    _DescribeScheduledInstancesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginate` `Response`

    Contains the output of DescribeScheduledInstances.

    - **ScheduledInstanceSet** *(list) --*

      Information about the Scheduled Instances.

      - *(dict) --*

        Describes a Scheduled Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **CreateDate** *(datetime) --*

          The date when the Scheduled Instance was purchased.

        - **HourlyPrice** *(string) --*

          The hourly price for a single instance.

        - **InstanceCount** *(integer) --*

          The number of instances.

        - **InstanceType** *(string) --*

          The instance type.

        - **NetworkPlatform** *(string) --*

          The network platform (``EC2-Classic`` or ``EC2-VPC`` ).

        - **NextSlotStartTime** *(datetime) --*

          The time for the next schedule to start.

        - **Platform** *(string) --*

          The platform (``Linux/UNIX`` or ``Windows`` ).

        - **PreviousSlotEndTime** *(datetime) --*

          The time that the previous schedule ended or will end.

        - **Recurrence** *(dict) --*

          The schedule recurrence.

          - **Frequency** *(string) --*

            The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).

          - **Interval** *(integer) --*

            The interval quantity. The interval unit depends on the value of ``frequency`` . For
            example, every 2 weeks or every 2 months.

          - **OccurrenceDaySet** *(list) --*

            The days. For a monthly schedule, this is one or more days of the month (1-31). For a
            weekly schedule, this is one or more days of the week (1-7, where 1 is Sunday).

            - *(integer) --*

          - **OccurrenceRelativeToEnd** *(boolean) --*

            Indicates whether the occurrence is relative to the end of the specified week or month.

          - **OccurrenceUnit** *(string) --*

            The unit for ``occurrenceDaySet`` (``DayOfWeek`` or ``DayOfMonth`` ).

        - **ScheduledInstanceId** *(string) --*

          The Scheduled Instance ID.

        - **SlotDurationInHours** *(integer) --*

          The number of hours in the schedule.

        - **TermEndDate** *(datetime) --*

          The end date for the Scheduled Instance.

        - **TermStartDate** *(datetime) --*

          The start date for the Scheduled Instance.

        - **TotalScheduledInstanceHours** *(integer) --*

          The total number of hours for a single instance for the entire term.
    """


_DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
    total=False,
)


class DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef(
    _DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef
):
    """
    Type definition for `DescribeScheduledInstancesPaginate` `SlotStartTimeRange`

    The time period for the first schedule to start.

    - **EarliestTime** *(datetime) --*

      The earliest date and time, in UTC, for the Scheduled Instance to start.

    - **LatestTime** *(datetime) --*

      The latest date and time, in UTC, for the Scheduled Instance to start.
    """


_DescribeSecurityGroupsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSecurityGroupsPaginateFiltersTypeDef(
    _DescribeSecurityGroupsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeSecurityGroupsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSecurityGroupsPaginatePaginationConfigTypeDef(
    _DescribeSecurityGroupsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgress` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgress` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgress` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgress` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroups` `IpPermissionsEgress`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
      A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
      types, you must specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
      `Protocol Numbers
      <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
      rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
      , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
      specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
      ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
      types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
      AWS service to access through a VPC endpoint from instances associated with the
      security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
      of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
      must specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security
      group, not both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroups` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
      A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
      types, you must specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
      `Protocol Numbers
      <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
      rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
      , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
      specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
      ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
      types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security
          group, not both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
      AWS service to access through a VPC endpoint from instances associated with the
      security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
      of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
      must specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponseSecurityGroups` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef",
    {
        "Description": str,
        "GroupName": str,
        "IpPermissions": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef
        ],
        "OwnerId": str,
        "GroupId": str,
        "IpPermissionsEgress": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef
        ],
        "Tags": List[DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginateResponse` `SecurityGroups`

    Describes a security group

    - **Description** *(string) --*

      A description of the security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **IpPermissions** *(list) --*

      The inbound rules associated with the security group.

      - *(dict) --*

        Describes a set of permissions for a security group rule.

        - **FromPort** *(integer) --*

          The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
          A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
          types, you must specify all codes.

        - **IpProtocol** *(string) --*

          The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
          `Protocol Numbers
          <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

          [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
          rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
          , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
          specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
          ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
          types and codes is allowed.

        - **IpRanges** *(list) --*

          The IPv4 ranges.

          - *(dict) --*

            Describes an IPv4 range.

            - **CidrIp** *(string) --*

              The IPv4 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv4 address, use the /32 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv4 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **Ipv6Ranges** *(list) --*

          [VPC only] The IPv6 ranges.

          - *(dict) --*

            [EC2-VPC only] Describes an IPv6 range.

            - **CidrIpv6** *(string) --*

              The IPv6 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv6 address, use the /128 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv6 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListIds** *(list) --*

          [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
          AWS service to access through a VPC endpoint from instances associated with the
          security group.

          - *(dict) --*

            Describes a prefix list ID.

            - **Description** *(string) --*

              A description for the security group rule that references this prefix list ID.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListId** *(string) --*

              The ID of the prefix.

        - **ToPort** *(integer) --*

          The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
          of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
          must specify all codes.

        - **UserIdGroupPairs** *(list) --*

          The security group and AWS account ID pairs.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **OwnerId** *(string) --*

      The AWS account ID of the owner of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **IpPermissionsEgress** *(list) --*

      [VPC only] The outbound rules associated with the security group.

      - *(dict) --*

        Describes a set of permissions for a security group rule.

        - **FromPort** *(integer) --*

          The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
          A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
          types, you must specify all codes.

        - **IpProtocol** *(string) --*

          The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
          `Protocol Numbers
          <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

          [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
          rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
          , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
          specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
          ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
          types and codes is allowed.

        - **IpRanges** *(list) --*

          The IPv4 ranges.

          - *(dict) --*

            Describes an IPv4 range.

            - **CidrIp** *(string) --*

              The IPv4 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv4 address, use the /32 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv4 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **Ipv6Ranges** *(list) --*

          [VPC only] The IPv6 ranges.

          - *(dict) --*

            [EC2-VPC only] Describes an IPv6 range.

            - **CidrIpv6** *(string) --*

              The IPv6 CIDR range. You can either specify a CIDR range or a source security
              group, not both. To specify a single IPv6 address, use the /128 prefix length.

            - **Description** *(string) --*

              A description for the security group rule that references this IPv6 address range.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListIds** *(list) --*

          [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
          AWS service to access through a VPC endpoint from instances associated with the
          security group.

          - *(dict) --*

            Describes a prefix list ID.

            - **Description** *(string) --*

              A description for the security group rule that references this prefix list ID.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListId** *(string) --*

              The ID of the prefix.

        - **ToPort** *(integer) --*

          The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
          of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
          must specify all codes.

        - **UserIdGroupPairs** *(list) --*

          The security group and AWS account ID pairs.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the security group.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcId** *(string) --*

      [VPC only] The ID of the VPC for the security group.
    """


_DescribeSecurityGroupsPaginateResponseTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseTypeDef",
    {
        "SecurityGroups": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef
        ]
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseTypeDef(
    _DescribeSecurityGroupsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSecurityGroupsPaginate` `Response`

    - **SecurityGroups** *(list) --*

      Information about the security groups.

      - *(dict) --*

        Describes a security group

        - **Description** *(string) --*

          A description of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **IpPermissions** *(list) --*

          The inbound rules associated with the security group.

          - *(dict) --*

            Describes a set of permissions for a security group rule.

            - **FromPort** *(integer) --*

              The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
              A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
              types, you must specify all codes.

            - **IpProtocol** *(string) --*

              The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
              `Protocol Numbers
              <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

              [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
              rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
              , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
              specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
              ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
              types and codes is allowed.

            - **IpRanges** *(list) --*

              The IPv4 ranges.

              - *(dict) --*

                Describes an IPv4 range.

                - **CidrIp** *(string) --*

                  The IPv4 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv4 address, use the /32 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv4 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **Ipv6Ranges** *(list) --*

              [VPC only] The IPv6 ranges.

              - *(dict) --*

                [EC2-VPC only] Describes an IPv6 range.

                - **CidrIpv6** *(string) --*

                  The IPv6 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv6 address, use the /128 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv6 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListIds** *(list) --*

              [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
              AWS service to access through a VPC endpoint from instances associated with the
              security group.

              - *(dict) --*

                Describes a prefix list ID.

                - **Description** *(string) --*

                  A description for the security group rule that references this prefix list ID.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **PrefixListId** *(string) --*

                  The ID of the prefix.

            - **ToPort** *(integer) --*

              The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
              of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
              must specify all codes.

            - **UserIdGroupPairs** *(list) --*

              The security group and AWS account ID pairs.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **OwnerId** *(string) --*

          The AWS account ID of the owner of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **IpPermissionsEgress** *(list) --*

          [VPC only] The outbound rules associated with the security group.

          - *(dict) --*

            Describes a set of permissions for a security group rule.

            - **FromPort** *(integer) --*

              The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number.
              A value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6
              types, you must specify all codes.

            - **IpProtocol** *(string) --*

              The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see
              `Protocol Numbers
              <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

              [VPC only] Use ``-1`` to specify all protocols. When authorizing security group
              rules, specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp``
              , or ``icmpv6`` allows traffic on all ports, regardless of any port range you
              specify. For ``tcp`` , ``udp`` , and ``icmp`` , you must specify a port range. For
              ``icmpv6`` , the port range is optional; if you omit the port range, traffic for all
              types and codes is allowed.

            - **IpRanges** *(list) --*

              The IPv4 ranges.

              - *(dict) --*

                Describes an IPv4 range.

                - **CidrIp** *(string) --*

                  The IPv4 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv4 address, use the /32 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv4 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **Ipv6Ranges** *(list) --*

              [VPC only] The IPv6 ranges.

              - *(dict) --*

                [EC2-VPC only] Describes an IPv6 range.

                - **CidrIpv6** *(string) --*

                  The IPv6 CIDR range. You can either specify a CIDR range or a source security
                  group, not both. To specify a single IPv6 address, use the /128 prefix length.

                - **Description** *(string) --*

                  A description for the security group rule that references this IPv6 address range.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **PrefixListIds** *(list) --*

              [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the
              AWS service to access through a VPC endpoint from instances associated with the
              security group.

              - *(dict) --*

                Describes a prefix list ID.

                - **Description** *(string) --*

                  A description for the security group rule that references this prefix list ID.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **PrefixListId** *(string) --*

                  The ID of the prefix.

            - **ToPort** *(integer) --*

              The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value
              of ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you
              must specify all codes.

            - **UserIdGroupPairs** *(list) --*

              The security group and AWS account ID pairs.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the security group.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcId** *(string) --*

          [VPC only] The ID of the VPC for the security group.
    """


_DescribeSnapshotsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSnapshotsPaginateFiltersTypeDef(_DescribeSnapshotsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeSnapshotsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeSnapshotsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSnapshotsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSnapshotsPaginatePaginationConfigTypeDef(
    _DescribeSnapshotsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSnapshotsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef(
    _DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef
):
    """
    Type definition for `DescribeSnapshotsPaginateResponseSnapshots` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeSnapshotsPaginateResponseSnapshotsTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseSnapshotsTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": str,
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef],
    },
    total=False,
)


class DescribeSnapshotsPaginateResponseSnapshotsTypeDef(
    _DescribeSnapshotsPaginateResponseSnapshotsTypeDef
):
    """
    Type definition for `DescribeSnapshotsPaginateResponse` `Snapshots`

    Describes a snapshot.

    - **DataEncryptionKeyId** *(string) --*

      The data encryption key identifier for the snapshot. This value is a unique identifier
      that corresponds to the data encryption key that was used to encrypt the original volume
      or snapshot copy. Because data encryption keys are inherited by volumes created from
      snapshots, and vice versa, if snapshots share the same data encryption key identifier,
      then they belong to the same volume/snapshot lineage. This parameter is only returned by
      DescribeSnapshots .

    - **Description** *(string) --*

      The description for the snapshot.

    - **Encrypted** *(boolean) --*

      Indicates whether the snapshot is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
      master key (CMK) that was used to protect the volume encryption key for the parent volume.

    - **OwnerId** *(string) --*

      The AWS account ID of the EBS snapshot owner.

    - **Progress** *(string) --*

      The progress of the snapshot, as a percentage.

    - **SnapshotId** *(string) --*

      The ID of the snapshot. Each snapshot receives a unique identifier when it is created.

    - **StartTime** *(datetime) --*

      The time stamp when the snapshot was initiated.

    - **State** *(string) --*

      The snapshot state.

    - **StateMessage** *(string) --*

      Encrypted Amazon EBS snapshots are copied asynchronously. If a snapshot copy operation
      fails (for example, if the proper AWS Key Management Service (AWS KMS) permissions are
      not obtained) this field displays error state details to help you diagnose why the error
      occurred. This parameter is only returned by  DescribeSnapshots .

    - **VolumeId** *(string) --*

      The ID of the volume that was used to create the snapshot. Snapshots created by the
      CopySnapshot action have an arbitrary volume ID that should not be used for any purpose.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

    - **OwnerAlias** *(string) --*

      Value from an Amazon-maintained list (``amazon`` | ``self`` | ``all`` |
      ``aws-marketplace`` | ``microsoft`` ) of snapshot owners. Not to be confused with the
      user-configured AWS account alias, which is set from the IAM console.

    - **Tags** *(list) --*

      Any tags assigned to the snapshot.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeSnapshotsPaginateResponseTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseTypeDef",
    {"Snapshots": List[DescribeSnapshotsPaginateResponseSnapshotsTypeDef]},
    total=False,
)


class DescribeSnapshotsPaginateResponseTypeDef(
    _DescribeSnapshotsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSnapshotsPaginate` `Response`

    - **Snapshots** *(list) --*

      Information about the snapshots.

      - *(dict) --*

        Describes a snapshot.

        - **DataEncryptionKeyId** *(string) --*

          The data encryption key identifier for the snapshot. This value is a unique identifier
          that corresponds to the data encryption key that was used to encrypt the original volume
          or snapshot copy. Because data encryption keys are inherited by volumes created from
          snapshots, and vice versa, if snapshots share the same data encryption key identifier,
          then they belong to the same volume/snapshot lineage. This parameter is only returned by
          DescribeSnapshots .

        - **Description** *(string) --*

          The description for the snapshot.

        - **Encrypted** *(boolean) --*

          Indicates whether the snapshot is encrypted.

        - **KmsKeyId** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
          master key (CMK) that was used to protect the volume encryption key for the parent volume.

        - **OwnerId** *(string) --*

          The AWS account ID of the EBS snapshot owner.

        - **Progress** *(string) --*

          The progress of the snapshot, as a percentage.

        - **SnapshotId** *(string) --*

          The ID of the snapshot. Each snapshot receives a unique identifier when it is created.

        - **StartTime** *(datetime) --*

          The time stamp when the snapshot was initiated.

        - **State** *(string) --*

          The snapshot state.

        - **StateMessage** *(string) --*

          Encrypted Amazon EBS snapshots are copied asynchronously. If a snapshot copy operation
          fails (for example, if the proper AWS Key Management Service (AWS KMS) permissions are
          not obtained) this field displays error state details to help you diagnose why the error
          occurred. This parameter is only returned by  DescribeSnapshots .

        - **VolumeId** *(string) --*

          The ID of the volume that was used to create the snapshot. Snapshots created by the
          CopySnapshot action have an arbitrary volume ID that should not be used for any purpose.

        - **VolumeSize** *(integer) --*

          The size of the volume, in GiB.

        - **OwnerAlias** *(string) --*

          Value from an Amazon-maintained list (``amazon`` | ``self`` | ``all`` |
          ``aws-marketplace`` | ``microsoft`` ) of snapshot owners. Not to be confused with the
          user-configured AWS account alias, which is set from the IAM console.

        - **Tags** *(list) --*

          Any tags assigned to the snapshot.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef(
    _DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetInstancesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": str,
    },
    total=False,
)


class DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef(
    _DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef
):
    """
    Type definition for `DescribeSpotFleetInstancesPaginateResponse` `ActiveInstances`

    Describes a running instance in a Spot Fleet.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **InstanceHealth** *(string) --*

      The health status of the instance. If the status of either the instance status check or
      the system status check is ``impaired`` , the health status of the instance is
      ``unhealthy`` . Otherwise, the health status is ``healthy`` .
    """


_DescribeSpotFleetInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginateResponseTypeDef",
    {
        "ActiveInstances": List[
            DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef
        ],
        "SpotFleetRequestId": str,
    },
    total=False,
)


class DescribeSpotFleetInstancesPaginateResponseTypeDef(
    _DescribeSpotFleetInstancesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSpotFleetInstancesPaginate` `Response`

    Contains the output of DescribeSpotFleetInstances.

    - **ActiveInstances** *(list) --*

      The running instances. This list is refreshed periodically and might be out of date.

      - *(dict) --*

        Describes a running instance in a Spot Fleet.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **InstanceHealth** *(string) --*

          The health status of the instance. If the status of either the instance status check or
          the system status check is ``impaired`` , the health status of the instance is
          ``unhealthy`` . Otherwise, the health status is ``healthy`` .

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.
    """


_DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef(
    _DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is
    launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for
      the volume. For ``gp2`` volumes, this represents the baseline performance of
      the volume and the rate at which the volume accumulates I/O credits for
      bursting. For more information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
      64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
      64,000 is guaranteed only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes;
      it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
      ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a
      volume size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
      Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
      (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
      (``standard`` ) volumes. If you specify a snapshot, the volume size must be
      equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the
      IOPS that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while
      being restored from a backing snapshot. The effect of setting the encryption
      state to ``true`` depends on the volume origin (new or from a snapshot),
      starting encryption state, ownership, and whether encryption by default is
      enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
      CMK under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      , `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can
      specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
      available instance store volumes depends on the instance type. After you
      connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device
      name. Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the
      block device mapping for the instance. When you launch an M3 instance, we
      ignore any instance store volumes specified in the block device mapping for the
      AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is
      launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for
        the volume. For ``gp2`` volumes, this represents the baseline performance of
        the volume and the rate at which the volume accumulates I/O credits for
        bursting. For more information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
        64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
        64,000 is guaranteed only on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes;
        it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
        ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a
        volume size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
        Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
        (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
        (``standard`` ) volumes. If you specify a snapshot, the volume size must be
        equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the
        IOPS that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while
        being restored from a backing snapshot. The effect of setting the encryption
        state to ``true`` depends on the volume origin (new or from a snapshot),
        starting encryption state, ownership, and whether encryption by default is
        enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
        CMK under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
        , `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `Monitoring`

    Enable or disable monitoring for the instances.

    - **Enabled** *(boolean) --*

      Enables monitoring for the instance.

      Default: ``false``
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4
      address. Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in
      a VPC. The public IP address can only be assigned to a network interface for
      eth0, and can only be assigned to a new network interface, not an existing one.
      You cannot specify more than one network interface in the request. If launching
      into a default subnet, the default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated.
      You can specify ``true`` only if creating a new network interface when
      launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network
      interface when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary
      network interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify
      the device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if
      creating a network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2
      chooses the IPv6 addresses from the range of the subnet. You cannot specify
      this option and the option to assign specific IPv6 addresses in the same
      request. You can specify this option if you've specified a minimum number of
      instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot
      specify this option and the option to assign a number of IPv6 addresses in the
      same request. You cannot specify this option if you've specified a minimum
      number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a
      network interface when launching an instance. You cannot specify this option if
      you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one
      private IPv4 address can be designated as primary. You cannot specify this
      option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4
          address. Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option
      and specify more than one private IP address using the private IP addresses
      option. You cannot specify this option if you're launching more than one
      instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if
      creating a network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA),
      specify ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `Placement`

    The placement information.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using
      commas; for example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance
      with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
      tenancy is not supported for Spot Instances.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127
      Unicode characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255
      Unicode characters.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecifications` `TagSpecifications`

    The tags for a Spot Fleet resource.

    - **ResourceType** *(string) --*

      The type of resource. Currently, the only resource type that is supported is
      ``instance`` .

    - **Tags** *(list) --*

      The tags.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127
          Unicode characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255
          Unicode characters.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LaunchSpecifications`

    Describes the launch specification for one or more Spot Instances. If you include
    On-Demand capacity in your fleet request, you can't use
    ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
    .

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify
      the IDs of the security groups. When requesting instances in EC2-Classic, you can
      specify the names or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block devices that are mapped to the Spot Instances. You can't specify
      both a snapshot ID and an encryption value. This is because only blank volumes can
      be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
      and its encryption status is used for the volume encryption status.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can
          specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
          available instance store volumes depends on the instance type. After you
          connect to the instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device
          name. Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the
          block device mapping for the instance. When you launch an M3 instance, we
          ignore any instance store volumes specified in the block device mapping for the
          AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is
          launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for
            the volume. For ``gp2`` volumes, this represents the baseline performance of
            the volume and the rate at which the volume accumulates I/O credits for
            bursting. For more information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
            64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
            64,000 is guaranteed only on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes;
            it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
            ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a
            volume size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
            Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
            (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
            (``standard`` ) volumes. If you specify a snapshot, the volume size must be
            equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the
            IOPS that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while
            being restored from a backing snapshot. The effect of setting the encryption
            state to ``true`` depends on the volume origin (new or from a snapshot),
            starting encryption state, ownership, and whether encryption by default is
            enabled. For more information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
            CMK under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            , `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instances are optimized for EBS I/O. This optimization
      provides dedicated throughput to Amazon EBS and an optimized configuration stack to
      provide optimal EBS I/O performance. This optimization isn't available with all
      instance types. Additional usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **Monitoring** *(dict) --*

      Enable or disable monitoring for the instances.

      - **Enabled** *(boolean) --*

        Enables monitoring for the instance.

        Default: ``false``

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must
      specify subnet IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in
          a VPC. The public IP address can only be assigned to a network interface for
          eth0, and can only be assigned to a new network interface, not an existing one.
          You cannot specify more than one network interface in the request. If launching
          into a default subnet, the default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated.
          You can specify ``true`` only if creating a new network interface when
          launching an instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network
          interface when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary
          network interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify
          the device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if
          creating a network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2
          chooses the IPv6 addresses from the range of the subnet. You cannot specify
          this option and the option to assign specific IPv6 addresses in the same
          request. You can specify this option if you've specified a minimum number of
          instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot
          specify this option and the option to assign a number of IPv6 addresses in the
          same request. You cannot specify this option if you've specified a minimum
          number of instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a
          network interface when launching an instance. You cannot specify this option if
          you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one
          private IPv4 address can be designated as primary. You cannot specify this
          option if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4
              address. Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option
          and specify more than one private IP address using the private IP addresses
          option. You cannot specify this option if you're launching more than one
          instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if
          creating a network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA),
          specify ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
          *Amazon Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using
        commas; for example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance
        with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
        tenancy is not supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk. Some kernels require additional drivers at launch. Check
      the kernel requirements for information about whether you need to specify a RAM
      disk. To find kernel requirements, refer to the AWS Resource Center and search for
      the kernel ID.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. If
      this value is not specified, the default is the Spot price specified for the fleet.
      To determine the Spot price per unit hour, divide the Spot price by the value of
      ``WeightedCapacity`` .

    - **SubnetId** *(string) --*

      The IDs of the subnets in which to launch the instances. To specify multiple
      subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
      subnet-0987cdef6example2".

    - **UserData** *(string) --*

      The Base64-encoded user data that instances use when starting up.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type. These are the same
      units that you chose to set the target capacity in terms of instances, or a
      performance characteristic such as vCPUs, memory, or I/O.

      If the target capacity divided by this value is not a whole number, Amazon EC2
      rounds the number of instances to the next whole number. If this value is not
      specified, the default is 1.

    - **TagSpecifications** *(list) --*

      The tags to apply during creation.

      - *(dict) --*

        The tags for a Spot Fleet resource.

        - **ResourceType** *(string) --*

          The type of resource. Currently, the only resource type that is supported is
          ``instance`` .

        - **Tags** *(list) --*

          The tags.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127
              Unicode characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255
              Unicode characters.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigs` `LaunchTemplateSpecification`

    The launch template.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template. You must specify either a template ID or a
      template name.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template. You must specify either a template name or a
      template ID.

    - **Version** *(string) --*

      The version number of the launch template. You must specify a version number.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": str,
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigs` `Overrides`

    Describes overrides for a launch template.

    - **InstanceType** *(string) --*

      The instance type.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instances.

    - **AvailabilityZone** *(string) --*

      The Availability Zone in which to launch the instances.

    - **WeightedCapacity** *(float) --*

      The number of units provided by the specified instance type.

    - **Priority** *(float) --*

      The priority for the launch template override. If
      **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
      priority to determine which launch template override to use first in fulfilling
      On-Demand capacity. The highest priority is launched first. Valid values are
      whole numbers starting at ``0`` . The lower the number, the higher the
      priority. If no number is set, the launch template override has the lowest
      priority.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LaunchTemplateConfigs`

    Describes a launch template and overrides.

    - **LaunchTemplateSpecification** *(dict) --*

      The launch template.

      - **LaunchTemplateId** *(string) --*

        The ID of the launch template. You must specify either a template ID or a
        template name.

      - **LaunchTemplateName** *(string) --*

        The name of the launch template. You must specify either a template name or a
        template ID.

      - **Version** *(string) --*

        The version number of the launch template. You must specify a version number.

    - **Overrides** *(list) --*

      Any parameters that you specify override the same parameters in the launch template.

      - *(dict) --*

        Describes overrides for a launch template.

        - **InstanceType** *(string) --*

          The instance type.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance.

        - **SubnetId** *(string) --*

          The ID of the subnet in which to launch the instances.

        - **AvailabilityZone** *(string) --*

          The Availability Zone in which to launch the instances.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type.

        - **Priority** *(float) --*

          The priority for the launch template override. If
          **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
          priority to determine which launch template override to use first in fulfilling
          On-Demand capacity. The highest priority is launched first. Valid values are
          whole numbers starting at ``0`` . The lower the number, the higher the
          priority. If no number is set, the launch template override has the lowest
          priority.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfig` `ClassicLoadBalancers`

    Describes a Classic Load Balancer.

    - **Name** *(string) --*

      The name of the load balancer.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfig` `ClassicLoadBalancersConfig`

    The Classic Load Balancers.

    - **ClassicLoadBalancers** *(list) --*

      One or more Classic Load Balancers.

      - *(dict) --*

        Describes a Classic Load Balancer.

        - **Name** *(string) --*

          The name of the load balancer.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfig` `TargetGroups`

    Describes a load balancer target group.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the target group.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfig` `TargetGroupsConfig`

    The target groups.

    - **TargetGroups** *(list) --*

      One or more target groups.

      - *(dict) --*

        Describes a load balancer target group.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the target group.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfig` `LoadBalancersConfig`

    One or more Classic Load Balancers and target groups to attach to the Spot Fleet
    request. Spot Fleet registers the running Spot Instances with the specified Classic
    Load Balancers and target groups.

    With Network Load Balancers, Spot Fleet cannot register instances that have the
    following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
    M3, and T1.

    - **ClassicLoadBalancersConfig** *(dict) --*

      The Classic Load Balancers.

      - **ClassicLoadBalancers** *(list) --*

        One or more Classic Load Balancers.

        - *(dict) --*

          Describes a Classic Load Balancer.

          - **Name** *(string) --*

            The name of the load balancer.

    - **TargetGroupsConfig** *(dict) --*

      The target groups.

      - **TargetGroups** *(list) --*

        One or more target groups.

        - *(dict) --*

          Describes a load balancer target group.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the target group.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": str,
        "OnDemandAllocationStrategy": str,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": str,
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": str,
        "LoadBalancersConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigs` `SpotFleetRequestConfig`

    The configuration of the Spot Fleet request.

    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance
      pools specified by the Spot Fleet request.

      If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
      Spot Instance pools with the lowest price. This is the default allocation strategy.

      If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
      the Spot Instance pools that you specify.

      If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
      from Spot Instance pools with optimal capacity for the number of instances that are
      launching.

    - **OnDemandAllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If
      you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
      the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
      that you assign to each Spot Fleet launch template override, launching the highest
      priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

    - **ClientToken** *(string) --*

      A unique, case-sensitive identifier that you provide to ensure the idempotency of your
      listings. This helps to avoid duplicate listings. For more information, see `Ensuring
      Idempotency
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
      .

    - **ExcessCapacityTerminationPolicy** *(string) --*

      Indicates whether running Spot Instances should be terminated if you decrease the
      target capacity of the Spot Fleet request below the current size of the Spot Fleet.

    - **FulfilledCapacity** *(float) --*

      The number of units fulfilled by this request compared to the set target capacity. You
      cannot set this value.

    - **OnDemandFulfilledCapacity** *(float) --*

      The number of On-Demand units fulfilled by this request compared to the set target
      On-Demand capacity.

    - **IamFleetRole** *(string) --*

      The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
      grants the Spot Fleet the permission to request, launch, terminate, and tag instances
      on your behalf. For more information, see `Spot Fleet Prerequisites
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
      in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
      Instances on your behalf when you cancel its Spot Fleet request using
      CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
      ``TerminateInstancesWithExpiration`` .

    - **LaunchSpecifications** *(list) --*

      The launch specifications for the Spot Fleet request. If you specify
      ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
      On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes the launch specification for one or more Spot Instances. If you include
        On-Demand capacity in your fleet request, you can't use
        ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
        .

        - **SecurityGroups** *(list) --*

          One or more security groups. When requesting instances in a VPC, you must specify
          the IDs of the security groups. When requesting instances in EC2-Classic, you can
          specify the names or the IDs of the security groups.

          - *(dict) --*

            Describes a security group.

            - **GroupName** *(string) --*

              The name of the security group.

            - **GroupId** *(string) --*

              The ID of the security group.

        - **AddressingType** *(string) --*

          Deprecated.

        - **BlockDeviceMappings** *(list) --*

          One or more block devices that are mapped to the Spot Instances. You can't specify
          both a snapshot ID and an encryption value. This is because only blank volumes can
          be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
          and its encryption status is used for the volume encryption status.

          - *(dict) --*

            Describes a block device mapping.

            - **DeviceName** *(string) --*

              The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

            - **VirtualName** *(string) --*

              The virtual device name (``ephemeral`` N). Instance store volumes are numbered
              starting from 0. An instance type with 2 available instance store volumes can
              specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
              available instance store volumes depends on the instance type. After you
              connect to the instance, you must mount the volume.

              NVMe instance store volumes are automatically enumerated and assigned a device
              name. Including them in your block device mapping has no effect.

              Constraints: For M3 instances, you must specify instance store volumes in the
              block device mapping for the instance. When you launch an M3 instance, we
              ignore any instance store volumes specified in the block device mapping for the
              AMI.

            - **Ebs** *(dict) --*

              Parameters used to automatically set up EBS volumes when the instance is
              launched.

              - **DeleteOnTermination** *(boolean) --*

                Indicates whether the EBS volume is deleted on instance termination. For more
                information, see `Preserving Amazon EBS Volumes on Instance Termination
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                in the Amazon Elastic Compute Cloud User Guide.

              - **Iops** *(integer) --*

                The number of I/O operations per second (IOPS) that the volume supports. For
                ``io1`` volumes, this represents the number of IOPS that are provisioned for
                the volume. For ``gp2`` volumes, this represents the baseline performance of
                the volume and the rate at which the volume accumulates I/O credits for
                bursting. For more information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                64,000 is guaranteed only on `Nitro-based instances
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                . Other instance families guarantee performance up to 32,000 IOPS. For more
                information, see `Amazon EBS Volume Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                Condition: This parameter is required for requests to create ``io1`` volumes;
                it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                ``standard`` volumes.

              - **SnapshotId** *(string) --*

                The ID of the snapshot.

              - **VolumeSize** *(integer) --*

                The size of the volume, in GiB.

                Default: If you're creating the volume from a snapshot and don't specify a
                volume size, the default is the snapshot size.

                Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                equal to or larger than the snapshot size.

              - **VolumeType** *(string) --*

                The volume type. If you set the type to ``io1`` , you must also specify the
                IOPS that the volume supports.

                Default: ``gp2``

              - **Encrypted** *(boolean) --*

                Indicates whether the encryption state of an EBS volume is changed while
                being restored from a backing snapshot. The effect of setting the encryption
                state to ``true`` depends on the volume origin (new or from a snapshot),
                starting encryption state, ownership, and whether encryption by default is
                enabled. For more information, see `Amazon EBS Encryption
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                in the *Amazon Elastic Compute Cloud User Guide* .

                In no case can you remove encryption from an encrypted volume.

                Encrypted volumes can only be attached to instances that support Amazon EBS
                encryption. For more information, see `Supported Instance Types
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                .

              - **KmsKeyId** *(string) --*

                Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                CMK under which the EBS volume is encrypted.

                This parameter is only supported on ``BlockDeviceMapping`` objects called by
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                , `RequestSpotFleet
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                , and `RequestSpotInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                .

            - **NoDevice** *(string) --*

              Suppresses the specified device included in the block device mapping of the AMI.

        - **EbsOptimized** *(boolean) --*

          Indicates whether the instances are optimized for EBS I/O. This optimization
          provides dedicated throughput to Amazon EBS and an optimized configuration stack to
          provide optimal EBS I/O performance. This optimization isn't available with all
          instance types. Additional usage charges apply when using an EBS Optimized instance.

          Default: ``false``

        - **IamInstanceProfile** *(dict) --*

          The IAM instance profile.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the instance profile.

          - **Name** *(string) --*

            The name of the instance profile.

        - **ImageId** *(string) --*

          The ID of the AMI.

        - **InstanceType** *(string) --*

          The instance type.

        - **KernelId** *(string) --*

          The ID of the kernel.

        - **KeyName** *(string) --*

          The name of the key pair.

        - **Monitoring** *(dict) --*

          Enable or disable monitoring for the instances.

          - **Enabled** *(boolean) --*

            Enables monitoring for the instance.

            Default: ``false``

        - **NetworkInterfaces** *(list) --*

          One or more network interfaces. If you specify a network interface, you must
          specify subnet IDs and security group IDs using the network interface.

          - *(dict) --*

            Describes a network interface.

            - **AssociatePublicIpAddress** *(boolean) --*

              Indicates whether to assign a public IPv4 address to an instance you launch in
              a VPC. The public IP address can only be assigned to a network interface for
              eth0, and can only be assigned to a new network interface, not an existing one.
              You cannot specify more than one network interface in the request. If launching
              into a default subnet, the default value is ``true`` .

            - **DeleteOnTermination** *(boolean) --*

              If set to ``true`` , the interface is deleted when the instance is terminated.
              You can specify ``true`` only if creating a new network interface when
              launching an instance.

            - **Description** *(string) --*

              The description of the network interface. Applies only if creating a network
              interface when launching an instance.

            - **DeviceIndex** *(integer) --*

              The position of the network interface in the attachment order. A primary
              network interface has a device index of 0.

              If you specify a network interface when launching an instance, you must specify
              the device index.

            - **Groups** *(list) --*

              The IDs of the security groups for the network interface. Applies only if
              creating a network interface when launching an instance.

              - *(string) --*

            - **Ipv6AddressCount** *(integer) --*

              A number of IPv6 addresses to assign to the network interface. Amazon EC2
              chooses the IPv6 addresses from the range of the subnet. You cannot specify
              this option and the option to assign specific IPv6 addresses in the same
              request. You can specify this option if you've specified a minimum number of
              instances to launch.

            - **Ipv6Addresses** *(list) --*

              One or more IPv6 addresses to assign to the network interface. You cannot
              specify this option and the option to assign a number of IPv6 addresses in the
              same request. You cannot specify this option if you've specified a minimum
              number of instances to launch.

              - *(dict) --*

                Describes an IPv6 address.

                - **Ipv6Address** *(string) --*

                  The IPv6 address.

            - **NetworkInterfaceId** *(string) --*

              The ID of the network interface.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 address of the network interface. Applies only if creating a
              network interface when launching an instance. You cannot specify this option if
              you're launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **PrivateIpAddresses** *(list) --*

              One or more private IPv4 addresses to assign to the network interface. Only one
              private IPv4 address can be designated as primary. You cannot specify this
              option if you're launching more than one instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

              - *(dict) --*

                Describes a secondary private IPv4 address for a network interface.

                - **Primary** *(boolean) --*

                  Indicates whether the private IPv4 address is the primary private IPv4
                  address. Only one IPv4 address can be designated as primary.

                - **PrivateIpAddress** *(string) --*

                  The private IPv4 addresses.

            - **SecondaryPrivateIpAddressCount** *(integer) --*

              The number of secondary private IPv4 addresses. You can't specify this option
              and specify more than one private IP address using the private IP addresses
              option. You cannot specify this option if you're launching more than one
              instance in a `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              request.

            - **SubnetId** *(string) --*

              The ID of the subnet associated with the network interface. Applies only if
              creating a network interface when launching an instance.

            - **InterfaceType** *(string) --*

              The type of network interface. To create an Elastic Fabric Adapter (EFA),
              specify ``efa`` . For more information, see `Elastic Fabric Adapter
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
              *Amazon Elastic Compute Cloud User Guide* .

              If you are not creating an EFA, specify ``interface`` or omit this parameter.

              Valid values: ``interface`` | ``efa``

        - **Placement** *(dict) --*

          The placement information.

          - **AvailabilityZone** *(string) --*

            The Availability Zone.

            [Spot Fleet only] To specify multiple Availability Zones, separate them using
            commas; for example, "us-west-2a, us-west-2b".

          - **GroupName** *(string) --*

            The name of the placement group.

          - **Tenancy** *(string) --*

            The tenancy of the instance (if the instance is running in a VPC). An instance
            with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
            tenancy is not supported for Spot Instances.

        - **RamdiskId** *(string) --*

          The ID of the RAM disk. Some kernels require additional drivers at launch. Check
          the kernel requirements for information about whether you need to specify a RAM
          disk. To find kernel requirements, refer to the AWS Resource Center and search for
          the kernel ID.

        - **SpotPrice** *(string) --*

          The maximum price per unit hour that you are willing to pay for a Spot Instance. If
          this value is not specified, the default is the Spot price specified for the fleet.
          To determine the Spot price per unit hour, divide the Spot price by the value of
          ``WeightedCapacity`` .

        - **SubnetId** *(string) --*

          The IDs of the subnets in which to launch the instances. To specify multiple
          subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
          subnet-0987cdef6example2".

        - **UserData** *(string) --*

          The Base64-encoded user data that instances use when starting up.

        - **WeightedCapacity** *(float) --*

          The number of units provided by the specified instance type. These are the same
          units that you chose to set the target capacity in terms of instances, or a
          performance characteristic such as vCPUs, memory, or I/O.

          If the target capacity divided by this value is not a whole number, Amazon EC2
          rounds the number of instances to the next whole number. If this value is not
          specified, the default is 1.

        - **TagSpecifications** *(list) --*

          The tags to apply during creation.

          - *(dict) --*

            The tags for a Spot Fleet resource.

            - **ResourceType** *(string) --*

              The type of resource. Currently, the only resource type that is supported is
              ``instance`` .

            - **Tags** *(list) --*

              The tags.

              - *(dict) --*

                Describes a tag.

                - **Key** *(string) --*

                  The key of the tag.

                  Constraints: Tag keys are case-sensitive and accept a maximum of 127
                  Unicode characters. May not begin with ``aws:`` .

                - **Value** *(string) --*

                  The value of the tag.

                  Constraints: Tag values are case-sensitive and accept a maximum of 255
                  Unicode characters.

    - **LaunchTemplateConfigs** *(list) --*

      The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
      specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
      you must use ``LaunchTemplateConfigs`` .

      - *(dict) --*

        Describes a launch template and overrides.

        - **LaunchTemplateSpecification** *(dict) --*

          The launch template.

          - **LaunchTemplateId** *(string) --*

            The ID of the launch template. You must specify either a template ID or a
            template name.

          - **LaunchTemplateName** *(string) --*

            The name of the launch template. You must specify either a template name or a
            template ID.

          - **Version** *(string) --*

            The version number of the launch template. You must specify a version number.

        - **Overrides** *(list) --*

          Any parameters that you specify override the same parameters in the launch template.

          - *(dict) --*

            Describes overrides for a launch template.

            - **InstanceType** *(string) --*

              The instance type.

            - **SpotPrice** *(string) --*

              The maximum price per unit hour that you are willing to pay for a Spot Instance.

            - **SubnetId** *(string) --*

              The ID of the subnet in which to launch the instances.

            - **AvailabilityZone** *(string) --*

              The Availability Zone in which to launch the instances.

            - **WeightedCapacity** *(float) --*

              The number of units provided by the specified instance type.

            - **Priority** *(float) --*

              The priority for the launch template override. If
              **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
              priority to determine which launch template override to use first in fulfilling
              On-Demand capacity. The highest priority is launched first. Valid values are
              whole numbers starting at ``0`` . The lower the number, the higher the
              priority. If no number is set, the launch template override has the lowest
              priority.

    - **SpotPrice** *(string) --*

      The maximum price per unit hour that you are willing to pay for a Spot Instance. The
      default is the On-Demand price.

    - **TargetCapacity** *(integer) --*

      The number of units to request for the Spot Fleet. You can choose to set the target
      capacity in terms of instances or a performance characteristic that is important to
      your application workload, such as vCPUs, memory, or I/O. If the request type is
      ``maintain`` , you can specify a target capacity of 0 and add capacity later.

    - **OnDemandTargetCapacity** *(integer) --*

      The number of On-Demand units to request. You can choose to set the target capacity in
      terms of instances or a performance characteristic that is important to your
      application workload, such as vCPUs, memory, or I/O. If the request type is
      ``maintain`` , you can specify a target capacity of 0 and add capacity later.

    - **OnDemandMaxTotalPrice** *(string) --*

      The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
      use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
      both parameters to ensure that your fleet cost does not exceed your budget. If you set
      a maximum price per hour for the On-Demand Instances and Spot Instances in your
      request, Spot Fleet will launch instances until it reaches the maximum amount you're
      willing to pay. When the maximum amount you're willing to pay is reached, the fleet
      stops launching instances even if it hasn’t met the target capacity.

    - **SpotMaxTotalPrice** *(string) --*

      The maximum amount per hour for Spot Instances that you're willing to pay. You can use
      the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
      parameters to ensure that your fleet cost does not exceed your budget. If you set a
      maximum price per hour for the On-Demand Instances and Spot Instances in your request,
      Spot Fleet will launch instances until it reaches the maximum amount you're willing to
      pay. When the maximum amount you're willing to pay is reached, the fleet stops
      launching instances even if it hasn’t met the target capacity.

    - **TerminateInstancesWithExpiration** *(boolean) --*

      Indicates whether running Spot Instances are terminated when the Spot Fleet request
      expires.

    - **Type** *(string) --*

      The type of request. Indicates whether the Spot Fleet only requests the target capacity
      or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
      places the required requests. It does not attempt to replenish Spot Instances if
      capacity is diminished, nor does it submit requests in alternative Spot pools if
      capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
      the target capacity. The Spot Fleet places the required requests to meet capacity and
      automatically replenishes any interrupted instances. Default: ``maintain`` .
      ``instant`` is listed but is not used by Spot Fleet.

    - **ValidFrom** *(datetime) --*

      The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

    - **ValidUntil** *(datetime) --*

      The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
      to fulfill the request. If no value is specified, the Spot Fleet request remains until
      you cancel it.

    - **ReplaceUnhealthyInstances** *(boolean) --*

      Indicates whether Spot Fleet should replace unhealthy instances.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

    - **LoadBalancersConfig** *(dict) --*

      One or more Classic Load Balancers and target groups to attach to the Spot Fleet
      request. Spot Fleet registers the running Spot Instances with the specified Classic
      Load Balancers and target groups.

      With Network Load Balancers, Spot Fleet cannot register instances that have the
      following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
      M3, and T1.

      - **ClassicLoadBalancersConfig** *(dict) --*

        The Classic Load Balancers.

        - **ClassicLoadBalancers** *(list) --*

          One or more Classic Load Balancers.

          - *(dict) --*

            Describes a Classic Load Balancer.

            - **Name** *(string) --*

              The name of the load balancer.

      - **TargetGroupsConfig** *(dict) --*

        The target groups.

        - **TargetGroups** *(list) --*

          One or more target groups.

          - *(dict) --*

            Describes a load balancer target group.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the target group.

    - **InstancePoolsToUseCount** *(integer) --*

      The number of Spot pools across which to allocate your target Spot capacity. Valid only
      when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
      cheapest Spot pools and evenly allocates your target Spot capacity across the number of
      Spot pools that you specify.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef",
    {
        "ActivityStatus": str,
        "CreateTime": datetime,
        "SpotFleetRequestConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef,
        "SpotFleetRequestId": str,
        "SpotFleetRequestState": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginateResponse` `SpotFleetRequestConfigs`

    Describes a Spot Fleet request.

    - **ActivityStatus** *(string) --*

      The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
      After all requests are placed, the status is ``pending_fulfillment`` . If the size of the
      fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If
      the size of the fleet is decreased, the status is ``pending_termination`` while Spot
      Instances are terminating.

    - **CreateTime** *(datetime) --*

      The creation date and time of the request.

    - **SpotFleetRequestConfig** *(dict) --*

      The configuration of the Spot Fleet request.

      - **AllocationStrategy** *(string) --*

        Indicates how to allocate the target Spot Instance capacity across the Spot Instance
        pools specified by the Spot Fleet request.

        If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
        Spot Instance pools with the lowest price. This is the default allocation strategy.

        If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
        the Spot Instance pools that you specify.

        If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
        from Spot Instance pools with optimal capacity for the number of instances that are
        launching.

      - **OnDemandAllocationStrategy** *(string) --*

        The order of the launch template overrides to use in fulfilling On-Demand capacity. If
        you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
        the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
        that you assign to each Spot Fleet launch template override, launching the highest
        priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

      - **ClientToken** *(string) --*

        A unique, case-sensitive identifier that you provide to ensure the idempotency of your
        listings. This helps to avoid duplicate listings. For more information, see `Ensuring
        Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
        .

      - **ExcessCapacityTerminationPolicy** *(string) --*

        Indicates whether running Spot Instances should be terminated if you decrease the
        target capacity of the Spot Fleet request below the current size of the Spot Fleet.

      - **FulfilledCapacity** *(float) --*

        The number of units fulfilled by this request compared to the set target capacity. You
        cannot set this value.

      - **OnDemandFulfilledCapacity** *(float) --*

        The number of On-Demand units fulfilled by this request compared to the set target
        On-Demand capacity.

      - **IamFleetRole** *(string) --*

        The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
        grants the Spot Fleet the permission to request, launch, terminate, and tag instances
        on your behalf. For more information, see `Spot Fleet Prerequisites
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
        in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
        Instances on your behalf when you cancel its Spot Fleet request using
        CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
        ``TerminateInstancesWithExpiration`` .

      - **LaunchSpecifications** *(list) --*

        The launch specifications for the Spot Fleet request. If you specify
        ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
        On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

        - *(dict) --*

          Describes the launch specification for one or more Spot Instances. If you include
          On-Demand capacity in your fleet request, you can't use
          ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
          .

          - **SecurityGroups** *(list) --*

            One or more security groups. When requesting instances in a VPC, you must specify
            the IDs of the security groups. When requesting instances in EC2-Classic, you can
            specify the names or the IDs of the security groups.

            - *(dict) --*

              Describes a security group.

              - **GroupName** *(string) --*

                The name of the security group.

              - **GroupId** *(string) --*

                The ID of the security group.

          - **AddressingType** *(string) --*

            Deprecated.

          - **BlockDeviceMappings** *(list) --*

            One or more block devices that are mapped to the Spot Instances. You can't specify
            both a snapshot ID and an encryption value. This is because only blank volumes can
            be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
            and its encryption status is used for the volume encryption status.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

              - **VirtualName** *(string) --*

                The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                starting from 0. An instance type with 2 available instance store volumes can
                specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
                available instance store volumes depends on the instance type. After you
                connect to the instance, you must mount the volume.

                NVMe instance store volumes are automatically enumerated and assigned a device
                name. Including them in your block device mapping has no effect.

                Constraints: For M3 instances, you must specify instance store volumes in the
                block device mapping for the instance. When you launch an M3 instance, we
                ignore any instance store volumes specified in the block device mapping for the
                AMI.

              - **Ebs** *(dict) --*

                Parameters used to automatically set up EBS volumes when the instance is
                launched.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination. For more
                  information, see `Preserving Amazon EBS Volumes on Instance Termination
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                  in the Amazon Elastic Compute Cloud User Guide.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports. For
                  ``io1`` volumes, this represents the number of IOPS that are provisioned for
                  the volume. For ``gp2`` volumes, this represents the baseline performance of
                  the volume and the rate at which the volume accumulates I/O credits for
                  bursting. For more information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                  64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                  64,000 is guaranteed only on `Nitro-based instances
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                  . Other instance families guarantee performance up to 32,000 IOPS. For more
                  information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  Condition: This parameter is required for requests to create ``io1`` volumes;
                  it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                  ``standard`` volumes.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                  Default: If you're creating the volume from a snapshot and don't specify a
                  volume size, the default is the snapshot size.

                  Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                  Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                  (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                  (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                  equal to or larger than the snapshot size.

                - **VolumeType** *(string) --*

                  The volume type. If you set the type to ``io1`` , you must also specify the
                  IOPS that the volume supports.

                  Default: ``gp2``

                - **Encrypted** *(boolean) --*

                  Indicates whether the encryption state of an EBS volume is changed while
                  being restored from a backing snapshot. The effect of setting the encryption
                  state to ``true`` depends on the volume origin (new or from a snapshot),
                  starting encryption state, ownership, and whether encryption by default is
                  enabled. For more information, see `Amazon EBS Encryption
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  In no case can you remove encryption from an encrypted volume.

                  Encrypted volumes can only be attached to instances that support Amazon EBS
                  encryption. For more information, see `Supported Instance Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                  .

                - **KmsKeyId** *(string) --*

                  Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                  CMK under which the EBS volume is encrypted.

                  This parameter is only supported on ``BlockDeviceMapping`` objects called by
                  `RunInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                  , `RequestSpotFleet
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                  , and `RequestSpotInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                  .

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instances are optimized for EBS I/O. This optimization
            provides dedicated throughput to Amazon EBS and an optimized configuration stack to
            provide optimal EBS I/O performance. This optimization isn't available with all
            instance types. Additional usage charges apply when using an EBS Optimized instance.

            Default: ``false``

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **ImageId** *(string) --*

            The ID of the AMI.

          - **InstanceType** *(string) --*

            The instance type.

          - **KernelId** *(string) --*

            The ID of the kernel.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **Monitoring** *(dict) --*

            Enable or disable monitoring for the instances.

            - **Enabled** *(boolean) --*

              Enables monitoring for the instance.

              Default: ``false``

          - **NetworkInterfaces** *(list) --*

            One or more network interfaces. If you specify a network interface, you must
            specify subnet IDs and security group IDs using the network interface.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to assign a public IPv4 address to an instance you launch in
                a VPC. The public IP address can only be assigned to a network interface for
                eth0, and can only be assigned to a new network interface, not an existing one.
                You cannot specify more than one network interface in the request. If launching
                into a default subnet, the default value is ``true`` .

              - **DeleteOnTermination** *(boolean) --*

                If set to ``true`` , the interface is deleted when the instance is terminated.
                You can specify ``true`` only if creating a new network interface when
                launching an instance.

              - **Description** *(string) --*

                The description of the network interface. Applies only if creating a network
                interface when launching an instance.

              - **DeviceIndex** *(integer) --*

                The position of the network interface in the attachment order. A primary
                network interface has a device index of 0.

                If you specify a network interface when launching an instance, you must specify
                the device index.

              - **Groups** *(list) --*

                The IDs of the security groups for the network interface. Applies only if
                creating a network interface when launching an instance.

                - *(string) --*

              - **Ipv6AddressCount** *(integer) --*

                A number of IPv6 addresses to assign to the network interface. Amazon EC2
                chooses the IPv6 addresses from the range of the subnet. You cannot specify
                this option and the option to assign specific IPv6 addresses in the same
                request. You can specify this option if you've specified a minimum number of
                instances to launch.

              - **Ipv6Addresses** *(list) --*

                One or more IPv6 addresses to assign to the network interface. You cannot
                specify this option and the option to assign a number of IPv6 addresses in the
                same request. You cannot specify this option if you've specified a minimum
                number of instances to launch.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 address of the network interface. Applies only if creating a
                network interface when launching an instance. You cannot specify this option if
                you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses to assign to the network interface. Only one
                private IPv4 address can be designated as primary. You cannot specify this
                option if you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4
                    address. Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses. You can't specify this option
                and specify more than one private IP address using the private IP addresses
                option. You cannot specify this option if you're launching more than one
                instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **SubnetId** *(string) --*

                The ID of the subnet associated with the network interface. Applies only if
                creating a network interface when launching an instance.

              - **InterfaceType** *(string) --*

                The type of network interface. To create an Elastic Fabric Adapter (EFA),
                specify ``efa`` . For more information, see `Elastic Fabric Adapter
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
                *Amazon Elastic Compute Cloud User Guide* .

                If you are not creating an EFA, specify ``interface`` or omit this parameter.

                Valid values: ``interface`` | ``efa``

          - **Placement** *(dict) --*

            The placement information.

            - **AvailabilityZone** *(string) --*

              The Availability Zone.

              [Spot Fleet only] To specify multiple Availability Zones, separate them using
              commas; for example, "us-west-2a, us-west-2b".

            - **GroupName** *(string) --*

              The name of the placement group.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance
              with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
              tenancy is not supported for Spot Instances.

          - **RamdiskId** *(string) --*

            The ID of the RAM disk. Some kernels require additional drivers at launch. Check
            the kernel requirements for information about whether you need to specify a RAM
            disk. To find kernel requirements, refer to the AWS Resource Center and search for
            the kernel ID.

          - **SpotPrice** *(string) --*

            The maximum price per unit hour that you are willing to pay for a Spot Instance. If
            this value is not specified, the default is the Spot price specified for the fleet.
            To determine the Spot price per unit hour, divide the Spot price by the value of
            ``WeightedCapacity`` .

          - **SubnetId** *(string) --*

            The IDs of the subnets in which to launch the instances. To specify multiple
            subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
            subnet-0987cdef6example2".

          - **UserData** *(string) --*

            The Base64-encoded user data that instances use when starting up.

          - **WeightedCapacity** *(float) --*

            The number of units provided by the specified instance type. These are the same
            units that you chose to set the target capacity in terms of instances, or a
            performance characteristic such as vCPUs, memory, or I/O.

            If the target capacity divided by this value is not a whole number, Amazon EC2
            rounds the number of instances to the next whole number. If this value is not
            specified, the default is 1.

          - **TagSpecifications** *(list) --*

            The tags to apply during creation.

            - *(dict) --*

              The tags for a Spot Fleet resource.

              - **ResourceType** *(string) --*

                The type of resource. Currently, the only resource type that is supported is
                ``instance`` .

              - **Tags** *(list) --*

                The tags.

                - *(dict) --*

                  Describes a tag.

                  - **Key** *(string) --*

                    The key of the tag.

                    Constraints: Tag keys are case-sensitive and accept a maximum of 127
                    Unicode characters. May not begin with ``aws:`` .

                  - **Value** *(string) --*

                    The value of the tag.

                    Constraints: Tag values are case-sensitive and accept a maximum of 255
                    Unicode characters.

      - **LaunchTemplateConfigs** *(list) --*

        The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
        specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
        you must use ``LaunchTemplateConfigs`` .

        - *(dict) --*

          Describes a launch template and overrides.

          - **LaunchTemplateSpecification** *(dict) --*

            The launch template.

            - **LaunchTemplateId** *(string) --*

              The ID of the launch template. You must specify either a template ID or a
              template name.

            - **LaunchTemplateName** *(string) --*

              The name of the launch template. You must specify either a template name or a
              template ID.

            - **Version** *(string) --*

              The version number of the launch template. You must specify a version number.

          - **Overrides** *(list) --*

            Any parameters that you specify override the same parameters in the launch template.

            - *(dict) --*

              Describes overrides for a launch template.

              - **InstanceType** *(string) --*

                The instance type.

              - **SpotPrice** *(string) --*

                The maximum price per unit hour that you are willing to pay for a Spot Instance.

              - **SubnetId** *(string) --*

                The ID of the subnet in which to launch the instances.

              - **AvailabilityZone** *(string) --*

                The Availability Zone in which to launch the instances.

              - **WeightedCapacity** *(float) --*

                The number of units provided by the specified instance type.

              - **Priority** *(float) --*

                The priority for the launch template override. If
                **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
                priority to determine which launch template override to use first in fulfilling
                On-Demand capacity. The highest priority is launched first. Valid values are
                whole numbers starting at ``0`` . The lower the number, the higher the
                priority. If no number is set, the launch template override has the lowest
                priority.

      - **SpotPrice** *(string) --*

        The maximum price per unit hour that you are willing to pay for a Spot Instance. The
        default is the On-Demand price.

      - **TargetCapacity** *(integer) --*

        The number of units to request for the Spot Fleet. You can choose to set the target
        capacity in terms of instances or a performance characteristic that is important to
        your application workload, such as vCPUs, memory, or I/O. If the request type is
        ``maintain`` , you can specify a target capacity of 0 and add capacity later.

      - **OnDemandTargetCapacity** *(integer) --*

        The number of On-Demand units to request. You can choose to set the target capacity in
        terms of instances or a performance characteristic that is important to your
        application workload, such as vCPUs, memory, or I/O. If the request type is
        ``maintain`` , you can specify a target capacity of 0 and add capacity later.

      - **OnDemandMaxTotalPrice** *(string) --*

        The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
        use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
        both parameters to ensure that your fleet cost does not exceed your budget. If you set
        a maximum price per hour for the On-Demand Instances and Spot Instances in your
        request, Spot Fleet will launch instances until it reaches the maximum amount you're
        willing to pay. When the maximum amount you're willing to pay is reached, the fleet
        stops launching instances even if it hasn’t met the target capacity.

      - **SpotMaxTotalPrice** *(string) --*

        The maximum amount per hour for Spot Instances that you're willing to pay. You can use
        the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
        parameters to ensure that your fleet cost does not exceed your budget. If you set a
        maximum price per hour for the On-Demand Instances and Spot Instances in your request,
        Spot Fleet will launch instances until it reaches the maximum amount you're willing to
        pay. When the maximum amount you're willing to pay is reached, the fleet stops
        launching instances even if it hasn’t met the target capacity.

      - **TerminateInstancesWithExpiration** *(boolean) --*

        Indicates whether running Spot Instances are terminated when the Spot Fleet request
        expires.

      - **Type** *(string) --*

        The type of request. Indicates whether the Spot Fleet only requests the target capacity
        or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
        places the required requests. It does not attempt to replenish Spot Instances if
        capacity is diminished, nor does it submit requests in alternative Spot pools if
        capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
        the target capacity. The Spot Fleet places the required requests to meet capacity and
        automatically replenishes any interrupted instances. Default: ``maintain`` .
        ``instant`` is listed but is not used by Spot Fleet.

      - **ValidFrom** *(datetime) --*

        The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
        :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

      - **ValidUntil** *(datetime) --*

        The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
        :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
        to fulfill the request. If no value is specified, the Spot Fleet request remains until
        you cancel it.

      - **ReplaceUnhealthyInstances** *(boolean) --*

        Indicates whether Spot Fleet should replace unhealthy instances.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

      - **LoadBalancersConfig** *(dict) --*

        One or more Classic Load Balancers and target groups to attach to the Spot Fleet
        request. Spot Fleet registers the running Spot Instances with the specified Classic
        Load Balancers and target groups.

        With Network Load Balancers, Spot Fleet cannot register instances that have the
        following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
        M3, and T1.

        - **ClassicLoadBalancersConfig** *(dict) --*

          The Classic Load Balancers.

          - **ClassicLoadBalancers** *(list) --*

            One or more Classic Load Balancers.

            - *(dict) --*

              Describes a Classic Load Balancer.

              - **Name** *(string) --*

                The name of the load balancer.

        - **TargetGroupsConfig** *(dict) --*

          The target groups.

          - **TargetGroups** *(list) --*

            One or more target groups.

            - *(dict) --*

              Describes a load balancer target group.

              - **Arn** *(string) --*

                The Amazon Resource Name (ARN) of the target group.

      - **InstancePoolsToUseCount** *(integer) --*

        The number of Spot pools across which to allocate your target Spot capacity. Valid only
        when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
        cheapest Spot pools and evenly allocates your target Spot capacity across the number of
        Spot pools that you specify.

    - **SpotFleetRequestId** *(string) --*

      The ID of the Spot Fleet request.

    - **SpotFleetRequestState** *(string) --*

      The state of the Spot Fleet request.
    """


_DescribeSpotFleetRequestsPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseTypeDef",
    {
        "SpotFleetRequestConfigs": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSpotFleetRequestsPaginate` `Response`

    Contains the output of DescribeSpotFleetRequests.

    - **SpotFleetRequestConfigs** *(list) --*

      Information about the configuration of your Spot Fleet.

      - *(dict) --*

        Describes a Spot Fleet request.

        - **ActivityStatus** *(string) --*

          The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
          After all requests are placed, the status is ``pending_fulfillment`` . If the size of the
          fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If
          the size of the fleet is decreased, the status is ``pending_termination`` while Spot
          Instances are terminating.

        - **CreateTime** *(datetime) --*

          The creation date and time of the request.

        - **SpotFleetRequestConfig** *(dict) --*

          The configuration of the Spot Fleet request.

          - **AllocationStrategy** *(string) --*

            Indicates how to allocate the target Spot Instance capacity across the Spot Instance
            pools specified by the Spot Fleet request.

            If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the
            Spot Instance pools with the lowest price. This is the default allocation strategy.

            If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all
            the Spot Instance pools that you specify.

            If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances
            from Spot Instance pools with optimal capacity for the number of instances that are
            launching.

          - **OnDemandAllocationStrategy** *(string) --*

            The order of the launch template overrides to use in fulfilling On-Demand capacity. If
            you specify ``lowestPrice`` , Spot Fleet uses price to determine the order, launching
            the lowest price first. If you specify ``prioritized`` , Spot Fleet uses the priority
            that you assign to each Spot Fleet launch template override, launching the highest
            priority first. If you do not specify a value, Spot Fleet defaults to ``lowestPrice`` .

          - **ClientToken** *(string) --*

            A unique, case-sensitive identifier that you provide to ensure the idempotency of your
            listings. This helps to avoid duplicate listings. For more information, see `Ensuring
            Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .

          - **ExcessCapacityTerminationPolicy** *(string) --*

            Indicates whether running Spot Instances should be terminated if you decrease the
            target capacity of the Spot Fleet request below the current size of the Spot Fleet.

          - **FulfilledCapacity** *(float) --*

            The number of units fulfilled by this request compared to the set target capacity. You
            cannot set this value.

          - **OnDemandFulfilledCapacity** *(float) --*

            The number of On-Demand units fulfilled by this request compared to the set target
            On-Demand capacity.

          - **IamFleetRole** *(string) --*

            The Amazon Resource Name (ARN) of an AWS Identity and Access Management (IAM) role that
            grants the Spot Fleet the permission to request, launch, terminate, and tag instances
            on your behalf. For more information, see `Spot Fleet Prerequisites
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites>`__
            in the *Amazon EC2 User Guide for Linux Instances* . Spot Fleet can terminate Spot
            Instances on your behalf when you cancel its Spot Fleet request using
            CancelSpotFleetRequests or when the Spot Fleet request expires, if you set
            ``TerminateInstancesWithExpiration`` .

          - **LaunchSpecifications** *(list) --*

            The launch specifications for the Spot Fleet request. If you specify
            ``LaunchSpecifications`` , you can't specify ``LaunchTemplateConfigs`` . If you include
            On-Demand capacity in your request, you must use ``LaunchTemplateConfigs`` .

            - *(dict) --*

              Describes the launch specification for one or more Spot Instances. If you include
              On-Demand capacity in your fleet request, you can't use
              ``SpotFleetLaunchSpecification`` ; you must use `LaunchTemplateConfig
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html>`__
              .

              - **SecurityGroups** *(list) --*

                One or more security groups. When requesting instances in a VPC, you must specify
                the IDs of the security groups. When requesting instances in EC2-Classic, you can
                specify the names or the IDs of the security groups.

                - *(dict) --*

                  Describes a security group.

                  - **GroupName** *(string) --*

                    The name of the security group.

                  - **GroupId** *(string) --*

                    The ID of the security group.

              - **AddressingType** *(string) --*

                Deprecated.

              - **BlockDeviceMappings** *(list) --*

                One or more block devices that are mapped to the Spot Instances. You can't specify
                both a snapshot ID and an encryption value. This is because only blank volumes can
                be encrypted on creation. If a snapshot is the basis for a volume, it is not blank
                and its encryption status is used for the volume encryption status.

                - *(dict) --*

                  Describes a block device mapping.

                  - **DeviceName** *(string) --*

                    The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

                  - **VirtualName** *(string) --*

                    The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                    starting from 0. An instance type with 2 available instance store volumes can
                    specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of
                    available instance store volumes depends on the instance type. After you
                    connect to the instance, you must mount the volume.

                    NVMe instance store volumes are automatically enumerated and assigned a device
                    name. Including them in your block device mapping has no effect.

                    Constraints: For M3 instances, you must specify instance store volumes in the
                    block device mapping for the instance. When you launch an M3 instance, we
                    ignore any instance store volumes specified in the block device mapping for the
                    AMI.

                  - **Ebs** *(dict) --*

                    Parameters used to automatically set up EBS volumes when the instance is
                    launched.

                    - **DeleteOnTermination** *(boolean) --*

                      Indicates whether the EBS volume is deleted on instance termination. For more
                      information, see `Preserving Amazon EBS Volumes on Instance Termination
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                      in the Amazon Elastic Compute Cloud User Guide.

                    - **Iops** *(integer) --*

                      The number of I/O operations per second (IOPS) that the volume supports. For
                      ``io1`` volumes, this represents the number of IOPS that are provisioned for
                      the volume. For ``gp2`` volumes, this represents the baseline performance of
                      the volume and the rate at which the volume accumulates I/O credits for
                      bursting. For more information, see `Amazon EBS Volume Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to
                      64,000IOPS for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of
                      64,000 is guaranteed only on `Nitro-based instances
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                      . Other instance families guarantee performance up to 32,000 IOPS. For more
                      information, see `Amazon EBS Volume Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      Condition: This parameter is required for requests to create ``io1`` volumes;
                      it is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or
                      ``standard`` volumes.

                    - **SnapshotId** *(string) --*

                      The ID of the snapshot.

                    - **VolumeSize** *(integer) --*

                      The size of the volume, in GiB.

                      Default: If you're creating the volume from a snapshot and don't specify a
                      volume size, the default is the snapshot size.

                      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for
                      Provisioned IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD
                      (``st1`` ), 500-16384 for Cold HDD (``sc1`` ), and 1-1024 for Magnetic
                      (``standard`` ) volumes. If you specify a snapshot, the volume size must be
                      equal to or larger than the snapshot size.

                    - **VolumeType** *(string) --*

                      The volume type. If you set the type to ``io1`` , you must also specify the
                      IOPS that the volume supports.

                      Default: ``gp2``

                    - **Encrypted** *(boolean) --*

                      Indicates whether the encryption state of an EBS volume is changed while
                      being restored from a backing snapshot. The effect of setting the encryption
                      state to ``true`` depends on the volume origin (new or from a snapshot),
                      starting encryption state, ownership, and whether encryption by default is
                      enabled. For more information, see `Amazon EBS Encryption
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                      in the *Amazon Elastic Compute Cloud User Guide* .

                      In no case can you remove encryption from an encrypted volume.

                      Encrypted volumes can only be attached to instances that support Amazon EBS
                      encryption. For more information, see `Supported Instance Types
                      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                      .

                    - **KmsKeyId** *(string) --*

                      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed
                      CMK under which the EBS volume is encrypted.

                      This parameter is only supported on ``BlockDeviceMapping`` objects called by
                      `RunInstances
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                      , `RequestSpotFleet
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                      , and `RequestSpotInstances
                      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                      .

                  - **NoDevice** *(string) --*

                    Suppresses the specified device included in the block device mapping of the AMI.

              - **EbsOptimized** *(boolean) --*

                Indicates whether the instances are optimized for EBS I/O. This optimization
                provides dedicated throughput to Amazon EBS and an optimized configuration stack to
                provide optimal EBS I/O performance. This optimization isn't available with all
                instance types. Additional usage charges apply when using an EBS Optimized instance.

                Default: ``false``

              - **IamInstanceProfile** *(dict) --*

                The IAM instance profile.

                - **Arn** *(string) --*

                  The Amazon Resource Name (ARN) of the instance profile.

                - **Name** *(string) --*

                  The name of the instance profile.

              - **ImageId** *(string) --*

                The ID of the AMI.

              - **InstanceType** *(string) --*

                The instance type.

              - **KernelId** *(string) --*

                The ID of the kernel.

              - **KeyName** *(string) --*

                The name of the key pair.

              - **Monitoring** *(dict) --*

                Enable or disable monitoring for the instances.

                - **Enabled** *(boolean) --*

                  Enables monitoring for the instance.

                  Default: ``false``

              - **NetworkInterfaces** *(list) --*

                One or more network interfaces. If you specify a network interface, you must
                specify subnet IDs and security group IDs using the network interface.

                - *(dict) --*

                  Describes a network interface.

                  - **AssociatePublicIpAddress** *(boolean) --*

                    Indicates whether to assign a public IPv4 address to an instance you launch in
                    a VPC. The public IP address can only be assigned to a network interface for
                    eth0, and can only be assigned to a new network interface, not an existing one.
                    You cannot specify more than one network interface in the request. If launching
                    into a default subnet, the default value is ``true`` .

                  - **DeleteOnTermination** *(boolean) --*

                    If set to ``true`` , the interface is deleted when the instance is terminated.
                    You can specify ``true`` only if creating a new network interface when
                    launching an instance.

                  - **Description** *(string) --*

                    The description of the network interface. Applies only if creating a network
                    interface when launching an instance.

                  - **DeviceIndex** *(integer) --*

                    The position of the network interface in the attachment order. A primary
                    network interface has a device index of 0.

                    If you specify a network interface when launching an instance, you must specify
                    the device index.

                  - **Groups** *(list) --*

                    The IDs of the security groups for the network interface. Applies only if
                    creating a network interface when launching an instance.

                    - *(string) --*

                  - **Ipv6AddressCount** *(integer) --*

                    A number of IPv6 addresses to assign to the network interface. Amazon EC2
                    chooses the IPv6 addresses from the range of the subnet. You cannot specify
                    this option and the option to assign specific IPv6 addresses in the same
                    request. You can specify this option if you've specified a minimum number of
                    instances to launch.

                  - **Ipv6Addresses** *(list) --*

                    One or more IPv6 addresses to assign to the network interface. You cannot
                    specify this option and the option to assign a number of IPv6 addresses in the
                    same request. You cannot specify this option if you've specified a minimum
                    number of instances to launch.

                    - *(dict) --*

                      Describes an IPv6 address.

                      - **Ipv6Address** *(string) --*

                        The IPv6 address.

                  - **NetworkInterfaceId** *(string) --*

                    The ID of the network interface.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 address of the network interface. Applies only if creating a
                    network interface when launching an instance. You cannot specify this option if
                    you're launching more than one instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                  - **PrivateIpAddresses** *(list) --*

                    One or more private IPv4 addresses to assign to the network interface. Only one
                    private IPv4 address can be designated as primary. You cannot specify this
                    option if you're launching more than one instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                    - *(dict) --*

                      Describes a secondary private IPv4 address for a network interface.

                      - **Primary** *(boolean) --*

                        Indicates whether the private IPv4 address is the primary private IPv4
                        address. Only one IPv4 address can be designated as primary.

                      - **PrivateIpAddress** *(string) --*

                        The private IPv4 addresses.

                  - **SecondaryPrivateIpAddressCount** *(integer) --*

                    The number of secondary private IPv4 addresses. You can't specify this option
                    and specify more than one private IP address using the private IP addresses
                    option. You cannot specify this option if you're launching more than one
                    instance in a `RunInstances
                    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                    request.

                  - **SubnetId** *(string) --*

                    The ID of the subnet associated with the network interface. Applies only if
                    creating a network interface when launching an instance.

                  - **InterfaceType** *(string) --*

                    The type of network interface. To create an Elastic Fabric Adapter (EFA),
                    specify ``efa`` . For more information, see `Elastic Fabric Adapter
                    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the
                    *Amazon Elastic Compute Cloud User Guide* .

                    If you are not creating an EFA, specify ``interface`` or omit this parameter.

                    Valid values: ``interface`` | ``efa``

              - **Placement** *(dict) --*

                The placement information.

                - **AvailabilityZone** *(string) --*

                  The Availability Zone.

                  [Spot Fleet only] To specify multiple Availability Zones, separate them using
                  commas; for example, "us-west-2a, us-west-2b".

                - **GroupName** *(string) --*

                  The name of the placement group.

                - **Tenancy** *(string) --*

                  The tenancy of the instance (if the instance is running in a VPC). An instance
                  with a tenancy of ``dedicated`` runs on single-tenant hardware. The ``host``
                  tenancy is not supported for Spot Instances.

              - **RamdiskId** *(string) --*

                The ID of the RAM disk. Some kernels require additional drivers at launch. Check
                the kernel requirements for information about whether you need to specify a RAM
                disk. To find kernel requirements, refer to the AWS Resource Center and search for
                the kernel ID.

              - **SpotPrice** *(string) --*

                The maximum price per unit hour that you are willing to pay for a Spot Instance. If
                this value is not specified, the default is the Spot price specified for the fleet.
                To determine the Spot price per unit hour, divide the Spot price by the value of
                ``WeightedCapacity`` .

              - **SubnetId** *(string) --*

                The IDs of the subnets in which to launch the instances. To specify multiple
                subnets, separate them using commas; for example, "subnet-1234abcdeexample1,
                subnet-0987cdef6example2".

              - **UserData** *(string) --*

                The Base64-encoded user data that instances use when starting up.

              - **WeightedCapacity** *(float) --*

                The number of units provided by the specified instance type. These are the same
                units that you chose to set the target capacity in terms of instances, or a
                performance characteristic such as vCPUs, memory, or I/O.

                If the target capacity divided by this value is not a whole number, Amazon EC2
                rounds the number of instances to the next whole number. If this value is not
                specified, the default is 1.

              - **TagSpecifications** *(list) --*

                The tags to apply during creation.

                - *(dict) --*

                  The tags for a Spot Fleet resource.

                  - **ResourceType** *(string) --*

                    The type of resource. Currently, the only resource type that is supported is
                    ``instance`` .

                  - **Tags** *(list) --*

                    The tags.

                    - *(dict) --*

                      Describes a tag.

                      - **Key** *(string) --*

                        The key of the tag.

                        Constraints: Tag keys are case-sensitive and accept a maximum of 127
                        Unicode characters. May not begin with ``aws:`` .

                      - **Value** *(string) --*

                        The value of the tag.

                        Constraints: Tag values are case-sensitive and accept a maximum of 255
                        Unicode characters.

          - **LaunchTemplateConfigs** *(list) --*

            The launch template and overrides. If you specify ``LaunchTemplateConfigs`` , you can't
            specify ``LaunchSpecifications`` . If you include On-Demand capacity in your request,
            you must use ``LaunchTemplateConfigs`` .

            - *(dict) --*

              Describes a launch template and overrides.

              - **LaunchTemplateSpecification** *(dict) --*

                The launch template.

                - **LaunchTemplateId** *(string) --*

                  The ID of the launch template. You must specify either a template ID or a
                  template name.

                - **LaunchTemplateName** *(string) --*

                  The name of the launch template. You must specify either a template name or a
                  template ID.

                - **Version** *(string) --*

                  The version number of the launch template. You must specify a version number.

              - **Overrides** *(list) --*

                Any parameters that you specify override the same parameters in the launch template.

                - *(dict) --*

                  Describes overrides for a launch template.

                  - **InstanceType** *(string) --*

                    The instance type.

                  - **SpotPrice** *(string) --*

                    The maximum price per unit hour that you are willing to pay for a Spot Instance.

                  - **SubnetId** *(string) --*

                    The ID of the subnet in which to launch the instances.

                  - **AvailabilityZone** *(string) --*

                    The Availability Zone in which to launch the instances.

                  - **WeightedCapacity** *(float) --*

                    The number of units provided by the specified instance type.

                  - **Priority** *(float) --*

                    The priority for the launch template override. If
                    **OnDemandAllocationStrategy** is set to ``prioritized`` , Spot Fleet uses
                    priority to determine which launch template override to use first in fulfilling
                    On-Demand capacity. The highest priority is launched first. Valid values are
                    whole numbers starting at ``0`` . The lower the number, the higher the
                    priority. If no number is set, the launch template override has the lowest
                    priority.

          - **SpotPrice** *(string) --*

            The maximum price per unit hour that you are willing to pay for a Spot Instance. The
            default is the On-Demand price.

          - **TargetCapacity** *(integer) --*

            The number of units to request for the Spot Fleet. You can choose to set the target
            capacity in terms of instances or a performance characteristic that is important to
            your application workload, such as vCPUs, memory, or I/O. If the request type is
            ``maintain`` , you can specify a target capacity of 0 and add capacity later.

          - **OnDemandTargetCapacity** *(integer) --*

            The number of On-Demand units to request. You can choose to set the target capacity in
            terms of instances or a performance characteristic that is important to your
            application workload, such as vCPUs, memory, or I/O. If the request type is
            ``maintain`` , you can specify a target capacity of 0 and add capacity later.

          - **OnDemandMaxTotalPrice** *(string) --*

            The maximum amount per hour for On-Demand Instances that you're willing to pay. You can
            use the ``onDemandMaxTotalPrice`` parameter, the ``spotMaxTotalPrice`` parameter, or
            both parameters to ensure that your fleet cost does not exceed your budget. If you set
            a maximum price per hour for the On-Demand Instances and Spot Instances in your
            request, Spot Fleet will launch instances until it reaches the maximum amount you're
            willing to pay. When the maximum amount you're willing to pay is reached, the fleet
            stops launching instances even if it hasn’t met the target capacity.

          - **SpotMaxTotalPrice** *(string) --*

            The maximum amount per hour for Spot Instances that you're willing to pay. You can use
            the ``spotdMaxTotalPrice`` parameter, the ``onDemandMaxTotalPrice`` parameter, or both
            parameters to ensure that your fleet cost does not exceed your budget. If you set a
            maximum price per hour for the On-Demand Instances and Spot Instances in your request,
            Spot Fleet will launch instances until it reaches the maximum amount you're willing to
            pay. When the maximum amount you're willing to pay is reached, the fleet stops
            launching instances even if it hasn’t met the target capacity.

          - **TerminateInstancesWithExpiration** *(boolean) --*

            Indicates whether running Spot Instances are terminated when the Spot Fleet request
            expires.

          - **Type** *(string) --*

            The type of request. Indicates whether the Spot Fleet only requests the target capacity
            or also attempts to maintain it. When this value is ``request`` , the Spot Fleet only
            places the required requests. It does not attempt to replenish Spot Instances if
            capacity is diminished, nor does it submit requests in alternative Spot pools if
            capacity is not available. When this value is ``maintain`` , the Spot Fleet maintains
            the target capacity. The Spot Fleet places the required requests to meet capacity and
            automatically replenishes any interrupted instances. Default: ``maintain`` .
            ``instant`` is listed but is not used by Spot Fleet.

          - **ValidFrom** *(datetime) --*

            The start date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
            :*SS* Z). By default, Amazon EC2 starts fulfilling the request immediately.

          - **ValidUntil** *(datetime) --*

            The end date and time of the request, in UTC format (*YYYY* -*MM* -*DD* T*HH* :*MM*
            :*SS* Z). After the end date and time, no new Spot Instance requests are placed or able
            to fulfill the request. If no value is specified, the Spot Fleet request remains until
            you cancel it.

          - **ReplaceUnhealthyInstances** *(boolean) --*

            Indicates whether Spot Fleet should replace unhealthy instances.

          - **InstanceInterruptionBehavior** *(string) --*

            The behavior when a Spot Instance is interrupted. The default is ``terminate`` .

          - **LoadBalancersConfig** *(dict) --*

            One or more Classic Load Balancers and target groups to attach to the Spot Fleet
            request. Spot Fleet registers the running Spot Instances with the specified Classic
            Load Balancers and target groups.

            With Network Load Balancers, Spot Fleet cannot register instances that have the
            following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1, HS1, M1, M2,
            M3, and T1.

            - **ClassicLoadBalancersConfig** *(dict) --*

              The Classic Load Balancers.

              - **ClassicLoadBalancers** *(list) --*

                One or more Classic Load Balancers.

                - *(dict) --*

                  Describes a Classic Load Balancer.

                  - **Name** *(string) --*

                    The name of the load balancer.

            - **TargetGroupsConfig** *(dict) --*

              The target groups.

              - **TargetGroups** *(list) --*

                One or more target groups.

                - *(dict) --*

                  Describes a load balancer target group.

                  - **Arn** *(string) --*

                    The Amazon Resource Name (ARN) of the target group.

          - **InstancePoolsToUseCount** *(integer) --*

            The number of Spot pools across which to allocate your target Spot capacity. Valid only
            when Spot **AllocationStrategy** is set to ``lowest-price`` . Spot Fleet selects the
            cheapest Spot pools and evenly allocates your target Spot capacity across the number of
            Spot pools that you specify.

        - **SpotFleetRequestId** *(string) --*

          The ID of the Spot Fleet request.

        - **SpotFleetRequestState** *(string) --*

          The state of the Spot Fleet request.
    """


_DescribeSpotInstanceRequestsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateFiltersTypeDef(
    _DescribeSpotInstanceRequestsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef(
    _DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequests` `Fault`

    The fault codes for the Spot Instance request, if any.

    - **Code** *(string) --*

      The reason code for the Spot Instance state change.

    - **Message** *(string) --*

      The message for the Spot Instance state change.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For
      ``io1`` volumes, this represents the number of IOPS that are provisioned for the
      volume. For ``gp2`` volumes, this represents the baseline performance of the
      volume and the rate at which the volume accumulates I/O credits for bursting. For
      more information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
      for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
      only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
      the *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it
      is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
      volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume
      size, the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
      IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
      for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
      specify a snapshot, the volume size must be equal to or larger than the snapshot
      size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS
      that the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being
      restored from a backing snapshot. The effect of setting the encryption state to
      ``true`` depends on the volume origin (new or from a snapshot), starting
      encryption state, ownership, and whether encryption by default is enabled. For
      more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS
      encryption. For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
      under which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      , `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
      , and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered
      starting from 0. An instance type with 2 available instance store volumes can
      specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
      instance store volumes depends on the instance type. After you connect to the
      instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device
      name. Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any
      instance store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For
        ``io1`` volumes, this represents the number of IOPS that are provisioned for the
        volume. For ``gp2`` volumes, this represents the baseline performance of the
        volume and the rate at which the volume accumulates I/O credits for bursting. For
        more information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
        for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
        only on `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
        the *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it
        is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
        volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume
        size, the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
        IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
        for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
        specify a snapshot, the volume size must be equal to or larger than the snapshot
        size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS
        that the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being
        restored from a backing snapshot. The effect of setting the encryption state to
        ``true`` depends on the volume origin (new or from a snapshot), starting
        encryption state, ownership, and whether encryption by default is enabled. For
        more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS
        encryption. For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
        under which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
        , `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
        , and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `Monitoring`

    Describes the monitoring of an instance.

    - **Enabled** *(boolean) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address.
      Only one IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a
      VPC. The public IP address can only be assigned to a network interface for eth0,
      and can only be assigned to a new network interface, not an existing one. You
      cannot specify more than one network interface in the request. If launching into a
      default subnet, the default value is ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You
      can specify ``true`` only if creating a new network interface when launching an
      instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network
      interface when launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network
      interface has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the
      device index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating
      a network interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
      the IPv6 addresses from the range of the subnet. You cannot specify this option and
      the option to assign specific IPv6 addresses in the same request. You can specify
      this option if you've specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify
      this option and the option to assign a number of IPv6 addresses in the same
      request. You cannot specify this option if you've specified a minimum number of
      instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a
      network interface when launching an instance. You cannot specify this option if
      you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one
      private IPv4 address can be designated as primary. You cannot specify this option
      if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address.
          Only one IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and
      specify more than one private IP address using the private IP addresses option. You
      cannot specify this option if you're launching more than one instance in a
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
      request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if
      creating a network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
      ``efa`` . For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `Placement`

    The placement information for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

      [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
      for example, "us-west-2a, us-west-2b".

    - **GroupName** *(string) --*

      The name of the placement group.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a
      tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
      supported for Spot Instances.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecification` `SecurityGroups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequests` `LaunchSpecification`

    Additional information for launching instances.

    - **UserData** *(string) --*

      The Base64-encoded user data for the instance.

    - **SecurityGroups** *(list) --*

      One or more security groups. When requesting instances in a VPC, you must specify the
      IDs of the security groups. When requesting instances in EC2-Classic, you can specify
      the names or the IDs of the security groups.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **AddressingType** *(string) --*

      Deprecated.

    - **BlockDeviceMappings** *(list) --*

      One or more block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered
          starting from 0. An instance type with 2 available instance store volumes can
          specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
          instance store volumes depends on the instance type. After you connect to the
          instance, you must mount the volume.

          NVMe instance store volumes are automatically enumerated and assigned a device
          name. Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any
          instance store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For
            ``io1`` volumes, this represents the number of IOPS that are provisioned for the
            volume. For ``gp2`` volumes, this represents the baseline performance of the
            volume and the rate at which the volume accumulates I/O credits for bursting. For
            more information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
            for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
            only on `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
            the *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it
            is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
            volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume
            size, the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
            IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
            for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
            specify a snapshot, the volume size must be equal to or larger than the snapshot
            size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS
            that the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being
            restored from a backing snapshot. The effect of setting the encryption state to
            ``true`` depends on the volume origin (new or from a snapshot), starting
            encryption state, ownership, and whether encryption by default is enabled. For
            more information, see `Amazon EBS Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS
            encryption. For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
            under which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            , `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
            , and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **EbsOptimized** *(boolean) --*

      Indicates whether the instance is optimized for EBS I/O. This optimization provides
      dedicated throughput to Amazon EBS and an optimized configuration stack to provide
      optimal EBS I/O performance. This optimization isn't available with all instance types.
      Additional usage charges apply when using an EBS Optimized instance.

      Default: ``false``

    - **IamInstanceProfile** *(dict) --*

      The IAM instance profile.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the instance profile.

      - **Name** *(string) --*

        The name of the instance profile.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **InstanceType** *(string) --*

      The instance type.

    - **KernelId** *(string) --*

      The ID of the kernel.

    - **KeyName** *(string) --*

      The name of the key pair.

    - **NetworkInterfaces** *(list) --*

      One or more network interfaces. If you specify a network interface, you must specify
      subnet IDs and security group IDs using the network interface.

      - *(dict) --*

        Describes a network interface.

        - **AssociatePublicIpAddress** *(boolean) --*

          Indicates whether to assign a public IPv4 address to an instance you launch in a
          VPC. The public IP address can only be assigned to a network interface for eth0,
          and can only be assigned to a new network interface, not an existing one. You
          cannot specify more than one network interface in the request. If launching into a
          default subnet, the default value is ``true`` .

        - **DeleteOnTermination** *(boolean) --*

          If set to ``true`` , the interface is deleted when the instance is terminated. You
          can specify ``true`` only if creating a new network interface when launching an
          instance.

        - **Description** *(string) --*

          The description of the network interface. Applies only if creating a network
          interface when launching an instance.

        - **DeviceIndex** *(integer) --*

          The position of the network interface in the attachment order. A primary network
          interface has a device index of 0.

          If you specify a network interface when launching an instance, you must specify the
          device index.

        - **Groups** *(list) --*

          The IDs of the security groups for the network interface. Applies only if creating
          a network interface when launching an instance.

          - *(string) --*

        - **Ipv6AddressCount** *(integer) --*

          A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
          the IPv6 addresses from the range of the subnet. You cannot specify this option and
          the option to assign specific IPv6 addresses in the same request. You can specify
          this option if you've specified a minimum number of instances to launch.

        - **Ipv6Addresses** *(list) --*

          One or more IPv6 addresses to assign to the network interface. You cannot specify
          this option and the option to assign a number of IPv6 addresses in the same
          request. You cannot specify this option if you've specified a minimum number of
          instances to launch.

          - *(dict) --*

            Describes an IPv6 address.

            - **Ipv6Address** *(string) --*

              The IPv6 address.

        - **NetworkInterfaceId** *(string) --*

          The ID of the network interface.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 address of the network interface. Applies only if creating a
          network interface when launching an instance. You cannot specify this option if
          you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **PrivateIpAddresses** *(list) --*

          One or more private IPv4 addresses to assign to the network interface. Only one
          private IPv4 address can be designated as primary. You cannot specify this option
          if you're launching more than one instance in a `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

          - *(dict) --*

            Describes a secondary private IPv4 address for a network interface.

            - **Primary** *(boolean) --*

              Indicates whether the private IPv4 address is the primary private IPv4 address.
              Only one IPv4 address can be designated as primary.

            - **PrivateIpAddress** *(string) --*

              The private IPv4 addresses.

        - **SecondaryPrivateIpAddressCount** *(integer) --*

          The number of secondary private IPv4 addresses. You can't specify this option and
          specify more than one private IP address using the private IP addresses option. You
          cannot specify this option if you're launching more than one instance in a
          `RunInstances
          <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
          request.

        - **SubnetId** *(string) --*

          The ID of the subnet associated with the network interface. Applies only if
          creating a network interface when launching an instance.

        - **InterfaceType** *(string) --*

          The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
          ``efa`` . For more information, see `Elastic Fabric Adapter
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
          Elastic Compute Cloud User Guide* .

          If you are not creating an EFA, specify ``interface`` or omit this parameter.

          Valid values: ``interface`` | ``efa``

    - **Placement** *(dict) --*

      The placement information for the instance.

      - **AvailabilityZone** *(string) --*

        The Availability Zone.

        [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
        for example, "us-west-2a, us-west-2b".

      - **GroupName** *(string) --*

        The name of the placement group.

      - **Tenancy** *(string) --*

        The tenancy of the instance (if the instance is running in a VPC). An instance with a
        tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
        supported for Spot Instances.

    - **RamdiskId** *(string) --*

      The ID of the RAM disk.

    - **SubnetId** *(string) --*

      The ID of the subnet in which to launch the instance.

    - **Monitoring** *(dict) --*

      Describes the monitoring of an instance.

      - **Enabled** *(boolean) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequests` `Status`

    The status code and status message describing the Spot Instance request.

    - **Code** *(string) --*

      The status code. For a list of status codes, see `Spot Status Codes
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
      in the *Amazon EC2 User Guide for Linux Instances* .

    - **Message** *(string) --*

      The description for the status code.

    - **UpdateTime** *(datetime) --*

      The date and time of the most recent status update, in UTC format (for example, *YYYY*
      -*MM* -*DD* T*HH* :*MM* :*SS* Z).
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequests` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": str,
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": str,
        "Status": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef
        ],
        "Type": str,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginateResponse` `SpotInstanceRequests`

    Describes a Spot Instance request.

    - **ActualBlockHourlyPrice** *(string) --*

      If you specified a duration and your Spot Instance request was fulfilled, this is the
      fixed hourly price in effect for the Spot Instance while it runs.

    - **AvailabilityZoneGroup** *(string) --*

      The Availability Zone group. If you specify the same Availability Zone group for all Spot
      Instance requests, all Spot Instances are launched in the same Availability Zone.

    - **BlockDurationMinutes** *(integer) --*

      The duration for the Spot Instance, in minutes.

    - **CreateTime** *(datetime) --*

      The date and time when the Spot Instance request was created, in UTC format (for example,
      *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Fault** *(dict) --*

      The fault codes for the Spot Instance request, if any.

      - **Code** *(string) --*

        The reason code for the Spot Instance state change.

      - **Message** *(string) --*

        The message for the Spot Instance state change.

    - **InstanceId** *(string) --*

      The instance ID, if an instance has been launched to fulfill the Spot Instance request.

    - **LaunchGroup** *(string) --*

      The instance launch group. Launch groups are Spot Instances that launch together and
      terminate together.

    - **LaunchSpecification** *(dict) --*

      Additional information for launching instances.

      - **UserData** *(string) --*

        The Base64-encoded user data for the instance.

      - **SecurityGroups** *(list) --*

        One or more security groups. When requesting instances in a VPC, you must specify the
        IDs of the security groups. When requesting instances in EC2-Classic, you can specify
        the names or the IDs of the security groups.

        - *(dict) --*

          Describes a security group.

          - **GroupName** *(string) --*

            The name of the security group.

          - **GroupId** *(string) --*

            The ID of the security group.

      - **AddressingType** *(string) --*

        Deprecated.

      - **BlockDeviceMappings** *(list) --*

        One or more block device mapping entries.

        - *(dict) --*

          Describes a block device mapping.

          - **DeviceName** *(string) --*

            The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

          - **VirtualName** *(string) --*

            The virtual device name (``ephemeral`` N). Instance store volumes are numbered
            starting from 0. An instance type with 2 available instance store volumes can
            specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
            instance store volumes depends on the instance type. After you connect to the
            instance, you must mount the volume.

            NVMe instance store volumes are automatically enumerated and assigned a device
            name. Including them in your block device mapping has no effect.

            Constraints: For M3 instances, you must specify instance store volumes in the block
            device mapping for the instance. When you launch an M3 instance, we ignore any
            instance store volumes specified in the block device mapping for the AMI.

          - **Ebs** *(dict) --*

            Parameters used to automatically set up EBS volumes when the instance is launched.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination. For more
              information, see `Preserving Amazon EBS Volumes on Instance Termination
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
              in the Amazon Elastic Compute Cloud User Guide.

            - **Iops** *(integer) --*

              The number of I/O operations per second (IOPS) that the volume supports. For
              ``io1`` volumes, this represents the number of IOPS that are provisioned for the
              volume. For ``gp2`` volumes, this represents the baseline performance of the
              volume and the rate at which the volume accumulates I/O credits for bursting. For
              more information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
              for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
              only on `Nitro-based instances
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
              . Other instance families guarantee performance up to 32,000 IOPS. For more
              information, see `Amazon EBS Volume Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
              the *Amazon Elastic Compute Cloud User Guide* .

              Condition: This parameter is required for requests to create ``io1`` volumes; it
              is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
              volumes.

            - **SnapshotId** *(string) --*

              The ID of the snapshot.

            - **VolumeSize** *(integer) --*

              The size of the volume, in GiB.

              Default: If you're creating the volume from a snapshot and don't specify a volume
              size, the default is the snapshot size.

              Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
              IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
              for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
              specify a snapshot, the volume size must be equal to or larger than the snapshot
              size.

            - **VolumeType** *(string) --*

              The volume type. If you set the type to ``io1`` , you must also specify the IOPS
              that the volume supports.

              Default: ``gp2``

            - **Encrypted** *(boolean) --*

              Indicates whether the encryption state of an EBS volume is changed while being
              restored from a backing snapshot. The effect of setting the encryption state to
              ``true`` depends on the volume origin (new or from a snapshot), starting
              encryption state, ownership, and whether encryption by default is enabled. For
              more information, see `Amazon EBS Encryption
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
              in the *Amazon Elastic Compute Cloud User Guide* .

              In no case can you remove encryption from an encrypted volume.

              Encrypted volumes can only be attached to instances that support Amazon EBS
              encryption. For more information, see `Supported Instance Types
              <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
              .

            - **KmsKeyId** *(string) --*

              Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
              under which the EBS volume is encrypted.

              This parameter is only supported on ``BlockDeviceMapping`` objects called by
              `RunInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
              , `RequestSpotFleet
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
              , and `RequestSpotInstances
              <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
              .

          - **NoDevice** *(string) --*

            Suppresses the specified device included in the block device mapping of the AMI.

      - **EbsOptimized** *(boolean) --*

        Indicates whether the instance is optimized for EBS I/O. This optimization provides
        dedicated throughput to Amazon EBS and an optimized configuration stack to provide
        optimal EBS I/O performance. This optimization isn't available with all instance types.
        Additional usage charges apply when using an EBS Optimized instance.

        Default: ``false``

      - **IamInstanceProfile** *(dict) --*

        The IAM instance profile.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the instance profile.

        - **Name** *(string) --*

          The name of the instance profile.

      - **ImageId** *(string) --*

        The ID of the AMI.

      - **InstanceType** *(string) --*

        The instance type.

      - **KernelId** *(string) --*

        The ID of the kernel.

      - **KeyName** *(string) --*

        The name of the key pair.

      - **NetworkInterfaces** *(list) --*

        One or more network interfaces. If you specify a network interface, you must specify
        subnet IDs and security group IDs using the network interface.

        - *(dict) --*

          Describes a network interface.

          - **AssociatePublicIpAddress** *(boolean) --*

            Indicates whether to assign a public IPv4 address to an instance you launch in a
            VPC. The public IP address can only be assigned to a network interface for eth0,
            and can only be assigned to a new network interface, not an existing one. You
            cannot specify more than one network interface in the request. If launching into a
            default subnet, the default value is ``true`` .

          - **DeleteOnTermination** *(boolean) --*

            If set to ``true`` , the interface is deleted when the instance is terminated. You
            can specify ``true`` only if creating a new network interface when launching an
            instance.

          - **Description** *(string) --*

            The description of the network interface. Applies only if creating a network
            interface when launching an instance.

          - **DeviceIndex** *(integer) --*

            The position of the network interface in the attachment order. A primary network
            interface has a device index of 0.

            If you specify a network interface when launching an instance, you must specify the
            device index.

          - **Groups** *(list) --*

            The IDs of the security groups for the network interface. Applies only if creating
            a network interface when launching an instance.

            - *(string) --*

          - **Ipv6AddressCount** *(integer) --*

            A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
            the IPv6 addresses from the range of the subnet. You cannot specify this option and
            the option to assign specific IPv6 addresses in the same request. You can specify
            this option if you've specified a minimum number of instances to launch.

          - **Ipv6Addresses** *(list) --*

            One or more IPv6 addresses to assign to the network interface. You cannot specify
            this option and the option to assign a number of IPv6 addresses in the same
            request. You cannot specify this option if you've specified a minimum number of
            instances to launch.

            - *(dict) --*

              Describes an IPv6 address.

              - **Ipv6Address** *(string) --*

                The IPv6 address.

          - **NetworkInterfaceId** *(string) --*

            The ID of the network interface.

          - **PrivateIpAddress** *(string) --*

            The private IPv4 address of the network interface. Applies only if creating a
            network interface when launching an instance. You cannot specify this option if
            you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **PrivateIpAddresses** *(list) --*

            One or more private IPv4 addresses to assign to the network interface. Only one
            private IPv4 address can be designated as primary. You cannot specify this option
            if you're launching more than one instance in a `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

            - *(dict) --*

              Describes a secondary private IPv4 address for a network interface.

              - **Primary** *(boolean) --*

                Indicates whether the private IPv4 address is the primary private IPv4 address.
                Only one IPv4 address can be designated as primary.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 addresses.

          - **SecondaryPrivateIpAddressCount** *(integer) --*

            The number of secondary private IPv4 addresses. You can't specify this option and
            specify more than one private IP address using the private IP addresses option. You
            cannot specify this option if you're launching more than one instance in a
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
            request.

          - **SubnetId** *(string) --*

            The ID of the subnet associated with the network interface. Applies only if
            creating a network interface when launching an instance.

          - **InterfaceType** *(string) --*

            The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
            ``efa`` . For more information, see `Elastic Fabric Adapter
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
            Elastic Compute Cloud User Guide* .

            If you are not creating an EFA, specify ``interface`` or omit this parameter.

            Valid values: ``interface`` | ``efa``

      - **Placement** *(dict) --*

        The placement information for the instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

          [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
          for example, "us-west-2a, us-west-2b".

        - **GroupName** *(string) --*

          The name of the placement group.

        - **Tenancy** *(string) --*

          The tenancy of the instance (if the instance is running in a VPC). An instance with a
          tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
          supported for Spot Instances.

      - **RamdiskId** *(string) --*

        The ID of the RAM disk.

      - **SubnetId** *(string) --*

        The ID of the subnet in which to launch the instance.

      - **Monitoring** *(dict) --*

        Describes the monitoring of an instance.

        - **Enabled** *(boolean) --*

          Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
          enabled.

    - **LaunchedAvailabilityZone** *(string) --*

      The Availability Zone in which the request is launched.

    - **ProductDescription** *(string) --*

      The product description associated with the Spot Instance.

    - **SpotInstanceRequestId** *(string) --*

      The ID of the Spot Instance request.

    - **SpotPrice** *(string) --*

      The maximum price per hour that you are willing to pay for a Spot Instance.

    - **State** *(string) --*

      The state of the Spot Instance request. Spot status information helps track your Spot
      Instance requests. For more information, see `Spot Status
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
      *Amazon EC2 User Guide for Linux Instances* .

    - **Status** *(dict) --*

      The status code and status message describing the Spot Instance request.

      - **Code** *(string) --*

        The status code. For a list of status codes, see `Spot Status Codes
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
        in the *Amazon EC2 User Guide for Linux Instances* .

      - **Message** *(string) --*

        The description for the status code.

      - **UpdateTime** *(datetime) --*

        The date and time of the most recent status update, in UTC format (for example, *YYYY*
        -*MM* -*DD* T*HH* :*MM* :*SS* Z).

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **Type** *(string) --*

      The Spot Instance request type.

    - **ValidFrom** *(datetime) --*

      The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). The request becomes active at this date and time.

    - **ValidUntil** *(datetime) --*

      The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
      :*SS* Z). If this is a one-time request, it remains active until all instances launch,
      the request is canceled, or this date is reached. If the request is persistent, it
      remains active until it is canceled or this date is reached. The default end date is 7
      days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted.
    """


_DescribeSpotInstanceRequestsPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseTypeDef",
    {
        "SpotInstanceRequests": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSpotInstanceRequestsPaginate` `Response`

    Contains the output of DescribeSpotInstanceRequests.

    - **SpotInstanceRequests** *(list) --*

      One or more Spot Instance requests.

      - *(dict) --*

        Describes a Spot Instance request.

        - **ActualBlockHourlyPrice** *(string) --*

          If you specified a duration and your Spot Instance request was fulfilled, this is the
          fixed hourly price in effect for the Spot Instance while it runs.

        - **AvailabilityZoneGroup** *(string) --*

          The Availability Zone group. If you specify the same Availability Zone group for all Spot
          Instance requests, all Spot Instances are launched in the same Availability Zone.

        - **BlockDurationMinutes** *(integer) --*

          The duration for the Spot Instance, in minutes.

        - **CreateTime** *(datetime) --*

          The date and time when the Spot Instance request was created, in UTC format (for example,
          *YYYY* -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Fault** *(dict) --*

          The fault codes for the Spot Instance request, if any.

          - **Code** *(string) --*

            The reason code for the Spot Instance state change.

          - **Message** *(string) --*

            The message for the Spot Instance state change.

        - **InstanceId** *(string) --*

          The instance ID, if an instance has been launched to fulfill the Spot Instance request.

        - **LaunchGroup** *(string) --*

          The instance launch group. Launch groups are Spot Instances that launch together and
          terminate together.

        - **LaunchSpecification** *(dict) --*

          Additional information for launching instances.

          - **UserData** *(string) --*

            The Base64-encoded user data for the instance.

          - **SecurityGroups** *(list) --*

            One or more security groups. When requesting instances in a VPC, you must specify the
            IDs of the security groups. When requesting instances in EC2-Classic, you can specify
            the names or the IDs of the security groups.

            - *(dict) --*

              Describes a security group.

              - **GroupName** *(string) --*

                The name of the security group.

              - **GroupId** *(string) --*

                The ID of the security group.

          - **AddressingType** *(string) --*

            Deprecated.

          - **BlockDeviceMappings** *(list) --*

            One or more block device mapping entries.

            - *(dict) --*

              Describes a block device mapping.

              - **DeviceName** *(string) --*

                The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

              - **VirtualName** *(string) --*

                The virtual device name (``ephemeral`` N). Instance store volumes are numbered
                starting from 0. An instance type with 2 available instance store volumes can
                specify mappings for ``ephemeral0`` and ``ephemeral1`` . The number of available
                instance store volumes depends on the instance type. After you connect to the
                instance, you must mount the volume.

                NVMe instance store volumes are automatically enumerated and assigned a device
                name. Including them in your block device mapping has no effect.

                Constraints: For M3 instances, you must specify instance store volumes in the block
                device mapping for the instance. When you launch an M3 instance, we ignore any
                instance store volumes specified in the block device mapping for the AMI.

              - **Ebs** *(dict) --*

                Parameters used to automatically set up EBS volumes when the instance is launched.

                - **DeleteOnTermination** *(boolean) --*

                  Indicates whether the EBS volume is deleted on instance termination. For more
                  information, see `Preserving Amazon EBS Volumes on Instance Termination
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
                  in the Amazon Elastic Compute Cloud User Guide.

                - **Iops** *(integer) --*

                  The number of I/O operations per second (IOPS) that the volume supports. For
                  ``io1`` volumes, this represents the number of IOPS that are provisioned for the
                  volume. For ``gp2`` volumes, this represents the baseline performance of the
                  volume and the rate at which the volume accumulates I/O credits for bursting. For
                  more information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS
                  for ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed
                  only on `Nitro-based instances
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
                  . Other instance families guarantee performance up to 32,000 IOPS. For more
                  information, see `Amazon EBS Volume Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in
                  the *Amazon Elastic Compute Cloud User Guide* .

                  Condition: This parameter is required for requests to create ``io1`` volumes; it
                  is not used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard``
                  volumes.

                - **SnapshotId** *(string) --*

                  The ID of the snapshot.

                - **VolumeSize** *(integer) --*

                  The size of the volume, in GiB.

                  Default: If you're creating the volume from a snapshot and don't specify a volume
                  size, the default is the snapshot size.

                  Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned
                  IOPS SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384
                  for Cold HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you
                  specify a snapshot, the volume size must be equal to or larger than the snapshot
                  size.

                - **VolumeType** *(string) --*

                  The volume type. If you set the type to ``io1`` , you must also specify the IOPS
                  that the volume supports.

                  Default: ``gp2``

                - **Encrypted** *(boolean) --*

                  Indicates whether the encryption state of an EBS volume is changed while being
                  restored from a backing snapshot. The effect of setting the encryption state to
                  ``true`` depends on the volume origin (new or from a snapshot), starting
                  encryption state, ownership, and whether encryption by default is enabled. For
                  more information, see `Amazon EBS Encryption
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
                  in the *Amazon Elastic Compute Cloud User Guide* .

                  In no case can you remove encryption from an encrypted volume.

                  Encrypted volumes can only be attached to instances that support Amazon EBS
                  encryption. For more information, see `Supported Instance Types
                  <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
                  .

                - **KmsKeyId** *(string) --*

                  Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK
                  under which the EBS volume is encrypted.

                  This parameter is only supported on ``BlockDeviceMapping`` objects called by
                  `RunInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                  , `RequestSpotFleet
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__
                  , and `RequestSpotInstances
                  <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
                  .

              - **NoDevice** *(string) --*

                Suppresses the specified device included in the block device mapping of the AMI.

          - **EbsOptimized** *(boolean) --*

            Indicates whether the instance is optimized for EBS I/O. This optimization provides
            dedicated throughput to Amazon EBS and an optimized configuration stack to provide
            optimal EBS I/O performance. This optimization isn't available with all instance types.
            Additional usage charges apply when using an EBS Optimized instance.

            Default: ``false``

          - **IamInstanceProfile** *(dict) --*

            The IAM instance profile.

            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the instance profile.

            - **Name** *(string) --*

              The name of the instance profile.

          - **ImageId** *(string) --*

            The ID of the AMI.

          - **InstanceType** *(string) --*

            The instance type.

          - **KernelId** *(string) --*

            The ID of the kernel.

          - **KeyName** *(string) --*

            The name of the key pair.

          - **NetworkInterfaces** *(list) --*

            One or more network interfaces. If you specify a network interface, you must specify
            subnet IDs and security group IDs using the network interface.

            - *(dict) --*

              Describes a network interface.

              - **AssociatePublicIpAddress** *(boolean) --*

                Indicates whether to assign a public IPv4 address to an instance you launch in a
                VPC. The public IP address can only be assigned to a network interface for eth0,
                and can only be assigned to a new network interface, not an existing one. You
                cannot specify more than one network interface in the request. If launching into a
                default subnet, the default value is ``true`` .

              - **DeleteOnTermination** *(boolean) --*

                If set to ``true`` , the interface is deleted when the instance is terminated. You
                can specify ``true`` only if creating a new network interface when launching an
                instance.

              - **Description** *(string) --*

                The description of the network interface. Applies only if creating a network
                interface when launching an instance.

              - **DeviceIndex** *(integer) --*

                The position of the network interface in the attachment order. A primary network
                interface has a device index of 0.

                If you specify a network interface when launching an instance, you must specify the
                device index.

              - **Groups** *(list) --*

                The IDs of the security groups for the network interface. Applies only if creating
                a network interface when launching an instance.

                - *(string) --*

              - **Ipv6AddressCount** *(integer) --*

                A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses
                the IPv6 addresses from the range of the subnet. You cannot specify this option and
                the option to assign specific IPv6 addresses in the same request. You can specify
                this option if you've specified a minimum number of instances to launch.

              - **Ipv6Addresses** *(list) --*

                One or more IPv6 addresses to assign to the network interface. You cannot specify
                this option and the option to assign a number of IPv6 addresses in the same
                request. You cannot specify this option if you've specified a minimum number of
                instances to launch.

                - *(dict) --*

                  Describes an IPv6 address.

                  - **Ipv6Address** *(string) --*

                    The IPv6 address.

              - **NetworkInterfaceId** *(string) --*

                The ID of the network interface.

              - **PrivateIpAddress** *(string) --*

                The private IPv4 address of the network interface. Applies only if creating a
                network interface when launching an instance. You cannot specify this option if
                you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **PrivateIpAddresses** *(list) --*

                One or more private IPv4 addresses to assign to the network interface. Only one
                private IPv4 address can be designated as primary. You cannot specify this option
                if you're launching more than one instance in a `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

                - *(dict) --*

                  Describes a secondary private IPv4 address for a network interface.

                  - **Primary** *(boolean) --*

                    Indicates whether the private IPv4 address is the primary private IPv4 address.
                    Only one IPv4 address can be designated as primary.

                  - **PrivateIpAddress** *(string) --*

                    The private IPv4 addresses.

              - **SecondaryPrivateIpAddressCount** *(integer) --*

                The number of secondary private IPv4 addresses. You can't specify this option and
                specify more than one private IP address using the private IP addresses option. You
                cannot specify this option if you're launching more than one instance in a
                `RunInstances
                <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__
                request.

              - **SubnetId** *(string) --*

                The ID of the subnet associated with the network interface. Applies only if
                creating a network interface when launching an instance.

              - **InterfaceType** *(string) --*

                The type of network interface. To create an Elastic Fabric Adapter (EFA), specify
                ``efa`` . For more information, see `Elastic Fabric Adapter
                <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon
                Elastic Compute Cloud User Guide* .

                If you are not creating an EFA, specify ``interface`` or omit this parameter.

                Valid values: ``interface`` | ``efa``

          - **Placement** *(dict) --*

            The placement information for the instance.

            - **AvailabilityZone** *(string) --*

              The Availability Zone.

              [Spot Fleet only] To specify multiple Availability Zones, separate them using commas;
              for example, "us-west-2a, us-west-2b".

            - **GroupName** *(string) --*

              The name of the placement group.

            - **Tenancy** *(string) --*

              The tenancy of the instance (if the instance is running in a VPC). An instance with a
              tenancy of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not
              supported for Spot Instances.

          - **RamdiskId** *(string) --*

            The ID of the RAM disk.

          - **SubnetId** *(string) --*

            The ID of the subnet in which to launch the instance.

          - **Monitoring** *(dict) --*

            Describes the monitoring of an instance.

            - **Enabled** *(boolean) --*

              Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
              enabled.

        - **LaunchedAvailabilityZone** *(string) --*

          The Availability Zone in which the request is launched.

        - **ProductDescription** *(string) --*

          The product description associated with the Spot Instance.

        - **SpotInstanceRequestId** *(string) --*

          The ID of the Spot Instance request.

        - **SpotPrice** *(string) --*

          The maximum price per hour that you are willing to pay for a Spot Instance.

        - **State** *(string) --*

          The state of the Spot Instance request. Spot status information helps track your Spot
          Instance requests. For more information, see `Spot Status
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html>`__ in the
          *Amazon EC2 User Guide for Linux Instances* .

        - **Status** *(dict) --*

          The status code and status message describing the Spot Instance request.

          - **Code** *(string) --*

            The status code. For a list of status codes, see `Spot Status Codes
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand>`__
            in the *Amazon EC2 User Guide for Linux Instances* .

          - **Message** *(string) --*

            The description for the status code.

          - **UpdateTime** *(datetime) --*

            The date and time of the most recent status update, in UTC format (for example, *YYYY*
            -*MM* -*DD* T*HH* :*MM* :*SS* Z).

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **Type** *(string) --*

          The Spot Instance request type.

        - **ValidFrom** *(datetime) --*

          The start date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). The request becomes active at this date and time.

        - **ValidUntil** *(datetime) --*

          The end date of the request, in UTC format (for example, *YYYY* -*MM* -*DD* T*HH* :*MM*
          :*SS* Z). If this is a one-time request, it remains active until all instances launch,
          the request is canceled, or this date is reached. If the request is persistent, it
          remains active until it is canceled or this date is reached. The default end date is 7
          days from the current date.

        - **InstanceInterruptionBehavior** *(string) --*

          The behavior when a Spot Instance is interrupted.
    """


_DescribeSpotPriceHistoryPaginateFiltersTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSpotPriceHistoryPaginateFiltersTypeDef(
    _DescribeSpotPriceHistoryPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeSpotPriceHistoryPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef(
    _DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSpotPriceHistoryPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceType": str,
        "ProductDescription": str,
        "SpotPrice": str,
        "Timestamp": datetime,
    },
    total=False,
)


class DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef(
    _DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef
):
    """
    Type definition for `DescribeSpotPriceHistoryPaginateResponse` `SpotPriceHistory`

    Describes the maximum price per hour that you are willing to pay for a Spot Instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone.

    - **InstanceType** *(string) --*

      The instance type.

    - **ProductDescription** *(string) --*

      A general description of the AMI.

    - **SpotPrice** *(string) --*

      The maximum price per hour that you are willing to pay for a Spot Instance.

    - **Timestamp** *(datetime) --*

      The date and time the request was created, in UTC format (for example, *YYYY* -*MM* -*DD*
      T*HH* :*MM* :*SS* Z).
    """


_DescribeSpotPriceHistoryPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateResponseTypeDef",
    {
        "SpotPriceHistory": List[
            DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef
        ]
    },
    total=False,
)


class DescribeSpotPriceHistoryPaginateResponseTypeDef(
    _DescribeSpotPriceHistoryPaginateResponseTypeDef
):
    """
    Type definition for `DescribeSpotPriceHistoryPaginate` `Response`

    Contains the output of DescribeSpotPriceHistory.

    - **SpotPriceHistory** *(list) --*

      The historical Spot prices.

      - *(dict) --*

        Describes the maximum price per hour that you are willing to pay for a Spot Instance.

        - **AvailabilityZone** *(string) --*

          The Availability Zone.

        - **InstanceType** *(string) --*

          The instance type.

        - **ProductDescription** *(string) --*

          A general description of the AMI.

        - **SpotPrice** *(string) --*

          The maximum price per hour that you are willing to pay for a Spot Instance.

        - **Timestamp** *(datetime) --*

          The date and time the request was created, in UTC format (for example, *YYYY* -*MM* -*DD*
          T*HH* :*MM* :*SS* Z).
    """


_DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef(
    _DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgress` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSet` `StaleIpPermissionsEgress`

    Describes a stale rule in a security group.

    - **FromPort** *(integer) --*

      The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **IpProtocol** *(string) --*

      The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
      Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
      .

    - **IpRanges** *(list) --*

      The IP ranges. Not applicable for stale security group rules.

      - *(string) --*

    - **PrefixListIds** *(list) --*

      The prefix list IDs for an AWS service. Not applicable for stale security group rules.

      - *(string) --*

    - **ToPort** *(integer) --*

      The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **UserIdGroupPairs** *(list) --*

      The security group pairs. Returns the ID of the referenced security group and VPC,
      and the ID and status of the VPC peering connection.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
      0-9, spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security
      group in EC2-Classic or a default VPC only. For a security group in a nondefault
      VPC, use the security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced
      security group is returned in the response. If the referenced security group is
      deleted, this value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security
      group in another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSet` `StaleIpPermissions`

    Describes a stale rule in a security group.

    - **FromPort** *(integer) --*

      The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **IpProtocol** *(string) --*

      The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
      Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
      .

    - **IpRanges** *(list) --*

      The IP ranges. Not applicable for stale security group rules.

      - *(string) --*

    - **PrefixListIds** *(list) --*

      The prefix list IDs for an AWS service. Not applicable for stale security group rules.

      - *(string) --*

    - **ToPort** *(integer) --*

      The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
      value of ``-1`` indicates all ICMP types.

    - **UserIdGroupPairs** *(list) --*

      The security group pairs. Returns the ID of the referenced security group and VPC,
      and the ID and status of the VPC peering connection.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
          0-9, spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security
          group in EC2-Classic or a default VPC only. For a security group in a nondefault
          VPC, use the security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced
          security group is returned in the response. If the referenced security group is
          deleted, this value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security
          group in another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "StaleIpPermissions": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
        ],
        "StaleIpPermissionsEgress": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginateResponse` `StaleSecurityGroupSet`

    Describes a stale security group (a security group that contains stale rules).

    - **Description** *(string) --*

      The description of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **StaleIpPermissions** *(list) --*

      Information about the stale inbound rules in the security group.

      - *(dict) --*

        Describes a stale rule in a security group.

        - **FromPort** *(integer) --*

          The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **IpProtocol** *(string) --*

          The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
          Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
          .

        - **IpRanges** *(list) --*

          The IP ranges. Not applicable for stale security group rules.

          - *(string) --*

        - **PrefixListIds** *(list) --*

          The prefix list IDs for an AWS service. Not applicable for stale security group rules.

          - *(string) --*

        - **ToPort** *(integer) --*

          The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **UserIdGroupPairs** *(list) --*

          The security group pairs. Returns the ID of the referenced security group and VPC,
          and the ID and status of the VPC peering connection.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **StaleIpPermissionsEgress** *(list) --*

      Information about the stale outbound rules in the security group.

      - *(dict) --*

        Describes a stale rule in a security group.

        - **FromPort** *(integer) --*

          The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **IpProtocol** *(string) --*

          The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
          Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
          .

        - **IpRanges** *(list) --*

          The IP ranges. Not applicable for stale security group rules.

          - *(string) --*

        - **PrefixListIds** *(list) --*

          The prefix list IDs for an AWS service. Not applicable for stale security group rules.

          - *(string) --*

        - **ToPort** *(integer) --*

          The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
          value of ``-1`` indicates all ICMP types.

        - **UserIdGroupPairs** *(list) --*

          The security group pairs. Returns the ID of the referenced security group and VPC,
          and the ID and status of the VPC peering connection.

          - *(dict) --*

            Describes a security group and AWS account ID pair.

            - **Description** *(string) --*

              A description for the security group rule that references this user ID group pair.

              Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
              0-9, spaces, and ._-:/()#,@[]+=;{}!$*

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group. In a request, use this parameter for a security
              group in EC2-Classic or a default VPC only. For a security group in a nondefault
              VPC, use the security group ID.

              For a referenced security group in another VPC, this value is not returned if the
              referenced security group is deleted.

            - **PeeringStatus** *(string) --*

              The status of a VPC peering connection, if applicable.

            - **UserId** *(string) --*

              The ID of an AWS account.

              For a referenced security group in another VPC, the account ID of the referenced
              security group is returned in the response. If the referenced security group is
              deleted, this value is not returned.

              [EC2-Classic] Required when adding or removing rules that reference a security
              group in another AWS account.

            - **VpcId** *(string) --*

              The ID of the VPC for the referenced security group, if applicable.

            - **VpcPeeringConnectionId** *(string) --*

              The ID of the VPC peering connection, if applicable.

    - **VpcId** *(string) --*

      The ID of the VPC for the security group.
    """


_DescribeStaleSecurityGroupsPaginateResponseTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseTypeDef",
    {
        "StaleSecurityGroupSet": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef
        ]
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeStaleSecurityGroupsPaginate` `Response`

    - **StaleSecurityGroupSet** *(list) --*

      Information about the stale security groups.

      - *(dict) --*

        Describes a stale security group (a security group that contains stale rules).

        - **Description** *(string) --*

          The description of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **StaleIpPermissions** *(list) --*

          Information about the stale inbound rules in the security group.

          - *(dict) --*

            Describes a stale rule in a security group.

            - **FromPort** *(integer) --*

              The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **IpProtocol** *(string) --*

              The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
              Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
              .

            - **IpRanges** *(list) --*

              The IP ranges. Not applicable for stale security group rules.

              - *(string) --*

            - **PrefixListIds** *(list) --*

              The prefix list IDs for an AWS service. Not applicable for stale security group rules.

              - *(string) --*

            - **ToPort** *(integer) --*

              The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **UserIdGroupPairs** *(list) --*

              The security group pairs. Returns the ID of the referenced security group and VPC,
              and the ID and status of the VPC peering connection.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **StaleIpPermissionsEgress** *(list) --*

          Information about the stale outbound rules in the security group.

          - *(dict) --*

            Describes a stale rule in a security group.

            - **FromPort** *(integer) --*

              The start of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **IpProtocol** *(string) --*

              The IP protocol name (for ``tcp`` , ``udp`` , and ``icmp`` ) or number (see `Protocol
              Numbers) <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__
              .

            - **IpRanges** *(list) --*

              The IP ranges. Not applicable for stale security group rules.

              - *(string) --*

            - **PrefixListIds** *(list) --*

              The prefix list IDs for an AWS service. Not applicable for stale security group rules.

              - *(string) --*

            - **ToPort** *(integer) --*

              The end of the port range for the TCP and UDP protocols, or an ICMP type number. A
              value of ``-1`` indicates all ICMP types.

            - **UserIdGroupPairs** *(list) --*

              The security group pairs. Returns the ID of the referenced security group and VPC,
              and the ID and status of the VPC peering connection.

              - *(dict) --*

                Describes a security group and AWS account ID pair.

                - **Description** *(string) --*

                  A description for the security group rule that references this user ID group pair.

                  Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z,
                  0-9, spaces, and ._-:/()#,@[]+=;{}!$*

                - **GroupId** *(string) --*

                  The ID of the security group.

                - **GroupName** *(string) --*

                  The name of the security group. In a request, use this parameter for a security
                  group in EC2-Classic or a default VPC only. For a security group in a nondefault
                  VPC, use the security group ID.

                  For a referenced security group in another VPC, this value is not returned if the
                  referenced security group is deleted.

                - **PeeringStatus** *(string) --*

                  The status of a VPC peering connection, if applicable.

                - **UserId** *(string) --*

                  The ID of an AWS account.

                  For a referenced security group in another VPC, the account ID of the referenced
                  security group is returned in the response. If the referenced security group is
                  deleted, this value is not returned.

                  [EC2-Classic] Required when adding or removing rules that reference a security
                  group in another AWS account.

                - **VpcId** *(string) --*

                  The ID of the VPC for the referenced security group, if applicable.

                - **VpcPeeringConnectionId** *(string) --*

                  The ID of the VPC peering connection, if applicable.

        - **VpcId** *(string) --*

          The ID of the VPC for the security group.
    """


_DescribeSubnetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSubnetsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSubnetsPaginateFiltersTypeDef(_DescribeSubnetsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeSubnetsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeSubnetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSubnetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSubnetsPaginatePaginationConfigTypeDef(
    _DescribeSubnetsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeSubnetsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of a CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `DescribeSubnetsPaginateResponseSubnets` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a subnet.

    - **AssociationId** *(string) --*

      The association ID for the CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of a CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_DescribeSubnetsPaginateResponseSubnetsTagsTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsTagsTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsTagsTypeDef
):
    """
    Type definition for `DescribeSubnetsPaginateResponseSubnets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeSubnetsPaginateResponseSubnetsTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": str,
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[DescribeSubnetsPaginateResponseSubnetsTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsTypeDef
):
    """
    Type definition for `DescribeSubnetsPaginateResponse` `Subnets`

    Describes a subnet.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the subnet.

    - **AvailabilityZoneId** *(string) --*

      The AZ ID of the subnet.

    - **AvailableIpAddressCount** *(integer) --*

      The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
      stopped instances are considered unavailable.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block assigned to the subnet.

    - **DefaultForAz** *(boolean) --*

      Indicates whether this is the default subnet for the Availability Zone.

    - **MapPublicIpOnLaunch** *(boolean) --*

      Indicates whether instances launched in this subnet receive a public IPv4 address.

    - **State** *(string) --*

      The current state of the subnet.

    - **SubnetId** *(string) --*

      The ID of the subnet.

    - **VpcId** *(string) --*

      The ID of the VPC the subnet is in.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the subnet.

    - **AssignIpv6AddressOnCreation** *(boolean) --*

      Indicates whether a network interface created in this subnet (including a network
      interface created by  RunInstances ) receives an IPv6 address.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the subnet.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a subnet.

        - **AssociationId** *(string) --*

          The association ID for the CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of a CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the subnet.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **SubnetArn** *(string) --*

      The Amazon Resource Name (ARN) of the subnet.
    """


_DescribeSubnetsPaginateResponseTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseTypeDef",
    {"Subnets": List[DescribeSubnetsPaginateResponseSubnetsTypeDef]},
    total=False,
)


class DescribeSubnetsPaginateResponseTypeDef(_DescribeSubnetsPaginateResponseTypeDef):
    """
    Type definition for `DescribeSubnetsPaginate` `Response`

    - **Subnets** *(list) --*

      Information about one or more subnets.

      - *(dict) --*

        Describes a subnet.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the subnet.

        - **AvailabilityZoneId** *(string) --*

          The AZ ID of the subnet.

        - **AvailableIpAddressCount** *(integer) --*

          The number of unused private IPv4 addresses in the subnet. The IPv4 addresses for any
          stopped instances are considered unavailable.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block assigned to the subnet.

        - **DefaultForAz** *(boolean) --*

          Indicates whether this is the default subnet for the Availability Zone.

        - **MapPublicIpOnLaunch** *(boolean) --*

          Indicates whether instances launched in this subnet receive a public IPv4 address.

        - **State** *(string) --*

          The current state of the subnet.

        - **SubnetId** *(string) --*

          The ID of the subnet.

        - **VpcId** *(string) --*

          The ID of the VPC the subnet is in.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the subnet.

        - **AssignIpv6AddressOnCreation** *(boolean) --*

          Indicates whether a network interface created in this subnet (including a network
          interface created by  RunInstances ) receives an IPv6 address.

        - **Ipv6CidrBlockAssociationSet** *(list) --*

          Information about the IPv6 CIDR blocks associated with the subnet.

          - *(dict) --*

            Describes an IPv6 CIDR block associated with a subnet.

            - **AssociationId** *(string) --*

              The association ID for the CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

            - **Ipv6CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of a CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the subnet.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **SubnetArn** *(string) --*

          The Amazon Resource Name (ARN) of the subnet.
    """


_DescribeTagsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTagsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTagsPaginateFiltersTypeDef(_DescribeTagsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeTagsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTagsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTagsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTagsPaginatePaginationConfigTypeDef(
    _DescribeTagsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTagsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTagsPaginateResponseTagsTypeDef = TypedDict(
    "_DescribeTagsPaginateResponseTagsTypeDef",
    {"Key": str, "ResourceId": str, "ResourceType": str, "Value": str},
    total=False,
)


class DescribeTagsPaginateResponseTagsTypeDef(_DescribeTagsPaginateResponseTagsTypeDef):
    """
    Type definition for `DescribeTagsPaginateResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The tag key.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **Value** *(string) --*

      The tag value.
    """


_DescribeTagsPaginateResponseTypeDef = TypedDict(
    "_DescribeTagsPaginateResponseTypeDef",
    {"Tags": List[DescribeTagsPaginateResponseTagsTypeDef]},
    total=False,
)


class DescribeTagsPaginateResponseTypeDef(_DescribeTagsPaginateResponseTypeDef):
    """
    Type definition for `DescribeTagsPaginate` `Response`

    - **Tags** *(list) --*

      The tags.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The tag key.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **Value** *(string) --*

          The tag value.
    """


_DescribeTrafficMirrorFiltersPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateFiltersTypeDef(
    _DescribeTrafficMirrorFiltersPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFilters` `EgressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRules` `DestinationPortRange`

    The destination port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRules` `SourcePortRange`

    The source port range assigned to the Traffic Mirror rule.

    - **FromPort** *(integer) --*

      The start of the Traffic Mirror port range. This applies to the TCP and UDP
      protocols.

    - **ToPort** *(integer) --*

      The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": str,
        "RuleNumber": int,
        "RuleAction": str,
        "Protocol": int,
        "DestinationPortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFilters` `IngressFilterRules`

    Describes the Traffic Mirror rule.

    - **TrafficMirrorFilterRuleId** *(string) --*

      The ID of the Traffic Mirror rule.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter that the rule is associated with.

    - **TrafficDirection** *(string) --*

      The traffic direction assigned to the Traffic Mirror rule.

    - **RuleNumber** *(integer) --*

      The rule number of the Traffic Mirror rule.

    - **RuleAction** *(string) --*

      The action assigned to the Traffic Mirror rule.

    - **Protocol** *(integer) --*

      The protocol assigned to the Traffic Mirror rule.

    - **DestinationPortRange** *(dict) --*

      The destination port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **SourcePortRange** *(dict) --*

      The source port range assigned to the Traffic Mirror rule.

      - **FromPort** *(integer) --*

        The start of the Traffic Mirror port range. This applies to the TCP and UDP
        protocols.

      - **ToPort** *(integer) --*

        The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

    - **DestinationCidrBlock** *(string) --*

      The destination CIDR block assigned to the Traffic Mirror rule.

    - **SourceCidrBlock** *(string) --*

      The source CIDR block assigned to the Traffic Mirror rule.

    - **Description** *(string) --*

      The description of the Traffic Mirror rule.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFilters` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginateResponse` `TrafficMirrorFilters`

    Describes the Traffic Mirror filter.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **IngressFilterRules** *(list) --*

      Information about the ingress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **EgressFilterRules** *(list) --*

      Information about the egress rules that are associated with the Traffic Mirror filter.

      - *(dict) --*

        Describes the Traffic Mirror rule.

        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter that the rule is associated with.

        - **TrafficDirection** *(string) --*

          The traffic direction assigned to the Traffic Mirror rule.

        - **RuleNumber** *(integer) --*

          The rule number of the Traffic Mirror rule.

        - **RuleAction** *(string) --*

          The action assigned to the Traffic Mirror rule.

        - **Protocol** *(integer) --*

          The protocol assigned to the Traffic Mirror rule.

        - **DestinationPortRange** *(dict) --*

          The destination port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **SourcePortRange** *(dict) --*

          The source port range assigned to the Traffic Mirror rule.

          - **FromPort** *(integer) --*

            The start of the Traffic Mirror port range. This applies to the TCP and UDP
            protocols.

          - **ToPort** *(integer) --*

            The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

        - **DestinationCidrBlock** *(string) --*

          The destination CIDR block assigned to the Traffic Mirror rule.

        - **SourceCidrBlock** *(string) --*

          The source CIDR block assigned to the Traffic Mirror rule.

        - **Description** *(string) --*

          The description of the Traffic Mirror rule.

    - **NetworkServices** *(list) --*

      The network service traffic that is associated with the Traffic Mirror filter.

      - *(string) --*

    - **Description** *(string) --*

      The description of the Traffic Mirror filter.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror filter.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTypeDef",
    {
        "TrafficMirrorFilters": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorFiltersPaginate` `Response`

    - **TrafficMirrorFilters** *(list) --*

      Information about one or more Traffic Mirror filters.

      - *(dict) --*

        Describes the Traffic Mirror filter.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.

        - **IngressFilterRules** *(list) --*

          Information about the ingress rules that are associated with the Traffic Mirror filter.

          - *(dict) --*

            Describes the Traffic Mirror rule.

            - **TrafficMirrorFilterRuleId** *(string) --*

              The ID of the Traffic Mirror rule.

            - **TrafficMirrorFilterId** *(string) --*

              The ID of the Traffic Mirror filter that the rule is associated with.

            - **TrafficDirection** *(string) --*

              The traffic direction assigned to the Traffic Mirror rule.

            - **RuleNumber** *(integer) --*

              The rule number of the Traffic Mirror rule.

            - **RuleAction** *(string) --*

              The action assigned to the Traffic Mirror rule.

            - **Protocol** *(integer) --*

              The protocol assigned to the Traffic Mirror rule.

            - **DestinationPortRange** *(dict) --*

              The destination port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **SourcePortRange** *(dict) --*

              The source port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **DestinationCidrBlock** *(string) --*

              The destination CIDR block assigned to the Traffic Mirror rule.

            - **SourceCidrBlock** *(string) --*

              The source CIDR block assigned to the Traffic Mirror rule.

            - **Description** *(string) --*

              The description of the Traffic Mirror rule.

        - **EgressFilterRules** *(list) --*

          Information about the egress rules that are associated with the Traffic Mirror filter.

          - *(dict) --*

            Describes the Traffic Mirror rule.

            - **TrafficMirrorFilterRuleId** *(string) --*

              The ID of the Traffic Mirror rule.

            - **TrafficMirrorFilterId** *(string) --*

              The ID of the Traffic Mirror filter that the rule is associated with.

            - **TrafficDirection** *(string) --*

              The traffic direction assigned to the Traffic Mirror rule.

            - **RuleNumber** *(integer) --*

              The rule number of the Traffic Mirror rule.

            - **RuleAction** *(string) --*

              The action assigned to the Traffic Mirror rule.

            - **Protocol** *(integer) --*

              The protocol assigned to the Traffic Mirror rule.

            - **DestinationPortRange** *(dict) --*

              The destination port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **SourcePortRange** *(dict) --*

              The source port range assigned to the Traffic Mirror rule.

              - **FromPort** *(integer) --*

                The start of the Traffic Mirror port range. This applies to the TCP and UDP
                protocols.

              - **ToPort** *(integer) --*

                The end of the Traffic Mirror port range. This applies to the TCP and UDP protocols.

            - **DestinationCidrBlock** *(string) --*

              The destination CIDR block assigned to the Traffic Mirror rule.

            - **SourceCidrBlock** *(string) --*

              The source CIDR block assigned to the Traffic Mirror rule.

            - **Description** *(string) --*

              The description of the Traffic Mirror rule.

        - **NetworkServices** *(list) --*

          The network service traffic that is associated with the Traffic Mirror filter.

          - *(string) --*

        - **Description** *(string) --*

          The description of the Traffic Mirror filter.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror filter.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTrafficMirrorSessionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateFiltersTypeDef(
    _DescribeTrafficMirrorSessionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorSessionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorSessionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessions` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[
            DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorSessionsPaginateResponse` `TrafficMirrorSessions`

    Describes a Traffic Mirror session.

    - **TrafficMirrorSessionId** *(string) --*

      The ID for the Traffic Mirror session.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **TrafficMirrorFilterId** *(string) --*

      The ID of the Traffic Mirror filter.

    - **NetworkInterfaceId** *(string) --*

      The ID of the Traffic Mirror session's network interface.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror session.

    - **PacketLength** *(integer) --*

      The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
      To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
      this value to 100, then the first 100 bytes that meet the filter criteria are copied to
      the target. Do not specify this parameter when you want to mirror the entire packet

    - **SessionNumber** *(integer) --*

      The session number determines the order in which sessions are evaluated when an interface
      is used by multiple sessions. The first session with a matching filter is the one that
      mirrors the packets.

      Valid values are 1-32766.

    - **VirtualNetworkId** *(integer) --*

      The virtual network ID associated with the Traffic Mirror session.

    - **Description** *(string) --*

      The description of the Traffic Mirror session.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror session.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTrafficMirrorSessionsPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTypeDef",
    {
        "TrafficMirrorSessions": List[
            DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorSessionsPaginate` `Response`

    - **TrafficMirrorSessions** *(list) --*

      Describes one or more Traffic Mirror sessions. By default, all Traffic Mirror sessions are
      described. Alternatively, you can filter the results.

      - *(dict) --*

        Describes a Traffic Mirror session.

        - **TrafficMirrorSessionId** *(string) --*

          The ID for the Traffic Mirror session.

        - **TrafficMirrorTargetId** *(string) --*

          The ID of the Traffic Mirror target.

        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.

        - **NetworkInterfaceId** *(string) --*

          The ID of the Traffic Mirror session's network interface.

        - **OwnerId** *(string) --*

          The ID of the account that owns the Traffic Mirror session.

        - **PacketLength** *(integer) --*

          The number of bytes in each packet to mirror. These are the bytes after the VXLAN header.
          To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set
          this value to 100, then the first 100 bytes that meet the filter criteria are copied to
          the target. Do not specify this parameter when you want to mirror the entire packet

        - **SessionNumber** *(integer) --*

          The session number determines the order in which sessions are evaluated when an interface
          is used by multiple sessions. The first session with a matching filter is the one that
          mirrors the packets.

          Valid values are 1-32766.

        - **VirtualNetworkId** *(integer) --*

          The virtual network ID associated with the Traffic Mirror session.

        - **Description** *(string) --*

          The description of the Traffic Mirror session.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror session.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTrafficMirrorTargetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateFiltersTypeDef(
    _DescribeTrafficMirrorTargetsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorTargetsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorTargetsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargets` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": str,
        "Description": str,
        "OwnerId": str,
        "Tags": List[
            DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorTargetsPaginateResponse` `TrafficMirrorTargets`

    Describes a Traffic Mirror target.

    - **TrafficMirrorTargetId** *(string) --*

      The ID of the Traffic Mirror target.

    - **NetworkInterfaceId** *(string) --*

      The network interface ID that is attached to the target.

    - **NetworkLoadBalancerArn** *(string) --*

      The Amazon Resource Name (ARN) of the Network Load Balancer.

    - **Type** *(string) --*

      The type of Traffic Mirror target.

    - **Description** *(string) --*

      Information about the Traffic Mirror target.

    - **OwnerId** *(string) --*

      The ID of the account that owns the Traffic Mirror target.

    - **Tags** *(list) --*

      The tags assigned to the Traffic Mirror target.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTrafficMirrorTargetsPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTypeDef",
    {
        "TrafficMirrorTargets": List[
            DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTrafficMirrorTargetsPaginate` `Response`

    - **TrafficMirrorTargets** *(list) --*

      Information about one or more Traffic Mirror targets.

      - *(dict) --*

        Describes a Traffic Mirror target.

        - **TrafficMirrorTargetId** *(string) --*

          The ID of the Traffic Mirror target.

        - **NetworkInterfaceId** *(string) --*

          The network interface ID that is attached to the target.

        - **NetworkLoadBalancerArn** *(string) --*

          The Amazon Resource Name (ARN) of the Network Load Balancer.

        - **Type** *(string) --*

          The type of Traffic Mirror target.

        - **Description** *(string) --*

          Information about the Traffic Mirror target.

        - **OwnerId** *(string) --*

          The ID of the account that owns the Traffic Mirror target.

        - **Tags** *(list) --*

          The tags assigned to the Traffic Mirror target.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef",
    {"TransitGatewayRouteTableId": str, "State": str},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachments` `Association`

    The association.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the route table for the transit gateway.

    - **State** *(string) --*

      The state of the association.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachments` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "TransitGatewayOwnerId": str,
        "ResourceOwnerId": str,
        "ResourceType": str,
        "ResourceId": str,
        "State": str,
        "Association": DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef,
        "CreationTime": datetime,
        "Tags": List[
            DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginateResponse` `TransitGatewayAttachments`

    Describes an attachment between a resource and a transit gateway.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayOwnerId** *(string) --*

      The ID of the AWS account that owns the transit gateway.

    - **ResourceOwnerId** *(string) --*

      The ID of the AWS account that owns the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **State** *(string) --*

      The attachment state.

    - **Association** *(dict) --*

      The association.

      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the route table for the transit gateway.

      - **State** *(string) --*

        The state of the association.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      The tags for the attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTypeDef",
    {
        "TransitGatewayAttachments": List[
            DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTransitGatewayAttachmentsPaginate` `Response`

    - **TransitGatewayAttachments** *(list) --*

      Information about the attachments.

      - *(dict) --*

        Describes an attachment between a resource and a transit gateway.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **TransitGatewayOwnerId** *(string) --*

          The ID of the AWS account that owns the transit gateway.

        - **ResourceOwnerId** *(string) --*

          The ID of the AWS account that owns the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **State** *(string) --*

          The attachment state.

        - **Association** *(dict) --*

          The association.

          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the route table for the transit gateway.

          - **State** *(string) --*

            The state of the association.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Tags** *(list) --*

          The tags for the attachment.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTransitGatewayRouteTablesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTransitGatewayRouteTablesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTables` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": str,
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef
):
    """
    Type definition for `DescribeTransitGatewayRouteTablesPaginateResponse` `TransitGatewayRouteTables`

    Describes a transit gateway route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the transit gateway route table.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway route table.

    - **DefaultAssociationRouteTable** *(boolean) --*

      Indicates whether this is the default association route table for the transit gateway.

    - **DefaultPropagationRouteTable** *(boolean) --*

      Indicates whether this is the default propagation route table for the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Tags** *(list) --*

      Any tags assigned to the route table.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTransitGatewayRouteTablesPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTypeDef",
    {
        "TransitGatewayRouteTables": List[
            DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTransitGatewayRouteTablesPaginate` `Response`

    - **TransitGatewayRouteTables** *(list) --*

      Information about the transit gateway route tables.

      - *(dict) --*

        Describes a transit gateway route table.

        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **State** *(string) --*

          The state of the transit gateway route table.

        - **DefaultAssociationRouteTable** *(boolean) --*

          Indicates whether this is the default association route table for the transit gateway.

        - **DefaultPropagationRouteTable** *(boolean) --*

          Indicates whether this is the default propagation route table for the transit gateway.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Tags** *(list) --*

          Any tags assigned to the route table.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    {"DnsSupport": str, "Ipv6Support": str},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachments` `Options`

    The VPC attachment options.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.

    - **Ipv6Support** *(string) --*

      Indicates whether IPv6 support is enabled.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachments` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": str,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef,
        "Tags": List[
            DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginateResponse` `TransitGatewayVpcAttachments`

    Describes a VPC attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **VpcOwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **State** *(string) --*

      The state of the VPC attachment.

    - **SubnetIds** *(list) --*

      The IDs of the subnets.

      - *(string) --*

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The VPC attachment options.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

      - **Ipv6Support** *(string) --*

        Indicates whether IPv6 support is enabled.

    - **Tags** *(list) --*

      The tags for the VPC attachment.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef",
    {
        "TransitGatewayVpcAttachments": List[
            DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTransitGatewayVpcAttachmentsPaginate` `Response`

    - **TransitGatewayVpcAttachments** *(list) --*

      Information about the VPC attachments.

      - *(dict) --*

        Describes a VPC attachment.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **VpcOwnerId** *(string) --*

          The ID of the AWS account that owns the VPC.

        - **State** *(string) --*

          The state of the VPC attachment.

        - **SubnetIds** *(list) --*

          The IDs of the subnets.

          - *(string) --*

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Options** *(dict) --*

          The VPC attachment options.

          - **DnsSupport** *(string) --*

            Indicates whether DNS support is enabled.

          - **Ipv6Support** *(string) --*

            Indicates whether IPv6 support is enabled.

        - **Tags** *(list) --*

          The tags for the VPC attachment.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeTransitGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewaysPaginateFiltersTypeDef(
    _DescribeTransitGatewaysPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeTransitGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewaysPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewaysPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": str,
        "DefaultRouteTableAssociation": str,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": str,
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": str,
        "DnsSupport": str,
    },
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginateResponseTransitGateways` `Options`

    The transit gateway options.

    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
      range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

    - **AutoAcceptSharedAttachments** *(string) --*

      Indicates whether attachment requests are automatically accepted.

    - **DefaultRouteTableAssociation** *(string) --*

      Indicates whether resource attachments are automatically associated with the default
      association route table.

    - **AssociationDefaultRouteTableId** *(string) --*

      The ID of the default association route table.

    - **DefaultRouteTablePropagation** *(string) --*

      Indicates whether resource attachments automatically propagate routes to the default
      propagation route table.

    - **PropagationDefaultRouteTableId** *(string) --*

      The ID of the default propagation route table.

    - **VpnEcmpSupport** *(string) --*

      Indicates whether Equal Cost Multipath Protocol support is enabled.

    - **DnsSupport** *(string) --*

      Indicates whether DNS support is enabled.
    """


_DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginateResponseTransitGateways` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": str,
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef,
        "Tags": List[DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef],
    },
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginateResponse` `TransitGateways`

    Describes a transit gateway.

    - **TransitGatewayId** *(string) --*

      The ID of the transit gateway.

    - **TransitGatewayArn** *(string) --*

      The Amazon Resource Name (ARN) of the transit gateway.

    - **State** *(string) --*

      The state of the transit gateway.

    - **OwnerId** *(string) --*

      The ID of the AWS account ID that owns the transit gateway.

    - **Description** *(string) --*

      The description of the transit gateway.

    - **CreationTime** *(datetime) --*

      The creation time.

    - **Options** *(dict) --*

      The transit gateway options.

      - **AmazonSideAsn** *(integer) --*

        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
        range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

      - **AutoAcceptSharedAttachments** *(string) --*

        Indicates whether attachment requests are automatically accepted.

      - **DefaultRouteTableAssociation** *(string) --*

        Indicates whether resource attachments are automatically associated with the default
        association route table.

      - **AssociationDefaultRouteTableId** *(string) --*

        The ID of the default association route table.

      - **DefaultRouteTablePropagation** *(string) --*

        Indicates whether resource attachments automatically propagate routes to the default
        propagation route table.

      - **PropagationDefaultRouteTableId** *(string) --*

        The ID of the default propagation route table.

      - **VpnEcmpSupport** *(string) --*

        Indicates whether Equal Cost Multipath Protocol support is enabled.

      - **DnsSupport** *(string) --*

        Indicates whether DNS support is enabled.

    - **Tags** *(list) --*

      The tags for the transit gateway.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeTransitGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTypeDef",
    {
        "TransitGateways": List[
            DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTypeDef(
    _DescribeTransitGatewaysPaginateResponseTypeDef
):
    """
    Type definition for `DescribeTransitGatewaysPaginate` `Response`

    - **TransitGateways** *(list) --*

      Information about the transit gateways.

      - *(dict) --*

        Describes a transit gateway.

        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.

        - **TransitGatewayArn** *(string) --*

          The Amazon Resource Name (ARN) of the transit gateway.

        - **State** *(string) --*

          The state of the transit gateway.

        - **OwnerId** *(string) --*

          The ID of the AWS account ID that owns the transit gateway.

        - **Description** *(string) --*

          The description of the transit gateway.

        - **CreationTime** *(datetime) --*

          The creation time.

        - **Options** *(dict) --*

          The transit gateway options.

          - **AmazonSideAsn** *(integer) --*

            A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The
            range is 64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.

          - **AutoAcceptSharedAttachments** *(string) --*

            Indicates whether attachment requests are automatically accepted.

          - **DefaultRouteTableAssociation** *(string) --*

            Indicates whether resource attachments are automatically associated with the default
            association route table.

          - **AssociationDefaultRouteTableId** *(string) --*

            The ID of the default association route table.

          - **DefaultRouteTablePropagation** *(string) --*

            Indicates whether resource attachments automatically propagate routes to the default
            propagation route table.

          - **PropagationDefaultRouteTableId** *(string) --*

            The ID of the default propagation route table.

          - **VpnEcmpSupport** *(string) --*

            Indicates whether Equal Cost Multipath Protocol support is enabled.

          - **DnsSupport** *(string) --*

            Indicates whether DNS support is enabled.

        - **Tags** *(list) --*

          The tags for the transit gateway.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeVolumeStatusPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVolumeStatusPaginateFiltersTypeDef(
    _DescribeVolumeStatusPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVolumeStatusPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumeStatusPaginatePaginationConfigTypeDef(
    _DescribeVolumeStatusPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginateResponseVolumeStatuses` `Actions`

    Describes a volume status operation code.

    - **Code** *(string) --*

      The code identifying the operation, for example, ``enable-volume-io`` .

    - **Description** *(string) --*

      A description of the operation.

    - **EventId** *(string) --*

      The ID of the event associated with this operation.

    - **EventType** *(string) --*

      The event type associated with this operation.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginateResponseVolumeStatuses` `Events`

    Describes a volume status event.

    - **Description** *(string) --*

      A description of the event.

    - **EventId** *(string) --*

      The ID of this event.

    - **EventType** *(string) --*

      The type of this event.

    - **NotAfter** *(datetime) --*

      The latest end time of the event.

    - **NotBefore** *(datetime) --*

      The earliest start time of the event.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": str, "Status": str},
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatus` `Details`

    Describes a volume status.

    - **Name** *(string) --*

      The name of the volume status.

    - **Status** *(string) --*

      The intended status of the volume status.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[
            DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginateResponseVolumeStatuses` `VolumeStatus`

    The volume status.

    - **Details** *(list) --*

      The details of the volume status.

      - *(dict) --*

        Describes a volume status.

        - **Name** *(string) --*

          The name of the volume status.

        - **Status** *(string) --*

          The intended status of the volume status.

    - **Status** *(string) --*

      The status of the volume.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef",
    {
        "Actions": List[
            DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef
        ],
        "AvailabilityZone": str,
        "Events": List[DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginateResponse` `VolumeStatuses`

    Describes the volume status.

    - **Actions** *(list) --*

      The details of the operation.

      - *(dict) --*

        Describes a volume status operation code.

        - **Code** *(string) --*

          The code identifying the operation, for example, ``enable-volume-io`` .

        - **Description** *(string) --*

          A description of the operation.

        - **EventId** *(string) --*

          The ID of the event associated with this operation.

        - **EventType** *(string) --*

          The event type associated with this operation.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the volume.

    - **Events** *(list) --*

      A list of events associated with the volume.

      - *(dict) --*

        Describes a volume status event.

        - **Description** *(string) --*

          A description of the event.

        - **EventId** *(string) --*

          The ID of this event.

        - **EventType** *(string) --*

          The type of this event.

        - **NotAfter** *(datetime) --*

          The latest end time of the event.

        - **NotBefore** *(datetime) --*

          The earliest start time of the event.

    - **VolumeId** *(string) --*

      The volume ID.

    - **VolumeStatus** *(dict) --*

      The volume status.

      - **Details** *(list) --*

        The details of the volume status.

        - *(dict) --*

          Describes a volume status.

          - **Name** *(string) --*

            The name of the volume status.

          - **Status** *(string) --*

            The intended status of the volume status.

      - **Status** *(string) --*

        The status of the volume.
    """


_DescribeVolumeStatusPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseTypeDef",
    {"VolumeStatuses": List[DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef]},
    total=False,
)


class DescribeVolumeStatusPaginateResponseTypeDef(
    _DescribeVolumeStatusPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVolumeStatusPaginate` `Response`

    - **VolumeStatuses** *(list) --*

      Information about the status of the volumes.

      - *(dict) --*

        Describes the volume status.

        - **Actions** *(list) --*

          The details of the operation.

          - *(dict) --*

            Describes a volume status operation code.

            - **Code** *(string) --*

              The code identifying the operation, for example, ``enable-volume-io`` .

            - **Description** *(string) --*

              A description of the operation.

            - **EventId** *(string) --*

              The ID of the event associated with this operation.

            - **EventType** *(string) --*

              The event type associated with this operation.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the volume.

        - **Events** *(list) --*

          A list of events associated with the volume.

          - *(dict) --*

            Describes a volume status event.

            - **Description** *(string) --*

              A description of the event.

            - **EventId** *(string) --*

              The ID of this event.

            - **EventType** *(string) --*

              The type of this event.

            - **NotAfter** *(datetime) --*

              The latest end time of the event.

            - **NotBefore** *(datetime) --*

              The earliest start time of the event.

        - **VolumeId** *(string) --*

          The volume ID.

        - **VolumeStatus** *(dict) --*

          The volume status.

          - **Details** *(list) --*

            The details of the volume status.

            - *(dict) --*

              Describes a volume status.

              - **Name** *(string) --*

                The name of the volume status.

              - **Status** *(string) --*

                The intended status of the volume status.

          - **Status** *(string) --*

            The status of the volume.
    """


_DescribeVolumesModificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVolumesModificationsPaginateFiltersTypeDef(
    _DescribeVolumesModificationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVolumesModificationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVolumesModificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumesModificationsPaginatePaginationConfigTypeDef(
    _DescribeVolumesModificationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVolumesModificationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef",
    {
        "VolumeId": str,
        "ModificationState": str,
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": str,
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": str,
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef(
    _DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef
):
    """
    Type definition for `DescribeVolumesModificationsPaginateResponse` `VolumesModifications`

    Describes the modification status of an EBS volume.

    If the volume has never been modified, some element values will be null.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **ModificationState** *(string) --*

      The current modification state. The modification state is null for unmodified volumes.

    - **StatusMessage** *(string) --*

      A status message about the modification progress or failure.

    - **TargetSize** *(integer) --*

      The target size of the volume, in GiB.

    - **TargetIops** *(integer) --*

      The target IOPS rate of the volume.

    - **TargetVolumeType** *(string) --*

      The target EBS volume type of the volume.

    - **OriginalSize** *(integer) --*

      The original size of the volume.

    - **OriginalIops** *(integer) --*

      The original IOPS rate of the volume.

    - **OriginalVolumeType** *(string) --*

      The original EBS volume type of the volume.

    - **Progress** *(integer) --*

      The modification progress, from 0 to 100 percent complete.

    - **StartTime** *(datetime) --*

      The modification start time.

    - **EndTime** *(datetime) --*

      The modification completion or failure time.
    """


_DescribeVolumesModificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateResponseTypeDef",
    {
        "VolumesModifications": List[
            DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef
        ]
    },
    total=False,
)


class DescribeVolumesModificationsPaginateResponseTypeDef(
    _DescribeVolumesModificationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVolumesModificationsPaginate` `Response`

    - **VolumesModifications** *(list) --*

      Information about the volume modifications.

      - *(dict) --*

        Describes the modification status of an EBS volume.

        If the volume has never been modified, some element values will be null.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **ModificationState** *(string) --*

          The current modification state. The modification state is null for unmodified volumes.

        - **StatusMessage** *(string) --*

          A status message about the modification progress or failure.

        - **TargetSize** *(integer) --*

          The target size of the volume, in GiB.

        - **TargetIops** *(integer) --*

          The target IOPS rate of the volume.

        - **TargetVolumeType** *(string) --*

          The target EBS volume type of the volume.

        - **OriginalSize** *(integer) --*

          The original size of the volume.

        - **OriginalIops** *(integer) --*

          The original IOPS rate of the volume.

        - **OriginalVolumeType** *(string) --*

          The original EBS volume type of the volume.

        - **Progress** *(integer) --*

          The modification progress, from 0 to 100 percent complete.

        - **StartTime** *(datetime) --*

          The modification start time.

        - **EndTime** *(datetime) --*

          The modification completion or failure time.
    """


_DescribeVolumesPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVolumesPaginateFiltersTypeDef(_DescribeVolumesPaginateFiltersTypeDef):
    """
    Type definition for `DescribeVolumesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVolumesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumesPaginatePaginationConfigTypeDef(
    _DescribeVolumesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVolumesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef(
    _DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef
):
    """
    Type definition for `DescribeVolumesPaginateResponseVolumes` `Attachments`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_DescribeVolumesPaginateResponseVolumesTagsTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVolumesPaginateResponseVolumesTagsTypeDef(
    _DescribeVolumesPaginateResponseVolumesTagsTypeDef
):
    """
    Type definition for `DescribeVolumesPaginateResponseVolumes` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVolumesPaginateResponseVolumesTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesTypeDef",
    {
        "Attachments": List[DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": str,
        "VolumeId": str,
        "Iops": int,
        "Tags": List[DescribeVolumesPaginateResponseVolumesTagsTypeDef],
        "VolumeType": str,
    },
    total=False,
)


class DescribeVolumesPaginateResponseVolumesTypeDef(
    _DescribeVolumesPaginateResponseVolumesTypeDef
):
    """
    Type definition for `DescribeVolumesPaginateResponse` `Volumes`

    Describes a volume.

    - **Attachments** *(list) --*

      Information about the volume attachments.

      - *(dict) --*

        Describes volume attachment details.

        - **AttachTime** *(datetime) --*

          The time stamp when the attachment initiated.

        - **Device** *(string) --*

          The device name.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **State** *(string) --*

          The attachment state of the volume.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **DeleteOnTermination** *(boolean) --*

          Indicates whether the EBS volume is deleted on instance termination.

    - **AvailabilityZone** *(string) --*

      The Availability Zone for the volume.

    - **CreateTime** *(datetime) --*

      The time stamp when volume creation was initiated.

    - **Encrypted** *(boolean) --*

      Indicates whether the volume is encrypted.

    - **KmsKeyId** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
      master key (CMK) that was used to protect the volume encryption key for the volume.

    - **Size** *(integer) --*

      The size of the volume, in GiBs.

    - **SnapshotId** *(string) --*

      The snapshot from which the volume was created, if applicable.

    - **State** *(string) --*

      The volume state.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For Provisioned
      IOPS SSD volumes, this represents the number of IOPS that are provisioned for the volume.
      For General Purpose SSD volumes, this represents the baseline performance of the volume
      and the rate at which the volume accumulates I/O credits for bursting. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes, in most Regions. The maximum IOPS for ``io1`` of 64,000 is guaranteed
      only on `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS.

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **Tags** *(list) --*

      Any tags assigned to the volume.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VolumeType** *(string) --*

      The volume type. This can be ``gp2`` for General Purpose SSD, ``io1`` for Provisioned
      IOPS SSD, ``st1`` for Throughput Optimized HDD, ``sc1`` for Cold HDD, or ``standard`` for
      Magnetic volumes.
    """


_DescribeVolumesPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseTypeDef",
    {"Volumes": List[DescribeVolumesPaginateResponseVolumesTypeDef]},
    total=False,
)


class DescribeVolumesPaginateResponseTypeDef(_DescribeVolumesPaginateResponseTypeDef):
    """
    Type definition for `DescribeVolumesPaginate` `Response`

    - **Volumes** *(list) --*

      Information about the volumes.

      - *(dict) --*

        Describes a volume.

        - **Attachments** *(list) --*

          Information about the volume attachments.

          - *(dict) --*

            Describes volume attachment details.

            - **AttachTime** *(datetime) --*

              The time stamp when the attachment initiated.

            - **Device** *(string) --*

              The device name.

            - **InstanceId** *(string) --*

              The ID of the instance.

            - **State** *(string) --*

              The attachment state of the volume.

            - **VolumeId** *(string) --*

              The ID of the volume.

            - **DeleteOnTermination** *(boolean) --*

              Indicates whether the EBS volume is deleted on instance termination.

        - **AvailabilityZone** *(string) --*

          The Availability Zone for the volume.

        - **CreateTime** *(datetime) --*

          The time stamp when volume creation was initiated.

        - **Encrypted** *(boolean) --*

          Indicates whether the volume is encrypted.

        - **KmsKeyId** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) customer
          master key (CMK) that was used to protect the volume encryption key for the volume.

        - **Size** *(integer) --*

          The size of the volume, in GiBs.

        - **SnapshotId** *(string) --*

          The snapshot from which the volume was created, if applicable.

        - **State** *(string) --*

          The volume state.

        - **VolumeId** *(string) --*

          The ID of the volume.

        - **Iops** *(integer) --*

          The number of I/O operations per second (IOPS) that the volume supports. For Provisioned
          IOPS SSD volumes, this represents the number of IOPS that are provisioned for the volume.
          For General Purpose SSD volumes, this represents the baseline performance of the volume
          and the rate at which the volume accumulates I/O credits for bursting. For more
          information, see `Amazon EBS Volume Types
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
          *Amazon Elastic Compute Cloud User Guide* .

          Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
          ``io1`` volumes, in most Regions. The maximum IOPS for ``io1`` of 64,000 is guaranteed
          only on `Nitro-based instances
          <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
          . Other instance families guarantee performance up to 32,000 IOPS.

          Condition: This parameter is required for requests to create ``io1`` volumes; it is not
          used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

        - **Tags** *(list) --*

          Any tags assigned to the volume.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VolumeType** *(string) --*

          The volume type. This can be ``gp2`` for General Purpose SSD, ``io1`` for Provisioned
          IOPS SSD, ``st1`` for Throughput Optimized HDD, ``sc1`` for Cold HDD, or ``standard`` for
          Magnetic volumes.
    """


_DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcClassicLinkDnsSupportPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef",
    {"ClassicLinkDnsSupported": bool, "VpcId": str},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef
):
    """
    Type definition for `DescribeVpcClassicLinkDnsSupportPaginateResponse` `Vpcs`

    Describes the ClassicLink DNS support status of a VPC.

    - **ClassicLinkDnsSupported** *(boolean) --*

      Indicates whether ClassicLink DNS support is enabled for the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.
    """


_DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef",
    {"Vpcs": List[DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef]},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcClassicLinkDnsSupportPaginate` `Response`

    - **Vpcs** *(list) --*

      Information about the ClassicLink DNS support status of the VPCs.

      - *(dict) --*

        Describes the ClassicLink DNS support status of a VPC.

        - **ClassicLinkDnsSupported** *(boolean) --*

          Indicates whether ClassicLink DNS support is enabled for the VPC.

        - **VpcId** *(string) --*

          The ID of the VPC.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionNotificationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionNotificationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": str,
    },
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionNotificationsPaginateResponse` `ConnectionNotificationSet`

    Describes a connection notification for a VPC endpoint or VPC endpoint service.

    - **ConnectionNotificationId** *(string) --*

      The ID of the notification.

    - **ServiceId** *(string) --*

      The ID of the endpoint service.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **ConnectionNotificationType** *(string) --*

      The type of notification.

    - **ConnectionNotificationArn** *(string) --*

      The ARN of the SNS topic for the notification.

    - **ConnectionEvents** *(list) --*

      The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
      and ``Reject`` .

      - *(string) --*

    - **ConnectionNotificationState** *(string) --*

      The state of the notification.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef",
    {
        "ConnectionNotificationSet": List[
            DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionNotificationsPaginate` `Response`

    - **ConnectionNotificationSet** *(list) --*

      One or more notifications.

      - *(dict) --*

        Describes a connection notification for a VPC endpoint or VPC endpoint service.

        - **ConnectionNotificationId** *(string) --*

          The ID of the notification.

        - **ServiceId** *(string) --*

          The ID of the endpoint service.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **ConnectionNotificationType** *(string) --*

          The type of notification.

        - **ConnectionNotificationArn** *(string) --*

          The ARN of the SNS topic for the notification.

        - **ConnectionEvents** *(list) --*

          The events for the notification. Valid values are ``Accept`` , ``Connect`` , ``Delete`` ,
          and ``Reject`` .

          - *(string) --*

        - **ConnectionNotificationState** *(string) --*

          The state of the notification.
    """


_DescribeVpcEndpointConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateFiltersTypeDef(
    _DescribeVpcEndpointConnectionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnections` `DnsEntries`

    Describes a DNS entry.

    - **DnsName** *(string) --*

      The DNS name.

    - **HostedZoneId** *(string) --*

      The ID of the private hosted zone.
    """


_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointId": str,
        "VpcEndpointOwner": str,
        "VpcEndpointState": str,
        "CreationTimestamp": datetime,
        "DnsEntries": List[
            DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef
        ],
        "NetworkLoadBalancerArns": List[str],
    },
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionsPaginateResponse` `VpcEndpointConnections`

    Describes a VPC endpoint connection to a service.

    - **ServiceId** *(string) --*

      The ID of the service to which the endpoint is connected.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **VpcEndpointOwner** *(string) --*

      The AWS account ID of the owner of the VPC endpoint.

    - **VpcEndpointState** *(string) --*

      The state of the VPC endpoint.

    - **CreationTimestamp** *(datetime) --*

      The date and time the VPC endpoint was created.

    - **DnsEntries** *(list) --*

      The DNS entries for the VPC endpoint.

      - *(dict) --*

        Describes a DNS entry.

        - **DnsName** *(string) --*

          The DNS name.

        - **HostedZoneId** *(string) --*

          The ID of the private hosted zone.

    - **NetworkLoadBalancerArns** *(list) --*

      The Amazon Resource Names (ARNs) of the network load balancers for the service.

      - *(string) --*
    """


_DescribeVpcEndpointConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseTypeDef",
    {
        "VpcEndpointConnections": List[
            DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointConnectionsPaginate` `Response`

    - **VpcEndpointConnections** *(list) --*

      Information about one or more VPC endpoint connections.

      - *(dict) --*

        Describes a VPC endpoint connection to a service.

        - **ServiceId** *(string) --*

          The ID of the service to which the endpoint is connected.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **VpcEndpointOwner** *(string) --*

          The AWS account ID of the owner of the VPC endpoint.

        - **VpcEndpointState** *(string) --*

          The state of the VPC endpoint.

        - **CreationTimestamp** *(datetime) --*

          The date and time the VPC endpoint was created.

        - **DnsEntries** *(list) --*

          The DNS entries for the VPC endpoint.

          - *(dict) --*

            Describes a DNS entry.

            - **DnsName** *(string) --*

              The DNS name.

            - **HostedZoneId** *(string) --*

              The ID of the private hosted zone.

        - **NetworkLoadBalancerArns** *(list) --*

          The Amazon Resource Names (ARNs) of the network load balancers for the service.

          - *(string) --*
    """


_DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef",
    {"ServiceType": str},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurations` `ServiceType`

    Describes the type of service for a VPC endpoint.

    - **ServiceType** *(string) --*

      The type of service.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurations` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef",
    {
        "ServiceType": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": str,
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginateResponse` `ServiceConfigurations`

    Describes a service configuration for a VPC endpoint service.

    - **ServiceType** *(list) --*

      The type of service.

      - *(dict) --*

        Describes the type of service for a VPC endpoint.

        - **ServiceType** *(string) --*

          The type of service.

    - **ServiceId** *(string) --*

      The ID of the service.

    - **ServiceName** *(string) --*

      The name of the service.

    - **ServiceState** *(string) --*

      The service state.

    - **AvailabilityZones** *(list) --*

      In the Availability Zones in which the service is available.

      - *(string) --*

    - **AcceptanceRequired** *(boolean) --*

      Indicates whether requests from other AWS accounts to create an endpoint to the service
      must first be accepted.

    - **ManagesVpcEndpoints** *(boolean) --*

      Indicates whether the service manages it's VPC endpoints. Management of the service VPC
      endpoints using the VPC endpoint API is restricted.

    - **NetworkLoadBalancerArns** *(list) --*

      The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

      - *(string) --*

    - **BaseEndpointDnsNames** *(list) --*

      The DNS names for the service.

      - *(string) --*

    - **PrivateDnsName** *(string) --*

      The private DNS name for the service.

    - **Tags** *(list) --*

      Any tags assigned to the service.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef",
    {
        "ServiceConfigurations": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServiceConfigurationsPaginate` `Response`

    - **ServiceConfigurations** *(list) --*

      Information about one or more services.

      - *(dict) --*

        Describes a service configuration for a VPC endpoint service.

        - **ServiceType** *(list) --*

          The type of service.

          - *(dict) --*

            Describes the type of service for a VPC endpoint.

            - **ServiceType** *(string) --*

              The type of service.

        - **ServiceId** *(string) --*

          The ID of the service.

        - **ServiceName** *(string) --*

          The name of the service.

        - **ServiceState** *(string) --*

          The service state.

        - **AvailabilityZones** *(list) --*

          In the Availability Zones in which the service is available.

          - *(string) --*

        - **AcceptanceRequired** *(boolean) --*

          Indicates whether requests from other AWS accounts to create an endpoint to the service
          must first be accepted.

        - **ManagesVpcEndpoints** *(boolean) --*

          Indicates whether the service manages it's VPC endpoints. Management of the service VPC
          endpoints using the VPC endpoint API is restricted.

        - **NetworkLoadBalancerArns** *(list) --*

          The Amazon Resource Names (ARNs) of the Network Load Balancers for the service.

          - *(string) --*

        - **BaseEndpointDnsNames** *(list) --*

          The DNS names for the service.

          - *(string) --*

        - **PrivateDnsName** *(string) --*

          The private DNS name for the service.

        - **Tags** *(list) --*

          Any tags assigned to the service.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicePermissionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicePermissionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef",
    {"PrincipalType": str, "Principal": str},
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicePermissionsPaginateResponse` `AllowedPrincipals`

    Describes a principal.

    - **PrincipalType** *(string) --*

      The type of principal.

    - **Principal** *(string) --*

      The Amazon Resource Name (ARN) of the principal.
    """


_DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef",
    {
        "AllowedPrincipals": List[
            DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicePermissionsPaginate` `Response`

    - **AllowedPrincipals** *(list) --*

      Information about one or more allowed principals.

      - *(dict) --*

        Describes a principal.

        - **PrincipalType** *(string) --*

          The type of principal.

        - **Principal** *(string) --*

          The Amazon Resource Name (ARN) of the principal.
    """


_DescribeVpcEndpointServicesPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServicesPaginateFiltersTypeDef(
    _DescribeVpcEndpointServicesPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef",
    {"ServiceType": str},
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginateResponseServiceDetails` `ServiceType`

    Describes the type of service for a VPC endpoint.

    - **ServiceType** *(string) --*

      The type of service.
    """


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginateResponseServiceDetails` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef",
    {
        "ServiceName": str,
        "ServiceId": str,
        "ServiceType": List[
            DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef
        ],
        "AvailabilityZones": List[str],
        "Owner": str,
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "VpcEndpointPolicySupported": bool,
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "Tags": List[
            DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginateResponse` `ServiceDetails`

    Describes a VPC endpoint service.

    - **ServiceName** *(string) --*

      The Amazon Resource Name (ARN) of the service.

    - **ServiceId** *(string) --*

      The ID of the endpoint service.

    - **ServiceType** *(list) --*

      The type of service.

      - *(dict) --*

        Describes the type of service for a VPC endpoint.

        - **ServiceType** *(string) --*

          The type of service.

    - **AvailabilityZones** *(list) --*

      The Availability Zones in which the service is available.

      - *(string) --*

    - **Owner** *(string) --*

      The AWS account ID of the service owner.

    - **BaseEndpointDnsNames** *(list) --*

      The DNS names for the service.

      - *(string) --*

    - **PrivateDnsName** *(string) --*

      The private DNS name for the service.

    - **VpcEndpointPolicySupported** *(boolean) --*

      Indicates whether the service supports endpoint policies.

    - **AcceptanceRequired** *(boolean) --*

      Indicates whether VPC endpoint connection requests to the service must be accepted by the
      service owner.

    - **ManagesVpcEndpoints** *(boolean) --*

      Indicates whether the service manages it's VPC endpoints. Management of the service VPC
      endpoints using the VPC endpoint API is restricted.

    - **Tags** *(list) --*

      Any tags assigned to the service.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeVpcEndpointServicesPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseTypeDef",
    {
        "ServiceNames": List[str],
        "ServiceDetails": List[
            DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef
        ],
    },
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointServicesPaginate` `Response`

    Contains the output of DescribeVpcEndpointServices.

    - **ServiceNames** *(list) --*

      A list of supported services.

      - *(string) --*

    - **ServiceDetails** *(list) --*

      Information about the service.

      - *(dict) --*

        Describes a VPC endpoint service.

        - **ServiceName** *(string) --*

          The Amazon Resource Name (ARN) of the service.

        - **ServiceId** *(string) --*

          The ID of the endpoint service.

        - **ServiceType** *(list) --*

          The type of service.

          - *(dict) --*

            Describes the type of service for a VPC endpoint.

            - **ServiceType** *(string) --*

              The type of service.

        - **AvailabilityZones** *(list) --*

          The Availability Zones in which the service is available.

          - *(string) --*

        - **Owner** *(string) --*

          The AWS account ID of the service owner.

        - **BaseEndpointDnsNames** *(list) --*

          The DNS names for the service.

          - *(string) --*

        - **PrivateDnsName** *(string) --*

          The private DNS name for the service.

        - **VpcEndpointPolicySupported** *(boolean) --*

          Indicates whether the service supports endpoint policies.

        - **AcceptanceRequired** *(boolean) --*

          Indicates whether VPC endpoint connection requests to the service must be accepted by the
          service owner.

        - **ManagesVpcEndpoints** *(boolean) --*

          Indicates whether the service manages it's VPC endpoints. Management of the service VPC
          endpoints using the VPC endpoint API is restricted.

        - **Tags** *(list) --*

          Any tags assigned to the service.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DescribeVpcEndpointsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointsPaginateFiltersTypeDef(
    _DescribeVpcEndpointsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcEndpointsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginateResponseVpcEndpoints` `DnsEntries`

    Describes a DNS entry.

    - **DnsName** *(string) --*

      The DNS name.

    - **HostedZoneId** *(string) --*

      The ID of the private hosted zone.
    """


_DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginateResponseVpcEndpoints` `Groups`

    Describes a security group.

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group.
    """


_DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginateResponseVpcEndpoints` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": str,
        "VpcId": str,
        "ServiceName": str,
        "State": str,
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[
            DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef
        ],
        "CreationTimestamp": datetime,
        "Tags": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginateResponse` `VpcEndpoints`

    Describes a VPC endpoint.

    - **VpcEndpointId** *(string) --*

      The ID of the VPC endpoint.

    - **VpcEndpointType** *(string) --*

      The type of endpoint.

    - **VpcId** *(string) --*

      The ID of the VPC to which the endpoint is associated.

    - **ServiceName** *(string) --*

      The name of the service to which the endpoint is associated.

    - **State** *(string) --*

      The state of the VPC endpoint.

    - **PolicyDocument** *(string) --*

      The policy document associated with the endpoint, if applicable.

    - **RouteTableIds** *(list) --*

      (Gateway endpoint) One or more route tables associated with the endpoint.

      - *(string) --*

    - **SubnetIds** *(list) --*

      (Interface endpoint) One or more subnets in which the endpoint is located.

      - *(string) --*

    - **Groups** *(list) --*

      (Interface endpoint) Information about the security groups associated with the network
      interface.

      - *(dict) --*

        Describes a security group.

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group.

    - **PrivateDnsEnabled** *(boolean) --*

      (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

    - **RequesterManaged** *(boolean) --*

      Indicates whether the VPC endpoint is being managed by its service.

    - **NetworkInterfaceIds** *(list) --*

      (Interface endpoint) One or more network interfaces for the endpoint.

      - *(string) --*

    - **DnsEntries** *(list) --*

      (Interface endpoint) The DNS entries for the endpoint.

      - *(dict) --*

        Describes a DNS entry.

        - **DnsName** *(string) --*

          The DNS name.

        - **HostedZoneId** *(string) --*

          The ID of the private hosted zone.

    - **CreationTimestamp** *(datetime) --*

      The date and time the VPC endpoint was created.

    - **Tags** *(list) --*

      Any tags assigned to the VPC endpoint.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC endpoint.
    """


_DescribeVpcEndpointsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseTypeDef",
    {"VpcEndpoints": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef]},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseTypeDef(
    _DescribeVpcEndpointsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcEndpointsPaginate` `Response`

    Contains the output of DescribeVpcEndpoints.

    - **VpcEndpoints** *(list) --*

      Information about the endpoints.

      - *(dict) --*

        Describes a VPC endpoint.

        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.

        - **VpcEndpointType** *(string) --*

          The type of endpoint.

        - **VpcId** *(string) --*

          The ID of the VPC to which the endpoint is associated.

        - **ServiceName** *(string) --*

          The name of the service to which the endpoint is associated.

        - **State** *(string) --*

          The state of the VPC endpoint.

        - **PolicyDocument** *(string) --*

          The policy document associated with the endpoint, if applicable.

        - **RouteTableIds** *(list) --*

          (Gateway endpoint) One or more route tables associated with the endpoint.

          - *(string) --*

        - **SubnetIds** *(list) --*

          (Interface endpoint) One or more subnets in which the endpoint is located.

          - *(string) --*

        - **Groups** *(list) --*

          (Interface endpoint) Information about the security groups associated with the network
          interface.

          - *(dict) --*

            Describes a security group.

            - **GroupId** *(string) --*

              The ID of the security group.

            - **GroupName** *(string) --*

              The name of the security group.

        - **PrivateDnsEnabled** *(boolean) --*

          (Interface endpoint) Indicates whether the VPC is associated with a private hosted zone.

        - **RequesterManaged** *(boolean) --*

          Indicates whether the VPC endpoint is being managed by its service.

        - **NetworkInterfaceIds** *(list) --*

          (Interface endpoint) One or more network interfaces for the endpoint.

          - *(string) --*

        - **DnsEntries** *(list) --*

          (Interface endpoint) The DNS entries for the endpoint.

          - *(dict) --*

            Describes a DNS entry.

            - **DnsName** *(string) --*

              The DNS name.

            - **HostedZoneId** *(string) --*

              The ID of the private hosted zone.

        - **CreationTimestamp** *(datetime) --*

          The date and time the VPC endpoint was created.

        - **Tags** *(list) --*

          Any tags assigned to the VPC endpoint.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the VPC endpoint.
    """


_DescribeVpcPeeringConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateFiltersTypeDef(
    _DescribeVpcPeeringConnectionsPaginateFiltersTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef(
    _DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP
      addresses when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC
      over the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the
      peer VPC over the VPC peering connection.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnections` `AccepterVpcInfo`

    Information about the accepter VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP
        addresses when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC
        over the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the
        peer VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP
      addresses when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC
      over the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the
      peer VPC over the VPC peering connection.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnections` `RequesterVpcInfo`

    Information about the requester VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP
        addresses when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC
        over the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the
        peer VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnections` `Status`

    The status of the VPC peering connection.

    - **Code** *(string) --*

      The status of the VPC peering connection.

    - **Message** *(string) --*

      A message that provides more information about the status, if applicable.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnections` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef",
    {
        "AccepterVpcInfo": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef,
        "Status": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef,
        "Tags": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef
        ],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginateResponse` `VpcPeeringConnections`

    Describes a VPC peering connection.

    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP
          addresses when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC
          over the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the
          peer VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **ExpirationTime** *(datetime) --*

      The time that an unaccepted VPC peering connection will expire.

    - **RequesterVpcInfo** *(dict) --*

      Information about the requester VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP
          addresses when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC
          over the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the
          peer VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **Status** *(dict) --*

      The status of the VPC peering connection.

      - **Code** *(string) --*

        The status of the VPC peering connection.

      - **Message** *(string) --*

        A message that provides more information about the status, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_DescribeVpcPeeringConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseTypeDef",
    {
        "VpcPeeringConnections": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseTypeDef
):
    """
    Type definition for `DescribeVpcPeeringConnectionsPaginate` `Response`

    - **VpcPeeringConnections** *(list) --*

      Information about the VPC peering connections.

      - *(dict) --*

        Describes a VPC peering connection.

        - **AccepterVpcInfo** *(dict) --*

          Information about the accepter VPC. CIDR block information is only returned when
          describing an active VPC peering connection.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.

          - **Ipv6CidrBlockSet** *(list) --*

            The IPv6 CIDR block for the VPC.

            - *(dict) --*

              Describes an IPv6 CIDR block.

              - **Ipv6CidrBlock** *(string) --*

                The IPv6 CIDR block.

          - **CidrBlockSet** *(list) --*

            Information about the IPv4 CIDR blocks for the VPC.

            - *(dict) --*

              Describes an IPv4 CIDR block.

              - **CidrBlock** *(string) --*

                The IPv4 CIDR block.

          - **OwnerId** *(string) --*

            The AWS account ID of the VPC owner.

          - **PeeringOptions** *(dict) --*

            Information about the VPC peering connection options for the accepter or requester VPC.

            - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

              Indicates whether a local VPC can resolve public DNS hostnames to private IP
              addresses when queried from instances in a peer VPC.

            - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

              Indicates whether a local ClassicLink connection can communicate with the peer VPC
              over the VPC peering connection.

            - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

              Indicates whether a local VPC can communicate with a ClassicLink connection in the
              peer VPC over the VPC peering connection.

          - **VpcId** *(string) --*

            The ID of the VPC.

          - **Region** *(string) --*

            The Region in which the VPC is located.

        - **ExpirationTime** *(datetime) --*

          The time that an unaccepted VPC peering connection will expire.

        - **RequesterVpcInfo** *(dict) --*

          Information about the requester VPC. CIDR block information is only returned when
          describing an active VPC peering connection.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.

          - **Ipv6CidrBlockSet** *(list) --*

            The IPv6 CIDR block for the VPC.

            - *(dict) --*

              Describes an IPv6 CIDR block.

              - **Ipv6CidrBlock** *(string) --*

                The IPv6 CIDR block.

          - **CidrBlockSet** *(list) --*

            Information about the IPv4 CIDR blocks for the VPC.

            - *(dict) --*

              Describes an IPv4 CIDR block.

              - **CidrBlock** *(string) --*

                The IPv4 CIDR block.

          - **OwnerId** *(string) --*

            The AWS account ID of the VPC owner.

          - **PeeringOptions** *(dict) --*

            Information about the VPC peering connection options for the accepter or requester VPC.

            - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

              Indicates whether a local VPC can resolve public DNS hostnames to private IP
              addresses when queried from instances in a peer VPC.

            - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

              Indicates whether a local ClassicLink connection can communicate with the peer VPC
              over the VPC peering connection.

            - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

              Indicates whether a local VPC can communicate with a ClassicLink connection in the
              peer VPC over the VPC peering connection.

          - **VpcId** *(string) --*

            The ID of the VPC.

          - **Region** *(string) --*

            The Region in which the VPC is located.

        - **Status** *(dict) --*

          The status of the VPC peering connection.

          - **Code** *(string) --*

            The status of the VPC peering connection.

          - **Message** *(string) --*

            A message that provides more information about the status, if applicable.

        - **Tags** *(list) --*

          Any tags assigned to the resource.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection.
    """


_DescribeVpcsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcsPaginateFiltersTypeDef(_DescribeVpcsPaginateFiltersTypeDef):
    """
    Type definition for `DescribeVpcsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_DescribeVpcsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcsPaginatePaginationConfigTypeDef(
    _DescribeVpcsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeVpcsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef(
    _DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef
):
    """
    Type definition for `DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSet` `CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef(
    _DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef
):
    """
    Type definition for `DescribeVpcsPaginateResponseVpcs` `CidrBlockAssociationSet`

    Describes an IPv4 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.

    - **CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {"State": str, "StatusMessage": str},
    total=False,
)


class DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    """
    Type definition for `DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSet` `Ipv6CidrBlockState`

    Information about the state of the CIDR block.

    - **State** *(string) --*

      The state of the CIDR block.

    - **StatusMessage** *(string) --*

      A message about the status of the CIDR block, if applicable.
    """


_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef(
    _DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef
):
    """
    Type definition for `DescribeVpcsPaginateResponseVpcs` `Ipv6CidrBlockAssociationSet`

    Describes an IPv6 CIDR block associated with a VPC.

    - **AssociationId** *(string) --*

      The association ID for the IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.

    - **Ipv6CidrBlockState** *(dict) --*

      Information about the state of the CIDR block.

      - **State** *(string) --*

        The state of the CIDR block.

      - **StatusMessage** *(string) --*

        A message about the status of the CIDR block, if applicable.
    """


_DescribeVpcsPaginateResponseVpcsTagsTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcsPaginateResponseVpcsTagsTypeDef(
    _DescribeVpcsPaginateResponseVpcsTagsTypeDef
):
    """
    Type definition for `DescribeVpcsPaginateResponseVpcs` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_DescribeVpcsPaginateResponseVpcsTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": str,
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": str,
        "Ipv6CidrBlockAssociationSet": List[
            DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[DescribeVpcsPaginateResponseVpcsTagsTypeDef],
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsTypeDef(_DescribeVpcsPaginateResponseVpcsTypeDef):
    """
    Type definition for `DescribeVpcsPaginateResponse` `Vpcs`

    Describes a VPC.

    - **CidrBlock** *(string) --*

      The primary IPv4 CIDR block for the VPC.

    - **DhcpOptionsId** *(string) --*

      The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
      default options are associated with the VPC).

    - **State** *(string) --*

      The current state of the VPC.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **OwnerId** *(string) --*

      The ID of the AWS account that owns the VPC.

    - **InstanceTenancy** *(string) --*

      The allowed tenancy of instances launched into the VPC.

    - **Ipv6CidrBlockAssociationSet** *(list) --*

      Information about the IPv6 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

        - **Ipv6CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **CidrBlockAssociationSet** *(list) --*

      Information about the IPv4 CIDR blocks associated with the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block associated with a VPC.

        - **AssociationId** *(string) --*

          The association ID for the IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

        - **CidrBlockState** *(dict) --*

          Information about the state of the CIDR block.

          - **State** *(string) --*

            The state of the CIDR block.

          - **StatusMessage** *(string) --*

            A message about the status of the CIDR block, if applicable.

    - **IsDefault** *(boolean) --*

      Indicates whether the VPC is the default VPC.

    - **Tags** *(list) --*

      Any tags assigned to the VPC.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.
    """


_DescribeVpcsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseTypeDef",
    {"Vpcs": List[DescribeVpcsPaginateResponseVpcsTypeDef]},
    total=False,
)


class DescribeVpcsPaginateResponseTypeDef(_DescribeVpcsPaginateResponseTypeDef):
    """
    Type definition for `DescribeVpcsPaginate` `Response`

    - **Vpcs** *(list) --*

      Information about one or more VPCs.

      - *(dict) --*

        Describes a VPC.

        - **CidrBlock** *(string) --*

          The primary IPv4 CIDR block for the VPC.

        - **DhcpOptionsId** *(string) --*

          The ID of the set of DHCP options you've associated with the VPC (or ``default`` if the
          default options are associated with the VPC).

        - **State** *(string) --*

          The current state of the VPC.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **OwnerId** *(string) --*

          The ID of the AWS account that owns the VPC.

        - **InstanceTenancy** *(string) --*

          The allowed tenancy of instances launched into the VPC.

        - **Ipv6CidrBlockAssociationSet** *(list) --*

          Information about the IPv6 CIDR blocks associated with the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block associated with a VPC.

            - **AssociationId** *(string) --*

              The association ID for the IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

            - **Ipv6CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of the CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **CidrBlockAssociationSet** *(list) --*

          Information about the IPv4 CIDR blocks associated with the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block associated with a VPC.

            - **AssociationId** *(string) --*

              The association ID for the IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

            - **CidrBlockState** *(dict) --*

              Information about the state of the CIDR block.

              - **State** *(string) --*

                The state of the CIDR block.

              - **StatusMessage** *(string) --*

                A message about the status of the CIDR block, if applicable.

        - **IsDefault** *(boolean) --*

          Indicates whether the VPC is the default VPC.

        - **Tags** *(list) --*

          Any tags assigned to the VPC.

          - *(dict) --*

            Describes a tag.

            - **Key** *(string) --*

              The key of the tag.

              Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
              characters. May not begin with ``aws:`` .

            - **Value** *(string) --*

              The value of the tag.

              Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
              characters.
    """


_DhcpOptionsCreateTagsTagsTypeDef = TypedDict(
    "_DhcpOptionsCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DhcpOptionsCreateTagsTagsTypeDef(_DhcpOptionsCreateTagsTagsTypeDef):
    """
    Type definition for `DhcpOptionsCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_DhcpOptionsSetsFilterFiltersTypeDef = TypedDict(
    "_DhcpOptionsSetsFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DhcpOptionsSetsFilterFiltersTypeDef(_DhcpOptionsSetsFilterFiltersTypeDef):
    """
    Type definition for `DhcpOptionsSetsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ExportTaskCancelledWaitWaiterConfigTypeDef = TypedDict(
    "_ExportTaskCancelledWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ExportTaskCancelledWaitWaiterConfigTypeDef(
    _ExportTaskCancelledWaitWaiterConfigTypeDef
):
    """
    Type definition for `ExportTaskCancelledWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ExportTaskCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_ExportTaskCompletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ExportTaskCompletedWaitWaiterConfigTypeDef(
    _ExportTaskCompletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `ExportTaskCompletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef
):
    """
    Type definition for `GetTransitGatewayAttachmentPropagationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `GetTransitGatewayAttachmentPropagationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef",
    {"TransitGatewayRouteTableId": str, "State": str},
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef
):
    """
    Type definition for `GetTransitGatewayAttachmentPropagationsPaginateResponse` `TransitGatewayAttachmentPropagations`

    Describes a propagation route table.

    - **TransitGatewayRouteTableId** *(string) --*

      The ID of the propagation route table.

    - **State** *(string) --*

      The state of the propagation route table.
    """


_GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef",
    {
        "TransitGatewayAttachmentPropagations": List[
            GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef
):
    """
    Type definition for `GetTransitGatewayAttachmentPropagationsPaginate` `Response`

    - **TransitGatewayAttachmentPropagations** *(list) --*

      Information about the propagation route tables.

      - *(dict) --*

        Describes a propagation route table.

        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the propagation route table.

        - **State** *(string) --*

          The state of the propagation route table.
    """


_GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTableAssociationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTableAssociationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTableAssociationsPaginateResponse` `Associations`

    Describes an association between a route table and a resource attachment.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The resource type.

    - **State** *(string) --*

      The state of the association.
    """


_GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef",
    {
        "Associations": List[
            GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTableAssociationsPaginate` `Response`

    - **Associations** *(list) --*

      Information about the associations.

      - *(dict) --*

        Describes an association between a route table and a resource attachment.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The resource type.

        - **State** *(string) --*

          The state of the association.
    """


_GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTablePropagationsPaginate` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTablePropagationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
        "State": str,
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTablePropagationsPaginateResponse` `TransitGatewayRouteTablePropagations`

    Describes a route table propagation.

    - **TransitGatewayAttachmentId** *(string) --*

      The ID of the attachment.

    - **ResourceId** *(string) --*

      The ID of the resource.

    - **ResourceType** *(string) --*

      The type of resource.

    - **State** *(string) --*

      The state of the resource.
    """


_GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef",
    {
        "TransitGatewayRouteTablePropagations": List[
            GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef
):
    """
    Type definition for `GetTransitGatewayRouteTablePropagationsPaginate` `Response`

    - **TransitGatewayRouteTablePropagations** *(list) --*

      Information about the route table propagations.

      - *(dict) --*

        Describes a route table propagation.

        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.

        - **ResourceId** *(string) --*

          The ID of the resource.

        - **ResourceType** *(string) --*

          The type of resource.

        - **State** *(string) --*

          The state of the resource.
    """


_ImageAvailableWaitFiltersTypeDef = TypedDict(
    "_ImageAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImageAvailableWaitFiltersTypeDef(_ImageAvailableWaitFiltersTypeDef):
    """
    Type definition for `ImageAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ImageAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_ImageAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ImageAvailableWaitWaiterConfigTypeDef(_ImageAvailableWaitWaiterConfigTypeDef):
    """
    Type definition for `ImageAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ImageCreateTagsTagsTypeDef = TypedDict(
    "_ImageCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ImageCreateTagsTagsTypeDef(_ImageCreateTagsTagsTypeDef):
    """
    Type definition for `ImageCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponseBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more
      information, see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see
      `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
      ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
      `Nitro-based instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more
      information, see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
      *Amazon Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size,
      the default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
      SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
      HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
      snapshot, the volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
      the volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends
      on the volume origin (new or from a snapshot), starting encryption state, ownership,
      and whether encryption by default is enabled. For more information, see `Amazon EBS
      Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
      For more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
      which the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by
      `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
      and `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
      .
    """


_ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef(
    _ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
      from 0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
      depends on the instance type. After you connect to the instance, you must mount the
      volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block
      device mapping for the instance. When you launch an M3 instance, we ignore any instance
      store volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more
        information, see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see
        `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
        ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
        `Nitro-based instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more
        information, see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size,
        the default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
        SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
        HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
        snapshot, the volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
        the volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends
        on the volume origin (new or from a snapshot), starting encryption state, ownership,
        and whether encryption by default is enabled. For more information, see `Amazon EBS
        Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
        For more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
        which the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by
        `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
        and `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
        .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ImageDescribeAttributeResponseDescriptionTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseDescriptionTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseDescriptionTypeDef(
    _ImageDescribeAttributeResponseDescriptionTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `Description`

    A description for the AMI.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageDescribeAttributeResponseKernelIdTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseKernelIdTypeDef(
    _ImageDescribeAttributeResponseKernelIdTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `KernelId`

    The kernel ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageDescribeAttributeResponseLaunchPermissionsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseLaunchPermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ImageDescribeAttributeResponseLaunchPermissionsTypeDef(
    _ImageDescribeAttributeResponseLaunchPermissionsTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `LaunchPermissions`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ImageDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class ImageDescribeAttributeResponseProductCodesTypeDef(
    _ImageDescribeAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_ImageDescribeAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseRamdiskIdTypeDef(
    _ImageDescribeAttributeResponseRamdiskIdTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `RamdiskId`

    The RAM disk ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageDescribeAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseSriovNetSupportTypeDef(
    _ImageDescribeAttributeResponseSriovNetSupportTypeDef
):
    """
    Type definition for `ImageDescribeAttributeResponse` `SriovNetSupport`

    Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
    enabled.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageDescribeAttributeResponseTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseTypeDef",
    {
        "BlockDeviceMappings": List[
            ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef
        ],
        "ImageId": str,
        "LaunchPermissions": List[
            ImageDescribeAttributeResponseLaunchPermissionsTypeDef
        ],
        "ProductCodes": List[ImageDescribeAttributeResponseProductCodesTypeDef],
        "Description": ImageDescribeAttributeResponseDescriptionTypeDef,
        "KernelId": ImageDescribeAttributeResponseKernelIdTypeDef,
        "RamdiskId": ImageDescribeAttributeResponseRamdiskIdTypeDef,
        "SriovNetSupport": ImageDescribeAttributeResponseSriovNetSupportTypeDef,
    },
    total=False,
)


class ImageDescribeAttributeResponseTypeDef(_ImageDescribeAttributeResponseTypeDef):
    """
    Type definition for `ImageDescribeAttribute` `Response`

    Describes an image attribute.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping entries.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **VirtualName** *(string) --*

          The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting
          from 0. An instance type with 2 available instance store volumes can specify mappings for
          ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes
          depends on the instance type. After you connect to the instance, you must mount the
          volume.

          NVMe instance store volumes are automatically enumerated and assigned a device name.
          Including them in your block device mapping has no effect.

          Constraints: For M3 instances, you must specify instance store volumes in the block
          device mapping for the instance. When you launch an M3 instance, we ignore any instance
          store volumes specified in the block device mapping for the AMI.

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the EBS volume is deleted on instance termination. For more
            information, see `Preserving Amazon EBS Volumes on Instance Termination
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
            in the Amazon Elastic Compute Cloud User Guide.

          - **Iops** *(integer) --*

            The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
            volumes, this represents the number of IOPS that are provisioned for the volume. For
            ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
            which the volume accumulates I/O credits for bursting. For more information, see
            `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for
            ``io1`` volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on
            `Nitro-based instances
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
            . Other instance families guarantee performance up to 32,000 IOPS. For more
            information, see `Amazon EBS Volume Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .

            Condition: This parameter is required for requests to create ``io1`` volumes; it is not
            used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

          - **SnapshotId** *(string) --*

            The ID of the snapshot.

          - **VolumeSize** *(integer) --*

            The size of the volume, in GiB.

            Default: If you're creating the volume from a snapshot and don't specify a volume size,
            the default is the snapshot size.

            Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS
            SSD (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold
            HDD (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a
            snapshot, the volume size must be equal to or larger than the snapshot size.

          - **VolumeType** *(string) --*

            The volume type. If you set the type to ``io1`` , you must also specify the IOPS that
            the volume supports.

            Default: ``gp2``

          - **Encrypted** *(boolean) --*

            Indicates whether the encryption state of an EBS volume is changed while being restored
            from a backing snapshot. The effect of setting the encryption state to ``true`` depends
            on the volume origin (new or from a snapshot), starting encryption state, ownership,
            and whether encryption by default is enabled. For more information, see `Amazon EBS
            Encryption
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
            in the *Amazon Elastic Compute Cloud User Guide* .

            In no case can you remove encryption from an encrypted volume.

            Encrypted volumes can only be attached to instances that support Amazon EBS encryption.
            For more information, see `Supported Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
            .

          - **KmsKeyId** *(string) --*

            Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under
            which the EBS volume is encrypted.

            This parameter is only supported on ``BlockDeviceMapping`` objects called by
            `RunInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
            `RequestSpotFleet
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ ,
            and `RequestSpotInstances
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__
            .

        - **NoDevice** *(string) --*

          Suppresses the specified device included in the block device mapping of the AMI.

    - **ImageId** *(string) --*

      The ID of the AMI.

    - **LaunchPermissions** *(list) --*

      The launch permissions.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **Description** *(dict) --*

      A description for the AMI.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **KernelId** *(dict) --*

      The kernel ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **RamdiskId** *(dict) --*

      The RAM disk ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **SriovNetSupport** *(dict) --*

      Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.
    """


_ImageExistsWaitFiltersTypeDef = TypedDict(
    "_ImageExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImageExistsWaitFiltersTypeDef(_ImageExistsWaitFiltersTypeDef):
    """
    Type definition for `ImageExistsWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ImageExistsWaitWaiterConfigTypeDef = TypedDict(
    "_ImageExistsWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ImageExistsWaitWaiterConfigTypeDef(_ImageExistsWaitWaiterConfigTypeDef):
    """
    Type definition for `ImageExistsWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_ImageModifyAttributeDescriptionTypeDef = TypedDict(
    "_ImageModifyAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class ImageModifyAttributeDescriptionTypeDef(_ImageModifyAttributeDescriptionTypeDef):
    """
    Type definition for `ImageModifyAttribute` `Description`

    A new description for the AMI.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageModifyAttributeLaunchPermissionAddTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ImageModifyAttributeLaunchPermissionAddTypeDef(
    _ImageModifyAttributeLaunchPermissionAddTypeDef
):
    """
    Type definition for `ImageModifyAttributeLaunchPermission` `Add`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ImageModifyAttributeLaunchPermissionRemoveTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ImageModifyAttributeLaunchPermissionRemoveTypeDef(
    _ImageModifyAttributeLaunchPermissionRemoveTypeDef
):
    """
    Type definition for `ImageModifyAttributeLaunchPermission` `Remove`

    Describes a launch permission.

    - **Group** *(string) --*

      The name of the group.

    - **UserId** *(string) --*

      The AWS account ID.
    """


_ImageModifyAttributeLaunchPermissionTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionTypeDef",
    {
        "Add": List[ImageModifyAttributeLaunchPermissionAddTypeDef],
        "Remove": List[ImageModifyAttributeLaunchPermissionRemoveTypeDef],
    },
    total=False,
)


class ImageModifyAttributeLaunchPermissionTypeDef(
    _ImageModifyAttributeLaunchPermissionTypeDef
):
    """
    Type definition for `ImageModifyAttribute` `LaunchPermission`

    A new launch permission for the AMI.

    - **Add** *(list) --*

      The AWS account ID to add to the list of launch permissions for the AMI.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.

    - **Remove** *(list) --*

      The AWS account ID to remove from the list of launch permissions for the AMI.

      - *(dict) --*

        Describes a launch permission.

        - **Group** *(string) --*

          The name of the group.

        - **UserId** *(string) --*

          The AWS account ID.
    """


_ImageWaitUntilExistsFiltersTypeDef = TypedDict(
    "_ImageWaitUntilExistsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ImageWaitUntilExistsFiltersTypeDef(_ImageWaitUntilExistsFiltersTypeDef):
    """
    Type definition for `ImageWaitUntilExists` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ImagesFilterFiltersTypeDef = TypedDict(
    "_ImagesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImagesFilterFiltersTypeDef(_ImagesFilterFiltersTypeDef):
    """
    Type definition for `ImagesFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceAttachClassicLinkVpcResponseTypeDef = TypedDict(
    "_InstanceAttachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class InstanceAttachClassicLinkVpcResponseTypeDef(
    _InstanceAttachClassicLinkVpcResponseTypeDef
):
    """
    Type definition for `InstanceAttachClassicLinkVpc` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_InstanceAttachVolumeResponseTypeDef = TypedDict(
    "_InstanceAttachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class InstanceAttachVolumeResponseTypeDef(_InstanceAttachVolumeResponseTypeDef):
    """
    Type definition for `InstanceAttachVolume` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_InstanceConsoleOutputResponseTypeDef = TypedDict(
    "_InstanceConsoleOutputResponseTypeDef",
    {"InstanceId": str, "Output": str, "Timestamp": datetime},
    total=False,
)


class InstanceConsoleOutputResponseTypeDef(_InstanceConsoleOutputResponseTypeDef):
    """
    Type definition for `InstanceConsoleOutput` `Response`

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Output** *(string) --*

      The console output, base64-encoded. If you are using a command line tool, the tool decodes
      the output for you.

    - **Timestamp** *(datetime) --*

      The time at which the output was last updated.
    """


_InstanceCreateImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceCreateImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class InstanceCreateImageBlockDeviceMappingsEbsTypeDef(
    _InstanceCreateImageBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `InstanceCreateImageBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_InstanceCreateImageBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceCreateImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": InstanceCreateImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class InstanceCreateImageBlockDeviceMappingsTypeDef(
    _InstanceCreateImageBlockDeviceMappingsTypeDef
):
    """
    Type definition for `InstanceCreateImage` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_InstanceCreateTagsTagsTypeDef = TypedDict(
    "_InstanceCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstanceCreateTagsTagsTypeDef(_InstanceCreateTagsTagsTypeDef):
    """
    Type definition for `InstanceCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_InstanceDeleteTagsTagsTypeDef = TypedDict(
    "_InstanceDeleteTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstanceDeleteTagsTagsTypeDef(_InstanceDeleteTagsTagsTypeDef):
    """
    Type definition for `InstanceDeleteTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": str,
        "VolumeId": str,
    },
    total=False,
)


class InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponseBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **Status** *(string) --*

      The attachment state.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef(
    _InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **Status** *(string) --*

        The attachment state.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.
    """


_InstanceDescribeAttributeResponseDisableApiTerminationTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseDisableApiTerminationTypeDef",
    {"Value": bool},
    total=False,
)


class InstanceDescribeAttributeResponseDisableApiTerminationTypeDef(
    _InstanceDescribeAttributeResponseDisableApiTerminationTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `DisableApiTermination`

    If the value is ``true`` , you can't terminate the instance through the Amazon EC2 console,
    CLI, or API; otherwise, you can.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceDescribeAttributeResponseEbsOptimizedTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseEbsOptimizedTypeDef",
    {"Value": bool},
    total=False,
)


class InstanceDescribeAttributeResponseEbsOptimizedTypeDef(
    _InstanceDescribeAttributeResponseEbsOptimizedTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `EbsOptimized`

    Indicates whether the instance is optimized for Amazon EBS I/O.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceDescribeAttributeResponseEnaSupportTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseEnaSupportTypeDef", {"Value": bool}, total=False
)


class InstanceDescribeAttributeResponseEnaSupportTypeDef(
    _InstanceDescribeAttributeResponseEnaSupportTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `EnaSupport`

    Indicates whether enhanced networking with ENA is enabled.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceDescribeAttributeResponseGroupsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class InstanceDescribeAttributeResponseGroupsTypeDef(
    _InstanceDescribeAttributeResponseGroupsTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef(
    _InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `InstanceInitiatedShutdownBehavior`

    Indicates whether an instance stops or terminates when you initiate shutdown from the
    instance (using the operating system command for system shutdown).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseInstanceTypeTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseInstanceTypeTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseInstanceTypeTypeDef(
    _InstanceDescribeAttributeResponseInstanceTypeTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `InstanceType`

    The instance type.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseKernelIdTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseKernelIdTypeDef(
    _InstanceDescribeAttributeResponseKernelIdTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `KernelId`

    The kernel ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class InstanceDescribeAttributeResponseProductCodesTypeDef(
    _InstanceDescribeAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_InstanceDescribeAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseRamdiskIdTypeDef(
    _InstanceDescribeAttributeResponseRamdiskIdTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `RamdiskId`

    The RAM disk ID.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseRootDeviceNameTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseRootDeviceNameTypeDef",
    {"Value": str},
    total=False,
)


class InstanceDescribeAttributeResponseRootDeviceNameTypeDef(
    _InstanceDescribeAttributeResponseRootDeviceNameTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `RootDeviceName`

    The device name of the root device volume (for example, ``/dev/sda1`` ).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class InstanceDescribeAttributeResponseSourceDestCheckTypeDef(
    _InstanceDescribeAttributeResponseSourceDestCheckTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `SourceDestCheck`

    Indicates whether source/destination checking is enabled. A value of ``true`` means that
    checking is enabled, and ``false`` means that checking is disabled. This value must be
    ``false`` for a NAT instance to perform NAT.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceDescribeAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseSriovNetSupportTypeDef",
    {"Value": str},
    total=False,
)


class InstanceDescribeAttributeResponseSriovNetSupportTypeDef(
    _InstanceDescribeAttributeResponseSriovNetSupportTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `SriovNetSupport`

    Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
    enabled.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseUserDataTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseUserDataTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseUserDataTypeDef(
    _InstanceDescribeAttributeResponseUserDataTypeDef
):
    """
    Type definition for `InstanceDescribeAttributeResponse` `UserData`

    The user data.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceDescribeAttributeResponseTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseTypeDef",
    {
        "Groups": List[InstanceDescribeAttributeResponseGroupsTypeDef],
        "BlockDeviceMappings": List[
            InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef
        ],
        "DisableApiTermination": InstanceDescribeAttributeResponseDisableApiTerminationTypeDef,
        "EnaSupport": InstanceDescribeAttributeResponseEnaSupportTypeDef,
        "EbsOptimized": InstanceDescribeAttributeResponseEbsOptimizedTypeDef,
        "InstanceId": str,
        "InstanceInitiatedShutdownBehavior": InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef,
        "InstanceType": InstanceDescribeAttributeResponseInstanceTypeTypeDef,
        "KernelId": InstanceDescribeAttributeResponseKernelIdTypeDef,
        "ProductCodes": List[InstanceDescribeAttributeResponseProductCodesTypeDef],
        "RamdiskId": InstanceDescribeAttributeResponseRamdiskIdTypeDef,
        "RootDeviceName": InstanceDescribeAttributeResponseRootDeviceNameTypeDef,
        "SourceDestCheck": InstanceDescribeAttributeResponseSourceDestCheckTypeDef,
        "SriovNetSupport": InstanceDescribeAttributeResponseSriovNetSupportTypeDef,
        "UserData": InstanceDescribeAttributeResponseUserDataTypeDef,
    },
    total=False,
)


class InstanceDescribeAttributeResponseTypeDef(
    _InstanceDescribeAttributeResponseTypeDef
):
    """
    Type definition for `InstanceDescribeAttribute` `Response`

    Describes an instance attribute.

    - **Groups** *(list) --*

      The security groups associated with the instance.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **BlockDeviceMappings** *(list) --*

      The block device mapping of the instance.

      - *(dict) --*

        Describes a block device mapping.

        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

        - **Ebs** *(dict) --*

          Parameters used to automatically set up EBS volumes when the instance is launched.

          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.

          - **DeleteOnTermination** *(boolean) --*

            Indicates whether the volume is deleted on instance termination.

          - **Status** *(string) --*

            The attachment state.

          - **VolumeId** *(string) --*

            The ID of the EBS volume.

    - **DisableApiTermination** *(dict) --*

      If the value is ``true`` , you can't terminate the instance through the Amazon EC2 console,
      CLI, or API; otherwise, you can.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EnaSupport** *(dict) --*

      Indicates whether enhanced networking with ENA is enabled.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EbsOptimized** *(dict) --*

      Indicates whether the instance is optimized for Amazon EBS I/O.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceInitiatedShutdownBehavior** *(dict) --*

      Indicates whether an instance stops or terminates when you initiate shutdown from the
      instance (using the operating system command for system shutdown).

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **InstanceType** *(dict) --*

      The instance type.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **KernelId** *(dict) --*

      The kernel ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **ProductCodes** *(list) --*

      A list of product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **RamdiskId** *(dict) --*

      The RAM disk ID.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **RootDeviceName** *(dict) --*

      The device name of the root device volume (for example, ``/dev/sda1`` ).

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **SourceDestCheck** *(dict) --*

      Indicates whether source/destination checking is enabled. A value of ``true`` means that
      checking is enabled, and ``false`` means that checking is disabled. This value must be
      ``false`` for a NAT instance to perform NAT.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **SriovNetSupport** *(dict) --*

      Indicates whether enhanced networking with the Intel 82599 Virtual Function interface is
      enabled.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **UserData** *(dict) --*

      The user data.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.
    """


_InstanceDetachClassicLinkVpcResponseTypeDef = TypedDict(
    "_InstanceDetachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class InstanceDetachClassicLinkVpcResponseTypeDef(
    _InstanceDetachClassicLinkVpcResponseTypeDef
):
    """
    Type definition for `InstanceDetachClassicLinkVpc` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_InstanceDetachVolumeResponseTypeDef = TypedDict(
    "_InstanceDetachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class InstanceDetachVolumeResponseTypeDef(_InstanceDetachVolumeResponseTypeDef):
    """
    Type definition for `InstanceDetachVolume` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_InstanceExistsWaitFiltersTypeDef = TypedDict(
    "_InstanceExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceExistsWaitFiltersTypeDef(_InstanceExistsWaitFiltersTypeDef):
    """
    Type definition for `InstanceExistsWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceExistsWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceExistsWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class InstanceExistsWaitWaiterConfigTypeDef(_InstanceExistsWaitWaiterConfigTypeDef):
    """
    Type definition for `InstanceExistsWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 5

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef",
    {"DeleteOnTermination": bool, "VolumeId": str},
    total=False,
)


class InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef(
    _InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `InstanceModifyAttributeBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the volume is deleted on instance termination.

    - **VolumeId** *(string) --*

      The ID of the EBS volume.
    """


_InstanceModifyAttributeBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceModifyAttributeBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class InstanceModifyAttributeBlockDeviceMappingsTypeDef(
    _InstanceModifyAttributeBlockDeviceMappingsTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `BlockDeviceMappings`

    Describes a block device mapping entry.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the volume is deleted on instance termination.

      - **VolumeId** *(string) --*

        The ID of the EBS volume.

    - **NoDevice** *(string) --*

      suppress the specified device included in the block device mapping.

    - **VirtualName** *(string) --*

      The virtual device name.
    """


_InstanceModifyAttributeDisableApiTerminationTypeDef = TypedDict(
    "_InstanceModifyAttributeDisableApiTerminationTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeDisableApiTerminationTypeDef(
    _InstanceModifyAttributeDisableApiTerminationTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `DisableApiTermination`

    If the value is ``true`` , you can't terminate the instance using the Amazon EC2 console, CLI, or
    API; otherwise, you can. You cannot use this parameter for Spot Instances.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeEbsOptimizedTypeDef = TypedDict(
    "_InstanceModifyAttributeEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeEbsOptimizedTypeDef(
    _InstanceModifyAttributeEbsOptimizedTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `EbsOptimized`

    Specifies whether the instance is optimized for Amazon EBS I/O. This optimization provides
    dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS
    I/O performance. This optimization isn't available with all instance types. Additional usage
    charges apply when using an EBS Optimized instance.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeEnaSupportTypeDef = TypedDict(
    "_InstanceModifyAttributeEnaSupportTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeEnaSupportTypeDef(
    _InstanceModifyAttributeEnaSupportTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `EnaSupport`

    Set to ``true`` to enable enhanced networking with ENA for the instance.

    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef(
    _InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `InstanceInitiatedShutdownBehavior`

    Specifies whether an instance stops or terminates when you initiate shutdown from the instance
    (using the operating system command for system shutdown).

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeInstanceTypeTypeDef = TypedDict(
    "_InstanceModifyAttributeInstanceTypeTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeInstanceTypeTypeDef(
    _InstanceModifyAttributeInstanceTypeTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `InstanceType`

    Changes the instance type to the specified value. For more information, see `Instance Types
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ . If the instance
    type is not valid, the error returned is ``InvalidInstanceAttributeValue`` .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeKernelTypeDef = TypedDict(
    "_InstanceModifyAttributeKernelTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeKernelTypeDef(_InstanceModifyAttributeKernelTypeDef):
    """
    Type definition for `InstanceModifyAttribute` `Kernel`

    Changes the instance's kernel to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeRamdiskTypeDef = TypedDict(
    "_InstanceModifyAttributeRamdiskTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeRamdiskTypeDef(_InstanceModifyAttributeRamdiskTypeDef):
    """
    Type definition for `InstanceModifyAttribute` `Ramdisk`

    Changes the instance's RAM disk to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeSourceDestCheckTypeDef = TypedDict(
    "_InstanceModifyAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeSourceDestCheckTypeDef(
    _InstanceModifyAttributeSourceDestCheckTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `SourceDestCheck`

    Specifies whether source/destination checking is enabled. A value of ``true`` means that checking
    is enabled, and ``false`` means that checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeSriovNetSupportTypeDef = TypedDict(
    "_InstanceModifyAttributeSriovNetSupportTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeSriovNetSupportTypeDef(
    _InstanceModifyAttributeSriovNetSupportTypeDef
):
    """
    Type definition for `InstanceModifyAttribute` `SriovNetSupport`

    Set to ``simple`` to enable enhanced networking with the Intel 82599 Virtual Function interface
    for the instance.

    There is no way to disable enhanced networking with the Intel 82599 Virtual Function interface at
    this time.

    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeUserDataTypeDef = TypedDict(
    "_InstanceModifyAttributeUserDataTypeDef", {"Value": bytes}, total=False
)


class InstanceModifyAttributeUserDataTypeDef(_InstanceModifyAttributeUserDataTypeDef):
    """
    Type definition for `InstanceModifyAttribute` `UserData`

    Changes the instance's user data to the specified value. If you are using an AWS SDK or command
    line tool, base64-encoding is performed for you, and you can load the text from a file.
    Otherwise, you must provide base64-encoded text.

    - **Value** *(bytes) --*
    """


_InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `InstanceMonitorResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_InstanceMonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstanceMonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstanceMonitorResponseInstanceMonitoringsTypeDef(
    _InstanceMonitorResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `InstanceMonitorResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_InstanceMonitorResponseTypeDef = TypedDict(
    "_InstanceMonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstanceMonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstanceMonitorResponseTypeDef(_InstanceMonitorResponseTypeDef):
    """
    Type definition for `InstanceMonitor` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_InstancePasswordDataResponseTypeDef = TypedDict(
    "_InstancePasswordDataResponseTypeDef",
    {"InstanceId": str, "PasswordData": str, "Timestamp": datetime},
    total=False,
)


class InstancePasswordDataResponseTypeDef(_InstancePasswordDataResponseTypeDef):
    """
    Type definition for `InstancePasswordData` `Response`

    - **InstanceId** *(string) --*

      The ID of the Windows instance.

    - **PasswordData** *(string) --*

      The password of the instance. Returns an empty string if the password is not available.

    - **Timestamp** *(datetime) --*

      The time the data was last updated.
    """


_InstanceRunningWaitFiltersTypeDef = TypedDict(
    "_InstanceRunningWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceRunningWaitFiltersTypeDef(_InstanceRunningWaitFiltersTypeDef):
    """
    Type definition for `InstanceRunningWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceRunningWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceRunningWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class InstanceRunningWaitWaiterConfigTypeDef(_InstanceRunningWaitWaiterConfigTypeDef):
    """
    Type definition for `InstanceRunningWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_InstanceStartResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceStartResponseStartingInstancesCurrentStateTypeDef(
    _InstanceStartResponseStartingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstanceStartResponseStartingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceStartResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceStartResponseStartingInstancesPreviousStateTypeDef(
    _InstanceStartResponseStartingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstanceStartResponseStartingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceStartResponseStartingInstancesTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesTypeDef",
    {
        "CurrentState": InstanceStartResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceStartResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceStartResponseStartingInstancesTypeDef(
    _InstanceStartResponseStartingInstancesTypeDef
):
    """
    Type definition for `InstanceStartResponse` `StartingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstanceStartResponseTypeDef = TypedDict(
    "_InstanceStartResponseTypeDef",
    {"StartingInstances": List[InstanceStartResponseStartingInstancesTypeDef]},
    total=False,
)


class InstanceStartResponseTypeDef(_InstanceStartResponseTypeDef):
    """
    Type definition for `InstanceStart` `Response`

    - **StartingInstances** *(list) --*

      Information about the started instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstanceStatusOkWaitFiltersTypeDef = TypedDict(
    "_InstanceStatusOkWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceStatusOkWaitFiltersTypeDef(_InstanceStatusOkWaitFiltersTypeDef):
    """
    Type definition for `InstanceStatusOkWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceStatusOkWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceStatusOkWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class InstanceStatusOkWaitWaiterConfigTypeDef(_InstanceStatusOkWaitWaiterConfigTypeDef):
    """
    Type definition for `InstanceStatusOkWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_InstanceStopResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceStopResponseStoppingInstancesCurrentStateTypeDef(
    _InstanceStopResponseStoppingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstanceStopResponseStoppingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceStopResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceStopResponseStoppingInstancesPreviousStateTypeDef(
    _InstanceStopResponseStoppingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstanceStopResponseStoppingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceStopResponseStoppingInstancesTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesTypeDef",
    {
        "CurrentState": InstanceStopResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceStopResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceStopResponseStoppingInstancesTypeDef(
    _InstanceStopResponseStoppingInstancesTypeDef
):
    """
    Type definition for `InstanceStopResponse` `StoppingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstanceStopResponseTypeDef = TypedDict(
    "_InstanceStopResponseTypeDef",
    {"StoppingInstances": List[InstanceStopResponseStoppingInstancesTypeDef]},
    total=False,
)


class InstanceStopResponseTypeDef(_InstanceStopResponseTypeDef):
    """
    Type definition for `InstanceStop` `Response`

    - **StoppingInstances** *(list) --*

      Information about the stopped instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstanceStoppedWaitFiltersTypeDef = TypedDict(
    "_InstanceStoppedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceStoppedWaitFiltersTypeDef(_InstanceStoppedWaitFiltersTypeDef):
    """
    Type definition for `InstanceStoppedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceStoppedWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceStoppedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class InstanceStoppedWaitWaiterConfigTypeDef(_InstanceStoppedWaitWaiterConfigTypeDef):
    """
    Type definition for `InstanceStoppedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef(
    _InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstanceTerminateResponseTerminatingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef(
    _InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstanceTerminateResponseTerminatingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstanceTerminateResponseTerminatingInstancesTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesTypeDef(
    _InstanceTerminateResponseTerminatingInstancesTypeDef
):
    """
    Type definition for `InstanceTerminateResponse` `TerminatingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstanceTerminateResponseTypeDef = TypedDict(
    "_InstanceTerminateResponseTypeDef",
    {
        "TerminatingInstances": List[
            InstanceTerminateResponseTerminatingInstancesTypeDef
        ]
    },
    total=False,
)


class InstanceTerminateResponseTypeDef(_InstanceTerminateResponseTypeDef):
    """
    Type definition for `InstanceTerminate` `Response`

    - **TerminatingInstances** *(list) --*

      Information about the terminated instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstanceTerminatedWaitFiltersTypeDef = TypedDict(
    "_InstanceTerminatedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceTerminatedWaitFiltersTypeDef(_InstanceTerminatedWaitFiltersTypeDef):
    """
    Type definition for `InstanceTerminatedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceTerminatedWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceTerminatedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class InstanceTerminatedWaitWaiterConfigTypeDef(
    _InstanceTerminatedWaitWaiterConfigTypeDef
):
    """
    Type definition for `InstanceTerminatedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `InstanceUnmonitorResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_InstanceUnmonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstanceUnmonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstanceUnmonitorResponseInstanceMonitoringsTypeDef(
    _InstanceUnmonitorResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `InstanceUnmonitorResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_InstanceUnmonitorResponseTypeDef = TypedDict(
    "_InstanceUnmonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstanceUnmonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstanceUnmonitorResponseTypeDef(_InstanceUnmonitorResponseTypeDef):
    """
    Type definition for `InstanceUnmonitor` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_InstanceWaitUntilExistsFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilExistsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceWaitUntilExistsFiltersTypeDef(_InstanceWaitUntilExistsFiltersTypeDef):
    """
    Type definition for `InstanceWaitUntilExists` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceWaitUntilRunningFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilRunningFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceWaitUntilRunningFiltersTypeDef(_InstanceWaitUntilRunningFiltersTypeDef):
    """
    Type definition for `InstanceWaitUntilRunning` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceWaitUntilStoppedFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilStoppedFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceWaitUntilStoppedFiltersTypeDef(_InstanceWaitUntilStoppedFiltersTypeDef):
    """
    Type definition for `InstanceWaitUntilStopped` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstanceWaitUntilTerminatedFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilTerminatedFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InstanceWaitUntilTerminatedFiltersTypeDef(
    _InstanceWaitUntilTerminatedFiltersTypeDef
):
    """
    Type definition for `InstanceWaitUntilTerminated` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstancesCreateTagsTagsTypeDef = TypedDict(
    "_InstancesCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstancesCreateTagsTagsTypeDef(_InstancesCreateTagsTagsTypeDef):
    """
    Type definition for `InstancesCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_InstancesFilterFiltersTypeDef = TypedDict(
    "_InstancesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstancesFilterFiltersTypeDef(_InstancesFilterFiltersTypeDef):
    """
    Type definition for `InstancesFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `InstancesMonitorResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_InstancesMonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstancesMonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstancesMonitorResponseInstanceMonitoringsTypeDef(
    _InstancesMonitorResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `InstancesMonitorResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_InstancesMonitorResponseTypeDef = TypedDict(
    "_InstancesMonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstancesMonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstancesMonitorResponseTypeDef(_InstancesMonitorResponseTypeDef):
    """
    Type definition for `InstancesMonitor` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_InstancesStartResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesStartResponseStartingInstancesCurrentStateTypeDef(
    _InstancesStartResponseStartingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstancesStartResponseStartingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesStartResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesStartResponseStartingInstancesPreviousStateTypeDef(
    _InstancesStartResponseStartingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstancesStartResponseStartingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesStartResponseStartingInstancesTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesTypeDef",
    {
        "CurrentState": InstancesStartResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesStartResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesStartResponseStartingInstancesTypeDef(
    _InstancesStartResponseStartingInstancesTypeDef
):
    """
    Type definition for `InstancesStartResponse` `StartingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstancesStartResponseTypeDef = TypedDict(
    "_InstancesStartResponseTypeDef",
    {"StartingInstances": List[InstancesStartResponseStartingInstancesTypeDef]},
    total=False,
)


class InstancesStartResponseTypeDef(_InstancesStartResponseTypeDef):
    """
    Type definition for `InstancesStart` `Response`

    - **StartingInstances** *(list) --*

      Information about the started instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstancesStopResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesStopResponseStoppingInstancesCurrentStateTypeDef(
    _InstancesStopResponseStoppingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstancesStopResponseStoppingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesStopResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesStopResponseStoppingInstancesPreviousStateTypeDef(
    _InstancesStopResponseStoppingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstancesStopResponseStoppingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesStopResponseStoppingInstancesTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesTypeDef",
    {
        "CurrentState": InstancesStopResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesStopResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesStopResponseStoppingInstancesTypeDef(
    _InstancesStopResponseStoppingInstancesTypeDef
):
    """
    Type definition for `InstancesStopResponse` `StoppingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstancesStopResponseTypeDef = TypedDict(
    "_InstancesStopResponseTypeDef",
    {"StoppingInstances": List[InstancesStopResponseStoppingInstancesTypeDef]},
    total=False,
)


class InstancesStopResponseTypeDef(_InstancesStopResponseTypeDef):
    """
    Type definition for `InstancesStop` `Response`

    - **StoppingInstances** *(list) --*

      Information about the stopped instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef(
    _InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    Type definition for `InstancesTerminateResponseTerminatingInstances` `CurrentState`

    The current state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    {"Code": int, "Name": str},
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef(
    _InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef
):
    """
    Type definition for `InstancesTerminateResponseTerminatingInstances` `PreviousState`

    The previous state of the instance.

    - **Code** *(integer) --*

      The state of the instance as a 16-bit unsigned integer.

      The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
      between 256 and 65,535. These numerical values are used for internal purposes and
      should be ignored.

      The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
      between 0 and 255.

      The valid values for instance-state-code will all be in the range of the low byte and
      they are:

      * ``0`` : ``pending``

      * ``16`` : ``running``

      * ``32`` : ``shutting-down``

      * ``48`` : ``terminated``

      * ``64`` : ``stopping``

      * ``80`` : ``stopped``

      You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
      decimal.

    - **Name** *(string) --*

      The current state of the instance.
    """


_InstancesTerminateResponseTerminatingInstancesTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesTypeDef(
    _InstancesTerminateResponseTerminatingInstancesTypeDef
):
    """
    Type definition for `InstancesTerminateResponse` `TerminatingInstances`

    Describes an instance state change.

    - **CurrentState** *(dict) --*

      The current state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **PreviousState** *(dict) --*

      The previous state of the instance.

      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.

        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and
        should be ignored.

        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
        between 0 and 255.

        The valid values for instance-state-code will all be in the range of the low byte and
        they are:

        * ``0`` : ``pending``

        * ``16`` : ``running``

        * ``32`` : ``shutting-down``

        * ``48`` : ``terminated``

        * ``64`` : ``stopping``

        * ``80`` : ``stopped``

        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.

      - **Name** *(string) --*

        The current state of the instance.
    """


_InstancesTerminateResponseTypeDef = TypedDict(
    "_InstancesTerminateResponseTypeDef",
    {
        "TerminatingInstances": List[
            InstancesTerminateResponseTerminatingInstancesTypeDef
        ]
    },
    total=False,
)


class InstancesTerminateResponseTypeDef(_InstancesTerminateResponseTypeDef):
    """
    Type definition for `InstancesTerminate` `Response`

    - **TerminatingInstances** *(list) --*

      Information about the terminated instances.

      - *(dict) --*

        Describes an instance state change.

        - **CurrentState** *(dict) --*

          The current state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **PreviousState** *(dict) --*

          The previous state of the instance.

          - **Code** *(integer) --*

            The state of the instance as a 16-bit unsigned integer.

            The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
            between 256 and 65,535. These numerical values are used for internal purposes and
            should be ignored.

            The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
            between 0 and 255.

            The valid values for instance-state-code will all be in the range of the low byte and
            they are:

            * ``0`` : ``pending``

            * ``16`` : ``running``

            * ``32`` : ``shutting-down``

            * ``48`` : ``terminated``

            * ``64`` : ``stopping``

            * ``80`` : ``stopped``

            You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
            decimal.

          - **Name** *(string) --*

            The current state of the instance.
    """


_InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": str},
    total=False,
)


class InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    """
    Type definition for `InstancesUnmonitorResponseInstanceMonitorings` `Monitoring`

    The monitoring for the instance.

    - **State** *(string) --*

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
      enabled.
    """


_InstancesUnmonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstancesUnmonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstancesUnmonitorResponseInstanceMonitoringsTypeDef(
    _InstancesUnmonitorResponseInstanceMonitoringsTypeDef
):
    """
    Type definition for `InstancesUnmonitorResponse` `InstanceMonitorings`

    Describes the monitoring of an instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **Monitoring** *(dict) --*

      The monitoring for the instance.

      - **State** *(string) --*

        Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
        enabled.
    """


_InstancesUnmonitorResponseTypeDef = TypedDict(
    "_InstancesUnmonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstancesUnmonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstancesUnmonitorResponseTypeDef(_InstancesUnmonitorResponseTypeDef):
    """
    Type definition for `InstancesUnmonitor` `Response`

    - **InstanceMonitorings** *(list) --*

      The monitoring information.

      - *(dict) --*

        Describes the monitoring of an instance.

        - **InstanceId** *(string) --*

          The ID of the instance.

        - **Monitoring** *(dict) --*

          The monitoring for the instance.

          - **State** *(string) --*

            Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is
            enabled.
    """


_InternetGatewayCreateTagsTagsTypeDef = TypedDict(
    "_InternetGatewayCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InternetGatewayCreateTagsTagsTypeDef(_InternetGatewayCreateTagsTagsTypeDef):
    """
    Type definition for `InternetGatewayCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_InternetGatewaysFilterFiltersTypeDef = TypedDict(
    "_InternetGatewaysFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class InternetGatewaysFilterFiltersTypeDef(_InternetGatewaysFilterFiltersTypeDef):
    """
    Type definition for `InternetGatewaysFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_KeyPairExistsWaitFiltersTypeDef = TypedDict(
    "_KeyPairExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class KeyPairExistsWaitFiltersTypeDef(_KeyPairExistsWaitFiltersTypeDef):
    """
    Type definition for `KeyPairExistsWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_KeyPairExistsWaitWaiterConfigTypeDef = TypedDict(
    "_KeyPairExistsWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class KeyPairExistsWaitWaiterConfigTypeDef(_KeyPairExistsWaitWaiterConfigTypeDef):
    """
    Type definition for `KeyPairExistsWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 5

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 6
    """


_KeyPairsFilterFiltersTypeDef = TypedDict(
    "_KeyPairsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class KeyPairsFilterFiltersTypeDef(_KeyPairsFilterFiltersTypeDef):
    """
    Type definition for `KeyPairsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_NatGatewayAvailableWaitFiltersTypeDef = TypedDict(
    "_NatGatewayAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class NatGatewayAvailableWaitFiltersTypeDef(_NatGatewayAvailableWaitFiltersTypeDef):
    """
    Type definition for `NatGatewayAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_NatGatewayAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_NatGatewayAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class NatGatewayAvailableWaitWaiterConfigTypeDef(
    _NatGatewayAvailableWaitWaiterConfigTypeDef
):
    """
    Type definition for `NatGatewayAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_NetworkAclCreateEntryIcmpTypeCodeTypeDef = TypedDict(
    "_NetworkAclCreateEntryIcmpTypeCodeTypeDef", {"Code": int, "Type": int}, total=False
)


class NetworkAclCreateEntryIcmpTypeCodeTypeDef(
    _NetworkAclCreateEntryIcmpTypeCodeTypeDef
):
    """
    Type definition for `NetworkAclCreateEntry` `IcmpTypeCode`

    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_NetworkAclCreateEntryPortRangeTypeDef = TypedDict(
    "_NetworkAclCreateEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class NetworkAclCreateEntryPortRangeTypeDef(_NetworkAclCreateEntryPortRangeTypeDef):
    """
    Type definition for `NetworkAclCreateEntry` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_NetworkAclCreateTagsTagsTypeDef = TypedDict(
    "_NetworkAclCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class NetworkAclCreateTagsTagsTypeDef(_NetworkAclCreateTagsTagsTypeDef):
    """
    Type definition for `NetworkAclCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_NetworkAclReplaceAssociationResponseTypeDef = TypedDict(
    "_NetworkAclReplaceAssociationResponseTypeDef",
    {"NewAssociationId": str},
    total=False,
)


class NetworkAclReplaceAssociationResponseTypeDef(
    _NetworkAclReplaceAssociationResponseTypeDef
):
    """
    Type definition for `NetworkAclReplaceAssociation` `Response`

    - **NewAssociationId** *(string) --*

      The ID of the new association.
    """


_NetworkAclReplaceEntryIcmpTypeCodeTypeDef = TypedDict(
    "_NetworkAclReplaceEntryIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class NetworkAclReplaceEntryIcmpTypeCodeTypeDef(
    _NetworkAclReplaceEntryIcmpTypeCodeTypeDef
):
    """
    Type definition for `NetworkAclReplaceEntry` `IcmpTypeCode`

    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.

    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.

    - **Type** *(integer) --*

      The ICMP type. A value of -1 means all types.
    """


_NetworkAclReplaceEntryPortRangeTypeDef = TypedDict(
    "_NetworkAclReplaceEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class NetworkAclReplaceEntryPortRangeTypeDef(_NetworkAclReplaceEntryPortRangeTypeDef):
    """
    Type definition for `NetworkAclReplaceEntry` `PortRange`

    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).

    - **From** *(integer) --*

      The first port in the range.

    - **To** *(integer) --*

      The last port in the range.
    """


_NetworkAclsFilterFiltersTypeDef = TypedDict(
    "_NetworkAclsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class NetworkAclsFilterFiltersTypeDef(_NetworkAclsFilterFiltersTypeDef):
    """
    Type definition for `NetworkAclsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef = TypedDict(
    "_NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    {"PrivateIpAddress": str},
    total=False,
)


class NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef(
    _NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
):
    """
    Type definition for `NetworkInterfaceAssignPrivateIpAddressesResponse` `AssignedPrivateIpAddresses`

    Describes the private IP addresses assigned to a network interface.

    - **PrivateIpAddress** *(string) --*

      The private IP address assigned to the network interface.
    """


_NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef = TypedDict(
    "_NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef",
    {
        "NetworkInterfaceId": str,
        "AssignedPrivateIpAddresses": List[
            NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
        ],
    },
    total=False,
)


class NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef(
    _NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef
):
    """
    Type definition for `NetworkInterfaceAssignPrivateIpAddresses` `Response`

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **AssignedPrivateIpAddresses** *(list) --*

      The private IP addresses assigned to the network interface.

      - *(dict) --*

        Describes the private IP addresses assigned to a network interface.

        - **PrivateIpAddress** *(string) --*

          The private IP address assigned to the network interface.
    """


_NetworkInterfaceAttachResponseTypeDef = TypedDict(
    "_NetworkInterfaceAttachResponseTypeDef", {"AttachmentId": str}, total=False
)


class NetworkInterfaceAttachResponseTypeDef(_NetworkInterfaceAttachResponseTypeDef):
    """
    Type definition for `NetworkInterfaceAttach` `Response`

    Contains the output of AttachNetworkInterface.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.
    """


_NetworkInterfaceAvailableWaitFiltersTypeDef = TypedDict(
    "_NetworkInterfaceAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class NetworkInterfaceAvailableWaitFiltersTypeDef(
    _NetworkInterfaceAvailableWaitFiltersTypeDef
):
    """
    Type definition for `NetworkInterfaceAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_NetworkInterfaceAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_NetworkInterfaceAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class NetworkInterfaceAvailableWaitWaiterConfigTypeDef(
    _NetworkInterfaceAvailableWaitWaiterConfigTypeDef
):
    """
    Type definition for `NetworkInterfaceAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 20

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 10
    """


_NetworkInterfaceCreateTagsTagsTypeDef = TypedDict(
    "_NetworkInterfaceCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class NetworkInterfaceCreateTagsTagsTypeDef(_NetworkInterfaceCreateTagsTagsTypeDef):
    """
    Type definition for `NetworkInterfaceCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": str,
    },
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef(
    _NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef
):
    """
    Type definition for `NetworkInterfaceDescribeAttributeResponse` `Attachment`

    The attachment (if any) of the network interface.

    - **AttachTime** *(datetime) --*

      The timestamp indicating when the attachment initiated.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.

    - **DeviceIndex** *(integer) --*

      The device index of the network interface attachment on the instance.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **InstanceOwnerId** *(string) --*

      The AWS account ID of the owner of the instance.

    - **Status** *(string) --*

      The attachment state.
    """


_NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef",
    {"Value": str},
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef(
    _NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef
):
    """
    Type definition for `NetworkInterfaceDescribeAttributeResponse` `Description`

    The description of the network interface.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_NetworkInterfaceDescribeAttributeResponseGroupsTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseGroupsTypeDef(
    _NetworkInterfaceDescribeAttributeResponseGroupsTypeDef
):
    """
    Type definition for `NetworkInterfaceDescribeAttributeResponse` `Groups`

    Describes a security group.

    - **GroupName** *(string) --*

      The name of the security group.

    - **GroupId** *(string) --*

      The ID of the security group.
    """


_NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef(
    _NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef
):
    """
    Type definition for `NetworkInterfaceDescribeAttributeResponse` `SourceDestCheck`

    Indicates whether source/destination checking is enabled.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_NetworkInterfaceDescribeAttributeResponseTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseTypeDef",
    {
        "Attachment": NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef,
        "Description": NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef,
        "Groups": List[NetworkInterfaceDescribeAttributeResponseGroupsTypeDef],
        "NetworkInterfaceId": str,
        "SourceDestCheck": NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef,
    },
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseTypeDef(
    _NetworkInterfaceDescribeAttributeResponseTypeDef
):
    """
    Type definition for `NetworkInterfaceDescribeAttribute` `Response`

    Contains the output of DescribeNetworkInterfaceAttribute.

    - **Attachment** *(dict) --*

      The attachment (if any) of the network interface.

      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.

      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the network interface is deleted when the instance is terminated.

      - **DeviceIndex** *(integer) --*

        The device index of the network interface attachment on the instance.

      - **InstanceId** *(string) --*

        The ID of the instance.

      - **InstanceOwnerId** *(string) --*

        The AWS account ID of the owner of the instance.

      - **Status** *(string) --*

        The attachment state.

    - **Description** *(dict) --*

      The description of the network interface.

      - **Value** *(string) --*

        The attribute value. The value is case-sensitive.

    - **Groups** *(list) --*

      The security groups associated with the network interface.

      - *(dict) --*

        Describes a security group.

        - **GroupName** *(string) --*

          The name of the security group.

        - **GroupId** *(string) --*

          The ID of the security group.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **SourceDestCheck** *(dict) --*

      Indicates whether source/destination checking is enabled.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_NetworkInterfaceModifyAttributeAttachmentTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeAttachmentTypeDef",
    {"AttachmentId": str, "DeleteOnTermination": bool},
    total=False,
)


class NetworkInterfaceModifyAttributeAttachmentTypeDef(
    _NetworkInterfaceModifyAttributeAttachmentTypeDef
):
    """
    Type definition for `NetworkInterfaceModifyAttribute` `Attachment`

    Information about the interface attachment. If modifying the 'delete on termination' attribute,
    you must specify the ID of the interface attachment.

    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the network interface is deleted when the instance is terminated.
    """


_NetworkInterfaceModifyAttributeDescriptionTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class NetworkInterfaceModifyAttributeDescriptionTypeDef(
    _NetworkInterfaceModifyAttributeDescriptionTypeDef
):
    """
    Type definition for `NetworkInterfaceModifyAttribute` `Description`

    A description for the network interface.

    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_NetworkInterfaceModifyAttributeSourceDestCheckTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class NetworkInterfaceModifyAttributeSourceDestCheckTypeDef(
    _NetworkInterfaceModifyAttributeSourceDestCheckTypeDef
):
    """
    Type definition for `NetworkInterfaceModifyAttribute` `SourceDestCheck`

    Indicates whether source/destination checking is enabled. A value of ``true`` means checking is
    enabled, and ``false`` means checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT. For more information, see `NAT Instances
    <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the *Amazon
    Virtual Private Cloud User Guide* .

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_NetworkInterfacesFilterFiltersTypeDef = TypedDict(
    "_NetworkInterfacesFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class NetworkInterfacesFilterFiltersTypeDef(_NetworkInterfacesFilterFiltersTypeDef):
    """
    Type definition for `NetworkInterfacesFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_PasswordDataAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_PasswordDataAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class PasswordDataAvailableWaitWaiterConfigTypeDef(
    _PasswordDataAvailableWaitWaiterConfigTypeDef
):
    """
    Type definition for `PasswordDataAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_PlacementGroupsFilterFiltersTypeDef = TypedDict(
    "_PlacementGroupsFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class PlacementGroupsFilterFiltersTypeDef(_PlacementGroupsFilterFiltersTypeDef):
    """
    Type definition for `PlacementGroupsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_RouteTableCreateTagsTagsTypeDef = TypedDict(
    "_RouteTableCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class RouteTableCreateTagsTagsTypeDef(_RouteTableCreateTagsTagsTypeDef):
    """
    Type definition for `RouteTableCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_RouteTablesFilterFiltersTypeDef = TypedDict(
    "_RouteTablesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class RouteTablesFilterFiltersTypeDef(_RouteTablesFilterFiltersTypeDef):
    """
    Type definition for `RouteTablesFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeEgressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeEgressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeEgressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeEgressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupAuthorizeEgressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[
            SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeEgress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeIngressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeIngressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeIngressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeIngressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupAuthorizeIngressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[
            SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsTypeDef
):
    """
    Type definition for `SecurityGroupAuthorizeIngress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupCreateTagsTagsTypeDef = TypedDict(
    "_SecurityGroupCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SecurityGroupCreateTagsTagsTypeDef(_SecurityGroupCreateTagsTagsTypeDef):
    """
    Type definition for `SecurityGroupCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `SecurityGroupRevokeEgressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `SecurityGroupRevokeEgressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeEgressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeEgressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupRevokeEgressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[
            SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeEgress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef
):
    """
    Type definition for `SecurityGroupRevokeIngressIpPermissions` `IpRanges`

    Describes an IPv4 range.

    - **CidrIp** *(string) --*

      The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv4 address, use the /32 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv4 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef
):
    """
    Type definition for `SecurityGroupRevokeIngressIpPermissions` `Ipv6Ranges`

    [EC2-VPC only] Describes an IPv6 range.

    - **CidrIpv6** *(string) --*

      The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
      both. To specify a single IPv6 address, use the /128 prefix length.

    - **Description** *(string) --*

      A description for the security group rule that references this IPv6 address range.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*
    """


_SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeIngressIpPermissions` `PrefixListIds`

    Describes a prefix list ID.

    - **Description** *(string) --*

      A description for the security group rule that references this prefix list ID.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListId** *(string) --*

      The ID of the prefix.
    """


_SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeIngressIpPermissions` `UserIdGroupPairs`

    Describes a security group and AWS account ID pair.

    - **Description** *(string) --*

      A description for the security group rule that references this user ID group pair.

      Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
      spaces, and ._-:/()#,@[]+=;{}!$*

    - **GroupId** *(string) --*

      The ID of the security group.

    - **GroupName** *(string) --*

      The name of the security group. In a request, use this parameter for a security group in
      EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
      security group ID.

      For a referenced security group in another VPC, this value is not returned if the
      referenced security group is deleted.

    - **PeeringStatus** *(string) --*

      The status of a VPC peering connection, if applicable.

    - **UserId** *(string) --*

      The ID of an AWS account.

      For a referenced security group in another VPC, the account ID of the referenced security
      group is returned in the response. If the referenced security group is deleted, this
      value is not returned.

      [EC2-Classic] Required when adding or removing rules that reference a security group in
      another AWS account.

    - **VpcId** *(string) --*

      The ID of the VPC for the referenced security group, if applicable.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupRevokeIngressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[
            SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsTypeDef
):
    """
    Type definition for `SecurityGroupRevokeIngress` `IpPermissions`

    Describes a set of permissions for a security group rule.

    - **FromPort** *(integer) --*

      The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A value
      of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **IpProtocol** *(string) --*

      The IP protocol name (``tcp`` , ``udp`` , ``icmp`` , ``icmpv6`` ) or number (see `Protocol
      Numbers <http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml>`__ ).

      [VPC only] Use ``-1`` to specify all protocols. When authorizing security group rules,
      specifying ``-1`` or a protocol number other than ``tcp`` , ``udp`` , ``icmp`` , or
      ``icmpv6`` allows traffic on all ports, regardless of any port range you specify. For ``tcp``
      , ``udp`` , and ``icmp`` , you must specify a port range. For ``icmpv6`` , the port range is
      optional; if you omit the port range, traffic for all types and codes is allowed.

    - **IpRanges** *(list) --*

      The IPv4 ranges.

      - *(dict) --*

        Describes an IPv4 range.

        - **CidrIp** *(string) --*

          The IPv4 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv4 address, use the /32 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv4 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **Ipv6Ranges** *(list) --*

      [VPC only] The IPv6 ranges.

      - *(dict) --*

        [EC2-VPC only] Describes an IPv6 range.

        - **CidrIpv6** *(string) --*

          The IPv6 CIDR range. You can either specify a CIDR range or a source security group, not
          both. To specify a single IPv6 address, use the /128 prefix length.

        - **Description** *(string) --*

          A description for the security group rule that references this IPv6 address range.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

    - **PrefixListIds** *(list) --*

      [VPC only] The prefix list IDs for an AWS service. With outbound rules, this is the AWS
      service to access through a VPC endpoint from instances associated with the security group.

      - *(dict) --*

        Describes a prefix list ID.

        - **Description** *(string) --*

          A description for the security group rule that references this prefix list ID.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **PrefixListId** *(string) --*

          The ID of the prefix.

    - **ToPort** *(integer) --*

      The end of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 code. A value of
      ``-1`` indicates all ICMP/ICMPv6 codes. If you specify all ICMP/ICMPv6 types, you must
      specify all codes.

    - **UserIdGroupPairs** *(list) --*

      The security group and AWS account ID pairs.

      - *(dict) --*

        Describes a security group and AWS account ID pair.

        - **Description** *(string) --*

          A description for the security group rule that references this user ID group pair.

          Constraints: Up to 255 characters in length. Allowed characters are a-z, A-Z, 0-9,
          spaces, and ._-:/()#,@[]+=;{}!$*

        - **GroupId** *(string) --*

          The ID of the security group.

        - **GroupName** *(string) --*

          The name of the security group. In a request, use this parameter for a security group in
          EC2-Classic or a default VPC only. For a security group in a nondefault VPC, use the
          security group ID.

          For a referenced security group in another VPC, this value is not returned if the
          referenced security group is deleted.

        - **PeeringStatus** *(string) --*

          The status of a VPC peering connection, if applicable.

        - **UserId** *(string) --*

          The ID of an AWS account.

          For a referenced security group in another VPC, the account ID of the referenced security
          group is returned in the response. If the referenced security group is deleted, this
          value is not returned.

          [EC2-Classic] Required when adding or removing rules that reference a security group in
          another AWS account.

        - **VpcId** *(string) --*

          The ID of the VPC for the referenced security group, if applicable.

        - **VpcPeeringConnectionId** *(string) --*

          The ID of the VPC peering connection, if applicable.
    """


_SecurityGroupsFilterFiltersTypeDef = TypedDict(
    "_SecurityGroupsFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SecurityGroupsFilterFiltersTypeDef(_SecurityGroupsFilterFiltersTypeDef):
    """
    Type definition for `SecurityGroupsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef",
    {"Key": str, "Values": List[str]},
    total=False,
)


class ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef(
    _ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    Type definition for `ServiceResourceCreateDhcpOptions` `DhcpConfigurations`

    - **Key** *(string) --*

    - **Values** *(list) --*

      - *(string) --*
    """


_ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef(
    _ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef(
    _ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef(
    _ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables it
    to run in any open Capacity Reservation that has matching attributes (instance type, platform,
    Availability Zone).

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ServiceResourceCreateInstancesCpuOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ServiceResourceCreateInstancesCpuOptionsTypeDef(
    _ServiceResourceCreateInstancesCpuOptionsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core. To disable multithreading for the instance, specify a value
      of ``1`` . Otherwise, specify the default value of ``2`` .
    """


_ServiceResourceCreateInstancesCreditSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class ServiceResourceCreateInstancesCreditSpecificationTypeDef(
    _ServiceResourceCreateInstancesCreditSpecificationTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `CreditSpecification`

    The credit option for CPU usage of the T2 or T3 instance. Valid values are ``standard`` and
    ``unlimited`` . To change this attribute after launch, use `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    Default: ``standard`` (T2 instances) or ``unlimited`` (T3 instances)

    - **CpuCredits** *(string) --* **[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef(
    _ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `ElasticGpuSpecification`

    A specification for an Elastic Graphics accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of Elastic Graphics accelerator.
    """


_ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef(
    _ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
      ``eia1.medium`` , and ``eia1.large`` .
    """


_ServiceResourceCreateInstancesHibernationOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ServiceResourceCreateInstancesHibernationOptionsTypeDef(
    _ServiceResourceCreateInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `HibernationOptions`

    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.

      Default: ``false``
    """


_ServiceResourceCreateInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ServiceResourceCreateInstancesIamInstanceProfileTypeDef(
    _ServiceResourceCreateInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances. The default is the
      On-Demand price.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
      only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
      ``stop`` .

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
      value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until all
      instances launch, the request is canceled, or this date is reached. If the request is
      persistent, it remains active until it is canceled or this date and time is reached. The
      default end date is 7 days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef(
    _ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances. The default is the
        On-Demand price.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
        only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
        ``stop`` .

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
        value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until all
        instances launch, the request is canceled, or this date is reached. If the request is
        persistent, it remains active until it is canceled or this date and time is reached. The
        default end date is 7 days from the current date.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_ServiceResourceCreateInstancesIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ServiceResourceCreateInstancesIpv6AddressesTypeDef(
    _ServiceResourceCreateInstancesIpv6AddressesTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ServiceResourceCreateInstancesLaunchTemplateTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ServiceResourceCreateInstancesLaunchTemplateTypeDef(
    _ServiceResourceCreateInstancesLaunchTemplateTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `LaunchTemplate`

    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the name
    or ID of a launch template, but not both.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **Version** *(string) --*

      The version number of the launch template.

      Default: The default version for the launch template.
    """


_ServiceResourceCreateInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ServiceResourceCreateInstancesLicenseSpecificationsTypeDef(
    _ServiceResourceCreateInstancesLicenseSpecificationsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_ServiceResourceCreateInstancesMonitoringTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesMonitoringTypeDef", {"Enabled": bool}
)


class ServiceResourceCreateInstancesMonitoringTypeDef(
    _ServiceResourceCreateInstancesMonitoringTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `Monitoring`

    Specifies whether detailed monitoring is enabled for the instance.

    - **Enabled** *(boolean) --* **[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
      IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ServiceResourceCreateInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
      public IP address can only be assigned to a network interface for eth0, and can only be
      assigned to a new network interface, not an existing one. You cannot specify more than one
      network interface in the request. If launching into a default subnet, the default value is
      ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You can
      specify ``true`` only if creating a new network interface when launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network interface when
      launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network interface
      has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the device
      index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating a network
      interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the IPv6
      addresses from the range of the subnet. You cannot specify this option and the option to
      assign specific IPv6 addresses in the same request. You can specify this option if you've
      specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify this option
      and the option to assign a number of IPv6 addresses in the same request. You cannot specify
      this option if you've specified a minimum number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a network
      interface when launching an instance. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one private IPv4
      address can be designated as primary. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
          IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and specify
      more than one private IP address using the private IP addresses option. You cannot specify
      this option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if creating a
      network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_ServiceResourceCreateInstancesPlacementTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesPlacementTypeDef(
    _ServiceResourceCreateInstancesPlacementTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `Placement`

    The placement for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not supported
      for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group strategy is
      set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not supported for
      the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for the
      ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstancesTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceCreateInstancesTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateInstancesTagSpecificationsTypeDef(
    _ServiceResourceCreateInstancesTagSpecificationsTypeDef
):
    """
    Type definition for `ServiceResourceCreateInstances` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef(
    _ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    Type definition for `ServiceResourceCreateNetworkInterface` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    Type definition for `ServiceResourceCreateNetworkInterface` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one IPv4
      address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ServiceResourceCreateSnapshotTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateSnapshotTagSpecificationsTypeDef(
    _ServiceResourceCreateSnapshotTagSpecificationsTypeDef
):
    """
    Type definition for `ServiceResourceCreateSnapshot` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef
):
    """
    Type definition for `ServiceResourceCreateVolumeTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceCreateVolumeTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateVolumeTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateVolumeTagSpecificationsTypeDef(
    _ServiceResourceCreateVolumeTagSpecificationsTypeDef
):
    """
    Type definition for `ServiceResourceCreateVolume` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef(
    _ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `ServiceResourceRegisterImageBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_ServiceResourceRegisterImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ServiceResourceRegisterImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ServiceResourceRegisterImageBlockDeviceMappingsTypeDef(
    _ServiceResourceRegisterImageBlockDeviceMappingsTypeDef
):
    """
    Type definition for `ServiceResourceRegisterImage` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_SnapshotCompletedWaitFiltersTypeDef = TypedDict(
    "_SnapshotCompletedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SnapshotCompletedWaitFiltersTypeDef(_SnapshotCompletedWaitFiltersTypeDef):
    """
    Type definition for `SnapshotCompletedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SnapshotCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_SnapshotCompletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class SnapshotCompletedWaitWaiterConfigTypeDef(
    _SnapshotCompletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `SnapshotCompletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_SnapshotCopyResponseTagsTypeDef = TypedDict(
    "_SnapshotCopyResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCopyResponseTagsTypeDef(_SnapshotCopyResponseTagsTypeDef):
    """
    Type definition for `SnapshotCopyResponse` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SnapshotCopyResponseTypeDef = TypedDict(
    "_SnapshotCopyResponseTypeDef",
    {"SnapshotId": str, "Tags": List[SnapshotCopyResponseTagsTypeDef]},
    total=False,
)


class SnapshotCopyResponseTypeDef(_SnapshotCopyResponseTypeDef):
    """
    Type definition for `SnapshotCopy` `Response`

    Contains the output of CopySnapshot.

    - **SnapshotId** *(string) --*

      The ID of the new snapshot.

    - **Tags** *(list) --*

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SnapshotCopyTagSpecificationsTagsTypeDef = TypedDict(
    "_SnapshotCopyTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCopyTagSpecificationsTagsTypeDef(
    _SnapshotCopyTagSpecificationsTagsTypeDef
):
    """
    Type definition for `SnapshotCopyTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SnapshotCopyTagSpecificationsTypeDef = TypedDict(
    "_SnapshotCopyTagSpecificationsTypeDef",
    {"ResourceType": str, "Tags": List[SnapshotCopyTagSpecificationsTagsTypeDef]},
    total=False,
)


class SnapshotCopyTagSpecificationsTypeDef(_SnapshotCopyTagSpecificationsTypeDef):
    """
    Type definition for `SnapshotCopy` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SnapshotCreateTagsTagsTypeDef = TypedDict(
    "_SnapshotCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCreateTagsTagsTypeDef(_SnapshotCreateTagsTagsTypeDef):
    """
    Type definition for `SnapshotCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef(
    _SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef
):
    """
    Type definition for `SnapshotDescribeAttributeResponse` `CreateVolumePermissions`

    Describes the user or group to be added or removed from the list of create volume
    permissions for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_SnapshotDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class SnapshotDescribeAttributeResponseProductCodesTypeDef(
    _SnapshotDescribeAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `SnapshotDescribeAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_SnapshotDescribeAttributeResponseTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseTypeDef",
    {
        "CreateVolumePermissions": List[
            SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef
        ],
        "ProductCodes": List[SnapshotDescribeAttributeResponseProductCodesTypeDef],
        "SnapshotId": str,
    },
    total=False,
)


class SnapshotDescribeAttributeResponseTypeDef(
    _SnapshotDescribeAttributeResponseTypeDef
):
    """
    Type definition for `SnapshotDescribeAttribute` `Response`

    Contains the output of DescribeSnapshotAttribute.

    - **CreateVolumePermissions** *(list) --*

      The users and groups that have the permissions for creating volumes from the snapshot.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume
        permissions for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.

    - **ProductCodes** *(list) --*

      The product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **SnapshotId** *(string) --*

      The ID of the EBS snapshot.
    """


_SnapshotModifyAttributeCreateVolumePermissionAddTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionAddTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionAddTypeDef
):
    """
    Type definition for `SnapshotModifyAttributeCreateVolumePermission` `Add`

    Describes the user or group to be added or removed from the list of create volume permissions
    for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef
):
    """
    Type definition for `SnapshotModifyAttributeCreateVolumePermission` `Remove`

    Describes the user or group to be added or removed from the list of create volume permissions
    for a volume.

    - **Group** *(string) --*

      The group to be added or removed. The possible value is ``all`` .

    - **UserId** *(string) --*

      The AWS account ID to be added or removed.
    """


_SnapshotModifyAttributeCreateVolumePermissionTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionTypeDef",
    {
        "Add": List[SnapshotModifyAttributeCreateVolumePermissionAddTypeDef],
        "Remove": List[SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef],
    },
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionTypeDef
):
    """
    Type definition for `SnapshotModifyAttribute` `CreateVolumePermission`

    A JSON representation of the snapshot attribute modification.

    - **Add** *(list) --*

      Adds the specified AWS account ID or group to the list.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume permissions
        for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.

    - **Remove** *(list) --*

      Removes the specified AWS account ID or group from the list.

      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume permissions
        for a volume.

        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .

        - **UserId** *(string) --*

          The AWS account ID to be added or removed.
    """


_SnapshotWaitUntilCompletedFiltersTypeDef = TypedDict(
    "_SnapshotWaitUntilCompletedFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SnapshotWaitUntilCompletedFiltersTypeDef(
    _SnapshotWaitUntilCompletedFiltersTypeDef
):
    """
    Type definition for `SnapshotWaitUntilCompleted` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SnapshotsFilterFiltersTypeDef = TypedDict(
    "_SnapshotsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SnapshotsFilterFiltersTypeDef(_SnapshotsFilterFiltersTypeDef):
    """
    Type definition for `SnapshotsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SpotInstanceRequestFulfilledWaitFiltersTypeDef = TypedDict(
    "_SpotInstanceRequestFulfilledWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SpotInstanceRequestFulfilledWaitFiltersTypeDef(
    _SpotInstanceRequestFulfilledWaitFiltersTypeDef
):
    """
    Type definition for `SpotInstanceRequestFulfilledWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef = TypedDict(
    "_SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef(
    _SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef
):
    """
    Type definition for `SpotInstanceRequestFulfilledWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_SubnetAvailableWaitFiltersTypeDef = TypedDict(
    "_SubnetAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SubnetAvailableWaitFiltersTypeDef(_SubnetAvailableWaitFiltersTypeDef):
    """
    Type definition for `SubnetAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SubnetAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_SubnetAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class SubnetAvailableWaitWaiterConfigTypeDef(_SubnetAvailableWaitWaiterConfigTypeDef):
    """
    Type definition for `SubnetAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef(
    _SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef
):
    """
    Type definition for `SubnetCreateInstancesBlockDeviceMappings` `Ebs`

    Parameters used to automatically set up EBS volumes when the instance is launched.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination. For more information,
      see `Preserving Amazon EBS Volumes on Instance Termination
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
      in the Amazon Elastic Compute Cloud User Guide.

    - **Iops** *(integer) --*

      The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
      volumes, this represents the number of IOPS that are provisioned for the volume. For
      ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
      which the volume accumulates I/O credits for bursting. For more information, see `Amazon
      EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
      volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
      instances
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
      . Other instance families guarantee performance up to 32,000 IOPS. For more information,
      see `Amazon EBS Volume Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
      Elastic Compute Cloud User Guide* .

      Condition: This parameter is required for requests to create ``io1`` volumes; it is not
      used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

    - **SnapshotId** *(string) --*

      The ID of the snapshot.

    - **VolumeSize** *(integer) --*

      The size of the volume, in GiB.

      Default: If you're creating the volume from a snapshot and don't specify a volume size, the
      default is the snapshot size.

      Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
      (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
      (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
      volume size must be equal to or larger than the snapshot size.

    - **VolumeType** *(string) --*

      The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
      volume supports.

      Default: ``gp2``

    - **Encrypted** *(boolean) --*

      Indicates whether the encryption state of an EBS volume is changed while being restored
      from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
      the volume origin (new or from a snapshot), starting encryption state, ownership, and
      whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
      in the *Amazon Elastic Compute Cloud User Guide* .

      In no case can you remove encryption from an encrypted volume.

      Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
      more information, see `Supported Instance Types
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
      .

    - **KmsKeyId** *(string) --*

      Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
      the EBS volume is encrypted.

      This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
      `RequestSpotFleet
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
      `RequestSpotInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .
    """


_SubnetCreateInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_SubnetCreateInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class SubnetCreateInstancesBlockDeviceMappingsTypeDef(
    _SubnetCreateInstancesBlockDeviceMappingsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `BlockDeviceMappings`

    Describes a block device mapping.

    - **DeviceName** *(string) --*

      The device name (for example, ``/dev/sdh`` or ``xvdh`` ).

    - **VirtualName** *(string) --*

      The virtual device name (``ephemeral`` N). Instance store volumes are numbered starting from
      0. An instance type with 2 available instance store volumes can specify mappings for
      ``ephemeral0`` and ``ephemeral1`` . The number of available instance store volumes depends on
      the instance type. After you connect to the instance, you must mount the volume.

      NVMe instance store volumes are automatically enumerated and assigned a device name.
      Including them in your block device mapping has no effect.

      Constraints: For M3 instances, you must specify instance store volumes in the block device
      mapping for the instance. When you launch an M3 instance, we ignore any instance store
      volumes specified in the block device mapping for the AMI.

    - **Ebs** *(dict) --*

      Parameters used to automatically set up EBS volumes when the instance is launched.

      - **DeleteOnTermination** *(boolean) --*

        Indicates whether the EBS volume is deleted on instance termination. For more information,
        see `Preserving Amazon EBS Volumes on Instance Termination
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination>`__
        in the Amazon Elastic Compute Cloud User Guide.

      - **Iops** *(integer) --*

        The number of I/O operations per second (IOPS) that the volume supports. For ``io1``
        volumes, this represents the number of IOPS that are provisioned for the volume. For
        ``gp2`` volumes, this represents the baseline performance of the volume and the rate at
        which the volume accumulates I/O credits for bursting. For more information, see `Amazon
        EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Constraints: Range is 100-16,000 IOPS for ``gp2`` volumes and 100 to 64,000IOPS for ``io1``
        volumes in most Regions. Maximum ``io1`` IOPS of 64,000 is guaranteed only on `Nitro-based
        instances
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances>`__
        . Other instance families guarantee performance up to 32,000 IOPS. For more information,
        see `Amazon EBS Volume Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .

        Condition: This parameter is required for requests to create ``io1`` volumes; it is not
        used in requests to create ``gp2`` , ``st1`` , ``sc1`` , or ``standard`` volumes.

      - **SnapshotId** *(string) --*

        The ID of the snapshot.

      - **VolumeSize** *(integer) --*

        The size of the volume, in GiB.

        Default: If you're creating the volume from a snapshot and don't specify a volume size, the
        default is the snapshot size.

        Constraints: 1-16384 for General Purpose SSD (``gp2`` ), 4-16384 for Provisioned IOPS SSD
        (``io1`` ), 500-16384 for Throughput Optimized HDD (``st1`` ), 500-16384 for Cold HDD
        (``sc1`` ), and 1-1024 for Magnetic (``standard`` ) volumes. If you specify a snapshot, the
        volume size must be equal to or larger than the snapshot size.

      - **VolumeType** *(string) --*

        The volume type. If you set the type to ``io1`` , you must also specify the IOPS that the
        volume supports.

        Default: ``gp2``

      - **Encrypted** *(boolean) --*

        Indicates whether the encryption state of an EBS volume is changed while being restored
        from a backing snapshot. The effect of setting the encryption state to ``true`` depends on
        the volume origin (new or from a snapshot), starting encryption state, ownership, and
        whether encryption by default is enabled. For more information, see `Amazon EBS Encryption
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters>`__
        in the *Amazon Elastic Compute Cloud User Guide* .

        In no case can you remove encryption from an encrypted volume.

        Encrypted volumes can only be attached to instances that support Amazon EBS encryption. For
        more information, see `Supported Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances>`__
        .

      - **KmsKeyId** *(string) --*

        Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer managed CMK under which
        the EBS volume is encrypted.

        This parameter is only supported on ``BlockDeviceMapping`` objects called by `RunInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ ,
        `RequestSpotFleet
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html>`__ , and
        `RequestSpotInstances
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html>`__ .

    - **NoDevice** *(string) --*

      Suppresses the specified device included in the block device mapping of the AMI.
    """


_SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    """
    Type definition for `SubnetCreateInstancesCapacityReservationSpecification` `CapacityReservationTarget`

    Information about the target Capacity Reservation.

    - **CapacityReservationId** *(string) --*

      The ID of the Capacity Reservation.
    """


_SubnetCreateInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": str,
        "CapacityReservationTarget": SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class SubnetCreateInstancesCapacityReservationSpecificationTypeDef(
    _SubnetCreateInstancesCapacityReservationSpecificationTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `CapacityReservationSpecification`

    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables it
    to run in any open Capacity Reservation that has matching attributes (instance type, platform,
    Availability Zone).

    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:

      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).

      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.

    - **CapacityReservationTarget** *(dict) --*

      Information about the target Capacity Reservation.

      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_SubnetCreateInstancesCpuOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class SubnetCreateInstancesCpuOptionsTypeDef(_SubnetCreateInstancesCpuOptionsTypeDef):
    """
    Type definition for `SubnetCreateInstances` `CpuOptions`

    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.

    - **ThreadsPerCore** *(integer) --*

      The number of threads per CPU core. To disable multithreading for the instance, specify a value
      of ``1`` . Otherwise, specify the default value of ``2`` .
    """


_SubnetCreateInstancesCreditSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class SubnetCreateInstancesCreditSpecificationTypeDef(
    _SubnetCreateInstancesCreditSpecificationTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `CreditSpecification`

    The credit option for CPU usage of the T2 or T3 instance. Valid values are ``standard`` and
    ``unlimited`` . To change this attribute after launch, use `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .

    Default: ``standard`` (T2 instances) or ``unlimited`` (T3 instances)

    - **CpuCredits** *(string) --* **[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_SubnetCreateInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class SubnetCreateInstancesElasticGpuSpecificationTypeDef(
    _SubnetCreateInstancesElasticGpuSpecificationTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `ElasticGpuSpecification`

    A specification for an Elastic Graphics accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of Elastic Graphics accelerator.
    """


_SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef(
    _SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `ElasticInferenceAccelerators`

    Describes an elastic inference accelerator.

    - **Type** *(string) --* **[REQUIRED]**

      The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
      ``eia1.medium`` , and ``eia1.large`` .
    """


_SubnetCreateInstancesHibernationOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesHibernationOptionsTypeDef", {"Configured": bool}, total=False
)


class SubnetCreateInstancesHibernationOptionsTypeDef(
    _SubnetCreateInstancesHibernationOptionsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `HibernationOptions`

    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .

    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.

      Default: ``false``
    """


_SubnetCreateInstancesIamInstanceProfileTypeDef = TypedDict(
    "_SubnetCreateInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class SubnetCreateInstancesIamInstanceProfileTypeDef(
    _SubnetCreateInstancesIamInstanceProfileTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `IamInstanceProfile`

    The IAM instance profile.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.

    - **Name** *(string) --*

      The name of the instance profile.
    """


_SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": str,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": str,
    },
    total=False,
)


class SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    """
    Type definition for `SubnetCreateInstancesInstanceMarketOptions` `SpotOptions`

    The options for Spot Instances.

    - **MaxPrice** *(string) --*

      The maximum hourly price you're willing to pay for the Spot Instances. The default is the
      On-Demand price.

    - **SpotInstanceType** *(string) --*

      The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
      only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
      ``stop`` .

    - **BlockDurationMinutes** *(integer) --*

      The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
      value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

    - **ValidUntil** *(datetime) --*

      The end date of the request. For a one-time request, the request remains active until all
      instances launch, the request is canceled, or this date is reached. If the request is
      persistent, it remains active until it is canceled or this date and time is reached. The
      default end date is 7 days from the current date.

    - **InstanceInterruptionBehavior** *(string) --*

      The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_SubnetCreateInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class SubnetCreateInstancesInstanceMarketOptionsTypeDef(
    _SubnetCreateInstancesInstanceMarketOptionsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `InstanceMarketOptions`

    The market (purchasing) option for the instances.

    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .

    - **MarketType** *(string) --*

      The market type.

    - **SpotOptions** *(dict) --*

      The options for Spot Instances.

      - **MaxPrice** *(string) --*

        The maximum hourly price you're willing to pay for the Spot Instances. The default is the
        On-Demand price.

      - **SpotInstanceType** *(string) --*

        The Spot Instance request type. For  RunInstances , persistent Spot Instance requests are
        only supported when **InstanceInterruptionBehavior** is set to either ``hibernate`` or
        ``stop`` .

      - **BlockDurationMinutes** *(integer) --*

        The required duration for the Spot Instances (also known as Spot blocks), in minutes. This
        value must be a multiple of 60 (60, 120, 180, 240, 300, or 360).

      - **ValidUntil** *(datetime) --*

        The end date of the request. For a one-time request, the request remains active until all
        instances launch, the request is canceled, or this date is reached. If the request is
        persistent, it remains active until it is canceled or this date and time is reached. The
        default end date is 7 days from the current date.

      - **InstanceInterruptionBehavior** *(string) --*

        The behavior when a Spot Instance is interrupted. The default is ``terminate`` .
    """


_SubnetCreateInstancesIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class SubnetCreateInstancesIpv6AddressesTypeDef(
    _SubnetCreateInstancesIpv6AddressesTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_SubnetCreateInstancesLaunchTemplateTypeDef = TypedDict(
    "_SubnetCreateInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class SubnetCreateInstancesLaunchTemplateTypeDef(
    _SubnetCreateInstancesLaunchTemplateTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `LaunchTemplate`

    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the name
    or ID of a launch template, but not both.

    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.

    - **LaunchTemplateName** *(string) --*

      The name of the launch template.

    - **Version** *(string) --*

      The version number of the launch template.

      Default: The default version for the launch template.
    """


_SubnetCreateInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_SubnetCreateInstancesLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class SubnetCreateInstancesLicenseSpecificationsTypeDef(
    _SubnetCreateInstancesLicenseSpecificationsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `LicenseSpecifications`

    Describes a license configuration.

    - **LicenseConfigurationArn** *(string) --*

      The Amazon Resource Name (ARN) of the license configuration.
    """


_SubnetCreateInstancesMonitoringTypeDef = TypedDict(
    "_SubnetCreateInstancesMonitoringTypeDef", {"Enabled": bool}
)


class SubnetCreateInstancesMonitoringTypeDef(_SubnetCreateInstancesMonitoringTypeDef):
    """
    Type definition for `SubnetCreateInstances` `Monitoring`

    Specifies whether detailed monitoring is enabled for the instance.

    - **Enabled** *(boolean) --* **[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    """
    Type definition for `SubnetCreateInstancesNetworkInterfaces` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    """
    Type definition for `SubnetCreateInstancesNetworkInterfaces` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
      IPv4 address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_SubnetCreateInstancesNetworkInterfacesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class SubnetCreateInstancesNetworkInterfacesTypeDef(
    _SubnetCreateInstancesNetworkInterfacesTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `NetworkInterfaces`

    Describes a network interface.

    - **AssociatePublicIpAddress** *(boolean) --*

      Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
      public IP address can only be assigned to a network interface for eth0, and can only be
      assigned to a new network interface, not an existing one. You cannot specify more than one
      network interface in the request. If launching into a default subnet, the default value is
      ``true`` .

    - **DeleteOnTermination** *(boolean) --*

      If set to ``true`` , the interface is deleted when the instance is terminated. You can
      specify ``true`` only if creating a new network interface when launching an instance.

    - **Description** *(string) --*

      The description of the network interface. Applies only if creating a network interface when
      launching an instance.

    - **DeviceIndex** *(integer) --*

      The position of the network interface in the attachment order. A primary network interface
      has a device index of 0.

      If you specify a network interface when launching an instance, you must specify the device
      index.

    - **Groups** *(list) --*

      The IDs of the security groups for the network interface. Applies only if creating a network
      interface when launching an instance.

      - *(string) --*

    - **Ipv6AddressCount** *(integer) --*

      A number of IPv6 addresses to assign to the network interface. Amazon EC2 chooses the IPv6
      addresses from the range of the subnet. You cannot specify this option and the option to
      assign specific IPv6 addresses in the same request. You can specify this option if you've
      specified a minimum number of instances to launch.

    - **Ipv6Addresses** *(list) --*

      One or more IPv6 addresses to assign to the network interface. You cannot specify this option
      and the option to assign a number of IPv6 addresses in the same request. You cannot specify
      this option if you've specified a minimum number of instances to launch.

      - *(dict) --*

        Describes an IPv6 address.

        - **Ipv6Address** *(string) --*

          The IPv6 address.

    - **NetworkInterfaceId** *(string) --*

      The ID of the network interface.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 address of the network interface. Applies only if creating a network
      interface when launching an instance. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **PrivateIpAddresses** *(list) --*

      One or more private IPv4 addresses to assign to the network interface. Only one private IPv4
      address can be designated as primary. You cannot specify this option if you're launching more
      than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

      - *(dict) --*

        Describes a secondary private IPv4 address for a network interface.

        - **Primary** *(boolean) --*

          Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
          IPv4 address can be designated as primary.

        - **PrivateIpAddress** *(string) --*

          The private IPv4 addresses.

    - **SecondaryPrivateIpAddressCount** *(integer) --*

      The number of secondary private IPv4 addresses. You can't specify this option and specify
      more than one private IP address using the private IP addresses option. You cannot specify
      this option if you're launching more than one instance in a `RunInstances
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html>`__ request.

    - **SubnetId** *(string) --*

      The ID of the subnet associated with the network interface. Applies only if creating a
      network interface when launching an instance.

    - **InterfaceType** *(string) --*

      The type of network interface. To create an Elastic Fabric Adapter (EFA), specify ``efa`` .
      For more information, see `Elastic Fabric Adapter
      <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html>`__ in the *Amazon Elastic
      Compute Cloud User Guide* .

      If you are not creating an EFA, specify ``interface`` or omit this parameter.

      Valid values: ``interface`` | ``efa``
    """


_SubnetCreateInstancesPlacementTypeDef = TypedDict(
    "_SubnetCreateInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": str,
        "SpreadDomain": str,
    },
    total=False,
)


class SubnetCreateInstancesPlacementTypeDef(_SubnetCreateInstancesPlacementTypeDef):
    """
    Type definition for `SubnetCreateInstances` `Placement`

    The placement for the instance.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.

      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.

    - **Affinity** *(string) --*

      The affinity setting for the instance on the Dedicated Host. This parameter is not supported
      for the  ImportInstance command.

    - **GroupName** *(string) --*

      The name of the placement group the instance is in.

    - **PartitionNumber** *(integer) --*

      The number of the partition the instance is in. Valid only if the placement group strategy is
      set to ``partition`` .

    - **HostId** *(string) --*

      The ID of the Dedicated Host on which the instance resides. This parameter is not supported for
      the  ImportInstance command.

    - **Tenancy** *(string) --*

      The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy
      of ``dedicated`` runs on single-tenant hardware. The ``host`` tenancy is not supported for the
      ImportInstance command.

    - **SpreadDomain** *(string) --*

      Reserved for future use.
    """


_SubnetCreateInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_SubnetCreateInstancesTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class SubnetCreateInstancesTagSpecificationsTagsTypeDef(
    _SubnetCreateInstancesTagSpecificationsTagsTypeDef
):
    """
    Type definition for `SubnetCreateInstancesTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SubnetCreateInstancesTagSpecificationsTypeDef = TypedDict(
    "_SubnetCreateInstancesTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[SubnetCreateInstancesTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class SubnetCreateInstancesTagSpecificationsTypeDef(
    _SubnetCreateInstancesTagSpecificationsTypeDef
):
    """
    Type definition for `SubnetCreateInstances` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SubnetCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateNetworkInterfaceIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class SubnetCreateNetworkInterfaceIpv6AddressesTypeDef(
    _SubnetCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    Type definition for `SubnetCreateNetworkInterface` `Ipv6Addresses`

    Describes an IPv6 address.

    - **Ipv6Address** *(string) --*

      The IPv6 address.
    """


_SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    Type definition for `SubnetCreateNetworkInterface` `PrivateIpAddresses`

    Describes a secondary private IPv4 address for a network interface.

    - **Primary** *(boolean) --*

      Indicates whether the private IPv4 address is the primary private IPv4 address. Only one IPv4
      address can be designated as primary.

    - **PrivateIpAddress** *(string) --*

      The private IPv4 addresses.
    """


_SubnetCreateTagsTagsTypeDef = TypedDict(
    "_SubnetCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SubnetCreateTagsTagsTypeDef(_SubnetCreateTagsTagsTypeDef):
    """
    Type definition for `SubnetCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_SubnetsFilterFiltersTypeDef = TypedDict(
    "_SubnetsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SubnetsFilterFiltersTypeDef(_SubnetsFilterFiltersTypeDef):
    """
    Type definition for `SubnetsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SystemStatusOkWaitFiltersTypeDef = TypedDict(
    "_SystemStatusOkWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SystemStatusOkWaitFiltersTypeDef(_SystemStatusOkWaitFiltersTypeDef):
    """
    Type definition for `SystemStatusOkWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_SystemStatusOkWaitWaiterConfigTypeDef = TypedDict(
    "_SystemStatusOkWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class SystemStatusOkWaitWaiterConfigTypeDef(_SystemStatusOkWaitWaiterConfigTypeDef):
    """
    Type definition for `SystemStatusOkWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VolumeAttachToInstanceResponseTypeDef = TypedDict(
    "_VolumeAttachToInstanceResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class VolumeAttachToInstanceResponseTypeDef(_VolumeAttachToInstanceResponseTypeDef):
    """
    Type definition for `VolumeAttachToInstance` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_VolumeAvailableWaitFiltersTypeDef = TypedDict(
    "_VolumeAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VolumeAvailableWaitFiltersTypeDef(_VolumeAvailableWaitFiltersTypeDef):
    """
    Type definition for `VolumeAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VolumeAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VolumeAvailableWaitWaiterConfigTypeDef(_VolumeAvailableWaitWaiterConfigTypeDef):
    """
    Type definition for `VolumeAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VolumeCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_VolumeCreateSnapshotTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class VolumeCreateSnapshotTagSpecificationsTagsTypeDef(
    _VolumeCreateSnapshotTagSpecificationsTagsTypeDef
):
    """
    Type definition for `VolumeCreateSnapshotTagSpecifications` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
      May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_VolumeCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_VolumeCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": str,
        "Tags": List[VolumeCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class VolumeCreateSnapshotTagSpecificationsTypeDef(
    _VolumeCreateSnapshotTagSpecificationsTypeDef
):
    """
    Type definition for `VolumeCreateSnapshot` `TagSpecifications`

    The tags to apply to a resource when the resource is being created.

    - **ResourceType** *(string) --*

      The type of resource to tag. Currently, the resource types that support tagging on creation
      are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host`` | ``fleet`` |
      ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
      ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
      ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
      ``volume`` .

      To tag a resource after it has been created, see `CreateTags
      <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .

    - **Tags** *(list) --*

      The tags to apply to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters.
          May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_VolumeCreateTagsTagsTypeDef = TypedDict(
    "_VolumeCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class VolumeCreateTagsTagsTypeDef(_VolumeCreateTagsTagsTypeDef):
    """
    Type definition for `VolumeCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_VolumeDeletedWaitFiltersTypeDef = TypedDict(
    "_VolumeDeletedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeDeletedWaitFiltersTypeDef(_VolumeDeletedWaitFiltersTypeDef):
    """
    Type definition for `VolumeDeletedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VolumeDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeDeletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VolumeDeletedWaitWaiterConfigTypeDef(_VolumeDeletedWaitWaiterConfigTypeDef):
    """
    Type definition for `VolumeDeletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VolumeDescribeAttributeResponseAutoEnableIOTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class VolumeDescribeAttributeResponseAutoEnableIOTypeDef(
    _VolumeDescribeAttributeResponseAutoEnableIOTypeDef
):
    """
    Type definition for `VolumeDescribeAttributeResponse` `AutoEnableIO`

    The state of ``autoEnableIO`` attribute.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VolumeDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": str},
    total=False,
)


class VolumeDescribeAttributeResponseProductCodesTypeDef(
    _VolumeDescribeAttributeResponseProductCodesTypeDef
):
    """
    Type definition for `VolumeDescribeAttributeResponse` `ProductCodes`

    Describes a product code.

    - **ProductCodeId** *(string) --*

      The product code.

    - **ProductCodeType** *(string) --*

      The type of product code.
    """


_VolumeDescribeAttributeResponseTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseTypeDef",
    {
        "AutoEnableIO": VolumeDescribeAttributeResponseAutoEnableIOTypeDef,
        "ProductCodes": List[VolumeDescribeAttributeResponseProductCodesTypeDef],
        "VolumeId": str,
    },
    total=False,
)


class VolumeDescribeAttributeResponseTypeDef(_VolumeDescribeAttributeResponseTypeDef):
    """
    Type definition for `VolumeDescribeAttribute` `Response`

    Contains the output of DescribeVolumeAttribute.

    - **AutoEnableIO** *(dict) --*

      The state of ``autoEnableIO`` attribute.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **ProductCodes** *(list) --*

      A list of product codes.

      - *(dict) --*

        Describes a product code.

        - **ProductCodeId** *(string) --*

          The product code.

        - **ProductCodeType** *(string) --*

          The type of product code.

    - **VolumeId** *(string) --*

      The ID of the volume.
    """


_VolumeDescribeStatusFiltersTypeDef = TypedDict(
    "_VolumeDescribeStatusFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VolumeDescribeStatusFiltersTypeDef(_VolumeDescribeStatusFiltersTypeDef):
    """
    Type definition for `VolumeDescribeStatus` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef
):
    """
    Type definition for `VolumeDescribeStatusResponseVolumeStatuses` `Actions`

    Describes a volume status operation code.

    - **Code** *(string) --*

      The code identifying the operation, for example, ``enable-volume-io`` .

    - **Description** *(string) --*

      A description of the operation.

    - **EventId** *(string) --*

      The ID of the event associated with this operation.

    - **EventType** *(string) --*

      The event type associated with this operation.
    """


_VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef
):
    """
    Type definition for `VolumeDescribeStatusResponseVolumeStatuses` `Events`

    Describes a volume status event.

    - **Description** *(string) --*

      A description of the event.

    - **EventId** *(string) --*

      The ID of this event.

    - **EventType** *(string) --*

      The type of this event.

    - **NotAfter** *(datetime) --*

      The latest end time of the event.

    - **NotBefore** *(datetime) --*

      The earliest start time of the event.
    """


_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": str, "Status": str},
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    """
    Type definition for `VolumeDescribeStatusResponseVolumeStatusesVolumeStatus` `Details`

    Describes a volume status.

    - **Name** *(string) --*

      The name of the volume status.

    - **Status** *(string) --*

      The intended status of the volume status.
    """


_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[
            VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
        ],
        "Status": str,
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef
):
    """
    Type definition for `VolumeDescribeStatusResponseVolumeStatuses` `VolumeStatus`

    The volume status.

    - **Details** *(list) --*

      The details of the volume status.

      - *(dict) --*

        Describes a volume status.

        - **Name** *(string) --*

          The name of the volume status.

        - **Status** *(string) --*

          The intended status of the volume status.

    - **Status** *(string) --*

      The status of the volume.
    """


_VolumeDescribeStatusResponseVolumeStatusesTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesTypeDef",
    {
        "Actions": List[VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef],
        "AvailabilityZone": str,
        "Events": List[VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesTypeDef
):
    """
    Type definition for `VolumeDescribeStatusResponse` `VolumeStatuses`

    Describes the volume status.

    - **Actions** *(list) --*

      The details of the operation.

      - *(dict) --*

        Describes a volume status operation code.

        - **Code** *(string) --*

          The code identifying the operation, for example, ``enable-volume-io`` .

        - **Description** *(string) --*

          A description of the operation.

        - **EventId** *(string) --*

          The ID of the event associated with this operation.

        - **EventType** *(string) --*

          The event type associated with this operation.

    - **AvailabilityZone** *(string) --*

      The Availability Zone of the volume.

    - **Events** *(list) --*

      A list of events associated with the volume.

      - *(dict) --*

        Describes a volume status event.

        - **Description** *(string) --*

          A description of the event.

        - **EventId** *(string) --*

          The ID of this event.

        - **EventType** *(string) --*

          The type of this event.

        - **NotAfter** *(datetime) --*

          The latest end time of the event.

        - **NotBefore** *(datetime) --*

          The earliest start time of the event.

    - **VolumeId** *(string) --*

      The volume ID.

    - **VolumeStatus** *(dict) --*

      The volume status.

      - **Details** *(list) --*

        The details of the volume status.

        - *(dict) --*

          Describes a volume status.

          - **Name** *(string) --*

            The name of the volume status.

          - **Status** *(string) --*

            The intended status of the volume status.

      - **Status** *(string) --*

        The status of the volume.
    """


_VolumeDescribeStatusResponseTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseTypeDef",
    {
        "NextToken": str,
        "VolumeStatuses": List[VolumeDescribeStatusResponseVolumeStatusesTypeDef],
    },
    total=False,
)


class VolumeDescribeStatusResponseTypeDef(_VolumeDescribeStatusResponseTypeDef):
    """
    Type definition for `VolumeDescribeStatus` `Response`

    - **NextToken** *(string) --*

      The token to use to retrieve the next page of results. This value is ``null`` when there are
      no more results to return.

    - **VolumeStatuses** *(list) --*

      Information about the status of the volumes.

      - *(dict) --*

        Describes the volume status.

        - **Actions** *(list) --*

          The details of the operation.

          - *(dict) --*

            Describes a volume status operation code.

            - **Code** *(string) --*

              The code identifying the operation, for example, ``enable-volume-io`` .

            - **Description** *(string) --*

              A description of the operation.

            - **EventId** *(string) --*

              The ID of the event associated with this operation.

            - **EventType** *(string) --*

              The event type associated with this operation.

        - **AvailabilityZone** *(string) --*

          The Availability Zone of the volume.

        - **Events** *(list) --*

          A list of events associated with the volume.

          - *(dict) --*

            Describes a volume status event.

            - **Description** *(string) --*

              A description of the event.

            - **EventId** *(string) --*

              The ID of this event.

            - **EventType** *(string) --*

              The type of this event.

            - **NotAfter** *(datetime) --*

              The latest end time of the event.

            - **NotBefore** *(datetime) --*

              The earliest start time of the event.

        - **VolumeId** *(string) --*

          The volume ID.

        - **VolumeStatus** *(dict) --*

          The volume status.

          - **Details** *(list) --*

            The details of the volume status.

            - *(dict) --*

              Describes a volume status.

              - **Name** *(string) --*

                The name of the volume status.

              - **Status** *(string) --*

                The intended status of the volume status.

          - **Status** *(string) --*

            The status of the volume.
    """


_VolumeDetachFromInstanceResponseTypeDef = TypedDict(
    "_VolumeDetachFromInstanceResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": str,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class VolumeDetachFromInstanceResponseTypeDef(_VolumeDetachFromInstanceResponseTypeDef):
    """
    Type definition for `VolumeDetachFromInstance` `Response`

    Describes volume attachment details.

    - **AttachTime** *(datetime) --*

      The time stamp when the attachment initiated.

    - **Device** *(string) --*

      The device name.

    - **InstanceId** *(string) --*

      The ID of the instance.

    - **State** *(string) --*

      The attachment state of the volume.

    - **VolumeId** *(string) --*

      The ID of the volume.

    - **DeleteOnTermination** *(boolean) --*

      Indicates whether the EBS volume is deleted on instance termination.
    """


_VolumeInUseWaitFiltersTypeDef = TypedDict(
    "_VolumeInUseWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeInUseWaitFiltersTypeDef(_VolumeInUseWaitFiltersTypeDef):
    """
    Type definition for `VolumeInUseWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VolumeInUseWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeInUseWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VolumeInUseWaitWaiterConfigTypeDef(_VolumeInUseWaitWaiterConfigTypeDef):
    """
    Type definition for `VolumeInUseWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VolumeModifyAttributeAutoEnableIOTypeDef = TypedDict(
    "_VolumeModifyAttributeAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class VolumeModifyAttributeAutoEnableIOTypeDef(
    _VolumeModifyAttributeAutoEnableIOTypeDef
):
    """
    Type definition for `VolumeModifyAttribute` `AutoEnableIO`

    Indicates whether the volume should be auto-enabled for I/O operations.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VolumesFilterFiltersTypeDef = TypedDict(
    "_VolumesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumesFilterFiltersTypeDef(_VolumesFilterFiltersTypeDef):
    """
    Type definition for `VolumesFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcAddressAssociateResponseTypeDef = TypedDict(
    "_VpcAddressAssociateResponseTypeDef", {"AssociationId": str}, total=False
)


class VpcAddressAssociateResponseTypeDef(_VpcAddressAssociateResponseTypeDef):
    """
    Type definition for `VpcAddressAssociate` `Response`

    - **AssociationId** *(string) --*

      [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_VpcAttachClassicLinkInstanceResponseTypeDef = TypedDict(
    "_VpcAttachClassicLinkInstanceResponseTypeDef", {"Return": bool}, total=False
)


class VpcAttachClassicLinkInstanceResponseTypeDef(
    _VpcAttachClassicLinkInstanceResponseTypeDef
):
    """
    Type definition for `VpcAttachClassicLinkInstance` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcAvailableWaitFiltersTypeDef = TypedDict(
    "_VpcAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcAvailableWaitFiltersTypeDef(_VpcAvailableWaitFiltersTypeDef):
    """
    Type definition for `VpcAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VpcAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpcAvailableWaitWaiterConfigTypeDef(_VpcAvailableWaitWaiterConfigTypeDef):
    """
    Type definition for `VpcAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VpcCreateTagsTagsTypeDef = TypedDict(
    "_VpcCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class VpcCreateTagsTagsTypeDef(_VpcCreateTagsTagsTypeDef):
    """
    Type definition for `VpcCreateTags` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
      not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode characters.
    """


_VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef",
    {"Value": bool},
    total=False,
)


class VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef(
    _VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef
):
    """
    Type definition for `VpcDescribeAttributeResponse` `EnableDnsHostnames`

    Indicates whether the instances launched in the VPC get DNS hostnames. If this attribute is
    ``true`` , instances in the VPC get DNS hostnames; otherwise, they do not.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcDescribeAttributeResponseEnableDnsSupportTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class VpcDescribeAttributeResponseEnableDnsSupportTypeDef(
    _VpcDescribeAttributeResponseEnableDnsSupportTypeDef
):
    """
    Type definition for `VpcDescribeAttributeResponse` `EnableDnsSupport`

    Indicates whether DNS resolution is enabled for the VPC. If this attribute is ``true`` , the
    Amazon DNS server resolves DNS hostnames for your instances to their corresponding IP
    addresses; otherwise, it does not.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcDescribeAttributeResponseTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseTypeDef",
    {
        "VpcId": str,
        "EnableDnsHostnames": VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef,
        "EnableDnsSupport": VpcDescribeAttributeResponseEnableDnsSupportTypeDef,
    },
    total=False,
)


class VpcDescribeAttributeResponseTypeDef(_VpcDescribeAttributeResponseTypeDef):
    """
    Type definition for `VpcDescribeAttribute` `Response`

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **EnableDnsHostnames** *(dict) --*

      Indicates whether the instances launched in the VPC get DNS hostnames. If this attribute is
      ``true`` , instances in the VPC get DNS hostnames; otherwise, they do not.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .

    - **EnableDnsSupport** *(dict) --*

      Indicates whether DNS resolution is enabled for the VPC. If this attribute is ``true`` , the
      Amazon DNS server resolves DNS hostnames for your instances to their corresponding IP
      addresses; otherwise, it does not.

      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcDetachClassicLinkInstanceResponseTypeDef = TypedDict(
    "_VpcDetachClassicLinkInstanceResponseTypeDef", {"Return": bool}, total=False
)


class VpcDetachClassicLinkInstanceResponseTypeDef(
    _VpcDetachClassicLinkInstanceResponseTypeDef
):
    """
    Type definition for `VpcDetachClassicLinkInstance` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcDisableClassicLinkResponseTypeDef = TypedDict(
    "_VpcDisableClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class VpcDisableClassicLinkResponseTypeDef(_VpcDisableClassicLinkResponseTypeDef):
    """
    Type definition for `VpcDisableClassicLink` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcEnableClassicLinkResponseTypeDef = TypedDict(
    "_VpcEnableClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class VpcEnableClassicLinkResponseTypeDef(_VpcEnableClassicLinkResponseTypeDef):
    """
    Type definition for `VpcEnableClassicLink` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcExistsWaitFiltersTypeDef = TypedDict(
    "_VpcExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcExistsWaitFiltersTypeDef(_VpcExistsWaitFiltersTypeDef):
    """
    Type definition for `VpcExistsWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcExistsWaitWaiterConfigTypeDef = TypedDict(
    "_VpcExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VpcExistsWaitWaiterConfigTypeDef(_VpcExistsWaitWaiterConfigTypeDef):
    """
    Type definition for `VpcExistsWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 1

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 5
    """


_VpcModifyAttributeEnableDnsHostnamesTypeDef = TypedDict(
    "_VpcModifyAttributeEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class VpcModifyAttributeEnableDnsHostnamesTypeDef(
    _VpcModifyAttributeEnableDnsHostnamesTypeDef
):
    """
    Type definition for `VpcModifyAttribute` `EnableDnsHostnames`

    Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in
    the VPC get DNS hostnames; otherwise, they do not.

    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS
    support.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcModifyAttributeEnableDnsSupportTypeDef = TypedDict(
    "_VpcModifyAttributeEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class VpcModifyAttributeEnableDnsSupportTypeDef(
    _VpcModifyAttributeEnableDnsSupportTypeDef
):
    """
    Type definition for `VpcModifyAttribute` `EnableDnsSupport`

    Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to the Amazon
    provided DNS server at the 169.254.169.253 IP address, or the reserved IP address at the base of
    the VPC network range "plus two" succeed. If disabled, the Amazon provided DNS service in the VPC
    that resolves public DNS hostnames to IP addresses is not enabled.

    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute.

    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnection` `AccepterVpcInfo`

    Information about the accepter VPC. CIDR block information is only returned when describing
    an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfo` `CidrBlockSet`

    Describes an IPv4 CIDR block.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfo` `Ipv6CidrBlockSet`

    Describes an IPv6 CIDR block.

    - **Ipv6CidrBlock** *(string) --*

      The IPv6 CIDR block.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfo` `PeeringOptions`

    Information about the VPC peering connection options for the accepter or requester VPC.

    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
      when queried from instances in a peer VPC.

    - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

      Indicates whether a local ClassicLink connection can communicate with the peer VPC over
      the VPC peering connection.

    - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

      Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
      VPC over the VPC peering connection.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnection` `RequesterVpcInfo`

    Information about the requester VPC. CIDR block information is only returned when
    describing an active VPC peering connection.

    - **CidrBlock** *(string) --*

      The IPv4 CIDR block for the VPC.

    - **Ipv6CidrBlockSet** *(list) --*

      The IPv6 CIDR block for the VPC.

      - *(dict) --*

        Describes an IPv6 CIDR block.

        - **Ipv6CidrBlock** *(string) --*

          The IPv6 CIDR block.

    - **CidrBlockSet** *(list) --*

      Information about the IPv4 CIDR blocks for the VPC.

      - *(dict) --*

        Describes an IPv4 CIDR block.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block.

    - **OwnerId** *(string) --*

      The AWS account ID of the VPC owner.

    - **PeeringOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter or requester VPC.

      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
        when queried from instances in a peer VPC.

      - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

        Indicates whether a local ClassicLink connection can communicate with the peer VPC over
        the VPC peering connection.

      - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

        Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
        VPC over the VPC peering connection.

    - **VpcId** *(string) --*

      The ID of the VPC.

    - **Region** *(string) --*

      The Region in which the VPC is located.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnection` `Status`

    The status of the VPC peering connection.

    - **Code** *(string) --*

      The status of the VPC peering connection.

    - **Message** *(string) --*

      A message that provides more information about the status, if applicable.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponseVpcPeeringConnection` `Tags`

    Describes a tag.

    - **Key** *(string) --*

      The key of the tag.

      Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
      characters. May not begin with ``aws:`` .

    - **Value** *(string) --*

      The value of the tag.

      Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
      characters.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAcceptResponse` `VpcPeeringConnection`

    Information about the VPC peering connection.

    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing
      an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **ExpirationTime** *(datetime) --*

      The time that an unaccepted VPC peering connection will expire.

    - **RequesterVpcInfo** *(dict) --*

      Information about the requester VPC. CIDR block information is only returned when
      describing an active VPC peering connection.

      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.

      - **Ipv6CidrBlockSet** *(list) --*

        The IPv6 CIDR block for the VPC.

        - *(dict) --*

          Describes an IPv6 CIDR block.

          - **Ipv6CidrBlock** *(string) --*

            The IPv6 CIDR block.

      - **CidrBlockSet** *(list) --*

        Information about the IPv4 CIDR blocks for the VPC.

        - *(dict) --*

          Describes an IPv4 CIDR block.

          - **CidrBlock** *(string) --*

            The IPv4 CIDR block.

      - **OwnerId** *(string) --*

        The AWS account ID of the VPC owner.

      - **PeeringOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter or requester VPC.

        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
          when queried from instances in a peer VPC.

        - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

          Indicates whether a local ClassicLink connection can communicate with the peer VPC over
          the VPC peering connection.

        - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

          Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
          VPC over the VPC peering connection.

      - **VpcId** *(string) --*

        The ID of the VPC.

      - **Region** *(string) --*

        The Region in which the VPC is located.

    - **Status** *(dict) --*

      The status of the VPC peering connection.

      - **Code** *(string) --*

        The status of the VPC peering connection.

      - **Message** *(string) --*

        A message that provides more information about the status, if applicable.

    - **Tags** *(list) --*

      Any tags assigned to the resource.

      - *(dict) --*

        Describes a tag.

        - **Key** *(string) --*

          The key of the tag.

          Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
          characters. May not begin with ``aws:`` .

        - **Value** *(string) --*

          The value of the tag.

          Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
          characters.

    - **VpcPeeringConnectionId** *(string) --*

      The ID of the VPC peering connection.
    """


_VpcPeeringConnectionAcceptResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseTypeDef",
    {
        "VpcPeeringConnection": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseTypeDef(
    _VpcPeeringConnectionAcceptResponseTypeDef
):
    """
    Type definition for `VpcPeeringConnectionAccept` `Response`

    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.

      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **ExpirationTime** *(datetime) --*

        The time that an unaccepted VPC peering connection will expire.

      - **RequesterVpcInfo** *(dict) --*

        Information about the requester VPC. CIDR block information is only returned when
        describing an active VPC peering connection.

        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.

        - **Ipv6CidrBlockSet** *(list) --*

          The IPv6 CIDR block for the VPC.

          - *(dict) --*

            Describes an IPv6 CIDR block.

            - **Ipv6CidrBlock** *(string) --*

              The IPv6 CIDR block.

        - **CidrBlockSet** *(list) --*

          Information about the IPv4 CIDR blocks for the VPC.

          - *(dict) --*

            Describes an IPv4 CIDR block.

            - **CidrBlock** *(string) --*

              The IPv4 CIDR block.

        - **OwnerId** *(string) --*

          The AWS account ID of the VPC owner.

        - **PeeringOptions** *(dict) --*

          Information about the VPC peering connection options for the accepter or requester VPC.

          - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

            Indicates whether a local VPC can resolve public DNS hostnames to private IP addresses
            when queried from instances in a peer VPC.

          - **AllowEgressFromLocalClassicLinkToRemoteVpc** *(boolean) --*

            Indicates whether a local ClassicLink connection can communicate with the peer VPC over
            the VPC peering connection.

          - **AllowEgressFromLocalVpcToRemoteClassicLink** *(boolean) --*

            Indicates whether a local VPC can communicate with a ClassicLink connection in the peer
            VPC over the VPC peering connection.

        - **VpcId** *(string) --*

          The ID of the VPC.

        - **Region** *(string) --*

          The Region in which the VPC is located.

      - **Status** *(dict) --*

        The status of the VPC peering connection.

        - **Code** *(string) --*

          The status of the VPC peering connection.

        - **Message** *(string) --*

          A message that provides more information about the status, if applicable.

      - **Tags** *(list) --*

        Any tags assigned to the resource.

        - *(dict) --*

          Describes a tag.

          - **Key** *(string) --*

            The key of the tag.

            Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode
            characters. May not begin with ``aws:`` .

          - **Value** *(string) --*

            The value of the tag.

            Constraints: Tag values are case-sensitive and accept a maximum of 255 Unicode
            characters.

      - **VpcPeeringConnectionId** *(string) --*

        The ID of the VPC peering connection.
    """


_VpcPeeringConnectionDeleteResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionDeleteResponseTypeDef", {"Return": bool}, total=False
)


class VpcPeeringConnectionDeleteResponseTypeDef(
    _VpcPeeringConnectionDeleteResponseTypeDef
):
    """
    Type definition for `VpcPeeringConnectionDelete` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcPeeringConnectionDeletedWaitFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionDeletedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionDeletedWaitFiltersTypeDef(
    _VpcPeeringConnectionDeletedWaitFiltersTypeDef
):
    """
    Type definition for `VpcPeeringConnectionDeletedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef(
    _VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `VpcPeeringConnectionDeletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VpcPeeringConnectionExistsWaitFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionExistsWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionExistsWaitFiltersTypeDef(
    _VpcPeeringConnectionExistsWaitFiltersTypeDef
):
    """
    Type definition for `VpcPeeringConnectionExistsWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcPeeringConnectionExistsWaitWaiterConfigTypeDef = TypedDict(
    "_VpcPeeringConnectionExistsWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpcPeeringConnectionExistsWaitWaiterConfigTypeDef(
    _VpcPeeringConnectionExistsWaitWaiterConfigTypeDef
):
    """
    Type definition for `VpcPeeringConnectionExistsWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VpcPeeringConnectionRejectResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionRejectResponseTypeDef", {"Return": bool}, total=False
)


class VpcPeeringConnectionRejectResponseTypeDef(
    _VpcPeeringConnectionRejectResponseTypeDef
):
    """
    Type definition for `VpcPeeringConnectionReject` `Response`

    - **Return** *(boolean) --*

      Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcPeeringConnectionWaitUntilExistsFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionWaitUntilExistsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionWaitUntilExistsFiltersTypeDef(
    _VpcPeeringConnectionWaitUntilExistsFiltersTypeDef
):
    """
    Type definition for `VpcPeeringConnectionWaitUntilExists` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcPeeringConnectionsFilterFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionsFilterFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionsFilterFiltersTypeDef(
    _VpcPeeringConnectionsFilterFiltersTypeDef
):
    """
    Type definition for `VpcPeeringConnectionsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcWaitUntilAvailableFiltersTypeDef = TypedDict(
    "_VpcWaitUntilAvailableFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcWaitUntilAvailableFiltersTypeDef(_VpcWaitUntilAvailableFiltersTypeDef):
    """
    Type definition for `VpcWaitUntilAvailable` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcWaitUntilExistsFiltersTypeDef = TypedDict(
    "_VpcWaitUntilExistsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcWaitUntilExistsFiltersTypeDef(_VpcWaitUntilExistsFiltersTypeDef):
    """
    Type definition for `VpcWaitUntilExists` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpcsFilterFiltersTypeDef = TypedDict(
    "_VpcsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcsFilterFiltersTypeDef(_VpcsFilterFiltersTypeDef):
    """
    Type definition for `VpcsFilter` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpnConnectionAvailableWaitFiltersTypeDef = TypedDict(
    "_VpnConnectionAvailableWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpnConnectionAvailableWaitFiltersTypeDef(
    _VpnConnectionAvailableWaitFiltersTypeDef
):
    """
    Type definition for `VpnConnectionAvailableWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpnConnectionAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VpnConnectionAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpnConnectionAvailableWaitWaiterConfigTypeDef(
    _VpnConnectionAvailableWaitWaiterConfigTypeDef
):
    """
    Type definition for `VpnConnectionAvailableWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """


_VpnConnectionDeletedWaitFiltersTypeDef = TypedDict(
    "_VpnConnectionDeletedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpnConnectionDeletedWaitFiltersTypeDef(_VpnConnectionDeletedWaitFiltersTypeDef):
    """
    Type definition for `VpnConnectionDeletedWait` `Filters`

    A filter name and value pair that is used to return a more specific list of results from a
    describe operation. Filters can be used to match a set of resources by specific criteria, such
    as tags, attributes, or IDs. The filters supported by a describe operation are documented with
    the describe operation. For example:

    *  DescribeAvailabilityZones

    *  DescribeImages

    *  DescribeInstances

    *  DescribeKeyPairs

    *  DescribeSecurityGroups

    *  DescribeSnapshots

    *  DescribeSubnets

    *  DescribeTags

    *  DescribeVolumes

    *  DescribeVpcs

    - **Name** *(string) --*

      The name of the filter. Filter names are case-sensitive.

    - **Values** *(list) --*

      The filter values. Filter values are case-sensitive.

      - *(string) --*
    """


_VpnConnectionDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VpnConnectionDeletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpnConnectionDeletedWaitWaiterConfigTypeDef(
    _VpnConnectionDeletedWaitWaiterConfigTypeDef
):
    """
    Type definition for `VpnConnectionDeletedWait` `WaiterConfig`

    A dictionary that provides parameters to control waiting behavior.

    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15

    - **MaxAttempts** *(integer) --*

      The maximum number of attempts to be made. Default: 40
    """
